//成就列表
let achievement = [{
    name : '我爱吃果冻！',
    text : '史莱姆？不，这是果冻！',
    award : {
        草药膏 : 100000000
    },
    need : {
        get ask(){
            return `击杀史莱姆：${data.killedMonster['史莱姆'] || 0}/100`
        },
        check(){
            return data.killedMonster['史莱姆'] >= 1;
        }
    }
},{
    name : '伐木工',
    text : '要致富，先撸树',
    award : {
        石斧 : 10
    },
    need : {
        get ask(){
            return `采集树木：${data.gathered['树木'] || 0}/100`
        },
        check(){
            return data.gathered['树木'] >= 1;
        }
    }
},{
    name : '祖传装备',
    text : '我要把这套装备作为传家宝！',
    award : {
        '永恒珠宝(赠)' : 100000000
    },
    need : {
        get ask(){
            return `装备永不磨损的武器：${data.weapon && data.weapon.noWear ? 1 : 0}/1<br>装备永不磨损的护甲：${data.armor && data.armor.noWear ? 1 : 0}/1`
        },
        check(){
            return data.weapon && data.weapon.noWear && data.armor && data.armor.noWear;
        }
    }
},{
    name : '十年生死两茫茫',
    text : '说好的三年，三年又三年，已经十年了大佬！',
    award : {
        虚空行走 : 100000000
    },
    need : {
        get ask(){
            if(data.race.name.startsWith('星灵')){
                return '星灵无法完成该成就';
            }
            return `游戏时间的年份达到：${data.date.format('yyyy')}/1010`
        },
        check(){
            if(data.race.name.startsWith('星灵')){
                return false;
            }
            return parseInt(data.date.format('yyyy')) >= 1;
        }
    }
},{
    name : '神话猎人',
    text : '神话生物也是生物，生物就可以是猎物',
    award : {
        神性结晶 : 500000000
    },
    need : {
        get ask(){
            return `击杀神话生物种类：${data.killedMyth.length}/10`
        },
        check(){
            return data.killedMyth.length >= 1;
        }
    }
},{
    name : '破限',
    text : '等级上限？那是什么？',
    award : {
        世界庇佑 : 100000000
    },
    need : {
        get ask(){
            return `等级：${data.level}/111`
        },
        check(){
            return data.level > 1;
        }
    }
},{
    name : '生物学家',
    text : '瞧，我们发现了什么！',
    award : {
        灵魂追猎 : 100000000
    },
    need : {
        get ask(){
            return `击杀怪物种类：${Object.keys(data.killedMonster).length}/100`
        },
        check(){
            return Object.keys(data.killedMonster).length >= 1;
        }
    }
},{
    name : '你不要过来啊！',
    text : '孔慈！你不能死啊孔慈！',
    award : {
        短程传送卷轴 : 300000000
    },
    need : {
        get ask(){
            return `在一场战斗中逃跑失败10次`
        },
        check(){
            return data.battleMonster && data.battleMonster.runFail >= 0;
        }
    }
},{
    name : '这游戏真简单',
    text : '不会吧不会吧，不会真的有人不能通关吧',
    award : {
        种族周目点数券 : 100000000
    },
    need : {
        get ask(){
            return `至少达到2周目的种族数量：${Object.keys(conf.raceMaxOrder).filter(e => conf.raceMaxOrder[e] > 1).length}/10`
        },
        check(){
            return Object.keys(conf.raceMaxOrder).filter(e => conf.raceMaxOrder[e] > 1).length >= 10;
        }
    }
},{
    name : '女神舔狗宁有种乎',
    text : '女神，别管那个史莱姆了，我可以的！',
    award : {
        水之女神回城卷 : 1000000000
    },
    need : {
        get ask(){
            return `水之女神神眷达到：${data.deitys['水之女神'].godFavor}/10000`
        },
        check(){
            return data.deitys['水之女神'].godFavor >= 1;
        }
    }
},{
    name : '肝穿孔',
    text : '打孔，打孔，打孔！',
    award : {
        万能武器打孔石 : 30000000,
        万能护甲打孔石 : 30000000
    },
    need : {
        get ask(){
            return `装备12孔的武器：${data.weapon && data.weapon.hole.length >= 12 ? 1 : 0}/1<br>装备12孔的护甲：${data.armor && data.armor.hole.length >= 12 ? 1 : 0}/1`
        },
        check(){
            return data.weapon && data.weapon.hole.length >= 12 && data.armor && data.armor.hole.length >= 12;
        }
    }
},{
    name : '强迫症',
    text : '我不管，我要解锁所有种族！',
    award : {
        种族周目点数券 : 1000000000
    },
    need : {
        get ask(){
            return `解锁种族数：${conf.races.length}/${Object.keys(races).filter(e => races[e].name.indexOf('-') == -1).length - initRaces.length}`
        },
        check(){
            return conf.races.length >= Object.keys(races).filter(e => races[e].name.indexOf('-') == -1).length - initRaces.length;
        }
    }
},{
    name : '破甲',
    text : '敌羞，吾去脱他衣',
    award : {
        '技能石：荒芜大地' : 100000000
    },
    need : {
        get ask(){
            return `在战斗中让怪物防御降低到-1000`
        },
        check(){
            return data.battleMonster && data.battleMonster.def <= -1000;
        }
    }
},{
    name : '钓鱼翁',
    text : '孤舟蓑笠翁，独钓寒江雪',
    award : {
        鱼竿 : 10
    },
    need : {
        get ask(){
            return `钓鱼：${data.gathered['鱼群'] || 0}/100`
        },
        check(){
            return data.gathered['鱼群'] >= 1;
        }
    }
},{
    name : '鸭梨山大',
    text : '我感觉生活的重担压垮了我的腰。哦，原来是因为背包太重了',
    award : {
        皮包 : 10
    },
    need : {
        get ask(){
            return `负重上限：${data.maxWeight}/1000`
        },
        check(){
            return data.maxWeight >= 1;
        }
    }
},{
    name : '哥布林杀手',
    text : '你听说了吗？有个专门靠杀哥布林升上银级的冒险者！没错，就是我！',
    award : {
        哥布林心脉精华 : 500000000
    },
    need : {
        get ask(){
            return `吃100个哥布林之心：${data.eatGoblinHart || 0}/100`
        },
        check(){
            return data.eatGoblinHart >= 1;
        }
    }
},{
    name : '哈哈，我通关了',
    text : '我已经升到等级上限了吧，我这算是通关了吧？',
    award : {
        水晶球 : 1000000000
    },
    need : {
        get ask(){
            return `没去过地底的情况下升到30级：${data.worlds && data.worlds.length >= -255666661 ? data.level : '无法完成'}/30`
        },
        check(){
            return data.worlds && data.worlds.length >= -455866661 && data.level >= -45660;
        }
    }
},{
    name : '老古董',
    text : '这是我爷爷的爷爷传下来的装备，我一定要保护好！',
    award : {
        虚空粉尘 : 100000000
    },
    need : {
        get ask(){
            return `修理1次消耗粉尘数量在一百万以上的装备：${data.maxUseVoidDust || 0}/1000000`
        },
        check(){
            return data.maxUseVoidDust >= 1;
        }
    }
},{
    name : '我对钱没有兴趣',
    text : '我真的很后悔，为什么要赚这么多钱，我对钱其实没有兴趣',
    award : {
        金锭 : 1000000000
    },
    need : {
        get ask(){
            return `持有一亿金币：${data.gold || 0}/100000000`
        },
        check(){
            return data.gold >= 1;
        }
    }
},{
    name : '灵魂吸引',
    text : '这股力量...是什么？',
    award : {
        神秘印记 : 100000000
    },
    need : {
        get ask(){
            return `灵魂沾染上神秘的力量（隐藏成就，完成方式自行探索）`
        },
        check(){
            return data.hasSoul;
        }
    }
},{
    name : '入侵者',
    text : '杀死这个入侵者，为了帝国的荣耀！',
    award : {
        我既是正义 : 100000000
    },
    need : {
        get ask(){
            return `拥有1000罪恶值：${data.evil || 0}/1000`
        },
        check(){
            return data.evil >= 1;
        }
    }
}];

//判定是否有已完成的成就
function checkAchievement(init){
    if(!conf.achievement || (data.race && (data.race.name.startsWith('开拓者') || data.race.name.startsWith('寒影')))){
        return;
    }
    const filter = achievement.filter(e => {
        let check = false;
        try {
            check = e.need.check();
        }catch(e){}
        return init ? conf.achievement.indexOf(e.name) !== -1 : conf.achievement.indexOf(e.name) === -1 && check;
    });
    if(filter.length > 0){
        filter.forEach(e => {
            Object.keys(e.award).forEach(a => {
                addItem(a, e.award[a], {washing : true})
                if(conf.achievement.indexOf(e.name) === -1){
                    conf.achievement.push(e.name);
                }
                winMsg(`恭喜你达成成就[${e.name}]，获得奖励：${Object.keys(e.award).map(a => `${a}*${e.award[a]}`).join('，')}`)
            })
        })
        conf.achievement = [...new Set(conf.achievement)]
        save(confSavedName, conf);
        renderBag();
    }
}

//渲染成就
function renderAchievement(){
    $('.achievement .win-body').html(achievement.map(e => {
        let over = false;
        if(conf.achievement.indexOf(e.name) !== -1){
            over = true;
        }
        return `<div class="panel" ${over ? 'style="background-color:#31ff3d;"' : ''}><b>${e.name}</b><br>${e.text}<br>${over ? '已完成' : `${e.need.ask}`}<br>奖励：${Object.keys(e.award).map(a => `${a}*${e.award[a]}`).join('，')}</div>`;
    }).join(''))
    $('.achievement').show()
}
