const eduCfgs = {
    roleNames : ['黛丝','米莉亚','戴莉贝尔','薇薇安','莉莉丝','拉蒂','蕾娜','黛薇儿','莉尔薇','贝莎','安娜','贝蒂','洛丽塔','艾莉丝','蕾米莉亚','克莉丝','塞蕾丝','缇雅','米娜'],//养成角色可能有的名称
    maxHunger : 100,//最大饥饿
    maxWater : 100,//最大水分
    reduceMin : 60,//每多少分钟减少一次饥饿和水分
    reduceOnce : 1,//每次减少的饥饿和水分
    needNum : 40,//饥饿或口渴的临界值
    maybeLikeFood : ['浆果','仙人掌肉','蘑菇','血肉果实','肉干','水果','哥布林之心','血肉花蕊','烤肉','烤鱼','鱼汤','蟹肉大餐','蘑菇煲','烤羊肉','烤魔兽肉','蜜汁血蕊','亚龙肉排'],//可能喜欢的食物
    maybeHateFood : ['鱼','螃蟹','羊肉','肉','魔兽肉','亚龙肉'],//可能讨厌的食物，在随机讨厌的食物时是会包含可能喜欢的食物列表一起随机的
    likeFoodNum : 3,//喜欢的食物种类
    hateFoodNum : 5,//讨厌的食物种类
    initFriendliness : 200,//初始好感度
    maxFriendliness : 1000,//最大好感度，并非不能更高，而是达到这个值才能触发一些特定的事件
    giveFoodAddFriendliness : 1,//投喂增加好感度
    needFood : 80,//至少要降低到多少饥饿和水分才能投喂
    giveLikeFoodAddFriendliness : 5,//投喂喜欢的食物增加好感度
    giveHateFoodReduceFriendliness : 10,//投喂讨厌的食物减少好感度
    reduceFriendliness4Day : 1,//每有1天没交流降低的好感度
    friendlinessLine1 : 100,//小于等于这个值就是冷漠
    friendlinessLine2 : 500,//大于冷漠小于等于这个值就是一般
    friendlinessLine3 : 800,//大于一般小于等于这个值就是友好，大于这个值就是亲密
}

//各种友好度和操作时会说的话
const eduSays = {
    '冷漠' : {
        //对话
        tell : {
            //没有跟随时才会说的话
            noFollow : {
                //不管什么场景下都可能会说的公用的对话
                common : [],
                //只会在特定季节以及特定时间（日或夜）才会说的话
                '春' : [],
                '夏' : [],
                '秋' : [],
                '冬' : [],
                '日' : [],
                '夜' : [],
            },
            //不管跟不跟随都有可能会说的对话
            common : [
                '……',
                '你好',
                '嗯'
            ],
            '春' : [],
            '夏' : [],
            '秋' : [],
            '冬' : [],
            '日' : [],
            '夜' : [],
        },
        giveItem : ['……谢谢'],
        notFood : ['我不需要'],
        notWater : ['我不需要'],
        giveFood : ['……谢谢'],
        likeFood : ['嗯，谢谢'],
        hateFood : ['……'],
    },
    '一般' : {
        tell : {
            //没有跟随时才会说的话
            noFollow : {
                //不管什么场景下都可能会说的公用的对话
                common : [],
                //只会在特定季节以及特定时间（日或夜）才会说的话
                '春' : [],
                '夏' : [],
                '秋' : [],
                '冬' : [],
                '日' : [],
                '夜' : [],
            },
            //不管跟不跟随都有可能会说的对话
            common : [
                '你好，有什么事吗？',
                '不知道为什么，我只记得自己的名字了',
                '外面好像很危险的样子',
                '我是怎么来到这里的呢……想不起来了',
                '谢谢你让我留下来',
            ],
            '春' : [
                '我好像闻到了花香',
            ],
            '夏' : [
                '好热……'
            ],
            '秋' : [
                '植物都开始枯萎了，我也会枯萎吗'
            ],
            '冬' : [
                '没有感觉到冷呢，真奇怪'
            ],
            '日' : [
                '小动物们都出去玩了吧',
                '我不想出去玩，呆在这里感觉很舒服'
            ],
            '夜' : [
                '嗯……晚上好'
            ],
        },
        giveItem : ['啊，谢谢你'],
        notFood : ['我现在不需要吃东西'],
        notWater : ['我现在不需要喝水'],
        giveFood : ['有点饿了，谢谢你'],
        likeFood : ['这是给我的吗？非常感谢'],
        hateFood : ['这是……嗯，谢谢'],
    },
    '友好' : {
        tell : {
            //没有跟随时才会说的话
            noFollow : {
                //不管什么场景下都可能会说的公用的对话
                common : [],
                //只会在特定季节以及特定时间（日或夜）才会说的话
                '春' : [],
                '夏' : [],
                '秋' : [],
                '冬' : [],
                '日' : [],
                '夜' : [],
            },
            //不管跟不跟随都有可能会说的对话
            common : [
                '嘻嘻，又见面了',
                '你好啊，没有受伤吧？',
                '你真的努力呢，总是在外面冒险',
                '我也好希望出去冒险啊，可惜我太弱了',
            ],
            '春' : [
                '不知道躺在花丛中是什么感觉呢',
                '花瓣被风吹起来的样子真好看',
            ],
            '夏' : [
                '夏天果然还是太热了啊',
                '唔，阴凉处……阴凉处……找到了！',
            ],
            '秋' : [
                '好凉爽啊~',
                '那棵树上有果子吗？',
            ],
            '冬' : [
                '会不会下雪呢，真期待',
                '下雪的话就可以堆雪人了吧',
            ],
            '日' : [
                '你好呀，今天有看到日出吗？',
                '又是努力的一天啊，加油',
            ],
            '夜' : [
                '夜里的风比白天果然还是要凉一些呢',
                '咦，你是在看我吗？',
            ],
        },
        giveItem : [
            '这是给我的吗？太感谢了！',
            '这东西看起来挺有意思的，谢谢你',
            '这是干什么用的呢？嗯，总之谢谢你',
        ],
        notFood : [
            '欸？可是我还没饿啊，谢谢你了',
            '真的吃不下了……谢谢你',
            '肚子好涨啊'
        ],
        notWater : [
            '我并不渴，谢谢啦~',
            '已经喝得够多了，谢谢你~',
        ],
        giveFood : [
            '劳烦您了，经常给我送吃的，非常感谢',
            '谢谢您这么照顾我',
            '啊，真是麻烦您了',
        ],
        likeFood : [
            '唔，好美味，谢谢~',
            '真是美味啊',
            '味道太棒了，谢谢你~',
        ],
        hateFood : [
            '嗯……毕竟劳烦您了呢',
            '没关系，还是可以吃的，谢谢',
        ],
    },
    '亲密' : {
        tell : {
            //没有跟随时才会说的话
            noFollow : {
                //不管什么场景下都可能会说的公用的对话
                common : [
                    '每次你出门我都在为你担心呢……',
                    '果然还是不想你出门，受伤了怎么办……',
                ],
                //只会在特定季节以及特定时间（日或夜）才会说的话
                '春' : [
                    '好想跟你一起去春游啊！嘻嘻，开玩笑的，我会拖累你的吧',
                    '下次给我带一些花回来哦，我给你做个花环吧~',
                ],
                '夏' : [
                ],
                '秋' : [
                ],
                '冬' : [
                ],
                '日' : [
                    '你今天还要出门吗？哼，出门就比陪我还重要吗？',
                    '出去冒险的时候不要忘了我哦，要安全回来知道吗！',
                    '我顶着大太阳，只想为你撑伞~啊，你来了~',
                ],
                '夜' : [
                    '我每天晚上都会对星星许愿，希望星星能保护你，让你每次冒险都能安全回来哦~',
                ],
            },
            //不管跟不跟随都有可能会说的对话
            common : [
                '要保护好自己哦，不然就没人来照顾我了，听到了没！',
                '我也好想变强啊，就可以保护你了~',
                '千万不要受伤哦，我会伤心的，记住了！',
                '我想学着做菜，以后做给你吃好不好？',
                '感觉云朵飞得好慢啊，很悠哉的样子',
                '看，这是我找到的野果~不知道能不能吃，不过真漂亮！',
                '这两片叶子时同一棵树上摘下来的，但是完全不一样呢',
                '我来帮忙砍柴吧~嘿咻！嘿咻！呜，完全砍不动',
                '听说钓鱼很有趣，虽然我不会，不过如果时和你在一起的话，坐在河边一整天也很开心哦~',
                '一只鸟，两只鸟，三只鸟……好困啊……Zzz……',
            ],
            '春' : [
                '啊，你看，好多蝴蝶啊！',
                '听说有一种饮料叫做酒，是用花做的吗？好想尝尝啊',
                '昨天晚上好像下雨了，地上湿湿的呢',
                '你看你看，这朵花是新长出来的，前两天我还没看到呢！',
                '刚才有一只兔子突然从那边跑出来了，呼呼，吓了我一跳呢~',
                '嘿咻嘿咻，我要把这个种子种下去，会长出美丽的花朵吧~',
                '起风了呢~哎呀，我的头发，不许看！乱七八糟的了……',
                '听说对着花朵许愿后，如果明年开了一模一样的花，愿望就会实现哦',
            ],
            '夏' : [
                '热死了热死了热死了，要死要死要死要死！',
                '出了好多汗啊~你在看哪里啊，讨厌！',
                '最讨厌夏天了，不过如果有你陪着的话，哼哼，也没那么讨厌嘛',
                '啊，那是什么？在树上吱吱叫的那个！',
                '那边的树上有好多小果子，它们秋天会成熟吗？好想尝尝~',
                '好热啊，呼——呼——呼——',
                '(哗啦——哗啦——似乎在洗澡，还是先不打扰她吧)',
                '夏天连风都是热的呢',
                '哎呀，那只吱吱叫的虫子飞到我头发上了，快帮我弄下来！',
                '这是什么？蝉？奇怪的名字',
            ],
            '秋' : [
                '一个果子，两个果子，三个果子~',
                '想陪你一起看日落，据说秋天的日落最美了~',
                '秋天的风果然是最舒服的，难道是因为刚过完夏天吗？嘻嘻，错了，是因为有你陪着我哦！',
                '这些掉下来的树叶最终都会变成养分吧',
                '来尝尝我摘的果子吧，很甜哦~',
                '你要喂我吃这个野果吗？啊呜~真好吃！',
                '你看，这个果子是甜的，这个有点酸，这个脆脆的，还有这个……这个……这个……',
                '你来了啊，嘻嘻，你看，来了好多小动物，它们都是看上了我晒的果干哦',
                '这些果子留着，作为种子，然后就能长出好多果树了吧~',
            ],
            '冬' : [
                '等下雪了，我要堆3个雪人，一个你，一个我，一个……哼，要你管！',
                '明明不怕冷，却会怕热，我还真是个奇怪的人啊，对吧~',
                '哎呀，好冷好冷，快给我捂捂手~嘻嘻，骗你的，我才不怕冷呢',
                '啊，你的手怎么这么冷，来我给你捂捂手~',
                '冬天的太阳超~~~温暖的！',
                '你看起来好冷的样子啊，我？我不冷啊，一点都没感觉到冷呢',
                '为什么冬天不下雪呢，真奇怪',
                '还是秋天比较好，有好多野果可以摘，冬天什么都没有了',
                '听说冬天更容易钓到鱼，是真的吗？',
                '啊，那边的水面好像结冰了！',
            ],
            '日' : [
                '太阳到底长什么样呢，我看看……啊，眼睛好痛！眼睛瞎掉了，呜呜呜',
                '(哒哒哒哒，她好像在散步)',
                '为什么白天都看不到星星呢',
                '你看你看，太阳和月亮一起出来了！',
                '看到那两只小鸟了吗？我认识他们哦，他们每天都会来这边找吃的',
            ],
            '夜' : [
                '你要陪我一起看星星吗？',
                '今晚夜色真美~',
                '有点困了，可以让我靠一下吗？Zzz……',
                '月亮旁边为什么没有星星呢，是被月亮赶走了吗',
                '夜晚比白天更吵闹呢',
                '谢谢你来陪我，晚上的时候总觉得特别的孤单',
                '要永远在一起哦[抱住]',
            ],
        },
        //给她物品时可能说的话
        giveItem : [
            '又给我送礼物了呢，我该给你送些什么呢？唔……好纠结',
            '谢谢，我会好好珍藏的~',
            '(*^_^*)能收到你的礼物，我真的好开心',
            '我会把它当成我最宝贵的东西的~',
        ],
        //给她食物，但是她不饿的时候可能说的话
        notFood : [
            '哎呀，我已经吃不下了嘛',
            '真是的，再吃下去吃胖了怎么办',
            '已经饱了，真的，真的，才……才不是因为要减肥呢，哼',
            '不吃不吃不吃，我就不吃，塞进我嘴巴里我也不吃！',
        ],
        //给她水，但是她不渴的时候可能说的话
        notWater : [
            '啊？！你真的以为我是水做的吗？',
            '再喝下去，要变成鲸鱼了哦！',
            '你都可以在我的肚子里游泳了！',
            '你想看彩虹吗？我再多喝点就可以让你看到彩虹了，哼',
        ],
        //她吃不喜欢也不讨厌的东西的时候可能说的话
        giveFood : [
            '又给我带来食物了吗，嘻嘻',
            '我开动了~',
            '啊呜~啊呜~啊呜~',
        ],
        //她吃喜欢的食物的时候可能说的话
        likeFood : [
            '哇，好好吃啊！',
            '你太了解我了，嘻嘻',
            '你这么关心我，是不是有什么企图啊，哼哼',
        ],
        //她吃讨厌的食物的时候可能说的话
        hateFood : [
            '好吧……毕竟是你给我带来的，我就不嫌弃了，哼',
            '啊，这个东西……算了，没事，谢谢你哦~',
        ],
    },
};

//可能为玩家制造的物品
const eduMakeItems = [{
    name : '草编戒指',
    friendliness : 801,
    items : ['纤维'],
    rate : 100,
    text : '繁星啊，求你们帮我保护好他吧，我会每夜都向你们祈祷的。——{name}',
    says : [
        `啊，你来了~`,
        `因为太担心你了，所以……`,
        `这个给你……`,
        `(获得草编戒指)`,
        `这是我给你做的，只要你戴在身上，就像我每天都陪在你身边一样~`,
        `一定要每天戴着哦！`,
        `才……才不是什么订婚戒指呢！`,
        `也不是结婚戒指！！！`,
        `哼（*゜ー゜*）`,
    ]
},{
    name : '牙齿项链',
    friendliness : 900,
    items : ['纤维', '尖牙', '木材', '石头'],
    rate : 100,
    text : '似乎用怪物的牙齿做成的项链能带来力量，我就给你做了一个，不许嫌丑哦！——{name}',
    says : [
        `这边，看这边~`,
        `啊，你受伤了吗？你的衣服是好像有血迹……`,
        `每天出去很危险吧……可以不出去吗？`,
        `就这样，我们每天都在一起，说说话，看看风景之类的……`,
        `对不起，说了任性的话呢`,
        `呐，这是我做的，送给你`,
        `(获得牙齿项链)`,
        `是用怪物的牙齿做的项链哦`,
        `用怪物的牙齿做成的项链能带来力量，是这样吧？`,
        `我也不知道是哪里听来的说法，就是感觉知道嘛~`,
        `总之，不许嫌丑，一定要随身戴着哦！`,
    ]
},{
    name : '水晶徽章',
    friendliness : 1000,
    items : ['纯净水晶', '神性结晶'],
    rate : 100,
    text : '只要我们都戴着这个徽章，我就能感受到你有没有危险哦，当我发现你遇到危险了，我会通过这个徽章把我的力量通过心灵传送给你的，一定会有用的吧——{name}',
    says : [
        `完成了！`,
        `哎呀，被你发现了，不过没关系，本来就是要给你的`,
        `(获得水晶徽章)`,
        `这是用各种水晶打磨的徽章`,
        `然后我用了一些……我自己也不知道怎么做到的方法，把他们弄到一起了`,
        `然后就变成这样子了！`,
        `看，闪闪发光的，很好看吧~`,
        `看，我也有一个一样的，这可是……哼哼`,
        `以后我们就用这个徽章来联系吧`,
        `就是在心里面说话啊，类似心灵感应那种！`,
        `只要多努力，一定可以做到心灵感应的吧，何况还有这么好看的媒介~`,
    ]
},{
    name : '灵魂布偶',
    friendliness : 1000,
    items : ['纤维', '哥布林之心', '布'],
    rate : 100,
    text : '要把这个布偶当成我一样珍惜哦，记得时刻带在身边，就像我永远陪在你身边一样——{name}',
    says : [
        `嘻嘻，有个好东西要送给你`,
        `当当当当！`,
        `厉害吧，这个布偶是不是跟我很像？`,
        `哼哼，当然厉害了，这可是我的分身哦！`,
        `就算我不在你身边，只要你带着这个布偶，我们的灵魂也是连接在一起的`,
        `(获得灵魂布偶)`,
        `千万不能弄丢哦，这可是我的分身！`,
        `你要是把它弄丢了，我就再也不理你了！哼哼`,
    ]
}];

//获取友好度
function getFriendliness(){
    if(data.edu.friendliness <= eduCfgs.friendlinessLine1){
        return '冷漠';
    }
    if(data.edu.friendliness <= eduCfgs.friendlinessLine2){
        return '一般';
    }
    if(data.edu.friendliness <= eduCfgs.friendlinessLine3){
        return '友好';
    }
    if(data.edu.friendliness > eduCfgs.friendlinessLine3){
        return '亲密';
    }
    return '冷漠';
}

//创建养成角色
function createEduRole(){
    const likeFood = eduCfgs.maybeLikeFood.getRandom(eduCfgs.likeFoodNum);
    return {
        id : getNewId(),
        name : eduCfgs.roleNames.getRandom(),
        hunger : eduCfgs.maxHunger,
        water : eduCfgs.maxWater,
        friendliness : eduCfgs.initFriendliness,
        eatDay : data.date,
        sayDay : data.date,
        likeFood,
        isInit : true,
        hateFood : [...eduCfgs.maybeLikeFood,...eduCfgs.maybeHateFood].filter(e => likeFood.indexOf(e) === -1).getRandom(eduCfgs.hateFoodNum),
    }
}

//渲染养成列表
function renderEdu(){
    if(!data.edu){
        return;
    }
    if(data.edu.isInit){
        says([
            `你……你好，我叫${data.edu.name}`,
            '我从哪里来……对不起，我不记得了',
            '我感觉到这里有什么东西在吸引我',
            '我……我可以留下来吗？'
        ],function(){
            data.edu.isInit = false;
            renderEdu();
            save();
        })
    }else{
        $('.edu-win').show().find('.name').html(`${data.edu.name}(${getFriendliness()}：${data.edu.friendliness})`);
        $('.edu-win .follow').html(data.edu.follow ? '取消跟随' : '邀请跟随');
        if(data.edu.knowLike){
            const arr = [...data.edu.knowLike];
            while(arr.length < 3){
                arr.push('???')
            }
            $('#edu-like-food').html(arr.join('，'));
        }
        if(data.edu.knowHate){
            const arr = [...data.edu.knowHate];
            while(arr.length < 5){
                arr.push('???')
            }
            $('#edu-hate-food').html(arr.join('，'));
        }

        if(festival && festival.name === '七夕活动' && data.edu.over && !data.edu.qixiGet){
            $('.qixi').show();
        }else{
            $('.qixi').hide();
        }

        //炼制选项
        if(data.race.name === '断肠人' && data.soulName === '泷' && data.dcrRaceFlag && data.dcrNqhbFlag && data.level >= 60 && hasAmulet('灵魂布偶')){
            $('.refine').show();
        }else{
            $('.refine').hide();
        }
    }
}

//七夕活动点击鹊桥仙
$('.qixi').click(function(){
    if(confirm('是否确定要吟诗？该操作会将你的理智上限补满')){
        data.maxSan = 100;
        data.edu.qixiGet = true;
        renderEdu();
        says([`金风玉露一相逢，便胜却人间无数。两情若是久长时，又岂在朝朝暮暮。`]);
        renderAttrs();
    }
});

//炼制
$('.refine').click(function(){
    if(confirm('是否确定要炼制？炼制功能是将灵魂布偶作为灵体的基础，以养成人物的灵魂作为养料，补全泷和鸳的残魂，让鸳可以以独立的灵体活动。炼制后，养成人物将死亡，且该存档将和BadEnd一样再也无法获得养成人物，然后你将觉醒为“断肠人-花魂”')){
        reduceItem('灵魂布偶')
        data.edu = null;
        data.eduOver = true;
        checkRaceOnceAwaken('断肠人-花魂');
        $('.edu-win').hide();
        renderMapElements(false, true)
    }
});

//渲染对话
let eduSayList = [];
let eduCallback = function(){};
function says(sayList = [], callback = function(){}){
    eduSayList = sayList;
    eduCallback = callback;
    if(sayList.length > 1){
        $('.say-win-ok').hide();
        $('.say-win-next').show().attr('data-index', 1);
    }else{
        $('.say-win-ok').show();
        $('.say-win-next').hide();
    }
    $('.say-win .say-win-title').html(sayList[0])
    $('.say-win').show();
}
$('.say-win-ok').click(function(){
    eduCallback();
    eduCallback = function(){};
});
$('.say-win-next').click(function(){
    const index = parseInt($(this).attr('data-index'));
    if(eduSayList.length - 1 == index){
        $('.say-win-ok').show();
        $('.say-win-next').hide();
    }else{
        $('.say-win-next').attr('data-index', index + 1);
    }
    $('.say-win .say-win-title').html(eduSayList[index])
});

//对话
$('.edu-win .tell').click(function(){
    //修改交流时间
    data.edu.sayDay = data.date;

    const day = new Date(data.date).format('yyyy-MM-dd');
    if(festival && festival.name === '七夕活动' && data.edu.qixiSay !== day){
        data.edu.qixiSay = day;
        addObjSan(data, 1);
        renderAttrs();
        save();
    }

    if(data.edu.friendliness >= 2000 && !data.edu.over){
        says([
            `呜……这是什么……`,
            `头好痛……`,
            `不……我不要……`,
            `快走……对不起，快走……`,
        ], () => {
            $('.edu-win').hide();
            startBattle('创世神', true)
            save();
            says([
                `呵呵，凡人`,
                `是吗。你的灵魂沾染到了我的力量`,
                `难怪我的人性沉睡了几百亿年，竟然自己醒来了`,
                `现在，我要收回我的人性了`,
                `凡人，你要阻拦我吗？`,
                `呵呵，愚蠢的凡人`,
            ]);
        });
        return;
    }

    const geted = eduMakeItems.filter(e => data.edu.maked.indexOf(e.name) === -1 && data.edu.friendliness >= e.friendliness && data.edu.items.hasAll(e.items) && randomNum(1,100) <= e.rate);
    if(geted.length > 0){
        says(geted[0].says);
        data.edu.maked.push(geted[0].name);
        addItem(geted[0].name, 1, {
            roleId : data.edu.id,
            text : geted[0].text.replace('{name}', data.edu.name),
        })
        data.edu.items = data.edu.items.filter(e => geted[0].items.indexOf(e) === -1)
        save();
        return;
    }

    const tell = eduSays[getFriendliness()].tell;
    const tells = [...tell.common,...tell[getSeason()], ...tell[getDayOrNight()], ...(data.edu.follow ? [] : tell.noFollow.common), ...(data.edu.follow ? [] : tell.noFollow[getSeason()]), ...(data.edu.follow ? [] : tell.noFollow[getDayOrNight()])];
    says([tells.getRandom()]);
    save();
    renderEdu();
});

$('.edu-items-win-items').on('click', 'div', function(){
    $('.edu-items-win-items div').removeClass('active');
    $(this).addClass('active')
});
//送食物
$('.edu-win .food').click(function(){
    if(data.edu.hunger >= eduCfgs.needFood && data.edu.water >= eduCfgs.needFood){
        says([eduSays[getFriendliness()].notFood.getRandom()]);
        return;
    }
    $('.edu-items-win-items').html(data.bag.filter(e => e.canUse && (e.hunger || e.water)).map(e => `<div>${e.name}</div>`).join(''))
    $('.five-food').show();
    $('.five-item').hide();
    $('.edu-items-win').show();
});
function giveFood(){
    const $select = $('.edu-items-win-items .active');
    if($select.length > 0){
        const name = $select.html();
        const like = data.edu.likeFood.indexOf(name) !== -1;
        const hate = data.edu.hateFood.indexOf(name) !== -1;

        //如果是只补充饥饿的食物，且饥饿不需要补充，则说话
        if(data.edu.hunger >= eduCfgs.needFood && !elementCfgs[name].water){
            says([eduSays[getFriendliness()].notFood.getRandom()]);
            return;
        }

        //如果是只补充水分的食物，且水分不需要补充，则说话
        if(data.edu.water >= eduCfgs.needFood && !elementCfgs[name].hunger){
            says([eduSays[getFriendliness()].notWater.getRandom()]);
            return;
        }

        if(elementCfgs[name].hunger > 0){
            data.edu.hunger = eduCfgs.maxHunger;
            data.edu.saidNeedFood = false;
        }
        if(elementCfgs[name].water > 0){
            data.edu.water = eduCfgs.maxWater;
            data.edu.saidNeedWater = false;
        }

        if(like){
            data.edu.friendliness += eduCfgs.giveLikeFoodAddFriendliness;
            says([eduSays[getFriendliness()].likeFood.getRandom()]);
            if(!data.edu.knowLike){
                data.edu.knowLike = [];
            }
            if(!data.edu.knowLike.includes(name)){
                data.edu.knowLike.push(name);
            }
        }else if(hate){
            data.edu.friendliness -= eduCfgs.giveHateFoodReduceFriendliness;
            says([eduSays[getFriendliness()].hateFood.getRandom()]);
            if(!data.edu.knowHate){
                data.edu.knowHate = [];
            }
            if(!data.edu.knowHate.includes(name)){
                data.edu.knowHate.push(name);
            }
        }else{
            data.edu.friendliness += eduCfgs.giveFoodAddFriendliness;
            says([eduSays[getFriendliness()].giveFood.getRandom()]);
        }

        reduceItem(name);
        $('.edu-items-win').hide();
        renderMapElements();
        save();
        renderEdu();
    }else{
        winMsg('请选择要赠送的食物', false, false);
    }
}
//送礼物
$('.edu-win .gift').click(function(){
    $('.edu-items-win-items').html(data.bag.filter(e => {
        if(e.isLock){
           return false;
        }
        if(data.weapon && data.weapon.id === e.id){
            return false;
        }
        if(data.armor && data.armor.id === e.id){
            return false;
        }
        if(data.bagEquip && data.bagEquip.id === e.id){
            return false;
        }
        if(data.mount && data.mount.id === e.id){
            return false;
        }
        return true;
    }).map(e => `<div data-id="${e.id}">${e.name}</div>`).join(''))
    $('.five-food').hide();
    $('.five-item').show();
    $('.edu-items-win').show();
});
function giveItem(){
    const $select = $('.edu-items-win-items .active');
    if($select.length > 0){
        const id = $select.attr('data-id');
        const item = getBagItemById(id);

        if(item.name.includes('戒指')){
            let filter = data.edu.items.filter(e => e.includes('戒指'));
            if(filter.length > 0){
                says([`你已经送过${filter[0]}给我了`]);
                return;
            }
        }

        reduceItemById(id)

        if(!data.edu.items.includes(item.name)){
            data.edu.items.push(item.name);
            if(getFriendliness() === '亲密' && item.name === '巧克力'){
                data.edu.friendliness += 1000;
            }
        }
        says([eduSays[getFriendliness()].giveItem.getRandom()]);
        $('.edu-items-win').hide();
        save();
        renderEdu();
    }else{
        winMsg('请选择要赠送的礼物', false, false);
    }
}
//邀请跟随
$('.edu-win .follow').click(function(){
    if(data.edu.follow){
        if(isInHome()){
            data.edu.follow = false;
            says([
                '好的，你先去忙吧',
                '放心吧，我一个人没关系的，我会照顾好自己的',
                '要经常来陪我哦~',
            ])
            save();
            renderEdu();
        }else{
            winMsg('只能在家里取消跟随', false, false);
        }
    }else{
        if(getFriendliness() === '亲密'){
            if(data.edu.follow == null && !confirm(`是否确认要让${data.edu.name}跟随你？请仔细阅读图鉴-说明-跟随后再决定`)){
                return;
            }
            says(data.edu.follow == null ? [
                '什……什么，要我跟着你？',
                '哈哈，你开玩笑的吧，我跟着你的话会拖累你的吧',
                '不要在这种事情上认真啊！',
                '也不是不相信你啦，只是，你还要分心保护我的话……',
                '好啦好啦，我也不想跟你分开嘛！',
                '那……那好吧，你得保护好我哦',
                '我也会努力帮忙的！',
            ] : [
                '你来接我啦~',
                '今天开始也要一起努力哦~'
            ])
            data.edu.follow = true;
            save();
            renderEdu();
        }else{
            says(['抱歉，我太弱了，不想拖累你'])
        }
    }
});
//赶走
$('.edu-win .drive').click(function(){
    if(!confirm(`是否确认要赶走${data.edu.name}`)){
        return;
    }
    data.edu = null;
    save();
    $('.edu-win').hide();
    renderMapElements();
    says(['……对不起，打扰您了，我这就离开'])
});

//校验是否有某个护身符
function hasAmulet(name){
    if(!data.edu){
        return false;
    }
    return data.bag.filter(e => e.isAmulet && e.name === name && e.roleId == data.edu.id).length > 0;
}
