//元素配方
const elementalRecipes = {
    力量药剂 : {
        金 : [20, 25],
        木 : [0, 0],
        水 : [0, 0],
        火 : [10, 15],
        土 : [5, 10],
        极 : [1, 5],
    },
    敏捷药剂 : {
        金 : [0, 0],
        木 : [0, 0],
        水 : [3, 7],
        火 : [18, 23],
        土 : [5, 5],
        极 : [1, 5],
    },
    经验药剂 : {
        金 : [80, 100],
        木 : [90, 100],
        水 : [50, 60],
        火 : [30, 50],
        土 : [130, 150],
        极 : [120, 130],
    },
    学习药剂 : {
        金 : [150, 180],
        木 : [100, 120],
        水 : [80, 90],
        火 : [10, 20],
        土 : [0, 0],
        极 : [150, 160],
    },
    香甜药水 : {
        金 : [0, 0],
        木 : [5, 10],
        水 : [0, 5],
        火 : [0, 0],
        土 : [0, 0],
        极 : [10000, 10000],
    },
};

//选择配方
let elementalRecipesRad = null;
$('.elemental-recipes-rad select').change(function(){
    elementalRecipesRad = $(this).val();
});

function renderElementalOnlyItems(){
    renderElemental(true);
}

//渲染元素实验室
function renderElemental(onlyItems){
    $('.elemental-win').show();

    let active = [];
    $('.elemental-win .tab-head.active').each(function(){
        active.push($(this).html());
    })

    if(!onlyItems){
        $('.frp-list').html('');
        $('.count-elemental').html('');
    }
    $('.elemental-items').html('');

    $('.elemental-recipes-rad select').html(Object.keys(elementalRecipes).map(e => `<option>${e}</option>`).join(''))
    if(elementalRecipesRad){
        $('.elemental-recipes-rad select').val(elementalRecipesRad);
    }else{
        elementalRecipesRad = $('.elemental-recipes-rad select').val();
    }

    //渲染装备列表
    data.bag.forEach(e => {
        if(elementCfgs[e.name].elemental){
            //筛选
            if(active.length > 0 && arrayIntersection([active,Object.keys(elementCfgs[e.name].elemental)]).length === 0){
                return;
            }
            $('.elemental-items').append(`<div data-id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}<br>${Object.keys(elementCfgs[e.name].elemental).map(ele => `${ele}(${elementCfgs[e.name].elemental[ele]})`).join('，')}</div>`);
        }
    })
}

//点击选择物品
$('.elemental-items').on('click', '.bag-item', function(){
    const id = $(this).attr('data-id');
    if(id){
        const item = getBagItemById(id);
        let has = $(`.frp[data-id=${id}]`);
        if(has.length > 0){
            const num = parseInt(has.attr('data-num'));
            if(num >= 10){
                winMsg('每种素材最多只能放入10个', false, false)
                return;
            }
            if(getNumById(id) > num){
                has.attr('data-num', num + 1).find('span').html(`${item.name}*${num + 1}`);
            }
        }else{
            if($('.frp').length >= 5){
                winMsg('最多只能放入5种素材', false, false)
                return;
            }
            $('.frp-list').append(`<div class="frp" data-num="1" data-id="${id}"><span>${item.name}*1</span><button class="add-elemental-item">+1</button><button class="reduce-elemental-item">-1</button></div>`)
        }
        countElemental();
    }
})

//数量加减
$('.frp-list').on('click', '.add-elemental-item', function(){
    const parent = $(this).parent();
    const num = parseInt(parent.attr('data-num'));
    if(num >= 10){
        winMsg('每种素材最多只能放入10个', false, false)
        return;
    }
    const id = parent.attr('data-id');
    const item = getBagItemById(id);
    if(item.quantity > num){
        parent.attr('data-num', num + 1).find('span').html(`${item.name}*${num + 1}`);
    }
    countElemental();
});
$('.frp-list').on('click', '.reduce-elemental-item', function(){
    const parent = $(this).parent();
    const num = parseInt(parent.attr('data-num'));
    if(num > 1){
        const id = parent.attr('data-id');
        const item = getBagItemById(id);
        parent.attr('data-num', num - 1).find('span').html(`${item.name}*${num - 1}`);
    }else{
        parent.remove()
    }
    countElemental();
});

//计算总元素
function countElemental(){
    $('.count-elemental').html('');
    const count = {};
    $('.frp').each(function(){
        const id = $(this).attr('data-id');
        const num = parseInt($(this).attr('data-num'));
        const item = getBagItemById(id);
        const ele = elementCfgs[item.name].elemental;
        Object.keys(ele).forEach(e => {
            if(!count[e]){
                count[e] = 0;
            }
            count[e] += ele[e] * num;
        })
    })
    $('.count-elemental').html(Object.keys(count).map(e => `<div>${e}(${count[e]})</div>`).join(''));
    return count;
}

//元素调和
$('.start-elemental').click(function(){
    if($('.frp').length > 0){
        //获取元素总和
        const count = countElemental();
        //循环所有配方
        const filter = Object.keys(elementalRecipes).filter(e => {
            let flag = true;
            //循环该配方需要的所有元素
            for(const name in elementalRecipes[e]){
                //获取该元素需要的数量
                const nums = elementalRecipes[e][name];
                //如果要求元素数量为0，则没有该元素就返回true,有则false
                if(nums[0] === 0 && nums[1] === 0){
                    if(count[name]){
                        flag = false;
                    }
                }else if(!count[name] || count[name] < nums[0] || count[name] > nums[1]){
                    flag = false;
                }
            }

            return flag;
        });

        if(filter.length > 0){
            addItem(filter[0])
            winMsg(`调和成功，你获得了[${filter[0]}*1]`)
            addElementalRecipes(filter[0]);
        }else{
            winMsg(`本次调和失败了，什么也没有获得`)
        }

        //减少素材数量
        $('.frp').each(function(){
            const id = $(this).attr('data-id');
            const num = parseInt($(this).attr('data-num'));
            reduceItemById(id, num);
        })
        renderElemental();
        save();
    }
});

//记录配方
function addElementalRecipes(name){
    if(!conf.elementalRecipes[name]){
        conf.elementalRecipes[name] = [];
    }
    //获取已有配方
    const arr = conf.elementalRecipes[name];
    let $frp = $('.frp');

    //获取本次配方的所有物品
    const nowItems = {};
    $frp.each(function(){
        const id = $(this).attr('data-id');
        const num = parseInt($(this).attr('data-num'));
        const item = getBagItemById(id);
        nowItems[item.name] = num;
    })

    //判定有没有一模一样的配方
    const filter = arr.filter(e => {
        //数量都对不上就不用继续了
        if(Object.keys(e).length === $frp.length){
            for(const key in e){
                if(!nowItems[key] || nowItems[key] !== e[key]){
                    //没有材料或者材料数量不对就可以直接排除了
                    return false;
                }
            }
        }else{
            return false;
        }
        return true;
    })

    //没有相同配方，则记录
    if(filter.length === 0){
        conf.elementalRecipes[name].push(nowItems);
        save(confSavedName, conf);
    }
}

//显示配方
$('.elemental-head button').click(function(){
    $('.elemental-recipes-win .win-body').html('');
    Object.keys(conf.elementalRecipes).filter(e => conf.elementalRecipes[e].length > 0).forEach(e => {
        let html = '';
        html += `<div class="elemental-recipes-one">`;
        html += `   <div class="elemental-recipes-title">${e}(点击展开/收起)</div>`;
        html += `   <div class="elemental-recipes-list">`;
        conf.elementalRecipes[e].forEach(i => {
            html += `       <div class="elemental-recipes-list-one">`;
            html += `           <div class="elemental-recipes-items">`;
            Object.keys(i).forEach(it => {
                html += `               <div class="elemental-recipes-item" data-name="${it}" data-num="${i[it]}">${it}*${i[it]} / ${getNumByBag(it)}</div>`;
            })
            html += `           </div>`;
            html += `           <div class="elemental-recipes-select">选择</div>`;
            html += `           <div class="elemental-recipes-create-all" data-name="${e}">全部制造</div>`;
            html += `           <div class="elemental-recipes-delete" data-name="${e}">删除</div>`;
            html += `       </div>`;
        })
        html += `   </div>`;
        html += `</div>`;
        $('.elemental-recipes-win .win-body').append(html);
    })
    $('.elemental-recipes-win').show();
});

//切换配方显示隐藏
$('.elemental-recipes-win').on('click','.elemental-recipes-title',function(){
    let find = $(this).parent().find('.elemental-recipes-list');
    if(find.is(':hidden')){
        find.show();
    }else{
        find.hide();
    }
})

//选择配方
$('.elemental-recipes-win').on('click','.elemental-recipes-select',function(){
    let flag = true;
    const items = {};
    $(this).parent().find('.elemental-recipes-item').each(function(){
        const name = $(this).attr('data-name');
        const num = parseInt($(this).attr('data-num'));
        if(getNumByBag(name) < num){
            flag = false;
        }else{
            items[name] = num;
        }
    });

    if(flag){
        $('.frp-list').html(Object.keys(items).map(e => `<div class="frp" data-num="${items[e]}" data-id="${getBagItemByName(e).id}"><span>${e}*${items[e]}</span><button class="add-elemental-item">+1</button><button class="reduce-elemental-item">-1</button></div>`).join(''));
        countElemental();
        $('.elemental-recipes-win').hide();
    }else{
        winMsg(`材料不足`, false, false)
    }
})

//全部制造
$('.elemental-recipes-win').on('click','.elemental-recipes-create-all',function(){
    const name = $(this).attr('data-name');
    const find = $(this).parent().find('.elemental-recipes-item');

    //获取元素总和
    $('.count-elemental').html('');
    const count = {};
    find.each(function(){
        const name = $(this).attr('data-name');
        const num = parseInt($(this).attr('data-num'));
        const ele = elementCfgs[name].elemental;
        Object.keys(ele).forEach(e => {
            if(!count[e]){
                count[e] = 0;
            }
            count[e] += ele[e] * num;
        })
    })
    //校验配方
    let flag = true;
    //循环该配方需要的所有元素
    for(const n in elementalRecipes[name]){
        //获取该元素需要的数量
        const nums = elementalRecipes[name][n];
        //如果要求元素数量为0，则没有该元素就返回true,有则false
        if(nums[0] === 0 && nums[1] === 0){
            if(count[n]){
                flag = false;
            }
        }else if(!count[n] || count[n] < nums[0] || count[n] > nums[1]){
            flag = false;
        }
    }

    if(!flag){
        winMsg('配方错误')
        return
    }


    if(!confirm('是否按照该配方全部制造？')){
        return;
    }
    flag = true;
    let minNum = 99999999;
    const items = {};
    find.each(function(){
        const name = $(this).attr('data-name');
        const num = parseInt($(this).attr('data-num'));
        const has = getNumByBag(name);
        if(has < num){
            flag = false;
        }else{
            const canNum = parseInt(has / num)
            if(minNum > canNum){
                minNum = canNum;
            }
            items[name] = num;
        }
    });

    if(flag){
        //删除物品
        Object.keys(items).forEach(e => {
            reduceItem(e, minNum * items[e])
        })

        addItem(name, minNum)
        winMsg(`你制造了[${name}*${minNum}]`)
        save()
        $('.elemental-head button').click();
    }else{
        winMsg(`材料不足`, false, false)
    }
})

//删除配方
$('.elemental-recipes-win').on('click','.elemental-recipes-delete',function(){
    if(!confirm('是否确认删除该配方？')){
        return;
    }
    const items = {};
    $(this).parent().find('.elemental-recipes-item').each(function(){
        const name = $(this).attr('data-name');
        const num = parseInt($(this).attr('data-num'));
        items[name] = num;
    });

    //判定有没有一模一样的配方
    const name = $(this).attr('data-name');
    conf.elementalRecipes[name] = conf.elementalRecipes[name].filter(e => {
        //数量都对不上就不用继续了
        if(Object.keys(e).length === Object.keys(items).length){
            for(const key in e){
                if(!items[key] || items[key] !== e[key]){
                    //没有材料或者材料数量不对就可以直接排除了
                    return true;
                }
            }
        }else{
            return true;
        }
        return false;
    })

    save(confSavedName, conf);
    $('.elemental-head button').click();
})

//配方研究
$('.rad-elemental').click(function(){
    const name = $('.elemental-recipes-rad select').val();
    const need = elementalRecipes[name];
    const count = countElemental();
    let text = [];
    let flag = true;

    Object.keys(need).forEach(e => {
        if(!count[e] && (need[e][0] !== 0 || need[e][1] !== 0)){
            text.push(`似乎需要${e}元素`)
            flag = false;
        }else if(count[e] > need[e][1]){
            text.push(`${e}元素反应过于剧烈`)
            flag = false;
        }else if(count[e] < need[e][0]){
            text.push(`${e}元素反应过于微弱`)
            flag = false;
        }
    })

    if(flag){
        addItem(name)
        winMsg(`研究成功，你获得了[${name}*1]`)
        addElementalRecipes(name);
    }else{
        $('.alert-win').show().find('.alert-win-title').html(text.join('，'))
    }

    //减少素材数量
    $('.frp').each(function(){
        const id = $(this).attr('data-id');
        const num = parseInt($(this).attr('data-num'));
        reduceItemById(id, num);
    })
    renderElemental();
    save();
})

//渲染元素实验室图鉴
function renderElementalCybernet(){
    $('.elemental-cybernet-win').show();
    $('.elemental-cybernet-items').html('');

    let active = [];
    $('.elemental-cybernet-win .tab-head.active').each(function(){
        active.push($(this).html());
    })

    //渲染物品列表
    Object.keys(elementCfgs).filter(e => elementCfgs[e].elemental).map(e => ({...elementCfgs[e],name :e})).forEach(e => {
        //筛选
        if(active.length > 0 && arrayIntersection([active,Object.keys(elementCfgs[e.name].elemental)]).length === 0){
            return;
        }
        $('.elemental-cybernet-items').append(`<div data-id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''}">${e.showName || e.name}<br>${Object.keys(elementCfgs[e.name].elemental).map(ele => `${ele}(${elementCfgs[e.name].elemental[ele]})`).join('，')}</div>`);
    })
}
