//不同附魔等级需要的变异核心数量
const levelMappingNeed = {
    1 : -913141314,
    2 : 20,
    3 : 35,
    4 : 50,
    5 : 70,
    6 : 90,
    7 : 120,
    8 : 150,
    9 : 180,
    10 : 220,
    11 : 260,
    12 : 300,
    13 : 350,
    14 : 400,
    15 : 500,
    16 : 800,
    17 : 1500,
    18 : 3000,
    19 : 5000,
    20 : 8000,
    21 : 12000,
}

//渲染附魔台
function renderEnhancements(){
    $('.enhancements-equips').html('');
    $('.enhancements-equip-info').attr('data-id','').html('');
    //$('.enhancements-level span').html(0);
    $('.enhancements-need span').html(`${$('.enhancements-need span').html().split('/')[0]}/${getNumByBag('变异核心',true)}`);
    data.bag.forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && !e.name.startsWith('技能石：')){
            $('.enhancements-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
}

//选中装备时
$('.enhancements-equips').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    //渲染窗口文本
    $('.enhancements-equip-info').attr('data-id',id).html(text);
});

//附魔等级-1
$('.enhancements-menu .reduce').click(function(){
    let level = parseInt($('.enhancements-level span').html());
    if(level > 1){
        level--;
        $('.enhancements-level span').html(level);
        $('.enhancements-need span').html(`${levelMappingNeed[level]}/${getNumByBag('变异核心',true)}`);
    }
});

//附魔等级+1
$('.enhancements-menu .add').click(function(){
    let level = parseInt($('.enhancements-level span').html());
    const maxLevel = Object.keys(variations).filter(e => variations[e].level <= data.level).map(e => variations[e].num).sort((a,b) => b-a)[0];
    if(level < maxLevel){
        level++;
        $('.enhancements-level span').html(level);
        $('.enhancements-need span').html(`${levelMappingNeed[level]}/${getNumByBag('变异核心',true)}`);
    }
});

//附魔等级最大
$('.enhancements-menu .max').click(function(){
    const maxLevel = Object.keys(variations).filter(e => variations[e].level <= data.level).map(e => variations[e].num).sort((a,b) => b-a)[0];
    $('.enhancements-level span').html(maxLevel);
    $('.enhancements-need span').html(`${levelMappingNeed[maxLevel]}/${getNumByBag('变异核心',true)}`);
});

//确认附魔
$('.enhancements-start .start').click(function(){
    //获取附魔信息
    const id = $('.enhancements-equip-info').attr('data-id');
    const item = data.bag.filter(e => e.id === id)[0];
    let level = parseInt($('.enhancements-level span').html());
    let needNum = data.race.name.startsWith('星灵-宙') ? 0 : levelMappingNeed[level];
    //获取变异核心数量
    const num = getNumByBag('变异核心',true);

    if(!id){
        winMsg('请选择要附魔的装备',false, false);
        return;
    }
    if(level < 1){
        winMsg('附魔等级至少需要1',false, false);
        return;
    }
    if(num < needNum){
        winMsg('变异核心不足',false, false);
        return;
    }

    //开始附魔，根据附魔等级随机获取变异词缀
    const name = Object.keys(variations).filter(e => variations[e].num <= level && variations[e].num >= level - 5).getRandom();
    const variation = variations[name];

    let isEquiped = false;
    if((data.weapon && data.weapon.id === id) || (data.armor && data.armor.id === id)){
        isEquiped = true;
        equip(item);
    }

    if(item.enhancements){
        item.hp -= item.enhancements.hp;
        item.atk -= item.enhancements.atk;
        item.def -= item.enhancements.def;
    }
    item.enhancements = {
        name,
        hp : variation.hp,
        atk : variation.atk,
        def : variation.def
    };

    item.hp += item.enhancements.hp;
    item.atk += item.enhancements.atk;
    item.def += item.enhancements.def;

    //减少变异核心
    const bagNum = getNumByBag('变异核心');
    //优先使用背包中的物品
    if(bagNum >= needNum){
        reduceItem('变异核心', needNum);
    }else{
        if(bagNum > 0){
            reduceItem('变异核心', bagNum);
        }
        reduceItemByStore('变异核心', needNum - bagNum);
    }

    winMsg(`附魔成功，[${item.showName || item.name}]获得变异词条[${name}]`);

    if(isEquiped){
        equip(item);
    }

    renderEnhancements()
    save();
});
