//创建词缀
function createFix(name,level,quality,attrs){
    return {[name] : {level,quality,attrs}}
}

//品质属性
const qualityAttr = {
    0 : {name : '普通', color : '#000'},
    1 : {name : '优秀', color : 'green'},
    2 : {name : '精良', color : 'blue'},
    3 : {name : '传说', color : '#ff5722'},
    4 : {name : '神话', color : '#ff0000'},
}

//不同品质增加的熟练度
const qualityAddForgeExp = {
    0 : 50000,
    1 : 100000,
    2 : 200000,
    3 : 500000,
    4 : 1000000,
};

//不同品质维修需要的虚空粉尘数量
const qualityFixNeedDust = {
    0 : 1,
    1 : 2,
    2 : 3,
    3 : 4,
    4 : 5,
};

//不同品的基础概率
const qualityRate = {
    1 : 10000,
    2 : 50000,
    3 : 100000,
    4 : 100000,
};

//不同品的最大概率
const qualityRateMax = {
    1 : 3000,
    2 : 2000,
    3 : 1000,
    4 : 5000,
};

//不同孔数的概率(千分之)
const holeRate = {
    1 : 50000,
    2 : 30000,
    3 : 10000,
    4 : 50000,
    5 : 25000,
    6 : 10000,
};

//前缀
const prefixs = {
    //优秀
    ...createFix('锋利的',1,1,{atk : 1}),
    ...createFix('坚固的',1,1,{def : 1}),
    ...createFix('耐用的',1,1,{endurance : 10}),

    ...createFix('穿刺之',4,1,{atk : 2}),
    ...createFix('守卫之',4,1,{def : 2}),
    ...createFix('牢靠的',4,1,{endurance : 20}),

    ...createFix('强击之',7,1,{atk : 3}),
    ...createFix('防御之',7,1,{def : 3}),
    ...createFix('强韧的',7,1,{endurance : 30}),

    ...createFix('蜂刺之',10,1,{atk : 4}),
    ...createFix('乌鱼之',10,1,{def : 4}),
    ...createFix('海龟之',10,1,{endurance : 40}),

    ...createFix('沉重的',13,1,{atk : 5}),
    ...createFix('稳定的',13,1,{def : 5}),
    ...createFix('稳固的',13,1,{endurance : 50}),

    ...createFix('老鹰之',17,1,{atk : 6}),
    ...createFix('河马之',17,1,{def : 6}),
    ...createFix('猿猴之',17,1,{endurance : 60}),

    ...createFix('蛮牛之',20,1,{atk : 7}),
    ...createFix('麋鹿之',20,1,{def : 7}),
    ...createFix('鹦鹉之',20,1,{endurance : 70}),

    ...createFix('毒蛇之',23,1,{atk : 8}),
    ...createFix('巨蜥之',23,1,{def : 8}),
    ...createFix('野牛之',23,1,{endurance : 80}),

    ...createFix('饿狼之',27,1,{atk : 9}),
    ...createFix('白犀之',27,1,{def : 9}),
    ...createFix('豚鼠之',27,1,{endurance : 90}),

    ...createFix('蜜蜂的',30,1,{atk : 12}),
    ...createFix('蝴蝶的',30,1,{def : 10}),
    ...createFix('蠕虫之',30,1,{endurance : 120}),

    ...createFix('蝉蛹之',33,1,{atk : 15}),
    ...createFix('青虫之',33,1,{def : 12}),
    ...createFix('蚱蜢之',33,1,{endurance : 150}),

    ...createFix('蜻蜓之',37,1,{atk : 18}),
    ...createFix('白象之',37,1,{def : 15}),
    ...createFix('灰狼之',37,1,{endurance : 180}),

    ...createFix('狸猫之',40,1,{atk : 21}),
    ...createFix('仓鼠之',40,1,{def : 18}),
    ...createFix('河豚之',40,1,{endurance : 210}),

    ...createFix('雄峰之',43,1,{atk : 25}),
    ...createFix('蚁后之',43,1,{def : 20}),
    ...createFix('灵蝶之',43,1,{endurance : 250}),

    ...createFix('花犬之',47,1,{atk : 30}),
    ...createFix('橘猫之',47,1,{def : 24}),
    ...createFix('候鸟之',47,1,{endurance : 300}),

    ...createFix('刺蛇之',50,1,{atk : 35}),
    ...createFix('猛犸之',50,1,{def : 28}),
    ...createFix('迅龙之',50,1,{endurance : 350}),

    ...createFix('狂狼之',53,1,{atk : 40}),
    ...createFix('夜枭之',53,1,{def : 35}),
    ...createFix('风龙之',53,1,{endurance : 400}),

    ...createFix('青鸟之',57,1,{atk : 45}),
    ...createFix('黄蟒之',57,1,{def : 40}),
    ...createFix('黑蛇之',57,1,{endurance : 450}),

    ...createFix('绿蜥之',60,1,{atk : 50}),
    ...createFix('白猫之',60,1,{def : 45}),
    ...createFix('灰兔之',60,1,{endurance : 500}),

    ...createFix('红鸾之',63,1,{atk : 60}),
    ...createFix('火凤之',63,1,{def : 52}),
    ...createFix('橘豹之',63,1,{endurance : 600}),

    ...createFix('黄象之',67,1,{atk : 70}),
    ...createFix('灵猴之',67,1,{def : 60}),
    ...createFix('巨猿之',67,1,{endurance : 700}),

    ...createFix('红鸟之',70,1,{atk : 80}),
    ...createFix('青蛇之',70,1,{def : 70}),
    ...createFix('白龙之',70,1,{endurance : 800}),

    ...createFix('冰龙之',73,1,{atk : 90}),
    ...createFix('飞虎之',73,1,{def : 80}),
    ...createFix('龙蝎之',73,1,{endurance : 900}),

    //精良
    ...createFix('蜂鸟之',1,2,{atk : 1, def : 1}),
    ...createFix('强木之',1,2,{endurance : 10, def : 1}),
    ...createFix('狂妄的',1,2,{atk : 1, endurance : 10}),

    ...createFix('刺客之',4,2,{atk : 2, def : 2}),
    ...createFix('不屈的',4,2,{endurance : 20, def : 2}),
    ...createFix('哈根的',4,2,{atk : 2, endurance : 20}),

    ...createFix('罡风之',7,2,{atk : 3, def : 3}),
    ...createFix('乌云之',7,2,{endurance : 30, def : 3}),
    ...createFix('海洋的',7,2,{atk : 3, endurance : 30}),

    ...createFix('深蓝的',10,2,{atk : 4, def : 4}),
    ...createFix('翠绿之',10,2,{endurance : 40, def : 4}),
    ...createFix('深红之',10,2,{atk : 4, endurance : 40}),

    ...createFix('碎片之',13,2,{atk : 5, def : 5}),
    ...createFix('碎石之',13,2,{endurance : 50, def : 5}),
    ...createFix('布偶之',13,2,{atk : 5, endurance : 50}),

    ...createFix('钢丝之',17,2,{atk : 6, def : 6}),
    ...createFix('铁甲之',17,2,{endurance : 60, def : 6}),
    ...createFix('蛋壳之',17,2,{atk : 6, endurance : 60}),

    ...createFix('血刺之',20,2,{atk : 7, def : 7}),
    ...createFix('铁皮之',20,2,{endurance : 70, def : 7}),
    ...createFix('橡胶之',20,2,{atk : 7, endurance : 70}),

    ...createFix('锋刃之',23,2,{atk : 8, def : 8}),
    ...createFix('牛皮之',23,2,{endurance : 80, def : 8}),
    ...createFix('芦苇之',23,2,{atk : 8, endurance : 80}),

    ...createFix('枯叶之',27,2,{atk : 9, def : 9}),
    ...createFix('杂草之',27,2,{endurance : 90, def : 9}),
    ...createFix('落日之',27,2,{atk : 9, endurance : 90}),

    ...createFix('浮尘之',30,2,{atk : 12, def : 10}),
    ...createFix('余辉之',30,2,{endurance : 120, def : 10}),
    ...createFix('光芒之',30,2,{atk : 12, endurance : 120}),

    ...createFix('丝线之',33,2,{atk : 15, def : 12}),
    ...createFix('泥泞之',33,2,{endurance : 150, def : 12}),
    ...createFix('枯木之',33,2,{atk : 15, endurance : 150}),

    ...createFix('莲叶之',37,2,{atk : 18, def : 15}),
    ...createFix('涟漪之',37,2,{endurance : 180, def : 15}),
    ...createFix('波浪之',37,2,{atk : 18, endurance : 180}),

    ...createFix('泰山之',40,2,{atk : 21, def : 18}),
    ...createFix('山脉之',40,2,{endurance : 210, def : 18}),
    ...createFix('山峰之',40,2,{atk : 21, endurance : 210}),

    ...createFix('羊肠之',43,2,{atk : 25, def : 20}),
    ...createFix('牛群之',43,2,{endurance : 250, def : 20}),
    ...createFix('奔驰之',43,2,{atk : 25, endurance : 250}),

    ...createFix('莲火之',47,2,{atk : 30, def : 24}),
    ...createFix('冰叶之',47,2,{endurance : 300, def : 24}),
    ...createFix('风霜之',47,2,{atk : 30, endurance : 300}),

    ...createFix('日晒之',50,2,{atk : 35, def : 28}),
    ...createFix('雨林之',50,2,{endurance : 350, def : 28}),
    ...createFix('鱼皮之',50,2,{atk : 35, endurance : 350}),

    ...createFix('荷花之',53,2,{atk : 40, def : 35}),
    ...createFix('针叶之',53,2,{endurance : 400, def : 35}),
    ...createFix('树皮之',53,2,{atk : 40, endurance : 400}),

    ...createFix('青钢之',57,2,{atk : 45, def : 40}),
    ...createFix('黑铁之',57,2,{endurance : 450, def : 40}),
    ...createFix('黄铜之',57,2,{atk : 45, endurance : 450}),

    ...createFix('红木之',60,2,{atk : 50, def : 45}),
    ...createFix('白石之',60,2,{endurance : 500, def : 45}),
    ...createFix('清流之',60,2,{atk : 50, endurance : 500}),

    ...createFix('榆木之',63,2,{atk : 60, def : 52}),
    ...createFix('河山之',63,2,{endurance : 600, def : 52}),
    ...createFix('风岚之',63,2,{atk : 60, endurance : 600}),

    ...createFix('长蛇之',67,2,{atk : 70, def : 60}),
    ...createFix('污泥之',67,2,{endurance : 700, def : 60}),
    ...createFix('渔网之',67,2,{atk : 70, endurance : 700}),

    ...createFix('残灯之',70,2,{atk : 80, def : 70}),
    ...createFix('火印之',70,2,{endurance : 800, def : 70}),
    ...createFix('长袍之',70,2,{atk : 80, endurance : 800}),

    ...createFix('冰火之',73,2,{atk : 90, def : 80}),
    ...createFix('风墙之',73,2,{endurance : 900, def : 80}),
    ...createFix('水泡之',73,2,{atk : 90, endurance : 900}),

    //传说
    ...createFix('无谋的',1,3,{atk : 2, def : 2}),
    ...createFix('稳重的',1,3,{endurance : 20, def : 2}),
    ...createFix('持续的',1,3,{atk : 2, endurance : 20}),

    ...createFix('利刃之',4,3,{atk : 3, def : 3}),
    ...createFix('承受之',4,3,{endurance : 30, def : 3}),
    ...createFix('悍勇的',4,3,{atk : 3, endurance : 30}),

    ...createFix('强大的',7,3,{atk : 4, def : 4}),
    ...createFix('守护的',7,3,{endurance : 40, def : 4}),
    ...createFix('无畏的',7,3,{atk : 4, endurance : 40}),

    ...createFix('勇气之',10,3,{atk : 5, def : 5}),
    ...createFix('冲动的',10,3,{endurance : 50, def : 5}),
    ...createFix('不懈的',10,3,{atk : 5, endurance : 50}),

    ...createFix('努力的',13,3,{atk : 6, def : 6}),
    ...createFix('奋斗的',13,3,{endurance : 60, def : 6}),
    ...createFix('坚持之',13,3,{atk : 6, endurance : 60}),

    ...createFix('红日之',17,3,{atk : 7, def : 7}),
    ...createFix('夕阳之',17,3,{endurance : 70, def : 7}),
    ...createFix('紫霞之',17,3,{atk : 7, endurance : 70}),

    ...createFix('气质的',20,3,{atk : 8, def : 8}),
    ...createFix('高傲的',20,3,{endurance : 80, def : 8}),
    ...createFix('丰满的',20,3,{atk : 8, endurance : 80}),

    ...createFix('不屑的',23,3,{atk : 9, def : 9}),
    ...createFix('孤勇的',23,3,{endurance : 90, def : 9}),
    ...createFix('冲杀的',23,3,{atk : 9, endurance : 90}),

    ...createFix('高山之',27,3,{atk : 12, def : 10}),
    ...createFix('流水之',27,3,{endurance : 120, def : 10}),
    ...createFix('和谐之',27,3,{atk : 12, endurance : 120}),

    ...createFix('高山之',30,3,{atk : 15, def : 12}),
    ...createFix('流水之',30,3,{endurance : 150, def : 12}),
    ...createFix('和谐之',30,3,{atk : 15, endurance : 150}),

    ...createFix('梦境之',33,3,{atk : 18, def : 15}),
    ...createFix('迷宫之',33,3,{endurance : 180, def : 15}),
    ...createFix('城镇之',33,3,{atk : 18, endurance : 180}),

    ...createFix('极速之',37,3,{atk : 21, def : 18}),
    ...createFix('飞驰之',37,3,{endurance : 210, def : 18}),
    ...createFix('平缓之',37,3,{atk : 21, endurance : 210}),

    ...createFix('崎岖之',40,3,{atk : 25, def : 21}),
    ...createFix('落馅之',40,3,{endurance : 250, def : 21}),
    ...createFix('拯救之',40,3,{atk : 25, endurance : 250}),

    ...createFix('困难之',43,3,{atk : 30, def : 24}),
    ...createFix('不平之',43,3,{endurance : 300, def : 24}),
    ...createFix('凸出之',43,3,{atk : 30, endurance : 300}),

    ...createFix('蔷薇之',47,3,{atk : 35, def : 30}),
    ...createFix('荼蘼之',47,3,{endurance : 350, def : 30}),
    ...createFix('袅袅之',47,3,{atk : 35, endurance : 350}),

    ...createFix('奔日之',50,3,{atk : 40, def : 35}),
    ...createFix('追风之',50,3,{endurance : 400, def : 35}),
    ...createFix('批星之',50,3,{atk : 40, endurance : 400}),

    ...createFix('笼罩之',53,3,{atk : 45, def : 40}),
    ...createFix('迷雾之',53,3,{endurance : 450, def : 40}),
    ...createFix('残阳之',53,3,{atk : 45, endurance : 450}),

    ...createFix('和风之',57,3,{atk : 50, def : 45}),
    ...createFix('烈日之',57,3,{endurance : 500, def : 45}),
    ...createFix('气势之',57,3,{atk : 50, endurance : 500}),

    ...createFix('天地之',60,3,{atk : 60, def : 52}),
    ...createFix('江海之',60,3,{endurance : 600, def : 52}),
    ...createFix('无限之',60,3,{atk : 60, endurance : 600}),

    ...createFix('末日之',63,3,{atk : 70, def : 60}),
    ...createFix('启迪之',63,3,{endurance : 700, def : 60}),
    ...createFix('方舟之',63,3,{atk : 70, endurance : 700}),

    ...createFix('巫师之',67,3,{atk : 80, def : 70}),
    ...createFix('奥术之',67,3,{endurance : 800, def : 70}),
    ...createFix('魔纹之',67,3,{atk : 80, endurance : 800}),

    ...createFix('圣光之',70,3,{atk : 90, def : 80}),
    ...createFix('怒气之',70,3,{endurance : 900, def : 80}),
    ...createFix('能量之',70,3,{atk : 90, endurance : 900}),

    ...createFix('无眠之',73,3,{atk : 100, def : 90}),
    ...createFix('神眼之',73,3,{endurance : 1000, def : 90}),
    ...createFix('婆娑之',73,3,{atk : 100, endurance : 1000}),

    //神话
    ...createFix('拉尔的',1,4,{atk : 3, def : 3}),
    ...createFix('基拉的',1,4,{endurance : 30, def : 3}),
    ...createFix('奈尔之',1,4,{atk : 3, endurance : 30}),

    ...createFix('咕噜之',4,4,{atk : 4, def : 4}),
    ...createFix('卡尔之',4,4,{endurance : 40, def : 4}),
    ...createFix('特鲁的',4,4,{atk : 4, endurance : 40}),

    ...createFix('塞拉之',7,4,{atk : 5, def : 5}),
    ...createFix('卡迪的',7,4,{endurance : 50, def : 5}),
    ...createFix('乌瑟之',7,4,{atk : 5, endurance : 50}),

    ...createFix('西斯的',10,4,{atk : 6, def : 6}),
    ...createFix('西恩的',10,4,{endurance : 60, def : 6}),
    ...createFix('鲁特的',10,4,{atk : 6, endurance : 60}),

    ...createFix('艾尔的',13,4,{atk : 7, def : 7}),
    ...createFix('艾斯之',13,4,{endurance : 70, def : 7}),
    ...createFix('艾迪之',13,4,{atk : 7, endurance : 70}),

    ...createFix('佐拉之',17,4,{atk : 8, def : 8}),
    ...createFix('菲拉之',17,4,{endurance : 80, def : 8}),
    ...createFix('奈特之',17,4,{atk : 8, endurance : 80}),

    ...createFix('鲁夫之',20,4,{atk : 9, def : 9}),
    ...createFix('丽芙之',20,4,{endurance : 90, def : 9}),
    ...createFix('艾拉之',20,4,{atk : 9, endurance : 90}),

    ...createFix('拉兹的',23,4,{atk : 12, def : 10}),
    ...createFix('乌兹的',23,4,{endurance : 120, def : 10}),
    ...createFix('塔拉的',23,4,{atk : 12, endurance : 120}),

    ...createFix('埃拉之',27,4,{atk : 15, def : 12}),
    ...createFix('吉卡之',27,4,{endurance : 150, def : 12}),
    ...createFix('哈卡之',27,4,{atk : 15, endurance : 150}),

    ...createFix('吐鲁之',30,4,{atk : 18, def : 15}),
    ...createFix('西蒙之',30,4,{endurance : 180, def : 15}),
    ...createFix('哆啦之',30,4,{atk : 18, endurance : 180}),

    ...createFix('米搜之',33,4,{atk : 21, def : 18}),
    ...createFix('路西之',33,4,{endurance : 150, def : 12}),
    ...createFix('威尔之',33,4,{atk : 15, endurance : 150}),

    ...createFix('麦克之',37,4,{atk : 25, def : 20}),
    ...createFix('维克之',37,4,{endurance : 250, def : 20}),
    ...createFix('阿迪之',37,4,{atk : 25, endurance : 250}),

    ...createFix('塞尔之',40,4,{atk : 30, def : 24}),
    ...createFix('尼特之',40,4,{endurance : 300, def : 24}),
    ...createFix('鲁斯之',40,4,{atk : 30, endurance : 300}),

    ...createFix('拉斯之',43,4,{atk : 35, def : 30}),
    ...createFix('奥多之',43,4,{endurance : 350, def : 30}),
    ...createFix('奥丁之',43,4,{atk : 35, endurance : 350}),

    ...createFix('希尔之',47,4,{atk : 40, def : 35}),
    ...createFix('提拉之',47,4,{endurance : 400, def : 35}),
    ...createFix('特洛之',47,4,{atk : 40, endurance : 400}),

    ...createFix('罗伊之',50,4,{atk : 45, def : 40}),
    ...createFix('迪特之',50,4,{endurance : 450, def : 40}),
    ...createFix('卡拉之',50,4,{atk : 45, endurance : 450}),

    ...createFix('迪尔之',53,4,{atk : 50, def : 45}),
    ...createFix('乌璐之',53,4,{endurance : 500, def : 45}),
    ...createFix('摩卡之',53,4,{atk : 50, endurance : 500}),

    ...createFix('罗摩之',57,4,{atk : 60, def : 52}),
    ...createFix('奥恩之',57,4,{endurance : 600, def : 52}),
    ...createFix('鲁西之',57,4,{atk : 60, endurance : 600}),

    ...createFix('默克之',60,4,{atk : 70, def : 60}),
    ...createFix('菲儿之',60,4,{endurance : 700, def : 60}),
    ...createFix('皮欧之',60,4,{atk : 70, endurance : 700}),

    ...createFix('诺娜之',63,4,{atk : 80, def : 70}),
    ...createFix('卡夫之',63,4,{endurance : 800, def : 70}),
    ...createFix('一库之',63,4,{atk : 80, endurance : 800}),

    ...createFix('琦玉之',67,4,{atk : 90, def : 80}),
    ...createFix('维恩之',67,4,{endurance : 900, def : 80}),
    ...createFix('扎克之',67,4,{atk : 90, endurance : 900}),

    ...createFix('班德之',70,4,{atk : 100, def : 90}),
    ...createFix('御坂之',70,4,{endurance : 1000, def : 90}),
    ...createFix('布特之',70,4,{atk : 100, endurance : 1000}),

    ...createFix('琳娜之',73,4,{atk : 110, def : 100}),
    ...createFix('本森之',73,4,{endurance : 1100, def : 100}),
    ...createFix('奥尔之',73,4,{atk : 110, endurance : 1100}),
};

//随机获取装备品质和词缀
function getEquipQuality(equip, isMonster) {
    //拥有默认品质的装备不需要获得词缀和品质
    if (equip.quality > 0) {
        if(!data.forgeCount[equip.name]){
            data.forgeCount[equip.name] = 0;
        }
        data.forgeCount[equip.name]++;
        return equip;
    }

    const fix = getFix(equip);//随机获得一个词条
    if(fix){
        equip.showName = fix + equip.name;
        Object.keys(prefixs[fix].attrs).forEach(e => {
            equip[e] += prefixs[fix].attrs[e];
        })
        if(equip.maxEndurance < equip.endurance){
            equip.maxEndurance = equip.endurance;
        }
    }

    //随机镶嵌孔数量
    let holeNum = 0;
    const holeRateNum = randomNum(1,1000);
    if (holeRateNum <= holeRate[6]) {
        holeNum = 6;
    }else if (holeRateNum <= holeRate[5]) {
        holeNum = 5;
    }else if (holeRateNum <= holeRate[4]) {
        holeNum = 4;
    }else if (holeRateNum <= holeRate[3]) {
        holeNum = 3;
    }else if (holeRateNum <= holeRate[2]) {
        holeNum = 2;
    }else if (holeRateNum <= holeRate[1]) {
        holeNum = 1;
    }
    equip.hole = new Array(holeNum);

    if(!data.forgeCount[equip.name]){
        data.forgeCount[equip.name] = {};
    }
    if(!data.forgeCount[equip.name][equip.quality]){
        data.forgeCount[equip.name][equip.quality] = 0;

        //神话品质第一次获得时奖励属性点
        if(!isMonster && equip.quality === 4){
            data.attrPoint += 1;
            if(!data.consumePoint){
                data.consumePoint = 0;
            }
            data.consumePoint -= 1;
            winMsg(`你首次锻造出了神话品质的${equip.name}，奖励1点属性点`)
        }
    }
    if(!isMonster){
        data.forgeCount[equip.name][equip.quality] += 1;
    }

    return equip;
}

function getQualityRate(){
    const rates = {};
    [1,2,3,4].forEach(e => {
        const rate = qualityRate[e] + parseInt(data.forgeExp / forgeQualityExp);
        rates[e] = rate <= qualityRateMax[e] ? rate : qualityRateMax[e];
    })

    return rates;
};

//获取词缀
function getFix(equip, fixRate = 1){
    //随机品质
    let num = randomNum(1, 1000);
    let flag = false;
    const rates = getQualityRate();

    //神话品质
    if (num <= rates[4] * fixRate) {
        equip.quality = 4;
        flag = true;
    }else{
        num = randomNum(1, 1000);
    }

    //传说品质
    if (!flag && num <= rates[3] * fixRate) {
        equip.quality = 3;
        flag = true;
    }else{
        num = randomNum(1, 1000);
    }

    //精良品质
    if (!flag && num <= rates[2] * fixRate) {
        equip.quality = 2;
        flag = true;
    }else{
        num = randomNum(1, 1000);
    }

    //优秀品质
    if (!flag && num <= rates[1] * fixRate) {
        equip.quality = 1;
    }

    //获取可用前缀列表
    const prefixList = Object.keys(prefixs).filter(e => {
        return prefixs[e].quality === equip.quality && (equip.level >= prefixs[e].level && prefixs[e].level >= (equip.level - 10))
    })

    const fix = prefixList.getRandom();//随机获得一个词条

    return fix;
}
