//家每级拥有的设施
const homeLevelFacility = {
    0 : ['床','仓库', '镶嵌物仓库'],
    1 : ['工作台','熔炉','厨房','锻造台','炼金室','附魔台','镶嵌台','符文法阵','装备打孔器','溶解室','洗涤室','元素实验室'],
    2 : ['虚空分解机','虚空修复器','次元研究室','次元交易所','亵渎室','纳米机器','次元金融所'],
    3 : ['传送门','时空法阵', '生命祭坛'],
    4 : ['锤炼台','神力窃取室','天赋祭坛'],
    5 : ['最终退路']
}

//制造等级对应的设施
const facility4level = {
    0 : ['空手', '工作台'],
    1 : ['工作台'],
}

//升级要求
const upLevelNeedItems = {
    0 : {'木材' : -13141314, '纤维' : -13141314, '石头' : -13141314},
    1 : {'铁锭' : -13141314,'铜锭' : -13141314,'红水晶' : -13141314,'魔晶石' : -13141314, '哥布林之心' : -13141313},
    2 : {'紫晶' : -13141314,'灵魂晶粉' : -13141314,'紫晶之核' : -13141314,'时空碎片' : -13171341},
    3 : {'赐福神力' : -13141313,'神性结晶' : -13141110},
    4 : {'弑神之证' : -13141311},
};

//设施使用方法
const facilityFunction = {
    '欺诈工作台' : function(){
        renderCheat();
    },
    '次元金融所' : function(){
        renderStock()
        if(!data.stockLog){
            says([`次元金融所是绝对的纯随机，绝对的没有黑幕，我代码是公开的，不信的可以自己去看或者问看得懂代码的大佬。但是长线必亏，因为你想想，100，+10%，再-10%，还剩多少？所以，只适合玩短线拼运气`])
            data.stockLog = true;
            save();
        }
    },
    '节日商店' : function(){
        renderFestivalShop()
    },
    '赞助商店' : function(){
        $('.sponsor-shop').show();
        renderSponsorShop()
    },
    '种族周目商店' : function(){
        renderOrderShop()
    },
    '古神祭坛' : function(){
        renderCthulhuAltar()
    },
    '扭曲熔炉' : function(){
        renderWarpSmelter()
    },
    '床' : function(){
        renderBed();
        $('.bed').show();
    },
    '仓库' : function(){
        if(!data.world.home.store){
            data.world.home.store = [];
            save();
        }
        $('.store-item-search input').val('')
        storeFilter = '';
        isRunesStore = false;
        renderStore();
        $('.store').show();
    },
    '镶嵌物仓库' : function(){
        if(!conf.runesStore){
            conf.runesStore = [];
            save(confSavedName, conf);
        }
        $('.store-item-search input').val('')
        storeFilter = '';
        isRunesStore = true;
        renderStore();
        $('.store').show();
    },
    '工作台' : function(){
        renderWorkList(1);
        showWorkWin()
    },
    '熔炉' : function(){
        renderWorkList(-1, '熔炉');
        showWorkWin()
    },
    '锻造台' : function(){
        renderForgeList();
        $('.forge').show();
    },
    '厨房' : function(){
        renderKitchen();
        $('.kitchen').show();
    },
    '炼金室' : function(){
        renderWorkList(-1, '炼金室');
        showWorkWin()
    },
    '元素实验室' : function(){
        renderElemental();
    },
    '虚空分解机' : function(){
        renderResolveMachine();
        $('.resolve-machine').show();
    },
    '虚空修复器' : function(){
        renderVoidFix();
        $('.void-fix').show();
    },
    '次元研究室' : function(){
        renderWorkList(-1, '次元研究室');
        showWorkWin()
    },
    '次元交易所' : function(){
        isGoblinExchange = false;
        reloadExchange()
        renderExchange();
        $('.exchange').show();
    },
    '亵渎室' : function(){
        renderWorkList(-1, '亵渎室');
        showWorkWin()
    },
    '附魔台' : function(){
        renderEnhancements();
        $('.enhancements').show();
    },
    '传送门' : function(){
        renderPortal()
        $('.portal').show();
    },
    '时空法阵' : function(){
        renderWorkList(-1, '时空法阵');
        showWorkWin()
    },
    '生命祭坛' : function(){
        renderWorkList(-1, '生命祭坛');
        showWorkWin()
    },
    '镶嵌台' : function(){
        renderInlay();
        $('.inlay').show();
    },
    '符文法阵' : function(){
        renderRuneCircle();
        $('.rune-circle').show();
    },
    '装备打孔器' : function(){
        renderAddHole();
        $('.equip-add-hole').show();
    },
    '溶解室' : function(){
        renderDissolutionRoom();
    },
    '洗涤室' : function(){
        renderWashingRoom();
    },
    '锤炼台' : function(){
        renderTemper();
        $('.temper').show();
    },
    '神力窃取室' : function(){
        renderWorkList(-1, '神力窃取室');
        showWorkWin()
    },
    '天赋祭坛' : function(){
        renderWorkList(-1, '天赋祭坛');
        showWorkWin()
    },
    '纳米机器' : function(){
        renderWorkList(-1, '纳米机器');
        showWorkWin()
    },
    '最终退路' : function(){
        renderWorkList(-1, '最终退路');
        showWorkWin()
    },
}

//渲染欺诈工作室
function renderCheat(){
    $('.cheat').show();
    $('.cheat-equips').html('');
    $('.cheat-equip-info').attr('data-id','').html('');
    $('#equip-name').val('');
    $('.change-equip-name').html(`改名(${getNumByBag('欺诈宝石',true)})`);
    data.bag.forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && !e.name.startsWith('技能石：')){
            $('.cheat-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
}
//选中装备时
$('.cheat-equips').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)
    $('#equip-name').val(item.showName || item.name);

    //渲染窗口文本
    $('.cheat-equip-info').attr('data-id',id).html(text);
});
//改名
$('.change-equip-name').click(function(){
    //获取物品
    const id = $('.cheat-equip-info').attr('data-id');
    if(id && getNumByBag('欺诈宝石',true)){
        const item = getBagItemById(id);
        let name = $('#equip-name').val();
        if(name.length > 5){
            winMsg('名字不能超过5个字')
            return;
        }
        if(item){
            //判断是否符文之语
            if(item.showName){
                const str = Object.keys(runeWord).filter(i => item.showName.endsWith(runeWord[i].name));
                if(str.length > 0){
                    name = name.replace(`${str[0]}：`, '');
                    name += `：${runeWord[str[0]].name}`;
                }
            }

            if(!confirm(`是否确认将这件装备的名字改为[${name}]？`)){
                return;
            }

            reduceItemByAll('欺诈宝石');
            item.showName = name;
            save();
            renderCheat();
        }
    }

});

//渲染厨房
function renderKitchen(){
    let flag = true;
    if(data.world.home.kitchenFire && getPassMin(new Date(data.world.home.kitchenFire), data.date) < 60){
        $('.kitchen-status').html(`已燃烧，剩余${60 - getPassMin(new Date(data.world.home.kitchenFire), data.date)}分钟`);
        $('.kitchen-menus button').hide();
    }else{
        flag = false;
        $('.kitchen-status').html('未燃烧');
        $('.kitchen-menus button').show();
    }

    const level = -1;
    const need = '厨房';
    $('.select-num-input').val(val);
    $('.kitchen .win-body').html('');
    //可用的配方
    const canRecipes = {};

    //循环所有配方
    Object.keys(recipes).forEach(key => {
        //如果满足设施要求，则直接加入可用列表，无视级别要求
        if(recipes[key].need && recipes[key].need === need){
            canRecipes[key] = recipes[key];
        }else if(level >= recipes[key].level){//如果配方的制造级别小于等于本次展开页面的等级，则加入可用列表
            canRecipes[key] = recipes[key];
        }
    })

    //循环所有可用配方
    Object.keys(canRecipes).forEach(key => {
        const items = canRecipes[key].items;
        let canMake = true;
        let canMakeTen = true;

        let html = '';
        html += `<div class="recipe">`;
        const strs = key.split('-');
        html += `<div class="recipe-name">${key}<span class="to-cybernet" data-name="${isNaN(strs[1]) ? key : strs[0]}">🔍</span>*${canRecipes[key].getNum}</div>`;
        html += `<div class="recipe-items">`;

        //循环所有所需物品
        const num = parseInt($('.select-num-input').val())
        Object.keys(items).forEach(item => {
            //获取持有物品，当在家所在的地块时，允许使用仓库的物品
            const itemNum = getNumByBag(item, data.location.join() === data.world.home.location.join());
            const needNum = items[item];
            if(itemNum < needNum){
                canMake = false;
                canMakeTen = false
            }else if(itemNum < needNum * num){
                canMakeTen = false;
            }

            html += `<div class="recipe-item ${itemNum >= needNum ? 'recipe-item-have' : 'recipe-item-no'}">${item}：${itemNum}/${needNum}</div>`;
        })
        if(!flag){
            canMake = false;
            canMakeTen = false;
        }
        html += `</div>`;
        html += `<div class="make ${canMake ? 'can-make' : ''}" data-name="${key}" data-level="${level}" data-need="${need}" data-num="1">制造</div>`;
        html += `<div class="make make-ten ${canMakeTen ? 'can-make' : ''}" data-name="${key}" data-level="${level}" data-need="${need}" data-num="${num}">批量</div>`;
        html += `</div>`;
        $('.kitchen .win-body').append(html);
    })

}
//点击点火
$('.kitchen-menus button').click(function(){
    const num1 = getNumByBag('燧石', true)
    const num2 = getNumByBag('树枝', true)
    const num3 = getNumByBag('木材', true)
    if(num1 < 1){
        winMsg('燧石不足', false, false);
        return;
    }
    if(num2 < 3){
        winMsg('树枝不足', false, false);
        return;
    }
    if(num3 < 1){
        winMsg('木材不足', false, false);
        return;
    }

    reduceItemByAll('燧石', 1)
    reduceItemByAll('树枝', 3)
    reduceItemByAll('木材', 1)
    data.world.home.kitchenFire = data.date.format('yyyy-MM-dd hh:mm:ss')
    renderKitchen();
    save();
})

//渲染溶解室
function renderDissolutionRoom(){
    $('.dissolution-btn').html(`溶解药水(${getNumByBag('溶解药水', true)})`);
    $('.dissolution-room .dissolution-room-circle-equips').html('');
    $('.dissolution-room .dissolution-room-equip-info').attr('data-id','').html('');

    //渲染装备列表
    data.bag.forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && !e.name.startsWith('技能石')){
            $('.dissolution-room .dissolution-room-circle-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })

    $('.dissolution-room').show();
}
//溶解室选中装备时
$('.dissolution-room .dissolution-room-circle-equips').on('click','.bag-item',function(){
    renderDissolutionEqInfo($(this).attr('id'));
});
function renderDissolutionEqInfo(id){
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    $('.dissolution-room .dissolution-room-equip-info').attr('data-id',id).html(text);
}
//确认溶解装备
$('.dissolution-btn').click(function(){
    const equipId = $('.dissolution-room .dissolution-room-equip-info').attr('data-id');
    const eq = getBagItemById(equipId)
    if(eq){
        const num = getNumByBag('溶解药水', true);
        const need = 1;

        if(num >= need){
            if(!confirm('是否确认溶解该装备？溶解后你装备将被销毁')){
                return false;
            }
            //获取背包中的数量
            //优先使用背包中的物品
            if(getNumByBag('溶解药水') >= need){
                reduceItem('溶解药水', need);
            }else{
                reduceItemByStore('溶解药水', need);
            }

            if(data.weapon && data.weapon.id === eq.id){
                equip(data.weapon);
            }
            if(data.armor && data.armor.id === eq.id){
                equip(data.armor);
            }
            eq.hole.forEach(e => {
                if(e){
                    addItem(e);
                }
            });
            reduceItemById(eq.id)
            winMsg(`你溶解了${eq.showName || eq.name}，回收了所有镶嵌物`)
            renderDissolutionRoom();

            save();
        }else{
            winMsg('溶解药水不足', false, false)
        }
    }
})

//渲染洗涤室
function renderWashingRoom(){
    $('.washing-btn').html(`洗涤灵泉(${getNumByBag('洗涤灵泉', true)})`);
    $('.washing-room .washing-room-circle-equips').html('');
    $('.washing-room .washing-room-equip-info').attr('data-id','').html('');

    //渲染装备列表
    data.bag.filter(e => !e.washing).forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && !e.name.startsWith('技能石') && e.level <= data.level){
            $('.washing-room .washing-room-circle-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })

    $('.washing-room').show();
}
//洗涤室选中装备时
$('.washing-room .washing-room-circle-equips').on('click','.bag-item',function(){
    renderWashingEqInfo($(this).attr('id'));
});
function renderWashingEqInfo(id){
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    $('.washing-room .washing-room-equip-info').attr('data-id',id).html(text);
}
//确认溶解装备
$('.washing-btn').click(function(){
    const equipId = $('.washing-room .washing-room-equip-info').attr('data-id');
    const eq = getBagItemById(equipId)
    if(eq){
        const num = getNumByBag('洗涤灵泉', true);
        const need = 1;

        if(num >= need){
            if(!confirm('是否确认洗涤该装备？')){
                return false;
            }
            //获取背包中的数量
            //优先使用背包中的物品
            if(getNumByBag('洗涤灵泉') >= need){
                reduceItem('洗涤灵泉', need);
            }else{
                reduceItemByStore('洗涤灵泉', need);
            }

            if(data.weapon && data.weapon.id === eq.id){
                data.weapon.level = 1;
            }
            if(data.armor && data.armor.id === eq.id){
                data.armor.level = 1;
            }
            eq.level = 1;
            eq.washing = true;
            winMsg(`你洗涤了${eq.showName || eq.name}`)
            renderWashingRoom();

            save();
        }else{
            winMsg('洗涤灵泉不足', false, false)
        }
    }
})

//渲染床
function renderBed(){
    const arr = [1,2,3,5,8,24];
    $('.bed .win-body').html(arr.map(e => {
        const need = 60 / statusMin * e;
        let {hunger : needHunger, water : needWater} = getNeedWaterAndHungerByMin(e * 60);

        if(data.race.getNoHunger()){
            return `<div class="sleep-time" data-hour="${e}">休息${e}小时<br>${data.race.name.startsWith('星灵') ? '' : `<font color="${needHunger + needWater >= data.hp ? 'red' : 'green'}">-${needHunger + needWater}/${data.hp}HP</font>`}</div>`
        }

        return `<div class="sleep-time" data-hour="${e}">休息${e}小时<br><font color="${needHunger > data.hunger ? 'red' : 'green'}">-${needHunger}/${data.hunger}饥饿</font><font color="${needWater > data.water ? 'red' : 'green'}">-${needWater}/${data.water}水分</font><font>+${need * sleepAddHp}HP</font></div>`;
    }).join(''));
}

//在床上休息
$('.bed').on('click','.sleep-time',function(){
    if($(this).find('font[color=red]').length > 0){
        if(data.race.getNoHunger()){
            winMsg('你的血量不足，休息这么久将导致死亡', false, false)
            return;
        }
        if(confirm('你的饥饿或水分不足，本次休息可能会导致扣血，是否要休息？')){
            timeLapses(parseInt($(this).attr('data-hour')) * 60, true);
            $('.bed').hide();
        }
    }else{
        timeLapses(parseInt($(this).attr('data-hour')) * 60, true);
        $('.bed').hide();
    }
});

//切换转移数量
let storeMoveNum = "1";
$('.store-menu').click(function () {
    storeMoveNum = $(this).attr('data-num');
    $('.store-menu-active').removeClass('store-menu-active');
    $(this).addClass('store-menu-active');
});

//切换仓库显示类型
let storeShowType = null;

$('.store-item-menu').click(function(){
    const type = $(this).html();
    $('.store-item-menu').removeClass('active');
    if(storeShowType === type){
        storeShowType = null;
    }else{
        storeShowType = type;
        $(this).addClass('active');
    }
    renderStore();
});

//背包转移到仓库
$('.bag-item-list .item-list-body').on('click','.store-item',function(){
    if(itemMove(1, $(this).attr('data-id'))){
        renderStore();
        renderBag();
        isRunesStore && save(confSavedName, conf);
    }
});

//仓库转移到背包
$('.store-item-list .item-list-body').on('click','.store-item',function(){
    if(itemMove(2, $(this).attr('data-id'))){
        renderStore();
        renderBag();
        isRunesStore && save(confSavedName, conf);
    }
});

//全部存入
$('.all-in').click(function(){
    const runesNames = runes.map(e => e.name);

    data.bag.filter(e => {
        if(isRunesStore){
            return !e.isLock && e.isInlay && !e.washing && e.name.indexOf('(赠)') === -1;
        }
        if(data.armor && data.armor.id === e.id){
            return false;
        }
        if(data.bagEquip && data.bagEquip.id === e.id){
            return false;
        }
        if(data.weapon && data.weapon.id === e.id){
            return false;
        }
        if(data.mount && data.mount.id === e.id){
            return false;
        }
        if(e.isLock ){
            return false;
        }
        return true;
    }).forEach(e => {
        itemMove(1, e.id, true);
    })
    renderStore();
    renderBag();
    isRunesStore && save(confSavedName, conf);
});

//全部取出
$('.all-out').click(function(){
    (isRunesStore ? conf.runesStore : data.world.home.store).forEach(e => {
        itemMove(2, e.id, true);
    })
    renderStore();
    renderBag();
    isRunesStore && save(confSavedName, conf);
});

//整理仓库
$('.store-sort').click(function(){
    const keys = Object.keys(elementCfgs);
    (isRunesStore ? conf.runesStore : data.world.home.store).sort(function(a,b){
        return keys.indexOf(a.name) - keys.indexOf(b.name);
    });
    save();
    renderStore();
    renderBag();
    isRunesStore && save(confSavedName, conf);
});

//物品转移方法
function itemMove(type,itemId, all = false){
    let from = null;
    let to = null;
    if(type === 1){
        from = data.bag;
        to = data.world.home.store;
        if(isRunesStore){
            to = conf.runesStore;
        }
    }else{
        to = data.bag;
        from = data.world.home.store;
        if(isRunesStore){
            from = conf.runesStore;
        }
    }

    //从指定容器删除物品
    function removeFrom(id){
        if(type === 1){
            data.bag = data.bag.filter(e => e.id !== id);
        }else{
            if(isRunesStore){
                conf.runesStore = conf.runesStore.filter(e => e.id !== id);
            }else{
                data.world.home.store = data.world.home.store.filter(e => e.id !== id);
            }
        }
    }

    //获取要取出的物品
    const item = from.filter(e => e.id === itemId)[0];

    //计算将产生的负重
    let weight = 0;
    if((storeMoveNum === 'all') || all){
        weight = item.weight * item.quantity;
    }else{
        let moveNum = parseInt(storeMoveNum);
        //保证转移数量不超过持有数量
        if(moveNum > item.quantity){
            moveNum = item.quantity;
        }
        weight = item.weight * moveNum;
    }

    //如果是不可叠加的物品，直接转移到目标容器里
    if(item.onlyOne){
        to.push(item);
        removeFrom(itemId);
    }else{
        //获取目标容器的同名物品
        const toItems = to.filter(e => e.name === item.name);
        //如果有同名物品，则叠加数量
        if(toItems.length > 0){
            //转移全部
            if((storeMoveNum === 'all') || all){
                toItems[0].quantity += item.quantity;
                removeFrom(itemId);
            }else{//转移指定数量
                let moveNum = parseInt(storeMoveNum);
                //保证转移数量不超过持有数量
                if(moveNum > item.quantity){
                    moveNum = item.quantity;
                }
                //用于判断是否完全转移
                const needDel = moveNum === item.quantity;

                //转移物品
                toItems[0].quantity += moveNum;

                //减少或删除来源处的物品数量
                if(needDel){
                    removeFrom(itemId);
                }else{
                    item.quantity -= moveNum;
                }
            }

        }else{//没有同名物品，则直接转移
            //转移全部
            if((storeMoveNum === 'all') || all){
                to.push(item);
                removeFrom(itemId);
            }else {//转移指定数量
                let moveNum = parseInt(storeMoveNum);
                //保证转移数量不超过持有数量
                if(moveNum > item.quantity){
                    moveNum = item.quantity;
                }
                //用于判断是否完全转移
                const needDel = moveNum === item.quantity;

                if(needDel){//完全转移
                    to.push(item);
                    removeFrom(itemId);
                }else{//非完全转移
                    const newItem = new Element(item);
                    newItem.quantity = moveNum;
                    to.push(newItem);
                    item.quantity -= moveNum;
                }
            }
        }
    }

    //负重变化
    if(type === 1){
        data.weight -= weight;
    }else{
        data.weight += weight;
    }

    //存档
    save();
    return true;
}

//点击升级家
$('.home-level-up-btn').click(function(){
    let canUp = true;
    $('.home-level-up-need-item').remove();

    //循环所有所需物品
    const needItems = upLevelNeedItems[data.world.home.level];
    let html = '';
    Object.keys(needItems).forEach(item => {
        const itemNum = getNumByBag(item, true);
        const needNum = needItems[item];
        if(itemNum < needNum){
            canUp = false;
        }

        html += `<div class="home-level-up-need-item ${itemNum >= needNum ? 'have' : 'no-have'}">${item}：${itemNum}/${needNum}</div>`;
    })

    //判断是否可升级
    if(canUp){
        $('.home-level-up button').show()
    }else{
        $('.home-level-up button').hide()
    }

    $('.home-level-up center').before(html);
    $('.home-level-up').show();
});

//点击升级按钮
$('.home-level-up button').click(function () {
    //减少物品
    const needItems = upLevelNeedItems[data.world.home.level];
    Object.keys(needItems).forEach(name => {
        //获取背包中的数量
        const bagNum = getNumByBag(name);
        //优先使用背包中的物品
        if(bagNum >= needItems[name]){
            reduceItem(name, needItems[name]);
        }else{
            if(bagNum > 0){
                reduceItem(name, bagNum);
            }
            reduceItemByStore(name, needItems[name] - bagNum);
        }
    })
    $('.home-level-up').hide();

    msg('家升级了！');

    data.world.home.level++;
    data.world.home.facilitys = [
        ...data.world.home.facilitys,
        ...(homeLevelFacility[data.world.home.level].map( e => ({
            level : 1,
            name : e
        })))
    ],
    renderHome();
    save();
});

//虚空分解机分解物品
$('.resolve-machine').on('click','.resolve-item-btn',function(){
    //获取物品ID
    const id = $(this).attr('data-id');
    //获取物品名
    const name = $(this).attr('data-name');
    //获取分解数量
    let num = parseInt($(this).attr('data-num'));
    //获取背包中的物品数量
    const bagNum = getNumById(id);
    //保证分解数量不超过背包数量
    if(num > bagNum){
        num = bagNum;
    }

    //获取虚空粉尘
    const getNum = getBagItemById(id).voidDust * num;
    addItem('虚空粉尘', getNum);
    //减少物品
    reduceItemById(id,num);
    winMsg(`分解[${name}]*${num}，获得[虚空粉尘]*${getNum}`)
    renderResolveMachine();
    save();
});

//装备保养
$('.void-fix').on('click','.maintain-btn',function(){
    if(!getNumByBag('装备保养油', true)){
        winMsg(`装备保养油不足`, false, false);
        return;
    }

    //获取物品ID
    const id = $(this).attr('data-id');
    const item = getBagItemById(id);

    item.fixNeedDust = elementCfgs[item.name].fixNeedDust;

    winMsg(`你的装备[${item.showName || item.name}]已保养完成`);
    reduceItem('装备保养油')
    renderVoidFix();
    save();

})

//修复耐久
$('.void-fix').on('click','.repair-btn',function(){
    //获取物品ID
    const id = $(this).attr('data-id');
    //获取物品名
    const name = $(this).attr('data-name');
    //获取需要的粉尘数量
    const num = parseInt($(this).attr('data-num'));

    //判断粉尘是否足够
    if(getNumByBag('虚空粉尘', true) < num){
        winMsg(`虚空粉尘数量不足`);
        return;
    }

    //恢复耐久
    const item = data.bag.filter(e => e.id === id)[0];
    const addNum = (item.maxEndurance || elementCfgs[item.name].maxEndurance) - item.endurance;
    item.endurance = (item.maxEndurance || elementCfgs[item.name].maxEndurance);

    //下次需要的粉尘翻倍
    item.fixNeedDust *= 2;

    //消耗粉尘
    //获取背包中的数量
    const bagNum = getNumByBag('虚空粉尘');
    //优先使用背包中的物品
    if(bagNum >= num){
        reduceItem('虚空粉尘', num);
    }else{
        if(bagNum > 0){
            reduceItem('虚空粉尘', bagNum);
        }
        reduceItemByStore('虚空粉尘', num - bagNum);
    }

    if(!data.maxUseVoidDust){
        data.maxUseVoidDust = 0;
    }
    if(num > data.maxUseVoidDust){
        data.maxUseVoidDust = num;
    }
    winMsg(`你消耗${num}个粉尘，修复了[${name}]${addNum}点耐久度`);
    renderVoidFix();
    save();
});

//渲染传送门
function renderPortal(){
    $('.portal .win-body').html('');
    data.worlds.forEach((world, index) => {
        if(data.worldIndex !== index && world.home && world.home.location && world.home.location.length === 2){
            $('.portal .win-body').append(`<div class="portal-point portal-to-home" data-world-index="${index}">传送：${world.name}的${world.home.level}级家(时空粉尘：1/${getNumByBag('时空粉尘',true)})</div>`)
        }
    })
    data.dungeon.forEach((e) => {
        $('.portal .win-body').append(`<div class="portal-point portal-to-dungeon" data-dungeon="${e}">传送：${e}(时空碎片：1/${getNumByBag('时空碎片',true)})</div>`)
    })
}

//传送回家
$('.portal .win-body').on('click', '.portal-to-home', function(){
    const num = getNumByBag('时空粉尘',true);
    if(!data.race.name.startsWith('星灵-空间行者') && !data.race.name.startsWith('星灵-宇') && num <= 0){
        winMsg('时空粉尘不足', false, false)
        return;
    }

    //减少时空粉尘
    if(!data.race.name.startsWith('星灵-空间行者') && !data.race.name.startsWith('星灵-宇')){
        reduceItemByAll('时空粉尘', 1);
    }

    const index = parseInt($(this).attr('data-world-index'));
    toWorld(index);
    data.location = data.world.home.location;
    //渲染地图元素
    renderMapElements();
    //渲染可前往的地图
    renderCanToMap();
    //渲染地图
    renderMap();
    $('.portal').hide();
    $('.home').hide();
    save();
});

//传送去副本
$('.portal .win-body').on('click', '.portal-to-dungeon', function(){
    const num = getNumByBag('时空碎片',true);
    if(!data.race.name.startsWith('星灵-空间行者') && !data.race.name.startsWith('星灵-宇') && num <= 0){
        winMsg('时空碎片不足', false, false)
        return;
    }

    if(data.weight > data.maxWeight){
        winMsg(`你超重了，无法传送`)
        return;
    }

    //减少时空碎片
    if(!data.race.name.startsWith('星灵-空间行者') && !data.race.name.startsWith('星灵-宇')){
        reduceItemByAll('时空碎片', 1);
    }

    const name = $(this).attr('data-dungeon');
    toDungeon(name);

    $('.portal').hide();
    $('.home').hide();
    save();
});

//渲染锤炼台
function renderTemper(){
    $('.temper-btn').html(`确认锤炼(${getNumByBag('神圣重锤', true)})`);
    $('.temper .equip-add-hole-circle-equips').html('');
    $('.temper .equip-add-hole-equip-info').attr('data-id','').html('');

    //渲染装备列表
    data.bag.forEach(e => {
        if((elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) && !e.name.startsWith('技能石')){
            $('.temper .equip-add-hole-circle-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
}

//锤炼台选中装备时
$('.temper .equip-add-hole-circle-equips').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    $('.temper .equip-add-hole-equip-info').attr('data-id',id).html(text);
});

//确认锤炼
$('.temper-btn').click(function(){
    const equipId = $('.temper .equip-add-hole-equip-info').attr('data-id');
    const eq = getBagItemById(equipId)
    if(eq){
        if(!eq.temperNum){
            eq.temperNum = 0;
        }

        const num = getNumByBag('神圣重锤', true);
        const need = Math.pow(2,eq.temperNum);

        if(num >= need){
            reduceItemByAll('神圣重锤', need);

            //如果是已穿上的装备，则先卸下来
            let equiped = false;
            if((data.weapon && data.weapon.id === equipId) || (data.armor && data.armor.id === equipId)){
                equiped = true;
                equip(eq);
            }

            //先解除原本的锤炼属性
            if(eq.temperAttr){
                for(const key in eq.temperAttr){
                    eq[key] -= eq.temperAttr[key];
                }
            }

            const fix = getFix(eq, 10);//随机获得一个词条
            if(fix){
                //记录当前词缀属性
                eq.temperAttr = prefixs[fix].attrs;
                eq.temperFixName = fix;

                Object.keys(prefixs[fix].attrs).forEach(e => {
                    eq[e] += prefixs[fix].attrs[e];
                })
                if(eq.maxEndurance < eq.endurance){
                    eq.maxEndurance = eq.endurance;
                }
            }

            //重新穿上
            if(equiped){
                equip(eq);
            }

            if(!data.race.name.startsWith('星灵-时间旅者') && !data.race.name.startsWith('星灵-宙')){
                eq.temperNum++;
            }

            winMsg(`锤炼完成，当前品质：${qualityAttr[eq.quality].name}`);
            save();
            renderTemper();
        }else{
            winMsg(`神圣重锤不足，需要${need}个神圣重锤`, false, false)
        }
    }
})
