//地图配置
const mapCfgs = [
    {
    name : '孤岛',//世界名称
    level : [1,10],//世界等级
    worldBoss : '哥布林英雄',//即守关BOSS
    mythMonster : ['神性史莱姆','扭曲邪物'],//神话怪
    finalBoss : '巨神飞鱼',//世界BOSS
},{
    name : '地底',
    level : [11,20],
    worldBoss : '地穴领主',
    mythMonster : ['远古残魂','扭曲的憎恨'],
    finalBoss : '火元素领主',
},{
    name : '半岛',
    level : [21,30],
    worldBoss : '兽人酋长',
    mythMonster : ['魔晶巨人','扭曲晶魂'],
    finalBoss : '利维坦幼体',
},{
    name : '大陆',
    level : [31,40],
    worldBoss : '死亡骑士',
    mythMonster : ['荒芜亚龙','绿龙幼崽','无名肉山'],
    finalBoss : '比蒙巨兽',
},{
    name : '死地',
    level : [41,50],
    worldBoss : '大剑士',
    mythMonster : ['青年黑龙','诅咒凶魂','死离人形'],
    finalBoss : '龙巫妖',
},{
    name : '战场',
    level : [51,60],
    worldBoss : '神眷圣骑士',
    mythMonster : ['幽灵龙','腐烂吸血鬼'],
    finalBoss : '六翼天使',
},{
    name : '帝国',
    level : [61,70],
    worldBoss : '沙暴地龙',
    mythMonster : ['使徒行者','深渊领主'],
    finalBoss : '神降祭祀',
},{
    name : '龙谷',
    level : [71,80],
    worldBoss : '五首龙神',
    mythMonster : [],
    finalBoss : '龙族吞噬者',
},{
    name : '神界',
    level : [81,90],
    worldBoss : '生命之神',
    mythMonster : ['五首龙神'],
    finalBoss : '远古死神',
    endTerrain : '神座',
    endBoss : '生命之神',
}];

//mapCfgs已经废弃，这是新的多地图随机机制的地图配置
const mapConfig = {
    0 : [{
        name : '孤岛',//世界名称
        level : [1,10],//世界等级
        worldBoss : '哥布林英雄',//即守关BOSS
        mythMonster : ['神性史莱姆','扭曲邪物'],//神话怪
        finalBoss : '巨神飞鱼',//世界BOSS
    },...newMapElements.maps[0]],
    1 : [{
        name : '地底',
        level : [11,20],
        worldBoss : '地穴领主',
        mythMonster : ['远古残魂','扭曲的憎恨'],
        finalBoss : '火元素领主',
    },{
        name : '海脊',
        level : [11,20],
        worldBoss : '独角海象',
        mythMonster : ['鱼人祭司','血肉幽灵船'],
        finalBoss : '水元素领主',
    },...newMapElements.maps[1]],
    2 : [{
        name : '半岛',
        level : [21,30],
        worldBoss : '兽人酋长',
        mythMonster : ['魔晶巨人','扭曲晶魂'],
        finalBoss : '利维坦幼体',
    },...newMapElements.maps[2]],
    3 : [{
        name : '大陆',
        level : [31,40],
        worldBoss : '死亡骑士',
        mythMonster : ['荒芜亚龙','绿龙幼崽','无名肉山'],
        finalBoss : '比蒙巨兽',
    },...newMapElements.maps[3]],
    4 : [{
        name : '死地',
        level : [41,50],
        worldBoss : '大剑士',
        mythMonster : ['青年黑龙','诅咒凶魂','死离人形'],
        finalBoss : '龙巫妖',
    },...newMapElements.maps[4]],
    5 : [{
        name : '战场',
        level : [51,60],
        worldBoss : '神眷圣骑士',
        mythMonster : ['幽灵龙','腐烂吸血鬼'],
        finalBoss : '六翼天使',
    },...newMapElements.maps[5]],
    6 : [{
        name : '帝国',
        level : [61,70],
        worldBoss : '沙暴地龙',
        mythMonster : ['使徒行者','深渊领主'],
        finalBoss : '神降祭祀',
    },...newMapElements.maps[6]],
    7 : [{
        name : '龙谷',
        level : [71,80],
        worldBoss : '五首龙神',
        mythMonster : [],
        finalBoss : '龙族吞噬者',
    },...newMapElements.maps[7]],
    8 : [{
        name : '神界',
        level : [81,90],
        worldBoss : '生命之神',
        mythMonster : ['五首龙神'],
        finalBoss : '远古死神',
        endTerrain : '神座',
        endBoss : '生命之神',
    },...newMapElements.maps[8]],
};
//所有地图的集合
let allMapList = [];
Object.keys(mapConfig).forEach(e => {
    allMapList = [
        ...allMapList,
        ...mapConfig[e]
    ];
})

//地形列表
const terrainArray = {
    '孤岛' : ['草原','丘陵','森林','戈壁','沙漠','绿洲','河滩','峡谷','湖泊','山脉','洞穴','沼泽','海滩'],
    '地底' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],
    '海脊' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],
    '半岛' : ['草原','丘陵','森林','河滩','山脉','洞穴','海滩','部落','废墟','晶林'],
    '大陆' : ['草原','丘陵','森林','戈壁','河滩','峡谷','湖泊','山脉','洞穴','沼泽','氏族','盆地','兽穴'],
    '死地' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '战场' : ['草原','丘陵','河滩','沼泽','坑洞','营地'],
    '帝国' : ['草原','丘陵','森林','河滩','湖泊','山脉','村庄','城镇'],
    '龙谷' : ['森林','河滩','峡谷','湖泊','山脉','洞穴','沼泽'],
    '神界' : ['草原','丘陵','森林','河滩','山脉'],
    ...newMapElements.terrainArray,
};
//地形可以和哪些其他地形相邻
const terrainJoinTerrain = {
    '草原' : ['草原','丘陵','森林','戈壁','河滩','湖泊','山脉','洞穴','海滩','部落','废墟','晶林','氏族','坑洞','营地','村庄','城镇'],
    '丘陵' : ['草原','丘陵','森林','戈壁','河滩','峡谷','湖泊','山脉','洞穴','海滩','部落','废墟','晶林','氏族','坑洞','营地','村庄','城镇'],
    '森林' : ['草原','丘陵','森林','河滩','湖泊','山脉','沼泽','部落','废墟','晶林','氏族','兽穴','村庄','城镇'],
    '戈壁' : ['草原','丘陵','戈壁','沙漠','河滩','峡谷','山脉','氏族'],
    '沙漠' : ['戈壁','沙漠','绿洲','峡谷','山脉','海滩'],
    '绿洲' : ['沙漠','绿洲'],
    '河滩' : ['草原','丘陵','森林','戈壁','河滩','峡谷','湖泊','山脉','洞穴','沼泽','海滩','部落','废墟','晶林','氏族','坑洞','营地','村庄','城镇'],
    '峡谷' : ['丘陵','戈壁','沙漠','河滩','峡谷','山脉','洞穴','海滩','氏族','盆地','兽穴'],
    '湖泊' : ['草原','丘陵','森林','河滩','湖泊','山脉','沼泽','氏族','村庄','城镇'],
    '山脉' : ['草原','丘陵','森林','戈壁','沙漠','河滩','峡谷','湖泊','山脉','洞穴','海滩','部落','废墟','晶林','氏族','盆地','兽穴','村庄','城镇'],
    '洞穴' : ['草原','丘陵','森林','戈壁','峡谷','山脉','洞穴','部落','废墟','晶林','氏族','兽穴'],
    '沼泽' : ['森林','河滩','湖泊','沼泽','海滩','氏族','兽穴','坑洞','营地'],
    '海滩' : ['草原','丘陵','河滩','峡谷','山脉','海滩','部落','废墟','晶林','浅底','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],

    '溶洞' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],
    '矿坑' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],
    '暗河' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],
    '熔岩' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],
    '苔洞' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],
    '通道' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],
    '遗迹' : ['溶洞','矿坑','暗河','熔岩','苔洞','通道','遗迹'],

    '浅底' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],
    '珊瑚' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],
    '礁石' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],
    '旋涡' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],
    '深水' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],
    '矿壁' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],
    '滩涂' : ['浅底','海滩','珊瑚','礁石','旋涡','深水','矿壁','滩涂'],

    '部落' : ['草原','丘陵','森林','河滩','山脉','洞穴','海滩','部落','废墟','晶林'],
    '废墟' : ['草原','丘陵','森林','河滩','山脉','洞穴','海滩','部落','废墟','晶林'],
    '晶林' : ['草原','丘陵','森林','河滩','山脉','洞穴','海滩','部落','废墟','晶林'],

    '氏族' : ['草原','丘陵','森林','戈壁','河滩','峡谷','湖泊','山脉','洞穴','沼泽'],
    '盆地' : ['峡谷','山脉','盆地'],
    '兽穴' : ['森林','峡谷','山脉','洞穴','沼泽'],

    '焦土' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '墓园' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '坟场' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '肉林' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '残骸' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '血池' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '鬼堡' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],
    '骨山' : ['焦土','墓园','坟场','肉林','残骸','血池','鬼堡','骨山'],

    '营地' : ['草原','丘陵','河滩','沼泽'],
    '坑洞' : ['草原','丘陵','河滩','沼泽','坑洞'],

    '村庄' : ['草原','丘陵','森林','河滩','湖泊','山脉','村庄','城镇'],
    '城镇' : ['草原','丘陵','森林','河滩','湖泊','山脉','村庄'],

    ...newMapElements.terrainJoinTerrain,
};
//追加新地图地形关联性
Object.keys(newMapElements.terrainJoinTerrainAppend).forEach(e => {
    terrainJoinTerrain[e] = [...terrainJoinTerrain[e], ...newMapElements.terrainJoinTerrainAppend[e]]
})

//每个地形对应的颜色
const terrainColor = {
    '神殿' : '#a90000',

    '草原' : 'green',
    '丘陵' : '#6b6c6b',
    '森林' : '#003980',
    '戈壁' : '#9e9e9e',
    '沙漠' : '#ffb101',
    '绿洲' : '#0cff0c',
    '河滩' : '#89ccdb',
    '峡谷' : '#b3806d',
    '湖泊' : '#2196f3',
    '山脉' : '#cb6904',
    '洞穴' : '#a90000',
    '沼泽' : '#795548',
    '海滩' : '#0037ff',

    '溶洞' : '#a90000',
    '矿坑' : '#9e9e9e',
    '暗河' : '#89ccdb',
    '熔岩' : 'red',
    '苔洞' : '#0cff0c',
    '通道' : '#cb6904',
    '遗迹' : '#795548',

    '浅底' : '#b3806d',
    '珊瑚' : '#9c27b0',
    '礁石' : '#a90000',
    '旋涡' : '#2196f3',
    '深水' : '#0007d4',
    '矿壁' : '#29ffe9',
    '滩涂' : '#9e9e9e',

    '部落' : '#009688',
    '废墟' : '#795548',
    '晶林' : '#9c27b0',

    '氏族' : '#009688',
    '盆地' : '#ffb101',
    '兽穴' : '#9c27b0',

    '焦土' : '#a90000',
    '墓园' : '#009688',
    '坟场' : '#795548',
    '肉林' : '#9c27b0',
    '残骸' : '#795548',
    '血池' : 'red',
    '鬼堡' : '#0037ff',
    '骨山' : '#9e9e9e',

    '营地' : '#009688',
    '坑洞' : '#cb6904',

    '村庄' : '#009688',
    '城镇' : '#795548',

    ...newMapElements.terrainColor,
};

//只能存在与最外层的地形
const outerTerrains = ['海滩','海崖'];

//横向地图数量
const xnum = 20;
//纵向地图数量
const ynum = 20;
//设置地图大小
$('.map-div').css({
    width : xnum * 50 + 'px',
    height : ynum * 50 + 'px'
});

//配置世界

//创建一个新地图
function createMap(terrains, canPush = true){
    const map = [];

    //循环横纵坐标数量，生成空地图
    for(let y = 0 ; y < ynum ; y++){
        map[y] = [];
        for(let x = 0 ; x < xnum ; x++){
            map[y][x] = '-1';
        }
    }

    //循环地图，填充地形
    for(let y = 0 ; y < map.length ; y++){
        for(let x = 0 ; x < map[y].length ; x++){
            //根据四方向内已有的地形，获取所有允许生成的地形列表
            const top = y > 0 ? map[y - 1][x] : '-1';
            const bottom = y < ynum - 1 ? map[y + 1][x] : '-1';
            const left = x > 0 ? map[y][x - 1] : '-1';
            const right = x < xnum - 1 ? map[y][x + 1] : '-1';
            //获取允许的所有地形并取交集
            let band = [(terrainJoinTerrain[top] || terrains),(terrainJoinTerrain[bottom] || terrains),(terrainJoinTerrain[left] || terrains),(terrainJoinTerrain[right] || terrains)];
            let tempTerrainArray = arrayIntersection(band);

            //获取随机地形
            let terrain = tempTerrainArray.getRandom();
            //如果随机出的地形是只能在最外层的地形，且x和y坐标不为0，也不为最后一个坐标，则说明不是最外层，重新随机一个地形
            while(tempTerrainArray.length > 1 && outerTerrains.indexOf(terrain) !== -1 && x !== 0 && y !== 0 && x !== (xnum - 1) && y !== (ynum - 1)){
                tempTerrainArray = tempTerrainArray.filter(e => e !== terrain);
                terrain = tempTerrainArray.getRandom();
            }

            if(!terrain){
                return createMap(terrains, false);
            }
            map[y][x] = terrain;
        }
    }

    //如果还有下一个世界，则随机出下一个地图的入口
    const nextX = randomNum(0, xnum - 1);
    const nextY = randomNum(0, ynum - 1);
    if(data.worldIndex < mapNum - 1){
        if(canPush){
            data.maps.push(mapConfig[data.worldIndex + 1].getRandom());
        }
        map[nextY][nextX] = data.maps[data.worldIndex + 1].name;
        data.nextPoint = [nextX,nextY];
    }else{
        data.nextPoint = null;
    }

    //如果不是初始地图，则随机出上一个地图的入口
    if(data.worldIndex > 0){
        let preX = randomNum(0, xnum - 1);
        let preY = randomNum(0, ynum - 1);
        while (preX === nextX && preY === nextY){
            preX = randomNum(0, xnum - 1);
            preY = randomNum(0, ynum - 1);
        }
        map[preY][preX] = data.maps[data.worldIndex - 1].name;
        data.prePoint = [preX,preY];
    }else{
        data.prePoint = null;
    }

    //创建神殿
    Object.keys(deitys).forEach(e =>{
        //随机神殿坐标
        let x = randomNum(0, xnum - 1);
        let y = randomNum(0, ynum - 1);
        while (terrainArray[data.maps[data.worldIndex].name].indexOf(map[y][x]) === -1){
            x = randomNum(0, xnum - 1);
            y = randomNum(0, ynum - 1);
        }

        //创建神殿
        const temple = createTemple(e, data.worldIndex);
        map[y][x] = '神殿';
        if(!data.temples){
            data.temples = {};
        }
        if(!data.temples[data.worldIndex]){
            data.temples[data.worldIndex] = {};
        }
        data.temples[data.worldIndex][`${x},${y}`] = temple;

        //创建对应神的信息
        if(!data.deitys){
            data.deitys = {};
        }
        if(!data.deitys[e]){
            data.deitys[e] = {
                godFavor : 0,//神眷
                belief : 0,//信仰
            };
        }
    })

    //创建最终BOSS所在地形
    if(data.maps[data.worldIndex].endTerrain){
        let x = randomNum(0, xnum - 1);
        let y = randomNum(0, ynum - 1);
        while (terrainArray[data.maps[data.worldIndex].name].indexOf(map[y][x]) === -1){
            x = randomNum(0, xnum - 1);
            y = randomNum(0, ynum - 1);
        }
        map[y][x] = data.maps[data.worldIndex].endTerrain;
        data.endBoss = `${x},${y}`;
    }

    return map;
}

//点击查看地图
$('.map-menu-btn').click(function(){
    $('#see-map-flag').addClass('hide');
    $('#add-map-flag').addClass('hide');
    $('.map-bottom-point').html(``)
    renderMap();
    $('.location-map').removeClass('location-map')
    $(`.map[point="${data.location.join()}"]`).addClass('location-map')
    $('.map-div-container').show();

    //地图定位到所在位置
    const points = $('.location-map').attr('point').split(',');
    $('.map-div-container .win-body').scrollTop((parseInt(points[1]) + 1) * 50 - ($('.map-div-container .win-body').height() / 2));
    $('.map-div-container .win-body').scrollLeft((parseInt(points[0]) + 1) * 50 - ($('.map-div-container .win-body').width() / 2) - 25);

    $('.map span').hide();
    $('.map').addClass('hide-map');
    Object.keys(data.world.showMap).forEach(e => {
        $(`.map[point="${e}"] span`).show();
        $(`.map[point="${e}"]`).removeClass('hide-map');
    })
    $(`.myth-monster span`).show();
    $(`.myth-monster`).removeClass('hide-map');
});

//添加地图标记
function addMapFlag(){
    if(!data.world.mapFlags){
        data.world.mapFlags = {};
    }
    const point = $('.select-map').attr('point');
    if(point){
        const text = prompt('请输入你要标注的内容(把内容全部删掉就可以删除该标记了)', data.world.mapFlags[point] || '');
        if(text != null){
            data.world.mapFlags[point] = text;
            save();
            $('.map-menu-btn').click();
        }
    }else{
        winMsg('请选择要标记的位置')
    }
}

//点击探索地图
$('.search').click(function(){
    //时间流逝
    timeLapses(searchMin);
});

//点击查看任务
$('.show-task').click(function(){
    $('.task-data').show();
    const html = $('.task-data .active').html();
    if(html === '神灵'){
        renderDeityTask();
    }else if(html === 'NPC'){
        renderNpcTaskInfo();
    }
});

//点击查看日志
$('.show-logs').click(function(){
    $('.logs p').html('');
    data.logs.forEach(e => {
        $('.logs p').append(e + '<br>');
    })
    $('.logs').show();
});

let systemLock = true;

//点击采集资源
$('.body').on('click','.element',function(){
    const id = $(this).attr('id');

    //获取元素配置
    const elementList = data.world.mapElements[data.location.join()].elementList;
    const el = elementList.filter(e => e.id === id)[0];
    let {name, time, num, getItem, needItem, canHand} = el;
    getItem = elementCfgs[name].getItem;

    //本次采集是否空手采集
    let isHand = false;
    //判断是否持有需要的物品
    if(needItem.length > 0){
        let has = false;
        needItem.forEach(needItemName => {
            if(has){
                return;
            }
            //获取背包中需要的物品
            let item = data.bag.filter(e => e.name === needItemName);
            //如果背包中有需要的物品，则耐久-1
            if(item.length > 0){
                reduceEndurance(needItemName);
                //找到需要的物品了
                has = true;
            }
        })
        //如果没找到需要的物品，则不允许采集
        if(!has){
            //如果允许空手采集，则进行空手采集处理
            if(canHand){
                isHand = true;
            }else{
                msg(`缺少工具:${needItem.join()}`,false);
                return;
            }
        }
    }

    data.safeRun = false;
    //记录获得了什么物品
    const getedItems = [];

    //循环可掉落物品
    getItem.forEach(({name : itemName,minNum,maxNum}) => {
        const dlcAddNum = checkMonthName('丰饶之月') ? 1 : checkMonthName('贫瘠之月') ? -1 : 0;
        //获取掉落数量
        const getNum = randomNum(minNum + dlcAddNum,maxNum + dlcAddNum);
        //掉落数量大于0，则放入背包
        if(getNum > 0){
            addItem(itemName, getNum)
            getedItems.push(`${elementCfgs[itemName] ? elementCfgs[itemName].showName || itemName : itemName}*${getNum}`);
        }else if(needItem.length > 0 && needItem[0] === '鱼竿'){
            //1%几率获得潮湿的爆炸物
            if(randomNum() <= 1){
                addItem('潮湿的爆炸物')
                getedItems.push(`潮湿的爆炸物*1`);
            }else if(randomNum(1, 100) <= 30){
                //30%几率获取物品
                const num = randomNum(1, 100);
                const type = num <= 60 ? ['资源','食物','素材'].getRandom() : num <= 95 ? ['料理','药品'].getRandom() : '稀有物品';

                if(goods[data.world.name][type]){
                    const itemName = goods[data.world.name][type].getRandom();
                    addItem(itemName,1);
                    getedItems.push(`${itemName}*1`);
                }
            }
        }
    })


    //如果只剩下一次可采集次数，则删除该元素，否则可采集次数减一
    if(num <= 1){
        //记录采集数量
        if(!data.gathered[name]){
            data.gathered[name] = 0;
        }
        data.gathered[name]++;

        if(name === '浆果丛' && data.gathered[name] >= 1000 && conf.races.indexOf('精灵') === -1){
            winMsg('恭喜你解锁精灵种族！');
            conf.races.push('精灵');
            save(confSavedName, conf);
        }

        data.world.mapElements[data.location.join()].elementList = elementList.filter(e => e.id !== id);
    }else{
        el.num = --num;
    }

    //如果有记录获取的物品，则打印
    if(getedItems.length > 0){
        msg(`采集${name},获得：${getedItems.join()}`);
    }else{
        msg(`什么也没采集到`,false);
    }

    if(festival && festival.name === '劳动节活动'){
        if(randomNum(1,1000) <= time){
            addItem('劳动奖章')
            msg('恭喜你获得劳动奖章')
        }
    }

    //时间流逝,空手采集消耗的时间翻倍
    timeLapses(time * (isHand ? 2 : 1));
})

//点击查看物品
$('.show-bag').click(function(){
    renderBag();
    $('.bag-player-equip button').removeClass('active');
    $('.bag-player-equip button').eq(data.selecEquip).addClass('active');
    $('.bag').show();
    $('.store').hide();
});

//点击制作
$('.show-work').click(function(){
    renderWorkList(0);
    showWorkWin()
});

//地图上点击节点移动
$('.map-div').on('click', '.map', function(){
    const point = $(this).attr('point');
    if(point){
        //星灵不触发地图移动
        if(!data.race.name.startsWith('星灵')){
            const pointArr = point.split(',');
            const x = pointArr[0];
            const y = pointArr[1];
            //上
            if(x == data.location[0] && y == data.location[1] - 1){
                $('.top').click();
                $('.map-menu-btn').click();
                return;
            }
            //下
            if(x == data.location[0] && y == data.location[1] + 1){
                $('.bottom').click();
                $('.map-menu-btn').click();
                return;
            }
            //左
            if(x == data.location[0] - 1 && y == data.location[1]){
                $('.left').click();
                $('.map-menu-btn').click();
                return;
            }
            //右
            if(x == data.location[0] + 1 && y == data.location[1]){
                $('.right').click();
                $('.map-menu-btn').click();
                return;
            }
            //点击的是当前节点则不管
            if(x == data.location[0] && y == data.location[1]){
                return;
            }
        }

        //星灵双击地图直接移动
        if(data.race.name.startsWith('星灵') && $(this).hasClass('select-map')){
            $('.fly-map').click();
            return;
        }

        //如果不是四周的节点，则选中
        $('.map-bottom-point').html(`坐标：${point}`)
        $('.select-map').removeClass('select-map')
        $(this).addClass('select-map')

        if(data.world.showMap[point]){
            if(!data.world.mapFlags){
                data.world.mapFlags = {};
            }
            if(data.world.mapFlags[point]){
                $('#see-map-flag').removeClass('hide');
            }else{
                $('#see-map-flag').addClass('hide');
            }
            $('#add-map-flag').removeClass('hide');
        }else{
            $('#see-map-flag').addClass('hide');
            $('#add-map-flag').addClass('hide');
        }
    }
});

//传送
$('.fly-map').click(function(){
    let $select = $('.select-map');
    if($select.length > 0){
        const point = $select.attr('point');
        if(point){
            const pointArr = point.split(',');
            const x = pointArr[0];
            const y = pointArr[1];
            if($select.hasClass('hide-map')){
                winMsg('只能传送已显示的地图', false, false)
                return;
            }

            if(!data.race.name.startsWith('星灵')){
                let numByBag = getNumByBag('小型传送阵', data.location.join() === data.world.home.location.join());
                if(numByBag < 1){
                    winMsg('需要消耗1个小型传送阵', false, false)
                    return;
                }
                reduceItemByAll('小型传送阵')

                if(randomNum(1,100) <= 1){
                    if(conf.races.indexOf('断肠人') === -1){
                        conf.races.push('断肠人');
                        save(confSavedName, conf);
                        winMsg(`恭喜你解锁了断肠人！`);
                    }
                }
            }
            data.location = [parseInt(x), parseInt(y)];
            msg(`传送到了[${$select.html()}]`);

            //将当前坐标和四周坐标设置为已探索
            setShowMap();
            //渲染可前往的地图
            renderCanToMap();
            //重新渲染地图
            renderMapElements();

            $('.map-menu-btn').click();
            save();
        }
    }

});

//点击要前往的地图
$('.top,.left,.right,.bottom').click(function(){
    if(data.inDungeon){
        winMsg('副本内不能移动', false, false)
        return;
    }
    let needTime = moveMin;

    //速度加成
    if(data.spd){
        needTime = parseInt(needTime / (1 + parseFloat2Fiexd(data.spd / 100)))
    }

    //亡灵移动更快
    if(data.race.name.startsWith('亡灵族')){
        needTime = 30;
    }
    const point = $(this).attr('data-point');
    if(point){
        //超重时不允许移动
        if(data.weight > 2100000000){
            if(data.race.name.startsWith('亡灵族') || data.runStatus['力量药剂']){
                needTime *= 1 + parseInt(data.weight / data.maxWeight);
            }else if(!data.race.name.startsWith('星灵')){
                winMsg('太重了，无法移动', false, false);
                return;
            }
        }

        if(data.runStatus['力量药剂']){
            data.runStatus['力量药剂']--;
            msg(`力量药剂剩余：${ data.runStatus['力量药剂']}`)
        }

        data.location = point.split(',');
        data.location[0] = parseInt(data.location[0]);
        data.location[1] = parseInt(data.location[1]);
        if(data.world.mapElements[data.location.join()]){
            data.world.mapElements[data.location.join()].losts = [];
        }

        $('.home').hide();
        msg(`前往了[${$(this).html()}]`);

        if(data.runStatus['敏捷药剂']){
            needTime = parseInt(needTime / 2)
            data.runStatus['敏捷药剂']--;
            msg(`敏捷药剂剩余：${ data.runStatus['敏捷药剂']}`)
        }

        //将当前坐标和四周坐标设置为已探索
        setShowMap();
        //时间流逝
        timeLapses(needTime);
        //渲染可前往的地图
        renderCanToMap();
    }
});

//查看图鉴
let showCyberneted = false;
$('.show-cybernet').click(function(){
    $('.cybernet').show();
    if(!showCyberneted){
        showCyberneted = true;
        renderCybernetItems();
    }
});

//点击前往其他地图
$('.body').on('click','.to-world',function(){
    //获取地图序号
    const index = parseInt($(this).attr('data-index'));
    toWorld(index);
});

//前往下一个世界
function nextWorld(){
    toWorld(data.worldIndex + 1);
}

//前往上一个世界
function preWorld(){
    toWorld(data.worldIndex - 1);
}

let canToWorld = true;
//前往其他世界
function toWorld(index,render = true){
    //增加限制，避免连点
    if(!canToWorld){
        return;
    }
    canToWorld = false;
    //用于判断是前往下一个世界还是上一个世界
    const isGo = data.worldIndex < index;
    //副本不保存世界信息
    if(!data.inDungeon){
        //保存世界信息
        data.worlds[data.worldIndex] = data.world;
    }
    //切换世界序号
    data.worldIndex = index;

    //如果该序号还未创建世界，则创建世界
    if(!data.worlds[data.worldIndex]){
        //创建地图
        const map = createMap(terrainArray[data.maps[data.worldIndex].name]);
        //创建世界
        data.worlds[data.worldIndex] = {
            ...data.maps[data.worldIndex],
            map : map,//世界地图
            showMap : {},//key为显坐标，value为1则代表已经显示出来，否则就是空白显示
            mapElements : {},//地图元素集合
            home : {
                location : []//家的坐标[1,2]
            },
            nextPoint : data.nextPoint,
            prePoint : data.prePoint,
            pass : false,//用于记录是否通关，即是否已经战胜守关BOSS
            mythMonster : data.maps[data.worldIndex].mythMonster.map(e => ({name : e, location : [randomNum(0,xnum - 1), randomNum(0,ynum - 1)]}))
        }
    }else{
        data.nextPoint = data.worlds[index].nextPoint;
        data.prePoint = data.worlds[index].prePoint;
    }

    //转移世界
    data.world = data.worlds[data.worldIndex];
    //切换地图
    data.map = data.world.map;
    //设置初始坐标
    if(isGo){
        data.location = data.world.prePoint;
    }else{
        data.location = data.world.nextPoint || data.world.prePoint;
    }

    msg(`进入[${data.world.name}]`);

    if(render){
        //将当前坐标和四周坐标设置为已探索
        setShowMap();

        //渲染可前往的地图
        renderCanToMap();
        //渲染地图
        renderMap();
        //时间流逝
        timeLapses(30);
    }

    if(data.showMythDay === new Date(data.date).format('yyyyMMdd')){
        const monsters = data.world.mythMonster.filter(e => !e.deathTime);
        if(monsters.length === 0){
            winMsg(`当前地图没有存活的神话怪`);
        }else{
            winMsg(monsters.map(e => `${e.name}：坐标${e.location.join()}`).join('，'));
        }
    }
    saveWorlds();
    canToWorld = true;
}

//将当前坐标和四周坐标设置为已探索
function setShowMap(point = data.location){
    data.world.showMap[point.join()] = 1;
    if(!data.dlcKeepDark){
        data.world.showMap[`${point[0] - 1},${point[1]}`] = 1;
        data.world.showMap[`${point[0] + 1},${point[1]}`] = 1;
        data.world.showMap[`${point[0]},${point[1] - 1}`] = 1;
        data.world.showMap[`${point[0]},${point[1] + 1}`] = 1;
    }
}

//批量采集功能
$('.gather-all').click(function(){
    renderMopUp();
    $('.mop-up-win-modal').show();
    $('.mop-up-win').show();
});

//关闭批量采集窗口
$('.close-mop-up-win').click(function(){
    $('.mop-up-win-modal').hide();
    $('.mop-up-win').hide();
})

//扫荡
$('.mop-up-win-body').on('click','.mop-up-element', function(){

    if(data.maxWater > 0){
        if(data.hunger <= 0 || data.water <= 0){
            winMsg('饥饿和口渴时无法扫荡')
            return;
        }
    }else{
        if(data.hp < data.maxHp * 0.2){
            winMsg('血量低于20%时无法扫荡')
            return;
        }
    }

    const elName = $(this).find('span').html();
    //记录总共消耗的时间
    let timeCount = 0;
    //记录获得了什么物品
    const getedItems = {};
    const arr = data.world.mapElements[data.location.join()].elementList.filter(e => e.name === elName);


    a:for(let index = 0 ; index < arr.length ; index++){
        const el = arr[index];
        let {name, time, num, getItem, needItem} = el;

        for(let i = 0 ; i < num ; i++){
            //判定饥饿和水分是否足够
            let {hunger : needHunger, water : needWater} = getNeedWaterAndHungerByMin(timeCount + time);
            if(!data.race.getNoHunger()){
                if(data.water - needWater < 10 || data.hunger - needHunger < 10){
                    winMsg(`采集中止，因为再采集一个将导致你的饥饿或水分降低到10点以下`)
                    break a;
                }
            }else{
                if(data.hp - needHunger - needWater < 50){
                    winMsg(`采集中止，因为再采集一个将导致你的血量低到50点以下`)
                    break a;
                }
            }

            //采集工具判定
            if(needItem && needItem.length){
                let flag = false;
                for(let j = 0 ; j < needItem.length ; j++){
                    let bagItemByName = getBagItemByName(needItem[j]);
                    if(bagItemByName){
                        reduceEndurance(needItem[j]);
                        flag = true;
                        break;
                    }
                }
                if(!flag){
                    winMsg(`你没有工具了`)
                    break a;
                }
            }

            //循环可掉落物品
            getItem.forEach(({name : itemName,minNum,maxNum}) => {
                //获取掉落数量
                const getNum = randomNum(minNum,maxNum);
                //掉落数量大于0，则放入背包
                if(getNum > 0){
                    addItem(itemName, getNum);
                    if(getedItems[itemName]){
                        getedItems[itemName] += getNum;
                    }else{
                        getedItems[itemName] = getNum;
                    }
                }
            })

            timeCount += time;
            el.num--;
        }

        if(el.num <= 0){
            data.world.mapElements[data.location.join()].elementList = data.world.mapElements[data.location.join()].elementList.filter(e => e.id !== el.id);
            //记录采集数量
            if(!data.gathered[name]){
                data.gathered[name] = 0;
            }
            data.gathered[name]++;

            if(name === '浆果丛' && data.gathered[name] >= 1000 && conf.races.indexOf('精灵') === -1){
                winMsg('恭喜你解锁精灵种族！');
                conf.races.push('精灵');
                save(confSavedName, conf);
            }
        }
    }

    if(timeCount > 0){
        winMsg(`你扫荡了${elName}，获得：${Object.keys(getedItems).map(e => `${e}*${getedItems[e]}`).join('，')}`)
        //时间流逝
        timeLapses(timeCount);
        renderMopUp();
    }
});

let mapSize = 1;
//地图放大
function mapBig(){
    mapSize += 0.1;
    $('.map-div').css('transform',`scale(${mapSize})`);
}

//地图缩小
function mapSmall(){
    mapSize -= 0.1;
    $('.map-div').css('transform',`scale(${mapSize})`);
}

//地图还原
function mapOrigin(){
    mapSize = 1;
    $('.map-div').css('transform',`scale(${mapSize})`);
}
