/**
 * 便捷创建地图怪物配置
 * @param name 怪物名
 * @param prob 出现概率,百分之
 */
const terrainMonster = function(name, prob, cfgs = monsterCfgs || {}){
    return {[name] : {prob, atkTime : cfgs[name].atkTime, atkProb : cfgs[name].atkProb, level : cfgs[name].level, type : cfgs[name].type}}
}

//怪物配置
let monsterCfgs = {
    '史莱姆' : {
        tags : ['魔物','史莱姆'],
        atkTime : '日',//主动攻击的时间
        atkProb : 10,//主动攻击的概率,
        level : 1,//怪物等级
        hp : 5,//生命值
        atk : 2,//攻击力,
        def : 0,//防御力
        exp : 2,//击败获得的经验值
        atkSpd : 1,
        type : null,//怪物类型默认为空，为空则是普通怪物
        items : [{name : '位面坐标：粘液',minNum : 98, maxNum : 1},{name : '图纸：软皮甲',minNum : 8, maxNum : 1},{name : '粘液',minNum : 1, maxNum : 2},{name : '软皮',minNum : 1, maxNum : 2}],//掉落物品，[{name : '物品名',minNum : 0, maxNum : 1}],minNum可以为负数，当随机数量在0以下时，都不会获取物品，所以可以minNum越小，获取到该物品的概率越低
    },
    '哥布林' : {
        tags : ['人型生物','哥布林'],
        atkTime : '夜',
        atkProb : 10,
        level : 2,
        hp : 10,
        atk : 3,
        def : 0,
        exp : 5,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：软皮甲',minNum : 8, maxNum : 1},{name : '图纸：利齿匕首',minNum : 8, maxNum : 1},{name : '碎布片',minNum : 1, maxNum : 2},{name : '铁片',minNum : 0, maxNum : 2},{name : '尖牙',minNum : 1, maxNum : 1}],
    },
    '狼' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 20,
        level : 3,
        hp : 20,
        atk : 5,
        def : 1,
        exp : 10,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：利齿匕首',minNum : 8, maxNum : 1},{name : '图纸：兽皮甲',minNum : 13, maxNum : 1},{name : '图纸：兽爪拳刃',minNum : 13, maxNum : 1},{name : '尖牙',minNum : 1, maxNum : 2},{name : '利爪',minNum : 0, maxNum : 2},{name : '兽皮',minNum : 1, maxNum : 3},{name : '肉',minNum : 1, maxNum : 3}],
    },
    '巨鼠' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 3,
        hp : 15,
        atk : 5,
        def : 1,
        exp : 7,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：利齿匕首',minNum : 8, maxNum : 1},{name : '图纸：兽皮甲',minNum : 13, maxNum : 1},{name : '图纸：兽爪拳刃',minNum : 13, maxNum : 1},{name : '尖牙',minNum : 1, maxNum : 2},{name : '利爪',minNum : 0, maxNum : 1},{name : '兽皮',minNum : 0, maxNum : 2},{name : '肉',minNum : 1, maxNum : 2}],
    },
    '蜘蛛' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 4,
        hp : 20,
        atk : 10,
        def : 0,
        exp : 10,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：甲壳衣',minNum : 8, maxNum : 1},{name : '蜘蛛丝',minNum : 1, maxNum : 2},{name : '毒囊',minNum : 1, maxNum : 2}],
    },
    '巨蟒' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 4,
        hp : 40,
        atk : 5,
        def : 2,
        exp : 15,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：兽皮甲',minNum : 8, maxNum : 1},{name : '图纸：兽爪拳刃',minNum : 8, maxNum : 1},{name : '毒囊',minNum : 1, maxNum : 1},{name : '蛇胆',minNum : 1, maxNum : 1},{name : '兽皮',minNum : 1, maxNum : 2}],
    },
    '蝎子' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 5,
        hp : 30,
        atk : 10,
        def : 2,
        exp : 15,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：甲壳衣',minNum : 18, maxNum : 1},{name : '甲壳',minNum : 1, maxNum : 2},{name : '毒囊',minNum : 1, maxNum : 1}],
    },
    '蠕虫' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 5,
        hp : 50,
        atk : 3,
        def : 0,
        exp : 10,
        atkSpd : 2,
        type : null,
        items : [{name : '图纸：软皮甲',minNum : 8, maxNum : 1},{name : '软皮',minNum : 2, maxNum : 5},{name : '粘液',minNum : 2, maxNum : 5},{name : '毒囊',minNum : 1, maxNum : 1}],
    },
    '巨蜥' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 7,
        hp : 50,
        atk : 8,
        def : 2,
        exp : 15,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：兽皮甲',minNum : 3, maxNum : 1},{name : '图纸：兽爪拳刃',minNum : 3, maxNum : 1},{name : '肉',minNum : 2, maxNum : 3},{name : '兽皮',minNum : 2, maxNum : 4},{name : '尖牙',minNum : 1, maxNum : 2},{name : '利爪',minNum : 1, maxNum : 2}],
    },
    '食人鱼' : {
        tags : ['野兽'],
        atkTime : '全天',
        atkProb : 5,
        level : 3,
        hp : 10,
        atk : 5,
        def : 0,
        exp : 4,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：利齿匕首',minNum : 8, maxNum : 1},{name : '尖牙',minNum : 0, maxNum : 1},{name : '肉',minNum : 0, maxNum : 1}],
    },
    '狮鹫' : {
        tags : ['野兽'],
        atkTime : '日',
        atkProb : 5,
        level : 10,
        hp : 60,
        atk : 15,
        def : 3,
        exp : 20,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：羽刃扇',minNum : 5, maxNum : 1},{name : '羽毛',minNum : 2, maxNum : 4},{name : '尖牙',minNum : 1, maxNum : 3},{name : '利爪',minNum : 1, maxNum : 3},{name : '肉',minNum : 3, maxNum : 5}],
    },
    '鱼人' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 5,
        hp : 20,
        atk : 3,
        def : 0,
        exp : 5,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：利齿匕首',minNum : 8, maxNum : 1},{name : '尖牙',minNum : 0, maxNum : 1},{name : '贝壳',minNum : 8, maxNum : 1}],
    },
    '鳄龟' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 8,
        hp : 50,
        atk : 8,
        def : 5,
        exp : 20,
        atkSpd : 2,
        type : null,
        items : [{name : '图纸：甲壳衣',minNum : 13, maxNum : 1},{name : '甲壳',minNum : 3, maxNum : 5},{name : '尖牙',minNum : 1, maxNum : 3},{name : '肉',minNum : 2, maxNum : 4}],
    },
    '哥布林巨人' : {
        tags : ['人型生物','哥布林', '巨型生物'],
        atkTime : '夜',
        atkProb : 10,
        level : 10,
        hp : 250,
        atk : 15,
        def : 3,
        exp : 60,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：哥布林杀手',minNum : 3, maxNum : 1},{name : '图纸：弱小联合',minNum : 3, maxNum : 1},{name : '碎布片',minNum : 5, maxNum : 8},{name : '尖牙',minNum : 2, maxNum : 4},{name : '哥布林之心',minNum : 1, maxNum : 1},{name : '技能石：重击',minNum : 1, maxNum : 1}],
    },
    '哥布林英雄' : {
        tags : ['人型生物','哥布林', '巨型生物'],
        atkTime : '夜',
        atkProb : 0,
        level : 10,
        hp : 750,
        atk : 25,
        def : 5,
        exp : 100,
        atkSpd : 3,
        type : '传说',
        items : [{name : '图纸：哥布林杀手',minNum : 0, maxNum : 1},{name : '图纸：弱小联合',minNum : 1, maxNum : 1},{name : '哥布林之心',minNum : 1, maxNum : 1},{name : '哥布林魔晶',minNum : 1, maxNum : 1},{name : '技能石：重击',minNum : 1, maxNum : 1}],
    },
    '神性史莱姆' : {
        tags : ['魔物','史莱姆'],
        atkTime : '日',
        atkProb : 0,
        level : 10,
        hp : 1000,
        atk : 40,
        def : 10,
        exp : 200,
        atkSpd : 2,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '图纸：弱小联合',minNum : 3, maxNum : 1},{name : '神性结晶',minNum : 1, maxNum : 1},{name : '闪耀的皮',minNum : 1, maxNum : 3},{name : '神性液体',minNum : 1, maxNum : 3},{name : '技能石：治愈术',minNum : 5, maxNum : 10}],
    },
    '扭曲邪物' : {
        tags : ['污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 10,
        hp : 1500,
        atk : 45,
        def : 15,
        exp : 300,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 1000, maxNum : 1},{name : '变异核心',minNum : 50, maxNum : 50}],
    },
    '碎裂的宝石巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 10,
        hp : 1500,
        atk : 45,
        def : 15,
        exp : 300,
        atkSpd : 3,
        type : '神话',
        items : getGemByLevel(1),
    },
    '巨神飞鱼' : {
        tags : ['野兽', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 10,
        hp : 5000,
        atk : 15,
        def : 3,
        exp : 600,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '10级武器打孔石',minNum : 1, maxNum : 3},{name : '10级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：1点',minNum : 1, maxNum : 1}],
    },

    '大哥布林' : {
        tags : ['人型生物','哥布林'],
        atkTime : '全天',
        atkProb : 10,
        level : 11,
        hp : 50,
        atk : 18,
        def : 10,
        exp : 20,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：麦林之刃',minNum : 8, maxNum : 1},{name : '布',minNum : 1, maxNum : 2},{name : '铁片',minNum : 2, maxNum : 4},{name : '尖牙',minNum : 1, maxNum : 3}],
    },
    '洞穴人' : {
        tags : ['人型生物'],
        atkTime : '全天',
        atkProb : 10,
        level : 12,
        hp : 80,
        atk : 18,
        def : 10,
        exp : 25,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：冲锋甲',minNum : 8, maxNum : 1},{name : '石矛',minNum : 2, maxNum : 1},{name : '尖牙',minNum : 0, maxNum : 2},{name : '布',minNum : 0, maxNum : 1}],
    },
    '蝙蝠' : {
        tags : ['野兽'],
        atkTime : '全天',
        atkProb : 10,
        level : 12,
        hp : 60,
        atk : 20,
        def : 8,
        exp : 30,
        atkSpd : 4,
        type : null,
        items : [{name : '图纸：麦林之刃',minNum : 8, maxNum : 1},{name : '图纸：重锤',minNum : 13, maxNum : 1},{name : '尖牙',minNum : 1, maxNum : 2},{name : '肉',minNum : 1, maxNum : 2},{name : '兽骨',minNum : 0, maxNum : 1}],
    },
    '猩红蝾螈' : {
        tags : ['野兽'],
        atkTime : '全天',
        atkProb : 10,
        level : 13,
        hp : 100,
        atk : 25,
        def : 12,
        exp : 40,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：麦林之刃',minNum : 8, maxNum : 1},{name : '图纸：重锤',minNum : 13, maxNum : 1},{name : '硬皮',minNum : 1, maxNum : 3},{name : '肉',minNum : 3, maxNum : 5},{name : '兽骨',minNum : 1, maxNum : 2}],
    },
    '黑矮人' : {
        tags : ['人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 15,
        hp : 150,
        atk : 28,
        def : 10,
        exp : 50,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：重锤',minNum : 8, maxNum : 1},{name : '图纸：矮人之心',minNum : 8, maxNum : 1},{name : '铁矿',minNum : 0, maxNum : 2},{name : '蘑菇',minNum : 1, maxNum : 2},{name : '矮人胡环',minNum : 1, maxNum : 2}],
    },
    '巨蝎' : {
        tags : ['野兽'],
        atkTime : '全天',
        atkProb : 10,
        level : 14,
        hp : 80,
        atk : 25,
        def : 15,
        exp : 50,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：冲锋甲',minNum : 8, maxNum : 1},{name : '图纸：重锤',minNum : 13, maxNum : 1},{name : '图纸：矮人之心',minNum : 13, maxNum : 1},{name : '硬壳',minNum : 3, maxNum : 5},{name : '肉',minNum : 2, maxNum : 4},{name : '兽骨',minNum : 1, maxNum : 2}],
    },
    '骷髅' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 10,
        level : 12,
        hp : 100,
        atk : 15,
        def : 10,
        exp : 30,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：残火盔甲',minNum : 18, maxNum : 1},{name : '图纸：矮人之心',minNum : 13, maxNum : 1},{name : '骨头',minNum : 1, maxNum : 3},{name : '灵魂残片',minNum : 0, maxNum : 1}],
    },
    '食尸鬼' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 10,
        level : 16,
        hp : 200,
        atk : 30,
        def : 10,
        exp : 100,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：残火盔甲',minNum : 18, maxNum : 1},{name : '图纸：矮人之心',minNum : 13, maxNum : 1},{name : '血肉精华',minNum : 1, maxNum : 2},{name : '灵魂残片',minNum : 1, maxNum : 1}],
    },
    '火蛇' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 10,
        level : 18,
        hp : 250,
        atk : 35,
        def : 12,
        exp : 150,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：熔火剑',minNum : 8, maxNum : 1},{name : '图纸：残火盔甲',minNum : 18, maxNum : 1},{name : '图纸：矮人之心',minNum : 13, maxNum : 1},{name : '魔核',minNum : 1, maxNum : 1},{name : '肉',minNum : 3, maxNum : 5},{name : '兽皮',minNum : 1, maxNum : 5},{name : '兽骨',minNum : 2, maxNum : 3},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '火元素' : {
        tags : ['元素生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 20,
        hp : 300,
        atk : 35,
        def : 15,
        exp : 200,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：重锤',minNum : 8, maxNum : 1},{name : '图纸：熔火剑',minNum : 8, maxNum : 1},{name : '图纸：残火盔甲',minNum : 8, maxNum : 1},{name : '火结晶',minNum : 1, maxNum : 1},{name : '火焰灰烬',minNum : 1, maxNum : 3}],
    },
    '游荡者' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 1500,
        atk : 40,
        def : 10,
        exp : 500,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：疯狂撕咬',minNum : 3, maxNum : 1},{name : '灵魂石',minNum : 1, maxNum : 1},{name : '残破的剑',minNum : 1, maxNum : 1},{name : '遗忘之魂',minNum : 3, maxNum : 1}],
    },
    '地穴领主' : {
        tags : ['魔物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 4000,
        atk : 60,
        def : 10,
        exp : 1000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '图纸：疯狂撕咬',minNum : 0, maxNum : 1},{name : '图纸：灵魂外壳',minNum : 0, maxNum : 1},{name : '地穴领主之爪',minNum : 3, maxNum : 5},{name : '地穴领主的壳',minNum : 1, maxNum : 3}],
    },
    '远古残魂' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 4000,
        atk : 80,
        def : 30,
        exp : 2000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '图纸：灵魂外壳',minNum : 0, maxNum : 1},{name : '技能石：灵魂鞭挞',minNum : 1, maxNum : 1},{name : '灵魂石',minNum : 1, maxNum : 3},{name : '遗忘之魂',minNum : 1, maxNum : 1},{name : '神性结晶',minNum : 1, maxNum : 2},{name : '神性魂石',minNum : 1, maxNum : 3},{name : '远古精魄',minNum : 1, maxNum : 3}],
    },
    '扭曲的憎恨' : {
        tags : ['不死族', '幽灵', '污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 5000,
        atk : 85,
        def : 35,
        exp : 2500,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 500, maxNum : 1},{name : '变异核心',minNum : 100, maxNum : 100}],
    },
    '火元素领主' : {
        tags : ['元素生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 15000,
        atk : 40,
        def : 10,
        exp : 5000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '20级武器打孔石',minNum : 1, maxNum : 3},{name : '20级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：2点',minNum : 1, maxNum : 1}],
    },
    '裂开的宝石巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 5000,
        atk : 85,
        def : 35,
        exp : 2500,
        atkSpd : 3,
        type : '神话',
        items : getGemByLevel(11),
    },

    '硬鳞鱼人' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 11,
        hp : 60,
        atk : 17,
        def : 12,
        exp : 25,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：鱼蟹锤',minNum : 8, maxNum : 1},{name : '图纸：刺壳甲',minNum : 8, maxNum : 1},{name : '图纸：鳞枪',minNum : 18, maxNum : 1},{name : '图纸：蓝龟板甲',minNum : 18, maxNum : 1},{name : '鱼人鳞片',minNum : 2, maxNum : 4},{name : '鱼人牙齿',minNum : 1, maxNum : 3},{name : '鱼人眼球',minNum : 0, maxNum : 2}],
    },
    '巨钳蟹' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 12,
        hp : 50,
        atk : 20,
        def : 15,
        exp : 30,
        atkSpd : 2,
        type : null,
        items : [{name : '图纸：鱼蟹锤',minNum : 8, maxNum : 1},{name : '图纸：刺壳甲',minNum : 8, maxNum : 1},{name : '图纸：鳞枪',minNum : 18, maxNum : 1},{name : '螃蟹壳',minNum : 0, maxNum : 1},{name : '蟹肉',minNum : 1, maxNum : 2},{name : '巨大蟹钳',minNum : 0, maxNum : 2}],
    },
    '毒刺海胆' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 13,
        hp : 80,
        atk : 30,
        def : 0,
        exp : 40,
        atkSpd : 1,
        type : null,
        items : [{name : '图纸：鱼蟹锤',minNum : 8, maxNum : 1},{name : '图纸：刺壳甲',minNum : 8, maxNum : 1},{name : '图纸：鳞枪',minNum : 18, maxNum : 1},{name : '图纸：碧水枪',minNum : 28, maxNum : 1},{name : '海胆毒刺',minNum : 1, maxNum : 3},{name : '海胆皮',minNum : 3, maxNum : 5}],
    },
    '披甲鱼人' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 14,
        hp : 80,
        atk : 25,
        def : 15,
        exp : 50,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：鱼蟹锤',minNum : 3, maxNum : 1},{name : '图纸：刺壳甲',minNum : 3, maxNum : 1},{name : '图纸：鳞枪',minNum : 8, maxNum : 1},{name : '图纸：蓝龟板甲',minNum : 8, maxNum : 1},{name : '鱼人鳞片',minNum : 3, maxNum : 4},{name : '鱼人牙齿',minNum : 1, maxNum : 3},{name : '鱼人眼球',minNum : 0, maxNum : 2}],
    },
    '铁甲海龟' : {
        tags : ['野兽'],
        atkTime : '日',
        atkProb : 10,
        level : 15,
        hp : 200,
        atk : 20,
        def : 20,
        exp : 80,
        atkSpd : 2,
        type : null,
        items : [{name : '图纸：蓝龟板甲',minNum : 8, maxNum : 1},{name : '海龟壳',minNum : 1, maxNum : 1},{name : '藤壶',minNum : 0, maxNum : 5},{name : '肉',minNum : 1, maxNum : 3}],
    },
    '蓝鳞海蛇' : {
        tags : ['野兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 16,
        hp : 200,
        atk : 35,
        def : 5,
        exp : 100,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：碧水枪',minNum : 18, maxNum : 1},{name : '图纸：波涛甲',minNum : 18, maxNum : 1},{name : '蓝鳞蛇皮',minNum : 0, maxNum : 1},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '鱼人斥候' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 17,
        hp : 250,
        atk : 35,
        def : 5,
        exp : 120,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：鱼蟹锤',minNum : 3, maxNum : 1},{name : '图纸：刺壳甲',minNum : 3, maxNum : 1},{name : '图纸：鳞枪',minNum : 8, maxNum : 1},{name : '图纸：蓝龟板甲',minNum : 8, maxNum : 1},{name : '鱼人鳞片',minNum : 3, maxNum : 4},{name : '鱼人牙齿',minNum : 1, maxNum : 3},{name : '鱼人眼球',minNum : 0, maxNum : 2}],
    },
    '鱼人战士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 18,
        hp : 300,
        atk : 30,
        def : 10,
        exp : 150,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：鱼蟹锤',minNum : 3, maxNum : 1},{name : '图纸：刺壳甲',minNum : 3, maxNum : 1},{name : '图纸：鳞枪',minNum : 3, maxNum : 1},{name : '图纸：蓝龟板甲',minNum : 3, maxNum : 1},{name : '鱼人鳞片',minNum : 3, maxNum : 4},{name : '鱼人牙齿',minNum : 1, maxNum : 3},{name : '鱼人眼球',minNum : 0, maxNum : 2}],
    },
    '鱼人法师' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 19,
        hp : 200,
        atk : 45,
        def : 3,
        exp : 180,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：鱼蟹锤',minNum : 3, maxNum : 1},{name : '图纸：刺壳甲',minNum : 3, maxNum : 1},{name : '图纸：鳞枪',minNum : 3, maxNum : 1},{name : '图纸：蓝龟板甲',minNum : 3, maxNum : 1},{name : '鱼人鳞片',minNum : 3, maxNum : 4},{name : '鱼人牙齿',minNum : 1, maxNum : 3},{name : '鱼人眼球',minNum : 0, maxNum : 2}],
    },
    '水元素' : {
        tags : ['元素生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 20,
        hp : 500,
        atk : 25,
        def : 5,
        exp : 200,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：碧水枪',minNum : 8, maxNum : 1},{name : '图纸：波涛甲',minNum : 8, maxNum : 1},{name : '元素水',minNum : 1, maxNum : 3},{name : '水之核',minNum : 1, maxNum : 1}],
    },
    '弄潮鱼人' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 5,
        level : 20,
        hp : 1200,
        atk : 50,
        def : 10,
        exp : 500,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：潮汐权杖',minNum : 3, maxNum : 1},{name : '图纸：怒浪重皮',minNum : 13, maxNum : 1},{name : '潮汐之眼',minNum : 1, maxNum : 2},{name : '海浪之鳞',minNum : 1, maxNum : 3},{name : '潮汐之心',minNum : 1, maxNum : 1},{name : '遗忘之魂',minNum : 3, maxNum : 1}],
    },
    '独角海象' : {
        tags : ['魔兽'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 5000,
        atk : 45,
        def : 35,
        exp : 1000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '图纸：潮汐权杖',minNum : 0, maxNum : 1},{name : '图纸：怒浪重皮',minNum : 0, maxNum : 1},{name : '海象角',minNum : 0, maxNum : 1},{name : '海象皮',minNum : 1, maxNum : 3},{name : '海象牙',minNum : 1, maxNum : 2}],
    },
    '鱼人祭司' : {
        tags : ['人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 3500,
        atk : 70,
        def : 10,
        exp : 2000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '图纸：潮汐权杖',minNum : 0, maxNum : 1},{name : '图纸：怒浪重皮',minNum : 1, maxNum : 1},{name : '神性结晶',minNum : 1, maxNum : 2},{name : '遗忘之魂',minNum : 1, maxNum : 1},{name : '蓝光鳞片',minNum : 1, maxNum : 3},{name : '光辉鱼眼',minNum : 1, maxNum : 2},{name : '冰凉鱼油',minNum : 0, maxNum : 1}],
    },
    '血肉幽灵船' : {
        tags : ['不死族', '污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 6000,
        atk : 70,
        def : 50,
        exp : 2500,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '遗忘之魂',minNum : 1, maxNum : 1},{name : '影魔传说',minNum : 500, maxNum : 1},{name : '变异核心',minNum : 100, maxNum : 100}],
    },
    '水元素领主' : {
        tags : ['元素生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 20,
        hp : 20000,
        atk : 20,
        def : 5,
        exp : 5000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '20级武器打孔石',minNum : 1, maxNum : 3},{name : '20级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：2点',minNum : 1, maxNum : 1}],
    },

    '大史莱姆' : {
        tags : ['魔物','史莱姆'],
        atkTime : '日',
        atkProb : 5,
        level : 21,
        hp : 500,
        atk : 45,
        def : 5,
        exp : 100,
        atkSpd : 2,
        type : null,
        items : [{name : '位面坐标：粘液',minNum : 98, maxNum : 1},{name : '图纸：战刀',minNum : 3, maxNum : 1},{name : '图纸：柔韧软甲',minNum : 3, maxNum : 1},{name : '粘液',minNum : 5, maxNum : 8},{name : '史莱姆精华',minNum : 1, maxNum : 3}, {name : '史莱姆核心',minNum : 1, maxNum : 1}, {name : '坚韧软皮',minNum : 1, maxNum : 3}],
    },
    '哥布林战士' : {
        tags : ['人型生物','哥布林'],
        atkTime : '夜',
        atkProb : 5,
        level : 22,
        hp : 550,
        atk : 50,
        def : 5,
        exp : 150,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：战刀',minNum : 3, maxNum : 1},{name : '图纸：柔韧软甲',minNum : 3, maxNum : 1},{name : '哥布林手爪',minNum : 1, maxNum : 2}, {name : '哥布林残刃',minNum : 1, maxNum : 2}, {name : '破口袋',minNum : 1, maxNum : 2}],
    },
    '疾风狼' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 23,
        hp : 600,
        atk : 55,
        def : 10,
        exp : 300,
        atkSpd : 4,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '魔兽骨',minNum : 1, maxNum : 2}, {name : '魔兽皮',minNum : 1, maxNum : 2}, {name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 3}, {name : '魔兽爪',minNum : 1, maxNum : 2}],
    },
    '暗影猎豹' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 23,
        hp : 550,
        atk : 60,
        def : 5,
        exp : 300,
        atkSpd : 5,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '图纸：元素冲击',minNum : 13, maxNum : 1},{name : '魔兽骨',minNum : 1, maxNum : 2}, {name : '魔兽皮',minNum : 1, maxNum : 2}, {name : '魔核',minNum : 0, maxNum : 1}, {name : '暗影血肉',minNum : 1, maxNum : 2}, {name : '魔兽爪',minNum : 1, maxNum : 2}],
    },
    '剑齿虎' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 24,
        hp : 700,
        atk : 60,
        def : 10,
        exp : 400,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '魔兽骨',minNum : 1, maxNum : 3}, {name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 4}, {name : '虎皮',minNum : 2, maxNum : 4}, {name : '魔兽爪',minNum : 1, maxNum : 2}],
    },
    '角蛇' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 25,
        hp : 700,
        atk : 60,
        def : 15,
        exp : 450,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '图纸：元素冲击',minNum : 8, maxNum : 1},{name : '魔兽骨',minNum : 1, maxNum : 3}, {name : '魔兽皮',minNum : 1, maxNum : 3}, {name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 4}, {name : '角蛇的角',minNum : 1, maxNum : 1},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '疾风猎鹰' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 25,
        hp : 650,
        atk : 65,
        def : 10,
        exp : 450,
        atkSpd : 6,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '图纸：元素冲击',minNum : 13, maxNum : 1},{name : '图纸：兽人战甲',minNum : 13, maxNum : 1},{name : '魔兽骨',minNum : 1, maxNum : 3},{name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 4}, {name : '魔兽爪',minNum : 1, maxNum : 2}, {name : '疾风鹰羽',minNum : 2, maxNum : 3}],
    },
    '食人花' : {
        tags : ['植物'],
        atkTime : '全天',
        atkProb : 5,
        level : 26,
        hp : 800,
        atk : 60,
        def : 5,
        exp : 500,
        atkSpd : 2,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '图纸：兽人战甲',minNum : 8, maxNum : 1},{name : '血肉花蕊',minNum : 1, maxNum : 1},{name : '柔韧根茎',minNum : 1, maxNum : 3},{name : '食人花汁',minNum : 1, maxNum : 3}],
    },
    '雷角马' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 5,
        level : 27,
        hp : 800,
        atk : 70,
        def : 10,
        exp : 600,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '图纸：元素冲击',minNum : 3, maxNum : 1},{name : '魔兽骨',minNum : 1, maxNum : 3}, {name : '魔兽皮',minNum : 1, maxNum : 3}, {name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 4}, {name : '雷角',minNum : 1, maxNum : 1}],
    },
    '蝎尾狮' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 28,
        hp : 900,
        atk : 75,
        def : 20,
        exp : 700,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：魔兽锋芒',minNum : 3, maxNum : 1},{name : '图纸：魔兽骨甲',minNum : 3, maxNum : 1},{name : '图纸：元素冲击',minNum : 3, maxNum : 1},{name : '魔兽骨',minNum : 1, maxNum : 3}, {name : '魔兽皮',minNum : 1, maxNum : 3}, {name : '魔核',minNum : 1, maxNum : 1}, {name : '魔兽肉',minNum : 2, maxNum : 4}, {name : '蝎尾狮的尾巴',minNum : 1, maxNum : 1}]
    },
    '半兽人' : {
        tags : ['兽人','人型生物'],
        atkTime : '日',
        atkProb : 5,
        level : 29,
        hp : 1000,
        atk : 80,
        def : 15,
        exp : 800,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：兽人战甲',minNum : 3, maxNum : 1},{name : '兽人之牙',minNum : 1, maxNum : 2}, {name : '兽人之心',minNum : 1, maxNum : 1}],
    },
    '强兽人' : {
        tags : ['兽人','人型生物'],
        atkTime : '日',
        atkProb : 5,
        level : 30,
        hp : 1200,
        atk : 85,
        def : 20,
        exp : 1000,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：兽人战甲',minNum : 3, maxNum : 1},{name : '兽人之牙',minNum : 2, maxNum : 3}, {name : '兽人之心',minNum : 1, maxNum : 2}],
    },
    '晶化幽灵' : {
        tags : ['不死族', '幽灵'],
        atkTime : '夜',
        atkProb : 5,
        level : 30,
        hp : 1000,
        atk : 85,
        def : 25,
        exp : 1200,
        atkSpd : 3,
        type : null,
        items : [{name : '紫晶',minNum : 0, maxNum : 1}, {name : '灵魂晶粉',minNum : 1, maxNum : 2}],
    },
    '紫晶巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 4000,
        atk : 100,
        def : 30,
        exp : 2500,
        atkSpd : 2,
        type : '精英',
        items : [{name : '图纸：兽人必须死',minNum : 3, maxNum : 1},{name : '紫晶',minNum : 2, maxNum : 3}, {name : '紫晶之核',minNum : 2, maxNum : 3}, {name : '魔力之源',minNum : 1, maxNum : 1}],
    },
    '兽人酋长' : {
        tags : ['兽人','人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 10000,
        atk : 140,
        def : 25,
        exp : 4000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '图纸：兽人必须死',minNum : 0, maxNum : 1},{name : '图纸：紫晶狂兽神',minNum : 0, maxNum : 1},{name : '兽人之牙',minNum :2, maxNum : 5}, {name : '兽人之心',minNum : 2, maxNum : 3},{name : '疯狂之血',minNum : 1, maxNum : 3}, {name : '疯狂的心',minNum : 1, maxNum : 1}],
    },
    '魔晶巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 10000,
        atk : 150,
        def : 30,
        exp : 6000,
        atkSpd : 2,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '图纸：紫晶狂兽神',minNum : 0, maxNum : 1},{name : '技能石：晶甲守护',minNum : 1, maxNum : 3},{name : '神性结晶',minNum : 1, maxNum : 3},{name : '神性紫晶',minNum : 1, maxNum : 2},{name : '神性枢纽',minNum : 1, maxNum : 3},],
    },
    '扭曲晶魂' : {
        tags : ['不死族', '幽灵', '污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 11000,
        atk : 155,
        def : 40,
        exp : 6500,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 200, maxNum : 1},{name : '变异核心',minNum : 200, maxNum : 200}],
    },
    '完整的宝石巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 30,
        hp : 11000,
        atk : 155,
        def : 40,
        exp : 6500,
        atkSpd : 3,
        type : '神话',
        items : getGemByLevel(21),
    },
    '利维坦幼体' : {
        tags : ['魔物', '巨型生物'],
        atkTime : '日',
        atkProb : 0,
        level : 30,
        hp : 35000,
        atk : 100,
        def : 30,
        exp : 25000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '30级武器打孔石',minNum : 1, maxNum : 3},{name : '30级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：4点',minNum : 1, maxNum : 1}],
    },


    '强酸史莱姆' : {
        tags : ['魔物','史莱姆'],
        atkTime : '日',
        atkProb : 5,
        level : 31,
        hp : 1000,
        atk : 105,
        def : 30,
        exp : 1300,
        atkSpd : 2,
        type : null,
        items : [{name : '位面坐标：粘液',minNum : 98, maxNum : 1},{name : '图纸：强酸利刃',minNum : 3, maxNum : 1},{name : '图纸：强韧重甲',minNum : 3, maxNum : 1},{name : '史莱姆精华',minNum : 1, maxNum : 3},{name : '强酸粘液',minNum : 1, maxNum : 3},{name : '酸性软皮',minNum : 1, maxNum : 2}],
    },
    '重装哥布林' : {
        tags : ['人型生物','哥布林'],
        atkTime : '夜',
        atkProb : 5,
        level : 31,
        hp : 1100,
        atk : 110,
        def : 40,
        exp : 1300,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：强酸利刃',minNum : 3, maxNum : 1},{name : '图纸：强韧重甲',minNum : 3, maxNum : 1},{name : '战刀残片',minNum : 1, maxNum : 2},{name : '重甲零件',minNum : 1, maxNum : 2}],
    },
    '哥布林骑士' : {
        tags : ['人型生物','哥布林'],
        atkTime : '夜',
        atkProb : 5,
        level : 32,
        hp : 1200,
        atk : 115,
        def : 30,
        exp : 1350,
        atkSpd : 4,
        type : null,
        items : [{name : '图纸：毒刺铠甲',minNum : 3, maxNum : 1},{name : '图纸：强酸利刃',minNum : 3, maxNum : 1},{name : '狼鞍',minNum : 1, maxNum : 1},{name : '战刀残片',minNum : 1, maxNum : 2}],
    },
    '哥布林祭司' : {
        tags : ['人型生物','哥布林'],
        atkTime : '夜',
        atkProb : 5,
        level : 32,
        hp : 1100,
        atk : 130,
        def : 10,
        exp : 1350,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：御灵权杖',minNum : 3, maxNum : 1},{name : '骨头杖',minNum : 1, maxNum : 2},{name : '骨头项链',minNum : 1, maxNum : 2}],
    },
    '刺蛇' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 33,
        hp : 1300,
        atk : 120,
        def : 25,
        exp : 1400,
        atkSpd : 5,
        type : null,
        items : [{name : '图纸：御灵权杖',minNum : 3, maxNum : 1},{name : '图纸：毒刺铠甲',minNum : 3, maxNum : 1},{name : '骨刺',minNum : 1, maxNum : 3},{name : '毒牙',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 1, maxNum : 2},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '幽灵蛛' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 33,
        hp : 1300,
        atk : 120,
        def : 30,
        exp : 1400,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：御灵权杖',minNum : 3, maxNum : 1},{name : '图纸：毒刺铠甲',minNum : 3, maxNum : 1},{name : '幽灵蛛丝',minNum : 1, maxNum : 2},{name : '幽灵毒囊',minNum : 1, maxNum : 1}],
    },
    '死神蝎' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 34,
        hp : 1200,
        atk : 125,
        def : 30,
        exp : 1450,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：毒刺铠甲',minNum : 3, maxNum : 1},{name : '图纸：亚龙皮甲',minNum : 3, maxNum : 1},{name : '剧毒尾刺',minNum : 1, maxNum : 2},{name : '重壳',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 1, maxNum : 2}],
    },
    '荒原狼' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 34,
        hp : 1400,
        atk : 120,
        def : 30,
        exp : 1450,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荒原战刀',minNum : 3, maxNum : 1},{name : '巨爪',minNum : 1, maxNum : 2},{name : '巨牙',minNum : 1, maxNum : 3},{name : '魔兽肉',minNum : 2, maxNum : 4}],
    },
    '厚皮蜥' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 35,
        hp : 1700,
        atk : 115,
        def : 40,
        exp : 1500,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荒原战刀',minNum : 3, maxNum : 1},{name : '图纸：亚龙皮甲',minNum : 3, maxNum : 1},{name : '重皮',minNum : 2, maxNum : 3},{name : '巨爪',minNum : 1, maxNum : 3},{name : '巨牙',minNum : 1, maxNum : 3},{name : '魔兽肉',minNum : 2, maxNum : 4}],
    },
    '迅猛龙' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 36,
        hp : 1600,
        atk : 130,
        def : 30,
        exp : 1600,
        atkSpd : 4,
        type : null,
        items : [{name : '图纸：荒原战刀',minNum : 3, maxNum : 1},{name : '图纸：亚龙皮甲',minNum : 3, maxNum : 1},{name : '重皮',minNum : 1, maxNum : 2},{name : '巨爪',minNum : 1, maxNum : 2},{name : '巨牙',minNum : 1, maxNum : 3},{name : '魔兽肉',minNum : 2, maxNum : 4}],
    },
    '荒龙' : {
        tags : ['魔兽','龙','巨型生物'],
        atkTime : '夜',
        atkProb : 5,
        level : 36,
        hp : 1900,
        atk : 120,
        def : 50,
        exp : 1600,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荒原战刀',minNum : 3, maxNum : 1},{name : '图纸：亚龙皮甲',minNum : 3, maxNum : 1},{name : '荒芜之核',minNum : 1, maxNum : 1},{name : '亚龙鳞',minNum : 1, maxNum : 2},{name : '亚龙肉',minNum : 1, maxNum : 2}],
    },
    '青牙兽' : {
        tags : ['魔兽','巨型生物'],
        atkTime : '夜',
        atkProb : 5,
        level : 37,
        hp : 1800,
        atk : 130,
        def : 40,
        exp : 1700,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荒原战刀',minNum : 3, maxNum : 1},{name : '图纸：亚龙皮甲',minNum : 3, maxNum : 1},{name : '青牙',minNum : 1, maxNum : 2},{name : '青牙兽皮',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 2, maxNum : 3}],
    },
    '黄酮蟒' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 5,
        level : 38,
        hp : 1700,
        atk : 130,
        def : 40,
        exp : 1800,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亚龙皮甲',minNum : 3, maxNum : 1},{name : '黄酮鳞',minNum : 1, maxNum : 3},{name : '黄酮胆',minNum : 0, maxNum : 1},{name : '魔兽肉',minNum : 1, maxNum : 2},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '地牙野猪' : {
        tags : ['魔兽','巨型生物'],
        atkTime : '夜',
        atkProb : 5,
        level : 39,
        hp : 2100,
        atk : 140,
        def : 50,
        exp : 1900,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：大地兽骨锤',minNum : 3, maxNum : 1},{name : '图纸：大地兽骨甲',minNum : 3, maxNum : 1},{name : '大地之牙',minNum : 1, maxNum : 2},{name : '大地之皮',minNum : 1, maxNum : 2},{name : '魔兽肉',minNum : 2, maxNum : 3}],
    },
    '大地熊' : {
        tags : ['魔兽','巨型生物'],
        atkTime : '夜',
        atkProb : 5,
        level : 39,
        hp : 2200,
        atk : 145,
        def : 55,
        exp : 1900,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：大地兽骨锤',minNum : 3, maxNum : 1},{name : '图纸：大地兽骨甲',minNum : 3, maxNum : 1},{name : '大地之牙',minNum : 1, maxNum : 2},{name : '大地之皮',minNum : 1, maxNum : 3},{name : '魔兽肉',minNum : 2, maxNum : 4}],
    },
    '氏族兽人' : {
        tags : ['兽人','人型生物'],
        atkTime : '日',
        atkProb : 5,
        level : 40,
        hp : 2400,
        atk : 150,
        def : 30,
        exp : 2000,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：大地兽骨锤',minNum : 3, maxNum : 1},{name : '图纸：大地兽骨甲',minNum : 3, maxNum : 1},{name : '氏族旗帜',minNum : 1, maxNum : 2},{name : '兽人獠牙',minNum : 1, maxNum : 2}],
    },
    '五彩魔蛟' : {
        tags : ['魔兽','巨型生物'],
        atkTime : '夜',
        atkProb : 0,
        level : 40,
        hp : 8000,
        atk : 170,
        def : 70,
        exp : 5000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：闪耀骑士剑',minNum : 0, maxNum : 1},{name : '五彩蛟麟',minNum : 2, maxNum : 3},{name : '魔蛟精血',minNum : 1, maxNum : 2},{name : '魔蛟骨髓',minNum : 1, maxNum : 2}],
    },
    '死亡骑士' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 15000,
        atk : 200,
        def : 80,
        exp : 8000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '图纸：闪耀骑士剑',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 1, maxNum : 1},{name : '不灭灵魂',minNum : 1, maxNum : 1},{name : '骑士颅骨',minNum : 1, maxNum : 1},{name : '残破徽章',minNum : 1, maxNum : 1},{name : '魔餍魂核',minNum : 1, maxNum : 1}],
    },
    '荒芜亚龙' : {
        tags : ['魔兽','龙','巨型生物'],
        atkTime : '日',
        atkProb : 0,
        level : 40,
        hp : 20000,
        atk : 260,
        def : 150,
        exp : 10000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '图纸：狰狞巨兽',minNum : 0, maxNum : 1},{name : '技能石：荒芜大地',minNum : 1, maxNum : 5},{name : '神性结晶',minNum : 2, maxNum : 3},{name : '荒芜核心',minNum : 1, maxNum : 1},{name : '荒芜麟爪',minNum : 1, maxNum : 2},{name : '亚龙肉',minNum : 2, maxNum : 4}],
    },
    '绿龙幼崽' : {
        tags : ['龙','巨型生物'],
        atkTime : '日',
        atkProb : 0,
        level : 40,
        hp : 25000,
        atk : 270,
        def : 110,
        exp : 12000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '图纸：狰狞巨兽',minNum : 1, maxNum : 1},{name : '技能石：威吓',minNum : 1, maxNum : 1},{name : '神性结晶',minNum : 2, maxNum : 3},{name : '龙晶',minNum : 0, maxNum : 1},{name : '幼龙鳞',minNum : 1, maxNum : 3},{name : '幼龙皮',minNum : 1, maxNum : 3},{name : '巨龙血脉',minNum : 18, maxNum : 1}],
    },
    '无名肉山' : {
        tags : ['污染','巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 22000,
        atk : 260,
        def : 100,
        exp : 12000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 100, maxNum : 1},{name : '变异核心',minNum : 500, maxNum : 500}],
    },
    '无瑕的宝石巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 40,
        hp : 22000,
        atk : 260,
        def : 100,
        exp : 12000,
        atkSpd : 3,
        type : '神话',
        items : getGemByLevel(31),
    },
    '比蒙巨兽' : {
        tags : ['魔兽','人型生物','巨型生物'],
        atkTime : '日',
        atkProb : 0,
        level : 40,
        hp : 70000,
        atk : 170,
        def : 70,
        exp : 50000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '40级武器打孔石',minNum : 1, maxNum : 3},{name : '40级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：8点',minNum : 1, maxNum : 1}],
    },

    '骷髅战士' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 41,
        hp : 2500,
        atk : 160,
        def : 20,
        exp : 2000,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：僵尸剑',minNum : 3, maxNum : 1},{name : '图纸：僵尸甲',minNum : 3, maxNum : 1},{name : '骸骨',minNum : 1, maxNum : 3},{name : '亡灵骨刀',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '骷髅法师' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 42,
        hp : 2300,
        atk : 170,
        def : 10,
        exp : 2100,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：僵尸剑',minNum : 3, maxNum : 1},{name : '图纸：僵尸甲',minNum : 3, maxNum : 1},{name : '骸骨',minNum : 1, maxNum : 3},{name : '亡灵骨杖',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '活尸' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 42,
        hp : 2700,
        atk : 165,
        def : 50,
        exp : 2100,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：僵尸剑',minNum : 3, maxNum : 1},{name : '图纸：僵尸甲',minNum : 3, maxNum : 1},{name : '尸水',minNum : 1, maxNum : 2},{name : '尸核',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '幽魂' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 43,
        hp : 2500,
        atk : 180,
        def : 30,
        exp : 2200,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：灵魂毒刺',minNum : 3, maxNum : 1},{name : '图纸：血肉护甲',minNum : 3, maxNum : 1},{name : '幽魂碎片',minNum : 1, maxNum : 3},{name : '幽魂核心',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '僵尸蟒' : {
        tags : ['不死族', '魔兽'],
        atkTime : '全天',
        atkProb : 5,
        level : 44,
        hp : 3000,
        atk : 180,
        def : 60,
        exp : 2300,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：灵魂毒刺',minNum : 3, maxNum : 1},{name : '图纸：血肉护甲',minNum : 3, maxNum : 1},{name : '尸毒牙',minNum : 1, maxNum : 4},{name : '尸毒蛇皮',minNum : 1, maxNum : 2},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '血肉亡灵' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 44,
        hp : 3500,
        atk : 180,
        def : 50,
        exp : 2300,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：灵魂毒刺',minNum : 3, maxNum : 1},{name : '图纸：血肉护甲',minNum : 3, maxNum : 1},{name : '灵魂血肉',minNum : 1, maxNum : 2},{name : '血肉核心',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '血肉屠夫' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 45,
        hp : 4000,
        atk : 190,
        def : 60,
        exp : 2400,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：灵魂毒刺',minNum : 3, maxNum : 1},{name : '图纸：血肉护甲',minNum : 3, maxNum : 1},{name : '灵魂血肉',minNum : 1, maxNum : 3},{name : '染血屠刀',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '尸巫' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 46,
        hp : 3500,
        atk : 200,
        def : 20,
        exp : 2500,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亡灵之手',minNum : 3, maxNum : 1},{name : '图纸：亡灵石甲',minNum : 3, maxNum : 1},{name : '尸巫法杖',minNum : 1, maxNum : 1},{name : '亡灵法核',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '吸血鬼' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 46,
        hp : 3500,
        atk : 190,
        def : 0,
        suck : 75,
        exp : 2500,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亡灵之手',minNum : 3, maxNum : 1},{name : '图纸：亡灵石甲',minNum : 3, maxNum : 1},{name : '吸血鬼牙',minNum : 1, maxNum : 2},{name : '血族翅膀',minNum : 1, maxNum : 2},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '石像鬼' : {
        tags : ['傀儡'],
        atkTime : '全天',
        atkProb : 5,
        level : 47,
        hp : 4000,
        atk : 180,
        def : 150,
        exp : 2600,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亡灵之手',minNum : 3, maxNum : 1},{name : '图纸：亡灵石甲',minNum : 3, maxNum : 1},{name : '亡灵碎石',minNum : 1, maxNum : 2},{name : '血肉石翼',minNum : 1, maxNum : 2},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '骷髅骑士' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 48,
        hp : 3700,
        atk : 230,
        def : 30,
        exp : 2700,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：怨恨长枪',minNum : 3, maxNum : 1},{name : '图纸：诅咒铠甲',minNum : 3, maxNum : 1},{name : '骷髅马鞍',minNum : 1, maxNum : 1},{name : '骷髅骑枪',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '血魔' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 49,
        hp : 4500,
        atk : 240,
        def : 50,
        exp : 2800,
        suck : 50,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：怨恨长枪',minNum : 3, maxNum : 1},{name : '图纸：诅咒铠甲',minNum : 3, maxNum : 1},{name : '血魔之心',minNum : 1, maxNum : 1},{name : '血魔残骸',minNum : 1, maxNum : 3},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '怨灵' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 50,
        hp : 2500,
        atk : 300,
        def : 20,
        exp : 2900,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：怨恨长枪',minNum : 3, maxNum : 1},{name : '图纸：诅咒铠甲',minNum : 3, maxNum : 1},{name : '怨恨之魂',minNum : 1, maxNum : 2},{name : '诅咒核心',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 98, maxNum : 1},{name : '不灭灵魂',minNum : 98, maxNum : 1}],
    },
    '巫妖' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 20000,
        atk : 280,
        def : 30,
        exp : 9000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '不死印记',minNum : 0, maxNum : 1},{name : '不灭灵魂',minNum : 0, maxNum : 1},{name : '死灵之书',minNum : 1, maxNum : 1},{name : '灵魂护符',minNum : 1, maxNum : 1}],
    },
    '憎恶' : {
        tags : ['不死族', '人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 30000,
        atk : 250,
        def : 70,
        exp : 9000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '不死印记',minNum : 0, maxNum : 1},{name : '不灭灵魂',minNum : 0, maxNum : 1},{name : '特制尸油',minNum : 1, maxNum : 3}],
    },
    '大剑士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 50,
        hp : 40000,
        atk : 300,
        def : 70,
        exp : 12000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '精铁断剑',minNum : 1, maxNum : 1},{name : '大剑士徽章',minNum : 1, maxNum : 1}],
    },
    '青年黑龙' : {
        tags : ['龙', '巨型生物'],
        atkTime : '日',
        atkProb : 0,
        level : 50,
        hp : 50000,
        atk : 400,
        def : 150,
        exp : 15000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '技能石：威吓',minNum : 1, maxNum : 3},{name : '神性结晶',minNum : 2, maxNum : 4},{name : '龙晶',minNum : 1, maxNum : 1},{name : '龙鳞',minNum : 2, maxNum : 4},{name : '龙皮',minNum : 1, maxNum : 3},{name : '龙血',minNum : 2, maxNum : 3},{name : '巨龙血脉',minNum : 1, maxNum : 1}],
    },
    '诅咒凶魂' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 40000,
        atk : 300,
        def : 50,
        exp : 15000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '技能石：灵魂折磨',minNum : 1, maxNum : 1},{name : '神性结晶',minNum : 2, maxNum : 4},{name : '不死印记',minNum : 1, maxNum : 1},{name : '不灭灵魂',minNum : 1, maxNum : 1},{name : '诅咒魂晶',minNum : 1, maxNum : 1}],
    },
    '死离人形' : {
        tags : ['污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 50000,
        atk : 350,
        def : 100,
        exp : 15000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 50, maxNum : 1},{name : '变异核心',minNum : 1000, maxNum : 1000}],
    },
    '完美的宝石巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 50000,
        atk : 350,
        def : 100,
        exp : 15000,
        atkSpd : 3,
        type : '神话',
        items : getGemByLevel(41),
    },
    '龙巫妖' : {
        tags : ['不死族', '龙'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 150000,
        atk : 250,
        def : 70,
        exp : 90000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '50级武器打孔石',minNum : 1, maxNum : 3},{name : '50级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：16点',minNum : 1, maxNum : 1}],
    },


    '骷髅剑士' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 51,
        hp : 4000,
        atk : 270,
        def : 30,
        exp : 3000,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荒骨之咬',minNum : 3, maxNum : 1},{name : '图纸：赐福甲胄',minNum : 3, maxNum : 1},{name : '精密骨骼',minNum : 1, maxNum : 3},{name : '骨质大剑',minNum : 1, maxNum : 1}],
    },
    '神选战士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 5,
        human : true,
        level : 52,
        hp : 5000,
        atk : 280,
        def : 50,
        exp : 3050,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荒骨之咬',minNum : 3, maxNum : 1},{name : '图纸：赐福甲胄',minNum : 3, maxNum : 1},{name : '战士徽章',minNum : 1, maxNum : 1},{name : '赐福铠甲',minNum : 1, maxNum : 1}],
    },
    '巨魔骷髅' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        human : true,
        level : 54,
        hp : 5500,
        atk : 300,
        def : 30,
        exp : 3200,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荒骨之咬',minNum : 3, maxNum : 1},{name : '图纸：赐福甲胄',minNum : 3, maxNum : 1},{name : '巨魔骨矛',minNum : 1, maxNum : 1},{name : '巨魔颅骨',minNum : 1, maxNum : 1}],
    },
    '神选法师' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 5,
        human : true,
        level : 55,
        hp : 4000,
        atk : 350,
        def : 10,
        exp : 3250,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：魔法弓',minNum : 3, maxNum : 1},{name : '图纸：魔法斗篷',minNum : 3, maxNum : 1},{name : '魔法宝石',minNum : 1, maxNum : 1},{name : '法师帽',minNum : 1, maxNum : 1}],
    },
    '神选游侠' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 5,
        human : true,
        level : 56,
        hp : 5000,
        atk : 300,
        def : 20,
        exp : 3300,
        atkSpd : 4,
        type : null,
        items : [{name : '图纸：魔法弓',minNum : 3, maxNum : 1},{name : '图纸：魔法斗篷',minNum : 3, maxNum : 1},{name : '精密断弓',minNum : 1, maxNum : 1},{name : '附魔箭矢',minNum : 1, maxNum : 3}],
    },
    '亡灵蠕虫' : {
        tags : ['不死族', '魔兽'],
        atkTime : '全天',
        atkProb : 5,
        level : 57,
        hp : 6000,
        atk : 300,
        def : 100,
        exp : 3350,
        atkSpd : 2,
        type : null,
        items : [{name : '图纸：魔法弓',minNum : 3, maxNum : 1},{name : '图纸：魔法斗篷',minNum : 3, maxNum : 1},{name : '灰白的皮',minNum : 1, maxNum : 3},{name : '枯朽粘液',minNum : 2, maxNum : 5}],
    },
    '神选骑士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 5,
        human : true,
        level : 58,
        hp : 6000,
        atk : 350,
        def : 50,
        exp : 3400,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：元素之灵',minNum : 3, maxNum : 1},{name : '图纸：元素庇佑',minNum : 3, maxNum : 1},{name : '赐福长枪',minNum : 1, maxNum : 1},{name : '骑士徽章',minNum : 1, maxNum : 1}],
    },
    '鲜血巨魔' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 59,
        hp : 10000,
        atk : 350,
        def : 0,
        suck : 70,
        exp : 3450,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：元素之灵',minNum : 3, maxNum : 1},{name : '图纸：元素庇佑',minNum : 3, maxNum : 1},{name : '鲜血图腾',minNum : 1, maxNum : 1},{name : '鲜血骨爪',minNum : 1, maxNum : 2}],
    },
    '女巫' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 5,
        human : true,
        level : 60,
        hp : 5000,
        atk : 400,
        def : 20,
        exp : 3500,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：元素之灵',minNum : 3, maxNum : 1},{name : '图纸：元素庇佑',minNum : 3, maxNum : 1},{name : '元素印记',minNum : 1, maxNum : 1},{name : '女巫徽章',minNum : 1, maxNum : 1}],
    },
    '神选冠军骑士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 60,
        hp : 50000,
        atk : 500,
        def : 150,
        exp : 15000,
        atkSpd : 4,
        type : '精英',
        items : [{name : '冠军凭证',minNum : 1, maxNum : 1},{name : '神赐徽章',minNum : 1, maxNum : 1},{name : '赐福神力',minNum : 1, maxNum : 1}],
    },
    '神眷圣骑士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 60,
        hp : 80000,
        atk : 650,
        def : 180,
        exp : 20000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '神圣重锤',minNum : 1, maxNum : 1},{name : '神赐徽章',minNum : 1, maxNum : 1},{name : '赐福神力',minNum : 1, maxNum : 1}],
    },
    '幽灵龙' : {
        tags : ['龙', '巨型生物', '不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '技能石：生死转换',minNum : 8, maxNum : 1},{name : '神性结晶',minNum : 2, maxNum : 5},{name : '龙魂',minNum : 1, maxNum : 1},{name : '巨龙之殇',minNum : 1, maxNum : 1}],
    },
    '腐烂吸血鬼' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        suck : 100,
        def : 0,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 8, maxNum : 1},{name : '变异核心',minNum : 2000, maxNum : 2000}],
    },
    '璀璨的宝石巨人' : {
        tags : ['傀儡','人型生物', '巨型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 60,
        hp : 150000,
        atk : 600,
        def : 200,
        exp : 30000,
        atkSpd : 3,
        type : '神话',
        items : getGemByLevel(51),
    },
    '六翼天使' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 60,
        hp : 350000,
        atk : 500,
        def : 150,
        exp : 150000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '60级武器打孔石',minNum : 1, maxNum : 3},{name : '60级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：32点',minNum : 1, maxNum : 1}],
    },


    '苦修士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        human : true,
        level : 61,
        hp : 8000,
        atk : 400,
        def : 30,
        exp : 3550,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：狂信战锤',minNum : 3, maxNum : 1},{name : '图纸：信仰卫士',minNum : 3, maxNum : 1},{name : '负重锁链',minNum : 1, maxNum : 1},{name : '染血锁环',minNum : 1, maxNum : 1}],
    },
    '狂信徒' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        human : true,
        level : 61,
        hp : 6000,
        atk : 420,
        def : 20,
        exp : 3550,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：狂信战锤',minNum : 3, maxNum : 1},{name : '图纸：信仰卫士',minNum : 3, maxNum : 1},{name : '狂信徽章',minNum : 1, maxNum : 1},{name : '信仰雕像',minNum : 1, maxNum : 1}],
    },
    '巡游卫士' : {
        tags : ['人型生物'],
        atkTime : '全天',
        atkProb : 25,
        human : true,
        level : 62,
        hp : 8000,
        atk : 430,
        def : 50,
        exp : 3600,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：狂信战锤',minNum : 3, maxNum : 1},{name : '图纸：信仰卫士',minNum : 3, maxNum : 1},{name : '卫士之盾',minNum : 1, maxNum : 1},{name : '卫士徽章',minNum : 1, maxNum : 1}],
    },
    '哨塔射手' : {
        tags : ['人型生物'],
        atkTime : '全天',
        atkProb : 10,
        human : true,
        level : 63,
        hp : 6000,
        atk : 450,
        def : 10,
        exp : 3650,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：狂信战锤',minNum : 3, maxNum : 1},{name : '图纸：信仰卫士',minNum : 3, maxNum : 1},{name : '制式战弓',minNum : 1, maxNum : 1},{name : '制式箭矢',minNum : 1, maxNum : 3}],
    },
    '隐秘猎人' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        human : true,
        level : 64,
        hp : 6000,
        atk : 500,
        def : 20,
        exp : 3700,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：狩猎长刀',minNum : 3, maxNum : 1},{name : '图纸：猎人皮甲',minNum : 3, maxNum : 1},{name : '猎人陷阱',minNum : 1, maxNum : 2},{name : '鲜血毛皮',minNum : 1, maxNum : 3}],
    },
    '阴影杀手' : {
        tags : ['人型生物'],
        atkTime : '夜',
        atkProb : 10,
        human : true,
        level : 65,
        hp : 5500,
        atk : 550,
        def : 10,
        exp : 3750,
        atkSpd : 5,
        type : null,
        items : [{name : '图纸：狩猎长刀',minNum : 3, maxNum : 1},{name : '图纸：猎人皮甲',minNum : 3, maxNum : 1},{name : '淬毒匕首',minNum : 1, maxNum : 1},{name : '精铁钩爪',minNum : 1, maxNum : 2}],
    },
    '水生战兽' : {
        tags : ['魔兽','巨型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 66,
        hp : 10000,
        atk : 450,
        def : 80,
        exp : 3800,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：狩猎长刀',minNum : 3, maxNum : 1},{name : '图纸：猎人皮甲',minNum : 3, maxNum : 1},{name : '浸水皮',minNum : 1, maxNum : 3},{name : '战兽爪',minNum : 1, maxNum : 3}],
    },
    '白鳞水蟒' : {
        tags : ['魔兽'],
        atkTime : '夜',
        atkProb : 10,
        level : 67,
        hp : 10000,
        atk : 480,
        def : 100,
        exp : 3850,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：狩猎长刀',minNum : 3, maxNum : 1},{name : '图纸：猎人皮甲',minNum : 3, maxNum : 1},{name : '白鳞',minNum : 1, maxNum : 3},{name : '白皮',minNum : 1, maxNum : 3},{name : '蛇胆',minNum : 1, maxNum : 1}],
    },
    '鹰身女妖' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        level : 68,
        hp : 10000,
        atk : 600,
        def : 50,
        exp : 3900,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荣耀魔剑',minNum : 3, maxNum : 1},{name : '图纸：妖风圣衣',minNum : 3, maxNum : 1},{name : '女妖手爪',minNum : 1, maxNum : 2},{name : '女妖翅膀',minNum : 1, maxNum : 2},{name : '女妖心脏',minNum : 1, maxNum : 1}],
    },
    '飓风龙兽' : {
        tags : ['魔兽'],
        atkTime : '日',
        atkProb : 10,
        level : 69,
        hp : 12000,
        atk : 520,
        def : 100,
        exp : 3950,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荣耀魔剑',minNum : 3, maxNum : 1},{name : '图纸：妖风圣衣',minNum : 3, maxNum : 1},{name : '飓风魔核',minNum : 1, maxNum : 1},{name : '飓风魔皮',minNum : 1, maxNum : 3},{name : '龙兽肝脏',minNum : 1, maxNum : 1}],
    },
    '荣耀骑士' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        human : true,
        level : 70,
        hp : 15000,
        atk : 500,
        def : 200,
        exp : 4000,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：荣耀魔剑',minNum : 3, maxNum : 1},{name : '图纸：妖风圣衣',minNum : 3, maxNum : 1},{name : '荣耀长枪',minNum : 1, maxNum : 1},{name : '荣耀马鞍',minNum : 1, maxNum : 1}],
    },
    '大神官' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 10,
        human : true,
        level : 70,
        hp : 8000,
        atk : 400,
        def : 50,
        exp : 4000,
        atkSpd : 2,
        type : null,
        items : [{name : '图纸：荣耀魔剑',minNum : 3, maxNum : 1},{name : '图纸：妖风圣衣',minNum : 3, maxNum : 1},{name : '神圣连枷',minNum : 1, maxNum : 1},{name : '神圣长袍',minNum : 1, maxNum : 1}],
    },
    '战争领主' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 70,
        hp : 80000,
        atk : 700,
        def : 250,
        exp : 20000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '水晶空瓶',minNum : 1, maxNum : 2},{name : '战争号角',minNum : 0, maxNum : 1}],
    },
    '沙暴地龙' : {
        tags : ['魔兽','巨型生物','龙'],
        atkTime : '日',
        atkProb : 0,
        level : 70,
        hp : 100000,
        atk : 800,
        def : 300,
        exp : 30000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '沙尘印记',minNum : 1, maxNum : 1},{name : '暴风龙眼',minNum : 1, maxNum : 1}],
    },
    '使徒行者' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 70,
        hp : 150000,
        atk : 800,
        def : 100,
        exp : 40000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：后院',minNum : 3, maxNum : 1},{name : '技能石：圣光之心',minNum : 1, maxNum : 3},{name : '神性结晶',minNum : 3, maxNum : 5}],
    },
    '深渊领主' : {
        tags : ['人型生物','污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 70,
        hp : 180000,
        atk : 900,
        suck : 30,
        def : 300,
        exp : 40000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : 3, maxNum : 1},{name : '影魔传说',minNum : 0, maxNum : 1},{name : '变异核心',minNum : 4000, maxNum : 4000}],
    },
    '神降祭祀' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 70,
        hp : 600000,
        atk : 700,
        def : 100,
        exp : 200000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '70级武器打孔石',minNum : 1, maxNum : 3},{name : '70级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：64点',minNum : 1, maxNum : 1}],
    },

    '怒焰亚龙' : {
        tags : ['魔兽','巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 72,
        hp : 20000,
        atk : 500,
        def : 200,
        exp : 4200,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亚龙之咬',minNum : 3, maxNum : 1},{name : '图纸：亚龙鳞甲',minNum : 3, maxNum : 1},{name : '烈焰亚龙牙',minNum : 1, maxNum : 3},{name : '亚龙鳞',minNum : 5, maxNum : 8},{name : '亚龙肉',minNum : 2, maxNum : 3}],
    },
    '冰霜亚龙' : {
        tags : ['魔兽','巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 74,
        hp : 23000,
        atk : 550,
        def : 200,
        exp : 4400,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亚龙之咬',minNum : 3, maxNum : 1},{name : '图纸：亚龙鳞甲',minNum : 3, maxNum : 1},{name : '冰霜亚龙牙',minNum : 1, maxNum : 3},{name : '亚龙鳞',minNum : 5, maxNum : 8},{name : '亚龙肉',minNum : 2, maxNum : 3}],
    },
    '毒液亚龙' : {
        tags : ['魔兽','巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 76,
        hp : 26000,
        atk : 550,
        def : 200,
        exp : 4600,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亚龙之咬',minNum : 3, maxNum : 1},{name : '图纸：亚龙鳞甲',minNum : 3, maxNum : 1},{name : '剧毒亚龙牙',minNum : 1, maxNum : 3},{name : '亚龙鳞',minNum : 5, maxNum : 8},{name : '亚龙肉',minNum : 2, maxNum : 3}],
    },
    '黑暗亚龙' : {
        tags : ['魔兽','巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 78,
        hp : 30000,
        atk : 600,
        def : 300,
        exp : 4800,
        atkSpd : 3,
        type : null,
        items : [{name : '图纸：亚龙之咬',minNum : 3, maxNum : 1},{name : '图纸：亚龙鳞甲',minNum : 3, maxNum : 1},{name : '黑暗亚龙牙',minNum : 1, maxNum : 3},{name : '亚龙鳞',minNum : 5, maxNum : 8},{name : '亚龙肉',minNum : 2, maxNum : 3}],
    },
    '红龙' : {
        tags : ['巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 80,
        hp : 100000,
        atk : 800,
        def : 300,
        exp : 30000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：龙魂之力',minNum : 3, maxNum : 1},{name : '图纸：龙魂守护',minNum : 3, maxNum : 1},{name : '龙晶',minNum : 1, maxNum : 1},{name : '龙鳞',minNum : 3, maxNum : 5},{name : '龙皮',minNum : 2, maxNum : 4},{name : '龙血',minNum : 3, maxNum : 5},{name : '巨龙血脉',minNum : 1, maxNum : 1},{name : '红龙魂',minNum : 1, maxNum : 1}],
    },
    '蓝龙' : {
        tags : ['巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 80,
        hp : 70000,
        atk : 650,
        def : 100,
        exp : 30000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：龙魂之力',minNum : 3, maxNum : 1},{name : '图纸：龙魂守护',minNum : 3, maxNum : 1},{name : '龙晶',minNum : 1, maxNum : 1},{name : '龙鳞',minNum : 3, maxNum : 5},{name : '龙皮',minNum : 2, maxNum : 4},{name : '龙血',minNum : 3, maxNum : 5},{name : '巨龙血脉',minNum : 1, maxNum : 1},{name : '蓝龙魂',minNum : 1, maxNum : 1}],
    },
    '绿龙' : {
        tags : ['巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 80,
        hp : 90000,
        atk : 700,
        def : 350,
        exp : 30000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：龙魂之力',minNum : 3, maxNum : 1},{name : '图纸：龙魂守护',minNum : 3, maxNum : 1},{name : '龙晶',minNum : 1, maxNum : 1},{name : '龙鳞',minNum : 3, maxNum : 5},{name : '龙皮',minNum : 2, maxNum : 4},{name : '龙血',minNum : 3, maxNum : 5},{name : '巨龙血脉',minNum : 1, maxNum : 1},{name : '绿龙魂',minNum : 1, maxNum : 1}],
    },
    '黑龙' : {
        tags : ['巨型生物','龙'],
        atkTime : '日',
        atkProb : 10,
        level : 80,
        hp : 120000,
        atk : 600,
        def : 500,
        exp : 30000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '图纸：龙魂之力',minNum : 3, maxNum : 1},{name : '图纸：龙魂守护',minNum : 3, maxNum : 1},{name : '龙晶',minNum : 1, maxNum : 1},{name : '龙鳞',minNum : 3, maxNum : 5},{name : '龙皮',minNum : 2, maxNum : 4},{name : '龙血',minNum : 3, maxNum : 5},{name : '巨龙血脉',minNum : 1, maxNum : 1},{name : '黑龙魂',minNum : 1, maxNum : 1}],
    },
    '五首龙神' : {
        tags : ['巨型生物','神','龙'],
        atkTime : '日',
        atkProb : 0,
        level : 80,
        hp : 300000,
        atk : 700,
        def : 300,
        exp : 100000,
        atkSpd : 5,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '神格', minNum : 1, maxNum : 1},{name : '神血',minNum : 0, maxNum : 1},{name : '技能石：驱散',minNum : 1, maxNum : 3},{name : '神性结晶',minNum : 4, maxNum : 6}],
        text : '弱小神力'
    },
    '龙族吞噬者' : {
        tags : ['巨型生物','神'],
        atkTime : '全天',
        atkProb : 0,
        level : 80,
        hp : 1000000,
        atk : 600,
        def : 400,
        exp : 300000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '80级武器打孔石',minNum : 1, maxNum : 3},{name : '80级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：128点',minNum : 1, maxNum : 1}],
    },


    '无害小动物' : {
        tags : ['野兽'],
        atkTime : '日',
        atkProb : 0,
        level : 90,
        hp : 1,
        atk : 1,
        def : 0,
        exp : 0,
        atkSpd : 3,
        items : [],
        text : '为了避免神界的神殿击杀任务没有目标怪物导致出现BUG而存在的玩意，反正你们遇不到的，神界任务遇到这个拒绝就好了，不过也不会有人去神界刷任务吧，去帝国刷啊！'
    },
    '草木之神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 90,
        hp : 200000,
        atk : 700,
        def : 100,
        exp : 50000,
        atkSpd : 3,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '神格', minNum : 1, maxNum : 1},{name : '草木神力精华', minNum : 1, maxNum : 1},{name : '神血',minNum : 0, maxNum : 1},{name : '技能石：洗涤',minNum : 1, maxNum : 3},{name : '神性结晶',minNum : 3, maxNum : 6}],
        text : '微弱神力'
    },
    '森林之神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 90,
        hp : 250000,
        atk : 800,
        def : 200,
        exp : 80000,
        atkSpd : 3,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '神格', minNum : 1, maxNum : 1},{name : '森林神力精华', minNum : 1, maxNum : 1},{name : '神血',minNum : 0, maxNum : 1},{name : '神性结晶',minNum : 4, maxNum : 6}],
        text : '弱小神力'
    },
    '山脉之神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 90,
        hp : 300000,
        atk : 900,
        def : 100,
        exp : 120000,
        atkSpd : 3,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '神格', minNum : 1, maxNum : 1},{name : '山脉神力精华', minNum : 1, maxNum : 1},{name : '神血',minNum : 0, maxNum : 1},{name : '神性结晶',minNum : 4, maxNum : 7}],
        text : '中等神力'
    },
    '大地之神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 90,
        hp : 400000,
        atk : 850,
        def : 700,
        exp : 150000,
        atkSpd : 3,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '神格', minNum : 1, maxNum : 1},{name : '大地神力精华', minNum : 1, maxNum : 1},{name : '神血',minNum : 0, maxNum : 1},{name : '神性结晶',minNum : 5, maxNum : 7}],
        text : '强大神力'
    },
    '生命之神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 90,
        hp : 600000,
        suck : 30,
        atk : 1000,
        def : 500,
        exp : 200000,
        atkSpd : 3,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '神格', minNum : 1, maxNum : 1},{name : '生命神力精华', minNum : 1, maxNum : 1},{name : '弑神之证', minNum : 1, maxNum : 1},{name : '神血',minNum : 0, maxNum : 1},{name : '神性结晶',minNum : 5, maxNum : 8}],
        text : '主神'
    },
    '远古死神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 90,
        hp : 3000000,
        atk : 800,
        def : 200,
        exp : 800000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '90级武器打孔石',minNum : 1, maxNum : 3},{name : '90级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：256点',minNum : 1, maxNum : 1}],
    },

    ...newMapElements.monsters,

    '水之女神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 100,
        hp : 5000000000,
        atk : 20000,
        def : 10000,
        exp : 0,
        atkSpd : 3,
        notRun : true,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [],
        text : '至高神',
    },
    '狩猎之神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 100,
        hp : 3000000000,
        atk : 30000,
        def : 8000,
        exp : 0,
        atkSpd : 3,
        notRun : true,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [],
        text : '至高神',
    },
    '创世神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 0,
        hp : 100000,
        atk : 0,
        def : 0,
        exp : 0,
        atkSpd : 3,
        notRun : true,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [],
        text : '创世神',
    },
    ...getBatchItem(['剑士','骑士','奥术师','盗贼','野蛮人','猎魔人','游侠','神圣选民','黑暗行者'], {
        tags : ['人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 0,
        hp : 0,
        atk : 0,
        def : 0,
        exp : 0,
        atkSpd : 3,
        items : [],
        isNpc : true,
        text : 'NPC战斗用的职业模板',
    }),
}

//获取所有怪物都掉落的公共掉落物
function getCommItems(type, level, isNpc, tags){
    let items = [...getMonsterRunes(type, level, tags)];
    items.push({name : '机械碎片', minNum : data.race.name.startsWith('机械族') ? -3 : -18, maxNum : 1});
    items.push({name : '机械核心', minNum : data.race.name.startsWith('机械族') ? -100 : -200, maxNum : 1});
    items.push({name : '牵引卷轴', minNum : 18, maxNum : 1});

    if(data.mythCurse === true && !data.inDungeon && !isNpc){
        items.push({name : '神话之力', minNum : 1, maxNum : 1});
    }

    if(festival && festival.monsterItems){
        items = [
            ...items,
            ...festival.monsterItems
        ]
    }
    return items;
}

//获取扭曲怪物的掉落物
function getDistortedItems(){
    const items = [];
    const num = {
        '神话' : 5,
        '传说' : 3,
        '精英' : 2
    };
    const rate = data.battleMonster.type ? num[data.battleMonster.type] || 1 : 1;
    //掉落旧日笔记
    if(randomNum(1,100) <= data.order - 1){
        items.push({name : '旧日笔记', minNum : 1, maxNum : rate});
    }

    return items;
}

//创建一个战斗怪物对象
function createBattleMonster(name, isControl){
    //创建基础属性
    let monster = {
        ...monsterCfgs[name],
        name,
        shield : 0,
        status : [],
        items : [...monsterCfgs[name].items.map(e => ({name : e.name,minNum : e.minNum ,maxNum : e.maxNum})),...getCommItems(monsterCfgs[name].type || '普通', monsterCfgs[name].level, false, monsterCfgs[name].tags)]
    };

    //无限副本特别处理
    if(dungeons[data.world.name] && dungeons[data.world.name].type === 2) {
        if (data.dungeonLevel == null) {
            data.dungeonLevel = 1;
        }

        //每次强化的比例
        let addNum = 0.5 * ((data.level > monsterCfgs[name].level ? parseInt((data.level - monsterCfgs[name].level) / 10) : 0) + 1);

        monster.items = [];
        monster.hp = monster.maxHp = parseInt(monster.hp * (1 + ((data.dungeonLevel - 1) * addNum)));
        monster.atk = parseInt(monster.atk * (1 + ((data.dungeonLevel - 1) * addNum)));
        monster.def = parseInt(monster.def * (1 + ((data.dungeonLevel - 1) * addNum)));
        monster.suck = parseInt((monster.suck || 0) * (1 + ((data.dungeonLevel - 1) * addNum)));
        monster.exp = parseInt(monster.exp * (1 + ((data.dungeonLevel - 1) * addNum)));
    }else{
        //判断神战
        let godBattleDeity = false;
        Object.keys(data.deitys).forEach(deity => {
            if(godBattleDeity){
                return;
            }
            if(data.deitys[deity].godFavor <= godBattle){
                godBattleDeity = deity;
            }
        })
        //进行神战
        if(godBattleDeity && !isControl){
            return {
                ...monsterCfgs[godBattleDeity],
                name : godBattleDeity,
                maxHp : monsterCfgs[godBattleDeity].hp,
                shield : 0,
                status : [],
            };
        }

        //判断变异
        if(variations && !isWorldBoss()){
            //怪物和人物等级差在一定等级以内才能变异
            if(data.level - monsterCfgs[name].level <= variationLevel && randomNum(1,100) <= variationRate){
                const variation = Object.keys(variations).filter(e => variations[e].level <= monsterCfgs[name].level).getRandom();
                if(variation){
                    monster.showName = `${variation}${name}`;
                    monster.atk += variations[variation].atk;
                    monster.def += variations[variation].def;
                    monster.hp += variations[variation].hp;
                    if(!data.dlcOriginal){
                        monster.items = [...monster.items,{name : '变异核心',minNum : variations[variation].num * 3, maxNum : variations[variation].num * 3}]
                    }
                }
            }
        }

        //周目加强
        monster = orderUp(monster);

        //寒影加强
        if(data.race.name.startsWith('寒影') && monsterCfgs[name].level > data.level){
            const levelNum = monsterCfgs[name].level - data.level;
            monster.atk = parseInt(monster.atk * (1 + (0.05 * levelNum)))
            monster.def = parseInt(monster.def * (1 + (0.05 * levelNum)))
            monster.hp = parseInt(monster.hp * (1 + (0.05 * levelNum)))
        }

        //判断神罚
        let flag = false;
        if(!isControl){
            //可以同时触发多个神的神罚
            Object.keys(data.deitys).forEach(deity => {
                //是否触发神罚
                if(data.deitys[deity].godFavor <= minGodFavorMonster){
                    flag = true;
                    //增加怪物属性
                    const num = parseInt((data.deitys[deity].godFavor - minGodFavorMonster)/-100) +1;//神罚属性倍数
                    monster.hp += godMonsterAddAttr.hp * num;
                    monster.atk += godMonsterAddAttr.atk * num;
                    monster.def += godMonsterAddAttr.def * num;
                }
            })
        }

        //通关触发神罚
        if(data.passAll && !isControl){
            //是否触发神罚
            flag = true;
            //增加怪物属性
            const num = parseInt(((-100000 * data.order) - minGodFavorMonster)/-100) +1;//神罚属性倍数
            monster.hp += godMonsterAddAttr.hp * num;
            monster.atk += godMonsterAddAttr.atk * num;
            monster.def += godMonsterAddAttr.def * num;
        }

        //添加神罚前缀
        if(flag){
            monster.showName = `神罚·${monster.showName || name}`;
        }

        //神话诅咒
        if(data.mythCurse === true && !data.inDungeon && !isControl){
            monster.hp *= 5;
            monster.atk *= 2;
            monster.def *= 2;
            monster.items.forEach(e => {
                const names = monsterCfgs[monster.name].items.map(i => i.name);

                if(names.indexOf(e.name) !== -1){
                    e.maxNum += 5;
                    e.minNum += 5;
                    if(e.minNum < 5){
                        e.minNum = 5;
                    }
                }
            })
            monster.showName = `诅咒·${monster.showName || name}`;
            data.mythCurse = false;
        }
    }

    //怪物武装DLC
    if(data.dlcMonsterEquip){
        //穿戴武器
        if(randomNum(1,100) <= 10){
            const filter = Object.keys(elementCfgs).filter(e => elementCfgs[e].isWeapon && !e.includes('盾') && !e.includes('技能石') && elementCfgs[e].level <= monster.level && elementCfgs[e].level >= monster.level - 10);
            if(filter.length > 0){
                const makeItem = filter[0];
                const equip = getEquipQuality(elementCfgs[makeItem].new({name : makeItem, quantity : 1}), true);
                monster.atk += equip.atk;
                monster.def += equip.def;
                monster.hp += equip.hp;
                if(!monster.suck){monster.suck = 0}
                monster.suck += equip.suck;
                monster.weapon = equip;
                monster.status.push(getStatus('持有武器'));
            }
        }
        //穿戴护甲
        if(randomNum(1,100) <= 10){
            const filter = Object.keys(elementCfgs).filter(e => elementCfgs[e].isArmor && elementCfgs[e].level <= monster.level && elementCfgs[e].level >= monster.level - 10);
            if(filter.length > 0){
                const makeItem = filter[0];
                const equip = getEquipQuality(elementCfgs[makeItem].new({name : makeItem, quantity : 1}), true);
                monster.atk += equip.atk;
                monster.def += equip.def;
                monster.hp += equip.hp;
                if(!monster.suck){monster.suck = 0}
                monster.suck += equip.suck;
                monster.armor = equip;
                monster.status.push(getStatus('穿戴护甲'));
            }
        }
    }

    monster.maxHp = monster.hp;
    monster.startAttrs = {
        maxHp : monster.maxHp,
        atk : monster.atk,
        def : monster.def,
    };
    console.log(monster)
    return monster;
}

//周目加强
function orderUp(monster){
    if(data.order > 1){
        let attrNum = (data.order - 1) * 3 * monster.level;
        const attrs = ['atk','atk','atk','atk','def','def','def','hp','hp','suck'];
        //以下为一次增加获得的点数
        const addNum = {
            atk : 1,
            def : 1,
            hp : parseInt(monsterCfgs[monster.name].hp * 0.01),
            suck : 0.5,
        }
        if(addNum.hp < 1){addNum.hp = 1}

        for(let i = 0 ; i < attrNum ; i++){
            const attr = attrs.getRandom();
            if(attr === 'suck' && !monster.suck){
                monster.suck = 0;
            }
            monster[attr] += addNum[attr];
        }
        monster.suck = parseInt(monster.suck || 0);
    }
    return monster;
}

//创建和NPC战斗的怪物
function createBattleNpc(id, playerAtkMonster){
    //获取npc
    const npc = data.world.npcs.filter(e => e.id === id)[0];
    //获取npc职业对应的怪物模板
    const monsterCfg = monsterCfgs[npc.profession];
    //随机获取对应地图的随机怪物
    const {level, hp, atk, def, exp, suck = 0} = monsterCfgs[getNpcRandomMonster(npc)];

    //增加罪恶值
    if(playerAtkMonster){
        addEvil(data.worldIndex + 1);
    }

    //随机属性
    function randomAttr(val){
        //阵营相同则不增幅属性
        if(npc.camp === '善良' && data.evil <= 0 || (npc.camp === '邪恶' && data.evil >= 0)){
            return val;
        }
        const num = data.evil >= 0 ? data.evil : -data.evil;

        return parseInt(val * parseFloat2Fiexd(randomNum(50 + num, 80 + num) / 100));
    }

    //创建基础属性
    let monster = {
        ...monsterCfg,
        name : npc.profession,
        showName : npc.name,
        npcId : id,
        shield : 0,
        status : [],
        level,
        playerAtkMonster,
        hp : randomAttr(hp),
        atk : randomAttr(atk),
        def : randomAttr(def),
        suck : randomAttr(suck),
        exp : randomAttr(exp),
        items : [...getCommItems(monsterCfg.type || '普通', monsterCfg.level, true, monsterCfg.tags)]
    };

    //周目加强
    monster = orderUp(monster);

    monster.maxHp = monster.hp;
    monster.startAttrs = {
        maxHp : monster.maxHp,
        atk : monster.atk,
        def : monster.def,
    };
    console.log(monster)
    return monster;
}

//获取指定地图可能出现的所有怪物
function getMonsterListByMapName(mapName = data.world.name){
    let mapMonsterList = [];
    terrainArray[mapName].forEach(e => {
        mapMonsterList = [...mapMonsterList,...Object.keys(terrainElements[e].monster)]
    })
    return mapMonsterList;
}

//根据NPC位阶获取随机怪物
function getNpcRandomMonster(npc, noHuman, noEnd){
    const arr = ['','精英','传说','神话'];

    //获取符合的所有怪物
    const monsterList = getMonsterListByMapName().filter(e => !e.includes("宝石巨人") && e !== data.maps[data.worldIndex].finalBoss && !monsterCfgs[e].isFestival && !monsterCfgs[e].cthulhuMonster && monsterCfgs[e].level >= data.maps[data.worldIndex].level[0] && monsterCfgs[e].level <= data.maps[data.worldIndex].level[1]).filter(e => noHuman ? !monsterCfgs[e].human : true).filter(e => noEnd ? e !== data.maps[data.worldIndex].worldBoss && monsterCfgs[e].type !== '神话' : true);

    let filter = [];
    let index = arr.indexOf(npc.rank)

    if(index !== -1){
        while (index < 4 && filter.length === 0){
            filter = monsterList.filter(e => arr[index] ? monsterCfgs[e].type === arr[index] : !monsterCfgs[e].type);
            index++;
        }
        if(filter.length === 0){
            filter = monsterList;
        }
    }

    return filter.getRandom();
}

/**
 * 获取扭曲怪物
 */
function getDistortedMonster(isNeedDistorted = false){
    const num = {
        '神话' : 5,
        '传说' : 3,
        '精英' : 2
    };
    const rate = data.battleMonster.type ? num[data.battleMonster.type] || 1 : 1;
    const reduceSan = ndx(rate, 6);

    if(data.battleMonster.startAttrs){
        for(const key in data.battleMonster.startAttrs){
            data.battleMonster[key] = data.battleMonster.startAttrs[key];
        }
    }

    data.battleMonster.maxHp *= 3;
    data.battleMonster.atk += data.battleMonster.level * 3 * rate;
    data.battleMonster.def += data.battleMonster.level * 2 * rate;
    data.battleMonster.distorted = true;
    data.battleMonster.hp = data.battleMonster.maxHp;
    data.battleMonster.status = [];

    if(!isNeedDistorted){
        data.battleMonster.showName = `扭曲的${data.battleMonster.showName || data.battleMonster.name}`
    }

    if(verification(false)){
        addBattleLog(`你看见了不可名状的事物，但你的克苏鲁学识让你免于扣除理智`)
    }else{
        reduceObjSan(data, reduceSan);
        addBattleLog(`你看见了不可名状的事物，你的理智减少了${reduceSan}`)
    }
}
