//世界BOSS提升属性
function worldBossAddAttr(atkRate = 0.1, defRate = 0.05){
    const atk = parseInt(data.battleMonster.atk * atkRate);
    const def = parseInt(data.battleMonster.def * defRate);
    data.battleMonster.atk += atk < 10 ? 10 : atk;
    data.battleMonster.def += def < 10 ? 10 : def;
}

//怪物技能
let monsterSkills = {
    '横扫' : {
        name : '横扫',
        normalAtk : false,//是否代替普通攻击，如果是的话，则不会被封印效果封印
        atr : 0,//命中率，也叫可以是成功率，设置为0和设置为100是一样的
        type : 'atk',//技能类型，atk=攻击，recover=恢复，berserk=变身，start=战斗开始时立刻触发,不进行check
        text : '1/3概率使用，造成1.5倍攻击力的伤害，有10%几率造成眩晕效果，持续1回合。',//技能说明
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('眩晕')
            }
            return null
        },
        check : function(){return randomNum(1,3) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 1.5},//获取攻击伤害数值或者治疗血量
    },
    '治愈' : {
        name : '治愈',
        type : 'recover',
        text : '生命值低于50%时，有1/3概率使用，恢复1.5倍攻击力的HP。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp / 2) && randomNum(1,3) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '腐蚀' : {
        name : '腐蚀',
        type : 'atk',
        text : '有1/5概率使用，造成2倍攻击力的伤害。',
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '撕咬' : {
        name : '撕咬',
        type : 'atk',
        text : '有1/5概率使用，造成2倍攻击力的伤害，有10%几率造成流血效果，每回合造成本技能10%的伤害，持续3回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('流血', {harm : parseInt(this.num * 0.1)})
            }
            return null
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '冲锋' : {
        name : '冲锋',
        type : 'atk',
        text : '在生命值高于95%时必定使用，造成2倍攻击力的伤害，有10%几率造成流血效果，每回合造成本技能10%的伤害，持续3回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('流血', {harm : parseInt(this.num * 0.1)})
            }
            return null
        },
        check : function(){return data.battleMonster.hp >= parseInt(data.battleMonster.maxHp * 0.95)},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '灵魂尖啸' : {
        name : '灵魂尖啸',
        type : 'atk',
        text : '1/5概率使用，造成1.5倍攻击力的伤害，无视防御，有10%几率造成眩晕效果，持续1回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('眩晕')
            }
            return null
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return (data.battleMonster.atk * 1.5) + (data.def > 0 ? data.def : 0)},
    },
    '大漩涡' : {
        name : '大漩涡',
        type : 'atk',
        text : '1/5概率使用，造成2倍攻击力的伤害，并给自己增加5层攻速积累状态',
        getStatus : function(){
            addStatus(data.battleMonster, getStatus('攻速积累', {num : 5}))
            return null
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '血肉转移' : {
        name : '血肉转移',
        type : 'atk',
        text : '1/5概率使用，造成1.5倍伤害，无视防御，并减少玩家相当于怪物当前攻击力的生命上限。',
        getStatus : function(){
            data.maxHp -= data.battleMonster.atk;
            addObjHp(data, 0);
            return null
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0)},
    },
    '绝命冲锋' : {
        name : '绝命冲锋',
        type : 'atk',
        text : '在生命值低于10%时必定使用，造成2倍攻击力的伤害，有10%几率造成流血效果，每回合造成本技能10%的伤害，持续3回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('流血', {harm : parseInt(this.num * 0.1)})
            }
            return null
        },
        check : function(){return data.battleMonster.hp < parseInt(data.battleMonster.maxHp * 0.1)},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '龙息' : {
        name : '龙息',
        type : 'atk',
        text : '有1/10概率使用，造成3倍攻击力的伤害，有30%几率造成燃烧效果，每回合造成本技能20%的伤害，持续3回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 30){
                return getStatus('燃烧', {harm : parseInt(this.num * 0.2)})
            }
            return null
        },
        check : function(){return randomNum(1,10) === 1},
        getNum : function(){return data.battleMonster.atk * 3},
    },
    '同化' : {
        name : '同化',
        type : 'recover',
        text : '生命值低于30%时，有1/5概率使用，恢复2倍攻击力的HP。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.3) && randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '神力爆发' : {
        name : '神力爆发',
        type : 'berserk',
        text : '生命值低于20%时必然使用。攻击力翻倍，防御力翻倍，生命值恢复至50%。该技能只会使用一次。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.2) && !data.battleMonster.showName},//用于判断使用条件是否满足
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.showName = `神力爆发·${data.battleMonster.name}`;
            data.battleMonster.atk *= 2;
            data.battleMonster.def *= 2;
            data.battleMonster.hp = parseInt(data.battleMonster.maxHp / 2);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了神力爆发，攻击和防御翻倍，并将血量恢复到50%。`);
        },
    },
    '黑暗冲击' : {
        name : '黑暗冲击',
        type : 'atk',
        text : '有1/5概率使用，使本次攻击无视30%的护甲。',
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk + (data.def * 0.3)},
    },
    '灵魂穿刺' : {
        name : '灵魂穿刺',
        type : 'atk',
        text : '1/5概率使用，本技能无视防御，有10%几率造成眩晕效果，持续1回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('眩晕')
            }
            return null
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0)},
    },
    '疯狂屠杀' : {
        name : '疯狂屠杀',
        type : 'atk',
        text : '1/5概率使用，造成1.5倍攻击力的伤害。',
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '剑气爆发' : {
        name : '剑气爆发',
        type : 'berserk',
        text : '生命值低于30%时必然使用。攻击力和防御力增加30%。该技能只会使用一次。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.3) && (!data.battleMonster.showName || !data.battleMonster.showName.startsWith(this.name))},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.showName = `${this.name}·${data.battleMonster.showName || data.battleMonster.name}`;
            data.battleMonster.atk += parseInt(data.battleMonster.atk * 0.3);
            data.battleMonster.def += parseInt(data.battleMonster.def * 0.3);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，击力和防御力增加30%。`);
        },
    },
    '深渊降临' : {
        name : '深渊降临',
        type : 'berserk',
        text : '生命值低于50%时必然使用。生命上限翻倍，并恢复所有生命值。该技能只会使用一次。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.5) && (!data.battleMonster.showName || !data.battleMonster.showName.startsWith(this.name))},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.showName = `${this.name}·${data.battleMonster.showName || data.battleMonster.name}`;
            data.battleMonster.maxHp *= 2;
            data.battleMonster.hp = data.battleMonster.maxHp;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，生命上限翻倍，并恢复所有生命值。`);
        },
    },
    '诅咒' : {
        name : '诅咒',
        type : 'berserk',
        text : '1/7概率使用，减少你50点攻击和50点防御。',
        check : function(){return randomNum(1,7) === 1},
        getNum : function(){return 0},
        use : function(){
            data.atk -= 50;
            data.def -= 50;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你的攻击力和防御力-50。`);
        },
    },
    '为了吾神' : {
        name : '为了吾神',
        type : 'berserk',
        text : '生命值低于30%时必然使用。攻击力和防御力增加30%。该技能只会使用一次。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.3) && (!data.battleMonster.showName || !data.battleMonster.showName.startsWith(this.name))},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.showName = `${this.name}·${data.battleMonster.showName || data.battleMonster.name}`;
            data.battleMonster.atk = parseInt(data.battleMonster.atk * 1.3);
            data.battleMonster.def = parseInt(data.battleMonster.def * 1.3);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，击力和防御力增加30%。`);
        },
    },
    '灵魂燃烧' : {
        name : '灵魂燃烧',
        type : 'berserk',
        text : '生命值低于20%时必然使用。攻击力增加100%，防御力如果大于0则会变为0，增加50%的吸血。该技能只会使用一次。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.2) && (!data.battleMonster.showName || !data.battleMonster.showName.startsWith(this.name))},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.showName = `${this.name}·${data.battleMonster.showName || data.battleMonster.name}`;
            data.battleMonster.atk *= 2;
            let text = `${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力增加100%`;
            if(data.battleMonster.def > 0){
                data.battleMonster.def = 0;
                text += '，防御力变为0';
            }
            data.battleMonster.suck = 50;
            addBattleLog(text);
        },
    },
    '坚毅' : {
        name : '坚毅',
        type : 'berserk',
        text : '1/5概率使用，增加50攻击和50防御。',
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.atk += 50;
            data.battleMonster.def += 50;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力和防御力+50。`);
        },
    },
    '神啊' : {
        name : '神啊',
        type : 'atk',
        text : '生命值低于10%时必然使用，造成3倍伤害。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.1) && (!data.battleMonster.showName || !data.battleMonster.showName.startsWith(this.name))},
        getNum : function(){return data.battleMonster.atk * 3},
    },
    '狙击' : {
        name : '狙击',
        type : 'atk',
        text : '首次攻击必然使用，造成3倍伤害。',
        check : function(use){
            if(!data.battleMonster.noFirstAtk){
                if(use){
                    data.battleMonster.noFirstAtk = true;
                }
                return true;
            }
            return false;
        },
        getNum : function(){return data.battleMonster.atk * 3},
    },
    '躲藏' : {
        name : '躲藏',
        type : 'atk',
        text : '1/5概率使用，使用投掷匕首造成0.5倍伤害，然后趁你被吸引注意力时躲藏起来，给你附加丢失目标状态，命中率降低100%，持续2回合。',
        getStatus : function(){
            return getStatus('丢失目标',{num :2})
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk * 0.5},
    },
    '刺杀' : {
        name : '刺杀',
        type : 'atk',
        text : '你拥有丢失目标状态时必然发动，造成2倍伤害。',
        check : function(){return data.status.filter(e => e.name === '丢失目标').length > 0},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '战吼' : {
        name : '战吼',
        type : 'berserk',
        text : '首次攻击必然使用，攻击力和防御力提高20%。',
        check : function(use){
            if(!data.battleMonster.noFirstAtk){
                if(use){
                    data.battleMonster.noFirstAtk = true;
                }
                return true;
            }
            return false;
        },
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.atk = parseInt(data.battleMonster.atk * 1.2);
            data.battleMonster.def = parseInt(data.battleMonster.def * 1.2);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力和防御力提高20%。`);
        },
    },
    '寒冰毒牙' : {
        name : '寒冰毒牙',
        type : 'atk',
        text : '1/5概率使用，造成1.5倍伤害，并有20%几率造成冰冻效果，持续1回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 20){
                return getStatus('冰冻')
            }
            return null
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '风行者' : {
        name : '风行者',
        type : 'start',
        text : '进入战斗时触发，飞起来让玩家难以攻击，给玩家附加空中目标状态，命中率降低30%，该状态不会自动消失。',
        check : function(){return false},
        use : function(){
            addStatus(data, getStatus('空中目标', {num : 1, keep : true}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你被附加了空中目标状态。`);
        },
    },
    '山岚之风' : {
        name : '山岚之风',
        type : 'start',
        text : '玩家没有罡风状态时必然使用，给玩家附加罡风状态，每回合造成200伤害，该状态不会自动消失。',
        check : function(){return false},
        use : function(){
            addStatus(data, getStatus('罡风', {num : 1, keep : true, harm : 200}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你被附加了罡风状态。`);
        },
    },
    '荣耀加身' : {
        name : '荣耀加身',
        type : 'recover',
        text : '生命值低于2%时必然发动，恢复一半生命值。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.02)},
        getNum : function(){return data.battleMonster.maxHp / 2},
    },
    '神圣守护' : {
        name : '神圣守护',
        type : 'berserk',
        text : '1/3概率使用，增加2000护盾。',
        check : function(){return randomNum(1,3) === 1},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.shield += 2000;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，获得2000护盾。`);
        },
    },
    '战争开始' : {
        name : '战争开始',
        type : 'berserk',
        text : '首次攻击必然使用，给自己附加血战状态，你每次攻击都会受到300反伤，该状态不会自动消失',
        check : function(use){
            if(!data.battleMonster.noFirstAtk){
                if(use){
                    data.battleMonster.noFirstAtk = true;
                }
                return true;
            }
            return false;
        },
        getNum : function(){return 0},
        use : function(){
            addStatus(data.battleMonster, getStatus('血战', {num : 1, keep : true, returnHarm : 300}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，获得了血战状态。`);
        },
    },
    '大地庇佑' : {
        name : '大地庇佑',
        type : 'recover',
        text : '有1/8概率使用，恢复2倍攻击力的HP。',
        check : function(){return randomNum(1,8) === 1},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '沙尘暴' : {
        name : '沙尘暴',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1倍伤害，并附加沙尘状态，命中率降低30%，持续3回合',
        getStatus : function(){
            return getStatus('沙尘')
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '神圣裁决' : {
        name : '神圣裁决',
        type : 'atk',
        text : '玩家血量低于15%时必然使用，造成100倍伤害',
        check : function(){return data.hp < data.maxHp * 0.15},
        getNum : function(){return data.battleMonster.atk * 100},
    },
    '不死之身' : {
        name : '不死之身',
        type : 'recover',
        text : '血量低于2000时，有30%概率使用，血量完全恢复',
        check : function(){return data.battleMonster.hp < 2000 && randomNum(1,100) <= 30},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.maxHp},
    },
    '圣光灼烧' : {
        name : '圣光灼烧',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1倍伤害，并附加灼烧状态，每回合收到300伤害，持续3回合',
        getStatus : function(){
            return getStatus('灼烧', {harm : 300})
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '腐化' : {
        name : '腐化',
        type : 'berserk',
        text : '1/5概率使用，降低你20防御。',
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return 0},
        use : function(){
            data.def -= 20;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你的防御力降低20`);
        },
    },
    '地狱火' : {
        name : '地狱火',
        type : 'atk',
        text : '有1/7概率使用，造成2倍攻击力的伤害，并附带燃烧效果，每回合造成200伤害，持续3回合。',
        getStatus : function(){
            return getStatus('燃烧', {harm : 200})
        },
        check : function(){return randomNum(1,7) === 1},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '暴风雪' : {
        name : '暴风雪',
        type : 'atk',
        text : '有1/7概率使用，造成2倍攻击力的伤害，并附带冰冻效果，持续1回合。',
        getStatus : function(){
            return getStatus('冰冻')
        },
        check : function(){return randomNum(1,7) === 1},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '衰老诅咒' : {
        name : '衰老诅咒',
        type : 'berserk',
        text : '有1/7概率使用，降低30攻击和30防御。',
        check : function(){return randomNum(1,7) === 1},
        getNum : function(){return 0},
        use : function(){
            data.atk -= 30;
            data.def -= 30;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你的攻击和防御力降低30。`);
        },
    },
    '毒咬' : {
        name : '毒咬',
        type : 'atk',
        text : '有1/7概率使用，造成2倍攻击力的伤害，并附带中毒状态，每回合造成100伤害，持续3回合。',
        getStatus : function(){
            return getStatus('中毒', {harm : 100})
        },
        check : function(){return randomNum(1,7) === 1},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '巨龙格斗术' : {
        name : '巨龙格斗术',
        type : 'atk',
        text : '有1/5概率使用，造成2倍伤害，并附加流血状态，每回合造成300伤害，持续3回合',
        getStatus : function(){
            return getStatus('流血', {harm : 300})
        },
        check : function(){return randomNum(1,5) === 1},
        getNum : function(){return data.battleMonster.atk * 3},
    },
    '火龙息' : {
        name : '火龙息',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1.5倍伤害，并附加以下随机一个状态（燃烧、灼烧），每回合造成200伤害，持续3回合',
        getStatus : function(){
            return getStatus(['燃烧','灼烧'].getRandom(), {harm : 200})
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '冰龙息' : {
        name : '冰龙息',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1.5倍伤害，并附加刺骨状态，每回合造成100伤害，持续3回合。当刺骨状态的持续回合达到6时，清除刺骨状态，附加冰冻状态，持续1回合',
        getStatus : function(){
            if(getStatuNum(data, '刺骨') >= 6){
                removeStatus(data, '刺骨')
                return getStatus('冰冻');
            }
            return getStatus('刺骨', {harm : 100})
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '毒龙息' : {
        name : '毒龙息',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1.5倍伤害，并附加中毒状态，每回合造成200伤害，持续3回合',
        getStatus : function(){
            return getStatus('中毒', {harm : 200})
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '死亡龙息' : {
        name : '死亡龙息',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1.5倍伤害，并附加生命流逝状态，每回合造成200伤害，持续3回合，并减少玩家5防御力',
        getStatus : function(){
            data.def -= 5;
            return getStatus('生命流逝', {harm : 200})
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '五彩龙息' : {
        name : '五彩龙息',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成2倍伤害，并附加燃烧、中毒、生命流逝状态，每回合造成120伤害，持续3回合，附加目盲状态，持续5回合，并附加刺骨状态，持续3回合。当刺骨状态的持续回合达到15时，清除刺骨状态，附加冰冻状态，持续1回合，30%概率封印你1回合',
        getStatus : function(){
            addStatus(data,  getStatus('燃烧', {harm : 120}))
            addStatus(data,  getStatus('中毒', {harm : 120}))
            addStatus(data,  getStatus('生命流逝', {harm : 120}))
            addStatus(data,  getStatus('目盲', {num : 5}))
            let text = '';
            if(randomNum(1,100) <= 30){
                addStatus(data,  getStatus('封印', {num : 1}))
                text += '，你被封印了';
            }
            if(getStatuNum(data, '刺骨') >= 15){
                removeStatus(data, '刺骨')
                text += '，你被冰冻了';
                addStatus(data,  getStatus('冰冻'))
            }else{
                addStatus(data,  getStatus('刺骨'))
            }

            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了五彩龙息，给你附加了大量负面状态${text}`)
            return null;
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '龙神守护' : {
        name : '龙神守护',
        type : 'berserk',
        text : '生命值低于30%时必然使用。防御力增加600。该技能只会使用一次。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.3) && (!data.battleMonster.showName || !data.battleMonster.showName.startsWith(this.name))},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.showName = `${this.name}·${data.battleMonster.showName || data.battleMonster.name}`;
            data.battleMonster.def += 600;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，防御力增加600。`);
        },
    },
    '根系缠绕' : {
        name : '根系缠绕',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1倍伤害，并附加缠绕状态，持续4回合',
        getStatus : function(){
            addStatus(data,  getStatus('缠绕'))
            return null;
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 1},
    },
    '根系束缚' : {
        name : '根系缠绕',
        type : 'berserk',
        text : '玩家身上有至少持续10回合的缠绕状态时使用，消除缠绕状态，增加束缚状态，使玩家无法行动，持续2回合。',
        use : function(){
            removeStatus(data,'缠绕')
            addStatus(data,  getStatus('束缚', {num : 2}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了根系束缚，你被束缚了`)
        },
        check : function(){return getStatuNum(data, '缠绕') >= 10},
        getNum : function(){return 0},
    },
    '寄生种子' : {
        name : '寄生种子',
        type : 'atk',
        check : function(){return randomNum(1,5) === 1},
        text : '有1/5概率使用，造成0.5倍伤害，并附加种子状态，持续10回合',
        getStatus : function(){
            addStatus(data,  getStatus('种子'))
            return null;
        },
        getNum : function(){return data.battleMonster.atk * 0.5},
    },
    '种子爆发' : {
        name : '种子爆发',
        type : 'berserk',
        check : function(){return hasStatus(data,'种子') && randomNum(1,5) === 1},
        text : '当玩家有种子状态时，有1/5概率使用，造成2倍伤害，并移除种子状态，附加放血状态，治疗量减少75%，持续10回合。该技能造成的伤害不波动，无视防御，无视护盾',
        use : function(){
            addStatus(data,  getStatus('放血', {num : 10}))
            removeStatus(data,'种子')
            const atk = data.battleMonster.atk * 2;
            data.hp -= atk;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了种子爆发，对你造成${atk}伤害`)
        },
        getNum : function(){return 0},
    },
    '丛林守卫' : {
        name : '丛林守卫',
        type : 'berserk',
        normalAtk : true,
        check : function(){return true},
        text : '该技能替代普通攻击使用，给自己附加3种树人（铁木树人，紫衫树人，黑刺树人）中任意随机一种状态，受到攻击时对玩家造成自身攻击50%的伤害，持续5回合',
        use : function(){
            const sta = ['铁木树人','紫衫树人','黑刺树人'].getRandom();
            addStatus(data.battleMonster,  getStatus(sta, {num : 5, returnHarm : parseInt(data.battleMonster.atk / 2)}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了丛林守卫，召唤出了${sta}`)
        },
        getNum : function(){return 0},
    },
    '生命摄取' : {
        name : '生命摄取',
        type : 'berserk',
        text : '生命值低于50%时，有1/5概率使用，吸收所有树人的生命，剩余树人的持续时间每剩余1回合，恢复0.5%生命值。',
        check : function(){
            const count = getStatuNum(data.battleMonster, '紫衫树人') + getStatuNum(data.battleMonster, '铁木树人') + getStatuNum(data.battleMonster, '黑刺树人');
            return count > 0 && data.battleMonster.hp < (data.battleMonster.maxHp / 2) && randomNum(1,5) === 1
        },
        use : function(){
            const count = getStatuNum(data.battleMonster, '紫衫树人') + getStatuNum(data.battleMonster, '铁木树人') + getStatuNum(data.battleMonster, '黑刺树人');
            removeStatus(data.battleMonster,'紫衫树人');removeStatus(data.battleMonster,'铁木树人');removeStatus(data.battleMonster,'黑刺树人');
            const addHp = parseInt(data.battleMonster.maxHp * 0.005 * count);
            battleAddHp(data.battleMonster, addHp);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了生命摄取，恢复了${addHp}HP`)
        },
        getNum : function(){return 0},
    },
    '树人自爆' : {
        name : '树人自爆',
        type : 'atk',
        text : '生命值低于30%时，有1/5概率使用，所有树人的冲上来自爆，剩余树人的持续时间每剩余1回合，造成0.5倍攻击力的伤害。',
        check : function(){
            const count = getStatuNum(data.battleMonster, '紫衫树人') + getStatuNum(data.battleMonster, '铁木树人') + getStatuNum(data.battleMonster, '黑刺树人');
            return count > 0 && data.battleMonster.hp < (data.battleMonster.maxHp * 0.3) && randomNum(1,5) === 1
        },
        getStatus : function(){
            removeStatus(data.battleMonster,'紫衫树人');removeStatus(data.battleMonster,'铁木树人');removeStatus(data.battleMonster,'黑刺树人');
            return null;
        },
        getNum : function(){
            const count = getStatuNum(data.battleMonster, '紫衫树人') + getStatuNum(data.battleMonster, '铁木树人') + getStatuNum(data.battleMonster, '黑刺树人');
            return data.battleMonster.atk * (count * 0.5)
        },
    },
    '山岭之力' : {
        name : '山岭之力',
        type : 'atk',
        normalAtk : true,
        check : function(){return true},
        text : '该技能替代普通攻击使用，造成1倍攻击，10%概率使玩家眩晕1回合，清除玩家身上的山岭状态，攻击力+100，如果没有眩晕玩家，则给玩家附加山岭状态，持续2回合。玩家每有1回合的山岭状态，眩晕几率增加10%',
        getStatus : function(){
            if(randomNum(1,100) <= 10 + (getStatuNum(data, '山岭') * 10)){
                removeStatus(data, '山岭')
                addStatus(data, getStatus('眩晕'))
                data.battleMonster.atk += 100;
            }else{
                addStatus(data, getStatus('山岭', {num : 2}))
            }

            return null;
        },
        getNum : function(){
            return data.battleMonster.atk
        },
    },
    '山岭爆发' : {
        name : '山岭爆发',
        type : 'atk',
        check : function(){return getStatuNum(data, '山岭') >= 7},
        text : '玩家身上的山岭状态剩余回合数达到7回合时使用，移除山岭状态，造成3倍攻击的伤害',
        getStatus : function(){
            removeStatus(data, '山岭')
            return null;
        },
        getNum : function(){
            return data.battleMonster.atk * 3
        },
    },
    '巨石阵' : {
        name : '巨石阵',
        type : 'berserk',
        check : function(){return getStatuNum(data, '山岭') > 0 && randomNum(1,5) === 1},
        text : '1/5概率使用，移除玩家的山岭状态，给玩家添加封印状态，每剩余1回合山岭状态，则封印玩家2回合',
        use : function(){
            addStatus(data, getStatus('封印', {num : getStatuNum(data, '山岭') * 2}))
            removeStatus(data, '山岭')
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了巨石阵，你被封印了`)
        },
        getNum : function(){
            return 0
        },
    },
    '地突刺' : {
        name : '地突刺',
        type : 'atk',
        normalAtk : true,
        check : function(){return true},
        text : '该技能替代普通攻击使用，造成1倍攻击，给玩家附加流血状态，每回合受到500伤害，持续5回合，并给自己附加大地状态，持续3回合。如果此时玩家身上的流血状态回合数超过10回合，则给玩家附加放血状态，持续3回合。',
        getStatus : function(){
            addStatus(data.battleMonster, getStatus('大地'))
            addStatus(data, getStatus('流血', {num : 3, harm : 500}))
            if(getStatuNum(data, '流血') >= 10){
                addStatus(data, getStatus('放血'))
            }
            return null
        },
        getNum : function(){
            return data.battleMonster.atk * 1
        },
    },
    '大地铠甲' : {
        name : '大地铠甲',
        type : 'berserk',
        check : function(){return getStatuNum(data.battleMonster, '大地') >= 10},
        text : '拥有至少10回合的大地状态时使用，移除大地状态，增加100防御力。',
        use : function(){
            data.battleMonster.def += 100;
            removeStatus(data.battleMonster, '大地')
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了大地铠甲，增加了100防御力`)
        },
        getNum : function(){
            return 0
        },
    },
    '遁地' : {
        name : '遁地',
        type : 'berserk',
        check : function(){
            if(data.battleMonster.hp < (data.battleMonster.maxHp * 0.5) && !hasStatus(data, '丢失目标')){
                return randomNum(1,100) <= 30
            }
            return false;
        },
        text : '生命值低于50%，且玩家身上没有丢失目标时，有百分之30%几率使用，遁入大地中，给玩家附加丢失目标状态，持续99回合。',
        use : function(){
            addStatus(data, getStatus('丢失目标', {num : 99}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了遁地，遁入大地中`)
        },
        getNum : function(){
            return 0
        },
    },
    '地脉融合' : {
        name : '地脉融合',
        type : 'recover',
        check : function(){
            if(hasStatus(data, '丢失目标')){
                removeStatus(data, '丢失目标')
                return true;
            }
            return false;
        },
        text : '玩家身上有丢失目标状态时使用，移除玩家的丢失目标状态，恢复20%生命值。',
        getNum : function(){return parseInt(data.battleMonster.maxHp * 0.2)},
    },
    '生命剥削' : {
        name : '生命剥削',
        type : 'berserk',
        normalAtk : true,
        check : function(){return true},
        text : '该技能替代普通攻击使用，给玩家附加生命剥削状态，每有1层生命剥削状态，造成的伤害增加玩家生命值上限的千分之一',
        use : function(){
            let hp = parseInt(data.hp * 0.2) - data.def;
            if(hp < parseInt(data.hp * 0.05)){
                hp = parseInt(data.hp * 0.05)
            }
            data.hp -= hp;
            addStatus(data.battleMonster, getStatus('生命之种', {num : 3}))
            addStatus(data, getStatus('生命流逝', {num : 5, harm : parseInt(data.maxHp * 0.01)}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了生命剥削，你的生命值减少了${hp}`)
        },
        getNum : function(){
            return 0
        },
    },
    '生命剥削' : {
        name : '生命剥削',
        type : 'atk',
        normalAtk : true,
        check : function(){return true},
        text : '该技能替代普通攻击使用，给玩家附加生命剥削状态，该状态不会自动消失。每有1层生命剥削状态，生命剥削技能造成的伤害增加玩家生命值上限的千分之一',
        getStatus : function(){
            addStatus(data,  getStatus('生命剥削'))
            return null;
        },
        getNum : function(){
            return data.battleMonster.atk * 1 + parseInt(data.maxHp * 0.001 * (getStatuNum(data, '生命剥削') + 1))
        },
    },
    '生命解放' : {
        name : '生命解放',
        type : 'berserk',
        text : '当损失的生命值达到30%以上时立刻使用，生命上限变为和当前生命值一样，每减少了200生命值上限，攻击力增加1点。使用生命解放技能后会给自己增加1层生命积累状态，该状态不会自动消失，也无法被技能或物品效果清除',
        check : function(){
            return data.battleMonster.hp <= data.battleMonster.maxHp * 0.7;
        },
        use(){
            const number = parseInt((data.battleMonster.maxHp - data.battleMonster.hp) / 200);
            data.battleMonster.atk += number;
            data.battleMonster.maxHp = data.battleMonster.hp
            addStatus(data.battleMonster, getStatus('生命积累'))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了生命解放，增加了${number}攻击力`)
        },
        getNum : function(){return 0},
    },
    '生命转移' : {
        name : '生命转移',
        type : 'atk',
        check : function(){return randomNum(1,100) <= 10},
        text : '10%概率使用，造成1倍伤害，并在攻击之前先减少玩家的生命上限，减少的值为生命之神当前攻击力的30%，每有1层生命积累状态，攻击力的比例提高10%，每有一层生命之种状态，减少玩家的生命上限的值增加一倍，并给自身恢复玩家减少的生命上限值的20倍的生命值。在这之后，给自己附加一层生命之种状态，每有1层生命积累状态，则额外再给自己增加1层生命之种状态，该状态不会自动消失。',
        getStatus : function(){
            const num = parseInt(data.battleMonster.atk * (0.3 + (getStatuNum(data.battleMonster, '生命积累') * 0.1))) * (getStatuNum(data.battleMonster, '生命之种') + 1)
            data.maxHp -= num;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }
            battleAddHp(data.battleMonster, num * 20)
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了生命转移，恢复${num * 20}的生命值，你的生命值上限减少了${num}`)
            addStatus(data.battleMonster, getStatus('生命之种', {num : 1 + getStatuNum(data.battleMonster, '生命积累')}))
            return null
        },
        getNum : function(){
            return data.battleMonster.atk * 1
        },
    },
    '世界之力' : {
        name : '世界之力',
        type : 'atk',
        normalAtk : true,
        text : '该技能替代普通攻击使用，造成1倍伤害，并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点',
        getStatus : function(){
            worldBossAddAttr();
            return null
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '蹦跶' : {
        name : '蹦跶',
        type : 'atk',
        text : '1/3概率使用，造成1.5倍攻击力的伤害，有10%几率造成眩晕效果，持续1回合。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            worldBossAddAttr();
            if(randomNum(1,100) <= 10){
                return getStatus('眩晕')
            }
            return null
        },
        check : function(){return randomNum(1,3) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 1.5},//获取攻击伤害数值或者治疗血量
    },
    '岩浆爆' : {
        name : '岩浆爆',
        type : 'atk',
        text : '1/5概率使用，造成2倍攻击力的伤害，附带燃烧效果，每回合造成自身攻击50%的伤害，持续3回合。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            addStatus(data,  getStatus('燃烧', {harm : parseInt(data.battleMonster.atk * 0.5)}))
            worldBossAddAttr();
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你获得了燃烧状态`)
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},//获取攻击伤害数值或者治疗血量
    },
    '水融合' : {
        name : '水融合',
        type : 'recover',
        text : '10%概率使用，恢复2倍攻击力的HP。',
        check : function(){return randomNum() <= 10},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '压制' : {
        name : '压制',
        type : 'atk',
        text : '1/5概率使用，造成2倍攻击力的伤害，并减少玩家10%当前攻击和防御。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            data.atk = parseInt(data.atk * 0.9);
            data.def = parseInt(data.def * 0.9);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你攻击力和防御力减少了10%`)
            worldBossAddAttr();
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},//获取攻击伤害数值或者治疗血量
    },
    '重爪撕裂' : {
        name : '重爪撕裂',
        type : 'atk',
        text : '1/5概率使用，造成2倍攻击力的伤害，如果在受到伤害前，玩家的血量已经低于50%，则给玩家附加放血状态，减少75%生命恢复，持续3回合。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            worldBossAddAttr();
            if(data.hp < data.hp * 0.5){
                return getStatus('放血')
            }
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},//获取攻击伤害数值或者治疗血量
    },
    '大裂解术' : {
        name : '大裂解术',
        type : 'atk',
        text : '1/10概率使用，造成3倍攻击力的伤害，玩家的武器和护甲如果不附带永不磨损属性，则耐久度变成0（注意，本技能造成的伤害会在装备被破坏且脱下后再计算！！！！）。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            worldBossAddAttr();
            if(data.weapon && !data.weapon.noWear){
                const item = getBagItemById(data.weapon.id);
                equip(item);
                item.endurance = 0;
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你的武器被破坏了`)
            }
            if(data.armor && !data.armor.noWear){
                const item = getBagItemById(data.armor.id);
                equip(item);
                item.endurance = 0;
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你的护甲被破坏了`)
            }
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},//获取攻击伤害数值或者治疗血量
    },
    '天之剑' : {
        name : '天之剑',
        type : 'atk',
        text : '1/5概率使用，造成（2倍攻击力+玩家已损失的生命值的50%）的伤害。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            worldBossAddAttr();
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2 + parseInt((data.maxHp - data.hp) * 0.5)},//获取攻击伤害数值或者治疗血量
    },
    '圣光净化' : {
        name : '圣光净化',
        type : 'atk',
        text : '1/5概率使用，造成2倍攻击力的伤害，并清除玩家的所有正面状态和自身的所有负面状态。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            worldBossAddAttr();
            removeAllBuff(data);
            removeAllDebuff(data.battleMonster);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}`)
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},//获取攻击伤害数值或者治疗血量
    },
    '力量吞噬' : {
        name : '力量吞噬',
        type : 'atk',
        text : '1/5概率使用，增加相当于玩家当前攻击力（不包含武器附加的攻击力，但会包含护甲附加的攻击力）相同数值的攻击力，然后造成2倍攻击力的伤害。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            data.battleMonster.atk += data.atk;
            worldBossAddAttr();
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力提高了${data.atk}`)
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk * 2},//获取攻击伤害数值或者治疗血量
    },
    '灵魂收割' : {
        name : '灵魂收割',
        type : 'atk',
        text : '1/5概率使用，额外造成玩家10%生命值上限且无视防御的一击。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
        getStatus : function(){
            worldBossAddAttr();
            return null
        },
        check : function(){return randomNum(1,5) === 1},//用于判断使用条件是否满足
        getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0) + parseInt(data.maxHp * 0.1)},
    },
    '仁慈' : {
        name : '仁慈',
        type : 'berserk',
        check : function(){return true},
        text : '100%使用，减少玩家5%生命值，无视防御，无视护盾，无视减伤，不波动。每次使用后给自身附加一层愤怒状态，每有一层愤怒状态，技能伤害增加5%',
        use : function(){
            let hp = parseInt(data.maxHp * 0.05 * (getStatuNum(data.battleMonster, '愤怒') + 1));
            data.hp -= hp;
            addStatus(data.battleMonster, getStatus('愤怒'))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了仁慈，你的生命值减少了${hp}`)
        },
        getNum : function(){
            return 0
        },
    },
    '重劈' : {
        name : '重劈',
        type : 'atk',
        text : '10%概率使用，造成3倍攻击力的伤害，有50%几率附加骨折状态，治疗量降低75%，持续5回合。使用后自身陷入力竭状态，无法行动，持续1回合',
        getStatus : function(){
            addStatus(data.battleMonster, getStatus('力竭'))
            if(randomNum(1,100) <= 50){
                return getStatus('骨折', {num : 5})
            }
            return null
        },
        check : function(){return randomNum(1,100) <= 10},
        getNum : function(){return data.battleMonster.atk * 3},
    },
    '十字斩' : {
        name : '十字斩',
        type : 'atk',
        text : '50%概率使用，造成1.5倍攻击力的伤害，有30%几率附加流血状态，每回合造成攻击方20%攻击力的伤害，持续5回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 30){
                return getStatus('流血', {harm : parseInt(data.battleMonster.atk * 0.2), num : 5})
            }
            return null
        },
        check : function(){return randomNum(1,100) <= 30},
        getNum : function(){return data.battleMonster.atk * 1.5},
    },
    '二连斩' : {
        name : '二连斩',
        type : 'atk',
        text : '玩家没有僵直状态时，有20%概率使用，造成1倍攻击力的伤害，并给玩家附加僵直状态，持续1回合。',
        getStatus : function(){
            return getStatus('僵直')
        },
        check : function(){return !getStatuNum(data, '僵直') && randomNum(1,100) <= 20},
        getNum : function(){return data.battleMonster.atk * 1},
    },
    '毒牙' : {
        name : '毒牙',
        type : 'atk',
        normalAtk : true,
        text : '代替普通攻击使用，造成1倍伤害，并给玩家附加中毒状态，每回合造成怪物攻击力10%的伤害，持续3回合',
        check : function(){return true},
        getStatus : function(){
            return getStatus('中毒', {num : 3, harm : parseInt(data.battleMonster.atk * 0.1)})
        },
        getNum : function(){return data.battleMonster.atk},
    },
    '戳刺' : {
        name : '戳刺',
        type : 'atk',
        text : '50%概率使用，造成2倍攻击力的伤害，有30%几率附加流血状态，每回合造成攻击方20%攻击力的伤害，持续5回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 30){
                return getStatus('流血', {harm : parseInt(data.battleMonster.atk * 0.2), num : 5})
            }
            return null
        },
        check : function(){return randomNum(1,100) <= 50},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '践踏' : {
        name : '践踏',
        type : 'atk',
        text : '20%概率使用，造成3倍攻击力的伤害',
        check : function(){return randomNum(1,100) <= 20},
        getNum : function(){return data.battleMonster.atk * 3},
    },
    '骑士冲锋' : {
        name : '骑士冲锋',
        type : 'atk',
        text : '在生命值高于95%时必定使用，造成2.5倍攻击力的伤害，有10%几率造成眩晕效果，使玩家无法行动，持续1回合。',
        getStatus : function(){
            if(randomNum(1,100) <= 10){
                return getStatus('眩晕')
            }
            return null
        },
        check : function(){return data.battleMonster.hp >= parseInt(data.battleMonster.maxHp * 0.95)},
        getNum : function(){return data.battleMonster.atk * 2.5},
    },
    '荣耀一击' : {
        name : '荣耀一击',
        type : 'atk',
        text : '在生命值低于5%时必定使用，自身血量变为1，造成2倍攻击力+本技能导致损失血量的3倍的伤害',
        getStatus : function(){
            data.battleMonster.hp = 1;
            return null
        },
        check : function(){return data.battleMonster.hp <= parseInt(data.battleMonster.maxHp * 0.05)},
        getNum : function(){return data.battleMonster.atk * 2 + ((data.battleMonster.hp - 1) * 3)},
    },
    '风刃' : {
        name : '风刃',
        type : 'atk',
        text : '30%几率使用，造成1倍伤害，并给玩家附加流血状态，每回合造成攻击方20%攻击力的伤害，持续5回合，并有30%概率给玩家附加放血状态，治疗量降低75%，持续5回合',
        getStatus : function(){
            addStatus(data, getStatus('流血', {harm : parseInt(data.battleMonster.atk * 0.2), num : 5}))
            if(randomNum(1,100) <= 30){
                return getStatus('放血')
            }
            return null
        },
        check : function(){return randomNum(1,100) <= 30},
        getNum : function(){return data.battleMonster.atk},
    },
    '雷暴术' : {
        name : '雷暴术',
        type : 'atk',
        text : '30%几率使用，造成2倍伤害，并给玩家附加麻痹状态，使玩家无法行动，持续1回合',
        getStatus : function(){
            return getStatus('麻痹')
        },
        check : function(){return randomNum(1,100) <= 30},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '奥术飞弹' : {
        name : '奥术飞弹',
        type : 'atk',
        text : '玩家没有奥术飞弹状态时有15%几率使用，玩家有奥术飞弹状态时必然使用，造成0.8倍伤害，如果玩家没有奥数飞弹状态，则给玩家附加奥术飞弹状态，使玩家无法行动，持续5回合',
        getStatus : function(){
            return getStatuNum(data, '奥术飞弹') ? null : getStatus('奥术飞弹', {num : 4})
        },
        check : function(){return getStatuNum(data, '奥术飞弹') ? true : randomNum(1,100) <= 15},
        getNum : function(){return data.battleMonster.atk * 0.8},
    },
    '陨石术' : {
        name : '陨石术',
        type : 'atk',
        text : '5%几率使用，造成5倍伤害，无视防御',
        check : function(){return randomNum(1,100) <= 5},
        getNum : function(){return data.battleMonster.atk * 5 + data.def},
    },
    '隐匿' : {
        name : '隐匿',
        type : 'berserk',
        text : '玩家没有“目标隐匿”状态时必然触发，给玩家附加目标隐匿状态，命中率降低100%，该状态不会自动消失',
        check : function(){return !getStatuNum(data, '目标隐匿')},
        getNum : function(){return 0},
        use : function(){
            addStatus(data, getStatus('目标隐匿'))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，从你的视野中消失了`);
        },
    },
    '闷棍' : {
        name : '闷棍',
        type : 'atk',
        text : '玩家拥有目标隐匿状态时必定使用，解除玩家的目标隐匿状态，造成0.5倍伤害，无视防御，给玩家附加闷棍状态，使玩家无法行动，该状态不会自动消失',
        getStatus : function(){
            removeStatus(data, '目标隐匿')
            return getStatus('闷棍');
        },
        check : function(){return getStatuNum(data, '目标隐匿')},
        getNum : function(){return data.battleMonster.atk * 0.5 + data.def},
    },
    '断筋' : {
        name : '断筋',
        type : 'atk',
        text : '玩家拥有闷棍状态时必定使用，解除玩家的闷棍状态，造成1倍伤害，无视防御，给玩家附加断筋状态，使玩家无法行动，该状态不会自动消失',
        getStatus : function(){
            removeStatus(data, '闷棍')
            return getStatus('断筋');
        },
        check : function(){return getStatuNum(data, '闷棍')},
        getNum : function(){return data.battleMonster.atk * 1 + data.def},
    },
    '割喉' : {
        name : '割喉',
        type : 'atk',
        text : '玩家拥有断筋状态时必定使用，解除玩家的断筋状态，造成2倍伤害，无视防御，给玩家附加割喉状态，封印玩家的技能，该状态不会自动消失',
        getStatus : function(){
            removeStatus(data, '断筋')
            return getStatus('割喉', {num : 1});
        },
        check : function(){return getStatuNum(data, '断筋')},
        getNum : function(){return data.battleMonster.atk * 2 + data.def},
    },
    '背刺' : {
        name : '背刺',
        type : 'atk',
        text : '玩家拥有割喉状态时必定使用，解除玩家的割喉状态，造成3倍伤害，无视防御',
        getStatus : function(){
            removeStatus(data, '割喉')
            return null;
        },
        check : function(){return getStatuNum(data, '割喉')},
        getNum : function(){return data.battleMonster.atk * 3 + data.def},
    },
    '力量咆哮' : {
        name : '力量咆哮',
        type : 'berserk',
        text : '自身没有力量状态时必定使用，攻击力翻倍，并给自己附加力量状态，该状态不会自动消失，也不会被清除状态的效果给清除',
        check : function(){return !getStatuNum(data.battleMonster, '力量')},
        getNum : function(){return 0},
        use : function(){
            addStatus(data.battleMonster, getStatus('力量'))
            data.battleMonster.atk *= 2;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力翻倍了`);
        },
    },
    '狂乱' : {
        name : '狂乱',
        type : 'atk',
        text : '必定使用，给自己附加狂乱状态，该状态不会自动消失。进行1次0.5倍到1.5倍攻击力的随机，每有一层狂乱，额外随机一次，将所有随机到的攻击力的总和作为本次技能的伤害',
        check : function(){return true},
        getStatus : function(){
            addStatus(data.battleMonster, getStatus('狂乱'))
            return null;
        },
        getNum : function(){
            let count = randomNum(parseInt(data.battleMonster.atk * 0.5) , parseInt(data.battleMonster.atk * 1.5));
            for(let i = 0 ; i < getStatuNum(data.battleMonster, '狂乱') ; i++){
                count += randomNum(parseInt(data.battleMonster.atk * 0.5) , parseInt(data.battleMonster.atk * 1.5));
            }
            return count;
        },
    },
    '拔剑' : {
        name : '拔剑',
        type : 'berserk',
        text : '当玩家是亡灵族、巫妖、吸血鬼、影魔、蜥蜴人、食人魔、操脑蛛、污染者、魅魔时必定使用，拔出随身携带的银剑，攻击力提高300%，该技能只会使用一次',
        check : function(){return !data.battleMonster.bj && ['亡灵族', '巫妖', '吸血鬼', '影魔', '蜥蜴人', '食人魔', '操脑蛛', '污染者','魅魔'].includes(data.race.name.split('-')[0])},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.bj = true;
            data.battleMonster.atk *= 4;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力提高了300%`);
        },
    },
    '大师剑术' : {
        name : '大师剑术',
        type : 'atk',
        text : '50%几率使用，造成1.5倍伤害，无视防御',
        check : function(){return randomNum(1,100) <= 50},
        getNum : function(){return data.battleMonster.atk * 1.5 + data.def},
    },
    '火焰法印' : {
        name : '火焰法印',
        type : 'atk',
        text : '30%几率使用，造成2倍伤害，并给玩家附加燃烧状态，每回合造成攻击方20%攻击力的伤害，持续5回合',
        getStatus : function(){
            return getStatus('燃烧', {harm : parseInt(data.battleMonster.atk * 0.2), num : 5})
        },
        check : function(){return randomNum(1,100) <= 30},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '来一局吗' : {
        name : '来一局吗',
        type : 'berserk',
        text : '谁能拒绝猎魔人提出的牌局呢，对吧。当血量低于20%时，有10%概率使用，获得充分的休息，血量完全恢复',
        check : function(){return data.battleMonster.hp <= (data.battleMonster.maxHp * 0.2) && randomNum(1,100) <= 10},
        getNum : function(){return 0},
        use : function(){
            data.battleMonster.hp = data.battleMonster.maxHp;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，获得充分的休息，血量完全恢复`);
        },
    },
    '轻灵一击' : {
        name : '轻灵一击',
        type : 'atk',
        normalAtk : true,
        text : '代替普通攻击使用，造成1倍伤害，有30%几率给玩家附加反应不及状态，使玩家无法行动，持续1回合',
        getStatus : function(){
            return randomNum(1,100) <= 30 ? getStatus('反应不及') : null;
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk},
    },
    '后跳射击' : {
        name : '后跳射击',
        type : 'atk',
        text : '30%几率使用，造成0.5倍伤害，并给玩家附加拉开距离状态，使玩家无法行动，持续1回合',
        getStatus : function(){
            return getStatus('拉开距离');
        },
        check : function(){return randomNum(1,100) <= 30},
        getNum : function(){return data.battleMonster.atk * 0.5},
    },
    '连续射击' : {
        name : '连续射击',
        type : 'atk',
        text : '20%几率使用，造成2~4倍伤害',
        getStatus : function(){
            return getStatus('拉开距离');
        },
        check : function(){return randomNum(1,100) <= 20},
        getNum : function(){return data.battleMonster.atk * randomNum(2,4)},
    },
    '光明十字' : {
        name : '光明十字',
        type : 'atk',
        normalAtk : true,
        text : '代替普通攻击使用，造成2倍伤害，并给玩家附加烈阳状态，每回合造成生命上限5%的伤害，该状态不会被清除状态的效果清除，也不会自动消失',
        getStatus : function(){
            return getStatus('烈阳', {harm : parseInt(data.maxHp * 0.05)});
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '神恩' : {
        name : '神恩',
        type : 'recover',
        text : '生命值低于50%时必然使用，恢复所有生命值。',
        check : function(){return data.battleMonster.hp < (data.battleMonster.maxHp * 0.5)},
        getNum : function(){return data.battleMonster.maxHp},
    },
    '黑暗强袭' : {
        name : '黑暗强袭',
        type : 'atk',
        normalAtk : true,
        text : '代替普通攻击使用，造成2倍伤害，并有80%概率使玩家陷入眩晕，持续1回合',
        getStatus : function(){
            return randomNum(1,100) <= 80 ? getStatus('眩晕') : null;
        },
        check : function(){return true},
        getNum : function(){return data.battleMonster.atk * 2},
    },
    '惊现' : {
        name : '惊现',
        type : 'atk',
        text : '20%几率使用，造成1倍伤害，增加5层攻速积累',
        getStatus : function(){
            addStatus(data.battleMonster, getStatus('攻速积累', {num : 5}))
            return null;
        },
        check : function(){return randomNum(1,100) <= 20},
        getNum : function(){return data.battleMonster.atk},
    },
    '击魂' : {
        name : '击魂',
        type : 'atk',
        text : '10%几率使用，造成2倍伤害，无视防御',
        getStatus : function(){
            addStatus(data.battleMonster, getStatus('攻速积累', {num : 5}))
            return null;
        },
        check : function(){return randomNum(1,100) <= 10},
        getNum : function(){return data.battleMonster.atk * 2 + data.def},
    },
};
//怪物药剂DLC
const monsterItemDlcSkills = {
    '微效治疗药剂' : {
        name : '微效治疗药剂',
        type : 'berserk',
        level : 1,
        check : function(){return data.battleMonster.maxHp - data.battleMonster.hp > 40 && getStatuNum(data.battleMonster, '恢复') < 1 && !data.battleMonster[this.name]},
        use : function(){
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, 20)}HP`)
            addStatus(data.battleMonster, getStatus('恢复', {addHp : 10, num : 2}))
        },
        getNum : function(){return 0},
    },
    '弱效治疗药剂' : {
        name : '弱效治疗药剂',
        type : 'berserk',
        level : 11,
        check : function(){return data.battleMonster.maxHp - data.battleMonster.hp > 80 && getStatuNum(data.battleMonster, '恢复') < 1 && !data.battleMonster[this.name]},
        use : function(){
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, 50)}HP`)
            addStatus(data.battleMonster, getStatus('恢复', {addHp : 25, num : 3}))
        },
        getNum : function(){return 0},
    },
    '中效治疗药剂' : {
        name : '中效治疗药剂',
        type : 'berserk',
        level : 21,
        check : function(){return data.battleMonster.maxHp - data.battleMonster.hp > 180 && getStatuNum(data.battleMonster, '恢复') < 1 && !data.battleMonster[this.name]},
        use : function(){
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, 100)}HP`)
            addStatus(data.battleMonster, getStatus('恢复', {addHp : 70, num : 4}))
        },
        getNum : function(){return 0},
    },
    '大地之心' : {
        name : '大地之心',
        type : 'berserk',
        level : 21,
        check : function(){return !getStatuNum(data.battleMonster, '大地之心') && !data.battleMonster[this.name]},
        use : function(){
            data.battleMonster.def += 50;
            addStatus(data.battleMonster, getStatus('大地之心'))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，增加了50防御`)
        },
        getNum : function(){return 0},
    },
    '高效治疗药剂' : {
        name : '高效治疗药剂',
        type : 'berserk',
        level : 41,
        check : function(){return data.battleMonster.maxHp - data.battleMonster.hp > 410 && getStatuNum(data.battleMonster, '恢复') < 1 && !data.battleMonster[this.name]},
        use : function(){
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, 200)}HP`)
            addStatus(data.battleMonster, getStatus('恢复', {addHp : 200, num : 5}))
        },
        getNum : function(){return 0},
    },
    '强效治疗药剂' : {
        name : '强效治疗药剂',
        type : 'berserk',
        level : 61,
        check : function(){return data.battleMonster.maxHp - data.battleMonster.hp > 710 && getStatuNum(data.battleMonster, '恢复') < 1 && !data.battleMonster[this.name]},
        use : function(){
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, 300)}HP`)
            addStatus(data.battleMonster, getStatus('恢复', {addHp : 400, num : 6}))
        },
        getNum : function(){return 0},
    },
    '龙血药剂' : {
        name : '龙血药剂',
        type : 'berserk',
        level : 71,
        check : function(){return data.battleMonster.maxHp - data.battleMonster.hp > 1310 && getStatuNum(data.battleMonster, '恢复') < 1 && !data.battleMonster[this.name]},
        use : function(){
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, 600)}HP`)
            addStatus(data.battleMonster, getStatus('恢复', {addHp : 700, num : 7}))
        },
        getNum : function(){return 0},
    },
    '哥布林心脉精华' : {
        name : '哥布林心脉精华',
        type : 'berserk',
        level : 21,
        check : function(){
            let add = parseInt(data.battleMonster.maxHp * 0.1);
            if(add < 100){
                add = 100;
            }
            return (data.battleMonster.maxHp - data.battleMonster.hp > add + 10 || data.battleMonster.maxHp - data.battleMonster.hp > parseInt(data.battleMonster.maxHp * 0.1) + 10) && !data.battleMonster[this.name]
        },
        use : function(){
            let add = parseInt(data.battleMonster.maxHp * 0.1);
            if(add < 100){
                add = 100;
            }
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, add)}HP`)
        },
        getNum : function(){return 0},
    },
    '魔蛟心脉精华' : {
        name : '魔蛟心脉精华',
        type : 'berserk',
        level : 31,
        check : function(){
            let add = parseInt(data.battleMonster.maxHp * 0.3);
            if(add < 800){
                add = 800;
            }
            return (data.battleMonster.maxHp - data.battleMonster.hp > add + 10 || data.battleMonster.maxHp - data.battleMonster.hp > parseInt(data.battleMonster.maxHp * 0.3) + 10) && !data.battleMonster[this.name]
        },
        use : function(){
            let add = parseInt(data.battleMonster.maxHp * 0.3);
            if(add < 800){
                add = 800;
            }
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, add)}HP`)
        },
        getNum : function(){return 0},
    },
    '狂暴心脉精华' : {
        name : '狂暴心脉精华',
        type : 'berserk',
        level : 31,
        check : function(){
            if(hasStatus(data.battleMonster, '狂暴') || hasStatus(data.battleMonster, '虚弱')){
                return false;
            }
            let add = parseInt(data.battleMonster.maxHp * 0.15);
            if(add < 200){
                add = 200;
            }
            return (data.battleMonster.maxHp - data.battleMonster.hp > add + 10 || data.battleMonster.maxHp - data.battleMonster.hp > parseInt(data.battleMonster.maxHp * 0.3) + 10) && !data.battleMonster[this.name]
        },
        use : function(){
            let addHp = parseInt(data.battleMonster.maxHp * 0.15);
            if(addHp < 200){
                addHp = 200;
            }
            addStatus(data.battleMonster, getStatus('狂暴'))
            const text = `使用了狂暴心脉精华，恢复${battleAddHp(data.battleMonster, addHp)}HP，获得狂暴状态`;
            addBattleLog(text)
        },
        getNum : function(){return 0},
    },
    '神性药剂' : {
        name : '神性药剂',
        type : 'berserk',
        level : 51,
        check : function(){
            let add = parseInt(data.battleMonster.maxHp * 0.5);
            if(add < 3000){
                add = 3000;
            }
            return (data.battleMonster.maxHp - data.battleMonster.hp > add + 10 || data.battleMonster.maxHp - data.battleMonster.hp > parseInt(data.battleMonster.maxHp * 0.5) + 10) && !data.battleMonster[this.name]
        },
        use : function(){
            let add = parseInt(data.battleMonster.maxHp * 0.5);
            if(add < 3000){
                add = 3000;
            }
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, add)}HP`)
        },
        getNum : function(){return 0},
    },
    '强效神性药剂' : {
        name : '强效神性药剂',
        type : 'berserk',
        level : 71,
        check : function(){
            return data.battleMonster.hp <= parseInt(data.battleMonster.maxHp * 0.1) && !data.battleMonster[this.name]
        },
        use : function(){
            let add = data.battleMonster.maxHp;
            data.battleMonster[this.name] = true;
            data.battleMonster.shield += data.battleMonster.maxHp;
            removeAllDebuff(data.battleMonster);
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，恢复${battleAddHp(data.battleMonster, add)}HP，获得${data.battleMonster.maxHp}护盾，并清除了所有负面效果`)
        },
        getNum : function(){return 0},
    },
    '巨龙之力' : {
        name : '巨龙之力',
        type : 'berserk',
        level : 71,
        check : function(){
            return !data.battleMonster[this.name]
        },
        use : function(){
            data.battleMonster[this.name] = true;
            data.battleMonster.atk += 100;
            data.battleMonster.def += 100;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力+100，防御力+100`)
        },
        getNum : function(){return 0},
    },
    '龙魂药剂' : {
        name : '龙魂药剂',
        type : 'berserk',
        level : 71,
        check : function(){
            return !data.battleMonster[this.name] && getStatuNum(data.battleMonster, '恢复') < 1
        },
        use : function(){
            data.battleMonster[this.name] = true;
            data.battleMonster.atk += 400;
            data.battleMonster.def += 300;
            removeAllDebuff(data.battleMonster);
            data.battleMonster.hp = data.battleMonster.maxHp;
            addStatus(data.battleMonster, getStatus('恢复', {addHp : parseInt(data.battleMonster.maxHp * 0.2), num : 10}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，攻击力+400，防御力+300，解除所有负面状态，生命值完全恢复`)
        },
        getNum : function(){return 0},
    },
    '风暴号角' : {
        name : '风暴号角',
        type : 'berserk',
        level : 61,
        check : function(){
            return !data.battleMonster[this.name]
        },
        use : function(){
            data.battleMonster[this.name] = true;
            addStatus(data, getStatus('封印', {num : 7}))
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你被封印了`)
        },
        getNum : function(){return 0},
    },
    '风暴药剂' : {
        name : '风暴药剂',
        type : 'berserk',
        level : 61,
        check : function(){
            return !data.battleMonster[this.name] && data.battleMonster.status.filter(e => e.type !== 'buff') > 0
        },
        use : function(){
            data.battleMonster[this.name] = true;
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，解除所有负面状态`)
            removeAllDebuff(data.battleMonster);
        },
        getNum : function(){return 0},
    },
    '巫毒药剂' : {
        name : '巫毒药剂',
        type : 'atk',
        level : 1,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            return getStatus('中毒', {harm : 10, num : 5})
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 30},
    },
    '魔晶炸弹' : {
        name : '魔晶炸弹',
        type : 'atk',
        level : 10,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            if(randomNum(1,100) <= 30){
                return getStatus('眩晕')
            }
            return null
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 100},
    },
    '火焰爆弹' : {
        name : '火焰爆弹',
        type : 'atk',
        level : 20,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            return getStatus('燃烧', {harm : 50, num : 3})
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 200},
    },
    '潮汐珠宝' : {
        name : '潮汐珠宝',
        type : 'atk',
        level : 20,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            data.battleMonster.shield += 20;
            return null
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 200},
    },
    '飞雷矛' : {
        name : '飞雷矛',
        type : 'atk',
        level : 30,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            if(randomNum(1,100) <= 30){
                return getStatus('麻痹')
            }
            return null
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 300},
    },
    '石化炸弹' : {
        name : '石化炸弹',
        type : 'atk',
        level : 30,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            if(randomNum(1,100) <= 30){
                return getStatus('石化')
            }
            return null
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 300},
    },
    '幽灵猛毒' : {
        name : '幽灵猛毒',
        type : 'atk',
        level : 40,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            return getStatus('中毒', {harm : 300, num : 3})
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 100},
    },
    '病毒吹箭' : {
        name : '病毒吹箭',
        type : 'atk',
        level : 40,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            return getStatus('中毒', {harm : 300, num : 3})
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 100},
    },
    '尸毒飞镖' : {
        name : '尸毒飞镖',
        type : 'atk',
        level : 50,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            return getStatus('中毒', {harm : 500, num : 3})
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 300},
    },
    '神性炸弹' : {
        name : '神性炸弹',
        type : 'atk',
        level : 60,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            if(randomNum(1,100) <= 50){
                return getStatus('眩晕', {num : 2})
            }
            return null
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 500},
    },
    '神性爆弹' : {
        name : '神性爆弹',
        type : 'atk',
        level : 70,
        getStatus : function(){
            data.battleMonster[this.name] = true;
            if(randomNum(1,100) <= 50){
                return getStatus('眩晕', {num : 3})
            }
            return null
        },
        check : function(){return !data.battleMonster[this.name]},
        getNum : function(){return 1000},
    },
}

monsterSkills = {
    ...monsterSkills,
    '捍地击' : {
        ...monsterSkills['腐蚀'],
        name : '捍地击',
    },
    ...monsterSkills,
    '海啸' : {
        ...monsterSkills['腐蚀'],
        name : '海啸',
    },
    '血肉牵引' : {
        ...monsterSkills['同化'],
        name : '血肉牵引',
    },
    '死亡一指' : {
        ...monsterSkills['龙息'],
        name : '死亡一指',
    },
    '不灭冲锋' : {
        ...monsterSkills['撕咬'],
        name : '不灭冲锋',
    },
    '强力飞扑' : {
        ...monsterSkills['撕咬'],
        name : '强力飞扑',
    },
    '勾魂索' : {
        ...monsterSkills['腐蚀'],
        name : '勾魂索',
    },
    '血肉吞噬' : {
        ...monsterSkills['同化'],
        name : '血肉吞噬',
    },
    '舍生斩' : {
        ...monsterSkills['横扫'],
        name : '舍生斩',
    },
    '帝国剑术' : {
        ...monsterSkills['横扫'],
        name : '帝国剑术',
    },
    '元素爆弹' : {
        ...monsterSkills['灵魂穿刺'],
        name : '元素爆弹',
    },
    '弱点狙击' : {
        ...monsterSkills['腐蚀'],
        name : '弱点狙击',
    },
    '荣耀冲锋' : {
        ...monsterSkills['撕咬'],
        name : '荣耀冲锋',
    },
    '生命沸腾' : {
        ...monsterSkills['治愈'],
        name : '生命沸腾',
    },
    '荣耀打击' : {
        ...monsterSkills['灵魂尖啸'],
        name : '荣耀打击',
    },
    '盾击' : {
        ...monsterSkills['横扫'],
        name : '盾击',
    },
    '火焰风暴' : {
        ...monsterSkills['地狱火'],
        name : '火焰风暴',
    },
    '火焰风暴' : {
        ...monsterSkills['地狱火'],
        name : '火焰风暴',
    },
    '摆尾' : {
        ...monsterSkills['横扫'],
        name : '摆尾',
    },
    '冲撞' : {
        ...monsterSkills['腐蚀'],
        name : '冲撞',
    },
    '缠咬' : {
        ...monsterSkills['毒咬'],
        name : '缠咬',
    },
    '仙食' : {
        ...monsterSkills['同化'],
        name : '仙食',
    },
    '云涛' : {
        ...monsterSkills['暴风雪'],
        name : '云涛',
    },
    '弱羽' : {
        ...monsterSkills['风刃'],
        name : '弱羽',
    },
    '饿撵' : {
        ...monsterSkills['狙击'],
        name : '饿撵',
    },
    '弄蒲' : {
        ...monsterSkills['大地庇佑'],
        name : '弄蒲',
    },
    '灭跃' : {
        ...monsterSkills['灵魂燃烧'],
        name : '灭跃',
    },
    '曰远' : {
        ...monsterSkills['黑暗冲击'],
        name : '曰远',
    },
    '神翟' : {
        ...monsterSkills['灵魂尖啸'],
        name : '神翟',
    },
    '焦蹋' : {
        ...monsterSkills['神啊'],
        name : '焦蹋',
    },
    '霜塑' : {
        ...monsterSkills['冰龙息'],
        name : '霜塑',
    },
    '弦秋' : {
        ...monsterSkills['暴风雪'],
        name : '弦秋',
    },
    '生乌' : {
        ...monsterSkills['同化'],
        name : '生乌',
    },
    '炬栅' : {
        ...monsterSkills['连续射击'],
        name : '炬栅',
    },
    '焙坷' : {
        ...monsterSkills['陨石术'],
        name : '焙坷',
    },
    '唁烬' : {
        ...monsterSkills['火焰法印'],
        name : '唁烬',
    },
    '夯涛' : {
        ...monsterSkills['深渊降临'],
        name : '夯涛',
    },
    '沧壶' : {
        ...monsterSkills['灵魂穿刺'],
        name : '沧壶',
    },
    '镰垄' : {
        ...monsterSkills['巨龙格斗术'],
        name : '镰垄',
    },
};

//怪物和技能关联配置
let monsterSkillMapping = {
    '兴风厉鬼' : ['惊现','击魂'],

    '角木蛟' : ['缠咬','冲撞','摆尾'],
    '亢金龙' : ['仙食','云涛','弱羽'],
    '氐土貉' : ['灭跃','饿撵','弄蒲'],
    '房日兔' : ['焦蹋','曰远','神翟'],
    '心月狐' : ['生乌','弦秋','霜塑'],
    '尾火虎' : ['焙坷','炬栅','唁烬'],
    '箕水豹' : ['夯涛','沧壶','镰垄'],

    '剑士' : ['横扫','重劈','十字斩','二连斩'],
    '骑士' : ['荣耀一击','骑士冲锋','戳刺','践踏'],
    '奥术师' : ['奥术飞弹','雷暴术','风刃','陨石术'],
    '盗贼' : ['背刺','割喉','断筋','闷棍','隐匿'],
    '野蛮人' : ['力量咆哮','狂乱'],
    '猎魔人' : ['来一局吗','拔剑','大师剑术','火焰法印'],
    '游侠' : ['连续射击','后跳射击','轻灵一击'],
    '神圣选民' : ['神恩','光明十字'],
    '黑暗行者' : ['黑暗强袭'],

    '巨神飞鱼' : ['蹦跶','世界之力'],
    '火元素领主' : ['岩浆爆','世界之力'],
    '水元素领主' : ['水融合','世界之力'],
    '利维坦幼体' : ['压制','世界之力'],
    '比蒙巨兽' : ['重爪撕裂','世界之力'],
    '龙巫妖' : ['大裂解术','世界之力'],
    '六翼天使' : ['天之剑','世界之力'],
    '神降祭祀' : ['圣光净化','世界之力'],
    '龙族吞噬者' : ['力量吞噬','世界之力'],
    '远古死神' : ['灵魂收割','世界之力'],

    '草木之神' : ['根系束缚','种子爆发','寄生种子','根系缠绕'],
    '森林之神' : ['树人自爆','生命摄取','丛林守卫'],
    '山脉之神' : ['山岭爆发','巨石阵','山岭之力'],
    '大地之神' : ['地脉融合','遁地','大地铠甲','地突刺'],
    '生命之神' : ['生命转移','生命解放','生命剥削'],

    '哥布林巨人' : ['横扫'],
    '哥布林英雄' : ['横扫'],
    '神性史莱姆' : ['治愈'],
    '扭曲邪物' : ['腐蚀'],

    '游荡者' : ['冲锋'],
    '地穴领主' : ['撕咬'],
    '远古残魂' : ['灵魂尖啸'],
    '扭曲的憎恨' : ['腐蚀'],

    '弄潮鱼人' : ['海啸'],
    '独角海象' : ['强力飞扑'],
    '鱼人祭司' : ['大漩涡'],
    '血肉幽灵船' : ['血肉转移'],

    '紫晶巨人' : ['捍地击'],
    '兽人酋长' : ['横扫'],
    '魔晶巨人' : ['捍地击'],
    '扭曲晶魂' : ['腐蚀'],

    '五彩魔蛟' : ['撕咬'],
    '死亡骑士' : ['冲锋','绝命冲锋'],
    '荒芜亚龙' : ['撕咬'],
    '绿龙幼崽' : ['龙息'],
    '无名肉山' : ['腐蚀', '同化'],

    '骷髅法师' : ['黑暗冲击'],
    '幽魂' : ['灵魂穿刺'],
    '血肉屠夫' : ['疯狂屠杀'],
    '尸巫' : ['黑暗冲击'],
    '骷髅骑士' : ['不灭冲锋'],
    '血魔' : ['血肉牵引'],
    '怨灵' : ['灵魂尖啸'],
    '巫妖' : ['死亡一指'],
    '憎恶' : ['勾魂索','血肉吞噬'],
    '大剑士' : ['剑气爆发', '帝国剑术'],
    '青年黑龙' : ['龙息'],
    '诅咒凶魂' : ['灵魂尖啸'],
    '死离人形' : ['深渊降临'],

    '骷髅剑士' : ['舍生斩'],
    '神选战士' : ['横扫'],
    '巨魔骷髅' : ['撕咬'],
    '神选法师' : ['元素爆弹'],
    '神选游侠' : ['弱点狙击'],
    '亡灵蠕虫' : ['腐蚀'],
    '神选骑士' : ['荣耀冲锋'],
    '鲜血巨魔' : ['生命沸腾'],
    '女巫' : ['诅咒'],
    '神选冠军骑士' : ['荣耀冲锋'],
    '神眷圣骑士' : ['为了吾神','荣耀打击'],
    '幽灵龙' : ['龙息','灵魂燃烧'],
    '腐烂吸血鬼' : ['撕咬'],

    '苦修士' : ['坚毅'],
    '狂信徒' : ['神啊'],
    '巡游卫士' : ['盾击'],
    '哨塔射手' : ['狙击'],
    '隐秘猎人' : ['躲藏'],
    '阴影杀手' : ['刺杀','躲藏'],
    '水生战兽' : ['战吼'],
    '白鳞水蟒' : ['寒冰毒牙'],
    '鹰身女妖' : ['风行者'],
    '飓风龙兽' : ['山岚之风'],
    '荣耀骑士' : ['荣耀加身', '荣耀冲锋'],
    '大神官' : ['神圣守护'],
    '战争领主' : ['战争开始'],
    '沙暴地龙' : ['大地庇佑','沙尘暴'],
    '使徒行者' : ['神圣裁决','不死之身','圣光灼烧'],
    '深渊领主' : ['深渊降临','腐化','地狱火'],

    '怒焰亚龙' : ['火焰风暴'],
    '冰霜亚龙' : ['暴风雪'],
    '毒液亚龙' : ['毒咬'],
    '黑暗亚龙' : ['衰老诅咒'],
    '红龙' : ['火龙息'],
    '蓝龙' : ['冰龙息'],
    '绿龙' : ['毒龙息'],
    '黑龙' : ['死亡龙息'],
    '五首龙神' : ['龙神守护','五彩龙息'],

    '水之女神' : ['神力爆发'],
    '狩猎之神' : ['神力爆发'],
    '创世神' : ['仁慈'],
};
//追加新地图怪物技能
Object.keys(newMapElements.monsterSkill).forEach(e => {
    monsterSkillMapping[e] = [];
    newMapElements.monsterSkill[e].forEach(s => {
        if(typeof s === 'string'){
            monsterSkillMapping[e].push(s);
        }else{
            monsterSkillMapping[e].push(s.name);

            if(s.extend){
                monsterSkills = {
                    ...monsterSkills,
                    [s.name] : {
                        ...monsterSkills[s.extend],
                        name : s.name,
                    }
                }
            }else{
                monsterSkills = {
                    ...monsterSkills,
                    [s.name] : s
                }
            }
        }
    });
})

//触发进入战斗时触发的技能
function useStartMonsterSkill(){
    let skillMappingList = monsterSkillMapping[data.battleMonster.name] || [];
    skillMappingList.filter(e => monsterSkills[e].type === 'start').forEach(e => {
        monsterSkills[e].use();
    })
}

//判断怪物是否使用技能。返回null则不适用，否则返回技能的数值和类型
function checkUseSkill(use){
    let skillMappingList = monsterSkillMapping[data.battleMonster.name] || [];
    let monsterSkillList = {...monsterSkills};

    //怪物物品DLC相关
    if(data.dlcMonsterItem && !isWorldBoss()){
        if(!data.battleMonster.hasItems){
            if(randomNum(1, 100) <= 10){
                const filter = Object.keys(monsterItemDlcSkills).filter(e => monsterItemDlcSkills[e].level <= data.battleMonster.level);
                data.battleMonster.hasItems = filter.derangedArray().slice(0,randomNum(1,parseInt(data.battleMonster.level / 10) + 1));
            }else{
                data.battleMonster.hasItems = [];
            }
        }
        skillMappingList = [...data.battleMonster.hasItems, ...skillMappingList]
        monsterSkillList = {...monsterSkillList, ...monsterItemDlcSkills}
    }

    //如果是禁魔状态，则禁止使用技能，代替普通攻击的技能除外
    if(isSeal(data.battleMonster)){
        skillMappingList = skillMappingList.filter(e => monsterSkillList[e].normalAtk);
    }

    if(skillMappingList){
        let skill = null;
        skillMappingList.forEach(e => {
            if(!skill && monsterSkillList[e].check(use)){
                skill = monsterSkillList[e];
            }
        })
        if(skill){
            return {
                name : skill.name,
                type : skill.type,
                num :skill.getNum(),
                use : skill.use,
                atr : skill.atr,
                normalAtk : skill.normalAtk,
                getStatus : skill.getStatus
            }
        }
    }

    return null;
}
