/**
 * 备注
 * 城市名：欧伦斯
 */

//创建NPC配置
function createNpcCfg(props = {}){
    return {
        gold : [100,1000],//随机的金币
        //可以随机到的职业
        profession : ['剑士','骑士','盗贼','奥术师','野蛮人','猎魔人','游侠'/*,'吟游诗人','牧师','圣骑士','预言家','舞娘'*/],
        ...props,
    }
}

//NPC配置
const npcCfg = {
    minNum : 20,//每个地图NPC的最小数量，小于这个数量就会刷新出新的NPC
    maxNum : 50,//每个地图NPC的最大数量，达到或者超过这个数量就不会刷新NPC了
    leaveEnterRate : 10,//NPC移动时直接进入或离开地图的概率，百分之
    taskRate : 30,//NPC拥有任务的概率，百分之

    loopTaskRate : 5,//任务为跑环任务的概率
    loopTaskPower : 50,//跑环任务多少环增加一倍奖励
    loopTaskMax : 300,//跑环任务最多多少环
    //完成一轮跑环可以获得的奖励
    loopTaskOverItems : ['坐骑：独角兽','神恩赐福','武器固化卷轴','护甲固化卷轴','虚空行走'],
    //完成一阶段轮跑环可以获得的奖励
    loopTaskOnceItems : ['神恩烹饪锅','水晶球','重生十字章'],

    camps : ['善良','中立','邪恶'],//阵营列表
    //性格列表
    characters : {
        谨慎 : {
            hasCampDetection : [2,5],//拥有阵营检测卷轴的数量
            useCampDetection : 100,//使用阵营检测的概率
        },
        普通 : {
            hasCampDetection : [0,2],
            useCampDetection : 30,
        },
        大意 : {
            hasCampDetection : [-2,1],
            useCampDetection : 10,
        },
    },
    //npc任务配置，不同的身份可以拥有的任务不同
    npcTaskCfg : {
        收集 : {
            type : ['行人','商人','猎人','士兵','冒险者'],//可以发布这个任务的NPC身份
            camp : ['善良','中立'],//可以发布这个任务的NPC阵营
            //任务文本
            texts : [
                '嗯，貌似还缺一些{name}，有点麻烦啊。啊，你愿意帮我弄一些来吗？',
                '你好，你愿意帮我弄一些{name}吗？我实在懒得动手了，我都忙了一天了。',
                '野外真是危险，但是我需要的东西还没凑齐，差的不多了，只是还需要一些{name}，你可以帮我弄来吗？',
                '最近看到很多人在收集{name}，我也想收集一些，如果你愿意帮我弄一些，我会给你报酬的。',
            ],
        },
        狩猎 : {
            type : ['行人','商人','猎人','士兵','冒险者'],
            camp : ['善良','中立'],
            texts : [
                '最近{name}越来越多了，已经影响正常通行了，现在发布了区域狩猎任务，你要接受吗？',
                '上次碰到一群{name}，突然窜出来的，吓我一跳，赶紧把他们都消灭吧。',
                '最近真奇怪，我以前从来没被{name}攻击过，前几天竟然被攻击了，是因为入侵者吗？',
                '{name}这种生物就不应该存在，该死的，他们太暴躁了，你愿意跟我一起狩猎它们吗？',
            ],
        },
        刺杀 : {
            type : ['行人','商人','猎人','士兵','冒险者'],
            camp : ['邪恶'],
            texts : [
                '这不是一个正义的活计，但是或许你会愿意接个私活？去把{name}杀掉吧，有人出了大价钱。',
                '干我们这行的，不会问你有什么办法完成任务，只会关心你能不能完成任务。杀掉{name}，证明你的能力吧。',
                '听着，如果你想要接这个任务，那么就不要多问，别管为什么，去杀掉{name}，然后回来找我领取赏金就行了，明白了吗？',
                '不要跟我说话，如果你不想成为目标的话。目标是{name}，去吧。',
            ],
        },
    },
    //各个类型的NPC
    types : {
        行人 : createNpcCfg({
            textList : [
                '据说有其他世界的入侵者来到我们的世界了，也不知道外面世界的人长什么样。',
                '野外的道路真难走。',
                '你看起来很面生啊，难道你就是外面世界的入侵者？',
                '在野外行走要小心怪物的偷袭。',
                '入侵者什么的跟我无关，反正有帝国在上面顶着呢。',
                '你有什么事吗？',
            ],
        }),
        商人 : createNpcCfg({
            gold : [200,2000],
            profession : ['剑士','盗贼','游侠'],
            textList : [
                '该死的，那些佣兵要价太高了。',
                '哎，这年头生意也不好做啊。',
                '你听说入侵者的事情了吗？也不知道来了多少人。',
                '因为入侵者，现在到处都戒严了，生意都变差了。',
                '我一定要成为欧伦斯最伟大的商人！',
            ],
        }),
        猎人 : createNpcCfg({
            profession : ['剑士','盗贼','猎魔人','游侠'],
            textList : [
                '猎人，一不小心就会变成猎物。',
                '你看到我的猎犬了吗？',
                '听说欧伦斯全城戒严了，因为有异世界的入侵者来到了我们的世界。',
                '为什么召集猎人追查入侵者的任务不让我参与呢，真是的。',
                '啊哈，这一趟真是大丰收啊！',
                '我的目标和那些没实力的猎人可不一样，我的目标是……哼，关你什么事。',
                '听说实力足够强的猎人都接到了追查入侵者的任务，我还需要努力啊。',
            ],
        }),
        士兵 : createNpcCfg({
            profession : ['剑士','盗贼','猎魔人','游侠'],
            textList : [
                '你看到可疑的人了吗？',
                '最近别乱跑，有其他世界的入侵者来到我们的世界了。',
                '听说入侵者正在肆意屠杀我们世界的生物，实在是太邪恶了！',
                '队长说入侵者的内心只有杀戮和破坏，好可怕的样子……',
                '一定要找出入侵者，荣耀属于欧伦斯！',
                '你看起来有点可疑啊，哈哈，我太敏感了吧，哪有那么巧让我遇上入侵者呢。',
            ],
        }),
        冒险者 : createNpcCfg({
            profession : ['剑士','盗贼','奥术师','野蛮人','猎魔人','游侠'],
            textList : [
                '每一次出门都是一次冒险，谁也不知道自己能不能活着回去。',
                '听说火绒冒险团前几天团灭了，真的是魔兽干的吗？',
                '火绒冒险团被魔兽团灭？怎么可能！那可是欧伦斯最强的冒险团，一定是入侵者干的！',
                '如果我能发现入侵者的踪迹，就能领到50万的赏金了，以后就不用再出来冒险了。',
                '这一块区域是我们大地之心冒险团的狩猎区，不想惹麻烦最好赶紧离开。',
                '入侵者到底有什么特点呢？就说有入侵者，其他什么信息也没有，这要怎么找呢。',
                '火绒冒险团的贝蒂小姐已经是传说级了吧，为什么还会被魔兽团灭呢？难以置信……',
                '听说这附近有神话生物出现，如果能狩猎到的话，那就发财了！',
            ],
        }),
    },
    //唯一NPC配置
    sole : {
        善良商店 : {
            name : '神圣选民',//名字
            camp : '善良',//阵营
            text : '你是心向光明之人，愿圣光忽悠……啊，不是，是护佑你。',//对话
            hateText : '你非心向光明之人，还是离开吧。',//对其他阵营的对话
            profession : '神圣选民',//职业
            //商品
            shop : {
                '一次性烹饪锅' : 1,
                '宓兰香精' : 1,
                '敌对感知卷轴' : 2,
                '捕捉缰绳' : 2,
                '精英缰绳' : 5,
                '传说缰绳' : 10,
                '神话缰绳' : 20,
                '装备保养油' : 10,
                '坐骑：皇家狮鹫' : 100,
                '坐骑：雷霆巨蜥' : 300,
                '坐骑：虚无梦魇' : 1000,
            },
        },
        /*邪恶商店 : {
            name : '黑暗行者',
            camp : '邪恶',
            text : '呵呵，你看起来不错嘛，有什么需要的吗？',
            hateText : '不敢拥抱黑暗，那你来找我干什么？想要拥抱死亡吗？呵呵',
            profession : '黑暗行者',
            shop : {
                '敌对感知卷轴' : 10
            },
        },*/
    },
    //profession : ['剑士','骑士','盗贼','奥术师','野蛮人','猎魔人','游侠'],
};

//初始化本地图的NPC
function initNpc(){
    if(!data.inDungeon && data.worldIndex >= 8){
        if(data.world.npcs){
            data.world.npcs = null;
        }
        return;
    }
    if(!data.inDungeon && !data.world.npcs){
        data.world.npcs = [];
        data.world.npcDate = data.date.format('yyyy-MM-dd');
        //类型列表
        const types = Object.keys(npcCfg.types);
        //随机数量
        const num = randomNum(npcCfg.minNum, npcCfg.maxNum);
        for(let i = 0 ; i < num ; i++){
            const type = types.getRandom();
            data.world.npcs.push(createNewNpc(type));
        }
    }
    if(data.world.npcs){
        let num = data.worldIndex + 1;
        num *= num;
        let hasGoodness = false;
        let hasEvil = false;
        data.world.npcs.forEach(e => {
            if(e.type === '善良商店'){
                hasGoodness = true;
            }
            /*if(e.type === '邪恶商店'){
                hasEvil = true;
            }*/
            if(!e.createDay){
                e.createDay = data.date.getTime()
            }
            const number = randomNum(1,100);
            if(e.rank == null){
                e.rank = number <= 1 ? '神话' : number <= 10 ? '传说' : number <= 30 ? '精英' : '';
            }
            if(e.gold == null){
                e.gold = randomNum(npcCfg.types[e.type].gold[0], npcCfg.types[e.type].gold[1]) * num;
            }
            if(!e.profession){
                e.profession = npcCfg.types[e.type].profession.getRandom();
            }
            if(!e.camp){
                e.camp = npcCfg.camps.getRandom();
            }
            if(e.initGold == null){
                e.initGold = e.gold;
            }
            if(!e.character){
                e.character = Object.keys(npcCfg.characters).getRandom();
                //随机阵营检测卷轴的数量
                const [min, max] = npcCfg.characters[e.character].hasCampDetection;
                const has = randomNum(min, max);
                if(has > 0){
                    if(!e.items){
                        e.items = {};
                    }
                    e.items['阵营检测卷轴'] = has;
                }
            }
            if(!e.task){
                e.task = createNpcTask(e);
            }
        })

        //创建阵营商店
        if(!hasGoodness){
            data.world.npcs.push(createNewNpc('善良商店'));
        }
        /*if(!hasEvil){
            data.world.npcs.push(createNewNpc('邪恶商店'));
        }*/
    }
}

//创建一个NPC
function createNewNpc(type){
    //创建阵营商店
    if(npcCfg.sole[type]){
        const {name, camp, text, profession} = npcCfg.sole[type];
        return {
            id : getNewId(),
            name,
            type,
            camp,
            character : Object.keys(npcCfg.characters).getRandom(),
            gold : 0,
            rank : '神话',
            createDay : data.date.getTime(),
            text,
            profession,
            location : [randomNum(0, xnum - 1),randomNum(0, ynum - 1)],//当前位置
            items : {},//携带物品
        };
    }

    //持有金币的倍率
    let num = data.worldIndex + 1;
    num *= num;
    //随机位阶数值
    const number = randomNum(1,100);

    const npc = {
        id : getNewId(),
        name : `${type}${npcNames.getRandom()}`,//名字
        type,//类型，即身份
        camp : npcCfg.camps.getRandom(),//阵营
        character : Object.keys(npcCfg.characters).getRandom(),//性格
        gold : randomNum(npcCfg.types[type].gold[0], npcCfg.types[type].gold[1]) * num,//持有金币
        rank : number <= 1 ? '神话' : number <= 10 ? '传说' : number <= 30 ? '精英' : '',//位阶
        createDay : data.date.getTime(),//创建时间
        text : npcCfg.types[type].textList.getRandom(),//对话文本
        profession : npcCfg.types[type].profession.getRandom(),//职业
        location : [randomNum(0, xnum - 1),randomNum(0, ynum - 1)],//当前位置
        items : {},//携带物品
    };
    npc.initGold = npc.gold;


    //创建任务
    npc.task = createNpcTask(npc);

    //随机阵营检测卷轴的数量
    const [min, max] = npcCfg.characters[npc.character].hasCampDetection;
    const has = randomNum(min, max);
    if(has > 0){
        npc.items['阵营检测卷轴'] = has;
    }

    return npc;
}

//创建NPC任务
function createNpcTask(npc){
    //随机任务概率
    const hasTask = (npc.task && npc.task.isLoopTask) || randomNum(1,100) <= npcCfg.taskRate;

    //没有任务直接返回over=true
    if(!hasTask){
        return {
            over : true
        };
    }

    //跑环任务概率
    const isLoopTask = (npc.task && npc.task.isLoopTask) || randomNum(1,100) <= npcCfg.loopTaskRate;

    //任务类型，根据阵营和身份随机，跑环任务不会出现刺杀任务
    let taskType = Object.keys(npcCfg.npcTaskCfg).filter(e => npcCfg.npcTaskCfg[e].camp.includes(npc.camp) && npcCfg.npcTaskCfg[e].type.includes(npc.type));

    if(isLoopTask && taskType.includes('刺杀')){
        taskType = taskType.filter(e => e !== '刺杀');
    }

    //没有可以发布的任务则直接返回over=true
    if(taskType.length === 0){
        return {
            over : true
        };
    }

    //创建任务
    const task = {
        isLoopTask,//是否跑环任务
        index : npc.task && npc.task.index ? npc.task.index + 1 : 1,//跑环任务序号
        over : false,//任务创建时固定未完成
        geted : false,//初始为未领取状态
        type : taskType.getRandom(),//任务类型
    };

    let power = 1;
    if(task.index >= npcCfg.loopTaskPower){
        power += parseInt(task.index / npcCfg.loopTaskPower)
    }

    if(task.type === '收集'){
        task.target = goods[data.world.name]['稀有物品'].filter(e => !e.startsWith('技能石') && !elementCfgs[e].onlyOne).getRandom();//随机目标物品
        task.need = data.worldIndex + 1;//随机需要的个数
        task.exp = parseInt(elementCfgs[task.target].gold / 2) * power;//随机任务给予的经验
        task.evil = (data.worldIndex + 1) * -1 * power;//给予的阵营值
        task.text = npcCfg.npcTaskCfg[task.type].texts.getRandom().replace('{name}', task.target);

    }else if(task.type === '狩猎'){
        task.target = getNpcRandomMonster(npc, true, true);//随机目标怪物
        task.need = (data.worldIndex + 1) * 5;//随机需要的个数
        task.exp = monsterCfgs[task.target].exp * task.need * power;//狩猎任务经验翻倍
        task.gold = parseInt((npc.initGold || npc.gold) / 2);//给金钱
        task.evil = 0;//狩猎任务不给阵营值
        task.text = npcCfg.npcTaskCfg[task.type].texts.getRandom().replace('{name}', task.target);

    }else if(task.type === '刺杀'){
        const targets = data.world.npcs.filter(e => e.id !== npc.id && !npcCfg.sole[e.type]);
        if(targets.length === 0){
            return {
                over : true
            };
        }
        const target = targets.getRandom();
        target.isKillTarget = true;
        task.target = target;//随机目标NPC
        task.need = 1;//需要的个数
        task.exp = 0;//刺杀任务不给经验
        task.gold = (npc.initGold || npc.gold) * 5;//给金钱
        task.evil = (data.worldIndex + 1) * power * 2;//给予的阵营值
        task.text = npcCfg.npcTaskCfg[task.type].texts.getRandom().replace('{name}', task.target.name || task.target);
    }

    return task;
}

//点击NPC
$('.body').on('click','.npc', function(){
    const id = $(this).attr('data-id');
    renderNpc(id)
})

//渲染NPC
function renderNpc(id){
    const npc = data.world.npcs.filter(e => e.id === id)[0];
    const {name, text, character, camp, items = {}, seeYouCamp, task = {}, type} = npc;

    if(npcCfg.sole[type]){
        if((npcCfg.sole[type].camp === '善良' && data.evil >= 0) || npcCfg.sole[type].camp === '邪恶' && data.evil <= 0){
            $('.alert-win').show().find('.alert-win-title').html(npcCfg.sole[type].hateText);
            return;
        }
    }

    //判断NPC主动检测玩家阵营
    if(data.race.name.startsWith("天使") || (!seeYouCamp && items['阵营检测卷轴'] > 0 && randomNum(1,100) <= npcCfg.characters[character].useCampDetection)){
        //消耗卷轴
        if(!data.race.name.startsWith("天使")){
            items['阵营检测卷轴']--;
            if(items['阵营检测卷轴'] <= 0){
                delete items['阵营检测卷轴'];
            }
        }
        //NPC不再检测你的阵营
        npc.seeYouCamp = true;

        //善良阵营的NPC有概率攻击罪恶值大于0的玩家
        if(camp === '善良' && randomNum(1,100) <= data.evil){
            npcAtkPlayer(npc);
            return;

        }else if(camp === '邪恶' && randomNum(1,100) <= -data.evil){//邪恶阵营有概率攻击罪恶值小于0的玩家
            npcAtkPlayer(npc);
            return;
        }else if(camp === '中立' && data.evil > 0){//中立阵营于是邪恶阵营的玩家会立刻离开
            data.world.npcs = data.world.npcs.filter(e => e.id !== id);
            $(`.npc[data-id=${id}]`).remove();
            $('.alert-win').show().find('.alert-win-title').html(`${name}发现你是邪恶阵营的存在，于是离开了`)
            return;
        }
    }

    if(task.over){
        $('.npc-task-menu').hide();
    }else{
        $('.npc-task-menu').show();
    }
    $('.npc-win .npc-name').html(name);
    $('.npc-win p').html(text);
    $('.npc-win-modal').show();
    $('.npc-win').show().attr('data-id', id);
}

//NPC主动攻击玩家
function npcAtkPlayer(npc){
    msg(`你被${npc.name}攻击了`);
    startBattle(npc.profession, false, false, true, npc.id)
    setTimeout(() => {
        if(inBattle()){
            $('.battle').show();
            $('.stop-auto-battle').hide();
        }
    },30)
}

//NPC移动
function npcMove(){
    if(!data.inDungeon && data.world.npcs && data.world.npcDate !== data.date.format('yyyy-MM-dd')){
        data.world.npcDate = data.date.format('yyyy-MM-dd')
        //NPC离开
        data.world.npcs = data.world.npcs.filter(e => {
            //玩家接了任务且未完成的NPC不会离开
            if(e.task && e.task.geted && !e.task.over){
                return true;
            }
            //刺杀目标，且发布任务的NPC还在时，不会离开
            if(e.isKillTarget && data.world.npcs.filter(n => n.task.type==='刺杀' && n.task.target.id===e.id).length){
                return true;
            }
            //阵营商店不会离开
            if(npcCfg.sole[e.type]){
                return true;
            }
            if(data.world.npcs.length <= npcCfg.minNum){
                return true;
            }
            if(data.world.npcs.length >= npcCfg.maxNum){
                return false;
            }
            return randomNum(0,100) > npcCfg.leaveEnterRate;
        })

        //NPC移动
        data.world.npcs.forEach(e => {
            //玩家接了任务且未完成的NPC不会移动和采集打怪等
            if(e.task && e.task.geted && !e.task.over){
                return;
            }
            //阵营商店不会移动和采集打怪等
            if(npcCfg.sole[e.type]){
                return true;
            }
            e.location = getMoveLocation(e.location);
            //更新刺杀任务的坐标
            let ts = data.world.npcs.filter(n => n.task.type==='刺杀' && n.task.target.id===e.id);
            if(ts.length){
                ts.forEach(n => {
                    n.task.target.location = e.location;
                })
            }

            //判断本次移动是采集还是战斗
            const terrainElement = terrainElements[data.world.map[e.location[1]][e.location[0]]];
            if(terrainElement){
                const number = randomNum(1,100);
                if(!e.items){
                    e.items = {};
                }

                if(number <= 50){//采集
                    if(terrainElement.elements){
                        const {canGather, num, getItem} = elementCfgs[Object.keys(terrainElement.elements).getRandom()];
                        if(canGather){
                            //循环采集次数
                            for(let i = 0 ; i < num ; i++){
                                //循环采集物品
                                getItem.forEach(i => {
                                    const {name, minNum, maxNum} = i;
                                    const num = randomNum(minNum, maxNum);
                                    if(num > 0){
                                        if(!e.items[name]){
                                            e.items[name] = 0;
                                        }
                                        e.items[name] += num;
                                    }
                                })
                            }
                        }
                    }
                }else{//战斗
                    if(terrainElement.monster){
                        const monsters = Object.keys(terrainElement.monster).filter(m => npcCanKillMonster(e.rank, m));
                        if(monsters.length > 0){
                            const {items} = monsterCfgs[monsters.getRandom()];
                            //循环掉落物
                            items.forEach(i => {
                                const {name, minNum, maxNum} = i;
                                const num = randomNum(minNum, maxNum);
                                if(num > 0){
                                    if(!e.items[name]){
                                        e.items[name] = 0;
                                    }
                                    e.items[name] += num;
                                }
                            })
                        }
                    }
                }
            }
        })

        //类型列表
        const types = Object.keys(npcCfg.types);
        //NPC加入
        for(let i = data.world.npcs.length ; i <= npcCfg.maxNum ; i++){
            if(data.world.npcs.length >= npcCfg.maxNum){
                continue;
            }
            if(data.world.npcs.length < npcCfg.minNum || randomNum(1,100) <=  npcCfg.leaveEnterRate){
                data.world.npcs.push(createNewNpc(types.getRandom()));
            }
        }
    }
}

//校验怪物是否可以被这个NPC击杀
function npcCanKillMonster(npcType, monster){
    if(monsterCfgs[monster].level >= data.world.level[0] - (monsterCfgs[monster].type ? 10 : 0) && monsterCfgs[monster].level <= data.world.level[1]){
        if(npcType === '神话'){
            return true;
        }
        if(npcType === '传说'){
            return monsterCfgs[monster].type !== '神话';
        }
        if(npcType === '精英'){
            return monsterCfgs[monster].type !== '神话' && monsterCfgs[monster].type !== '精英';
        }
        return !monsterCfgs[monster].type;
    }
    return false;
}


//获取移动后的位置
function getMoveLocation(location){
    const [x,y] = location;
    //存放可前往的坐标
    const xarray = [];
    const yarray = [];
    if(x > 0){
        xarray.push(x - 1);
    }
    if(x < xnum - 1){
        xarray.push(x + 1);
    }
    if(y > 0){
        yarray.push(y - 1);
    }
    if(y < ynum - 1){
        yarray.push(y + 1);
    }

    //1则移动x坐标，2则移动y坐标
    const flag = randomNum(1,2);
    if(flag === 1){
        return [xarray.getRandom(), y];
    }else{
        return [x, yarray.getRandom()];
    }
}

//点击交易
$('.npc-shop-menu').click(function(){
    renderNpcShop();
});

//点击任务
$('.npc-task-menu').click(function(){
    renderNpcTask();
});

//渲染NPC任务
function renderNpcTask() {
    const id = $('.npc-win').attr('data-id');
    if (id) {
        const npc = data.world.npcs.filter(e => e.id === id)[0];
        let {geted, type, target, need, now = 0, exp, gold, evil, text, index = 0, isLoopTask} = npc.task;

        if(type === '收集'){
            now = getNumByBag(target)
        }

        if(isLoopTask){
            $('.npc-task-loop').html(`跑环任务：第${index}环`);
        }else{
            $('.npc-task-loop').html('');
        }
        $('.npc-task-name').html(type + (target.name || target));
        $('.npc-task-text').html(geted ? '你需要确认任务目标吗？自己看吧。' : text);
        $('.npc-task-target').html(`任务目标：${(target.name || target)}${target.location ? `[${target.location.join()}]` : `<span class="to-cybernet" data-name="${target}">🔍</span>`}`);
        $('.npc-task-now').html(`完成情况：${now}/${need}${geted ? '' : '(未领取)'}`);
        if(exp){
            $('.npc-task-exp').show().html(`奖励经验值：${exp}`);
        }else{
            $('.npc-task-exp').hide();
        }
        if(gold){
            $('.npc-task-gold').show().html(`奖励金币：${gold}`);
        }else{
            $('.npc-task-gold').hide();
        }
        if(evil){
            $('.npc-task-evil').show().html(`奖励阵营值：${evil > 0 ? '邪恶+' + evil : '善良+' + -evil}`);
        }else{
            $('.npc-task-evil').hide();
        }

        $('.over-task').hide();
        if(geted){
            $('.get-task').hide();
            $('.stop-task').show();
            if(now >= need){
                $('.over-task').show();
            }
        }else{
            $('.get-task').show();
            $('.stop-task').hide();
        }

        $('.npc-task-win').show();
    }
}

//渲染NPC页面信息页面
function renderNpcTaskInfo(){
    if(data.world.npcs){
        $('.task-info').html('');
        //获取已领取未完成的任务
        const taskNpcs = data.world.npcs.filter(e => e.task.geted && !e.task.over);
        taskNpcs.forEach(e => {
            let {type, target, need, now = 0, exp, gold, evil, isLoopTask, index} = e.task;

            if(type === '收集'){
                now = getNumByBag(target)
            }

            let html = '';
            html += `<div class="panel ${now >= need ? 'success' : ''}">`;
            html += `    <h5>${type + (target.name || target)}</h5>`;
            if(isLoopTask){
                html += `    <span>跑环任务：第${index}环</span><br>`;
            }
            html += `    <span>发布人：${e.name}[${e.location.join()}]</span><u class="to-npc" data-location="${e.location.join()}">传送</u><br>`;
            html += `    <span>任务目标：${(target.name || target)}${target.location ? `[${target.location.join()}]<u class="to-npc" data-location="${target.location.join()}">传送</u>` : `<span class="to-cybernet" data-name="${target}">🔍</span>`}</span><br>`;
            html += `    <span>完成情况：${now}/${need}</span><br>`;
            if(exp){
                html += `<span>奖励经验值：${exp}</span><br>`;
            }
            if(gold){
                html += `<span>奖励金币：${gold}</span><br>`;
            }
            if(evil){
                html += `<span>奖励阵营值：${evil > 0 ? '邪恶+' + evil : '善良+' + -evil}</span><br>`;
            }
            html += `</div>`;
            $('.task-info').append(html)
        })
    }
}

//传送至NPC
$('.task-info').on('click','.to-npc',function(){
    if(!data.race.name.startsWith('星灵')){
        let numByBag = getNumByBag('小型传送阵', data.location.join() === data.world.home.location.join());
        if(numByBag < 1){
            winMsg('需要消耗1个小型传送阵', false, false)
            return;
        }
        reduceItemByAll('小型传送阵')
    }

    if(!confirm(`是否确认要传送到该NPC所在位置？`)){
        return false;
    }

    const location = $(this).attr('data-location');
    if(location){
        const [x,y] = location.split(',');
        data.location = [parseInt(x), parseInt(y)];
        msg(`传送到了[${data.map[y][x]}]`);

        //将当前坐标和四周坐标设置为已探索
        setShowMap();
        //渲染可前往的地图
        renderCanToMap();
        //重新渲染地图
        renderMapElements();

        $('.task-data').hide();
        save();
    }
});

//领取任务
$('.get-task').click(function(){
    const id = $('.npc-win').attr('data-id');
    if(id){
        const npc = data.world.npcs.filter(e => e.id === id)[0];
        const {need, now = 0} = npc.task;
        npc.task.geted = true;
        renderNpcTask()
        save();
    }
})

//拒绝任务
$('.stop-task').click(function(){
    if(!confirm('任务拒绝后无法再领取，拒绝刺杀任务后还会导致NPC攻击你，确认拒绝吗？')){
        return;
    }
    const id = $('.npc-win').attr('data-id');
    if(id){
        const npc = data.world.npcs.filter(e => e.id === id)[0];
        npc.task.geted = false;
        npc.task.over = true;
        save();
        if(npc.task.type === '刺杀'){
            const ts = data.world.npcs.filter(e => e.id === npc.task.target.id);
            if(ts.length > 0){
                ts[0].isKillTarget = false;
            }
            $('.npc-win-modal').hide();
            $('.npc-win').hide();
            npcAtkPlayer(npc);
        }else{
            $('.npc-task-win').hide();
            renderNpc(id)
        }
    }
})

//领取任务奖励
$('.over-task').click(function(){
    const id = $('.npc-win').attr('data-id');
    if(id){
        const npc = data.world.npcs.filter(e => e.id === id)[0];
        const {exp, gold, evil, target, need, type, isLoopTask, index} = npc.task;
        const msg = [];

        if(type === '收集'){
            reduceItem(target, need)
            msg.push(`交出了${target}*${need}`);
            if(!npc.items){
                npc.items = {};
            }
            if(!npc.items[target]){
                npc.items[target] = 0;
            }
            npc.items[target] += need;
        }

        if(exp){
            msg.push(`获得了${addExp(exp, monsterCfgs[target] ? monsterCfgs[target].level : data.maps[data.worldIndex].level[1])}经验`);
        }
        if(gold){
            data.gold += gold;
            msg.push(`获得了${gold}金币`);
        }
        if(evil){
            addEvil(evil);
            if(evil < 0){
                npc.evil = (npc.evil || 0) + evil;
            }
            msg.push(`获得了${evil > 0 ? evil : -evil}${evil > 0 ? '邪恶' : '善良'}阵营值`);
        }

        if(isLoopTask && index < npcCfg.loopTaskMax){
            npc.task = createNpcTask(npc);
            npc.task.geted = true;
            renderNpcTask();
        }else{
            npc.task.over = true;
            npc.task.geted = false;
        }
        winMsg(`你完成了任务[${type + (target.name || target)}]，${msg.join('，')}`)
        level();

        //完成一阶段跑环
        if(index > 0 && index % npcCfg.loopTaskPower === 0){
            if(randomNum(1,100) <= (data.worldIndex + 1) * parseInt(index / npcCfg.loopTaskPower)){
                const random = npcCfg.loopTaskOnceItems.getRandom();
                addItem(random);
                winMsg(`看在你努力的份上，任务委托人给了你一个${random}`)
            }
        }//isLoopTask

        //完成一轮跑环
        if(index >= npcCfg.loopTaskMax){
            const random = npcCfg.loopTaskOverItems.getRandom();
            addItem(random);
            const num = randomNum(parseInt((data.worldIndex + 1) / 4), parseInt((data.worldIndex + 1) / 2));
            winMsg(`你完成了一轮跑环任务，获得了一个${random}`)
            if(num > 0){
                addItem('神恩赐福', num)
                winMsg(`你的善良让神感受到了，你额外获得了${num}个神恩赐福`)
            }
        }

        if(!npc.task.geted){
            $('.npc-task-win').hide();
        }
        renderNpc(id)
        renderBag();
        save();
    }
})

//渲染NPC交易
function renderNpcShop(){
    const id = $('.npc-win').attr('data-id');
    if(id){
        $('.npc-shop-win-items').html('');
        const npc = data.world.npcs.filter(e => e.id === id)[0];

        //渲染阵营商店
        if(npcCfg.sole[npc.type]){
            renderCampShop(npc)
            return;
        }

        $('.your-gold').html(data.gold || 0);
        $('.npc-gold').html(npc.gold);
        const active = $('.npc-shop-win .active').html();
        if(active === '购买'){
            if(npc.items && Object.keys(npc.items).length > 0){
                let html = ``;
                Object.keys(npc.items).forEach(e => {
                    const gold = parseInt(elementCfgs[e].gold * 0.8) || 1;
                    html += `<div class="npc-shop-win-item">`;
                    html += `<h5>${e}<span class="to-cybernet" data-name="${e}">🔍</span> * ${npc.items[e]}</h5>`;
                    html += `<div class="npc-price">售价：${gold}金币</div>`;
                    html += `<button class="buy-npc-item" data-name="${e}" data-id="${id}" data-num="1">买1个</button>`;
                    html += `<button class="buy-npc-item" data-name="${e}" data-id="${id}" data-num="10">买10个</button>`;
                    html += `<button class="buy-npc-item" data-name="${e}" data-id="${id}" data-num="1000000">买全部</button>`;
                    html += `</div>`;
                })
                $('.npc-shop-win-items').append(html)
            }
        }else{
            let html = '';
            data.bag.forEach(e => {
                if(data.armor && data.armor.id === e.id){
                    return;
                }
                if(data.bagEquip && data.bagEquip.id === e.id){
                    return
                }
                if(data.weapon && data.weapon.id === e.id){
                    return;
                }
                if(data.mount && data.mount.id === e.id){
                    return;
                }
                if(e.isLock){
                    return;
                }

                const gold = parseInt(elementCfgs[e.name].gold * 0.25);
                if(gold <= 0){
                    return;
                }

                html += `<div class="npc-shop-win-item">`;
                html += `<h5>${e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span> * ${getNumByBag(e.name)}</h5>`;
                html += `<div class="npc-price">出价：${gold}金币</div>`;
                html += `<button class="sell-npc-item" data-itemId="${e.id}" data-id="${id}" data-num="1">卖1个</button>`;
                html += `<button class="sell-npc-item" data-itemId="${e.id}" data-id="${id}" data-num="10">卖10个</button>`;
                html += `<button class="sell-npc-item" data-itemId="${e.id}" data-id="${id}" data-num="1000000">卖全部</button>`;
                html += `</div>`;
            })
            $('.npc-shop-win-items').append(html);
        }

        $('.npc-shop-win').show();
    }
}

//渲染阵营商店
function renderCampShop(npc){
    const {type} = npc;
    const {shop} = npcCfg.sole[type];
    const showShop = {
        ...shop,
    }
    if(data.dlcFateMonth){
        showShop['命运干扰'] = 20;
    }

    $('.camp-shop-win-items').html('');
    $('.camp-shop-evil').html('阵营点数：' + (data.evil > 0 ? data.evil : -data.evil))
    let html = ``;
    Object.keys(showShop).forEach(e => {
        html += `<div class="camp-shop-win-item">`;
        html += `<h5>${e}<span class="to-cybernet" data-name="${e}">🔍</span></h5>`;
        html += `<div class="camp-price">售价：${showShop[e]}点</div>`;
        html += `<button class="buy-camp-item" data-name="${e}" data-point="${showShop[e]}" data-num="1">买1个</button>`;
        html += `<button class="buy-camp-item" data-name="${e}" data-point="${showShop[e]}" data-num="10">买10个</button>`;
        html += `<button class="buy-camp-item" data-name="${e}" data-point="${showShop[e]}" data-num="1000">买1000个</button>`;
        html += `</div>`;
    })
    $('.camp-shop-win-items').append(html)
    $('.camp-shop-win').show();
}
//点击购买阵营商店的商品
$('.camp-shop-win-items').on('click', '.buy-camp-item', function(){
    const name = $(this).attr('data-name');
    const point = parseInt($(this).attr('data-point'));
    let num = parseInt($(this).attr('data-num'));
    const has = data.evil < 0 ? -data.evil : data.evil;
    const camp = data.evil < 0 ? '善良' : '邪恶';

    if(has < point){
        winMsg(`阵营点不足`, false, false)
        return;
    }

    const max = parseInt(has / point);
    if(max < num){
        num = max;
    }
    const need = point * num;

    if(data.evil < 0){
        data.evil += need;
    }else{
        data.evil -= need;
    }
    addItem(name, num);
    winMsg(`你花费了${need}${camp}阵营点数，购买了${name}*${num}`)
    save();
    $('.camp-shop-evil').html('阵营点数：' + (data.evil > 0 ? data.evil : -data.evil))
})

//点击购买NPC的商品
$('.npc-shop-win-items').on('click', '.buy-npc-item', function(){
    const id = $(this).attr('data-id');
    const name = $(this).attr('data-name');
    let num = parseInt($(this).attr('data-num'));
    const npc = data.world.npcs.filter(e => e.id === id)[0];
    const has = npc.items[name];
    const gold = parseInt(elementCfgs[name].gold * 0.8) || 1;
    //避免购买的数量超出NPC持有数量
    if(num > has){
        num = has;
    }
    let need = gold * num;

    //避免金币不足
    if(data.gold < gold){
        winMsg('金币不足', false, false)
        return;
    }
    if(data.gold < need){
        num = parseInt(data.gold / gold);
        need = gold * num
    }

    data.gold -= need;
    data.gold = parseFloat2Fiexd(data.gold);
    addItem(name, num);
    npc.gold += need;
    npc.items[name] -= num;
    //删除已经没有持有的物品
    if(npc.items[name] <= 0){
        delete npc.items[name];
    }

    winMsg(`你向${npc.name}购买了${name}*${num}`)
    save();
    renderNpcShop();
})

//点击出售物品给NPC
$('.npc-shop-win-items').on('click', '.sell-npc-item', function(){
    const id = $(this).attr('data-id');
    const itemId = $(this).attr('data-itemId');
    const item = getBagItemById(itemId);
    const name = item.name;
    let num = parseInt($(this).attr('data-num'));
    const has = getNumByBag(name);
    const npc = data.world.npcs.filter(e => e.id === id)[0];
    const gold = parseInt(elementCfgs[name].gold * 0.25);
    //避免购买的数量超出NPC持有数量
    if(num > has){
        num = has;
    }
    let need = gold * num;

    //避免金币不足
    if(npc.gold < gold){
        winMsg(`${npc.name}的金币不足`, false, false)
        return;
    }

    if(npc.gold < need){
        num = parseInt(npc.gold / gold);
        need = gold * num;
    }

    npc.gold -= need;
    reduceItemById(itemId, num);
    data.gold += need;
    data.gold = parseFloat2Fiexd(data.gold);
    if(!npc.items){
        npc.items = {};
    }
    if(!npc.items[name]){
        npc.items[name] = 0;
    }
    npc.items[name] += num;

    winMsg(`你向${npc.name}出售了${name}*${num}`)
    save();
    renderNpcShop();
})

//点击攻击NPC
$('.atk-npc-menu').click(function(){
    if(!confirm('是否确认主动发起攻击？可能造成极其严重的后果，请确保你已经熟读图鉴-说明-居民战斗')){
        return;
    }
    const id = $('.npc-win').attr('data-id');
    if(id) {
        const npc = data.world.npcs.filter(e => e.id === id)[0];
        startBattle(npc.profession, true, false, true, id)
        $('.npc-win-modal').hide();
        $('.npc-win').hide();
    }
});
