//种族类
function Race(props = {}){
    for(const key in props){
        this[key] = props[key];
    }
}
Race.prototype = {
    challenge : false, //是否挑战种族
    name : '人类',
    hp : 200,//初始生命
    hunger : 100,//初始饥饿
    water : 100,//初始水分
    weight : 100,//初始负重
    atk : 3,//初始攻击
    def : 0,//初始防御
    hpUp : 10,//升级提升生命值
    hungerUp : 2,//升级提升饥饿
    waterUp : 2,//升级提升水分
    weightUp : 5,//升级提升负重
    atkUp : 0,//升级提升攻击
    defUp : 0,//升级提升防御
    attrPoint : 131401,//升级获得属性点
    atkSpd : 3,//攻击速度
    text : null,//说明文本
    initItems : [],//初始物品
    recipes : [],//种族专属配方
    get : '自动解锁',//解锁方式说明
    //获取是否时无饥饿种族
    getNoHunger(){
        return !!this.noHunger;
    },
    //获取攻击速度
    getAtkSpd(){
        return data.race.atkSpd + data.atkSpd + (data.weapon ? data.weapon.atkSpd || 0 : 0);
    },
    //种族技能
    skills : {},
    //初始信仰和神眷
    deity : null,
    //升级所需经验公式
    getLevelUpExp(){
        return data.level * data.level * 10;
    },
    //创建人物时调用
    onCreate(){

    },
    //转职为这个职业时调用
    onToRace(){

    }
};

//种族列表
const races = {
    '教学种族' : new Race({
        name : '教学种族',
        hunger : 200,//初始饥饿
        water : 200,//初始水分
        weight : 500,//初始负重
        atk : 5,//初始攻击
        def : 0,//初始防御
        hp : 300,//初始生命
        hpUp : 20,//升级提升生命值
        hungerUp : 10,//升级提升饥饿
        waterUp : 10,//升级提升水分
        weightUp : 20,//升级提升负重
        atkUp : 0,//升级提升攻击
        defUp : 0,//升级提升防御
        attrPoint : 131402,//升级获得属性点
        initItems : [{name : '短程传送卷轴', num : 10}, {name : '重生十字章', num : 10}, {name : '草药膏', num : 50}],
        text : '为了让新玩家熟悉基本玩法的种族，建议熟悉了后就换其他种族，因为教学种族毫无强度和游戏性可言，且不能完成成就，不能使用镶嵌物仓库'
    }),
    '人类' : new Race({
        name : '人类',
        initItems : [{name : '技能石：血气斩', num : 1}, {name : '浆果', num : 10}, {name : '水', num : 10}],
        skills : {
            '血气斩' : createRecipesCfg({'肉' : 1}),
        },
        text : '生命上限越高，伤害越高'
    }),
    '人类-战士' : new Race({
        name : '人类-战士',
        attrPoint : 131403,
        godRace : '人类-神孽',//对应的2觉种族
        skills : {
            '血气斩' : createRecipesCfg({'肉' : 1}),
            '浴血奋战' : createRecipesCfg({'肉' : 1})
        },
        text : '人类一次觉醒种族，比其他一觉种族多了1点属性点，愈战愈勇'
    }),
    '人类-神孽' : new Race({
        name : '人类-神孽',
        attrPoint : 131403,
        skills : {
            '血气斩' : createRecipesCfg({'肉' : 1}),
            '浴血奋战' : createRecipesCfg({'肉' : 1}),
            '狂暴治疗' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '人类-战士二次觉醒种族，受伤越重，恢复能力越强'
    }),
    '人类-法师' : new Race({
        name : '人类-法师',
        hpUp : 8,
        weightUp : 4,
        attrPoint : 131402,
        godRace : '人类-元素师',
        skills : {
            '寒冰箭' : createRecipesCfg({'魔晶石' : 1}),
            '火球术' : createRecipesCfg({'魔晶石' : 1})
        },
        onToRace(){
            data.spi = 600;
        },
        text : '人类一次觉醒种族，能使用魔法，拥有精神属性，精神上限为等级*10，睡觉时每15分钟恢复5点精神，没睡觉时每15分钟恢复1点精神，没有饥饿和水分也不会影响精神的恢复'
    }),
    '人类-元素师' : new Race({
        name : '人类-元素师',
        hpUp : 8,
        weightUp : 4,
        attrPoint : 131402,
        skills : {
            '寒冰箭' : createRecipesCfg({'魔晶石' : 1}),
            '火球术' : createRecipesCfg({'魔晶石' : 1}),
        },
        text : '人类-法师二次觉醒种族，掌握瞬发技巧，使用法术不需要念咒，精神上限变为等级 * 30，精神恢复速度翻倍'
    }),
    '史莱姆' : new Race({
        name : '史莱姆',
        hp : 250,
        hunger :120,
        water :120,
        weight : 80,
        atk : 2,
        def : 1,
        initItems : [{name : '技能石：吞噬', num : 1000}, {name : '粘液', num : 10}],
        skills : {
            '吞噬' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '消化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '腐蚀' : createRecipesCfg({'粘液' : 1}),
            '强酸腐蚀' : createRecipesCfg({'强酸粘液' : 1})
        },
        text : '恢复强，伤害高，就是打材料麻烦'
    }),
    '史莱姆-强酸' : new Race({
        name : '史莱姆-强酸',
        hp : 250,
        hunger :120,
        water :120,
        weight : 80,
        atk : 5,
        def : 1,
        attrPoint : 131402,
        godRace : '史莱姆-毒液',
        skills : {
            '吞噬' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '消化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '腐蚀' : createRecipesCfg({'粘液' : 1}),
            '强酸腐蚀' : createRecipesCfg({'强酸粘液' : 1}),
            '强酸护甲' : createRecipesCfg({'强酸粘液' : 1}, 0, null, 1000)
        },
        text : '史莱姆一次觉醒种族，能用强酸保护自己，并对攻击者造成伤害'
    }),
    '史莱姆-毒液' : new Race({
        name : '史莱姆-毒液',
        hp : 250,
        hunger :120,
        water :120,
        weight : 80,
        atk : 5,
        def : 1,
        attrPoint : 131402,
        skills : {
            '吞噬' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '消化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '腐蚀' : createRecipesCfg({'粘液' : 1}),
            '强酸腐蚀' : createRecipesCfg({'强酸粘液' : 1}),
            '强酸护甲' : createRecipesCfg({'强酸粘液' : 1}, 0, null, 1000),
            '枯朽' : createRecipesCfg({'枯朽粘液' : 1}),
        },
        text : '史莱姆-强酸二次觉醒种族，含有剧毒'
    }),
    '史莱姆-巨化' : new Race({
        name : '史莱姆-巨化',
        hp : 400,
        hunger : 200,
        water : 200,
        weight : 200,
        hpUp : 20,
        hungerUp : 5,
        waterUp :5,
        atk : 3,
        def : 2,
        attrPoint : 131402,
        godRace : '史莱姆-王者',
        skills : {
            '吞噬' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '消化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '分裂' : createRecipesCfg({'粘液' : 1}, 0, null, 1000)
        },
        text : '史莱姆一次觉醒种族，拥有巨大的身体，能承受更多的伤害，同时拥有恐怖的恢复能力'
    }),
    '史莱姆-王者' : new Race({
        name : '史莱姆-王者',
        hp : 500,
        hunger : 200,
        water : 200,
        weight : 200,
        hpUp : 40,
        hungerUp : 5,
        waterUp :5,
        atk : 3,
        def : 2,
        attrPoint : 131402,
        skills : {
            '吞噬' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '消化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '分裂' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '王者护卫' : createRecipesCfg({'粘液' : 1}, 0, null, 1000)
        },
        text : '史莱姆-巨化二次觉醒种族，作为一个王者，最重要的是活着，所以生命力极其浑厚'
    }),
    '哥布林' : new Race({
        name : '哥布林',
        hp : 100,
        hunger : 70,
        water : 70,
        atk : 5,
        initItems : [{name : '技能石：偷袭', num : 1}],
        skills : {
            '偷袭' : createRecipesCfg({'魔晶石' : 1}),
            '伪装求饶' : createRecipesCfg({'魔晶石' : 1}),
            '偷窃' : createRecipesCfg({'魔晶石' : 1}),
            '神之手指' : createRecipesCfg({'神性结晶' : 1})
        },
        text : '哥布林总是十分猥琐小心，显得十分弱小。在你攻击或者使用投掷品之前，怪物会信心爆棚，并对你不屑一顾，此时怪物对你的造成的伤害减少30%，该减伤可以和盾牌其他减伤效果叠加（例如装备了龙盾的情况下，就是总共70%减伤）'
    }),
    '哥布林-商人' : new Race({
        name : '哥布林-商人',
        hp : 150,
        hunger : 70,
        water : 70,
        atk : 5,
        attrPoint : 131402,
        godRace : '哥布林-神壕',
        skills : {
            '伪装求饶' : createRecipesCfg({'魔晶石' : 1}),
            '偷窃' : createRecipesCfg({'魔晶石' : 1}),
            '神之手指' : createRecipesCfg({'神性结晶' : 1}),
            '行商' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000)
        },
        text : '哥布林一次觉醒种族，保留了哥布林的减伤特性，并拥有打开一个专属交易页面的功能，在专属交易页面中，可以无限制购买本层出售的所有商品，并且在专属交易页面出售物品时半价出售，而非五分之一价格出售'
    }),
    '哥布林-神壕' : new Race({
        name : '哥布林-神壕',
        hp : 150,
        hunger : 70,
        water : 70,
        atk : 5,
        attrPoint : 131402,
        getLevelUpExp(){
            let rate = 1;
            if(data.level > 130){
                rate += parseInt((data.level - 130) / 10);
            }
            return data.level * data.level * 10 * rate;
        },
        skills : {
            '伪装求饶' : createRecipesCfg({'魔晶石' : 1}),
            '偷窃' : createRecipesCfg({'魔晶石' : 1}),
            '神之手指' : createRecipesCfg({'神性结晶' : 1}),
            '行商' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000),
            '金钱至上' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000),
            '金钱万岁' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000),
        },
        text : '哥布林-商人二次觉醒种族，可以用金钱直接购买等级，但是从130级开始，升级经验每过10级提高1倍。即140级以下，升级经验和常规种族一样。140级~149级，需要2倍升级经验，150~159级需要3倍升级经验，160~169级需要4倍升级经验，以此类推。'
    }),
    '哥布林-卑劣者' : new Race({
        name : '哥布林-卑劣者',
        hp : 100,
        hunger : 100,
        water : 100,
        atk : 5,
        atkUp : 1,
        hpUp :5,
        attrPoint : 131402,
        godRace : '哥布林-恶徒',
        skills : {
            '抽刀' : createRecipesCfg({'魔晶石' : 1}),
            '夺目' : createRecipesCfg({'魔晶石' : 1}),
            '放血' : createRecipesCfg({'魔晶石' : 1})
        },
        text : '哥布林一次觉醒种族，保留了哥布林的减伤特性，擅长以卑劣的手段攻击敌人，虽然脆弱，却极具攻击性'
    }),
    '哥布林-恶徒' : new Race({
        name : '哥布林-恶徒',
        hp : 100,
        hunger : 100,
        water : 100,
        atk : 5,
        atkUp : 1,
        hpUp :5,
        attrPoint : 131402,
        skills : {
            '抽刀' : createRecipesCfg({'魔晶石' : 1}),
            '夺目' : createRecipesCfg({'魔晶石' : 1}),
            '放血' : createRecipesCfg({'魔晶石' : 1}),
            '疯狂连击' : createRecipesCfg({'魔晶石' : 1})
        },
        text : '哥布林-卑劣者二次觉醒种族，理论上有可能打出无限连'
    }),
    '扑克人' : new Race({
        name : '扑克人',
        initItems : [{name : '技能石：黑桃', num : 1000},{name : '技能石：红桃', num : 1000},{name : '技能石：梅花', num : 1},{name : '技能石：方片', num : 1000}],
        skills : {
            '黑桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '红桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '梅花' : createRecipesCfg({'纤维' : 1}),
            '方片' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        },
        text : '曾经最强初始种族，后来被作者削弱了，不过依旧可能是最强种族'
    }),
    '扑克人-游侠' : new Race({
        name : '扑克人-游侠',
        attrPoint : 131402,
        godRace : '扑克人-剑神',
        skills : {
            '黑桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '红桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '梅花' : createRecipesCfg({'纤维' : 1}),
            '方片' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '重置' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '连击' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        },
        text : '扑克人一次觉醒种族，擅长连击'
    }),
    '扑克人-剑神' : new Race({
        name : '扑克人-剑神',
        attrPoint : 131402,
        skills : {
            '黑桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '红桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '梅花' : createRecipesCfg({'纤维' : 1}),
            '方片' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '重置' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '连击' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '开天' : createRecipesCfg({'纤维' : 1}),
        },
        text : '扑克人-游侠二次觉醒种族，擅长爆发'
    }),
    '扑克人-反王' : new Race({
        name : '扑克人-反王',
        attrPoint : 131402,
        godRace : '扑克人-全王',
        skills : {
            '黑桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '红桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '梅花' : createRecipesCfg({'纤维' : 1}),
            '方片' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '重置' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '红王' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '黑王' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        },
        text : '扑克人一次觉醒种族，擅长强化花色'
    }),
    '扑克人-全王' : new Race({
        name : '扑克人-全王',
        attrPoint : 131402,
        skills : {
            '黑桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '红桃' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '梅花' : createRecipesCfg({'纤维' : 1}),
            '方片' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '重置' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '红王' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '黑王' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '全王' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        },
        text : '扑克人-反王二次觉醒种族，强化所有花色'
    }),
    '开拓者' : new Race({
        challenge : true,
        name : '开拓者',
        hp : 100,
        hungerUp : 0,
        waterUp : 0,
        weightUp : 0,
        attrPoint : 131400,
        getLevelUpExp(){
            return data.level * data.level * 5;
        },
        initItems : [{name : '短程传送卷轴', num : 3}],
        text : '挑战种族。开拓者不能使用镶嵌物仓库，不能使用种族周目商店，无法获得其他角色周目的周目礼包（自身跳周目可以获得礼包），无法获得神话诅咒，逃跑成功率30%，每10分钟减少一次状态（其他种族为15分钟），升级所需的经验减半',
    }),
    '寒影' : new Race({
        challenge : true,
        name : '寒影',
        hp : 100,
        hungerUp : 0,
        waterUp : 0,
        weightUp : 0,
        attrPoint : 131400,
        getLevelUpExp(){
            return data.level * data.level * 5;
        },
        initItems : [],
        text : '挑战种族，且拥有开拓者的所有特性。玩家“寒影”特别要求的种族，永久在地图显示神话怪的位置。所有怪物（不仅限于神话怪）变为24小时主动攻击，攻击概率统一为10%，在和比自己等级高的怪物战斗时，怪物每比玩家等级高1级，属性提高5%'
    }),
    '弑魂叔' : new Race({
        challenge : true,
        name : '弑魂叔',
        hp : 100,
        weight : 75,
        hungerUp : 0,
        waterUp : 0,
        weightUp : 0,
        attrPoint : 131400,
        getLevelUpExp(){
            return data.level * data.level * 5;
        },
        recipes : {
            '折叠床' : createRecipesCfg({'铁锭' : 10, '布' : 20, '纤维' : 50}),
            '木罐' : createRecipesCfg({'木材' : 3, '粘液' : 10}),
            '果汁' : createRecipesCfg({'木罐' : 1,'浆果' : 10}),
        },
        onCreate(){
            data.spd = 30;
        },
        initItems : [{name : '短程传送卷轴', num : 3},{name : '书包', num : 1},{name : '一包饼干', num : 10}],
        text : '挑战种族，且拥有开拓者的所有特性。因为弑魂叔习惯快步走路，自带30%移动速度加成，也因此消耗更大，季度为夏天时水分消耗变为3倍(其他种族为2倍)，睡觉时和其他种族饥饿消耗一致，非睡觉时饥饿消耗为1.5倍。弑魂叔身体素质不行，所以初始负重略低一些，但是弑魂叔随身携带者书包，并且书包中常备着一些饼干，但他并不会做饼干，所以吃完就没了。弑魂叔可以制作折叠床和自制果汁。弑魂叔有严重的腰间盘突出和心脏早搏，所以当连续3个小时没有睡觉，进入战斗时会自动附加“腰痛”状态，攻击力降低10%，防御力降低20%，该状态无法被清除。连续8个小时没睡觉，进入战斗时会自动附加“煎熬”状态，攻击力降低30%，防御力降低50%，该状态无法被清除。连续15个小时没睡觉，时间每流逝1分钟，降低1点血量，进入战斗时会自动附加“崩溃”状态，攻击力降低50%，防御力降低80%，该状态无法被清除。弑魂叔可以在主页的时间后面看到自己多久没睡觉。当1天没睡觉时，每次时间流逝都有1%几率猝死，在1天的基础上，每增加1小时，猝死几率增加3%',
    }),
    '神性史莱姆' : new Race({
        name : '神性史莱姆',
        hp : 300,
        hunger :150,
        water :150,
        atk : 3,
        def : 1,
        hpUp : 15,
        initItems : [{name : '神性液体', num : 10}],
        skills : {
            '凝结' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '融入' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神疗术' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '净化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神性爆发' : createRecipesCfg({'粘液' : 1}, 0, null, 1000)
        },
        deity : {
            name : '水之女神',
            godFavor : 1000,
            belief : 0
        },
        onCreate(){
            data.divinity = 50;
            data.reduceHart = 0.2;
        },
        get : '史莱姆吃50个神性液体，会获得进化刻印，使用进化刻印解锁',
        text : '固定拥有20%的减伤'
    }),
    '神性史莱姆-神化' : new Race({
        name : '神性史莱姆-神化',
        hp : 300,
        hunger :150,
        water :150,
        atk : 3,
        def : 1,
        hpUp : 20,
        attrPoint : 131402,
        godRace : '神性史莱姆-半神',
        skills : {
            '凝结' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '融入' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神疗术' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '净化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神性爆发' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '索求' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '律令死亡' : createRecipesCfg({'粘液' : 1}),
        },
        text : '神性史莱姆一次觉醒种族，保留减伤特性，并逐步提高自己的神性'
    }),
    '神性史莱姆-半神' : new Race({
        name : '神性史莱姆-半神',
        hp : 300,
        hunger :150,
        water :150,
        atk : 3,
        def : 1,
        hpUp : 20,
        attrPoint : 131402,
        skills : {
            '凝结' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '融入' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神疗术' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '净化' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神性爆发' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '索求' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '律令死亡' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '祈祷' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
        },
        text : '神性史莱姆-神化二次觉醒种族，可以借助神性直接提升等级'
    }),
    '神性史莱姆-亵渎' : new Race({
        name : '神性史莱姆-亵渎',
        hp : 300,
        hunger :150,
        water :150,
        atk : 3,
        def : 1,
        hpUp : 20,
        attrPoint : 131402,
        godRace : '神性史莱姆-狩神者',
        skills : {
            '凝结' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '融入' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神疗术' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神性爆发' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '奉献' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
        },
        text : '神性史莱姆一次觉醒种族，保留减伤特性，对神力本身充满了亵渎之意，能用神性换取水之女神的眷顾。击杀神话怪物时，获得怪物等级/3的神性，副本中击杀无法获得神性'
    }),
    '神性史莱姆-狩神者' : new Race({
        name : '神性史莱姆-狩神者',
        hp : 300,
        hunger :150,
        water :150,
        atk : 3,
        def : 1,
        hpUp : 20,
        attrPoint : 131402,
        skills : {
            '凝结' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '融入' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神疗术' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '神性爆发' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '奉献' : createRecipesCfg({'粘液' : 1}, 0, null, 1000),
            '狩神' : createRecipesCfg({'粘液' : 1}),
        },
        text : '神性史莱姆-亵渎二次觉醒种族，可以对神话生物造成巨额伤害'
    }),
    '巨龙' : new Race({
        name : '巨龙',
        weight : 200,
        initItems : [{name : '技能石：龙威', num : 1}],
        skills : {
            '龙威' : createRecipesCfg({'龙晶' : 1})
        },
        get : '在生命祭坛制造“转生卷轴：巨龙”，使用后解锁',
        text : '巨龙对一般生物拥有绝对的血脉压制，怪物不会主动攻击你。在你主动攻击怪物时，如果怪物攻击力*0.8不超过你的防御力，且你攻击力*1.5超过可怪物的防御力（该攻击力不会计入武器的攻击力，但是会计入护甲的攻击力），则不进行战斗，直接取得战斗胜利，也不会损耗装备耐久度。该特性只对普通怪物有效'
    }),
    '巨龙-红龙' : new Race({
        name : '巨龙-红龙',
        weight : 200,
        atkUp : 1,
        attrPoint : 131402,
        godRace : '巨龙-三头龙',
        initItems : [{name : '技能石：龙威', num : 1}],
        skills : {
            '龙威' : createRecipesCfg({'龙晶' : 1}),
            '烈焰' : createRecipesCfg({'魔晶石' : 1}),
        },
        text : '巨龙一次觉醒种族，保留了血脉压制特性，并觉醒了自己的红龙血脉'
    }),
    '巨龙-黑龙' : new Race({
        name : '巨龙-黑龙',
        weight : 200,
        defUp : 1,
        attrPoint : 131402,
        godRace : '巨龙-三头龙',
        initItems : [{name : '技能石：龙威', num : 1}],
        skills : {
            '龙威' : createRecipesCfg({'龙晶' : 1}),
            '凋零' : createRecipesCfg({'魔晶石' : 1}),
        },
        text : '巨龙一次觉醒种族，保留了血脉压制特性，并觉醒了自己的黑龙血脉'
    }),
    '巨龙-三头龙' : new Race({
        name : '巨龙-三头龙',
        weight : 200,
        defUp : 1,
        attrPoint : 131402,
        initItems : [{name : '技能石：龙威', num : 1}],
        skills : {
            '龙威' : createRecipesCfg({'龙晶' : 1}),
            '三色龙息' : createRecipesCfg({'魔晶石' : 1}),
        },
        text : '巨龙-红龙和巨龙-黑龙共同的二次觉醒种族，能同时喷吐3色龙息'
    }),
    '亡灵族' : new Race({
        name : '亡灵族',
        hp : 300,
        hunger : 0,
        water :0 ,
        weight : 300,
        atk : 3,
        def : 0,
        hpUp : 20,
        weightUp : 20,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        initItems : [{name : '灵魂碎片', num : 10}],
        skills : {
            '死魂灵' : createRecipesCfg({'灵魂碎片' : 1}),
            '提取肉' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '提取魔兽肉' : createRecipesCfg({'魔兽肉' : 1}, 0, null, 1000),
            '提取亚龙肉' : createRecipesCfg({'亚龙肉' : 1}, 0, null, 1000)
        },
        onCreate(){
            data.soul = 0;
        },
        get : '在生命祭坛制造“灵魂标记：亡灵族”，使用后解锁，使用“灵魂标记：巫妖”会同时解锁亡灵族',
        text : '该种族无法觉醒（即无法一二转）。击杀怪物后，恢复怪物最大生命20%的HP。亡灵不知疲倦。地图移动更快，只需要30分钟。亡灵耐力更强，可以超负重移动，负重每超过负重上限一倍，地图移动时间提高一倍（以30分钟为基础），不满一倍按1倍算。每杀死一个相差10级以内的怪物，会获得1灵魂'
    }),
    '巫妖' : new Race({
        name : '巫妖',
        hp : 250,
        hunger : 0,
        water :0 ,
        weight : 200,
        atk : 5,
        def : 0,
        hpUp : 15,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        initItems : [{name : '灵魂碎片', num : 10}],
        skills : {
            '提取肉' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '提取魔兽肉' : createRecipesCfg({'魔兽肉' : 1}, 0, null, 1000),
            '提取亚龙肉' : createRecipesCfg({'亚龙肉' : 1}, 0, null, 1000),
            '巫妖学识' : createRecipesCfg({'灵魂碎片' : 1}, 0, null, 1000),
            '灵魂打击' : createRecipesCfg({'灵魂碎片' : 1}),
            '制造命匣' : createRecipesCfg({'灵魂碎片' : 1}),
            '亡灵天灾' : createRecipesCfg({'灵魂碎片' : 1})
        },
        onCreate(){
            data.soul = 0;
        },
        get : '在生命祭坛制造“灵魂标记：巫妖”，使用后解锁，或者亡灵族使用“巫妖生态研究笔记”解锁',
        text : '巫妖可以存着经验不升级，在需要的时候手动点击升级，但是储存经验最多为升级需求经验的10倍。击杀怪物后，恢复怪物最大生命20%的HP。每杀死一个相差10级以内的怪物，会获得1灵魂'
    }),
    '巫妖-魂师' : new Race({
        name : '巫妖-魂师',
        hp : 250,
        hunger : 0,
        water :0 ,
        weight : 200,
        atk : 5,
        def : 0,
        hpUp : 15,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        godRace : '巫妖-灵魂主宰',
        skills : {
            '提取肉' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '提取魔兽肉' : createRecipesCfg({'魔兽肉' : 1}, 0, null, 1000),
            '提取亚龙肉' : createRecipesCfg({'亚龙肉' : 1}, 0, null, 1000),
            '巫妖学识' : createRecipesCfg({'灵魂碎片' : 1}, 0, null, 1000),
            '灵魂打击' : createRecipesCfg({'灵魂碎片' : 1}),
            '制造命匣' : createRecipesCfg({'灵魂碎片' : 1}),
            '灵魂屠戮' : createRecipesCfg({'灵魂碎片' : 1})
        },
        text : '巫妖一次觉醒种族，保留了击杀怪物恢复生命值的特性，并在操控灵魂毁灭生灵的道路上越走越远。每杀死一个怪物，会获得3灵魂，所杀怪物的等级没有限制'
    }),
    '巫妖-灵魂主宰' : new Race({
        name : '巫妖-灵魂主宰',
        hp : 250,
        hunger : 0,
        water :0 ,
        weight : 200,
        atk : 5,
        def : 0,
        hpUp : 15,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        skills : {
            '提取肉' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '提取魔兽肉' : createRecipesCfg({'魔兽肉' : 1}, 0, null, 1000),
            '提取亚龙肉' : createRecipesCfg({'亚龙肉' : 1}, 0, null, 1000),
            '巫妖学识' : createRecipesCfg({'灵魂碎片' : 1}, 0, null, 1000),
            '灵魂打击' : createRecipesCfg({'灵魂碎片' : 1}),
            '制造命匣' : createRecipesCfg({'灵魂碎片' : 1}),
            '灵魂屠戮' : createRecipesCfg({'灵魂碎片' : 1}),
            '灵魂爆炸' : createRecipesCfg({'灵魂碎片' : 1}),
        },
        text : '巫妖-魂师二次觉醒种族，可以将控制的灵魂自爆攻击敌人'
    }),
    '巫妖-死神' : new Race({
        name : '巫妖-死神',
        hp : 250,
        hunger : 0,
        water :0 ,
        weight : 200,
        atk : 5,
        def : 0,
        hpUp : 15,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        godRace : '巫妖-死亡主宰',
        skills : {
            '提取肉' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '提取魔兽肉' : createRecipesCfg({'魔兽肉' : 1}, 0, null, 1000),
            '提取亚龙肉' : createRecipesCfg({'亚龙肉' : 1}, 0, null, 1000),
            '灵魂打击' : createRecipesCfg({'灵魂碎片' : 1}),
            '制造命匣' : createRecipesCfg({'灵魂碎片' : 1}),
            '灵魂收割' : createRecipesCfg({'灵魂碎片' : 1}, 0, null, 1000),
            '灵魂提取' : createRecipesCfg({'魔晶石' : 1})
        },
        text : '巫妖一次觉醒种族，保留了击杀怪物恢复生命值和获得灵魂的特性，同时专精于毁灭敌人的灵魂，使用灵魂打击时，将减少怪物相当于你本身攻击力（计入护甲增加的攻击力，不计入武器增加的攻击力）的最大生命值'
    }),
    '巫妖-死亡主宰' : new Race({
        name : '巫妖-死亡主宰',
        hp : 250,
        hunger : 0,
        water :0 ,
        weight : 200,
        atk : 5,
        def : 0,
        hpUp : 15,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        skills : {
            '提取肉' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '提取魔兽肉' : createRecipesCfg({'魔兽肉' : 1}, 0, null, 1000),
            '提取亚龙肉' : createRecipesCfg({'亚龙肉' : 1}, 0, null, 1000),
            '灵魂打击' : createRecipesCfg({'灵魂碎片' : 1}),
            '制造命匣' : createRecipesCfg({'灵魂碎片' : 1}),
            '灵魂收割' : createRecipesCfg({'灵魂碎片' : 1}),
            '灵魂提取' : createRecipesCfg({'魔晶石' : 1})
        },
        text : '巫妖-死神二次觉醒种族，在保留死神的特性的同时，在战斗中死亡时，如果拥有超过300灵魂，则消耗300灵魂，恢复100%生命值，攻击力和防御力提高300，每场战斗只能触发一次'
    }),
    '水之神裔' : new Race({
        name : '水之神裔',
        hp : 100,
        water : 150,
        atk : 2,
        def : 2,
        waterUp : 10,
        initItems : [{name : '水', num : 20},{name : '水之女神回城卷', num : 10}],
        get : '在水之神殿购买“转生卷轴：水之神裔”，使用后解锁',
        skills : {
            '水疗术' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '浓缩' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '花鸟风月' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '转换' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '水弹' : createRecipesCfg({'水' : 1}),
            '水甲' : createRecipesCfg({'水' : 1}, 0, null, 1000)
        },
        deity : {
            name : '水之女神',
            godFavor : 2000,
            belief : 2000
        },
        text : '初始获得对水之女神的2000神眷和2000信仰'
    }),
    '水之神裔-水法师' : new Race({
        name : '水之神裔-水法师',
        hp : 100,
        water : 300,
        atk : 3,
        def : 2,
        waterUp : 20,
        attrPoint : 131402,
        godRace : '水之神裔-海王',
        skills : {
            '水疗术' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '浓缩' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '花鸟风月' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '转换' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '水弹' : createRecipesCfg({'水' : 1}),
            '水甲' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '生生不息' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '水龙术' : createRecipesCfg({'水' : 1}),
            '源水护盾' : createRecipesCfg({'水' : 1}, 0, null, 1000),
        },
        text : '水之神裔一次觉醒种族，专精于对水的控制和利用'
    }),
    '水之神裔-海王' : new Race({
        name : '水之神裔-海王',
        hp : 100,
        water : 300,
        atk : 3,
        def : 2,
        waterUp : 20,
        attrPoint : 131402,
        skills : {
            '水疗术' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '浓缩' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '花鸟风月' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '转换' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '水弹' : createRecipesCfg({'水' : 1}),
            '水甲' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '生生不息' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '水龙术' : createRecipesCfg({'水' : 1}),
            '源水护盾' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '深海' : createRecipesCfg({'水' : 1}, 0, null, 1000),
        },
        text : '水之神裔-水法师二次觉醒种族，能将敌人拉入深海之中'
    }),
    '水之神裔-冰法师' : new Race({
        name : '水之神裔-冰法师',
        hp : 100,
        water : 150,
        atk : 5,
        def : 0,
        waterUp : 10,
        attrPoint : 131402,
        godRace : '水之神裔-冰皇',
        skills : {
            '浓缩' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '凝水成冰' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '冰棱柱' : createRecipesCfg({'冰霜结晶' : 1}),
            '寒冰甲' : createRecipesCfg({'冰霜结晶' : 1}, 0, null, 1000),
            '冰封千里' : createRecipesCfg({'冰霜结晶' : 1})
        },
        text : '水之神裔一次觉醒种族，专精于寒冰魔法'
    }),
    '水之神裔-冰皇' : new Race({
        name : '水之神裔-冰皇',
        hp : 100,
        water : 150,
        atk : 5,
        def : 0,
        waterUp : 10,
        attrPoint : 131402,
        skills : {
            '浓缩' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '凝水成冰' : createRecipesCfg({'水' : 1}, 0, null, 1000),
            '冰棱柱' : createRecipesCfg({'冰霜结晶' : 1}),
            '寒冰甲' : createRecipesCfg({'冰霜结晶' : 1}, 0, null, 1000),
            '冰封千里' : createRecipesCfg({'冰霜结晶' : 1}),
            '寒冰锻造' : createRecipesCfg({'冰霜结晶' : 1}),
        },
        text : '水之神裔-冰法师二次觉醒种族，擅长将冰制造成武器'
    }),
    '狩猎神裔' : new Race({
        name : '狩猎神裔',
        atk : 4,
        def : 0,
        initItems : [{name : '技能石：永恒追猎', num : 1},{name : '狩猎之神回城卷', num : 10}],
        skills : {
            '永恒追猎' : createRecipesCfg({'魔晶石' : 10}),
            '荣耀追猎' : createRecipesCfg({'魔晶石' : 10}),
            '狩猎神罚' : createRecipesCfg({'魔晶石' : 1}),
            '神话狙杀' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000)
        },
        deity : {
            name : '狩猎之神',
            godFavor : 2000,
            belief : 2000
        },
        get : '在狩猎神殿购买“转生卷轴：狩猎神裔”，使用后解锁',
        text : '初始获得对狩猎之神的2000神眷和2000信仰。和非神话怪物战斗时，攻击波动变为1.2倍到1.5倍，和神话怪物战斗时固定为1.5倍攻击'
    }),
    '狩猎神裔-追猎者' : new Race({
        name : '狩猎神裔-追猎者',
        atk : 4,
        def : 0,
        attrPoint : 131402,
        godRace : '狩猎神裔-陷阱大师',
        skills : {
            '永恒追猎' : createRecipesCfg({'魔晶石' : 10}),
            '荣耀追猎' : createRecipesCfg({'魔晶石' : 10}),
            '狩猎神罚' : createRecipesCfg({'魔晶石' : 1}),
            '神话狙杀' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000),
            '精英巢穴' : createRecipesCfg({'魔晶石' : 1}),
            '传说领地' : createRecipesCfg({'魔晶石' : 1}),
        },
        text : '狩猎神裔一次觉醒种族，拥有了更强的追猎能力，能找到怪物的巢穴进行狩猎'
    }),
    '狩猎神裔-陷阱大师' : new Race({
        name : '狩猎神裔-陷阱大师',
        atk : 4,
        def : 0,
        attrPoint : 131402,
        skills : {
            '永恒追猎' : createRecipesCfg({'魔晶石' : 10}),
            '荣耀追猎' : createRecipesCfg({'魔晶石' : 10}),
            '狩猎神罚' : createRecipesCfg({'魔晶石' : 1}),
            '神话狙杀' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000),
            '精英巢穴' : createRecipesCfg({'魔晶石' : 1}),
            '传说领地' : createRecipesCfg({'魔晶石' : 1}),
        },
        text : '狩猎神裔-追猎者二次觉醒种族，触发战斗时，怪物生命值变为50%，防御力减少50%，并获得陷阱状态，3回合无法行动'
    }),
    '狩猎神裔-防御大师' : new Race({
        name : '狩猎神裔-防御大师',
        atk : 3,
        def : 1,
        defUp : 1,
        attrPoint : 131402,
        godRace : '狩猎神裔-铠甲神匠',
        skills : {
            '永恒追猎' : createRecipesCfg({'魔晶石' : 10}),
            '荣耀追猎' : createRecipesCfg({'魔晶石' : 10}),
            '狩猎神罚' : createRecipesCfg({'魔晶石' : 1}),
            '神话狙杀' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000),
        },
        text : '狩猎神裔一次觉醒种族，和神话怪物战斗时，攻击波动固化为最大，擅长防御，武器和护甲提供的防御力提高50%'
    }),
    '狩猎神裔-铠甲神匠' : new Race({
        name : '狩猎神裔-铠甲神匠',
        atk : 3,
        def : 1,
        defUp : 1,
        attrPoint : 131402,
        skills : {
            '永恒追猎' : createRecipesCfg({'魔晶石' : 10}),
            '荣耀追猎' : createRecipesCfg({'魔晶石' : 10}),
            '狩猎神罚' : createRecipesCfg({'魔晶石' : 1}),
            '神话狙杀' : createRecipesCfg({'魔晶石' : 1}, 0, null, 1000),
            '神甲锻造' : createRecipesCfg({'魔晶石' : 1}),
        },
        text : '狩猎神裔-防御大师二次觉醒种族，能用神性结晶制造狩猎神甲，且制造护甲时，必定锻造出极品，但是无法锻造护甲完成欧皇成就'
    }),
    '戏命师' : new Race({
        name : '戏命师',
        atk : 0,
        initItems : [{name : '技能石：命运剥夺', num : 1000},{name : '命运硬币', num : 10}],
        skills : {
            '探索命运' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运剥夺' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '拨动命运' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运转盘' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运回溯' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运感知' : createRecipesCfg({'命运硬币' : 10}),
            '命运挽歌' : createRecipesCfg({'命运硬币' : 1}),
        },
        get : '任意60级以上的角色，进入游戏时解锁',
        text : '戏命师不能使用普通攻击和武器攻击，但是可以使用技能石攻击（例如重击是允许使用的）。戏命师的存在本身便能影响命运，当戏命师在战斗时，攻击浮动都将从0.8-1.2变为0.5-1.5'
    }),
    '戏命师-厄兆' : new Race({
        name : '戏命师-厄兆',
        hp : 400,
        atk : 0,
        attrPoint : 131402,
        godRace : '戏命师-迷雾',
        skills : {
            '探索命运' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运剥夺' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运转盘' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运回溯' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运挽歌' : createRecipesCfg({'命运硬币' : 1}),
            '命运操控' : createRecipesCfg({'命运硬币' : 1}),
            '恶兆之花' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '灾厄化身' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '同生共死' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
        },
        text : '戏命师一次觉醒种族，保留了戏命师的特性，并给敌人带来无尽的厄运'
    }),
    '戏命师-迷雾' : new Race({
        name : '戏命师-迷雾',
        hp : 400,
        atk : 0,
        attrPoint : 131402,
        skills : {
            '探索命运' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运剥夺' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运转盘' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运回溯' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运挽歌' : createRecipesCfg({'命运硬币' : 1}),
            '命运操控' : createRecipesCfg({'命运硬币' : 1}),
            '恶兆之花' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '灾厄化身' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '同生共死' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '迷之蝶' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
        },
        text : '戏命师-厄兆二次觉醒种族，命运已被迷雾笼罩，敌人无法看清'
    }),
    '戏命师-强运' : new Race({
        name : '戏命师-强运',
        hp : 400,
        atk : 0,
        attrPoint : 131402,
        godRace : '戏命师-黑花',
        skills : {
            '探索命运' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运剥夺' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运转盘' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运回溯' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运感知' : createRecipesCfg({'命运硬币' : 10}),
            '命运挽歌' : createRecipesCfg({'命运硬币' : 1}),
            '命运之眼' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运连线' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
        },
        text : '戏命师一次觉醒种族，保留了戏命师的特性，擅长操控幸运'
    }),
    '戏命师-黑花' : new Race({
        name : '戏命师-黑花',
        hp : 400,
        atk : 0,
        attrPoint : 131402,
        skills : {
            '探索命运' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运剥夺' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运转盘' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运回溯' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运感知' : createRecipesCfg({'命运硬币' : 10}),
            '命运挽歌' : createRecipesCfg({'命运硬币' : 1}),
            '命运之眼' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '命运连线' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
            '春之歌' : createRecipesCfg({'命运硬币' : 1}, 0, null, 1000),
        },
        text : '戏命师-强运二次觉醒种族，命运之花已经绽放'
    }),
    '机械族' : new Race({
        name : '机械族',
        hp : 300,
        hunger : 0,
        water :0 ,
        weight : 500,
        atk : 3,
        def : 1,
        hpUp : 20,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        initItems : [{name : '技能石：超载攻击', num : 1},{name : '机械碎片', num : 10}],
        skills : {
            '超载攻击' : createRecipesCfg({'机械碎片' : 1}),
            '紧急维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '大维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心制造' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心拆卸' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
        },
        get : '击败任意怪物都有几率掉落机械碎片和机械核心，背包中准备20个机械碎片，然后使用机械核心解锁',
        text : '机械族自带感应器，有更大概率在怪物身上找到机械碎片或机械核心'
    }),
    '机械族-装甲' : new Race({
        name : '机械族-装甲',
        hp : 400,
        hunger : 0,
        water :0 ,
        weight : 500,
        atk : 3,
        def : 2,
        hpUp : 20,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        godRace : '机械族-机械神',
        skills : {
            '紧急维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '大维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心制造' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心拆卸' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '纳米装甲' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '装甲涂层' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
        },
        text : '机械族一次觉醒种族，叠最厚的甲，挨最毒的打'
    }),
    '机械族-机械神' : new Race({
        name : '机械族-机械神',
        hp : 400,
        hunger : 0,
        water :0 ,
        weight : 500,
        atk : 3,
        def : 2,
        hpUp : 20,
        weightUp : 10,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        skills : {
            '紧急维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '大维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心制造' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心拆卸' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '纳米装甲' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '装甲涂层' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '机械神降' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
        },
        text : '机械族-装甲二次觉醒种族，已经机械飞升'
    }),
    '机械族-战斗' : new Race({
        name : '机械族-战斗',
        hp : 300,
        hunger : 200,
        water : 200,
        weight : 300,
        atk : 5,
        def : 0,
        hpUp : 20,
        weightUp : 10,
        attrPoint : 131402,
        godRace : '机械族-补全机',
        skills : {
            '超载攻击' : createRecipesCfg({'机械碎片' : 1}),
            '大维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心制造' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心拆卸' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            'AT立场' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '暴走' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
        },
        text : '机械族一次觉醒种族，未知型号'
    }),
    '机械族-补全机' : new Race({
        name : '机械族-补全机',
        hp : 300,
        hunger : 200,
        water : 200,
        weight : 300,
        atk : 5,
        def : 0,
        hpUp : 20,
        weightUp : 10,
        attrPoint : 131402,
        skills : {
            '超载攻击' : createRecipesCfg({'机械碎片' : 1}),
            '大维修' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心制造' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '核心拆卸' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            'AT立场' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '暴走' : createRecipesCfg({'机械碎片' : 1}, 0, null, 1000),
            '歼星' : createRecipesCfg({'机械碎片' : 1}),
        },
        text : '机械族-战斗二次觉醒种族，完成人类补全计划的机体'
    }),
    '影魔' : new Race({
        name : '影魔',
        initItems : [{name : '技能石：恶魔变身', num : 1000}],
        skills : {
            '恶魔变身' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        getLevelUpExp(){
            if(!data.useEmbs){
                data.useEmbs = 0;
            }
            return data.level * data.level * (10 + data.useEmbs);
        },
        get : '击败深渊怪物有几率掉落“影魔传说”，使用后解锁',
        text : '触发战斗时，如果是在夜晚，影魔的攻击力和防御力提高20%，并在开始战斗时给对手附加难以观察状态，减少20%命中率，该状态不会自动消失。但是在白天，攻击力和防御力降低20%'
    }),
    '影魔-暗影工匠' : new Race({
        name : '影魔-暗影工匠',
        attrPoint : 131402,
        godRace : '影魔-暗影神匠',
        getLevelUpExp(){
            if(!data.useEmbs){
                data.useEmbs = 0;
            }
            return data.level * data.level * (10 + data.useEmbs);
        },
        skills : {
            '恶魔变身' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '暗影附加' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '暗影锻造' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '影魔一次觉醒种族，能使用暗影之力锻造装备'
    }),
    '影魔-暗影神匠' : new Race({
        name : '影魔-暗影神匠',
        attrPoint : 131402,
        getLevelUpExp(){
            if(!data.useEmbs){
                data.useEmbs = 0;
            }
            return data.level * data.level * (10 + data.useEmbs);
        },
        skills : {
            '恶魔变身' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '暗影附加' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '暗影锻造' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '暗影神器' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '影魔-暗影工匠二次觉醒种族，能使用暗影之力锻造神器'
    }),
    '影魔-暗影生物' : new Race({
        name : '影魔-暗影生物',
        attrPoint : 131402,
        godRace : '影魔-虚空大君',
        getLevelUpExp(){
            if(!data.useEmbs){
                data.useEmbs = 0;
            }
            return data.level * data.level * (10 + data.useEmbs);
        },
        skills : {
            '恶魔变身' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '暗影融合' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '影魔一次觉醒种族，在黑夜中几乎拥有不死之身'
    }),
    '影魔-虚空大君' : new Race({
        name : '影魔-虚空大君',
        attrPoint : 131402,
        getLevelUpExp(){
            if(!data.useEmbs){
                data.useEmbs = 0;
            }
            return data.level * data.level * (10 + data.useEmbs);
        },
        skills : {
            '恶魔变身' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '暗影融合' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '虚空低语' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '影魔-暗影生物二次觉醒种族，虚空无处不在'
    }),
    '蜥蜴人' : new Race({
        name : '蜥蜴人',
        hp : 300,
        hunger : 150,
        water : 150,
        weight : 150,
        hpUp : 15,
        weightUp : 20,
        atk : 5,
        def : 2,
        initItems : [{name : '肉', num : 10},{name : '水', num : 10}],
        skills : {
            '先祖附魔' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        get : '当一个2周目或以上的角色进入游戏时，将自动解锁',
        text : '蜥蜴人天生警觉，被怪物偷袭时也不会失去先手权，且可以选择立刻逃跑。蜥蜴人无法穿戴武器、护甲和背包，但是可以使用武器和护甲给自己的利爪和鳞片附魔，附魔只生效1次，新的附魔会覆盖原本的附魔，利爪和鳞片的附魔分开计算'
    }),
    '蜥蜴人-先祖战士' : new Race({
        name : '蜥蜴人-先祖战士',
        hp : 300,
        hunger : 150,
        water : 150,
        weight : 150,
        hpUp : 15,
        weightUp : 20,
        atk : 5,
        def : 2,
        attrPoint : 131402,
        godRace : '蜥蜴人-卡格拉玛',
        skills : {
            '先祖附魔' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '先祖狂暴' : createRecipesCfg({'魔晶石' : 20,'神性结晶' : 1}, 0),
        },
        text : '蜥蜴人一次觉醒种族，能进一步激发先祖之力'
    }),
    '蜥蜴人-卡格拉玛' : new Race({
        name : '蜥蜴人-卡格拉玛',
        hp : 300,
        hunger : 150,
        water : 150,
        weight : 150,
        hpUp : 15,
        weightUp : 20,
        atk : 5,
        def : 2,
        attrPoint : 131402,
        skills : {
            '先祖附魔' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '先祖狂暴' : createRecipesCfg({'魔晶石' : 20,'神性结晶' : 1}, 0),
        },
        text : '蜥蜴人二次觉醒种族，卡格拉玛是蜥蜴人最强战士独有的称号，可以将武器附魔在鳞片上'
    }),
    '蜥蜴人-巫医' : new Race({
        name : '蜥蜴人-巫医',
        hp : 300,
        hunger : 150,
        water : 150,
        weight : 150,
        hpUp : 15,
        weightUp : 20,
        atk : 5,
        def : 2,
        attrPoint : 131402,
        godRace : '蜥蜴人-巫祖',
        skills : {
            '先祖附魔' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '制造传承药剂' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '蜥蜴人一次觉醒种族，擅长制造药物'
    }),
    '蜥蜴人-巫祖' : new Race({
        name : '蜥蜴人-巫祖',
        hp : 300,
        hunger : 150,
        water : 150,
        weight : 150,
        hpUp : 15,
        weightUp : 20,
        atk : 5,
        def : 2,
        attrPoint : 131402,
        skills : {
            '先祖附魔' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '制造传承药剂' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '幽灵虫' : createRecipesCfg({'肉' : 1}, 0),
        },
        text : '蜥蜴人二次觉醒种族，掌握了蜥蜴人独有的黑魔法'
    }),
    '吸血鬼' : new Race({
        name : '吸血鬼',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        initItems : [{name : '草药膏', num : 10},{name : '微效治疗药剂', num : 10}],
        skills : {},
        onCreate(){
            data.suck = 20;
        },
        get : '在战斗中攻击时，触发200%的吸血时解锁',
        text : '吸血鬼天生自带20%吸血，并且吸血不会降低生命上限'
    }),
    '吸血鬼-刀锋战士' : new Race({
        name : '吸血鬼-刀锋战士',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger : true,
        attrPoint : 131402,
        godRace : '吸血鬼-收割者',
        skills : {
            '抽取血液' : createRecipesCfg({'异化血液' : 1}, 0, null, 1000),
        },
        text : '吸血鬼一次觉醒种族，能从血液中获取力量'
    }),
    '吸血鬼-收割者' : new Race({
        name : '吸血鬼-收割者',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger : true,
        attrPoint : 131402,
        skills : {
            '抽取血液' : createRecipesCfg({'异化血液' : 1}, 0, null, 1000),
        },
        text : '吸血鬼二次觉醒种族，战斗中不再有血液的饮用次数限制，但是从第二次开始，每次饮用只能获得血液中20%的攻防加成'
    }),
    '吸血鬼-伯爵' : new Race({
        name : '吸血鬼-伯爵',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger : true,
        attrPoint : 131402,
        skills : {},
        godRace : '吸血鬼-亲王',
        text : '吸血鬼一次觉醒种族，自带的吸血提升至80%',
        onToRace(){
            data.suck += 60;
        }
    }),
    '吸血鬼-亲王' : new Race({
        name : '吸血鬼-亲王',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger : true,
        attrPoint : 131402,
        skills : {},
        text : '吸血鬼一次觉醒种族，自带的吸血提升至120%',
        onToRace(){
            data.suck += 40;
        }
    }),
    '地球人' : new Race({
        name : '地球人',
        atkUp : 1,
        attrPoint : 131402,
        get : '使用回城卷轴(就叫回城卷轴，不是水之女神回城卷和狩猎之神回城卷)时，有5%几率遭遇时空乱流，导致回城失败，遇到时空乱流时将解锁地球人',
        text : '地球人无法装备武器。使用投掷品时，造成的直接伤害翻倍'
    }),
    '地球人-佛门' : new Race({
        name : '地球人-佛门',
        defUp : 1,
        attrPoint : 131402,
        godRace : '-1',
        onToRace(){
            data.merit = 0;
            data.karma = 0;
        },
        skills : {
            '超度' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '无量法相' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '功德无量' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '功德圆满' : createRecipesCfg({'神性结晶' : 1}),
            '轮回' : createRecipesCfg({'神性结晶' : 1}),
        },
        text : '地球人一次觉醒种族，超度怪物会获得功德，击杀任何怪物都会减少1功德，自身技能的效果和功德有关。该种族无法使用神灵之力，只能通过功德圆满技能转换种族'
    }),
    '地球人-活佛' : new Race({
        name : '地球人-活佛',
        defUp : 1,
        attrPoint : 131402,
        skills : {
            '超度' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '无量法相' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '功德无量' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '轮回' : createRecipesCfg({'神性结晶' : 1}),
        },
        text : '地球人-佛门功德圆满后转为该种族。在洗点时，每拥有1点善业，额外增加1点攻击和1点防御，本次洗点增加的攻防下次洗点会消失，然后重新根据当前的善业获得额外攻防'
    }),
    '地球人-蜀山' : new Race({
        name : '地球人-蜀山',
        atkUp : 1,
        attrPoint : 131402,
        godRace : '地球人-酒剑仙',
        recipes : {
            '天剑' : createRecipesCfg({'神性结晶' : 10, '铁锭' : 100, '璀璨的红宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '雷剑' : createRecipesCfg({'神性结晶' : 10, '铁锭' : 100, '璀璨的紫宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '昊天镜' : createRecipesCfg({'神性结晶' : 10, '铜锭' : 100, '璀璨的黄宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '日金轮' : createRecipesCfg({'神性结晶' : 10, '金锭' : 100, '璀璨的绿宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '月金轮' : createRecipesCfg({'神性结晶' : 10, '金锭' : 100, '璀璨的紫宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
        },
        skills : {
            '天剑' : createRecipesCfg({'神性结晶' : 1}),
            '雷剑' : createRecipesCfg({'神性结晶' : 1}),
            '天雷合并' : createRecipesCfg({'神性结晶' : 1}),
            '昊天镜' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '日金轮' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '月金轮' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
        },
        text : '地球人一次觉醒种族，可以在工作台制造飞剑和法器'
    }),
    '地球人-酒剑仙' : new Race({
        name : '地球人-酒剑仙',
        atkUp : 1,
        attrPoint : 131402,
        recipes : {
            '天剑' : createRecipesCfg({'神性结晶' : 10, '铁锭' : 100, '璀璨的红宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '雷剑' : createRecipesCfg({'神性结晶' : 10, '铁锭' : 100, '璀璨的紫宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '昊天镜' : createRecipesCfg({'神性结晶' : 10, '铜锭' : 100, '璀璨的黄宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '日金轮' : createRecipesCfg({'神性结晶' : 10, '金锭' : 100, '璀璨的绿宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '月金轮' : createRecipesCfg({'神性结晶' : 10, '金锭' : 100, '璀璨的紫宝石' : 5, '变异核心' : 10000, '虚空粉尘' : 20000}),
            '青果酿' : createRecipesCfg({'神性结晶' : 10, '芦苇' : 100, '浆果' : 100}),
            '女儿红' : createRecipesCfg({'神性结晶' : 10, '芦苇' : 100, '神性液体' : 10}),
            '竹叶青' : createRecipesCfg({'神性结晶' : 10, '芦苇' : 100, '龙血' : 10}),
            '醉红尘' : createRecipesCfg({'神性结晶' : 100, '芦苇' : 100, '五彩石' : 1}),
        },
        skills : {
            '天剑' : createRecipesCfg({'神性结晶' : 1}),
            '雷剑' : createRecipesCfg({'神性结晶' : 1}),
            '天雷合并' : createRecipesCfg({'神性结晶' : 1}),
            '昊天镜' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '日金轮' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
            '月金轮' : createRecipesCfg({'神性结晶' : 1}, 0, null, 1000),
        },
        text : '地球人-蜀山二次觉醒种族，可以通过喝酒来加强自身。青红揽明月，竹叶破苍天。醉笑红尘客，唯我酒剑仙。'
    }),
    '食人魔' : new Race({
        name : '食人魔',
        hp : 300,
        hunger : 200,
        water : 100,
        weight : 150,
        atk : 4,
        def : 1,
        hpUp : 15,
        hungerUp : 5,
        weightUp : 10,
        initItems : [{name : '肉', num : 10}, {name : '烤肉', num : 10}],
        skills : {
            '掠食' : createRecipesCfg({'肉' : 1}),
            '狂暴' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '自食' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        get : '吃掉100个哥布林之心',
        text : '食人魔只吃肉类食物（不会增加饥饿值的食物不受限制），且消耗饥饿值的速度翻倍'
    }),
    '食人魔-暴食' : new Race({
        name : '食人魔-暴食',
        hp : 300,
        hunger : 200,
        water : 100,
        weight : 200,
        atk : 4,
        def : 1,
        hpUp : 20,
        hungerUp : 10,
        weightUp : 10,
        attrPoint : 131402,
        godRace : '食人魔-暴君',
        skills : {
            '掠食' : createRecipesCfg({'肉' : 1}),
            '狂暴' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '自食' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '无尽暴食' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '食人魔一次觉醒种族，当战斗对象会掉落肉类食物时，掠食伤害翻倍'
    }),
    '食人魔-暴君' : new Race({
        name : '食人魔-暴君',
        hp : 300,
        hunger : 200,
        water : 100,
        weight : 200,
        atk : 4,
        def : 1,
        hpUp : 20,
        hungerUp : 10,
        weightUp : 10,
        attrPoint : 131402,
        skills : {
            '掠食' : createRecipesCfg({'肉' : 1}),
            '狂暴' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '自食' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '无尽暴食' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
            '铁血' : createRecipesCfg({'肉' : 1}, 0, null, 1000),
        },
        text : '食人魔-暴食二次觉醒种族，可以进入铁血状态，吸血翻倍'
    }),
    '食人魔-双头法师' : new Race({
        name : '食人魔-双头法师',
        hp : 300,
        hunger : 200,
        water : 100,
        weight : 150,
        atk : 4,
        def : 1,
        hpUp : 15,
        hungerUp : 5,
        weightUp : 10,
        attrPoint : 131402,
        godRace : '食人魔-血法师',
        skills : {
            '爆轰术' : createRecipesCfg({'肉' : 1}),
        },
        text : '食人魔一次觉醒种族，食人魔法师拥有超长的智慧，可以压制内心的饥饿和狂躁，双头食人魔更是绝佳的施法天才，拥有双重施法的能力'
    }),
    '食人魔-血法师' : new Race({
        name : '食人魔-血法师',
        hp : 300,
        hunger : 200,
        water : 100,
        weight : 150,
        atk : 4,
        def : 1,
        hpUp : 15,
        hungerUp : 5,
        weightUp : 10,
        attrPoint : 131402,
        skills : {
            '爆轰术' : createRecipesCfg({'肉' : 1}),
        },
        text : '食人魔-双头法师二次觉醒种族，使用爆轰术时，减少怪物相当于爆轰术攻击力（指的是技能石上面显示的攻击力）五分之一的血量上限'
    }),
    '操脑蛛' : new Race({
        name : '操脑蛛',
        hp : 100,
        hunger : 100,
        water : 100,
        weight : 100,
        atk : 0,
        def : 0,
        hpUp : 0,
        hungerUp : 0,
        waterUp : 0,
        weightUp : 0,
        atkUp : 0,
        defUp : 0,
        attrPoint : 131400,
        getNoHunger(){
            return !!data.control;
        },
        //控制怪物
        control(){
            const monster = data.control;
            data.maxHp += monster.hp;
            data.hp += monster.hp;
            data.atk = monster.atk;
            data.def = monster.def;
            data.suck = monster.suck || 0;
            data.hunger = data.maxHunger = 0;
            data.water = data.maxWater = 0;
        },
        initItems : [{name : '蜘蛛丝', num : 10}, {name : '草药膏', num : 10}],
        skills : {
            '解除操纵' : createRecipesCfg({'蜘蛛丝' : 1}, 0, null, 1000),
            '精神狂暴' : createRecipesCfg({'蜘蛛丝' : 1}, 0, null, 1000),
            '怪物强化' : createRecipesCfg({'蜘蛛丝' : 1}, 0, null, 1000),
        },
        get : '连续5次吃观音土没有减少生命值上限则解锁该种族',
        text : '该种族无法觉醒（即无法一二转）。十分微小的生物，难以被察觉，所以在没有操纵怪物的情况下，不会被其他怪物主动攻击。操脑蛛任何情况下都无法穿戴装备。未操纵怪物时无法穿戴背包，但是自身的负重属于灵魂空间，不受影响，点击怪物的操作改为操纵该怪物，只能操纵等级不高于自己的怪物，只能操纵普通怪物，不能操纵精英/传说/神话怪物，也不能操纵副本中的怪物，操纵怪物时可能会发现操纵的怪物变异了，获得的属性也是变异后的属性。操纵怪物时会降低怪物对应的等级，但是等级至少会有1级（例如你5级，操控狼，操控后-3级，变为2级。你10级，操控狮鹫，-10级，但是至少保留1级，所以变为1级）。无法使用被操纵怪物的技能。操纵怪物后，攻击、防御、吸血属性变为怪物对应的属性，血量在自身基础上增加怪物的血量，可以正常穿背包，战斗时你的名字变为该怪物的名字。你操纵的怪物死亡时，你会跟着一起死亡。你可以主动解除操纵怪物，此时你的属性会变为自己的属性，并自动脱下背包和坐骑，当你重新操纵一个怪物时，如果你之前自动脱下的背包和坐骑还在背包，则会自动穿上。当你未操纵怪物时，属于有饥饿种族，饥饿和水分不够时百分比扣血。当你操纵怪物时，饥饿和水分变为0，且变为无饥饿种族，不再百分比扣血，但是会固定扣血，和其他无饥饿种族一样。'
    }),
    '污染者' : new Race({
        name : '污染者',
        initItems : [{name : '技能石：自我扭曲', num : 1000}],
        skills : {
            '自我扭曲' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
            '无智狂暴' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        },
        onCreate(){
            if(data.maxSan > 80){
                data.maxSan = 80;
                addObjSan(data, 0)
            }
        },
        get : '使用100个古神血液解锁',
        text : '该种族无法觉醒（即无法一二转）。被古神的力量污染产生的生物，自带20点克苏鲁学识。污染者永远处于半疯状态，所以不会在战斗中因为理智原因陷入疯狂。污染者的理智最低为1点，任何扣理智的操作都不会导致理智低于1点，但是如果污染者的理智上限降低到0或0以下，依旧会陷入永恒的疯狂导致删档。每15分钟，污染者自动恢复1点理智。'
    }),
    '星灵' : new Race({
        name : '星灵',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        initItems : [{name : '时空碎片', num : 10}],
        skills : {
            '时间穿梭' : createRecipesCfg({'时空碎片' : 1}, 0, null, 1000),
        },
        get : '击杀一次创世神获得，不需要战斗胜利，只要将创世神血量打光，触发一次创世神的复活即可。',
        text : '可以无限制在可见地图传送，相当于有无限个小型传送阵。点击小地图移动时无视负重，大地图上点击选中某一格时（即出现蓝色边框），再次点击这一格直接传送，不需要点传送按钮。可以加速时间流逝，任意流逝时间，即你可以直接穿梭到100年后。无法完成十年生死两茫茫成就。本身是无饥饿种族，同时不受时间流逝影响，即永不消耗饥饿水分，所以不会随时间流逝掉血。逃跑固定100%成功率，任何战斗场景下都可以逃跑。不喜欢战斗，攻击浮动为70%~80%'
    }),
    '星灵-空间行者' : new Race({
        name : '星灵-空间行者',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        godRace : '星灵-宇',
        skills : {
            '时间穿梭' : createRecipesCfg({'时空碎片' : 1}, 0, null, 1000),
        },
        text : '星灵一次觉醒种族，使用传送门时不需要消耗时空粉尘和时空碎片'
    }),
    '星灵-宇' : new Race({
        name : '星灵-宇',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        skills : {
            '时间穿梭' : createRecipesCfg({'时空碎片' : 1}, 0, null, 1000),
        },
        text : '星灵-空间行者二次觉醒种族，可以直接从空间中拿取材料，锻造装备不需要消耗材料'
    }),
    '星灵-时间旅者' : new Race({
        name : '星灵-时间旅者',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        godRace : '星灵-宙',
        skills : {
            '时间穿梭' : createRecipesCfg({'时空碎片' : 1}, 0, null, 1000),
        },
        text : '星灵一次觉醒种族，一件装备无论锤炼过多少次，锤炼时都只需要消耗1个神圣重锤，且武器和护甲不会因战斗而减少耐久度'
    }),
    '星灵-宙' : new Race({
        name : '星灵-宙',
        hunger : 0,
        water :0 ,
        hungerUp : 0,
        waterUp : 0,
        noHunger :true,
        attrPoint : 131402,
        skills : {
            '时间穿梭' : createRecipesCfg({'时空碎片' : 1}, 0, null, 1000),
        },
        text : '星灵-时间旅者二次觉醒种族，附魔时不需要消耗变异核心'
    }),
    '精灵' : new Race({
        name : '精灵',
        hp : 100,
        weight : 80,
        atk : 2,
        def : 0,
        initItems : [{name : '技能石：木箭', num : 5}, {name : '弓胚', num : 1}, {name : '技能石：自然附着', num : 1000}, {name : '石矛', num : 1}],
        recipes : {
            '弓胚' : createRecipesCfg({'木材' : 5, '纤维' : 10}),
            '弓胚：猎人' : createRecipesCfg({'铜锭' : 5, '兽皮' : 10, '蜘蛛丝' : 5}),
            '弓胚：灵魂' : createRecipesCfg({'木材' : 5, '哥布林魔晶' : 3, '灵魂残片' : 10, '蜘蛛丝' : 5, '闪耀的皮' : 10}),
            '弓胚：巨人杀手-1' : createRecipesCfg({'铁锭' : 10, '幽灵蛛丝' : 10, '疯狂之血' : 5, '神性紫晶' : 3}),
            '弓胚：巨人杀手-2' : createRecipesCfg({'铁锭' : 10, '石化巨爪' : 10, '石巨人之眼' : 5, '石化重瞳' : 3}),
        },
        skills : {
            '自然附着' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '木箭' : createRecipesCfg({'木材' : 3, 纤维 : 5}),
            '魔法箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 5, 魔晶石 : 2, 羽毛 : 10}),
            '火焰箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 10, 红水晶 : 10, 羽毛 : 10}),
        },
        get : '采集（包括扫荡）1000个浆果丛(采集五次直到浆果丛消失算采集了1个)获得，在系统-游戏数据统计里可以看到采集了多少个浆果丛',
        text : '可以制造弓箭，并用弓箭进行攻击'
    }),
    '精灵-游侠' : new Race({
        name : '精灵-游侠',
        hp : 100,
        weight : 80,
        atk : 2,
        def : 0,
        attrPoint : 131402,
        godRace : '精灵-游侠将军',
        recipes : {
            '弓胚' : createRecipesCfg({'木材' : 5, '纤维' : 10}),
            '弓胚：猎人' : createRecipesCfg({'铜锭' : 5, '兽皮' : 10, '蜘蛛丝' : 5}),
            '弓胚：灵魂' : createRecipesCfg({'木材' : 5, '哥布林魔晶' : 3, '灵魂残片' : 10, '蜘蛛丝' : 5, '闪耀的皮' : 10}),
            '弓胚：巨人杀手-1' : createRecipesCfg({'铁锭' : 10, '幽灵蛛丝' : 10, '疯狂之血' : 5, '神性紫晶' : 3}),
            '弓胚：巨人杀手-2' : createRecipesCfg({'铁锭' : 10, '石化巨爪' : 10, '石巨人之眼' : 5, '石化重瞳' : 3}),
            '弓胚：游侠' : createRecipesCfg({'木材' : 10, '幽灵蛛丝' : 10, '精密骨骼' : 20, '魔法宝石' : 20}),
            '弓胚：屠龙者' : createRecipesCfg({'铁锭' : 10, '幽灵蛛丝' : 20, '龙皮' : 10, '龙鳞' : 10, '龙晶' : 3}),
        },
        skills : {
            '自然附着' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '木箭' : createRecipesCfg({'木材' : 3, 纤维 : 5}),
            '魔法箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 5, 魔晶石 : 2, 羽毛 : 10}),
            '火焰箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 10, 红水晶 : 10, 羽毛 : 10}),
            '腐蚀箭' : createRecipesCfg({'木材' : 5, 强酸粘液 : 20, 尸水 : 10, 异化血液 : 20, 血族翅膀 : 10}),
            '穿甲箭-1' : createRecipesCfg({'铁锭' : 5, 大地之牙 : 10, 紫晶 : 10, 疾风鹰羽 : 10}),
            '穿甲箭-2' : createRecipesCfg({'铁锭' : 5, 石化大喙 : 10, 黄水晶 : 2, 石化大羽 : 10}),
            '爆裂箭' : createRecipesCfg({'附魔箭矢' : 5, 元素印记 : 10, 飓风魔核 : 10, 女妖翅膀 : 10}),
        },
        text : '精灵一次觉醒种族，掌握了更多的弓箭制造方法'
    }),
    '精灵-游侠将军' : new Race({
        name : '精灵-游侠将军',
        hp : 100,
        weight : 80,
        atk : 2,
        def : 0,
        attrPoint : 131402,
        recipes : {
            '弓胚' : createRecipesCfg({'木材' : 5, '纤维' : 10}),
            '弓胚：猎人' : createRecipesCfg({'铜锭' : 5, '兽皮' : 10, '蜘蛛丝' : 5}),
            '弓胚：灵魂' : createRecipesCfg({'木材' : 5, '哥布林魔晶' : 3, '灵魂残片' : 10, '蜘蛛丝' : 5, '闪耀的皮' : 10}),
            '弓胚：巨人杀手-1' : createRecipesCfg({'铁锭' : 10, '幽灵蛛丝' : 10, '疯狂之血' : 5, '神性紫晶' : 3}),
            '弓胚：巨人杀手-2' : createRecipesCfg({'铁锭' : 10, '石化巨爪' : 10, '石巨人之眼' : 5, '石化重瞳' : 3}),
            '弓胚：游侠' : createRecipesCfg({'木材' : 10, '幽灵蛛丝' : 10, '精密骨骼' : 20, '魔法宝石' : 20}),
            '弓胚：屠龙者' : createRecipesCfg({'铁锭' : 10, '幽灵蛛丝' : 20, '龙皮' : 10, '龙鳞' : 10, '龙晶' : 3}),
        },
        skills : {
            '自然附着' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '木箭' : createRecipesCfg({'木材' : 3, 纤维 : 5}),
            '魔法箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 5, 魔晶石 : 2, 羽毛 : 10}),
            '火焰箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 10, 红水晶 : 10, 羽毛 : 10}),
            '腐蚀箭' : createRecipesCfg({'木材' : 5, 强酸粘液 : 20, 尸水 : 10, 异化血液 : 20, 血族翅膀 : 10}),
            '穿甲箭-1' : createRecipesCfg({'铁锭' : 5, 大地之牙 : 10, 紫晶 : 10, 疾风鹰羽 : 10}),
            '穿甲箭-2' : createRecipesCfg({'铁锭' : 5, 石化大喙 : 10, 黄水晶 : 2, 石化大羽 : 10}),
            '爆裂箭' : createRecipesCfg({'附魔箭矢' : 5, 元素印记 : 10, 飓风魔核 : 10, 女妖翅膀 : 10}),
        },
        text : '精灵-游侠二次觉醒种族，所有箭矢都会额外触发一次伤害'
    }),
    '精灵-德鲁伊' : new Race({
        name : '精灵-德鲁伊',
        hp : 100,
        weight : 80,
        atk : 2,
        def : 0,
        attrPoint : 131402,
        godRace : '精灵-荒野半神',
        recipes : {
            '弓胚' : createRecipesCfg({'木材' : 5, '纤维' : 10}),
            '弓胚：猎人' : createRecipesCfg({'铜锭' : 5, '兽皮' : 10, '蜘蛛丝' : 5}),
            '弓胚：灵魂' : createRecipesCfg({'木材' : 5, '哥布林魔晶' : 3, '灵魂残片' : 10, '蜘蛛丝' : 5, '闪耀的皮' : 10}),
            '弓胚：巨人杀手-1' : createRecipesCfg({'铁锭' : 10, '幽灵蛛丝' : 10, '疯狂之血' : 5, '神性紫晶' : 3}),
            '弓胚：巨人杀手-2' : createRecipesCfg({'铁锭' : 10, '石化巨爪' : 10, '石巨人之眼' : 5, '石化重瞳' : 3}),
        },
        skills : {
            '自然附着' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '木箭' : createRecipesCfg({'木材' : 3, 纤维 : 5}),
            '魔法箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 5, 魔晶石 : 2, 羽毛 : 10}),
            '火焰箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 10, 纯净水晶 : 10, 羽毛 : 10}),
            '变身巨熊' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '变身猎豹' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '撼地击' : createRecipesCfg({纤维 : 1}),
            '双爪撕裂' : createRecipesCfg({纤维 : 1}),
        },
        text : '精灵一次觉醒种族，可以变身为动物形态'
    }),
    '精灵-荒野半神' : new Race({
        name : '精灵-荒野半神',
        hp : 100,
        weight : 80,
        atk : 2,
        def : 0,
        attrPoint : 131402,
        recipes : {
            '弓胚' : createRecipesCfg({'木材' : 5, '纤维' : 10}),
            '弓胚：猎人' : createRecipesCfg({'铜锭' : 5, '兽皮' : 10, '蜘蛛丝' : 5}),
            '弓胚：灵魂' : createRecipesCfg({'木材' : 5, '哥布林魔晶' : 3, '灵魂残片' : 10, '蜘蛛丝' : 5, '闪耀的皮' : 10}),
            '弓胚：巨人杀手-1' : createRecipesCfg({'铁锭' : 10, '幽灵蛛丝' : 10, '疯狂之血' : 5, '神性紫晶' : 3}),
            '弓胚：巨人杀手-2' : createRecipesCfg({'铁锭' : 10, '石化巨爪' : 10, '石巨人之眼' : 5, '石化重瞳' : 3}),
        },
        skills : {
            '自然附着' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '木箭' : createRecipesCfg({'木材' : 3, 纤维 : 5}),
            '魔法箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 5, 魔晶石 : 2, 羽毛 : 10}),
            '火焰箭' : createRecipesCfg({'木材' : 5, 蜘蛛丝 : 10, 红水晶 : 10, 羽毛 : 10}),
            '变身巨熊' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '变身猎豹' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '大地之熊' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '幻影猎豹' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '撼地击' : createRecipesCfg({纤维 : 1}),
            '双爪撕裂' : createRecipesCfg({纤维 : 1}),
        },
        text : '精灵-德鲁伊二次觉醒种族，掌握了更强大的能力'
    }),
    '半人马' : new Race({
        name : '半人马',
        skills : {
            '冲锋' : createRecipesCfg({纤维 : 1}),
        },
        onCreate(){
            data.spd = 50;
        },
        get : '速度加成达到50%后，触发时间流逝（例如跑图，探索，采集，睡觉，打怪）即解锁',
        text : '初始拥有50%的速度加成'
    }),
    '半人马-轻骑兵' : new Race({
        name : '半人马-轻骑兵',
        attrPoint : 131402,
        godRace : '半人马-白马义从',
        skills : {
            '冲锋' : createRecipesCfg({纤维 : 1}),
        },
        text : '半人马一次觉醒种族，使用冲锋时有概率造成两次伤害。速度加成在1%~99%时几率为20%；速度加成在100%~199%时几率为40%；速度大于等于200%时几率为60%'
    }),
    '半人马-白马义从' : new Race({
        name : '半人马-白马义从',
        attrPoint : 131402,
        skills : {
            '冲锋' : createRecipesCfg({纤维 : 1}),
            '神速' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '解除神速' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '半人马-轻骑兵二次觉醒种族，可以将速度提高到极致'
    }),
    '半人马-重骑兵' : new Race({
        name : '半人马-重骑兵',
        attrPoint : 131402,
        godRace : '半人马-西凉铁骑',
        skills : {
            '冲锋' : createRecipesCfg({纤维 : 1}),
            '提速' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        onToRace(){
            data.spd -= 50;
        },
        text : '半人马一次觉醒种族，扣除50%速度加成，即和别的种族相比不再有额外的速度加成。使用冲锋时，防御也会提供加成。速度加成在1%~99%时，每2点防御提高1点伤害；速度加成在100%~199%时，每1点防御提高1点伤害；速度大于等于200%时，每1点防御提高2点伤害'
    }),
    '半人马-西凉铁骑' : new Race({
        name : '半人马-西凉铁骑',
        attrPoint : 131402,
        skills : {
            '冲锋' : createRecipesCfg({纤维 : 1}),
            '提速' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '半人马-重骑兵二次觉醒种族，冲锋的防御加成固定为3倍，且无视防御'
    }),
    '地精' : new Race({
        name : '地精',
        hp : 100,
        hunger : 50,
        water : 50,
        get : '钓鱼时，如果没钓到鱼，则有1%几率获得“潮湿的爆炸物”，使用后解锁地精种族',
        recipes : {
            '硫磺-1' : createRecipesCfg({'铜矿' : 1}, 1, '熔炉'),
            '硫磺-2' : createRecipesCfg({'铁矿' : 1}, 1, '熔炉'),
            '硫磺-3' : createRecipesCfg({'金矿' : 1}, 1, '熔炉'),
            '硝酸钾' : createRecipesCfg({'纤维' : 10, '木材' : 1}, 1, '熔炉'),
            '木炭' : createRecipesCfg({'木材' : 1}, 1, '熔炉'),
            '黑火药' : createRecipesCfg({'硝酸钾' : 15, '木炭' : 3, '硫磺' : 2}, 1, null, 20),
            '强化黑火药-1' : createRecipesCfg({'黑火药' : 3, '魔力水晶' : 1}, 1),
            '强化黑火药-2' : createRecipesCfg({'黑火药' : 3, '魔力水晶' : 1}, 1),
            '劣质炸药' : createRecipesCfg({'黑火药' : 3, '石头' : 2, '兽皮' : 1, '纤维' : 2}, 1),
            '魔晶炸药' : createRecipesCfg({'黑火药' : 10, '魔晶石' : 5, '兽皮' : 1, '纤维' : 2}, 1),
            '骨刺炸药-1' : createRecipesCfg({'强化黑火药' : 5, '骨刺' : 10, '大地之皮' : 2, '幽灵蛛丝' : 4}, 1),
            '骨刺炸药-2' : createRecipesCfg({'强化黑火药' : 5, '蜈蚣节肢' : 10, '鳄鱼皮' : 2, '水纹毒丝' : 4}, 1),
        },
        skills : {
            '埋雷' : createRecipesCfg({木炭 : 1}, 0, null, 1000),
            '引诱' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '地精可以在熔炉中制造硫磺、木炭和硝酸钾，然后用于在工作台合成黑火药，并在工作台制造地精科技物品。同时，各大财团都不欢迎地精这群喜欢爆炸的疯子，除非钱够多。所以在次元交易所购买物品时的价格变为原本的10倍。'
    }),
    '地精-爆破师' : new Race({
        name : '地精-爆破师',
        hp : 100,
        hunger : 50,
        water : 50,
        attrPoint : 131402,
        godRace : '地精-爆破工程师',
        recipes : {
            '硫磺-1' : createRecipesCfg({'铜矿' : 1}, 1, '熔炉'),
            '硫磺-2' : createRecipesCfg({'铁矿' : 1}, 1, '熔炉'),
            '硫磺-3' : createRecipesCfg({'金矿' : 1}, 1, '熔炉'),
            '硝酸钾' : createRecipesCfg({'纤维' : 10, '木材' : 1}, 1, '熔炉'),
            '木炭' : createRecipesCfg({'木材' : 1}, 1, '熔炉'),
            '黑火药' : createRecipesCfg({'硝酸钾' : 15, '木炭' : 3, '硫磺' : 2}, 1, null, 20),
            '强化黑火药-1' : createRecipesCfg({'黑火药' : 3, '魔力水晶' : 1}, 1),
            '强化黑火药-2' : createRecipesCfg({'黑火药' : 3, '魔力水晶' : 1}, 1),
            '信仰火药' : createRecipesCfg({'黑火药' : 5, '信仰雕像' : 5}, 1),
            '劣质炸药' : createRecipesCfg({'黑火药' : 3, '石头' : 2, '兽皮' : 1, '纤维' : 2}, 1),
            '魔晶炸药' : createRecipesCfg({'黑火药' : 10, '魔晶石' : 5, '兽皮' : 1, '纤维' : 2}, 1),
            '骨刺炸药' : createRecipesCfg({'强化黑火药' : 5, '骨刺' : 10, '大地之皮' : 2, '幽灵蛛丝' : 4}, 1),
            '魔法炸药' : createRecipesCfg({'强化黑火药' : 10, '魔法宝石' : 5, '灰白的皮' : 3, '枯朽粘液' : 5}, 1),
            '飓风炸药' : createRecipesCfg({'信仰火药' : 2, '飓风魔核' : 5, '飓风魔皮' : 3, '染血锁环' : 5}, 1),
        },
        skills : {
            '埋雷' : createRecipesCfg({木炭 : 1}, 0, null, 1000),
            '引诱' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '地精一次觉醒种族，能制造威力更大的炸药'
    }),
    '地精-工程师' : new Race({
        name : '地精-工程师',
        hp : 100,
        hunger : 50,
        water : 50,
        attrPoint : 131402,
        godRace : '地精-爆破工程师',
        recipes : {
            '坐骑：伐木机器人' : createRecipesCfg({'铁锭' : 500, '铜锭' : 300, '神性结晶' : 3, '紫晶之核' : 10}, 1),
            '心脏起搏器' : createRecipesCfg({'雷角' : 10, '铁锭' : 2, '铜锭' : 1}, 1),
            '空间撕裂器' : createRecipesCfg({'铁锭' : 3, '铜锭' : 1, '时空粉尘' : 1}, 1),
        },
        text : '地精一次觉醒种族，工程师们认为，爆炸救不了地精，地精的未来还得靠工程学。无法再制造炸药相关物品，但是能在工作台中制造各种工程学造物。什么，机器人太重，不方便？你倒是做一些次元钥匙啊！'
    }),
    '地精-爆破工程师' : new Race({
        name : '地精-爆破工程师',
        hp : 100,
        hunger : 50,
        water : 50,
        attrPoint : 131402,
        recipes : {
            '硫磺-1' : createRecipesCfg({'铜矿' : 1}, 1, '熔炉'),
            '硫磺-2' : createRecipesCfg({'铁矿' : 1}, 1, '熔炉'),
            '硫磺-3' : createRecipesCfg({'金矿' : 1}, 1, '熔炉'),
            '硝酸钾' : createRecipesCfg({'纤维' : 10, '木材' : 1}, 1, '熔炉'),
            '木炭' : createRecipesCfg({'木材' : 1}, 1, '熔炉'),
            '黑火药' : createRecipesCfg({'硝酸钾' : 15, '木炭' : 3, '硫磺' : 2}, 1, null, 20),
            '强化黑火药-1' : createRecipesCfg({'黑火药' : 3, '魔力水晶' : 1}, 1),
            '强化黑火药-2' : createRecipesCfg({'黑火药' : 3, '魔力水晶' : 1}, 1),
            '信仰火药' : createRecipesCfg({'黑火药' : 5, '信仰雕像' : 5}, 1),
            '劣质炸药' : createRecipesCfg({'黑火药' : 3, '石头' : 2, '兽皮' : 1, '纤维' : 2}, 1),
            '魔晶炸药' : createRecipesCfg({'黑火药' : 10, '魔晶石' : 5, '兽皮' : 1, '纤维' : 2}, 1),
            '骨刺炸药' : createRecipesCfg({'强化黑火药' : 5, '骨刺' : 10, '大地之皮' : 2, '幽灵蛛丝' : 4}, 1),
            '魔法炸药' : createRecipesCfg({'强化黑火药' : 10, '魔法宝石' : 5, '灰白的皮' : 3, '枯朽粘液' : 5}, 1),
            '飓风炸药' : createRecipesCfg({'信仰火药' : 2, '飓风魔核' : 5, '飓风魔皮' : 3, '染血锁环' : 5}, 1),
            '坐骑：伐木机器人' : createRecipesCfg({'铁锭' : 500, '铜锭' : 300, '神性结晶' : 3, '紫晶之核' : 10}, 1),
            '心脏起搏器' : createRecipesCfg({'雷角' : 10, '铁锭' : 2, '铜锭' : 1}, 1),
            '空间撕裂器' : createRecipesCfg({'铁锭' : 3, '铜锭' : 1, '时空粉尘' : 1}, 1),
            '某元素235' : createRecipesCfg({'神格' : 1, '变异核心' : 10000}, 1),
            '某元素239' : createRecipesCfg({'神格' : 1, '虚空粉尘' : 10000}, 1),
            '某元素241' : createRecipesCfg({'神格' : 1, '龙魂宝石' : 1}, 1),
            '会裂开的炸药' : createRecipesCfg({'某元素235' : 5, '某元素239' : 5, '某元素241' : 10, '铁锭' : 50, '铜锭' : 20}, 1),
            '坐骑：载弹机器人' : createRecipesCfg({'铁锭' : 300, '铜锭' : 200, '暴风龙眼' : 3, '紫晶之核' : 10}, 1),
        },
        skills : {
            '埋雷' : createRecipesCfg({木炭 : 1}, 0, null, 1000),
            '引诱' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '地精共用二次觉醒种族，顶级的爆破师和工程师一致认为，单靠工程学或者爆破学救不了地精，他们决定互相学习，最终将工程学和爆破学融为一体，成就了最伟大的地精双料博士，爆破工程师'
    }),
    '狐族' : new Race({
        name : '狐族',
        hp : 100,
        hunger : 50,
        water : 50,
        weight : 50,
        atk : 2,
        def : 0,
        hpUp : 5,
        hungerUp : 1,
        waterUp : 1,
        weightUp : 2,
        atkUp : 0,
        defUp : 0,
        attrPoint : 131403,
        get : '地球人-蜀山在使用天雷合并时，有1%概率解锁狐族',
        skills : {
            '吓唬' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '本是蜀山中一只小狐狸，某日蜀山发生仙魔大战，天雷合并剑意连绵不绝，受逸散的灵气影响，从而诞生灵智，也与天雷合并的气息产生关联。一日，突然受到天雷合并剑意牵引，落入异界之中。虽有灵智，本体仍为一幼狐，体质孱弱，需尽全力，才能博得一线生机。PS：一转前属性很低，但是学习能力很强（每级3点属性点）。一转后属性将反超其他种族'
    }),
    '狐族-狐妖' : new Race({
        name : '狐族-狐妖',
        hp : 300,
        hunger : 200,
        water : 200,
        weight : 200,
        atk : 5,
        def : 3,
        hpUp : 15,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 10,
        atkUp : 0,
        defUp : 0,
        godRace : '狐族-狐仙',
        attrPoint : 131403,
        skills : {
            '狐火' : createRecipesCfg({纤维 : 1}),
            '唤灵' : createRecipesCfg({纤维 : 1}),
            '迷魂' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '狐族一次觉醒种族（狐族只有这一个一转）。已脱离凡兽范围，化身为妖兽，体质超长，并习得些许妖法'
    }),
    '狐族-狐仙' : new Race({
        name : '狐族-狐仙',
        hp : 300,
        hunger : 200,
        water : 200,
        weight : 200,
        atk : 5,
        def : 3,
        hpUp : 15,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 10,
        atkUp : 0,
        defUp : 0,
        attrPoint : 131403,
        skills : {
            '狐火' : createRecipesCfg({纤维 : 1}),
            '唤灵' : createRecipesCfg({纤维 : 1}),
            '迷魂' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '呼风' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '唤雨' : createRecipesCfg({纤维 : 1}),
            '招雷' : createRecipesCfg({纤维 : 1}),
        },
        text : '狐族-狐妖二次觉醒种族，得道成仙，一举一动，便能呼风唤雨，电闪雷鸣。小提示：饥饿和水分不够用？属性点加到饥饿和水分上啊！'
    }),
    '魅魔' : new Race({
        name : '魅魔',
        get : '养成人物触发HappyEnd时解锁（以前已经完成剧情的养成人物，如果还被你养着，那么在你进入游戏时解锁魅魔）。具体操作为：养成人物到2000好感度时，对话即会触发和创世神的战斗，被创世神打死时，如果你的背包中有养成人物送给你的灵魂布偶，则触发HappyEnd。获得养成人物的方法见：图鉴-说明-养成',
        onCreate(){
            data.blood = [];
        },
        skills : {
            '查看气息' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '魅惑' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '魅魔为了保持自身的吸引力，护甲的样式有所更改，所以只能获得护甲提供的防御力的80%（即护甲100防御，你穿上只增加80防御力）。魅魔对任何生物都极具吸引力，在战斗时，对方无法集中精神，攻击波动变为80%~100%。魅魔不享受等级经验加成，但是受等级经验削减。即打比自己等级高的怪不会增加经验，打比自己等级低的怪会减少经验。可以诱惑其他生物交配并吸取精气，吸取精气会耗费你大量能量，所以你的等级会下降被你吸收精气的生物对应的等级，清空经验，并自动进行一次洗点。吸收精气后，会带有该生物的气息，该生物不会主动攻击你。你可以反复吸收一种生物的精气，次数无限制。你第一次吸收某个生物的精气时，拥有该生物10%的气息，之后再次吸收这个生物的精气，气息增加1%，无上限。每拥有1%的气息，则增加该生物对应气息百分比的攻击和防御基础值（以图鉴数据为准，而不是战斗实时数据，只在特定时间出现的怪物，例如节日怪，在非节日期间，不会给玩家提供属性加成，查看气息时也看不到相应的怪物，但是如果确实有对应的气息，在下次节日节日期间又可以获得加成了），以及百分比的十分之一的血量上限，增加的属性向下取整，不足1点即为0。你可以拥有多个气息，拥有的数量不限制，每个气息都能给你带来基础属性加成，不会因为气息多了加成就变少。气息会在跳周目时全部失去。举例：第一次吸收荣耀骑士的精气，拥有荣耀骑士10%的气息，荣耀骑士的属性为“15000血，500攻击，200防御”，即你的基础属性增加150血，50攻击，20防御。之后每次吸收荣耀骑士精气，增加15血，5攻击，2防御'
    }),
    '魅魔-首领' : new Race({
        name : '魅魔-首领',
        weightUp : 10,
        godRace : '魅魔-女王',
        attrPoint : 131402,
        skills : {
            '查看气息' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '魅惑' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '魅魔一次觉醒种族（魅魔只有这一个一转）。可以使用吸收精英怪物的精气'
    }),
    '魅魔-女王' : new Race({
        name : '魅魔-女王',
        weightUp : 10,
        attrPoint : 131402,
        skills : {
            '查看气息' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '魅惑' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '魅魔-首领二次觉醒种族。可以使用吸收传说怪物的精气'
    }),
    '断肠人' : new Race({
        name : '断肠人',
        get : '使用“小型传送阵”在地图上传送时(星灵传送时不消耗小型传送阵，所以无法解锁)，有1%几率解锁断肠人',
        onCreate(){
            if(data.maxSan > 99){
                data.maxSan = 99;
                addObjSan(data, 0)
            }
            data.soulName = randomNum() <= 50 ? '泷' : '鸳';
        },
        changeSoul(){
            data.soulName = data.soulName === '泷' ? '鸳' : '泷';
            data.reduceHart -= data.cnReduceHart;
            data.cnReduceHart = 0;
            addStatus(data, getStatus('心悸'))
            addBattleLog(data.race.says[data.soulName].getRandom())
        },
        skills : {
            '悲怨' : createRecipesCfg({纤维 : 1}),
            '痴念' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '癫狂' : createRecipesCfg({纤维 : 1}),
            '肝肠寸断' : createRecipesCfg({天赋神晶 : 1}),
        },
        says : {
            泷 : [
                '宁同万死碎绮翼，不忍云间两分张。',
                '明月楼高休独倚。酒入愁肠，化作相思泪。',
                '起来呵手封题处，偏到鸳鸯两字冰。',
                '行宫见月伤心色，夜雨闻铃肠断声。',
                '世事茫茫难自料，春愁黯黯独成眠。',
                '一枝红艳露凝霜，云雨巫山枉断肠。',
                '尽叫得鹃声碎,却教人空断肠。',
            ],
            鸳 : [
                '君埋泉下泥销骨，我寄人间雪满头。',
                '不知魂已断，空有梦相随。',
                '枕前泪共阶前雨，隔个窗儿滴到明。',
                '思君如满月，夜夜减清辉。',
                '从别后，忆相逢，几回魂梦与君同。',
                '不觉新凉似水，相思两鬓如霜。',
                '忧来思君不敢忘，不觉泪下沾衣裳。',
                '红绽樱桃含白雪，断肠声里唱阳关。',
            ],
        },
        text : '“泷”和“鸳”是一对痴恋的情侣，某日，两人远游登山，忽然狂风大作，将二人吹下山崖，双方临死前所见的最后一幕，是对方死亡的瞬间。死亡后，二人的灵魂被卷入时空裂缝，在巧合下穿越到了异界，并自动凝结出一具躯体，两人因灵魂扭曲，共用着一副躯体，当泷苏醒时，身体会变成泷的模样，鸳苏醒时亦然。两人的灵魂扭曲在了一起，但灵魂的扭曲让双方的意识都出现了一定程度的混乱，每当一方醒来，都可以获得另一方活动的记忆，但却都以为是自己的记忆，谁都意识不到其中有何问题。双方苦苦思念着对方，却永远找不到对方。该角色的背景设定在游戏中体现为：初始理智为99，克苏鲁学识为0，即少了的1点理智无法带来克苏鲁学识（即你就算理智变为90，也是9点克苏鲁学识，而不是10点），也不会导致灵感触动的触发，但可能导致战斗中疯狂。游戏开局时，出现的灵魂随机为“泷”或“鸳”。每当在战斗中触发疯狂时，会变为另一个灵魂操控身体，且给自身附加“心悸”状态，该状态不会自动消失。每个灵魂能使用的技能不一样。'
    }),
    '断肠人-孤芳' : new Race({
        name : '断肠人-孤芳',
        godRace : '断肠人-红煞',
        attrPoint : 131402,
        skills : {
            '万年霜雪' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '残花落尽' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '断肠人一次觉醒种族，无法通过常规方式觉醒，必须使用技能“肝肠寸断”才能觉醒。“鸳”苦苦思念着“泷”，多少个日夜之后终是明白，此生相见无望，唯有孤芳自赏，独自凋零。鸳的悲恸磨灭了泷的灵魂，从此不会再切换灵魂。'
    }),
    '断肠人-红煞' : new Race({
        name : '断肠人-红煞',
        attrPoint : 131402,
        skills : {
            '疯魔' : createRecipesCfg({纤维 : 1}),
        },
        text : '断肠人-孤芳二次觉醒种族。神灵之力抚平了“鸳”灵魂中的混乱，鸳想起了当初和泷双魂一体的日子，也明白了泷原来一直都在自己身边，但是当初肝肠寸断之时，却是自己无意间将泷的灵魂磨灭。鸳意识到，是自己杀死了泷，且使泷神魂俱灭。被抚平的灵魂彻底崩溃，鸳彻底的疯了。'
    }),
    '断肠人-独竹' : new Race({
        name : '断肠人-独竹',
        godRace : '断肠人-黑邪',
        attrPoint : 131402,
        skills : {
            '心茫然' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '断肠人一次觉醒种族，无法通过常规方式觉醒，必须使用技能“肝肠寸断”才能觉醒。“泷”一直告诉自己，自己能重生，“鸳”理应也行。然而日日苦寻不得果，终是心生绝望，放弃追寻。此生只剩对影成双，却是无处话凄凉。泷的悲恸磨灭了鸳的灵魂，从此不会再切换灵魂。'
    }),
    '断肠人-黑邪' : new Race({
        name : '断肠人-黑邪',
        attrPoint : 131402,
        skills : {
            '崩灵' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '断肠人-独竹二次觉醒种族。神灵之力抚平了“泷”灵魂中的混乱，泷想起了当初和鸳双魂一体的日子，才知晓两人当初虽不得相见，却从未相离。可自己肝肠寸断之时，却无意间将鸳的灵魂磨灭，魂消魄散。两人本可为比翼鸟，却因为自己的软弱，使得鸳永不超生，二人更是连人鬼殊途都算不上，便是能入碧落黄泉却再也寻不到鸳了。被抚平的灵魂彻底崩溃，泷彻底的疯了。'
    }),
    '断肠人-花魂' : new Race({
        name : '断肠人-花魂',
        godRace : '断肠人-双仙',
        attrPoint : 131402,
        skills : {
            '风月情浓' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '死生契阔' : createRecipesCfg({纤维 : 1}),
        },
        text : '断肠人一次觉醒种族，觉醒方式未知（意思是，这个是隐藏种族）。鸳的灵魂分离了出来，身体永远由泷掌控，鸳以灵体的形式存在，虽为灵体，却可互相触碰，相依相偎。二人终能生死相依，形影不离。'
    }),
    '断肠人-双仙' : new Race({
        name : '断肠人-双仙',
        attrPoint : 131402,
        skills : {
            '风月情浓' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '死生契阔' : createRecipesCfg({纤维 : 1}),
        },
        text : '断肠人-花魂二次觉醒种族，战斗中死亡时，可满血复活（每场战斗一次），并获得“双仙”状态，你受到攻击时，敌方将受到相当于你攻击力（包含已装备的武器的攻击力）的伤害，该状态不会自动消失'
    }),
    '天使' : new Race({
        name : '天使',
        get : '拥有1000善良值或1000邪恶值时解锁',
        skills : {
        },
        text : '天使翅膀的颜色会随着善恶的变化而变化，所以一眼就能看出所属阵营，当你和NPC接触时，NPC不会消耗阵营卷轴，会立即获取你的阵营，并根据你所属阵营给出反应。和使用阵营检测卷轴检测你的阵营同理，如果NPC在第一次接触你时没有攻击你，以后你再接触这个NPC他也不会攻击你，即使你的善恶值或阵营发生了变化。天使对阵营的感知同样很强，能感知到同阵营的人物所在，在地图上同阵营的NPC会以褐色标注所在位置'
    }),
    '天使-混沌' : new Race({
        name : '天使-混沌',
        godRace : '天使-伪神',
        attrPoint : 131402,
        skills : {
            '混沌审判' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '天使一次觉醒种族（天使只有这一个一次觉醒种族）。当获取善良值或者邪恶值时，获取的值翻倍。当获取善良值时，如果所属阵营为邪恶阵营，则不会增加善良值，而是将阵营直接转为善良阵营，并获得和邪恶值相等的善良值，例如：你现在是邪恶阵营，拥有100点邪恶值，当你获取善良值时，不管获取的值是多少，本次都不会增加善良值，而你本人将直接变为善良阵营，并拥有100点善良值。如果此时你再获取善良值，比如5点，因为你是善良阵营，所以可以正常获取，又因为翻倍，所以你的善良值变为110'
    }),
    '天使-伪神' : new Race({
        name : '天使-伪神',
        attrPoint : 131402,
        skills : {
            '混沌审判' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
            '阵营转换' : createRecipesCfg({纤维 : 1}, 0, null, 1000),
        },
        text : '天使-混沌二次觉醒种族，可以自由转换阵营。保留天使-混沌的特性，并且当获取善良值或者邪恶值时，获取的值变为3倍'
    }),
};

//查看种族信息
function seeRace(name){
    $('.common-win').show().find('.win-body').html(getRaceText(name));
}

//获取种族说明
function getRaceText(name){
    const defaultRace = new Race();
    return '<p>'+Object.keys(races).filter(e => e.startsWith(name)).map(race => {
        let html = ``;
        html += `<h5 style="text-align: center">${race}</h5><p>`;
        html += `<font color="${defaultRace.hp > races[race].hp ? 'red' : defaultRace.hp < races[race].hp ? '#2eaffd' : ''}">初始生命：${races[race].hp}</font><br>`;
        html += `<font color="${defaultRace.hunger > races[race].hunger ? 'red' : defaultRace.hunger < races[race].hunger ? '#2eaffd' : ''}">初始饥饿：${races[race].hunger}</font><br>`;
        html += `<font color="${defaultRace.water > races[race].water ? 'red' : defaultRace.water < races[race].water ? '#2eaffd' : ''}">初始水分：${races[race].water}</font><br>`;
        html += `<font color="${defaultRace.weight > races[race].weight ? 'red' : defaultRace.weight < races[race].weight ? '#2eaffd' : ''}">初始负重：${races[race].weight}</font><br>`;
        html += `<font color="${defaultRace.atk > races[race].atk ? 'red' : defaultRace.atk < races[race].atk ? '#2eaffd' : ''}">初始攻击：${races[race].atk}</font><br>`;
        html += `<font color="${defaultRace.def > races[race].def ? 'red' : defaultRace.def < races[race].def ? '#2eaffd' : ''}">初始防御：${races[race].def}</font><br>`;
        html += `<font color="${defaultRace.hpUp > races[race].hpUp ? 'red' : defaultRace.hpUp < races[race].hpUp ? '#2eaffd' : ''}">升级提升生命值：${races[race].hpUp}</font><br>`;
        html += `<font color="${defaultRace.hungerUp > races[race].hungerUp ? 'red' : defaultRace.hungerUp < races[race].hungerUp ? '#2eaffd' : ''}">升级提升饥饿：${races[race].hungerUp}</font><br>`;
        html += `<font color="${defaultRace.waterUp > races[race].waterUp ? 'red' : defaultRace.waterUp < races[race].waterUp ? '#2eaffd' : ''}">升级提升水分：${races[race].waterUp}</font><br>`;
        html += `<font color="${defaultRace.weightUp > races[race].weightUp ? 'red' : defaultRace.weightUp < races[race].weightUp ? '#2eaffd' : ''}">升级提升负重：${races[race].weightUp}</font><br>`;
        html += `<font color="${defaultRace.atkUp > races[race].atkUp ? 'red' : defaultRace.atkUp < races[race].atkUp ? '#2eaffd' : ''}">升级提升攻击：${races[race].atkUp}</font><br>`;
        html += `<font color="${defaultRace.defUp > races[race].defUp ? 'red' : defaultRace.defUp < races[race].defUp ? '#2eaffd' : ''}">升级提升防御：${races[race].defUp}</font><br>`;
        html += `升级获得属性点：${races[race].attrPoint}<br>`;
        html += `攻击速度：${races[race].atkSpd}<br>`;
        html += `解锁方式：${races[race].get}<br>`;
        if(races[race].text){
            html += `特性：${races[race].text}<br>`;
        }
        html += `<b>初始携带物品：</b>${races[race].initItems.map(i => `${i.name}<span class="to-cybernet" data-name="${i.name}">🔍</span>*${i.num}`).join('，') || '无'}<br>`;
        html += `<br><b>种族技能(制造材料)</b><br>${Object.keys(races[race].skills).map(s => `<b>${s}</b><span class="to-cybernet" data-name="技能石：${s.split('-')[0]}">🔍</span>(${Object.keys(races[race].skills[s].items).map(i => `${i}<span class="to-cybernet" data-name="${i.split('-')[0]}">🔍</span>*${races[race].skills[s].items[i]}`).join('+')})：${elementCfgs[`技能石：${s.split('-')[0]}`].text}`).join('<br>') || '无'}<br>`;
        html += `<br><b>种族特有配方(制造材料)</b><br>${Object.keys(races[race].recipes).map(s => `<b>${s}</b><span class="to-cybernet" data-name="${s.split('-')[0]}">🔍</span>(${Object.keys(races[race].recipes[s].items).map(i => `${i}<span class="to-cybernet" data-name="${i.split('-')[0]}">🔍</span>*${races[race].recipes[s].items[i]}`).join('+')})：${elementCfgs[`${s.split('-')[0]}`].text}`).join('<br>') || '无'}<br>`;
        html += `</P>`;
        return html;
    }).join('<br><br>')+'</p>';
}
