//时间流逝,流逝的时间仅接受以分钟为单位
function timeLapses(min,inBed){
    //解锁半人马
    if(conf.races.indexOf('半人马') === -1 && data.spd >= 50){
        winMsg('恭喜你解锁半人马种族！');
        conf.races.push('半人马');
        save(confSavedName, conf);
    }
    //解锁天使
    if((data.evil >= 1000 || data.evil <= -1000) && conf.races.indexOf('天使') === -1){
        winMsg('恭喜你解锁天使种族！');
        conf.races.push('天使');
        save(confSavedName, conf);
    }

    if(data.san <= 0 || data.maxSan <= 0){
        addDieLog(`理智或理智上限小于等于0，陷入了永恒的疯狂`);
        die();
    }

    //如果时间为0，则不进行时间流逝
    if(min === 0){
        save();
        warning();
        return;
    }

    if((!data.race.getNoHunger() && conf.waterWarning && data.water <= 0) || (!data.race.getNoHunger() && conf.hungerWarning && data.hunger <= 0)){
        alert('你的饥饿或水分已空，请注意！（可在系统中关闭饥饿和水分提醒）')
    }

    if(data.sweetPotion && data.sweetPotion !== data.date.format('yyyy-MM-dd')){
        data.sweetPotion = null;
        winMsg(`香甜药水已失效`);
    }

    //怪物引爆炸药
    if(data.buryExplosive){
        Object.keys(data.buryExplosive).forEach(worldName => {
            const worldBuryExplosive= data.buryExplosive[worldName];
            Object.keys(worldBuryExplosive).forEach(point => {
                const explosives = worldBuryExplosive[point];
                let count = 0;
                Object.keys(explosives).forEach(e => {
                    count += explosives[e];
                })

                if(randomNum() <= count){
                    msg(`你埋藏在${worldName}[${point}]的炸药被怪物无意间触发了`)
                    data.buryExplosive[worldName][point] = {};
                }
            })
        })
    }

    //龙骑士产生雷电
    if(data.dlcDragonKnight){
        const number = parseInt(min / 10);
        let count = 0;
        if(number > 0){
            //随机在玩家位置的数量
            for (let i = 0 ; i < number ; i++){
                const location = [randomNum(0,xnum - 1), randomNum(0,ynum - 1)];
                if(location[0] === data.location[0] && location[1] === data.location[1]){
                    count++;
                }
            }
            if(count > 0){
                //遭雷劈
                const atk = parseInt(data.maxHp * (0.3 + (data.worldIndex * 0.05)));
                for (let i = 0 ; i < count ; i++){
                    const harm = parseInt(atk * ( 1 - (data.reduceHart || 0)) - data.def);
                    if(harm > 0){
                        data.hp -= harm;
                    }
                }
                let text = `你被雷电击中了${count}次`;
                //获取龙蛋
                if(randomNum(1, 100) < (count * (data.worldIndex + 1) * 2)){
                    addItem(dungeonEggs.getRandom());
                    text += '，获得了一颗龙蛋';
                }

                winMsg(text);
                if(!data.hideLeipiAlert){
                    says([text])
                }
            }
            if(data.hp <= 0){
                addDieLog(`你被雷劈死了`);
            }
        }
    }


    let nowTime = data.date.getTime();
    //加速腐朽,如果装备没有记录时间，则记录时间
    if(data.dlcAccDecay){
        if(data.weapon){
            let bagItemById = getBagItemById(data.weapon.id);
            if(!bagItemById.timeLapses){
                bagItemById.timeLapses = nowTime;
            }
            if(bagItemById.timeLapses > nowTime){
                bagItemById.timeLapses = nowTime;
            }
            data.weapon = bagItemById;
        }
        if(data.armor){
            let bagItemById = getBagItemById(data.armor.id);
            if(!bagItemById.timeLapses){
                bagItemById.timeLapses = nowTime;
            }
            if(bagItemById.timeLapses > nowTime){
                bagItemById.timeLapses = nowTime;
            }
            data.armor = bagItemById;
        }
    }

    data.date = addMin(data.date,min);

    //记录最后一次睡觉的时间
    if(inBed){
        data.sleepTime = data.date.getTime();
    }else if(data.race.name.startsWith('弑魂叔')){
        const {hour, day} = getTime(data.date.getTime() - data.sleepTime);
        //超过15小时，会随时间流逝扣血
        if(hour >= 15){
            data.hp -= min;
        }
        //超过1天有概率猝死
        if(day >= 1){
            const rate = (hour - 24) * 3 + 1;
            if(randomNum() <= rate){
                addDieLog(`长时间没有休息导致猝死`);
                die();
            }
        }
    }

    //加速腐朽DLC减少耐久度
    nowTime = data.date.getTime();
    if(data.dlcAccDecay){
        const oneHour = 1000 * 60 * 60;
        if(data.weapon){
            let bagItemById = getBagItemById(data.weapon.id);
            const num = parseInt((nowTime - bagItemById.timeLapses) / oneHour / (bagItemById.noWear ? 12 : 1));
            bagItemById.endurance -= num;
            if(bagItemById.endurance < 0){
                bagItemById.endurance = 0;
            }
            if(bagItemById.endurance === 0){
                equip(bagItemById);
            }else{
                bagItemById.timeLapses += num * oneHour * (bagItemById.noWear ? 12 : 1);
                data.weapon = bagItemById;
            }
        }
        if(data.armor){
            let bagItemById = getBagItemById(data.armor.id);
            const num = parseInt((nowTime - bagItemById.timeLapses) / oneHour / (bagItemById.noWear ? 12 : 1));
            bagItemById.endurance -= num;
            if(bagItemById.endurance < 0){
                bagItemById.endurance = 0;
            }
            if(bagItemById.endurance === 0){
                equip(bagItemById);
            }else{
                bagItemById.timeLapses += num * oneHour * (bagItemById.noWear ? 12 : 1);
                data.armor = bagItemById;
            }
        }
    }

    if(data.race.name.startsWith('星灵')){
        data.statusDate = data.date;
    }

    //故事变动
    changeStock();
    //NPC移动
    npcMove();

    //命运之月
    if(data.dlcFateMonth && data.monthType && data.monthType.month !== data.date.format('MM')){
        data.monthType = {
            ...dlcFateMonths.getRandom(),
            month : data.date.format('MM')
        };
        if(conf.showFateMonth){
            $('.alert-win').show().find('.alert-win-title').html(`本月为[${data.monthType.name}]，${data.monthType.text}，点击页面顶部的游戏时间可以查看本月主题`)
        }
    }

    //世界末日
    setWorldEndMap();

    //统计扣除了几次状态
    let count = 0;
    //如果没有因为状态不足扣除生命值，则代表状态良好，如果是在床上休息，状态良好时每次扣除状态都会回复一定量的HP
    let great = true;
    //多少血量代替1饥饿值或水分值
    let reduceHpForHungerOrWater = parseInt(data.maxHp * 0.01);
    //是否无饥饿水分的种族
    const noHunger = data.race.getNoHunger();

    if(noHunger){
        reduceHpForHungerOrWater = 1;
    }

    if(data.race.name.startsWith('星灵')){

    }else if(data.hp > 0){
        //循环减少饥饿和水分，饥饿和水分不足时用生命值代替
        while (getPassMin(data.statusDate, data.date) >= statusMin){

            const hungerNum = data.race.name.startsWith('食人魔') ? 2 : data.race.name.startsWith('弑魂叔') && !inBed ? 1.5 : statusNum;
            const waterNum = getSeason() === '夏' ? data.race.name.startsWith('弑魂叔') ? 3 : 2 : statusNum;

            if(data.hunger >= hungerNum){
                data.hunger -= hungerNum;
            }else{
                const num = hungerNum - data.hunger;
                data.hunger -= hungerNum - num;
                data.hp -= num * reduceHpForHungerOrWater;
                great = false;
            }

            if(data.water >= waterNum){
                data.water -= waterNum;
            }else{
                const num = waterNum - data.water;
                data.water -= waterNum - num;
                data.hp -= num * reduceHpForHungerOrWater;
                great = false;
            }

            if(data.race.name.startsWith('人类-法师')){
                if(inBed){
                    addSpi(statusMin / 15 * 5);
                }else{
                    addSpi(statusMin / 15);
                }
            }
            if(data.race.name.startsWith('人类-元素师')){
                if(inBed){
                    addSpi(statusMin / 15 * 10);
                }else{
                    addSpi(statusMin / 15 * 2);
                }
            }
            if(data.race.name.startsWith('污染者')){
                addObjSan(data, statusMin / 15);
            }

            count++;
            data.statusDate = addMin(data.statusDate, statusMin)
        }

        //向上取整
        if(!Number.isInteger(data.hunger)){
            data.hunger = Math.ceil(data.hunger);
        }
        if(!Number.isInteger(data.hp)){
            data.hp = Math.ceil(data.hp);
        }

        if(data.hp <= 0){
            addDieLog(`${inBed ? '睡觉时' : ''}饥饿或水分不足，扣血后死亡`);
        }
        //在床上且状态良好时，回复HP
        if(inBed && great){
            data.hp += count * sleepAddHp;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
                if(data.san < 1){
                    data.san = 1;
                }
            }
        }
    }

    //兼容新加的神话怪
    if(!data.world.mythMonster){
        data.world.mythMonster = [];
    }
    if(data.world.mythMonster.length < data.maps[data.worldIndex].mythMonster.length){
        const myths = data.maps[data.worldIndex].mythMonster.filter(e => data.world.mythMonster.map(m => m.name).indexOf(e) === -1);
        data.world.mythMonster = [...data.world.mythMonster,...(myths.map(e => ({name : e, location : [randomNum(0,xnum - 1), randomNum(0,ynum - 1)],day : new Date(data.date).format('yyyyMMdd')})))]
    }
    //判断神话怪物移动和重生
    data.world.mythMonster.forEach(e => {
        const {name, location, day, deathTime} = e;
        //如果神话怪是死亡状态，则判断是否需要重生
        if(deathTime){
            //不重生
            if(new Date(data.date).getTime() - deathTime < (1000 * 60 * 60 * 24 * mythMonsterRebirthDay)){
                e.location = [-1, -1];
            }else{//重生
                e.location = [randomNum(0,xnum - 1), randomNum(0,ynum - 1)];
                while ((data.nextPoint && e.location.join() === data.nextPoint.join()) || (data.prePoint && e.location.join() === data.prePoint.join())){
                    e.location = [randomNum(0,xnum - 1), randomNum(0,ynum - 1)];
                }
                e.deathTime = null;
                winMsg(`${name}再次降临这个世界`)
            }
        }else{
            //不是同一天，则移动
            if(day !== new Date(data.date).format('yyyyMMdd')){
                e.location = getMoveLocation(location);

                while ((data.nextPoint && e.location.join() === data.nextPoint.join()) || (data.prePoint && e.location.join() === data.prePoint.join())){
                    e.location = getMoveLocation(location);
                }

                e.day = new Date(data.date).format('yyyyMMdd');
            }
        }
    })

    //渲染神话怪状态
    renderMythStatus()

    if(data.edu){
        //降低饥饿和水分
        let passMin = getPassMin(data.edu.eatDay, data.date);
        while (passMin >= eduCfgs.reduceMin){
            data.edu.hunger -= eduCfgs.reduceOnce;
            data.edu.water -= eduCfgs.reduceOnce * (getSeason() === '夏' ? data.race.name.startsWith('弑魂叔') ? 3 : 2 : 1);
            data.edu.eatDay = addMin(data.edu.eatDay, eduCfgs.reduceMin);
            passMin -= eduCfgs.reduceMin;
        }

        //降低好感度
        let passDay = getPassMin(data.edu.sayDay, data.date);
        let oneDayMin = 60 * 24;
        while (passDay > oneDayMin){
            data.edu.friendliness -= eduCfgs.reduceFriendliness4Day;
            data.edu.sayDay = addMin(data.edu.sayDay, oneDayMin);
            passDay -= oneDayMin;
        }
    }

    //自动吃喝
    if(data.edu && data.edu.over && data.edu.follow && data.ks){
        let hasWater = false;
        if(data.ks[0] && getNumByBag(data.ks[0]) > 0){
            const item = getBagItemByName(data.ks[0]);
            hasWater = item.water > 0;
            if(item.hunger > 0 && data.maxHunger - data.hunger >= item.hunger){
                let num = 0;
                while (data.maxHunger - data.hunger >= item.hunger && num < item.quantity){
                    addObjHunger(data, item.hunger);
                    addObjWater(data, item.water || 0);
                    num++;
                }
                reduceItem(item.name, num)
                msg(`${data.edu.name}喂你吃了${num}个${item.name}`)
                save();
            }
        }
        if(data.ks[1] && getNumByBag(data.ks[1]) > 0){
            const item0 = getBagItemByName(data.ks[0]);
            const item = getBagItemByName(data.ks[1]);
            if(item.water > 0 && (hasWater ? data.maxWater - data.water - item0.water >=  item.water : data.maxWater - data.water >= item.water)){
                let num = 0;
                while ((hasWater ? data.maxWater - data.water - item0.water >=  item.water : data.maxWater - data.water >= item.water) && num < item.quantity){
                    addObjWater(data, item.water);
                    num++;
                }
                reduceItem(item.name, num)
                msg(`${data.edu.name}喂你吃了${num}个${item.name}`)
                save();
            }
        }

        //养成人物喂自己
        if(data.edu.hunger <= eduCfgs.needNum + 20 && (data.ks[2] && getNumByBag(data.ks[2]) > 0 || data.ks[0] && getNumByBag(data.ks[0]) > 0)){
            let item = getBagItemByName(data.ks[2]);
            if(!item || !item.hunger){
                item = getBagItemByName(data.ks[0]);
            }

            if(item){
                const like = data.edu.likeFood.indexOf(item.name) !== -1;
                const hate = data.edu.hateFood.indexOf(item.name) !== -1;
                let isEat = false;
                if(item.hunger > 0){
                    data.edu.hunger = eduCfgs.maxHunger;
                    data.edu.saidNeedFood = false;
                    isEat = true;
                }
                if(item.water > 0){
                    data.edu.water = eduCfgs.maxWater;
                    data.edu.saidNeedWater = false;
                    isEat = true;
                }

                if(isEat){
                    msg(`${data.edu.name}自己吃了1个${item.name}`)
                    reduceItem(item.name)
                    if(like){
                        data.edu.friendliness += eduCfgs.giveLikeFoodAddFriendliness;
                    }else if(hate){
                        data.edu.friendliness -= eduCfgs.giveHateFoodReduceFriendliness;
                    }else{
                        data.edu.friendliness += eduCfgs.giveFoodAddFriendliness;
                    }
                }
            }
        }
        if(data.edu.water <= eduCfgs.needNum + 20 && (data.ks[2] && getNumByBag(data.ks[2]) > 0 || data.ks[1] && getNumByBag(data.ks[1]) > 0)){
            let item = getBagItemByName(data.ks[2]);
            if(!item || !item.water){
                item = getBagItemByName(data.ks[1]);
            }

            if(item){
                const like = data.edu.likeFood.indexOf(item.name) !== -1;
                const hate = data.edu.hateFood.indexOf(item.name) !== -1;
                let isEat = false;

                if(item.hunger > 0){
                    data.edu.hunger = eduCfgs.maxHunger;
                    data.edu.saidNeedFood = false;
                    isEat = true;
                }
                if(item.water > 0){
                    data.edu.water = eduCfgs.maxWater;
                    data.edu.saidNeedWater = false;
                    isEat = true;
                }

                if(isEat){
                    msg(`${data.edu.name}自己吃了1个${item.name}`)
                    reduceItem(item.name)
                    if(like){
                        data.edu.friendliness += eduCfgs.giveLikeFoodAddFriendliness;
                    }else if(hate){
                        data.edu.friendliness -= eduCfgs.giveHateFoodReduceFriendliness;
                    }else{
                        data.edu.friendliness += eduCfgs.giveFoodAddFriendliness;
                    }
                }
            }
        }
    }

    if(data.dlcKeepDark){
        //记录黑暗时间
        let playerGood = data.hp > 0;
        let has = 0;
        let items = data.bag.filter(e => e.name === '火把')
        items.forEach(e => {
            has += e.endurance;
        })
        //一小时的毫秒数
        const oneH = 1000 * 60 * 60;

        while(data.date.getTime() - data.darkTime > oneH){
            //如果还有火把，则消耗1耐久
            if(has){
                reduceEndurance('火把');
                has--;
            }else{
                //没有火把则被怪物攻击
                const atk = parseInt(data.maxHp * 0.3);
                const harm = parseInt(atk * ( 1 - (data.reduceHart || 0)) - data.def);
                if(harm > 0){
                    data.hp -= harm;
                }
                msg(`你被黑暗维度的怪物攻击了，受到${harm}伤害`)
                if(data.armor){
                    reduceArmorEndurance(data.armor.id);
                }
            }
            data.darkTime += oneH;
        }
        if(playerGood && data.hp <= 0){
            addDieLog(`你被黑暗维度的怪物杀死了`)
        }
    }

    //渲染季节和日夜
    renderSeasonAndDayNight();

    //重新渲染地图
    renderMapElements();
    renderCanToMap()
    renderKeepDark()

    if(data.hp <= 0){
        die();
        return;
    }else{
        let monsterMaybeAtkYou = !inBed && !data.inDungeon && !data.race.name.startsWith('巨龙') && (!data.race.name.startsWith('操脑蛛') || data.control) && !data.safeRun;
        //如果不是在床上休息，也不在副本，则有可能被怪物攻击。而巨龙不会被主动攻击
        if(monsterMaybeAtkYou){
            const dlcAddProb = checkMonthName('暴动之月') ? 10 : checkMonthName('平静之月') && !data.race.challenge ? -10 : 0;
            //获取当前地图的怪物列表
            let monsterList = data.world.mapElements[data.location.join()].monsterList || [];

            //魅魔不会被拥有血脉的怪物攻击
            let notBattleNames = [];
            if(data.race.name.startsWith('魅魔')){
                notBattleNames = data.blood.map(e => e.name);
            }

            //循环所有怪物
            let inBattle = false;
            [...monsterList,...data.world.mythMonster.filter(e => e.location.join() === data.location.join()).map(e => e.name)].forEach(e => {
                if(inBattle){
                    return;
                }
                const name = e.split('(')[0];

                if(notBattleNames.includes(name)){
                    return;
                }

                //获取攻击概率和主动攻击时间
                const {atkProb, atkTime, level} = monsterCfgs[name];
                //获取当前时间
                const dayOrNight = getDayOrNight();

                //怪物不会攻击比自己高5级以上的玩家
                if(data.level - level > 5 && !(data.edu && data.edu.follow && !data.edu.over)){
                    return;
                }

                //如果当前时间在怪物的攻击时间范围内，则判断是否发起攻击
                if(atkTime === '全天' || dayOrNight === atkTime || (data.edu && data.edu.follow && !data.edu.over)){
                    const random = randomNum(1,100);
                    //怪物攻击
                    if(random <= atkProb + dlcAddProb){
                        msg(`你被${name}攻击了`);
                        inBattle = true;
                        startBattle(name);
                    }
                }
            })
        }
        save();
    }


    warning();
    renderKs();
}

//状态不足时红色警告
function warning(){
    let flag = false;

    if(conf.hpWarning && data.hp < data.maxHp * 0.2){
        flag = true;
    }
    if(!data.race.getNoHunger() && conf.hungerWarning && data.hunger < 20){
        flag = true;
    }
    if(!data.race.getNoHunger() && conf.waterWarning && data.water < 20){
        flag = true;
    }
    if(conf.weightWarning && data.weight > data.maxWeight){
        flag = true;
    }
    //弑魂叔提醒睡觉
    if(data.race.name.startsWith('弑魂叔') && getTime(data.date.getTime() - data.sleepTime).hour >= 10){
        flag = true;
    }

    if(flag){
        $('body').addClass('warning');
        if(!$('.map-div').is(':hidden')){
            alert('请注意你的状态')
        }
    }else{
        $('body').removeClass('warning');
    }

    if(conf.weightWarning && data.weight >= data.maxWeight * 0.8){
        $('body').addClass('orange-warning');
    }else{
        $('body').removeClass('orange-warning');
    }
}

//死亡
function die(){
    if(data.battleMonster && data.battleMonster.name === '创世神'){
        const isHasAmulet = hasAmulet('灵魂布偶');
        says([
            `我的耐心已经耗尽，你终将引来死亡`,
            `${data.edu.name}：不，请等等……`,
            `你还在留恋吗？你只是我的人性化身而已，本就是我的一部分，回归我的身体吧`,
            `${data.edu.name}：我愿意回归，但是请你饶恕这个凡人吧`,
            `凡人的生命终将走到尽头`,
            `${data.edu.name}：但应该自己走到尽头`,
            `${data.edu.name}：我只有这一点小小的要求，对你来说微不足道，求你了`,
            `好吧，那么，这是我最后的仁慈了`,
            `凡人，你就继续你那短暂的生命吧`,
            `${data.edu.name}：对不起，给你添麻烦了`,
            `${data.edu.name}：我刚才全都想起来了`,
            `${data.edu.name}：我没有欺骗过你，从来没有`,
            `${data.edu.name}：以后不能陪着你了`,
            `${data.edu.name}：要保护好自己哦`,
            `[${data.edu.name}微笑地看着你，眼里的泪水从脸庞滑落]`,
            `[你只能看着她和创世神一起消失]`,
            `[再也见不到了，无论是${data.edu.name}，还是别的谁]`,
            `[这个世界你从此只能一个人生活了，永远一个人]`,
        ], () => {
            if(isHasAmulet){
                says([
                    `……`,
                    `[你感觉到身上一阵炽热]`,
                    `[她送给你布偶正在发着柔和的光，暖暖的，就像她的身体一样]`,
                    `咦，我这是……？`,
                    `是你吗？真的是你吗？`,
                    `[布偶发出一阵强光，变成了${data.edu.name}]`,
                    `[她握着你的手，满脸泪水]`,
                    `我不是被创世神吸收了吗？`,
                    `是这个布偶吧，我记得我在这个布偶里注入了我的灵魂`,
                    `我能感觉到，我和创世神已经没有联系了`,
                    `我们可以在一起了对吧？永远在一起`,
                    `[${data.edu.name}摆脱了和创世神的联系]`,
                    `[以后不会再遇到创世神了]`,
                    `[因为体内没有了创世神的力量，她跟随你时将不会再被怪物额外攻击]`,
                    `[当你让她跟随你时，她会提醒你吃喝(即自动吃喝，具体见图鉴-说明-养成剧情)]`,
                ]);
            }
        });
        if(isHasAmulet){
            if(conf.races.indexOf('魅魔') === -1){
                winMsg('恭喜你解锁魅魔！');
                conf.races.push('魅魔');
                save(confSavedName, conf);
            }
            data.edu.over = true;
            data.eduOver = true;
            reduceItem('灵魂布偶')
            save();
        }else{
            data.edu = null;
            data.eduOver = true;
        }

        data.hp = data.maxHp;
        battleEnd();
        renderMapElements();
        save();
        return false;
    }

    //灵魂守护死亡判定
    if(inBattle() && hasStatus(data, '灵魂守护')){
        removeStatus(data, '灵魂守护');
        data.hp = parseInt(data.maxHp * 0.5)
        addBattleLog(`她的灵魂保护了你`)
        if(data.san < 1){
            data.san = 1;
        }
        return true;
    }

    //死亡主宰死亡判定
    if(inBattle() && data.race.name === '巫妖-死亡主宰' && data.soul >= 300 && data.battleMonster && !data.battleMonster.wyswzz){
        data.battleMonster.wyswzz = true;
        data.soul -= 300;
        data.atk += 300;
        data.def += 300;
        addBattleLog(`你是死亡的主宰，你在死亡中获得力量：生命值恢复${battleAddHp(data, data.maxHp)}，攻击力和防御力+300`)
        if(data.san < 1){
            data.san = 1;
        }
        return true;
    }

    //断肠人-双仙死亡判定
    if(inBattle() && data.race.name === '断肠人-双仙' && data.battleMonster && !data.battleMonster.dcrsx){
        data.battleMonster.dcrsx = true;
        addStatus(data, getStatus('双仙', {returnHarm : data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)}))
        addBattleLog(`鸳为你承受了伤害，并被激怒了：生命值恢复${battleAddHp(data, data.maxHp)}，获得双仙状态`)
        if(data.san < 1){
            data.san = 1;
        }
        return true;
    }

    //无限副本获取奖励
    if(dungeons[data.world.name] && dungeons[data.world.name].type === 2) {
        $('.leave-dungeon').click();
        battleEnd();
        return false;
    }

    //死亡丢失坐骑
    if(data.mount && data.mount.quality != 4){
        const id = data.mount.id;
        equipMount(data.mount)
        reduceItemById(id)
    }

    //坐骑替死
    const dieDragon = data.mount && data.mount.quality == 4;

    if(data.bind){
        let num = 0;
        if(data.reviveNum){
            num = data.reviveNum;
        }else{
            data.reviveNum = 0;
        }
        if(data.bind.race === '巫妖命匣' || data.bind.race === '神力庇佑' || data.bind.race === '世界庇佑' || (data.bind.race === '命运挽歌' && getNumByBag('命运硬币') >= data.level * 5 * (num + 1))){
            if(data.bind.race === '巫妖命匣'){
                data.hp = data.maxHp;
                if(data.san < 1){
                    data.san = 1;
                }
                //回到重生点
                toWorld(data.bind.index);
                data.location = data.bind.location;
                $('.alert-win').show().find('.alert-win-title').html('作为一名巫妖，你应该庆幸自己还有命匣，而不是永远的归于寂静。');
            }
            if(data.bind.race === '神力庇佑'){
                $('.alert-win').show().find('.alert-win-title').html('神力保护了你，让你免于死亡，但要小心，保护你的神力已经耗尽。');
            }
            if(data.bind.race === '世界庇佑'){
                let finalBoss = null;
                const map = data.maps.filter(e => e.name === data.world.name);
                if(map.length > 0){
                    finalBoss = map[0].finalBoss;
                }
                if(data.battleMonster && data.battleMonster.name === finalBoss){
                    $('.alert-win').show().find('.alert-win-title').html('因为世界BOSS的存在，你窃取世界之力没有被发现，你完美的复活了。');
                }else{
                    if(data.race.challenge){
                        battleEnd();
                        //脱下装备
                        const weapon = data.weapon && getBagItemById(data.weapon.id);
                        const armor = data.armor && getBagItemById(data.armor.id);
                        const bagEquip = data.bagEquip && getBagItemById(data.bagEquip.id);
                        if(weapon){
                            equip(weapon)
                        }
                        if(armor){
                            equip(armor)
                        }
                        if(bagEquip){
                            equipBag(bagEquip)
                        }
                        //清空背包
                        data.bag = [];

                        data.exp = 0;
                        data.level = 1;
                        initAttr();
                        data.hp = data.maxHp;
                        if(data.san < 1){
                            data.san = 1;
                        }
                        data.bind = null;
                        data.spi = 10;
                        data.divinity = 0;
                        data.soul = 0;
                        data.mucus = 0;

                        if(data.race.name.startsWith('戏命师')){
                            data.reviveNum = 0;
                            addItem('命运硬币', 10)
                        }

                        //回到重生点
                        toWorld(0, false);
                        const x = randomNum(0,xnum - 1);
                        const y = randomNum(0,ynum - 1);
                        data.location = [x,y];
                        setShowMap();
                        //渲染地图元素
                        renderMapElements();
                        //渲染可前往的地图
                        renderCanToMap();
                        //渲染地图
                        renderMap();

                        $('.home').hide();
                        save();
                        $('.alert-win').show().find('.alert-win-title').html('你窃取了世界之力，勉强保住了性命，但是身上的东西全都丢失了。');

                        backupSaved(false);
                        return;
                    }
                    if(data.race.name.startsWith('操脑蛛') || data.control){
                        data.control = null;
                        initAttr();
                        data.suck = 0;
                        $('.alert-win').show().find('.alert-win-title').html('你窃取了世界之力，虽然完美复活了，但也受到了世界的反噬，并且你操控的怪物无法复活');
                    }else{
                        $('.alert-win').show().find('.alert-win-title').html('你窃取了世界之力，虽然完美复活了，但也受到了世界的反噬。');
                    }
                    data.attrPoint -= 3;
                    if(!data.consumePoint){
                        data.consumePoint = 0;
                    }
                    data.consumePoint += 3;
                }
            }
            if(data.bind.race === '命运挽歌'){
                data.hp = data.maxHp;
                if(data.san < 1){
                    data.san = 1;
                }
                data.reviveNum++;
                reduceItem('命运硬币', data.level * 5 * (num + 1))
                $('.alert-win').show().find('.alert-win-title').html('你不甘于死亡，幸运的是你准备充分，你成功扭转了自己的命运。');
            }
            data.bind = null;
            data.hp = data.maxHp;
            if(data.san < 1){
                data.san = 1;
            }
        }else{
            if(data.bind.race === '命运挽歌'){
                battleEnd();
                reallyDie();
                backupSaved(false);
                return false;
            }
            battleEnd();
            data.hp = data.maxHp;
            if(data.san < 1){
                data.san = 1;
            }
            //回到重生点
            toWorld(data.bind.index);
            data.location = data.bind.location;
            //脱下装备
            const weapon = data.weapon && getBagItemById(data.weapon.id);
            const armor = data.armor && getBagItemById(data.armor.id);
            const bagEquip = data.bagEquip && getBagItemById(data.bagEquip.id);
            const mount = data.mount && getBagItemById(data.mount.id);
            if(mount){
                equipMount(mount)
            }
            if(weapon){
                equip(weapon)
            }
            if(armor){
                equip(armor)
            }
            if(bagEquip){
                equipBag(bagEquip)
            }
            //清空背包
            data.bag = [];
            //吸血鬼和神性史莱姆清空吸血和减伤
            data.reduceHart = 0;
            data.suck = 0;
            data.spd = 0;

            //转生
            data.race = races[data.bind.race];
            data.exp = 0;
            data.level = 1;
            //蜥蜴人先祖附魔清空
            if(data.patriarchEnchantWeapon){
                data.atk -= data.patriarchEnchantWeapon.atk || 0;
                data.def -= data.patriarchEnchantWeapon.def || 0;
                data.reduceHart -= data.patriarchEnchantWeapon.defProp || 0;
                data.maxHp -= data.patriarchEnchantWeapon.hp || 0;
                data.suck -= data.patriarchEnchantWeapon.suck || 0;
                data.patriarchEnchantWeapon = null;
            }
            if(data.patriarchEnchantArmor){
                data.atk -= data.patriarchEnchantArmor.atk || 0;
                data.def -= data.patriarchEnchantArmor.def || 0;
                data.reduceHart -= data.patriarchEnchantArmor.defProp || 0;
                data.maxHp -= data.patriarchEnchantArmor.hp || 0;
                data.suck -= data.patriarchEnchantArmor.suck || 0;
                data.patriarchEnchantArmor = null;
            }

            initAttr();
            data.bind = null;
            data.race.initItems.forEach(e => {
                addItem(e.name, e.num)
            })

            $('.alert-win').show().find('.alert-win-title').html('你的死亡毫无价值，但你的灵魂标记让你不至于失去一切。现在，你作为亡灵生物，重新站了起来。')

            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf(data.race.name) === -1){
                conf.races.push(data.race.name);
                save(confSavedName, conf);
                winMsg(`恭喜你解锁了${data.race.name}！`);
            }
        }

        //渲染地图元素
        renderMapElements();
        //渲染可前往的地图
        renderCanToMap();
        //渲染地图
        renderMap();
        renderBag();
        save();
    }else if(dieDragon){
        $('.alert-win').show().find('.alert-win-title').html('你的坐骑献祭了自己，拯救了你的生命');
        data.hp = data.maxHp;
        if(data.san < 1){
            data.san = 1;
        }

        const id = data.mount.id;
        equipMount(data.mount);
        reduceItemById(id)

        //渲染地图元素
        renderMapElements();
        //渲染可前往的地图
        renderCanToMap();
        //渲染地图
        renderMap();
        renderBag();
        battleEnd();
        save();
        backupSaved(false);
        return true;
    }else{
        reallyDie();
    }

    battleEnd();
    backupSaved(false);
    return false;
}

//无法复活了，真的死了
function reallyDie(){
    if(data.maxSan <= 0){
        isDie = true;
        Store.remove()
        addBattleLog('你知道了太多不该知道的知识，你见到了太多不该见到的东西，你的理智上限已经小于等于0，你永远的死亡了')
        msg('你知道了太多不该知道的知识，你见到了太多不该见到的东西，你的理智上限已经小于等于0，你永远的死亡了')
        $('.die').show()
    }
    //简单难度不会删档
    if(diff === '简单难度'){
        battleEnd();
        data.hp = data.maxHp;
        data.san = data.maxSan;
        data.hunger = data.maxHunger;
        data.water = data.maxWater;
        data.bind = null;

        data.attrPoint -= 1;
        if(!data.consumePoint){
            data.consumePoint = 0;
        }
        data.consumePoint += 1;
        initAttr();

        save()
        backupSaved(false);
        setTimeout(warning, 1000)
        renderBag();

        $('.home').hide();
        $('.alert-win').show().find('.alert-win-title').html('你的死亡并不是毫无代价，你永远损失了1点属性点')
    }else if(diff === '新人难度'){
        battleEnd();
        data.hp = data.maxHp;
        data.san = data.maxSan;
        data.hunger = data.maxHunger;
        data.water = data.maxWater;
        data.bind = null;

        if(data.level > 1){
            data.level--;
        }
        data.exp = 0;
        initAttr();

        save()
        backupSaved(false);
        setTimeout(warning, 1000)
        renderBag();

        $('.home').hide();
        $('.alert-win').show().find('.alert-win-title').html('你死亡了，等级降低1级，并自动进行了1次洗点，请重新加点')
    }else{
        if(data.order > 1){
            battleEnd();
            data.order -= 1;
            Object.keys(races).forEach(e => {
                races[e].attrPoint -= 2
            })
            if(data.order > 1){
                data.race = races[data.race.name || '人类'];
            }
            data.san = data.maxSan;
            data.bind = null;

            initAttr();
            save()
            backupSaved(false);
            setTimeout(warning, 1000)
            renderBag();
            renderMapElements();

            $('.home').hide();
            $('.alert-win').show().find('.alert-win-title').html('的死亡了，你的灵魂被拉扯着，感觉回到了上一个时空')
        }else if(hasAmulet('灵魂布偶')){
            data.hp = data.maxHp;

            says([
                '果然还是遇到危险了吗……',
                '没关系，没关系，一直都是你保护我，这一次轮到我保护你了吧',
                '谢谢你这段时间的照顾',
                '明明约定要永远在一起的，但是我恐怕没办法再陪着你了',
                '对不起……以后一定要更加小心哦，好吧吗？',
                '永别了，对不起……',
                `(${data.edu.name}用自己的灵魂治愈了你)`,
            ])

            data.bag = data.bag.filter(e => !(e.isAmulet && e.name === '灵魂布偶' && e.roleId == data.edu.id));
            addItem(`破烂的布偶`, 1, {text : `${data.edu.name}送给你的布偶，和她长得一模一样，但是已经碎掉了，不会再有任何效果了`})

            data.edu = null;
            //渲染地图元素
            renderMapElements();
            //渲染可前往的地图
            renderCanToMap();
            //渲染地图
            renderMap();
            renderBag();
            save();
            backupSaved(false);
        }else{
            isDie = true;
            Store.remove()
            addBattleLog('你死了，死得毫无荣誉可言')
            msg('你死了，死得毫无荣誉可言')
            $('.die').show()
        }
    }
}

//点击物品类型
$('.bag-menu').click(function(){
    const menu = $(this).attr('data-menu');
    showItemType = menu;
    $('.bag-menu').removeClass('bag-menu-active');
    $(this).addClass('bag-menu-active');
    renderBag();
});

//物品上锁或者解锁
$('.item-use-win-name').on('click','.item-lock',function(){
    const id = $(this).attr('data-id');
    const item = getBagItemById(id);
    item.isLock = !item.isLock;
    $('.item-use-win-name').html(`${item.isLock ? `<font class="item-lock" data-id="${item.id}" color="red">🔒︎</font>` : `<font data-id="${item.id}" class="item-lock">🔓</font>`}${item.showName || item.name}<span class="to-cybernet" data-name="${item.name}">🔍</span>`);
    if(item.isLock){
        $('.item-discard').hide();
    }else{
        $('.item-discard').show();
        if(item.isArmor|| item.addWeight || item.isWeapon || item.isMount){
            if((data.mount && data.mount.id === item.id) || (data.armor && data.armor.id === item.id) || (data.bagEquip && data.bagEquip.id === item.id) || (data.weapon && data.weapon.id === item.id)){
                //已装备的物品不可丢弃
                $('.item-discard').hide();
            }
        }
    }
    renderBag();
    save()
});

//点击物品时
$('.bag-items').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    clickBagItem(getBagItemById(id));
});

function clickBagItem(item){
    const text = getItemInfo(item)

    $('.item-discard').show();

    //渲染窗口文本
    $('.item-use-win-name').html(`${item.isLock ? `<font class="item-lock" data-id="${item.id}" color="red">🔒︎</font>` : `<font data-id="${item.id}" class="item-lock">🔓</font>`}${item.showName || item.name}<span class="to-cybernet" data-name="${item.name}">🔍</span>`);
    $('.text-data').html(text);
    if(item.canUse){
        if(elementCfgs[item.name].func || item.name.startsWith('图纸')){
            $('.use-item').hide();
            $('.use-item-one').show();
        }else{
            $('.use-item').show();
        }

        if(item.hunger && data.race.name.startsWith('食人魔') && !elementCfgs[item.name].isMeat){
            $('.use-item').hide();
        }

        $('.use-item-one').html(`使用(${item.quantity})`);
    }else if(item.isArmor|| item.addWeight || item.isWeapon || item.isMount){
        $('.use-item').hide();
        $('.use-item-one').show();
        if((data.armor && data.armor.id === item.id) || (data.bagEquip && data.bagEquip.id === item.id) || (data.weapon && data.weapon.id === item.id) || (data.mount && data.mount.id === item.id)){
            $('.use-item-one').html(item.isMount ? '落地' : `卸下`);
            //已装备的物品不可丢弃
            $('.item-discard').hide();
        }else{
            $('.use-item-one').html(item.isMount ? '乘骑' : `装备`);
        }

        if(item.name.startsWith('技能石：') || item.endurance <= 0){
            $('.use-item').hide();
        }

        if(data.race.name.startsWith('蜥蜴人') || ((data.race.name.startsWith('地球人') || data.race.name.startsWith('戏命师')) && item.isWeapon) || (data.race.name.startsWith('操脑蛛') && (!item.addWeight || !data.control))){
            if(!item.isMount && item.name !== '灵魂威慑'){
                $('.use-item').hide()
            }
        }
    }else{
        $('.use-item').hide();
    }

    //锁定的物品不可丢弃
    if(item.isLock){
        $('.item-discard').hide();
    }

    $('.use-item').attr('data-id',item.id);
    $('.item-discard').attr('data-id',item.id);
    $('.item-discard .input').html(1)
    $('.item-use-win-modal').show();
    $('.item-use-win').show();
}

//关闭物品使用窗口
$('.item-use-win-close').click(function(){
    $('.item-use-win-modal').hide();
    $('.item-use-win').hide();
});

//点击使用物品
$('.use-item').click(function(){
    //获取物品
    const id = $(this).attr('data-id');
    const item = data.bag.filter(e => e.id === id)[0];
    let num = parseInt($(this).attr('data-num'));
    if(item.quantity < num){
        num = item.quantity;
    }

    //装备物品
    if(item.isArmor || item.isWeapon){
        equip(item);
        return;
    }

    //装备背包
    if(item.addWeight){
        equipBag(item);
        return;
    }

    //乘骑坐骑
    if(item.isMount){
        equipMount(item);
        return;
    }

    //获得效果
    if(elementCfgs[item.name].func && !elementCfgs[item.name].func.call(item, item)){
        return;
    }

    //针对恢复饥饿/水分/生命值的物品，当可恢复的属性满了时，则提示不需要吃
    if(!elementCfgs[item.name].func && ((item.hp && !item.isInlay) || item.hunger || item.water)){
        let hpGood = true;
        let hungerGood = true;
        let waterGood = true;
        if(item.hp && !item.isInlay && data.hp < data.maxHp){
            hpGood = false;
        }
        if(item.hunger && data.hunger < data.maxHunger){
            hungerGood = false;
        }
        if(item.water && data.water < data.maxWater){
            waterGood = false;
        }
        if(hpGood && hungerGood && waterGood){
            winMsg(`你不需要使用这个`, false, false)
            return;
        }else if(num > 1){
            //如果选择的是使用10个，那么判断是否需要吃10个，如果不需要10个就能吃满，就减少数量
            let needNum = 0;
            if(item.hp && !item.isInlay && data.hp < data.maxHp){
                const need = Math.ceil((data.maxHp - data.hp) / item.hp);
                if(need > needNum){
                    needNum = need;
                }
            }
            if(item.hunger && data.hunger < data.maxHunger){
                const need = Math.ceil((data.maxHunger - data.hunger) / item.hunger);
                if(need > needNum){
                    needNum = need;
                }
            }
            if(item.water && data.water < data.maxWater){
                const need = Math.ceil((data.maxWater - data.water) / item.water);
                if(need > needNum){
                    needNum = need;
                }
            }
            if(needNum < num){
                num = needNum;
            }
        }
    }

    if(item.hp && !item.isInlay){
        data.hp += item.hp * num;
        if(data.hp > data.maxHp){
            data.hp = data.maxHp;
        }
    }
    if(item.hunger){
        data.hunger += item.hunger * num;
        if(data.hunger > data.maxHunger){
            data.hunger = data.maxHunger;
        }
    }
    if(item.water){
        data.water += item.water * num;
        if(data.water > data.maxWater){
            data.water = data.maxWater;
        }
    }

    if(item.getForgeRate){
        if(data.forgeRecipes.indexOf(item.getForgeRate) === -1){
            data.forgeRecipes.push(item.getForgeRate);
            winMsg(`你学会了打造[${item.getForgeRate}]`);
        }else{
            winMsg(`你已经会打造[${item.getForgeRate}]了`, false);
            return;
        }
    }else{
        winMsg(`使用了[${item.name}]*${num}`);
    }

    //如果使用后数量为0，则删除物品，并关闭使用弹窗
    if(reduceItemById(id, num)){
        $('.item-use-win-modal').hide();
        $('.item-use-win').hide();
    }else{
        $('.item-discard .input').html(1)
        $('.item-number').html(item.quantity);
        $('.use-item-one').html(`使用(${item.quantity})`);
    }
    //渲染背包
    renderBag();
    warning();
    if(data.hp <= 0){
        addDieLog(`使用${item.name}导致你死亡`);
        die();
    }else{
        //存档
        save();
    }
});

//穿上或脱下装备
function equip(item){
    let rate = 1;
    if(data.race.name.startsWith('狩猎神裔-防御大师') || data.race.name.startsWith('狩猎神裔-铠甲神匠')){
        rate = 1.5;
    }
    if(data.race.name.startsWith('魅魔')){
        rate = 0.8;
    }

    if(item.isWeapon){//武器
        if(data.weapon && data.weapon.id === item.id){//脱下
            data.weapon = null;
            data.def -= parseInt(item.def * rate);
            data.reduceHart -= item.defProp;
            data.maxHp -= item.hp;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }

            if(data.selfAttrs){
                data.selfAttrs.maxHp -= item.hp;
                data.selfAttrs.reduceHart -= item.defProp;
                data.selfAttrs.def -= parseInt(item.def * rate);
            }

        }else{//穿上
            if(item.level > data.level){
                winMsg('未达到装备等级', false, false)
                return;
            }
            //加速腐朽DLC记录时间
            if(data.dlcAccDecay){
                item.timeLapses = data.date.getTime();
            }
            if(data.weapon){
                data.def -= parseInt(data.weapon.def * rate);
                data.reduceHart -= data.weapon.defProp;
                data.maxHp -= data.weapon.hp;
            }
            data.def += parseInt(item.def * rate);
            data.reduceHart += item.defProp;
            data.maxHp += item.hp;
            data.weapon = item;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }
        }
    }else{//护甲
        if(data.armor && data.armor.id === item.id){//脱下
            data.armor = null;
            data.atk -= item.getAtk(item);
            data.def -= parseInt(item.def * rate);
            data.reduceHart -= item.defProp;
            data.maxHp -= item.hp;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }
            if(data.selfAttrs){
                data.selfAttrs.maxHp -= item.hp;
                data.selfAttrs.atk -= item.atk;
                data.selfAttrs.def -= parseInt(item.def * rate);
                data.selfAttrs.reduceHart -= item.defProp;
            }
        }else{//穿上
            if(item.level > data.level){
                winMsg('未达到装备等级', false, false)
                return;
            }
            //加速腐朽DLC记录时间
            if(data.dlcAccDecay){
                item.timeLapses = data.date.getTime();
            }
            if(data.armor){
                data.atk -= data.armor.getAtk(data.armor);
                data.def -= parseInt(data.armor.def * rate);
                data.reduceHart -= data.armor.defProp;
                data.maxHp -= data.armor.hp;
            }
            data.armor = item;
            data.atk += item.getAtk(item);
            data.def += parseInt(item.def * rate);
            data.reduceHart += item.defProp;
            data.maxHp += item.hp;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }
        }
    }

    $('.item-use-win-modal').hide();
    $('.item-use-win').hide();
    //渲染背包
    renderBag();
    //存档
    save();
}

//乘骑或下地
function equipMount(item){
    if(data.mount && data.mount.id === item.id){
        data.mount = null;
        data.maxWeight -= item.weightUp;
        data.spd -= item.spd;
        data.maxHp -= item.hp;
        if(data.selfAttrs){
            data.selfAttrs.maxHp -= item.hp;
            data.selfAttrs.spd -= item.spd || 0;
        }
        addObjHp(data, 0);

        elementCfgs[item.name].changeEquip && elementCfgs[item.name].changeEquip.call(item, false);
    }else{
        if(data.mount){
            data.maxWeight -= data.mount.weightUp;
            data.spd -= data.mount.spd;
            data.maxHp -= data.mount.hp;
        }
        data.mount = item;
        data.maxWeight += item.weightUp;
        data.spd += item.spd;
        data.maxHp += item.hp;

        elementCfgs[item.name] && elementCfgs[item.name].changeEquip.call(item, true);
    }
    $('.item-use-win-modal').hide();
    $('.item-use-win').hide();

    //渲染背包
    renderBag();
    //存档
    save();
}

//穿上或脱下背包
function equipBag(item){
    if(data.bagEquip && data.bagEquip.id === item.id){
        data.bagEquip = null;
        data.maxWeight -= item.addWeight;
    }else{
        if(data.bagEquip){
            data.maxWeight -= data.bagEquip.addWeight;
        }
        data.bagEquip = item;
        data.maxWeight += item.addWeight;
    }
    $('.item-use-win-modal').hide();
    $('.item-use-win').hide();
    //渲染背包
    renderBag();
    //存档
    save();
}

//点击丢弃按钮
$('.item-discard button').click(function(){
    let num = $(this).attr('data-num');
    //获取物品
    const id = $(this).parents('.item-discard').attr('data-id');
    const item = getBagItemById(id);

    if(item.isWeapon || item.isArmor){
        if(!confirm('是否确认丢弃这件装备？')){
            return;
        }
    }else if(item.isMount){
        if(!confirm('是否确认丢弃这个坐骑？')){
            return;
        }
    }else if(item.quality == 4){
        if(!confirm('是否确认丢弃这个神话品质的物品？')){
            return;
        }
    }

    if(num === 'all'){
        num = item.quantity
    }else{
        num = parseInt(num)
        if(num > item.quantity){
            num = item.quantity;
        }
    }

    if(reduceItemById(item.id,num)){
        $('.item-use-win-modal').hide();
        $('.item-use-win').hide();
    }else{
        $('.item-discard .input').html(1)
        $('.item-number').html(item.quantity);
        $('.use-item-one').html(`使用(${item.quantity})`);
    }

    //丢弃到可拾取区域
    if(!data.world.mapElements[data.location.join()].losts){
        data.world.mapElements[data.location.join()].losts = [];
    }
    const losts = data.world.mapElements[data.location.join()].losts;
    if(item.onlyOne){
        losts.push(item);
    }else{
        let filter = losts.filter(e => e.name === item.name);
        if(filter.length){
            filter[0].quantity += num;
        }else{
            const lostItem = {...item, quantity : num}
            losts.push(lostItem);
        }
    }

    winMsg(`丢弃${num}个[${item.name}]`);

    renderMapElements(false, true)
    //渲染背包
    renderBag();
    //存档
    save();
});

//拾取
$('#get-losts').click(function(){
    if(!data.world.mapElements[data.location.join()].losts){
        data.world.mapElements[data.location.join()].losts = [];
    }
    const losts = data.world.mapElements[data.location.join()].losts;
    losts.forEach(item => {
        if(item.onlyOne){
            data.bag.push(new Element(item));
        }else{
            addItem(item.name, item.quantity)
        }
    })
    data.world.mapElements[data.location.join()].losts = [];

    winMsg(`你拾取了：${losts.map(e => `${e.name}*${e.quantity}`).join('、')}`);
    renderMapElements(false, true)
    renderBag();
    save();
})

//获取背包中指定物品的数量
function getNumByBag(name, inHome){
    const items = data.bag.filter(e => e.name === name);
    const storeItem = inHome ? data.world.home.store.filter(e => e.name === name) : [];



    if(!inHome && items.length === 0){
        return 0;
    }

    if(inHome && items.length === 0 && storeItem.length === 0){
        return 0;
    }

    return (items.length > 0 ? items[0].quantity : 0) + (inHome && storeItem.length > 0 ? storeItem[0].quantity : 0);
}

//根据ID获得背包中的指定物品
function getBagItemById(id){
    const filter = data.bag.filter(e => e.id === id);
    return filter.length > 0 ? filter[0] : null;
}

//根据名称获得背包中的指定物品，没有则返回null
function getBagItemByName(name){
    const filter = data.bag.filter(e => e.name === name);
    return filter.length > 0 ? filter[0] : null;
}

//根据ID获取背包中指定物品的数量
function getNumById(id){
    const items = data.bag.filter(e => e.id === id);

    return items.length > 0 ? items[0].quantity : 0;
}

//点击制造物品
$('.work .win-body,.kitchen .win-body').on('click','.can-make',function(){
    //获取要制造的物品名
    const makeItem = $(this).attr('data-name');
    const itemName = makeItem.split('-').length > 1 ? isNaN(makeItem.split('-')[1]) ? makeItem : makeItem.split('-')[0] : makeItem;
    //制造数量
    const num = parseInt($(this).attr('data-num'));
    //获取所有配方
    const allRecipes = {...recipes};
    Object.keys(data.race.skills).forEach(e => {
        allRecipes[`技能石：${e}`] = data.race.skills[e];
    })
    if(data.mount && elementCfgs[data.mount.name].skills){
        Object.keys(elementCfgs[data.mount.name].skills).forEach(e => {
            allRecipes[`技能石：${e}`] = elementCfgs[data.mount.name].skills[e];
        })
    }
    if(data.weapon && elementCfgs[data.weapon.name].skills){
        Object.keys(elementCfgs[data.weapon.name].skills).forEach(e => {
            allRecipes[`技能石：${e}`] = elementCfgs[data.weapon.name].skills[e];
        })
    }
    //加载护甲技能
    if(data.armor && elementCfgs[data.armor.name].skills){
        Object.keys(elementCfgs[data.armor.name].skills).forEach(e => {
            allRecipes[`技能石：${e}`] = elementCfgs[data.armor.name].skills[e];
        })
    }

    //黑暗侵蚀DLC加入火把
    if(data.dlcKeepDark){
        allRecipes['火把'] = createRecipesCfg({'树枝' : 2, '纤维' : 2, '木材' : 1, '燧石' : 1});
    }

    //获取配方列表
    const items = allRecipes[makeItem].items;
    //减少物品
    Object.keys(items).forEach(name => {
        //如果是在家，允许使用仓库中的物品
        if(data.location.join() === data.world.home.location.join()){
            //获取背包中的数量
            const bagNum = getNumByBag(name);
            //优先使用背包中的物品
            if(bagNum >= items[name] * num){
                reduceItem(name, items[name] * num);
            }else{
                if(bagNum > 0){
                    reduceItem(name, bagNum);
                }
                reduceItemByStore(name, (items[name] * num) - bagNum);
            }

        }else{
            reduceItem(name, items[name] * num);
        }

    })
    //加入背包
    addItem(itemName, num * allRecipes[makeItem].getNum);

    winMsg(`制造了[${itemName}]*${num * allRecipes[makeItem].getNum}`);
    renderWorkList(parseInt($(this).attr('data-level') || 0), $(this).attr('data-need'));
    renderKitchen();
    renderBag();
    save();
})

//点击锻造物品
$('.forge-body').on('click','.forge-can-make',function(){
    //获取要制造的物品名
    const makeItem = $(this).attr('data-name');
    //获取配方列表
    const items = forgeRecipes[makeItem].items;
    //减少物品
    Object.keys(items).forEach(name => {
        //如果是在家，允许使用仓库中的物品
        if(data.location.join() === data.world.home.location.join()){
            //获取背包中的数量
            const bagNum = getNumByBag(name);
            //优先使用背包中的物品
            if(bagNum >= items[name]){
                reduceItem(name, items[name]);
            }else{
                if(bagNum > 0){
                    reduceItem(name, bagNum);
                }
                reduceItemByStore(name, items[name] - bagNum);
            }

        }else{
            reduceItem(name, items[name]);
        }

    })

    //创建装备并加入背包
    const equip = getEquipQuality(elementCfgs[makeItem].new({name : makeItem, quantity : 1}));
    data.weight += equip.weight;
    equipAttrFloat(equip);
    data.bag.push(equip);

    data.forgeExp += qualityAddForgeExp[equip.quality];
    winMsg(`锻造获得[${equip.showName || equip.name}]${equip.hole.length > 0 ? `{${equip.hole.length}}` : ''}，锻造熟练度+${qualityAddForgeExp[equip.quality]}`);

    renderForgeList();
    renderBag();
    save();
})

//装备属性浮动
function equipAttrFloat(equip){
    let count = 0;
    let hasNotMax = !!data.usedXyjz;
    let hasNotMin = false;
    let jp = true;
    ['atk','def','suck','hp'].forEach(e => {
        if(equip[e]){
            count++;
            if(equip.isArmor && data.race.name === '狩猎神裔-铠甲神匠'){
                data.usedXyjz = true;
            }

            let min = data.usedXyjz ? 100 + equipAttrFloatNum :  100 - equipAttrFloatNum;
            if(festival && festival.name && festival.name.includes('国庆')){
                min = data.usedXyjz ? 100 + equipAttrFloatNum :  100;
            }
            const max = 100 + equipAttrFloatNum;
            let floatNum = randomNum(min, max) / 100;
            if(floatNum !== 1.2){
                jp = false;
                hasNotMax = true;
            }
            if(floatNum !== 0.8){
                hasNotMin = true;
            }
            equip[e] = parseInt(equip[e] * floatNum);
        }
    })
    if(data.usedXyjz){
        hasNotMax = true;
    }
    data.usedXyjz = false;

    if(jp){
        equip.jp = true;
        ['atk','def','suck','hp'].forEach(e => {
            if(equip[e]){
                equip[e] += equip.level * (e === 'hp' ? 10 : 1);
            }
        })
    }

    //非酋和欧皇成就判断
    if(count >= 3){
        if(!hasNotMax){
            data.isOuHuang = true;
        }
        if(!hasNotMin){
            data.isFeiQiu = true;
        }
    }
}

//减少耐久,调用一次只减少1点耐久调用时请确保背包中有该物品
function reduceEndurance(name){
    //获取背包中需要的物品
    let item = data.bag.filter(e => e.name === name)[0];
    if(item.noWear){
        return;
    }
    //耐久-1
    item.endurance--;
    //如果耐久为0了，则删除该物品
    if(item.endurance <= 0){
        data.bag = data.bag.filter(e => e.id !== item.id);
        data.weight -= elementCfgs[name].weight;
        msg(`${name}损坏了`)
    }
}

//从背包减少物品，调用此方法请保证背包必定有该物品且数量一定不小于num的值
function reduceItem(name, num = 1){
    let noHave = false;
    const item = data.bag.filter(e => e.name === name)[0];
    if(item){
        item.quantity -= num;
        if(item.quantity <= 0){
            data.bag = data.bag.filter(e => e.name !== name);
            noHave = true;
        }

        data.weight -= elementCfgs[name].weight * num;
    }else{
        return true;
    }

    return noHave;
}

//从仓库减少物品，调用此方法请保证仓库必定有该物品且数量一定不小于num的值
function reduceItemByStore(name, num = 1){
    let noHave = false;
    const item = data.world.home.store.filter(e => e.name === name)[0];
    if(item){
        item.quantity -= num;
        if(item.quantity <= 0){
            data.world.home.store = data.world.home.store.filter(e => e.name !== name);
            noHave = true;
        }
    }else{
        return true;
    }

    return noHave;
}

//从背包减少物品，调用此方法请保证背包必定有该物品且数量一定不小于num的值
function reduceItemById(id, num = 1){
    let noHave = false;
    const item = data.bag.filter(e => e.id === id)[0];
    if(item){
        if(item.quantity === num){
            data.bag = data.bag.filter(e => e.id !== id);
            noHave = true;
        }else{
            item.quantity -= num;
        }
    }else{
        return true;
    }

    data.weight -= elementCfgs[item.name].weight * num;
    renderAttrs();
    return noHave;
}

//批量添加物品，开发人员自用方法
function addItemBatch(name = [], num){
    name.forEach(e => {
        addItem(e, num);
    })
}

//物品加入背包
function addItem(name, num = 1, attr = {}){
    const items = data.bag.filter(e => e.name === name);

    //如果是新物品或不可叠加物品，则初始化个数，并放入背包
    if(items.length === 0 || elementCfgs[name].onlyOne){
        if(elementCfgs[name].onlyOne){//如果是不可叠加物品，则一个个放入背包
            for(let i = 0 ; i < num ; i++){
                const item = elementCfgs[name].new({name : name, quantity : 1, ...attr});
                data.bag.push(item);
            }
        }else{
            const item = elementCfgs[name].new({name : name, quantity : num, ...attr});
            data.bag.push(item);
        }
    }else{//不是新加入的物品，则增加数量
        items[0].quantity += num;
    }
    data.weight += elementCfgs[name].weight * num;
    renderAttrs();
}

//判断升级
function level(showWin = false, handle = false){
    //巫妖手动升级
    if(data.race.name.startsWith("巫妖") && !handle){
        return;
    }
    //获取升级所需经验
    const needExp = data.race.getLevelUpExp();
    //判断是否满足升级条件
    if(data.exp >= needExp){
        let rate = (parseInt(data.level / 10) + 1);
        rate = rate > 5 ? 5 : rate;

        //增加等级和属性点
        data.attrPoint += data.race.attrPoint;
        if(diff === '新人难度'){
            data.attrPoint += 2;
        }
        data.atk += data.race.atkUp;
        data.def += data.race.defUp;
        data.maxHp += data.race.hpUp * rate;
        data.maxHunger += data.race.hungerUp;
        data.maxWater += data.race.waterUp;
        data.maxWeight += data.race.weightUp;
        if(data.selfAttrs){
            data.selfAttrs.maxHunger += data.race.hungerUp;
            data.selfAttrs.maxHp += data.race.hpUp * rate;
            data.selfAttrs.atk += data.race.atkUp;
            data.selfAttrs.def += data.race.defUp;
        }
        data.level++;
        //减少经验
        data.exp -= needExp;
        if(showWin){
            winMsg(`等级提升！`);
        }else{
            msg(`等级提升！`);
        }
        renderBag();
        if(!handle){
            level();
        }
    }
}

//属性加点
$('.add-attr').click(function(){
    const attr = $(this).attr('data-attr');
    if(attr === 'level'){
        level(false, true);
        return;
    }
    if(data.attrPoint > 0){
        let num = addAttrPointNum;

        if(num > data.attrPoint){
            num = data.attrPoint;
        }
        data.attrPoint -= num;

        for(let i = 0 ; i < num ; i++){
            if(attr === 'hp'){
                if(!data.addHpPoint){
                    data.addHpPoint = 0;
                }

                let rate = (parseInt(data.addHpPoint / 20) + 1);
                const addHp = (rate > 5 ? 5 : rate) * data.race.hpUp;
                data.hp += addHp;
                data.maxHp += addHp;
                data.addHpPoint++;
            }
            if(attr === 'hunger'){
                data.hunger += 10;
                data.maxHunger += 10;
            }
            if(attr === 'water'){
                data.water += 10;
                data.maxWater += 10;
            }
            if(attr === 'weight'){
                data.maxWeight += 10;
            }
            if(attr === 'atk'){
                data.atk += 1;
            }
            if(attr === 'def'){
                data.def += 1;
            }
        }

        renderBag();
        save();
    }
});

//点击删号重玩
$('.regame').click(function(){
    if(confirm('该操作无法恢复，是否确认删除当前角色重新开始游戏？')){
        isDie = true;
        Store.remove()
        $('.alert-win').show().find('.alert-win-title').html('为了保护你的存档，请勿操作游戏，2秒后将进入选择种族页面')
        setTimeout(function(){
            window.location.reload();
        }, 2000)
    }
})

//切换难度
$('.rediff').click(function(){
    if(systemLock){
        $('.alert-win').show().find('.alert-win-title').html('为了保护你的存档，开局后2秒内不允许切换难度')
        return;
    }
    if(confirm('是否确认要切换难度？点击确认3秒后进入难度选择页面')){
        setTimeout(function(){
            diff = '0';
            saveDiff();
            window.location.reload();
        }, 3000)
    }
})

//点击清除缓存
$('.clear-cache').click(function(){
    const url = (window.location.href.indexOf('time=') === -1 ? `${window.location.href}?time=${new Date().getTime()}` : `${window.location.href.split('time=')[0]}time=${new Date().getTime()}`);
    window.location.href = url;
})

//点击查看日志
$('.update-logs').click(function(){
    $.get('logs.txt?time=' + new Date().getTime(),function(resp){
        $('.update-logs-win .win-body').html(resp.replace(/\n/g,'<br>'));
        $('.update-logs-win').show();
    })
})

//无限副本击杀记录
$('.dungeon-killed-level').click(function(){
    if(!data.killedLevels){
        data.killedLevels = {};
    }
    $('.dungeon-killed-level-rank .win-body').html(Object.keys(data.killedLevels).map(e => `<p>${e}：LV${data.killedLevels[e]}</p>`).join(''));
    $('.dungeon-killed-level-rank').show();
})

//切换DLC
$('.init-dlc').click(function(){
    const attr = $(this).attr('data-attr');
    const name = $(this).attr('data-name');

    if(attr !== 'dlcAutoKillMonster'){
        if(data.date.getTime() !== initDate.getTime() && data[attr]){
            winMsg('DLC只有刚创建的角色才能关闭', false, false)
            return;
        }
    }
    if(!data[attr] && !confirm('是否确认开启DLC？开启前请先在图鉴-说明-DLC中了解要开启的DLC的相关内容')){
        return;
    }
    data[attr] = !data[attr];
    if(window[attr + 'Open']){window[attr + 'Open']()}
    $(this).html(`${name}：${data[attr] ? '已开启' : '已关闭'}`);
    save();
})

//DLC命运之月
function dlcFateMonthOpen(){
    conf.showFateMonth = true;
    if(data.dlcFateMonth && !data.monthType){
        data.monthType = {
            ...dlcFateMonths.getRandom(),
            month : data.date.format('MM')
        };
        $('.alert-win').show().find('.alert-win-title').html(`本月为[${data.monthType.name}]，${data.monthType.text}，点击页面顶部的游戏时间可以查看本月主题`)
    }
}

//DLC黑暗侵蚀
function dlcKeepDarkOpen(){
    data.darkTime = data.date.getTime();
    if(data.date.getTime() === initDate.getTime()){
        addItem('火把', 5);
    }
}

//DLC自动打怪
function dlcAutoKillMonsterOpen(){
    if(data.dlcAutoKillMonster){
        $('#auto-kill-monster').show();
    }else{
        $('#auto-kill-monster').hide();
    }
}

//DLC世界末日
function dlcWorldEndOpen(){
    if(data.dlcWorldEnd){
        data.doomsday = data.date.format('yyyy-MM-dd')
    }
}

//DLC末法时代
function dlcLastMagicOpen(){
    if(data.dlcLastMagic && data.race.name.includes('-')){
        let weapon = null;
        let armor = null;
        if(data.weapon){
            weapon = getBagItemById(data.weapon.id);
            equip(data.weapon)
        }
        if(data.armor){
            armor = getBagItemById(data.armor.id);
            equip(data.armor)
        }


        data.race = races[data.race.name.split('-')[0]];
        data.race.onCreate();
        if(data.patriarchEnchantArmor && data.patriarchEnchantArmor.isWeapon){
            data.atk -= data.patriarchEnchantArmor.atk || 0;
            data.def -= data.patriarchEnchantArmor.def || 0;
            data.reduceHart -= data.patriarchEnchantArmor.defProp || 0;
            data.maxHp -= data.patriarchEnchantArmor.hp || 0;
            data.suck -= data.patriarchEnchantArmor.suck || 0;
            data.patriarchEnchantArmor = null;
        }
        initAttr();

        if(weapon){
            equip(weapon)
        }
        if(armor){
            equip(armor)
        }
    }
}

//开关神话怪提示
$('.myth-msg').click(function(){
    conf.mythMsg = !conf.mythMsg;
    $('.myth-msg').html(`神话怪提醒：${conf.mythMsg ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})

//开关传说怪提示
$('.legend-msg').click(function(){
    conf.legendMsg = !conf.legendMsg;
    $('.legend-msg').html(`传说怪提醒：${conf.legendMsg ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})

//开关精英怪提示
$('.elite-msg').click(function(){
    conf.eliteMsg = !conf.eliteMsg;
    $('.elite-msg').html(`精英怪提醒：${conf.eliteMsg ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})

//切换存档
$('.select-saved').click(function(){
    if(systemLock){
        $('.alert-win').show().find('.alert-win-title').html('为了保护你的存档，开局后2秒内不允许切换存档')
        return;
    }
    renderSavedList();
    Object.keys(conf.saveListNames).forEach(e => {
        $(`.save[data-name="${e}"]`).html(conf.saveListNames[e]);
    })
    $('.saves').show();
    $('.saves').removeClass('now-saved');
    $(`.save[data-name="${conf.savedName}"]`).addClass('now-saved');
})
$('.saves .save-list').on('click', '.save',function() {
    if($(this).hasClass('now-saved')){
        return;
    }
    $('.save').removeClass('active');
    $(this).addClass('active');
    try{
        const savedData = load($(this).attr('data-name')) || {};
        if(savedData.version){
            $('.save-info').html(`<div class="btn-box" onclick="delSaved()"><span class="text-btn">删除存档</span></div><div class="saved-attr">种族：${savedData.race.name}</div><div class="saved-attr">等级：${savedData.level}</div><div class="saved-attr">周目：${savedData.order}</div>`);
            return;
        }
    }catch (e) {
        console.error(e)

    }
    $('.save-info').html('')
})
//删除存档
function delSaved(){
    const name = $('.save-list .active').attr('data-name');
    if(name && confirm('是否确认删除该存档？存档删除后无法恢复！')){
        delAllSavedFile(name);
        delete conf.saveListNames[name];
        save(confSavedName, conf);
        $('.select-saved').click();
    }
}

//确认切换存档
$('.save-btn').click(function() {
    const name = $('.save-list .active').attr('data-name');
    if(name){
        $('.alert-win').show().find('.alert-win-title').html('为了保护你的存档，请勿操作游戏，3秒后将切换存档')
        setTimeout(function(){
            conf.savedName = name;
            save(confSavedName, conf);
            window.location.reload();
        }, 3000)
    }
})

//家设施排序开关
$('.home-order').click(function(){
    conf.homeOrder = !conf.homeOrder;
    $('.home-order').html(`家设施排序：${conf.homeOrder ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})

//血量、饥饿和水分提醒开关
$('.hp-warning').click(function(){
    conf.hpWarning = !conf.hpWarning;
    $('.hp-warning').html(`血量提醒：${conf.hpWarning ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})
$('.hunger-warning').click(function(){
    conf.hungerWarning = !conf.hungerWarning;
    $('.hunger-warning').html(`饥饿提醒：${conf.hungerWarning ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})
$('.water-warning').click(function(){
    conf.waterWarning = !conf.waterWarning;
    $('.water-warning').html(`水分提醒：${conf.waterWarning ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})
$('.dark-model').click(function(){
    conf.darkModel = !conf.darkModel;
    $('.dark-model').html(`夜间模式：${conf.darkModel ? '已开启' : '已关闭'}`);
    if(conf.darkModel){
        $('body').addClass('night-mode');
    }else{
        $('body').removeClass('night-mode');
    }
    save(confSavedName, conf);
})
$('.weight-warning').click(function(){
    conf.weightWarning = !conf.weightWarning;
    $('.weight-warning').html(`重量提醒：${conf.weightWarning ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})

$('.home-num').click(function(){
    if(!conf.homeNum){
        conf.homeNum = 1;
    }
    conf.homeNum++;
    if(conf.homeNum > 3){
        conf.homeNum = 1;
    }
    $('.home-num').html(`家设施列数：${conf.homeNum}`);
    save(confSavedName, conf);
})

//自动战斗开关
$('.show-auto-battle').click(function(){
    conf.showAutoBattle = !conf.showAutoBattle;
    $('.show-auto-battle').html(`自动攻击：${conf.showAutoBattle ? '已开启' : '已关闭'}`);
    save(confSavedName, conf);
})

//连续攻击开关
$('.keep-atk').click(function(){
    if(!data.keepAtkLog && !conf.keepAtk && !confirm('请仔细阅读图鉴-说明-连续攻击，否则造成一切严重后果不要骂娘')){
        return;
    }
    data.keepAtkLog = true;
    conf.keepAtk = !conf.keepAtk;
    $('.keep-atk').html(`连续攻击：${conf.keepAtk ? '已开启' : '已关闭'}`);
    save();
    save(confSavedName, conf);
});

//关闭按钮位置
$('.is-bottom-win').click(function(){
    conf.isBottomWin = !conf.isBottomWin;
    $('.is-bottom-win').html(`关闭按钮位置：${conf.isBottomWin ? '下方' : '上方'}`);
    //设定弹窗关闭按钮位置
    if(conf.isBottomWin){
        $('.win').addClass('bottom-win');
    }else{
        $('.win').removeClass('bottom-win');
    }
    save(confSavedName, conf);
})

//安家
$('#create-home').click(function(){
    if(confirm('是否确认在这里安家？')){
        data.world.home = {
            location : data.location,//家的位置
            level : 0,//家的级别
            //家的设施
            facilitys : homeLevelFacility[0].map( e => ({
                level : 1,
                name : e
            })),
            //仓库
            store : []
        };
        renderMap();
        renderMapElements();
        save();
    }
});

//回家
$('#go-home').click(function(){
    renderHome();
    $('.home').show();
});

//减少物品耐久
function reduceItemEndurance(item, num = 1){
    //消耗武器的耐久度
    item.endurance -= num;
    if(item.endurance <= 0){
        addBattleLog(`${item.showName || item.name}损坏了`)
        msg(`${item.showName || item.name}损坏了`)
        data.bag = data.bag.filter(e => e.id !== item.id);
    }
}

//武器减少耐久
function reduceWeaponEndurance(id){
    //获取武器
    const weapon = data.bag.filter(e => e.id === id)[0];

    //永不磨损则不减少耐久
    if(weapon.noWear && weapon.name !== '灵魂威慑' && !weapon.name.startsWith("技能石")){
        return weapon;
    }

    //星灵-时间旅者不减少耐久
    if(data.race.name.startsWith('星灵-时间旅者') || data.race.name.startsWith('星灵-宙')){
        return weapon;
    }

    //消耗武器的耐久度
    weapon.endurance--;
    if(data.weapon && data.weapon.id === weapon.id){
        data.weapon.endurance = weapon.endurance;
    }
    if(weapon.endurance <= 0){
        //停止自动攻击
        clearInterval(autoBattle);
        clearInterval(autoBattleId);
        stopAutoKillMonster = true;
        $('.stop-auto-battle').hide();

        //如果是装备的武器，则减少装备的属性
        if(data.weapon && data.weapon.id === weapon.id){
            equip(weapon);
        }

        if(weapon.name.startsWith("技能石")){
            reduceItemById(weapon.id)
        }

        addBattleLog(`${weapon.showName || weapon.name}损坏了`)
        msg(`${weapon.showName || weapon.name}损坏了`)
    }
    return weapon;
}

//护甲减少耐久
function reduceArmorEndurance(id){
    //获取护甲
    const armor = data.bag.filter(e => e.id === id)[0];

    //永不磨损则不减少耐久
    if(armor.noWear){
        return armor;
    }

    //星灵-时间旅者不减少耐久
    if(data.race.name.startsWith('星灵-时间旅者') || data.race.name.startsWith('星灵-宙')){
        return armor;
    }

    //消耗护甲的耐久度
    if(checkMonthName('腐蚀之月') && randomNum(1,100) <= 50){
        armor.endurance -= 2;
    }else if(checkMonthName('牢固之月') && randomNum(1,100) <= 50){

    }else{
        armor.endurance--;
    }
    if(data.armor && data.armor.id === armor.id){
        data.armor.endurance = armor.endurance;
    }
    if(armor.endurance <= 0){
        //停止自动攻击
        clearInterval(autoBattle);
        clearInterval(autoBattleId);
        stopAutoKillMonster = true;
        $('.stop-auto-battle').hide();

        //如果是装备的护甲，则减少装备的属性
        if(data.armor && data.armor.id === armor.id){
            equip(armor);
        }

        addBattleLog(`${armor.showName || armor.name}损坏了`)
        msg(`${armor.showName || armor.name}损坏了`)
    }
    return armor;
}

//重新计算背包重量和解决背包中数量异常的物品
function debugBag(){
    if(isNaN(data.gold)){
        $('.alert-win').show().find('.alert-win-title').html('发现你的金币变成了错误的值，以为你修复。你可以回忆一下刚才干了什么，然后跟作者反馈，帮助作者找到出现这个情况的原因')
        data.gold = 0;
    }

    if(data.spd == null || isNaN(data.spd) || (data.spd < 0 && !(data.mount && data.mount.name === '坐骑：雷霆巨蜥' && data.spd === -30))){
        const mount = data.mount;
        if(mount) equipMount(mount);
        if(data.race.name.startsWith('半人马')){
            if(data.race.name.startsWith('半人马-重骑兵') || data.race.name.startsWith('半人马-西凉铁骑')){
                data.spd = 0;
            }else{
                data.spd = 50;
            }
        }else{
            data.spd = 0;
        }
        if(mount) equipMount(mount);
    }

    if(data.bag){
        renderKeepDark()
        let weight = 0;
        let hasBug = false;
        data.bag.forEach(e => {
            //处理数量异常
            if(isNaN(e.quantity) || e.quantity == null){
                e.quantity = 1;
                hasBug = true;
            }
            weight += e.quantity * e.weight;
        })
        //清理实际不存在的装备
        if(data.weapon && data.bag.filter(e => e.id === data.weapon.id).length === 0){
            hasBug = true;
            data.weapon = null;
        }
        if(data.armor && data.bag.filter(e => e.id === data.armor.id).length === 0){
            hasBug = true;
            data.armor = null;
        }

        //解决重量显示BUG
        if(data.weight !== weight){
            hasBug = true;
            data.weight = weight;
        }

        if(hasBug){
            renderBag();
        }
    }

    if(data.startTime){
        data.startTime += 1000;
        $('.this-game-time').html(`游戏时长（${diff}）：${getTimeText(data.startTime)}`)
    }else{
        $('.this-game-time').html('该存档无法计算游戏时长')
    }
}

//属性点初始化，一般用于洗点和转生
function initAttr(){
    const weapon = data.weapon && getBagItemById(data.weapon.id);
    const armor = data.armor && getBagItemById(data.armor.id);
    const bagEquip = data.bagEquip && getBagItemById(data.bagEquip.id);
    const mount = data.mount && getBagItemById(data.mount.id);
    if(weapon){
        equip(weapon)
    }
    if(armor){
        equip(armor)
    }
    if(bagEquip){
        equipBag(bagEquip)
    }
    if(mount){
        equipMount(mount)
    }

    //根据等级计算增加的血量
    let addHp = 0;
    for(let i = 1 ; i < data.level ; i++){
        let rate = (parseInt(i / 10) + 1);
        rate = rate > 5 ? 5 : rate;
        addHp += data.race.hpUp * rate
    }

    data.addHpPoint = 0;
    data.maxHp = data.race.hp + addHp;
    data.maxHunger = data.race.hunger + ((data.level - 1) * data.race.hungerUp);
    data.maxWater = data.race.water + ((data.level - 1) * data.race.waterUp);
    data.maxWeight = data.race.weight + ((data.level - 1) * data.race.weightUp);
    data.atk = data.race.atk + ((data.level - 1) * data.race.atkUp);
    data.def = data.race.def + ((data.level - 1) * data.race.defUp);
    data.attrPoint = (data.level - 1) * data.race.attrPoint - (data.consumePoint ? data.consumePoint : 0) + (diff === '新人难度' ? (data.level - 1) * 2 : 0);

    if(data.race.name.startsWith('操脑蛛') && !data.control){
        if(bagEquip){
            data.preBag = bagEquip.id;
        }
        if(mount){
            data.preMount = mount.id;
        }
    }else{
        if(data.race.name.startsWith('操脑蛛') && data.control){
            data.race.control();
        }
        if(weapon){
            equip(weapon)
        }
        if(armor){
            equip(armor)
        }
        if(bagEquip){
            equipBag(bagEquip)
        }
        if(mount){
            equipMount(mount)
        }
    }

    //魅魔增加血脉属性
    if(data.race.name.startsWith('魅魔')){
        let countAtk = 0;
        let countDef = 0;
        let countHp = 0;
        data.blood.filter(e => monsterCfgs[e.name]).forEach(e => {
            countAtk += parseInt(monsterCfgs[e.name].atk * e.num / 100);
            countDef += parseInt(monsterCfgs[e.name].def * e.num / 100);
            countHp += parseInt(monsterCfgs[e.name].hp * e.num / 1000);
        })
        data.atk += countAtk;
        data.def += countDef;
        data.maxHp += countHp;
    }

    //蜥蜴人先祖附魔属性回归
    if(data.race.name.startsWith('蜥蜴人')){
        data.reduceHart = 0;
    }
    if(data.patriarchEnchantWeapon){
        data.atk += data.patriarchEnchantWeapon.atk;
        data.def += data.patriarchEnchantWeapon.def;
        data.reduceHart += data.patriarchEnchantWeapon.defProp;
        data.maxHp += data.patriarchEnchantWeapon.hp;
    }
    if(data.patriarchEnchantArmor){
        data.atk += data.patriarchEnchantArmor.atk;
        data.def += data.patriarchEnchantArmor.def;
        data.maxHp += data.patriarchEnchantArmor.hp;
        data.reduceHart += data.patriarchEnchantArmor.defProp;
    }

    bestStatus();
    if(data.race.name.startsWith('地球人-活佛')){
        data.atk += data.karma;
        data.def += data.karma;
    }
}

//获取装备信息
function getItemInfo(item, showName){
    //拼接使用效果
    let text = showName ? `<h4 style="text-align: center;">${item.showName || item.name}</h4>` : '';
    if(item.showName){
        text += `原名：${item.name}<br>`;
    }
    if(item.jp){
        text += `<font class="sponsor-name">极品</font><br>`;
    }
    if(item.isWeapon || item.isArmor || item.isInlay){
        text += `等级：${item.level}${item.washing ? ` (已洗涤)` : ''}<br>`;
    }
    if(item.isThrow){
        text += `投掷品<br>`;
    }
    if(item.isAmulet){
        text += `护身符(属性只能在图鉴看到)<br>`;
    }
    if(item.isMount){
        text += `坐骑<br>`;
    }
    if(item.quality){
        text += `品质：${qualityAttr[item.quality].name}<br>`;
    }
    text += `重量：${item.weight}&nbsp;&nbsp;数量：<span class="item-number">${item.quantity}</span>&nbsp;&nbsp;${item.onlyOne ? '耐久：' + item.endurance : ''}<br>`;
    if(elementCfgs[item.name].elemental){
        text += `元素：${Object.keys(elementCfgs[item.name].elemental).map(e => `${e}(${elementCfgs[item.name].elemental[e]})`).join('，')}<br>`;
    }
    if(item.atkTags && item.atkTags.length > 0){
        text += `针对拥有指定标签的怪物增加/减少伤害：${item.atkTags.map(e => `对[${e.tag}]${e.rate < 0 ? '减少' : '增加'}${e.rate}倍伤害`).join('，')}<br>`;
    }
    if(item.getHp()){
        text += `HP+${item.getHp()}<br>`;
    }
    if(item.hunger){
        text += `饥饿+${item.hunger}<br>`;
    }
    if(item.water){
        text += `水分+${item.water}<br>`;
    }
    if(item.getAtk(item)){
        text += `攻击：${item.getAtk(item)}${item.getAtk(item) !== item.atk ? `(<u  class="blue" onclick="javascript:alertWin('括号内的攻击力是该物品原始的攻击力，例如潮汐权杖，原始攻击力为40，在有水的地形攻击力为80，在没水的地形攻击力为32');">${item.atk}🔍</u>)` : ''}<br>`;
    }
    if(item.atkSpd){
        text += `攻速${item.atkSpd > 0 ? '+' : ''}${item.atkSpd}<br>`;
    }
    if(item.def){
        text += `防御：${item.def}<br>`;
    }
    if(item.defProp){
        text += `减少伤害：${parseFloat2Fiexd(item.defProp * 100)}%<br>`;
    }
    if(item.suck){
        text += `吸血：${item.suck}%<br>`;
    }
    if(item.noWear){
        text += `永不磨损<br>`;
    }
    if(item.addWeight){
        text += `负重+${item.addWeight}<br>`;
    }
    if(item.weightUp){
        text += `负重+${item.weightUp}<br>`;
    }
    if(item.spd){
        text += `速度+${item.spd}%<br>`;
    }
    if(item.draw){
        text += `吸引值：${item.draw}<br>`;
    }
    if(item.hole.length > 0){
        text += ``;
        for(let i = 0 ; i < item.hole.length ; i++){
            if(item.hole[i]){
                text += `<div class="hole">▲&nbsp;${item.hole[i]}${getInlayText(item.hole[i])}</div>`;
            }else{
                text += `<div class="uninlay hole" data-index="${i}">△&nbsp;未镶嵌</div>`;
            }
        }
    }

    //镶嵌物独有属性
    if(item.isInlay && item.endurance > 1){
        text += `耐久度+${item.endurance}<br>`;
    }

    if(item.enhancements){
        text += `<h5>附魔词条：${item.enhancements.name}</h5>`;
        if(item.enhancements.hp){
            text += `HP+${item.enhancements.hp}<br>`;
        }
        if(item.enhancements.atk){
            text += `攻击：${item.enhancements.atk}<br>`;
        }
        if(item.enhancements.def){
            text += `防御：${item.enhancements.def}<br>`;
        }
    }

    if(item.warpSmelter){
        text += `<h5>扭曲词条</h5>`;
        item.warpSmelter.forEach(e => {
            if(e.attr === 'atk'){
                text += `攻击：${e.num}<br>`;
            }
            if(e.attr === 'def'){
                text += `防御：${e.num}<br>`;
            }
            if(e.attr === 'suck'){
                text += `吸血：${e.num}%<br>`;
            }
            if(e.attr === 'defProp'){
                text += `减少伤害：${e.num * 100}%<br>`;
            }
            if(e.attr === 'endurance'){
                text += `耐久：${e.num}<br>`;
            }
            if(e.attr === 'hp'){
                text += `HP：${e.num}<br>`;
            }
        })
    }

    if(item.temperAttr){
        text += `<h5>锤炼词缀：${item.temperFixName}</h5>`;
        text += `锤炼次数：${item.temperNum}<br>`;
        text += `下次锤炼消耗：${Math.pow(2,item.temperNum)}个神圣重锤<br>`;
        if(item.temperAttr.endurance){
            text += `耐久+${item.temperAttr.endurance}<br>`;
        }
        if(item.temperAttr.atk){
            text += `攻击：${item.temperAttr.atk}<br>`;
        }
        if(item.temperAttr.def){
            text += `防御：${item.temperAttr.def}<br>`;
        }
    }

    if(item.text){
        text += `${item.text}<br>`;
    }

    return text;
}

//加满状态
function bestStatus(){
    data.hp = data.maxHp;
    data.hunger = data.maxHunger;
    data.water = data.maxWater;
}

let addAttrPointNum = 1;
//切换一次加几点
$('.add-attr-point-num').click(function(){
    if(addAttrPointNum === 1){
        addAttrPointNum = 10;
    }else if(addAttrPointNum === 10){
        addAttrPointNum = 100;
    }else if(addAttrPointNum === 100){
        addAttrPointNum = 1000;
    }else{
        addAttrPointNum = 1;
    }
    $(this).html(`一次加${addAttrPointNum}点`)
});

//整理背包
$('.sort-bag').click(function(){
    const keys = Object.keys(elementCfgs);
    const lockBag = [];
    const UnlockBag = [];
    data.bag.forEach(e => {
        if(e.isLock || (data.weapon && data.weapon.id === e.id) || (data.armor && data.armor.id === e.id) || (data.bagEquip && data.bagEquip.id === e.id) || (data.mount && data.mount.id === e.id)){
            lockBag.push(e);
        }else{
            UnlockBag.push(e);
        }
    });

    lockBag.sort(function(a,b){
        return keys.indexOf(a.name) - keys.indexOf(b.name);
    });
    UnlockBag.sort(function(a,b){
        return keys.indexOf(a.name) - keys.indexOf(b.name);
    });
    data.bag = [...lockBag, ...UnlockBag];
    renderBag()
    save();
});

//减少物品，背包不足就从仓库减少，使用该方法请确保物品一定足够
function reduceItemByAll(name, need = 1){
    //获取背包中的数量
    const bagNum = getNumByBag(name);
    //优先使用背包中的物品
    if (bagNum >= need) {
        reduceItem(name, need);
    } else {
        if (bagNum > 0) {
            reduceItem(name, bagNum);
        }
        reduceItemByStore(name, need - bagNum);
    }
}

//天赋觉醒
function talentAwakening(name, level = 60){
    data.race = races[name];
    data.race.onToRace();
    data.level = level;
    if(data.weapon && data.weapon.level > level){
        equip(data.weapon);
    }
    if(data.armor && data.armor.level > level){
        equip(data.armor);
    }
    initAttr();
}

//先祖附魔切换附魔类型
$('.patriarch-enchant-type').click(function(){
    $('.patriarch-enchant-type').removeClass('active');
    $(this).addClass('active');
    renderPatriarchEnchant();
});

//渲染先祖附魔
function renderPatriarchEnchant(){
    $('.patriarch-enchant-equips').html('');
    $('.patriarch-enchant-equip-info').attr('data-id','').html('');
    $('.patriarch-enchant-has-equip-info').html('');
    $('.patriarch-enchant-claw').hide();
    $('.patriarch-enchant-scale').hide();

    const isClaw = $('.patriarch-enchant-type.active').text() === '附魔利爪';
    if(isClaw){
        $('.patriarch-enchant-claw').show();
        if(data.patriarchEnchantWeapon){
            $('.patriarch-enchant-has-equip-info').html(getItemInfo(data.patriarchEnchantWeapon, true));
        }else{
            $('.patriarch-enchant-has-equip-info').html('无利爪附魔');
        }
    }else{
        $('.patriarch-enchant-scale').show();
        if(data.patriarchEnchantArmor){
            $('.patriarch-enchant-has-equip-info').html(getItemInfo(data.patriarchEnchantArmor, true));
        }else{
            $('.patriarch-enchant-has-equip-info').html('无鳞片附魔');
        }
    }

    data.bag.forEach(e => {
        if(!e.name.startsWith('技能石') && e.level <= data.level && (isClaw ? elementCfgs[e.name].isWeapon : data.race.name === '蜥蜴人-卡格拉玛' ? (elementCfgs[e.name].isWeapon || elementCfgs[e.name].isArmor) : elementCfgs[e.name].isArmor)){
            $('.patriarch-enchant-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
}

//选中装备时
$('.patriarch-enchant-equips').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    //渲染窗口文本
    $('.patriarch-enchant-equip-info').attr('data-id',id).html(text);
});

//附魔利爪
$('.patriarch-enchant-claw').click(function(){
    const id = $('.patriarch-enchant-equip-info').attr('data-id');
    if(!id){
        winMsg('请先选择装备')
        return;
    }
    if(confirm('是否确认附魔利爪？原本的利爪附魔将会被覆盖')){
        const item = getBagItemById(id);

        data.suck = data.suck || 0;
        if(data.patriarchEnchantWeapon){
            data.atk -= data.patriarchEnchantWeapon.atk || 0;
            data.def -= data.patriarchEnchantWeapon.def || 0;
            data.reduceHart -= data.patriarchEnchantWeapon.defProp || 0;
            data.maxHp -= data.patriarchEnchantWeapon.hp || 0;
            data.suck -= data.patriarchEnchantWeapon.suck || 0;
        }

        data.atk += item.atk || 0;
        data.def += item.def || 0;
        data.reduceHart += item.defProp || 0;
        data.maxHp += item.hp || 0;
        data.suck += item.suck || 0;
        if(data.hp > data.maxHp){
            data.hp = data.maxHp;
        }

        data.patriarchEnchantWeapon = item;
        reduceItemById(id);
        renderPatriarchEnchant();
        renderBag();
        save();
    }
});

//附魔鳞片
$('.patriarch-enchant-scale').click(function(){
    const id = $('.patriarch-enchant-equip-info').attr('data-id');
    if(!id){
        winMsg('请先选择装备')
        return;
    }
    if(confirm('是否确认附魔鳞片？原本的鳞片附魔将会被覆盖')){
        const item = getBagItemById(id);

        data.suck = data.suck || 0;
        if(data.patriarchEnchantArmor){
            data.atk -= data.patriarchEnchantArmor.atk || 0;
            data.def -= data.patriarchEnchantArmor.def || 0;
            data.reduceHart -= data.patriarchEnchantArmor.defProp || 0;
            data.maxHp -= data.patriarchEnchantArmor.hp || 0;
            data.suck -= data.patriarchEnchantArmor.suck || 0;
        }

        data.atk += item.atk || 0;
        data.def += item.def || 0;
        data.reduceHart += item.defProp || 0;
        data.maxHp += item.hp || 0;
        data.suck += item.suck || 0;
        if(data.hp > data.maxHp){
            data.hp = data.maxHp;
        }

        data.patriarchEnchantArmor = item;
        reduceItemById(id);
        renderPatriarchEnchant();
        renderBag();
        save();
    }
});

//渲染流浪商人商店
function renderWanderingMerchantShop(){
    $('.wandering-merchant-shop').show();
    $('.wandering-merchant-shop .buy').html('');
    $('.wandering-merchant-shop .world-power').html(`世界之力：${data.worldPower}`);
    data.world.WanderingMerchantShop.goods.forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name">${e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span></div></div>`;
        html += `<div><div class="price">单价：${e.point}世界之力</div><div class="buy-btns">`;
        html += `<button class="buy-wandering-merchant-good-btn" data-point="${e.point}" data-name="${e.name}" data-num="1">买1个</button>`;
        html += `<button class="buy-wandering-merchant-good-btn" data-point="${e.point}" data-name="${e.name}" data-num="10">买10个</button>`;
        html += `</div></div>`;
        $('.wandering-merchant-shop .buy').append(html);
    })
}

//渲染周目商店
function renderOrderShop(){
    $('.wandering-merchant-shop').show();
    $('.wandering-merchant-shop .buy').html('');
    $('.wandering-merchant-shop .world-power').html(`种族周目点数：${data.orderPoint || 0}`);
    const goods = [{
        name : '金锭',
        point : 1
    },{
        name : '短程传送卷轴',
        point : 1
    },{
        name : '重生十字章',
        point : 2
    },{
        name : '时空背包',
        point : 3
    },{
        name : '封魔卷轴',
        point : 5
    },{
        name : '虚空行走',
        point : 10
    },{
        name : '超级转生卷轴',
        point : 10
    },{
        name : 'DLC体验券',
        point : 20
    },{
        name : '心灵之剑',
        point : 20
    }];
    goods.forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name">${e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span></div></div>`;
        html += `<div><div class="price">单价：${e.point}点</div><div class="buy-btns">`;
        html += `<button class="buy-order-good-btn" data-point="${e.point}" data-name="${e.name}" data-num="1">买1个</button>`;
        html += `<button class="buy-order-good-btn" data-point="${e.point}" data-name="${e.name}" data-num="10">买10个</button>`;
        html += `</div></div>`;
        $('.wandering-merchant-shop .buy').append(html);
    })
}

//购买周目商店
$('.wandering-merchant-shop .buy').on('click','.buy-order-good-btn',function(){
    const name = $(this).attr('data-name');
    const num = parseInt($(this).attr('data-num'));
    const point = parseInt($(this).attr('data-point'));
    const need = point * num;

    if(!data.orderPoint){
        data.orderPoint = 0;
    }
    if(data.orderPoint < need){
        winMsg('种族周目点数不足',false,false)
        return;
    }

    winMsg(`购买了${name}*${num}，消耗${need}种族周目点数`)
    data.orderPoint -= need;
    addItem(name,num);
    renderOrderShop();

    save();
});

//购买流浪商人物品
$('.wandering-merchant-shop .buy').on('click','.buy-wandering-merchant-good-btn',function(){
    const name = $(this).attr('data-name');
    const num = parseInt($(this).attr('data-num'));
    const point = parseInt($(this).attr('data-point'));
    const need = point * num;

    if(data.worldPower < need){
        winMsg('世界之力不足',false,false)
        return;
    }

    winMsg(`购买了${name}*${num}，消耗${need}世界之力`)
    data.worldPower -= need;
    addItem(name,num);
    renderWanderingMerchantShop();

    save();
});

//判断是否正在和世界BOSS战斗
function battle4WorldBoss(){
    let finalBoss = null;
    const map = data.maps.filter(e => e.name === data.world.name);
    if(map.length > 0){
        finalBoss = map[0].finalBoss;
    }
    if(data.battleMonster && data.battleMonster.name === finalBoss){
        return true;
    }
    return false;
}

//给指定装备打孔
function addHole(equip, level){
    let flag = false;
    if(equip.level <= level){
        flag = true;
    }else{
        flag = randomNum(1,100) > (equip.level - level) * 3
    }

    if(flag){
        equip.hole = [...equip.hole];
        equip.hole.push(null);
        winMsg(`打孔成功`)
    }else{
        winMsg(`打孔失败`)
    }
}

//点击经验提取器中的物品
$('.exp-items').on('click','.bag-item',function(){
    const id = $(this).attr('id');
    $('.exp-number-value').attr('id', id).html(getBagItemById(id).voidDust * 10);
    $('.exp-items .bag-item').removeClass('active')
    $(this).addClass('active')
});

//点击提取经验按钮
$('.exp-number button').click(function(){
    const id = $('.exp-number-value').attr('id');
    if(!id){
        winMsg('请先选择物品')
        return;
    }
    let num = parseInt($(this).attr('data-num'));
    const item = getBagItemById(id);
    if(num > item.quantity){
        num = item.quantity;
    }

    data.exp += item.voidDust * num * 10;
    winMsg(`分解${item.showName || item.name}*${num}，获得经验${item.voidDust * num * 10}`)
    level(true);
    reduceItemById(id, num);
    renderExpExtract();
    if(item.quantity > num){
        $('.exp-number-value').attr('id', id).html(item.voidDust * 10);
    }
    renderBag();
    save()
});

//给对象回血
function addObjHp(obj, num){
    obj.hp += num;
    if(obj.hp > obj.maxHp){
        obj.hp = obj.maxHp;
    }
}

//给对象增加饥饿
function addObjHunger(obj, num){
    obj.hunger += num;
    if(obj.hunger > obj.maxHunger){
        obj.hunger = obj.maxHunger;
    }
}

//给对象增加水分
function addObjWater(obj, num){
    obj.water += num;
    if(obj.water > obj.maxWater){
        obj.water = obj.maxWater;
    }
}

//给对象增加理智
function addObjSan(obj, num){
    obj.san += num;
    if(obj.san > obj.maxSan){
        obj.san = obj.maxSan;
    }
}

//给对象减少理智
function reduceObjSan(obj, num){
    obj.san -= num;
    if(data.race.name.startsWith("污染者") && data.san < 1){
        data.san = 1;
    }
    if(obj.san < 0){
        msg('你陷入了永恒的疯狂')
        data.hp = 0;
        addDieLog(`你的理智降为0，陷入了永恒的疯狂`);
        die();
    }
}

//给玩家增加精神
function addSpi(num){
    data.spi += num;

    if(data.race.name.startsWith('人类-法师')){
        if(data.spi > data.level * 10){
            data.spi = data.level * 10;
        }
    }
    if(data.race.name.startsWith('人类-元素师')){
        if(data.spi > data.level * 30){
            data.spi = data.level * 30;
        }
    }
}

//点击退回关闭弹窗
function clickBack4hide(){
    if(isDie){
        window.location.reload();
        return;
    }
    if($('.no-back:visible').length){
        if(confirm('是否确认退出游戏？为了避免存档损坏，建议3秒无操作再退出游戏')){
            window.control.exit();
        }
        return;
    }
    if($('.is-win:visible').length){
        if($('.is-win .win:visible').length){
            if($('.cybernet:visible').length){
                $('.cybernet:visible').hide();
            }else{
                $('.is-win .win:visible').eq($('.is-win .win:visible').length - 1).hide();
            }
        }else{
            if($('.cybernet:visible').length){
                $('.cybernet:visible').hide();
            }else{
                $('.is-win .close').click();
            }
        }
    }else if($('.win:visible').length){
        if($('.cybernet:visible').length){
            $('.cybernet:visible').hide();
        }else{
            $('.win:visible').eq($('.win:visible').length - 1).hide();
        }
    }else if(window.control && confirm('是否确认退出游戏？为了避免存档损坏，建议3秒无操作再退出游戏')){
        window.control.exit();
    }
}
function clickBack4hide222(){
    if(isDie){
        window.location.reload();
        return;
    }
    if($('.no-back:visible').length){
        if(confirm('是否确认退出游戏？为了避免存档损坏，建议3秒无操作再退出游戏')){
            window.control.exit();
        }
        return;
    }
    if($('.item-use-win:visible').length){
        if($('.cybernet:visible').length){
            $('.cybernet:visible').hide();
        }else{
            $('.item-use-win-close').click();
        }
    }else if($('.mop-up-win:visible').length){
        if($('.cybernet:visible').length){
            $('.cybernet:visible').hide();
        }else{
            $('.close-mop-up-win').click();
        }
    }else if($('.npc-win:visible').length){
        if($('.npc-win .win:visible').length){
            if($('.cybernet:visible').length){
                $('.cybernet:visible').hide();
            }else{
                $('.npc-win .win:visible').eq($('.npc-win .win:visible').length - 1).hide();
            }
        }else{
            if($('.cybernet:visible').length){
                $('.cybernet:visible').hide();
            }else{
                $('.npc-win-close').click();
            }
        }
    }else if($('.win:visible').length){
        if($('.cybernet:visible').length){
            $('.cybernet:visible').hide();
        }else{
            $('.win:visible').eq($('.win:visible').length - 1).hide();
        }
    }else if(window.control && confirm('是否确认退出游戏？为了避免存档损坏，建议3秒无操作再退出游戏')){
        window.control.exit();
    }
}

//添加死亡日志
function addDieLog(text, noWrite){
    if(noWrite) {
        return;
    }
    conf.dieLog = [`<h5>${new Date().format('yyyy-MM-dd hh:mm:ss')} ${diff}存档${conf.savedName.replace('trailblazer-','')} ${data.race.name}LV${data.level}</h5>${text}`, ...conf.dieLog];
    conf.dieLog = conf.dieLog.slice(0,100)
    save(confSavedName, conf);
}

//快捷键相关
$('.select-ks-win-items').on('click', 'div', function(){
    $('.select-ks-win-items div').removeClass('active');
    $(this).addClass('active')
});
let ksIndex = -1;
$('.ks').on('click', 'div', function(){
    const index = parseInt($(this).attr('data-index'));
    if($('.bag').is(':hidden')){//页面点击
        if(data.ks[index]){
            const item = getBagItemByName(data.ks[index]);
            if(item){
                clickBagItem(item);
            }else{
                winMsg('背包中没有该物品', false, false);
            }
        }
    }else{//背包点击
        ksIndex = index;
        $('.select-ks-win-items').html('<div>取消</div>' + data.bag.filter(e => e.canUse).map(e => `<div>${e.name}</div>`).join(''))
        $('.select-ks-win').show();
    }
});
function selectKs(){
    const $select = $('.select-ks-win-items .active');
    if($select.length > 0){
        let name = $select.html();
        if(name === '取消'){
            name = '';
        }
        data.ks[ksIndex] = name;
        $('.select-ks-win').hide();
        save();
        renderBag();
    }else{
        winMsg('请选择要设置快捷键的物品', false, false);
    }
}

//是世界BOSS
function isWorldBoss(){
    return data.battleMonster && data.battleMonster.name === data.world.finalBoss;
}

//渲染世界属性
function renderWorld(){
    data.world.home.store = data.world.home.store || [];
    data.world.home.store = data.world.home.store.map(e => new Element(e));
    Object.keys(data.world.mapElements).forEach(key => {
        data.world.mapElements[key].elementList = data.world.mapElements[key].elementList.map(e => new Element(e));
    })
    data.worlds.forEach(world => {
        world.home.store = world.home.store || [];
        world.home.store = world.home.store.map(e => new Element(e));
        Object.keys(world.mapElements).forEach(key => {
            world.mapElements[key].elementList = world.mapElements[key].elementList.map(e => new Element(e));
        })
    })
}

//获取季节
function getSeason(){
    if(data.dlcKeepWinter){
        return '冬';
    }
    const month = data.date.getMonth();
    if([2,3,4].includes(month)){
        return '春';
    }else if([5,6,7].includes(month)){
        return '夏';
    }else if([8,9,10].includes(month)){
        return '秋';
    }else if([11,0,1].includes(month)){
        return '冬';
    }
}

//获取日夜
function getDayOrNight(){
    if(data.dlcKeepDark){
        return '夜';
    }
    let hours = data.date.getHours();
    const season = getSeason();
    if(season === '春'){
        return hours >= 6 && hours < 19 ? '日' : '夜';
    }else if(season === '夏'){
        return hours >= 5 && hours < 20 ? '日' : '夜';
    }else if(season === '秋'){
        return hours >= 6 && hours < 19 ? '日' : '夜';
    }else if(season === '冬'){
        return hours >= 7 && hours < 18 ? '日' : '夜';
    }
}

//渲染季节和日夜
function renderSeasonAndDayNight(){
    const season = getSeason();
    $('.season').html(season);
    const dayOrNight = getDayOrNight();
    $('.day-or-night').removeClass('day').removeClass('night').addClass(dayOrNight === '日' ? 'day' : 'night').html(dayOrNight);

    if(dayOrNight === '日'){
        $('.body-back').attr('class', 'body-back body-back-sun');
    }else{
        $('.body-back').attr('class', 'body-back body-back-moon');
    }

    //是否显示日夜背景
    if(conf.showDayNightBack){
        $('.body-back').show()
    }else{
        $('.body-back').hide()
    }
}

//渲染页面上方
function renderPageTop(){
    let top = 230;
    //是否显示日月季节
    if(conf.showSeasonDayNight == null){
        conf.showSeasonDayNight = true;
    }
    if(conf.showSeasonDayNight){
        $('.time').show();
    }else{
        $('.time').hide();
        top -= 50;
    }
    //是否显示游荡神话存活状态
    if(conf.showMythStatus == null){
        conf.showMythStatus = true;
    }
    if(conf.showMythStatus){
        $('.body-head-msg').show();
    }else{
        $('.body-head-msg').hide();
        top -= 60
    }
    //是否显示元素过滤
    if(conf.showEleFilter == null){
        conf.showEleFilter = true;
    }
    if(conf.showEleFilter){
        $('.body-head-filter').show();
    }else{
        $('.body-head-filter').hide();
        top -= 30
    }
    $('.body-div').css('top', top)
}

//防卡死页面
$('.anti-jamming-menu').click(function(){
    $('.anti-jamming-menu').removeClass('active');
    $(this).addClass('active');
    renderAntiJamming();
});
let ajNames = {};
function renderAntiJamming(){
    const type = $('.anti-jamming-menu.active').attr('data-type');
    let items = [];
    if(type === 'bag'){
        items = data.bag;
    }else if(data.world.home && data.world.home.store){
        items = data.world.home.store || [];
    }
    ajNames = {};
    items.filter(e => {
        if(data.weapon && data.weapon.id === e.id){
            return false;
        }
        if(data.armor && data.armor.id === e.id){
            return false;
        }
        if(data.mount && data.mount.id === e.id){
            return false;
        }

        return e.onlyOne && !e.isLock;
    }).forEach(e => {
        const name = e.showName || e.name;
        if(!ajNames[name]){
            ajNames[name] = 0;
        }
        ajNames[name]++;
    })
    $('.anti-jamming-body').html(Object.keys(ajNames).map(e => `<div class="anti-jamming-item">${e} * ${ajNames[e]}<br><button data-name="${e}" data-type="1">丢1个</button><button data-name="${e}" data-type="2">丢一半</button><button data-name="${e}" data-type="3">丢全部</button></div>`).join(''))
    $('.anti-jamming').show();
}
$('.anti-jamming-body').on('click', 'button', function(){
    const type = $(this).attr('data-type');
    const name = $(this).attr('data-name');
    let num = 1;

    if(type === '2'){
        num = parseInt(ajNames[name] / 2)
    }
    if(type === '3'){
        num = ajNames[name];
    }

    if(!confirm(`是否确认丢弃${num}个[${name}]`)){
        return;
    }

    if($('.anti-jamming-menu.active').attr('data-type') === 'bag'){
        const newBag = [];
        data.bag.forEach(e => {
            const itemName = e.showName || e.name;

            if(data.weapon && data.weapon.id === e.id){
                newBag.push(e);
                return;
            }
            if(data.armor && data.armor.id === e.id){
                newBag.push(e);
                return;
            }
            if(data.mount && data.mount.id === e.id){
                newBag.push(e);
                return;
            }

            if(itemName === name && num > 0 && !e.isLock){
                num--;
                return;
            }else{
                newBag.push(e);
            }
        })
        data.bag = newBag;
    }else if(data.world.home && data.world.home.store){
        const newStore = [];
        data.world.home.store.forEach(e => {
            const itemName = e.showName || e.name;
            if(itemName === name && num > 0){
                num--;
                return;
            }else{
                newStore.push(e);
            }
        })
        data.world.home.store = newStore;
    }

    renderAntiJamming();
})

//判断是否在家里
function isInHome(){
    return data.world.home && data.world.home.location.join() === data.location.join();
}

//查看未击杀神话
function showUnkillMyth(){
    if(!data.killedMyth){
        data.killedMyth = [];
    }

    const myths = Object.keys(monsterCfgs).filter(e => monsterCfgs[e].type === '神话' && !e.includes('宝石巨人') && e !== '创世神' && !data.killedMyth.includes(e))
    winMsg(`你未击杀过的神话怪(宝石巨人和创世神不计入)有：${myths.join('，')}`);
}

//技能石合并
function skillMerge(){
    let names = [...new Set(data.bag.filter(e => e.name.startsWith('技能石：') && e.onlyOne).map(e => e.name))];
    names.forEach(e => {
        const filter = data.bag.filter(b => b.name === e);
        const len = filter.length;
        if(len > 1){
            for(let i = 1 ; i < filter.length ; i++){
                filter[0].endurance += filter[i].endurance;
                filter[0].weight += filter[i].weight;
                reduceItemById(filter[i].id);
            }
        }
        if(len){
            filter[0].weight = Math.ceil(filter[0].endurance / elementCfgs[filter[0].name].endurance) * elementCfgs[filter[0].name].weight;
        }
    })
    renderBag();
    save();
    winMsg('你的技能石已经合并完成')
}

//时间戳转时分秒
function getTimeText(dateTime){
    let s = parseInt((dateTime) / 1000);
    let m = parseInt(s / 60);
    s -= m * 60;
    const h = parseInt(m / 60);
    m -= h * 60;
    return `${h}小时${m}分${s}秒`
}

//命运之月DLC列表
const dlcFateMonths = [{
    name : '丰饶之月',
    text : '采集获得资源的数量上下限+1',
},{
    name : '贫瘠之月',
    text : '采集获得资源的数量上下限-1',
},{
    name : '暴动之月',
    text : '怪物主动攻击概率+10%',
},{
    name : '平静之月',
    text : '怪物主动攻击概率-10%，挑战种族不受平静之月影响',
},{
    name : '命运波动之月',
    text : '攻击波动上下限+10%',
},{
    name : '命运平稳之月',
    text : '攻击波动上下限-10%',
},{
    name : '行商之月',
    text : '每个商人都有50%概率额外再出售一件物品',
},{
    name : '缺货之月',
    text : '每个商人都有50%概率不出售物品',
},{
    name : '腐蚀之月',
    text : '装备(包括装备类技能石)磨损时有50%概率额外消耗1耐久',
},{
    name : '牢固之月',
    text : '装备(包括装备类技能石)磨损时有50%概率不消耗耐久',
},{
    name : '富有之月',
    text : '怪物所有自身的掉落物(不包括额外掉落物)上下限+1',
},{
    name : '贫穷之月',
    text : '怪物所有自身的掉落物(不包括额外掉落物)上下限-1',
},{
    name : '献祭之月',
    text : '神殿只会发布献祭任务',
},{
    name : '猎杀之月',
    text : '神殿只会发布猎杀任务',
},{
    name : '勤奋之月',
    text : '打怪获得的经验+50%',
},{
    name : '懒惰之月',
    text : '打怪获得的经验-50%',
},{
    name : '骚动之月',
    text : '怪物出现的概率+10，包括精英和传说等怪物',
},{
    name : '休眠之月',
    text : '怪物出现的概率-10，出现概率低于10%的怪物将不会在本月出现，挑战种族不受休眠之月影响',
}]

//获取命运之月的本月名称
function getMonthName(){
    return data.dlcFateMonth && data.monthType ? data.monthType.name : null;
}

//校验本月是否指定的命运之月
function checkMonthName(name){
    return getMonthName() === name;
}

//设置被毁灭的地形
function setWorldEndMap(){
    if(data.inDungeon){
        return;
    }
    const now = data.date.format('yyyy-MM-dd');
    const oneDay = 1000 * 60 * 60 * 24;
    if(data.dlcWorldEnd && data.doomsday !== now){
        let list = [];
        //获取资源地形列表
        const terrainArrayElement = terrainArray[data.maps[data.worldIndex].name];

        //获取所有资源地形的坐标
        data.world.map.forEach((e, y) => {
            e.forEach((m, x) => {
                if(terrainArrayElement.includes(m)){
                    list.push([y,x]);
                }
            })
        })

        //只要还有资源地形，且毁灭日不是今天，就毁灭一个随机地形
        let flag = false;
        while(list.length > 0 && data.doomsday !== now){
            flag = true;
            const random = list.getRandom();
            winMsg(`${data.map[random[0]][random[1]]}[${random[1]},${random[0]}]毁灭了`)

            //修改地形名，清除资源
            data.map[random[0]][random[1]] = '末地';
            data.world.map[random[0]][random[1]] = '末地';
            data.world.mapElements[`${random[1]},${random[0]}`] = {
                elementList : [],
                monsterList : [],
                renderDates : {}
            }

            list = list.filter(e => e[0] !== random[0] || e[1] !== random[1])
            data.doomsday = new Date(new Date(data.doomsday).getTime() + oneDay).format('yyyy-MM-dd')
        }

        //毁灭日修改
        data.doomsday = now;

        if(flag){
            //将当前坐标和四周坐标设置为已探索
            setShowMap();
            //渲染可前往的地图
            renderCanToMap();
            //重新渲染地图
            renderMapElements();

            if(!$('.map-div').is(':hidden')){
                $('.map-menu-btn').click();
            }
        }
    }
}

//校验是否可以用一转觉醒物品
function checkRaceOnceAwaken(raceName){
    if(data.level < 60){
        winMsg('至少60级才可以使用！', false, false);
        return false;
    }
    if(data.dlcLastMagic){
        winMsg('末法时代无法觉醒！', false, false);
        return false;
    }
    const only = raceName.split('-')[0]
    if(data.race.name !== only){
        winMsg(`只有${only}才能使用！`, false, false);
        return false;
    }
    talentAwakening(raceName);
    winMsg('恭喜你觉醒了天赋！');
    return true;
}

//渲染神话怪状态
function renderMythStatus(){
    $('.body-head-msg').html(data.world.mythMonster.map(e => `<div ${e.deathTime ? 'class="is-die"' : ''}>${e.deathTime ? '死亡' : '存活'}：${e.name}</div>`).join(''))
    if(data.world.mythMonster.length < 4){
        let num = 4 - data.world.mythMonster.length;
        while(num){
            $('.body-head-msg').append('<div></div>')
            num--;
        }
    }
}

//使用药剂
function useDrug(name, num){
    if(!data.runStatus[name]){
        data.runStatus[name] = 0;
    }
    data.runStatus[name] += num;
    msg(`${name}剩余：${ data.runStatus[name]}`)
}

//获取选中的元素过滤
function getFilterEleChecked(){
    const arr = [];
    $('.body-head-filter input:checked').each(function(){
        arr.push($(this).val())
    })
    return arr;
}
//修改显示情况
$('.body-head-filter input').change(function(){
    renderMapElements(false, true)
})

//星灵时间穿梭
$('.time-shuttle-hour').click(function(){
    const number = parseInt($(this).attr('data-num'));
    winMsg('你穿梭了' + $(this).html())
    timeLapses(number * 60);
});

//增加经验
function addExp(exp, level = -1){
    let flag = false;
    if(data.runStatus['学习药剂']){
        flag = true;
        data.runStatus['学习药剂']--;
        msg(`学习药剂剩余：${ data.runStatus['学习药剂']}`)
    }

    let calcLevel = data.level;
    if(data.race.name.startsWith('魅魔') && calcLevel < level){
        calcLevel = level;
    }

    if(level !== -1){
        exp = parseInt((exp * (1 - ((calcLevel - level) * (calcLevel < level ? 0.1 : flag ? 0.025 : 0.05)))).toFixed(0))
        if(calcLevel - level >= (flag ? 40 : 20)){
            exp = 0;
        }
    }

    if(data.exp >= data.race.getLevelUpExp() * 10){
        msg('你的当前经验已达升级经验的10倍，无法获取经验')
        exp = 0;
    }

    if(checkMonthName('勤奋之月')){
        exp = parseInt(exp * 1.5);
    }
    if(checkMonthName('懒惰之月')){
        exp = parseInt(exp * 0.5);
    }
    if(data.runStatus['经验药剂']){
        exp *= 2;
        data.runStatus['经验药剂']--;
        msg(`经验药剂剩余：${ data.runStatus['经验药剂']}`)
    }
    data.exp += exp;

    return exp;
}

//获取战斗胜利时怪物的掉落物
function getBattleWinItems(){
    const dlcAddNum = checkMonthName('富有之月') ? 1 : checkMonthName('贫穷之月') ? -1 : 0;
    let getList = data.battleMonster.items.map(e => {
        return {
            ...e,
            minNum : e.minNum + dlcAddNum,
            maxNum : e.maxNum + dlcAddNum,
            attr : e.attr
        }
    });
    return getList;
}

//扫荡怪物
function batchKillMonster(monsterList){
    const items = [];
    let exp = 0;

    //循环怪物集合
    monsterList.forEach(e => {
        data.battleMonster = createBattleMonster(e);

        //记录击杀数量
        if(!data.killedMonster[data.battleMonster.name]){
            data.killedMonster[data.battleMonster.name] = 0;
        }
        data.killedMonster[data.battleMonster.name]++;

        //获取掉落物
        let getList = getBattleWinItems();
        getList.forEach(e => {
            const {name, minNum, maxNum, attr} = e;
            const num = randomNum(e.minNum,e.maxNum);
            if(num > 0){
                //判断是是否有相同掉落物
                let filter = items.filter(i => i.name === name && (attr ? i.attr && JSON.stringify(attr) === JSON.stringify(i.attr) : true));
                if(filter.length > 0){
                    filter[0].minNum += num;
                    filter[0].maxNum += num;
                }else{
                    items.push({
                        ...e,
                        minNum : num,
                        maxNum : num
                    })
                }
            }
        })

        //如果是神殿任务，则增加击杀数量
        if(!data.temples){
            data.temples = {};
        }
        if(!data.temples[data.worldIndex]){
            data.temples[data.worldIndex] = {};
        }
        Object.keys(data.temples).forEach(index => {
            Object.keys(data.temples[index]).forEach(e => {
                const temple = data.temples[index][e];
                if(temple && temple.task.monster === data.battleMonster.name){
                    temple.task.killed++;
                    if(temple.task.killed === temple.task.num){
                        winMsg(`完成任务：${temple.task.name}`)
                    }
                }
            })
        })

        //如果是NPC任务怪，则记录
        if(data.world.npcs){
            const taskNpcs = data.world.npcs.filter(e => e.task && e.task.geted && !e.task.over && e.task.target === data.battleMonster.name);
            taskNpcs.forEach(e => {
                if(!e.task.now){
                    e.task.now = 0;
                }
                e.task.now++;
            })
        }

        exp += addExp(data.battleMonster.exp, data.battleMonster.level)
    })

    data.battleMonster = null;
    const getItems = [];
    addKillMonsterItems(items, getItems);
    level();
    return `击杀了${monsterList.length}个怪物，EXP+${exp}，获得：${ getItems.join()}`;
}

//获取怪物掉落物
function addKillMonsterItems(getList, getItems){
    getList.forEach(e => {
        if(e.name.startsWith('图纸：') && data.forgeRecipes.indexOf(e.name.replace('图纸：','')) !== -1){
            return;
        }
        if(e.name.startsWith('位面坐标：') && data.dungeon.indexOf(e.name.replace('位面坐标：','')) !== -1){
            return;
        }

        const num = randomNum(e.minNum,e.maxNum);
        if(num > 0){
            addItem(e.name,num, e.attr);
            getItems.push(`${elementCfgs[e.name] ? elementCfgs[e.name].showName || e.showName || e.name : e.showName || e.name}*${num}`);
        }
    });
}

//选择装备搭配
function selectEquip(index){
    if(data.selecEquip == index){
        return;
    }
    $('.bag-player-equip button').removeClass('active');
    $('.bag-player-equip button').eq(index).addClass('active');
    //刷新当前位置的装备信息
    refreshSelecEquip()

    //脱下装备
    {
        let {weapon, armor, bagEquip, mount} = data.equipList[data.selecEquip];
        if(weapon) equip(weapon);
        if(armor) equip(armor);
        if(bagEquip) equipBag(bagEquip);
        if(mount) equipMount(mount);
    }

    //切换装备位置
    data.selecEquip = index;

    //穿上装备
    let {weapon, armor, bagEquip, mount} = data.equipList[index];
    if(weapon && getBagItemById(weapon.id)) equip(getBagItemById(weapon.id));
    if(armor && getBagItemById(armor.id)) equip(getBagItemById(armor.id));
    if(bagEquip && getBagItemById(bagEquip.id)) equipBag(getBagItemById(bagEquip.id));
    if(mount && getBagItemById(mount.id)) equipMount(getBagItemById(mount.id));
    save();
    renderBag();
}

//刷新选中装备列表
function refreshSelecEquip(){
    data.equipList[data.selecEquip] = {
        weapon : data.weapon,
        armor : data.armor,
        bagEquip : data.bagEquip,
        mount : data.mount,
    }
}

//超级转生卷轴选择种族
$('.super-select-race-ok').click(function(){
    const raceName = $('.super-select-race .active').html();
    if(raceName){
        //脱下装备
        const weapon = data.weapon && getBagItemById(data.weapon.id);
        const armor = data.armor && getBagItemById(data.armor.id);
        const bagEquip = data.bagEquip && getBagItemById(data.bagEquip.id);
        const mount = data.mount && getBagItemById(data.mount.id);
        if(weapon){
            equip(weapon)
        }
        if(armor){
            equip(armor)
        }
        if(bagEquip){
            equipBag(bagEquip)
        }
        if(mount){
            equipMount(mount)
        }

        //蜥蜴人先祖附魔清空
        if(data.patriarchEnchantWeapon){
            data.atk -= data.patriarchEnchantWeapon.atk || 0;
            data.def -= data.patriarchEnchantWeapon.def || 0;
            data.reduceHart -= data.patriarchEnchantWeapon.defProp || 0;
            data.maxHp -= data.patriarchEnchantWeapon.hp || 0;
            data.suck -= data.patriarchEnchantWeapon.suck || 0;
            data.patriarchEnchantWeapon = null;
        }
        if(data.patriarchEnchantArmor){
            data.atk -= data.patriarchEnchantArmor.atk || 0;
            data.def -= data.patriarchEnchantArmor.def || 0;
            data.reduceHart -= data.patriarchEnchantArmor.defProp || 0;
            data.maxHp -= data.patriarchEnchantArmor.hp || 0;
            data.suck -= data.patriarchEnchantArmor.suck || 0;
            data.patriarchEnchantArmor = null;
        }

        //吸血鬼和神性史莱姆清空吸血和减伤
        data.reduceHart = 0;
        data.suck = 0;
        data.spd = 0;

        data.race = races[raceName];
        data.race.onCreate();
        data.exp = 0;
        data.level = 1;

        data.race.initItems.forEach(e => {
            addItem(e.name, e.num)
        })

        initAttr();
        winMsg(`你变成${raceName}了！`);
        reduceItem('超级转生卷轴')
        renderBag();
        $('.super-select-race').hide();
        save();
    }
})

//渲染自然附着
function renderNaturalAttachment(){
    $('.natural-attachment-equips').html('');
    $('.old-equip-info').attr('data-id','').html('');
    $('.new-equip-info').attr('data-id','').html('');

    //渲染装备列表
    data.bag.forEach(e => {
        if(((!e.isBow && e.isWeapon) || (e.isBow && !e.isWeapon)) && !e.name.startsWith('技能石')){
            $('.natural-attachment-equips').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${(data.armor && data.armor.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' : ''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}<br>x${e.quantity}</div>`);
        }
    })
}

//自然附着选中装备时
$('.natural-attachment-equips').on('click','.bag-item',function(){
    //获取物品
    const id = $(this).attr('id');
    const item = data.bag.filter(e => e.id === id)[0];
    const text = getItemInfo(item, true)

    if(item.isBow){
        //渲染窗口文本
        $('.old-equip-info').attr('data-id',id).html(text);
    }else{
        //渲染窗口文本
        $('.new-equip-info').attr('data-id',id).html(text);
    }
});

//点击自然附着
$('.natural-attachment-ok').click(function(){
    const oldId = $('.old-equip-info').attr('data-id');
    const newId = $('.new-equip-info').attr('data-id');

    if(oldId && newId){
        const oldEq = getBagItemById(oldId);
        const newEq = getBagItemById(newId);

        oldEq.isWeapon = true;
        oldEq.showName = `弓:${newEq.showName || newEq.name}`;
        oldEq.quality = newEq.quality;
        oldEq.noWear = newEq.noWear;
        if(oldEq.level < newEq.level){
            oldEq.level = newEq.level;
        }
        oldEq.atk += newEq.atk;
        oldEq.atkSpd += newEq.atkSpd;
        oldEq.def += newEq.def;
        oldEq.defProp += newEq.defProp;
        oldEq.suck += newEq.suck;
        oldEq.hp += newEq.hp;

        oldEq.hole = [...newEq.hole];
        oldEq.enhancements = newEq.enhancements;
        oldEq.temperAttr = newEq.temperAttr;
        oldEq.warpSmelter = newEq.warpSmelter;

        if(newEq.atkTags && newEq.atkTags.length > 0){
            if(!oldEq.atkTags){
                oldEq.atkTags = [];
            }
            newEq.atkTags.forEach(e => {
                let ts = oldEq.atkTags.filter(f => f.tag === e.tag);
                if(ts.length > 0){
                    ts[0].rate = ts[0].rate + e.rate;
                }else{
                    oldEq.atkTags.push(e);
                }
            })
        }

        reduceItemById(newId)

        winMsg('自然附着已完成')
        renderNaturalAttachment();
        renderBag();
        save();
    }else{
        winMsg('请选择参与转移的装备', false, false)
    }
});

/**
 * 获取基础攻击力
 * @param otherAtk 额外攻击力
 * @param playerAtk 是否加上玩家攻击力
 * @param weaponAtk 是否加上武器攻击力
 * @param dd 是否无视防御
 * @param rate 倍率
 * @returns {number} 最终攻击力
 */
function getBaseAtk(otherAtk = 0, playerAtk = true, weaponAtk = true, dd = false, rate = 1){
    let atk = 0;
    if(playerAtk){
        atk += data.atk;
    }
    if(weaponAtk){
        atk += data.weapon ? data.weapon.getAtk(data.weapon) : 0;
    }
    if(dd){
        atk += data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0;
    }

    return parseInt((atk + otherAtk) * rate);
}

//渲染黑暗侵蚀DLC相关元素
function renderKeepDark(){
    if(data.dlcKeepDark){
        let count = 0;
        let items = data.bag.filter(e => e.name === '火把')
        items.forEach(e => {
            count += e.endurance;
        })
        $('.dark-keep-endurance').show().html('🔥' + count)

        if(count){
            $('.keep-dark-body').hide()
        }else{
            $('.keep-dark-body').show();
        }
    }else{
        $('.dark-keep-endurance').hide()
        $('.keep-dark-body').hide()
    }
}

//点击选择火药
$('.select-explosive-win-items').on('click', 'div', function(){
    $('.select-explosive-win-items div').removeClass('active');
    $(this).addClass('active')
});
//确定埋几个
function selectExplosive(num){
    let id = $('.select-explosive-win-items .active').attr('data-id');
    if(id){
        let bagItemById = getBagItemById(id);
        if(num > bagItemById.quantity){
            num = bagItemById.quantity;
        }
        if(num === -1){
            num = bagItemById.quantity;
        }
        if(!data.buryExplosive[data.world.name]){
            data.buryExplosive[data.world.name] = {};
        }
        if(!data.buryExplosive[data.world.name][data.location.join()]){
            data.buryExplosive[data.world.name][data.location.join()] = {};
        }
        if(!data.buryExplosive[data.world.name][data.location.join()][bagItemById.name]){
            data.buryExplosive[data.world.name][data.location.join()][bagItemById.name] = 0;
        }

        reduceItem(bagItemById.name, num)
        data.buryExplosive[data.world.name][data.location.join()][bagItemById.name] += num;
        winMsg(`你在这里埋藏了${num}个${bagItemById.name}`, false, false);

        renderBag();
        renderMapElements(false, true)
        let ts = data.bag.filter(e => e.name.endsWith('炸药'));
        $('.select-explosive-win').show().find('.select-explosive-win-items').html(`${ts.map(e => `<div data-id="${e.id}">${e.showName || e.name}*${e.quantity}</div>`).join('')}`);
        $(`.select-explosive-win-items [data-id=${id}]`).addClass('active')
        save();
    }else{
        winMsg(`请先选择炸药`, false, false);
    }
}

//没走战斗事件，也不波动，但是要被防御和减伤减免的战斗扣血，仅限玩家使用
function battleOtherAtk(atk, obj = data, mountReduceHarm = true){
    let harm = (atk * (1 - (obj.reduceHart || 0))) - obj.def;
    if(harm > 0){
        harm = reduceShield(obj, harm, mountReduceHarm)
        obj.hp -= harm;
        if(obj.armor && (atk * 2) > obj.armor.def){
            reduceArmorEndurance(obj.armor.id)
        }
        return harm
    }
    return 0;
}

//查看存档路径
function seeSavePath(){
    if(window.control){
        $('.common-win').show().find('.win-body').html(`<p>如果没有授权外部存储权限，文件就还在原存档位置，授权了就在新存档位置。如果你1.158版本之前就已经开始玩了，你的大多数存档就一定是在原存档位置，你更新1.158之后玩过的存档，如果授权了，就会出现在新存档位置，没玩过的就还在原存档位置。你可以将原存档位置的文件全部移动到新存档位置，但是遇到同名文件不要覆盖，选择跳过，不然可能会出现更新1.158版本后的游戏进度被之前的进度覆盖的情况。<br>原存档位置：${window.control.oldPath()}<br>当前存档位置：${window.control.newPath()}</p>`);
    }else{
        winMsg(`无法获取存档位置`)
    }
}

//根据分钟获取将失去多少饥饿和水分
function getNeedWaterAndHungerByMin(min){
    if(data.race.name.startsWith('星灵')) {
        return {
            hunger : 0,
            water : 0
        };
    }

    const need = parseInt(min / statusMin);
    const needHunger = data.race.name.startsWith('食人魔') ? need * 2 : need;
    const needWater = getSeason() === '夏' ? need * (data.race.name.startsWith('弑魂叔') ? 3 : 2) : need;
    return {
        hunger : needHunger,
        water : needWater
    };
}

//渲染常见问题窗口
function renderAskWin(){
    const askLikt = [{
        ask : '哪里有攻略？',
        answer : 'taptap的开拓者论坛有很多攻略，对于游戏基础问题，打开“系统-图鉴”，能解决游戏中90%的问题。对于游戏的一些基础设定，建议先看看“系统-图鉴-说明”，不一定要细看，至少稍微过一遍，了解下游戏有哪些内容。'
    },{
        ask : '怎么搬家？',
        answer : '先说半岛以后，到了半岛，可以升级3级家了，3级家有传送门，仓库物品全部取出，然后传送门传送到你要搬的家里，就行了。半岛之前，为了方便搬家，一般在孤岛可以选择安家在神殿，或者地底入口。如果安家在神殿，则去了地底后，先不带孤岛的东西，只带少量必需品，然后可以打得过神性史莱姆，或者钓鱼钓到了神性结晶，或者有钱在次元交易所（2级家解锁）买到神性结晶，就可以在次元研究室造次元钥匙，在地底神殿安家后，在孤岛的地底入口使用次元钥匙<span class="to-cybernet" data-name="次元钥匙">🔍</span>，把仓库物品全部拿出，然后进入地底，然后使用神殿回城卷，就完成搬家了。如果是安家在地底入口，则地底就安家在孤岛入口，这样直接就可以从孤岛一次性取出所有物品，进入地底，再存入所有物品了。'
    },{
        ask : '使用了图纸为什么不能制造装备？',
        answer : '图纸在背包中使用后，需要在1级家的锻造台锻造对应的装备。'
    },{
        ask : '页面变红了或者变黄了是什么意思？',
        answer : '血量低于20%，或者饥饿和水分低于20点，页面就会变红警告。如果当前负重超过最大负重的80%，就会变黄警告。这些警告提醒都可以在系统里关闭。'
    },{
        ask : '怎么找游荡的神话怪（例如神性史莱姆）？',
        answer : '在孤岛时只能看运气，进了地底后，2级家可以造“灵魂追猎<span class="to-cybernet" data-name="灵魂追猎">🔍</span>”，用灵魂追猎就可以在地图上标注出神话怪的位置了。'
    },{
        ask : '牵引卷轴召唤过来的世界BOSS怎么打？',
        answer : '可以打几下就逃跑，再叫出来继续打，世界BOSS不会回血的，而逃跑可以重置世界BOSS的攻防。'
    },{
        ask : '为什么水分消耗突然变成饥饿消耗的双倍了？',
        answer : '因为到夏天了，具体见：图鉴-说明-季节和日夜。'
    },{
        ask : '怎么一转和二转？',
        answer : '4级家可以制造“天赋神晶<span class="to-cybernet" data-name="天赋神晶">🔍</span>”，用于在“天赋祭坛<span class="to-cybernet" data-name="天赋祭坛">🔍</span>”制造一转道具。同样4级家可以制造“神灵之力<span class="to-cybernet" data-name="神灵之力">🔍</span>”，用于二转。'
    },{
        ask : '坐骑技能怎么制造？',
        answer : '一个带有技能的坐骑，在乘骑状态时，即可在制造页面制造对应的技能石。'
    },{
        ask : '不小心把重要物品丢掉了怎么办？',
        answer : '重要物品可以在物品详情页面左上角点击小锁把它锁住，就不会被不小心丢掉或者卖掉了。如果确实不小心丢掉了，页面下方的按钮栏会多出一个“拾取”按钮，可以拾取刚才丢弃的物品。但是如果你离开了当前这一格地图，再回来时，之前丢弃的物品就会消失，再也无法寻回了。'
    }]
    $('.ask-list').html(askLikt.map(e => `<div class="ask-box"><div class="ask">${e.ask}</div><div class="answer">${e.answer}</div></div>`).join(''));
    $('.ask-win').show();
}

//切换问题显示隐藏
$('.ask-win').on('click', '.ask', function(){
    $(this).next().toggle();
})

//获取可以刷新出来的怪物列表
function getCanRenderMonster(mapName = data.map[data.location[1]][data.location[0]]){
    const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
    return Object.keys(monsters).filter(name => monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1])
}

//点击打开自动打怪窗口
$('#auto-kill-monster').click(function(){
    let {selectMonster = [], selectSkill = []} = data.autoKillMonsterCfg;
    $('.auto-kill-monster-win').show();
    $('.auto-kill-monster-win-monsters').html(getCanRenderMonster().map(e => `<div ${selectMonster.includes(e) ? 'class="active"' : ''}>${e}</div>`).join(''));
    $('.auto-kill-monster-win-skills').html(`<div ${selectSkill === '普通攻击' ? 'class="active"' : ''} data-id="普通攻击">普通攻击</div>` + data.bag.filter(e => (e.endurance > 0 && e.name.startsWith('技能石')) || (e.battleUse)).map(e => `<div data-id="${e.id}" ${selectSkill === e.id ? 'class="active"' : ''}>${e.showName || e.name}(${e.onlyOne ? e.endurance : e.quantity})</div>`).join(''));
});
//点击选择怪物
$('.auto-kill-monster-win-monsters').on('click', 'div', function(){
    if($(this).hasClass('active')){
        $(this).removeClass('active')
    }else{
        $(this).addClass('active')
    }
});
//点击选择技能
$('.auto-kill-monster-win-skills').on('click', 'div', function(){
    $('.auto-kill-monster-win-skills div').removeClass('active');
    $(this).addClass('active')
});
//开始自动打怪
$('.auto-kill-monster-win-ok').click(function(e){
    e.stopPropagation();
    startAutoKillMonster();
})

//开始自动打怪
function startAutoKillMonster(){
    const selectMonster = [];
    $('.auto-kill-monster-win-monsters .active').each(function(){
        selectMonster.push($(this).html());
    })
    let selectSkill = $('.auto-kill-monster-win-skills .active').attr('data-id');
    if(!selectMonster.length){
        winMsg('请选择怪物', false, false)
        return;
    }
    if(!selectSkill){
        winMsg('请选择攻击方式', false, false)
        return;
    }
    data.autoKillMonsterCfg.selectMonster = selectMonster;
    data.autoKillMonsterCfg.selectSkill = selectSkill;
    data.autoKillMonsterCfg.run = true;
    stopAutoKillMonster = false;
    autoKillMonster();
    $('.auto-kill-monster-win').hide();
}

let stopAutoKillMonster = true;

//点击任意位置停止自动攻击
$('body').click(function () {
    stopAutoKillMonster = true;
});

//自动打怪的方法
function autoKillMonster(){
    //生命值小于20%，或饥饿和水分小于20，则停止自动打怪
    if(stopAutoKillMonster || data.hp < data.maxHp * 0.2 || (!data.race.getNoHunger() && ((data.hungerStopAutoKill && data.hunger < 20) || (data.waterStopAutoKill && data.water < 20)))){
        return;
    }
    setTimeout(() => {
        let {selectMonster, selectSkill, run} = data.autoKillMonsterCfg;
        if(run){
            //战斗中的处理
            if(inBattle()){
                //战斗中的怪物是自己指定的怪物才继续，否则不继续自动战斗，这是为了防止被怪物攻击时以不正确的攻击方式打计划外的怪物
                if(selectMonster.includes(data.battleMonster.name)){
                    if(selectSkill === '普通攻击'){
                        if(data.weapon){
                            useWeaponAtk(data.weapon);
                        }else{
                            playerAtk('空手', data.atk);
                        }
                        autoKillMonster();
                    }else{//使用武器或技能
                        let item = getBagItemById(selectSkill);
                        if(item != null){
                            if(item.isWeapon){
                                if(item.level > data.level || item.endurance <= 0){
                                    return;
                                }
                                useWeaponAtk(item);
                            }else if(item.battleUse){
                                //被封印时不渲染技能
                                if (isSeal(data) && item.name.startsWith('技能石')) {
                                    return;
                                }
                                battleUseItem(item.id);
                            }
                            autoKillMonster();
                        }
                    }
                }
            }else{//战斗外的处理
                const monsters = data.world.mapElements[data.location.join()] ? data.world.mapElements[data.location.join()].monsterList || [] : [];
                //如果页面刷出了当前要打的怪物，则开始战斗
                const hasMonsters = arrayIntersection([monsters,selectMonster]);
                if(hasMonsters.length > 0){
                    startBattle(hasMonsters[0], true)
                }else{//如果没刷出怪物，则触发一次探索
                    timeLapses(searchMin);
                }
                autoKillMonster();
            }
        }
    }, 50)
}

//获取玩家所属阵营
function getPlayerCamp(){
    return data.evil > 0 ? '邪恶' : data.evil < 0 ? '善良' : '中立';
}

//切换风格
function triggerStyle(){
    conf.oldStyle = !conf.oldStyle;
    save(confSavedName, conf);
    if(conf.oldStyle){
        $('.map-menu-div').removeClass('new-style');
    }else{
        $('.map-menu-div').addClass('new-style');
    }
}

//点击系统的标题
function clickSystemHead(){
    let type = $('.system-head .active').text();
    if(type){
        $('.system-box').hide();
        $(`.system-box[data-type='${type}']`).show()
    }
}

//增加罪恶值，如果是负数就是增加善良值
function addEvil(num){
    if(data.race.name.startsWith('天使-混沌') || data.race.name.startsWith('天使-伪神')){
        if(data.evil < 0 && num > 0){
            data.evil = -data.evil;
        }else if(data.evil > 0 && num < 0){
            data.evil = -data.evil;
        }else{
            data.evil += num * (data.race.name.startsWith('天使-伪神') ? 3 : 2);
        }
    }else{
        data.evil += num;
    }
}

//战斗中血量小于0时先调用这个方法，可能会因为某些原因不死
function preDie(obj){
    //不死状态
    if(isNoDie(obj) && obj.maxHp >= 1){
        obj.hp = 1;
        addBattleLog(`${obj.status.filter(e => e.noDie)[0].name}让${obj.world ? '你' : obj.showName || obj.name}抗拒了死亡的到来`)
    }
    //复活状态
    if(canRevive(obj)){
        const name = obj.status.filter(e => e.revive)[0].name;
        obj.hp = 0;
        addBattleLog(`${obj.world ? '你' : obj.showName || obj.name}因为【${name}】状态复活了，并恢复了${battleAddHp(obj, status[name].getReviveHp(obj))}HP`)
        obj.status = obj.status.filter(e => !e.revive);
    }
}

//点击开关切换开关状态
$('.on-off-core').click(function(e){
    e.stopPropagation();
    const attr = $(this).attr('data-attr');
    const clickClass = $(this).attr('click-cls');
    const click = $(this).attr('click');
    if(clickClass){
        $('.' + clickClass)[0].click();
    }else{
        eval(attr + '= !' + attr);
        if(click){
            eval(click + '()')
        }
        save();
        save(confSavedName, conf);
    }

    renderOnOff(attr);
})

//渲染开关状态
function renderOnOff(attr) {
    let el = $(`.on-off-core[data-attr='${attr}']`);
    if(eval((el.attr('hidden') ? '!' : '') + attr)){
        el.addClass('open')
    }else{
        el.removeClass('open')
    }
}

//渲染所有开关状态
function renderAllOnOff(){
    $('.on-off-core').each(function(){
        const attr = $(this).attr('data-attr');
        renderOnOff(attr);
    });
}

//系统内alert
function alertWin(text){
    $('.alert-win').show().find('.alert-win-title').html(text)
}

//获取时间错对应的天/小时/分钟，都是分别计算的，但是如果format为true，就是合并计算的
function getTime(time, format){
    //一分钟的时间
    const oneMin = 1000 * 60;
    //一小时的时间
    const oneHour = oneMin * 60;
    //一天的时间
    const oneDay = oneHour * 24;

    if(format){
        if(time < oneHour){
            return `${parseInt(time / oneMin)}分钟`;
        }else if(time < oneDay){
            const hour = parseInt(time / oneHour);
            const min = parseInt((time - (hour * oneHour)) / oneMin);
            return `${hour}小时${min}分钟`;
        }else{
            const day = parseInt(time / oneDay);
            const hour = parseInt((time - (day * oneDay)) / oneHour);
            const min = parseInt((time - (day * oneDay) - (hour * oneHour)) / oneMin);
            return `${day}天${hour}小时${min}分钟`;
        }
    }else{
        return {
            min : parseInt(time / oneMin),
            hour : parseInt(time / oneHour),
            day : parseInt(time / oneDay),
        }
    }
}

//获取指定装备的锻造材料，开发者专用方法
function addEquipForgeItems(name, num = 1){
    Object.keys(forgeRecipes[name].items).forEach(e => {
        addItem(e, forgeRecipes[name].items[e] * num)
    })
}
