//版本号
const version = '0.1';

//加载难度
let diff = loadDiff();
diff = diff == '0' ? '' : diff;
//加载配置
let conf = null;
//游戏数据
let data = null;
//没有版本号，说明没有加载到数据，认为是新游戏，初始化数据
let isInit = false;
let giveGrantMsg = !!Store.get('giveGrantMsg');
if(!giveGrantMsg){
    giveGrantMsg = true;
    Store.set('giveGrantMsg', giveGrantMsg);
    alert('请给游戏授权《外部存储权限》，否则会存档会存放在data文件夹内，安卓11开始会让你很难操作你的存档。不知道为什么，游戏本身不会提示你授权，需要手动授权，授权方式请百度，不授权也行，不影响游戏本身的功能。存档具体位置，请查看“系统”中的“存档位置”按钮。如果授权后提示坏挡，可以取消授权，有个别玩家反馈过这个问题，但我使用他的存档并没有问题，猜测和机型或者系统版本有关');
}
try{
    if(diff){
        startSelectRace();
    }else{
        $('.start-warning').hide();
        $('.select-diff').show();
        $('.select-diff .facility').click(function(){
            $('.select-diff .facility').removeClass('active');
            $(this).addClass('active');
        });
        $('.select-diff-ok').click(function(){
            const diffName = $('.select-diff .active h5').html();
            if(diffName){
                diff = diffName;
                saveDiff();
                startSelectRace();
                $('.select-diff').hide();
            }
        });
    }

    //选择难度后开始游戏
    function startSelectRace(){
        try{
            window.conf = conf = loadConf();
            /*$.ajax({
                url: "trailblazer/conf.saved",
                async: false,
                success(resp){
                    conf = JSON.parse(resp)
                }
            });*/
            if(!conf.races){
                conf.races = [];
            }
            window.data = data = load() || {};
            /*$.ajax({
                url: "temp/新人难度trailblazer-2.saved",
                async: false,
                success(resp){
                    data = JSON.parse(resp)
                }
            });*/

            if(typeof data === 'object'){
                $('.start-warning').hide();
            }else{
                $('.start-warning').show();
            }

            //判断种族是否不对
            if(data && data.race){
                if(!races[data.race.name]){
                    $('.start-warning').hide();
                    $('.alert-win').show().find('.alert-win-title').html(`你的种族[${data.race.name}]在本游戏中不存在，请前往系统中删档重玩`)
                    systemLock = false;
                    return;
                }
            }

            if(!data.version){
                isInit = true;

                //渲染可选种族列表
                const unlock = [...initRaces,...(conf.races ? conf.races : [])]
                const lock = [];

                Object.keys(races).forEach(e => {
                    if(!unlock.includes(e)){
                        lock.push(e);
                    }
                })

                const allRace = [...unlock,...lock];
                allRace.filter(e => races[e].name.indexOf('-') == -1).forEach(e => {
                    if((diff === '新人难度' || diff === '简单难度') && races[e].challenge){
                        return;
                    }
                    $('.init-plot .plot-body .race-list').append(`<div class="race one-line ${unlock.indexOf(e) === -1 ? 'lock' : ''}">${e}${unlock.indexOf(e) === -1 ? '(未解锁)' : ''}</div>`)
                })

                //显示初始化剧情
                $('.init-plot').show()

                $('.init-plot .race').click(function(){
                    $('.init-plot .race').removeClass('active');
                    if(!$(this).hasClass('lock')){
                        $(this).addClass('active');
                    }
                    $('.init-plot .plot-body .race-info').html(getRaceText($(this).html().split('(')[0]))
                });

                $('.start-game').click(function(){
                    const raceName = $('.init-plot .race.active').html();
                    if(raceName){
                        //初始化游戏数据
                        initGameData(raceName);
                        $('.init-plot').hide();
                        $('.plot-create').show();
                    }
                });

            }else{
                //寒影专属配置
                if(data.race.name && data.race.name.startsWith('寒影')){
                    Object.keys(monsterCfgs).forEach(e => {
                        monsterCfgs[e].atkTime = '全天';
                        monsterCfgs[e].atkProb = 10;
                    })
                }

                //加载世界
                if(data.worlds){
                    setTimeout(saveWorlds,1000)
                }else{
                    loadWorlds();
                    /*$.ajax({
                        url: "temp/新人难度trailblazer-2-map.saved",
                        async: false,
                        success(resp){
                            data.worlds = JSON.parse(resp)
                        }
                    });*/
                }

                //兼容随机地图功能
                if(data.maps == null){
                    data.maps = mapCfgs.slice(0, data.worlds.length + 1);
                }

                //格式化日期
                data.date = new Date(data.date);
                if(data.edu){
                    data.edu.eatDay = new Date(data.edu.eatDay);
                    data.edu.sayDay = new Date(data.edu.sayDay);
                }
                data.statusDate = new Date(data.statusDate);
                Object.keys(data.world.mapElements).forEach(key => {
                    Object.keys(data.world.mapElements[key].renderDates).forEach(name => {
                        data.world.mapElements[key].renderDates[name] = new Date(data.world.mapElements[key].renderDates[name]);
                    })
                })
                data.worlds.forEach(e => {
                    Object.keys(e.mapElements).forEach(key => {
                        Object.keys(e.mapElements[key].renderDates).forEach(name => {
                            e.mapElements[key].renderDates[name] = new Date(e.mapElements[key].renderDates[name]);
                        })
                    })
                })

                //格式化背包、仓库、地图资源的资源类
                data.bag = data.bag.filter(e => elementCfgs[e.name]).map(e => new Element(e));
                renderWorld();
                if(data.weapon){
                    data.weapon = new Element(data.weapon);
                }
                if(data.armor){
                    data.armor = new Element(data.armor);
                }
                if(data.bagEquip){
                    data.bagEquip = new Element(data.bagEquip);
                }
                if(data.mount){
                    data.mount = new Element(data.mount);
                }
                if(data.patriarchEnchantWeapon){
                    data.patriarchEnchantWeapon = new Element(data.patriarchEnchantWeapon);
                }
                if(data.patriarchEnchantArmor){
                    data.patriarchEnchantArmor = new Element(data.patriarchEnchantArmor);
                }
                if(data.equipList){
                    data.equipList = data.equipList.map(e => {
                        return {
                            weapon : e.weapon && new Element(e.weapon),
                            armor : e.armor && new Element(e.armor),
                            bagEquip : e.bagEquip && new Element(e.bagEquip),
                            mount : e.mount && new Element(e.mount),
                        }
                    })
                }

                //格式化种族
                if(data.race){
                    data.race = races[data.race.name || '人类'];
                }

                //记录最高周目
                if(!conf.maxOrder){
                    conf.maxOrder = 1;
                }
                if(data.order > conf.maxOrder){
                    conf.maxOrder = data.order;
                    save(confSavedName, conf);
                }
                //记录种族最高周目
                if(!conf.raceMaxOrder){
                    conf.raceMaxOrder = {};
                }
                const baseRaceName = data.race.name.split('-')[0]
                conf.raceMaxOrder[baseRaceName] = conf.raceMaxOrder[baseRaceName] || 0;
                if(data.order > conf.raceMaxOrder[baseRaceName]){
                    conf.raceMaxOrder[baseRaceName] = data.order;
                    save(confSavedName, conf);
                }

                //兼容成就
                if(!conf.achievement){
                    conf.achievement = [];
                    save(confSavedName, conf);
                }

                //兼容副本
                if(!data.dungeon){
                    data.dungeon = [];
                }

                //兼容粘液
                data.mucus = data.mucus || 0;

                //不考虑在副本的情况
                if(!data.inDungeon){
                    //兼容神话怪
                    if(!data.world.mythMonster || data.world.mythMonster.length === 0){
                        data.world.mythMonster = data.maps[data.worldIndex].mythMonster.map(e => ({name : e, location : [randomNum(0,xnum - 1), randomNum(0,ynum - 1)],day : new Date(data.date).format('yyyyMMdd')}))
                    }

                    //兼容新加的神话怪
                    if(!data.world.mythMonster){
                        data.world.mythMonster = [];
                    }
                    if(data.world.mythMonster.length < data.maps[data.worldIndex].mythMonster.length){
                        const myths = data.maps[data.worldIndex].mythMonster.filter(e => data.world.mythMonster.map(m => m.name).indexOf(e) === -1);
                        data.world.mythMonster = [...data.world.mythMonster,...(myths.map(e => ({name : e, location : [randomNum(0,xnum - 1), randomNum(0,ynum - 1)],day : new Date(data.date).format('yyyyMMdd')})))]
                    }
                }

                //兼容神灵系统
                if(!data.deitys){
                    data.deitys = {};

                    data.worlds.forEach((world,index) => {
                        //创建神殿
                        Object.keys(deitys).forEach(e =>{
                            //随机神殿坐标
                            let x = randomNum(0, xnum - 1);
                            let y = randomNum(0, ynum - 1);
                            while (terrainArray[data.maps[index].name].indexOf(world.map[y][x]) === -1){
                                x = randomNum(0, xnum - 1);
                                y = randomNum(0, ynum - 1);
                            }

                            //创建神殿
                            const temple = createTemple(e, index);
                            world.map[y][x] = '神殿';
                            if(index === data.worldIndex){
                                data.map[y][x] = '神殿';
                                data.world.map[y][x] = '神殿';
                            }
                            if(!data.temples){
                                data.temples = {};
                            }
                            if(!data.temples[index]){
                                data.temples[index] = {};
                            }
                            data.temples[index][`${x},${y}`] = temple;

                            //创建对应神的信息
                            if(!data.deitys[e]){
                                data.deitys[e] = {
                                    godFavor : 0,//神眷
                                    belief : 0,//信仰
                                };
                            }
                        })
                    })
                }else if(Object.keys(data.deitys).length < Object.keys(deitys).length){//兼容新加入的神
                    const myDeitys = Object.keys(data.deitys);
                    data.worlds.forEach((world,index) => {
                        //创建神殿
                        Object.keys(deitys).forEach(e =>{
                            //已有的神不处理
                            if(myDeitys.indexOf(e) !== -1){
                                return;
                            }

                            //随机神殿坐标
                            let x = randomNum(0, xnum - 1);
                            let y = randomNum(0, ynum - 1);
                            while (terrainArray[data.maps[index].name].indexOf(world.map[y][x]) === -1){
                                x = randomNum(0, xnum - 1);
                                y = randomNum(0, ynum - 1);
                            }

                            //创建神殿
                            const temple = createTemple(e, index);
                            world.map[y][x] = '神殿';
                            if(index === data.worldIndex){
                                data.map[y][x] = '神殿';
                                data.world.map[y][x] = '神殿';
                            }
                            if(!data.temples){
                                data.temples = {};
                            }
                            if(!data.temples[index]){
                                data.temples[index] = {};
                            }
                            data.temples[index][`${x},${y}`] = temple;

                            //创建对应神的信息
                            if(!data.deitys[e]){
                                data.deitys[e] = {
                                    godFavor : 0,//神眷
                                    belief : 0,//信仰
                                };
                            }
                        })
                    })
                }

                //兼容种族
                if(!data.race){
                    data.race = races['人类'];
                }

                //兼容已击杀神话怪物列表
                if(!data.killedMyth){
                    data.killedMyth = [];
                }

                startGame()
            }
        }catch (e) {
            $('.start-warning').hide();
            $('.alert-win').show().find('.alert-win-title').html('你看到这个，未必就说明你这个存档坏掉了，可能是因为某个BUG导致游戏报错了，可以去群里私聊作者反馈，然后切换到其他存档先玩别的存档，如果确定是坏档了，就去系统里点击存档还原，可以还原到上一次自动备份的数据，具体见图鉴-说明-存档还原。如果没有可还原的备份存档或者备份存档也是坏的，那就删除存档删掉这个坏档，重新开始吧')
            systemLock = false;
            console.error(e)
        }
    }

    //初始化游戏数据，新游戏开始时调用
    function initGameData(raceName){
        data.version = version;

        //世界序号
        data.worldIndex = 0;
        data.maps = [mapConfig[data.worldIndex].getRandom()];
        data.world = {
            ...data.maps[data.worldIndex]
        }

        //寒影专属配置
        if(raceName.startsWith('寒影')){
            Object.keys(monsterCfgs).forEach(e => {
                monsterCfgs[e].atkTime = '全天';
                monsterCfgs[e].atkProb = 10;
            })
        }

        //初始时间
        data.date = initDate;

        //兼容成就
        data.killedMonster = data.killedMonster || {};
        data.gathered = data.gathered || {};

        data.nextPoint = null;//前往下一个世界的坐标
        data.prePoint = null;//前往上一个世界的坐标
        //生成地图
        data.map = createMap(terrainArray[data.maps[data.worldIndex].name]);

        //默认开启提醒
        conf.hpWarning = true;
        conf.hungerWarning = true;
        conf.waterWarning = true;
        conf.weightWarning = true;

        //记录游戏时间
        data.startTime = 1;

        //创建初始世界
        data.world = {
            ...data.world,
            map : data.map,//世界地图
            showMap : {},//key为显坐标，value为1则代表已经显示出来，否则就是空白显示
            mapElements : {},//地图元素集合
            home : {
                location : []//家的坐标[1,2]
            },
            nextPoint : data.nextPoint,
            prePoint : data.prePoint,
            pass : false,//用于记录是否通关，即是否已经战胜守关BOSS
            //神话怪物
            mythMonster : data.maps[data.worldIndex].mythMonster.map(e => ({name : e, location : [randomNum(0,xnum - 1), randomNum(0,ynum - 1)],day : new Date(data.date).format('yyyyMMdd')}))
        }
        data.worlds = [data.world];
        saveWorlds();
        //显示神话怪所在的天数
        data.showMythDay = null;

        //等级
        data.level = 1;
        //神性
        data.divinity = 0
        //灵魂
        data.soul = 0;
        //粘液
        data.mucus = 0;
        //额外属性点
        data.consumePoint = 0;
        //理智
        data.san = 100;
        data.maxSan = 100;
        //种族
        data.race = races[raceName];
        data.race.onCreate();
        //经验
        data.exp = 0;
        //属性点
        data.attrPoint = 0;
        //攻击力
        data.atk = data.race.atk;
        //防御力
        data.def = data.race.def;
        //生命值
        data.hp = data.race.hp;
        data.maxHp = data.race.hp;
        //饥饿值
        data.hunger = data.race.hunger;
        data.maxHunger = data.race.hunger;
        //水分值
        data.water = data.race.water;
        data.maxWater = data.race.water;
        //负重
        data.weight = 0;
        data.maxWeight = data.race.weight;

        data.forgeCount = {};
        data.ks = ['','','','','','',''];

        //种族初始信仰和神眷
        if(data.race.deity){
            data.deitys[data.race.deity.name].godFavor = data.race.deity.godFavor;
            data.deitys[data.race.deity.name].belief = data.race.deity.belief;
        }

        //存放可传送的副本
        data.dungeon = [];

        //存放已击杀的神话怪物
        data.killedMyth = [];

        //锻造经验
        data.forgeExp = 0;
        //已学习的锻造配方
        data.forgeRecipes = [];

        //背包
        data.bag = [];
        data.race.initItems.forEach(e => {
            addItem(e.name, e.num)
        })

        //周目礼包
        if(!data.race.challenge && data.race.name !== '教学种族' && conf.maxOrder > 1){
            addItem('周目礼包',3 * (conf.maxOrder - 1));
        }
        //种族周目点数
        if(!conf.raceMaxOrder){
            conf.raceMaxOrder = {};
        }
        let num = 0;
        Object.keys(conf.raceMaxOrder).forEach(e => {
            num += conf.raceMaxOrder[e] - 1;
        });
        data.orderPoint = num;

        //武器
        data.weapon = null;
        //护甲
        data.armor = null;
        //背包装备
        data.bagEquip = null;

        //初始地点
        const x = randomNum(0,xnum - 1);
        const y = randomNum(0,ynum - 1);
        data.location = [x,y];

        //正在战斗的对象
        data.battleMonster = null;
        //初始状态时间，记录最后一次状态变化的时间
        data.statusDate = data.date;

        //初始化日志
        data.logs = [];

        //获得成就奖励
        if(!conf.achievement){
            conf.achievement = [];
            save(confSavedName, conf);
        }
        if(conf.achievement.length > 0){
            addItem('成就礼包')
        }

        //开拓者专属配置
        if(data.race.challenge || data.race.name.startsWith('教学种族')){
            achievement = [];
        }

        //挑战种族送东西
        if(diff === '扩展难度' && data.race.challenge){
            addItem('水之神殿感应器');
            addItem('狩猎神殿感应器');
            addItem('地图出口感应器');
        }

        startGame();
    }

    //开始游戏
    function startGame(){
        getNetDate(date => {
            if(diff === '硬核难度' || diff === '扩展难度'){
                Object.keys(monsterCfgs).forEach(e => {
                    if(e === '无害小动物'){
                        return;
                    }
                    monsterCfgs[e].exp = monsterCfgs[e].level * 5 * (monsterCfgs[e].type === '神话' ? 20 : monsterCfgs[e].type === '传说' ? 10 : monsterCfgs[e].type === '精英' ? 5 : 1);
                })
            }

            //切换模式
            if(conf.darkModel){
                $('body').addClass('night-mode');
            }

            renderPageTop();

            //设定弹窗关闭按钮位置
            if(conf.isBottomWin){
                $('.win').addClass('bottom-win');
            }

            if(data.maxSan == null){
                data.san = 100;
                data.maxSan = 100;
            }
            if((data.race.name.startsWith('人类-法师') || data.race.name.startsWith('人类-元素师')) && data.spi == null){
                data.spi = 100;
            }
            data.killedMonster = data.killedMonster || {};
            data.gathered = data.gathered || {};

            data.worldPower = data.worldPower || 0;

            //格式化镶嵌物仓库
            conf.runesStore = conf.runesStore || [];
            conf.runesStore = conf.runesStore.map(e => new Element(e));

            //兼容周目
            if(!data.order){
                data.order = 1;
            }
            if(!conf.drawNum){
                conf.drawNum = 0;
            }
            if(!data.drawNum){
                data.drawNum = 0;
            }
            if(data.drawNum > 0 && !data.race.challenge){
                conf.drawNum += data.drawNum;
                data.drawNum = 0;
                save(confSavedName, conf);
            }
            //兼容死亡日志
            conf.dieLog = conf.dieLog || [];
            //兼容锻造统计
            if(!data.forgeCount){
                data.forgeCount = {};
            }
            //兼容快捷键
            if(!data.ks){
                data.ks = ['','','','','','',''];
            }else if(data.ks.length === 5){
                data.ks.push('');
                data.ks.push('');
            }
            Object.keys(races).forEach(e => {
                races[e].attrPoint += 2 * (data.order - 1)
            })
            if(data.order > 1){
                data.race = races[data.race.name || '人类'];
            }

            //兼容战斗状态
            if(!data.status){
                data.status = [];
            }

            //解决哥布林属性BUG
            if(data.race.name.startsWith('哥布林') && data.reduceHart > 1){
                let weapon = null;
                let armor = null;
                if(data.weapon){
                    weapon = getBagItemById(data.weapon.id);
                    equip(data.weapon)
                }
                if(data.armor){
                    armor = getBagItemById(data.armor.id);
                    equip(data.armor)
                }

                data.reduceHart = 0;

                if(weapon){
                    equip(weapon)
                }
                if(armor){
                    equip(armor)
                }
            }

            //兼容元素配方
            if(!conf.elementalRecipes){
                conf.elementalRecipes = {};
                save(confSavedName, conf);
            }

            //兼容移动状态
            if(!data.runStatus){
                data.runStatus = {};
            }

            //兼容百分比减伤
            if(data.reduceHart == null){
                data.reduceHart = 0;
            }
            //兼容吸血
            data.suck = data.suck || 0;
            //兼容显示怪物等级
            if(conf.showMonsterLevel == null){
                conf.showMonsterLevel = true;
            }

            //兼容自动打怪配置
            if(!data.autoKillMonsterCfg){
                data.autoKillMonsterCfg = {};
            }

            //兼容埋藏炸药
            if(!data.buryExplosive){
                data.buryExplosive = {};
            }

            //兼容新样式
            /*if(conf.oldStyle == null){
                conf.oldStyle = false;
                save(confSavedName, conf);
            }
            if(!conf.oldStyle){
                $('.map-menu-div').addClass('new-style');
            }*/

            //戏命师修改攻击浮动
            if(data.race.name.startsWith('戏命师')){
                atkFloat = 0.5;
            }

            //解锁戏命师
            if(conf.races.indexOf('戏命师') === -1 && data.level >= 60){
                winMsg('恭喜你解锁戏命师种族！');
                conf.races.push('戏命师');
                save(confSavedName, conf);
            }

            //解锁魅魔
            if(data.edu && data.edu.over && data.eduOver && conf.races.indexOf('魅魔') === -1){
                winMsg('恭喜你解锁魅魔！');
                conf.races.push('魅魔');
                save(confSavedName, conf);
            }

            //解锁蜥蜴人
            if(conf.races.indexOf('蜥蜴人') === -1 && data.order > 1){
                winMsg('恭喜你解锁蜥蜴人种族！');
                conf.races.push('蜥蜴人');
                save(confSavedName, conf);
            }

            //获取节日礼物
            const festivalGift = getFestivalGift(date);

            if(festivalGift){
                if(window.notNetDate){
                    winMsg('从网络获取时间失败，无法领取节日礼物')
                }else{
                    Object.keys(festivalGift.gifts).forEach(e => {
                        addItem(e, festivalGift.gifts[e]);
                    })

                    data.getedGift.push(date.format('yyyy-MM-dd'))
                    setTimeout(function(){
                        $('.alert-win').show().find('.alert-win-title').html(`${festivalGift.text}请收下节日礼物：${Object.keys(festivalGift.gifts).map(e => `${e}*${festivalGift.gifts[e]}`).join('，')}`)
                    }, 300)
                }
            }

            //开拓者专属配置
            if(data.race.challenge || data.race.name.startsWith('教学种族')){
                homeLevelFacility[0] = ['床','仓库'];
                runSuccessRate = 30;
                statusMin = 10;
                $('.upload-saved').remove();
                $('.download-saved').remove();
                achievement = [];
            }

            //赠送史莱姆进化石
            if(!data.hasSlmjhs && data.race.name.startsWith('史莱姆') && conf.races.includes('神性史莱姆')){
                addItem('史莱姆进化石');
                data.hasSlmjhs = true;
            }

            //新人难度专属配置
            if(diff === '新人难度'){
                statusMin = 60;
            }

            //处理金币
            if(data.gold == null){
                data.gold = 0;
            }

            //处理速度
            if(data.spd == null){
                data.spd = 0;
            }

            //处理攻速
            if(data.atkSpd == null){
                data.atkSpd = 0;
            }

            //处理最后一次睡觉的时间
            if(data.sleepTime == null){
                data.sleepTime = data.date.getTime();
            }

            //处理罪恶值
            if(data.evil == null){
                data.evil = 0;
            }

            //处理存档还原次数
            if(!data.restoreNum){
                data.restoreNum = 0;
            }

            //处理装备栏
            if(!data.equipList){
                data.selecEquip = 0;
                data.equipList = [{},{},{}]
            }

            //处理血量
            data.hp = parseInt(data.hp);

            //处理错误的神性史莱姆减伤
            if(data.race.name.startsWith('神性史莱姆') && data.reduceHart < 0.2){
                data.reduceHart = 0.2;
            }

            //初始化股市
            initStock();

            //初始化NPC
            initNpc();

            //将当前坐标和四周坐标设置为已探索
            setShowMap();
            //渲染属性
            renderAttrs();
            //渲染地图元素
            renderMapElements(isInit,true);
            //渲染可前往的地图
            renderCanToMap();
            //渲染地图
            renderMap();

            //更改存档种族
            if(!conf.saveListNames){
                conf.saveListNames = {};
            }
            const name = `${data.race.name}`;
            if(!conf.saveListNames[conf.savedName] || conf.saveListNames[conf.savedName] !== name){
                conf.saveListNames[conf.savedName] = name
                save(confSavedName, conf);
            }

            data.logs.forEach(e => {
                msg(e, false, false);
            })
            msg('欢迎新的开拓者！点击右下角“系统”进入系统界面后，点击右上角“图鉴”可以查看游戏的各种机制和功能，尤其是《说明》部分，新手一定要看看！', false)

            if(data.maxWeight < 0){
                initAttr();
                winMsg('发现你的负重为负数，自动为你洗点一次，请重新加点', false, false)
            }
            if(data.maxHunger == null){
                initAttr();
                winMsg('发现你的最大饥饿值异常，自动为你洗点一次，请重新加点', false, false)
            }

            msg('特别注意！！！！为了避免存档损坏，请勿在进行游戏时突然退出游戏，游戏为自动存档，2秒自动保存1次，如果在保存到一半时退出游戏，会导致存档损坏，且无法挽回。避免方法：要退出游戏时，先放置3秒不做任何操作，无操作时不会存档。', false)
            msg('系统里有安全退出按钮，使用这个按钮退出绝对不会损坏存档', false, false)
            msg('当前难度：' + diff, false)

            //渲染神话怪状态
            renderMythStatus()

            //渲染季节和日夜
            renderSeasonAndDayNight();


            //存档
            save();
            warning();
            renderKs();

            //如果是正在战斗中，直接打开战斗页面
            if(data.battleMonster && !monsterCfgs[data.battleMonster.name]){
                battleEnd();
            }
            if(data.battleMonster){
                if(!data.battleMonster.status){
                    data.battleMonster.status = [];
                }
                renderBattlePage();
                $('.battle').show();
                $('.stop-auto-battle').hide();
            }

            //if(conf.closeChatRoom){
            //$('#chatroom').hide()
            //}

            if(conf.hideAskWin){
                $('#askWin').hide()
            }

            if(conf.hideMapBtnBox || data.inDungeon){
                $('#map-btn-box').hide()
            }

            if(data.hungerStopAutoKill == null){
                data.hungerStopAutoKill = true;
            }
            if(data.waterStopAutoKill == null){
                data.waterStopAutoKill = true;
            }

            if(data.dlcAutoKillMonster){
                $('#auto-kill-monster').show();
            }else{
                $('#auto-kill-monster').hide();
            }

            if(diff !== '扩展难度' && !data.dlcExperience){
                $('.dlc-split,.init-dlc,.dlc-show').hide();
            }
            initSponsor()
            initAnno();
            renderKeepDark()
            renderAllOnOff();
            setInterval(debugBag,1000);
        });
    }
}catch (e) {
    $('.start-warning').hide();
    $('.alert-win').show().find('.alert-win-title').html('你看到这个，未必就说明你这个存档坏掉了，可能是因为某个BUG导致游戏报错了，可以去群里私聊作者反馈，然后切换到其他存档先玩别的存档，如果确定是坏档了，就去系统里点击存档还原，可以还原到上一次自动备份的数据，具体见图鉴-说明-存档还原。如果没有可还原的备份存档或者备份存档也是坏的，那就删除存档删掉这个坏档，重新开始吧')
    systemLock = false;
    console.error(e)
}
