//新地图的元素集合
const newMaps = [map3Shandi,map4Shidi];

//新地图的元素集合
const newMapElements = {
    maps : {
        0 : [],
        1 : [],
        2 : [],
        3 : [],
        4 : [],
        5 : [],
        6 : [],
        7 : [],
        8 : [],
    },
    terrainArray : {},
    terrainJoinTerrain : {},
    terrainJoinTerrainAppend : {},
    terrainColor : {},
    elements : {},
    monsters : {},
    monsterItems : {},
    monsterSkill : {},
    terrainElements : {},
    deity : {
        水之女神 : {
            hates : [
            ],
            likes : [
            ],
        },
        狩猎之神 : {
            hates : [
            ],
            likes : [
            ],
        }
    },
    equip : {},
    shop : {},
    forgeRecipes : {},
    tuzhi : {},
};

//将所有地图配置格式化处理
newMaps.forEach(e => {
    //获取基础信息
    const {index, confs, ...map} = e;
    newMapElements.maps[index].push(map);

    //获取配置数据
    const {
        terrainArray,
        terrainJoinTerrain,
        terrainJoinTerrainAppend,
        terrainColor,
        elements,
        monsters,
        monsterItems,
        monsterSkill,
        terrainElements,
        deity,
        equip,
        shop,
        forgeRecipes
    } = confs;

    newMapElements.terrainArray[map.name] = terrainArray;
    newMapElements.terrainJoinTerrain = {...newMapElements.terrainJoinTerrain,...terrainJoinTerrain};
    newMapElements.terrainJoinTerrainAppend = {...newMapElements.terrainJoinTerrainAppend,...terrainJoinTerrainAppend};
    newMapElements.terrainColor = {...newMapElements.terrainColor,...terrainColor};
    newMapElements.elements = {...newMapElements.elements,...elements};

    //循环所有装备，生成图纸，并指定给掉落材料的怪物掉落物
    Object.keys(equip).forEach(name => {
        const {level} = equip[name];
        const recipe = forgeRecipes[name];

        //循环配方需要的所有物品
        Object.keys(recipe.items).forEach(item => {
            //循环所有怪物
            Object.keys(monsters).forEach(monsterName => {
                //获取怪物所有掉落物
                let getItems = monsters[monsterName].items.map(e => e.name);
                //如果该怪物掉落该物品
                if(getItems.includes(item)){
                    //创建图纸物品
                    newMapElements.tuzhi[`图纸：${name}`] = new Element({canUse : true, getForgeRate : name, text : '使用后在1级家的锻造台锻造'})

                    if(!monsters[monsterName].items.filter(e => e.name === `图纸：${name}`).length){
                        //添加图纸的掉落
                        if(monsters[monsterName].type === '精英'){
                            monsters[monsterName].items.push({name : `图纸：${name}`,minNum : 3, maxNum : 1})
                        }else if(monsters[monsterName].type === '传说' || monsters[monsterName].type === '神话'){
                            monsters[monsterName].items.push({name : `图纸：${name}`,minNum : 0, maxNum : 1})
                        }else{
                            monsters[monsterName].items.push({name : `图纸：${name}`,minNum : level > monsters[monsterName].level ? -8 : -3, maxNum : 1})
                        }
                    }
                }
            })

        })
    })

    newMapElements.monsters = {...newMapElements.monsters,...monsters};
    newMapElements.monsterItems = {...newMapElements.monsterItems,...monsterItems};
    newMapElements.monsterSkill = {...newMapElements.monsterSkill,...monsterSkill};

    Object.keys(terrainElements).forEach(e => {
        if(newMapElements.terrainElements[e]){
            newMapElements.terrainElements[e].monster = {...newMapElements.terrainElements[e].monster,...terrainElements[e].monster};
            newMapElements.terrainElements[e].elements = {...newMapElements.terrainElements[e].elements,...terrainElements[e].elements};
        }else{
            newMapElements.terrainElements[e] = terrainElements[e];
        }
    })

    Object.keys(deity).forEach(e => {
        newMapElements.deity[e].hates = [...newMapElements.deity[e].hates, ...deity[e].hates];
        newMapElements.deity[e].likes = [...newMapElements.deity[e].likes, ...deity[e].likes];
    })

    newMapElements.equip = {...newMapElements.equip,...equip};
    newMapElements.shop[map.name] = shop;
    newMapElements.forgeRecipes = {...newMapElements.forgeRecipes,...forgeRecipes};
})
