//渲染地图
function renderMap(){
    const map = data.map;
    //清空地图
    $('.map-div').html('');

    if(!data.world.mapFlags){
        data.world.mapFlags = {};
    }

    //如果有地图标记
    if(data.world.mapFlags[data.location.join()]){

    }

    //循环横纵坐标数量，生成地图
    for(let y = 0 ; y < map.length ; y++){
        for(let x = 0 ; x < map[y].length ; x++){
            //获取该坐标的地形名
            let terrain = map[y][x];
            //判断该地形是否是家
            const homeMap = data.world.home.location.length > 0 && data.world.home.location.join() === (x + ',' + y) ? 'home-map' : '';
            //判断该地形是不是地图出入口
            const outerMap = (data.nextPoint && data.nextPoint.join() === (x + ',' + y)) || data.prePoint && data.prePoint.join() === (x + ',' + y) || terrain === data.maps[data.worldIndex].endTerrain ? 'outer-map' : '';
            //判断是否神话怪所在
            let myth = null;
            if(data.showMythDay === new Date(data.date).format('yyyyMMdd') || data.race.name.startsWith('寒影')){
                myth = data.world.mythMonster.filter(e => e.location.join() === (x + ',' + y)).length > 0 ? 'myth-monster' : '';
            }else{
                myth = '';
            }

            //判断是否NPC所在
            let isNpc = null;
            if(data.world.npcs && data.world.npcs.filter(e => ((data.race.name.startsWith("天使") && e.camp === getPlayerCamp()) || e.showMapLocation) && e.location.join() === (x + ',' + y)).length > 0){
                if(data.world.npcs && data.world.npcs.filter(e => ((data.race.name.startsWith("天使") && e.camp === getPlayerCamp())) && e.location.join() === (x + ',' + y)).length > 0){
                    isNpc = 'tianshi-map-npc';
                }else{
                    isNpc = 'map-npc';
                }
            }else{
                isNpc = '';
            }

            //判断是否阵营商店所在
            let isCampShop = null;
            if(data.world.npcs && data.world.npcs.filter(e => e.showMapLocation && npcCfg.sole[e.type] && e.location.join() === (x + ',' + y)).length > 0){
                isCampShop = 'map-cap-shop';
            }else{
                isCampShop = '';
            }

            //判断是否神殿
            const de = Object.keys(data.temples[data.worldIndex]).filter(e => e === (x + ',' + y));
            let temples = de.length > 0 ? data.temples[data.worldIndex][de[0]] && data.temples[data.worldIndex][de[0]].deity === '水之女神' ? 'temple-map-ele deity-water' : 'temple-map-ele' : '';
            if(terrain !== '神殿'){
                temples = '';
            }

            $(`<div class="map ${homeMap} ${outerMap} ${myth} ${temples} ${isNpc} ${isCampShop}" point="${x + ',' + y}">${data.world.mapFlags[x + ',' + y] ? '<span class="map-flag">🚩</span>' : ''}<span>${terrain}</span></div>`).css('color' , terrainColor[terrain]).appendTo('.map-div');
        }
    }
    renderMiniMap();
}

//渲染人物属性
function renderAttrs(){
    $('#level').html(`${data.level}(${Percentage(data.exp, data.race.getLevelUpExp())}%)`);
    $('#exp').html(data.exp);
    $('#levelUpExp').html(data.race.getLevelUpExp());
    $('#san').html(data.san);
    $('#maxSan').html(data.maxSan);
    $('#hp').html(data.hp);
    $('#maxHp').html(data.maxHp);
    $('#hunger').html(data.hunger);
    $('#weight').html(data.weight);
    $('#maxHunger').html(data.maxHunger);
    $('#water').html(data.water);
    $('#maxWater').html(data.maxWater);
    $('#maxWeight').html(data.maxWeight);
}

//根据名字过滤元素
let nameFilterEl = '';
$("#name-filer-el").bind("input propertychange",function(){
    nameFilterEl = $(this).val();
    renderMapElements(false, true)
});

//渲染果汁剩余效果时间
function renderGuozhi(){
    if(data.date < data.guozhiTime){
        $('#guozhi').html(`(🍺：${getTime(data.guozhiTime - data.date.getTime(), true)})`);
    }else{
        $('#guozhi').html('');
    }
}

//渲染地图上的元素，并同时渲染地图名和当前时间以及状态
function renderMapElements(isInit,start){
    if(conf.hideMapBtnBox || data.inDungeon){
        $('#map-btn-box').hide()
    }else{
        $('#map-btn-box').show()
    }
    if(data.dlcAutoKillMonster){
        $('#auto-kill-monster').show();
    }else{
        $('#auto-kill-monster').hide();
    }
    //渲染地图名
    $('#map-name').html(`${data.world.name}：${data.map[data.location[1]][data.location[0]]}[${data.location[0]},${data.location[1]}]`);
    //渲染时间
    $('#time').html(`${data.order > 1 ? `${data.order}周目` : ''}${data.date.format('yyyy年MM月dd日 hh:mm')}`);

    if(data.race.name.startsWith('弑魂叔')){
        $('#pre-sleep-time').html(`(上次睡觉：${getTime(data.date.getTime() - data.sleepTime, true)}前)`);
    }else{
        $('#pre-sleep-time').html('');
    }
    //渲染果汁剩余效果时间
    renderGuozhi();

    //渲染您人物状态
    renderAttrs()

    //判断是否有可拾取的物品
    if(data.world.mapElements[data.location.join()] && data.world.mapElements[data.location.join()].losts && data.world.mapElements[data.location.join()].losts.length > 0){
        $('#get-losts').show();
    }else{
        $('#get-losts').hide();
    }

    //判断安家相关
    if(data.world.home.location.length > 0){
        $('#create-home').hide();
        $('#go-home').hide();

        //如果当前位置是家所在，则可以选择回家
        if(data.world.home.location.join() === data.location.join()){
            $('#go-home').show();
        }
    }else{
        $('#create-home').show();
        $('#go-home').hide();
    }

    //判断是否可以一键采集
    if(festival){
        $('#festival').html(festival.name.replace('活动','')).show();
    }else{
        $('#festival').hide();
    }

    //判断是否显示节日按钮
    if(data.level - data.world.level[1] > 5){
        $('.gather-all').show();
    }else{
        $('.gather-all').hide();
    }

    //副本不能回家和安家和一键采集和移动
    if(data.inDungeon){
        $('.to-map').hide();
        $('#create-home').hide();
        $('#go-home').hide();
        $('.gather-all').hide();
    }else{
        $('.to-map').show();
    }

    //渲染埋藏炸药
    function renderExplosive(){
        //渲染埋藏炸药
        $('.body .explosive').remove();
        if(data.buryExplosive[data.world.name] && data.buryExplosive[data.world.name][data.location.join()]){
            let explosives = data.buryExplosive[data.world.name][data.location.join()];
            $('.body').append(`${Object.keys(explosives).map(e => `<div class="explosive">${e}*${explosives[e]}</div>`).join('')}`);
        }
    }
    renderExplosive();

    //渲染地图元素
    const point = data.location.join();//坐标

    //获取该坐标的地图元素
    let mapElement = data.world.mapElements[point];
    const mapName = data.map[data.location[1]][data.location[0]];//地图名

    //如果没获取到，则初始化
    if(!mapElement){
        mapElement = {
            elementList : [],//可采集元素列表
            monsterList : [],//怪物列表
            renderDates : {},//记录本次渲染的时间，用于下次渲染时判断是否需要更新地图元素
        };

        //初始化可采集的元素
        const elements = terrainElements[mapName] ? terrainElements[mapName].elements : {};
        //循环所有可采集元素配置
        for(const name in elements){
            const {num} = elements[name];//初始出现数量
            const [min,max] = num;
            const have = randomNum(min,max);//随机生成数量
            if(have > 0){
                for(let i = 0 ; i < have ; i++){
                    //创建一个实例
                    mapElement.elementList.push(elementCfgs[name].new({name}));
                }
            }

            //记录该元素的渲染时间，用于下次渲染时判断是否生成新元素
            mapElement.renderDates[name] = data.date;
        }
    }else{//如果已经到过该地块，则根据时间判断是否需要增加可采集元素
        //获取可采集元素配置
        const elements = terrainElements[mapName] ? terrainElements[mapName].elements : {};
        //循环所有可采集元素配置
        for(const name in elements){
            const day = elementCfgs[name].day;//生成时间
            if(!mapElement.renderDates[name]){
                mapElement.renderDates[name] = data.date;
            }
            if(day > 0){
                //只要没超时，就循环添加
                while(getPassDay(mapElement.renderDates[name],data.date) >= day){
                    //没超过上限，则添加
                    if(mapElement.elementList.filter(e => e.name === name).length <= elements[name].maxNum){
                        //创建一个实例
                        mapElement.elementList.push(elementCfgs[name].new({name}));
                        mapElement.renderDates[name] = addDay(mapElement.renderDates[name],day);
                    }else{//超过了上限，则不添加，并将时间设置为现在
                        mapElement.renderDates[name] = data.date;
                    }
                }
            }
        }
    }

    //根据地图元素列表，渲染地图元素
    $('.body .element').remove();
    if(!conf.showEleFilter || getFilterEleChecked().includes('资源')){
        mapElement.elementList.forEach(el => {
            if(nameFilterEl){
                //逗号分割查询内容
                let arr = [];
                if(nameFilterEl.includes(',')){
                    arr = nameFilterEl.split(',');
                }else if(nameFilterEl.includes('，')){
                    arr = nameFilterEl.split('，');
                }else{
                    arr.push(nameFilterEl);
                }

                //判断元素名字是否包含了任意一个查询内容
                let flag = false;
                arr.forEach(e => {
                    if(e && el.name.includes(e)){
                        flag = true;
                    }
                })

                //一个都没包含则不渲染
                if(!flag){
                    return;
                }
            }
            $('.body').append(`<div class="element" id="${el.id}">${el.name}(${el.num})</div>`);
        })
    }

    //如果是刚进入页面调用的，且不是新游戏的初始化，则不刷新地图怪物
    if(start && !isInit){

    }else{
        //获取当前时间
        const dayOrNight = getDayOrNight();
        //获取怪物配置
        const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
        mapElement.monsterList = [];
        const dlcAddProb = checkMonthName('骚动之月') ? 10 : checkMonthName('休眠之月') && !data.inDungeon && !data.race.challenge ? -10 : 0;
        //循环怪物配置
        for(const name in monsters){
            //副本不会刷新重复的怪物
            if(data.inDungeon && dungeons[data.world.name].type === 1 && data.dungeonKilled && data.dungeonKilled.indexOf(name) !== -1){
                continue;
            }

            let prob = monsters[name].prob + dlcAddProb + (data.sweetPotion ? 10 : 0);//出现概率

            //不在副本中且开启了作息时间DLC，则不在攻击时间的怪物不刷新
            if(!data.inDungeon && data.dlcSleepTime && monsters[name].atkTime !== '全天' && dayOrNight !== monsters[name].atkTime){
                prob = 0;
            }
            if(randomNum(1,100) <= prob){
                if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1]){
                    mapElement.monsterList.push(`${name}`);
                }

            }
        }
    }

    //渲染副本出口
    $('.body .leave-dungeon').remove();
    if(data.inDungeon){
        $('.body').html('');
        $('.body').append(`<div class="leave-dungeon">离开</div>`);

        //渲染无限副本内容
        if(dungeons[data.world.name] && dungeons[data.world.name].type === 2){
            if(data.dungeonLevel == null){
                data.dungeonLevel = 1;
            }

            if(!data.dungeonKilled){
                data.dungeonKilled = [];
            }
            if(data.dungeonKilled.length > 0){
                mapElement.monsterList = [data.dungeonKilled[0]];
            }
            mapElement.monsterList = mapElement.monsterList.map(e => `${e}${e.includes(`(LV${data.dungeonLevel})`) ? '' : `(LV${data.dungeonLevel})`}`);
        }
    }

    //根据地图怪物列表，渲染地图怪物
    $('.body .monster').remove();
    $('.body .wandering-merchant').remove();
    $('.body .inspiration-struck').remove();
    let mlist = mapElement.monsterList;
    if(conf.monsterSort){
        const sortNames = Object.keys(data.killedMonster).sort((a,b) => data.killedMonster[a] - data.killedMonster[b]);
        mlist = mlist.sort((a,b) => sortNames.indexOf(b.split('(')[0]) - sortNames.indexOf(a.split('(')[0]));
    }
    mlist.filter(e => monsterCfgs[e.split('(')[0]]).forEach(el => {
        const name = el.split('(')[0];
        const lv = conf.showMonsterLevel ? `(LV${monsterCfgs[name].level})` : '';

        if(conf.legendMsg && monsterCfgs[name].type === '传说' && !data.inDungeon){
            $('.alert-win').show().find('.alert-win-title').html('发现传说怪')
        }
        if(conf.eliteMsg && monsterCfgs[name].type === '精英' && !data.inDungeon){
            $('.alert-win').show().find('.alert-win-title').html('发现精英怪')
        }
        if(conf.mythMsg && monsterCfgs[name].type === '神话' && !data.inDungeon){
            $('.alert-win').show().find('.alert-win-title').html('发现神话怪')
        }


        if(!conf.showEleFilter || getFilterEleChecked().includes('怪物')){
            if(nameFilterEl){
                //逗号分割查询内容
                let arr = [];
                if(nameFilterEl.includes(',')){
                    arr = nameFilterEl.split(',');
                }else if(nameFilterEl.includes('，')){
                    arr = nameFilterEl.split('，');
                }else{
                    arr.push(nameFilterEl);
                }

                //判断元素名字是否包含了任意一个查询内容
                let flag = false;
                arr.forEach(e => {
                    if(e && name.includes(e)){
                        flag = true;
                    }
                })

                if(!flag){
                    return;
                }
            }
            $('.body').append(`<div class="monster" data-name="${name}">${el}${el.indexOf('(') !== -1 ? '' : lv}${monsterCfgs[name].type ? `(${monsterCfgs[name].type})` : ''}</div>`);
        }
    })

    //不是副本才渲染以下内容
    if(!data.inDungeon){
        //渲染地图出口
        $('.body .to-world').remove();
        //如果是地图出口
        if((data.nextPoint && point === data.nextPoint.join()) || (data.prePoint && point === data.prePoint.join())){
            const html = `<div class="to-world" data-index="${data.nextPoint && point === data.nextPoint.join() ? data.worldIndex + 1 : data.worldIndex - 1}">前往${mapName}</div>`;
            //如果是下一个地图的入口，则判断是否战胜守关BOSS，没战胜则渲染守关BOSS
            if(data.nextPoint && point === data.nextPoint.join()){
                if(data.world.pass){//渲染下一个地图的出口
                    $('.body').append(html);
                }else if(!conf.showEleFilter || getFilterEleChecked().includes('怪物')){//渲染守关BOSS
                    $('.body').append(`<div class="monster" data-name="${data.world.worldBoss}">${data.world.worldBoss}${monsterCfgs[data.world.worldBoss].type ? `(${monsterCfgs[data.world.worldBoss].type})` : ''}</div>`);
                }
            }else{
                $('.body').append(html);
            }
        }

        //渲染神殿
        if(!data.temples){
            data.temples = {};
        }
        if(!data.temples[data.worldIndex]){
            data.temples[data.worldIndex] = {};
        }
        const temple = data.temples[data.worldIndex][point];
        if(temple){
            $('.body').html(`<div class="temple-map">${temple.name}</div>`);
            renderExplosive();
        }else{
            $('.body .temple-map').remove();
        }

        //渲染神话怪
        if(!conf.showEleFilter || getFilterEleChecked().includes('怪物')){
            const myths = data.world.mythMonster.filter(e => e.location.join() === point && !e.deathTime);
            if(myths.length > 0){
                if(conf.mythMsg && !data.inDungeon){
                    $('.alert-win').show().find('.alert-win-title').html('发现神话怪');
                }
                myths.forEach(e => {
                    if(nameFilterEl && !e.name.includes(nameFilterEl)){
                        return;
                    }
                    $('.body').append(`<div class="monster" data-name="${e.name}">${e.name}${monsterCfgs[e.name].type ? `(${monsterCfgs[e.name].type})` : ''}</div>`);
                })
            }

            //渲染最终BOSS
            if(data.maps[data.worldIndex].endTerrain === mapName){
                const name = data.maps[data.worldIndex].endBoss;
                $('.body').append(`<div class="monster" data-name="${name}">${name}${monsterCfgs[name].type ? `(${monsterCfgs[name].type})` : ''}</div>`);
            }
        }

        //渲染流浪商人，每个月10号出现
        if(data.date.format('dd') === '10' && !data.dlcOriginal){
            //商品列表
            const goodList = [{
                name : '牵引卷轴',
                point : 1
            },{
                name : '世界药剂',
                point : 1
            },{
                name : '世界庇佑',
                point : 10
            },{
                name : '溶解药水',
                point : 10
            },{
                name : '藏宝图',
                point : 10
            },{
                name : '大灾变',
                point : 50
            },{
                name : '观察之眼',
                point : 100
            },{
                name : '洗涤灵泉',
                point : 500
            },{
                name : '时光砂砾',
                point : 500
            },{
                name : '扭曲怀表',
                point : 1000
            }];

            if(!data.world.WanderingMerchantShop || data.world.WanderingMerchantShop.date !== data.date.format('yyyy-MM-dd')){
                data.world.WanderingMerchantShop = {
                    date : data.date.format('yyyy-MM-dd'),
                    goods : goodList
                };
            }
            if(isInHome()){
                $('.body').append(`<div class="wandering-merchant" onclick="javascript:renderWanderingMerchantShop();">流浪商人</div>`);
            }
        }else{
            data.world.WanderingMerchantShop = null;
        }

        //渲染灵感触动
        if(!(start && !isInit) && verification(false)){
            if(conf.insMsg){
                $('.alert-win').show().find('.alert-win-title').html('你的灵感被触动')
            }
            $('.body').append(`<div class="inspiration-struck" onclick="javascript:inspirationStruck();">灵感触动</div>`);
        }

        //渲染藏宝图
        $('.body .excavate').remove();
        if(!data.treasureMaps){
            data.treasureMaps = {};
        }
        if(data.treasureMaps[data.worldIndex]){
            const treasureMap = data.treasureMaps[data.worldIndex].filter(e => e.location.join() === data.location.join());
            $('.body').append(treasureMap.map(e => `<div class="excavate">宝藏</div>`).join(''))
        }

        $('.body .npc').remove();
        //初始化NPC
        initNpc();
        if(getFilterEleChecked().includes('NPC') && data.world.npcs){
            //渲染NPC
            const location = data.location.join();
            data.world.npcs.filter(e => e.location.join() === location).forEach(e => {
                if(npcCfg.sole[e.type]){
                    e.showMapLocation = true;
                }
                $('.body').append(`<div class="npc" data-id="${e.id}">${e.name}${e.showCamp ? `[${e.camp}]` : ''}</div>`)
            })
        }
    }

    //渲染养成角色
    $('.body .edu').remove();
    if(data.edu && (data.inDungeon ? data.edu.follow : (isInHome() || data.edu.follow))){
        if(!data.edu.items){
            data.edu.items = [];
        }
        if(!data.edu.maked){
            data.edu.maked = [];
        }

        let canShow = true;
        if(data.edu.hunger <= 0){
            says([`你发现了${data.edu.name}的尸体，她似乎已经饿死了`]);
            data.edu = null;
            canShow = false;
            save();
        }else if(data.edu.water <= 0){
            says([`你发现了${data.edu.name}的尸体，她似乎已经渴死了`]);
            data.edu = null;
            canShow = false;
            save();
        }else if(data.edu.friendliness <= 0){
            says([`${data.edu.name}不见了，你无论在哪里都找不到她，她似乎已经离开了`]);
            data.edu = null;
            canShow = false;
            save();
        }else if(data.edu.hunger <= eduCfgs.needNum && !data.edu.saidNeedFood){
            says([`肚子饿了……`]);
            data.edu.saidNeedFood = true;
        }else if(data.edu.water <= eduCfgs.needNum && !data.edu.saidNeedWater){
            says([`好渴……`]);
            data.edu.saidNeedWater = true;
        }
        if(canShow){
            $('.body').append(`<div class="edu" onclick="javascript:renderEdu();">${data.edu.name}</div>`);
        }
    }

    //数据存入地图中
    data.world.mapElements[point] = mapElement;
}

//渲染小地图
function renderMiniMap(){
    const xarr = [data.location[0] - 3, data.location[0] - 2, data.location[0] - 1, data.location[0], data.location[0] + 1, data.location[0] + 2, data.location[0] + 3];
    const yarr = [data.location[1] - 3, data.location[1] - 2, data.location[1] - 1, data.location[1], data.location[1] + 1, data.location[1] + 2, data.location[1] + 3];
    let html = '';

    yarr.forEach(y => {
        xarr.forEach(x => {
            try {
                const el = data.map[y] && data.map[y][x];
                if(!el){
                    html += `<div class="map none-map"></div>`;
                    return;
                }
                if(!data.world.showMap[x + ',' + y]){
                    if(data.showMythDay === new Date(data.date).format('yyyyMMdd') || data.race.name.startsWith('寒影')){
                        let flag = false;
                        data.world.mythMonster.forEach(e => {
                            if(e.location.join() === [x,y].join()){
                                flag = true;
                            }
                        })

                        if(flag){
                            html += `<div class="map myth-monster">${el}</div>`;
                            return;
                        }
                    }
                    html += `<div class="map"></div>`;
                    return;
                }
                let cls = '';

                //渲染当前位置
                if(data.location.join() === [x,y].join()){
                    cls += ' location-map';
                }

                //渲染家
                if(data.world.home && data.world.home.location && data.world.home.location.length > 0 && data.world.home.location.join() === [x,y].join()){
                    cls += ' home-map';
                }

                //渲染地图出口
                if((data.nextPoint && data.nextPoint.join() === [x,y].join()) || (data.prePoint && data.prePoint.join() === [x,y].join()) || (data.maps[data.worldIndex].endTerrain && data.endBoss && data.endBoss === [x,y].join())){
                    cls += ' outer-map';
                }

                //渲染NPC所在
                data.world.npcs && data.world.npcs.filter(e => (data.race.name.startsWith("天使") && e.camp === getPlayerCamp()) || e.showMapLocation).forEach(e => {
                    if(e.location.join() === [x,y].join()){
                        if(data.race.name.startsWith("天使") && e.camp === getPlayerCamp()){
                            if(npcCfg.sole[e.type]){
                                cls += ' map-cap-shop';
                            }else{
                                cls += ' tianshi-map-npc';
                            }
                        }else{
                            if(npcCfg.sole[e.type]){
                                cls += ' map-cap-shop';
                            }else{
                                cls += ' map-npc';
                            }
                        }
                    }
                })

                //渲染神话怪所在
                if(data.showMythDay === new Date(data.date).format('yyyyMMdd') || data.race.name.startsWith('寒影')){
                    data.world.mythMonster.forEach(e => {
                        if(e.location.join() === [x,y].join()){
                            cls += ' myth-monster';
                        }
                    })
                }

                //渲染神殿
                Object.keys(data.temples[data.worldIndex]).forEach(e => {
                    if(e === [x,y].join()){
                        cls += ' temple-map-ele';
                        if(data.temples[data.worldIndex][e] && data.temples[data.worldIndex][e].deity === '水之女神'){
                            cls += ' deity-water';
                        }
                    }
                })

                html += `<div class="map ${cls}" point="${x},${y}" style="color: ${terrainColor[el]};">${el}</div>`;
            }catch (e) {
                console.error(e)
                html += `<div class="map none-map"></div>`;
            }
        })
    })
    $('.mini-map>div').html(html);
}

//渲染可前往的地图
function renderCanToMap(){
    //渲染小地图
    renderMiniMap();

    //副本不渲染可前往的地图
    if(data.inDungeon){
        return;
    }

    $('.now').html(data.map[data.location[1]][data.location[0]]);
    //左
    if(data.location[0] > 0){
        const y = data.location[1];
        const x = data.location[0] - 1;
        const point = data.map[y][x];
        const canShow = !data.dlcKeepDark ? true : data.world.showMap[`${x},${y}`] == '1';

        $('.left').html(point).css('color' , !canShow ? '' : terrainColor[point] || '').attr('data-point',[data.location[0] - 1,data.location[1]].join());
        if(!canShow){
            $('.left').addClass('dark-dlc-cant-to');
        }else{
            $('.left').removeClass('dark-dlc-cant-to');
        }
    }else{
        $('.left').html('').attr('data-point','');
    }

    //右
    if(data.location[0] < xnum - 1){
        const y = data.location[1];
        const x = data.location[0] + 1;
        const point = data.map[y][x];
        const canShow = !data.dlcKeepDark ? true : data.world.showMap[`${x},${y}`] == '1';

        $('.right').html(point).css('color' , !canShow ? '' : terrainColor[point] || '').attr('data-point',[data.location[0] + 1,data.location[1]].join());
        if(!canShow){
            $('.right').addClass('dark-dlc-cant-to');
        }else{
            $('.right').removeClass('dark-dlc-cant-to');
        }
    }else{
        $('.right').html('').attr('data-point','');
    }

    //上
    if(data.location[1] > 0){
        const y = data.location[1] - 1;
        const x = data.location[0];
        const point = data.map[y][x];
        const canShow = !data.dlcKeepDark ? true : data.world.showMap[`${x},${y}`] == '1';

        $('.top').html(point).css('color' , !canShow ? '' : terrainColor[point] || '').attr('data-point',[data.location[0],data.location[1] - 1].join());
        if(!canShow){
            $('.top').addClass('dark-dlc-cant-to');
        }else{
            $('.top').removeClass('dark-dlc-cant-to');
        }
    }else{
        $('.top').html('').attr('data-point','');
    }

    //下
    if(data.location[1] < ynum - 1){
        const y = data.location[1] + 1;
        const x = data.location[0];
        const point = data.map[y][x];
        const canShow = !data.dlcKeepDark ? true : data.world.showMap[`${x},${y}`] == '1';

        $('.bottom').html(point).css('color' , !canShow ? '' : terrainColor[point] || '').attr('data-point',[data.location[0],data.location[1] + 1].join());
        if(!canShow){
            $('.bottom').addClass('dark-dlc-cant-to');
        }else{
            $('.bottom').removeClass('dark-dlc-cant-to');
        }
    }else{
        $('.bottom').html('').attr('data-point','');
    }

    //渲染家
    $('.to-map>div').removeClass('home-map');
    if(data.world.home && data.world.home.location && data.world.home.location.length > 0){
        $(`.to-map>div[data-point='${data.world.home.location.join()}']`).addClass('home-map');
    }

    //渲染地图出口
    $('.to-map>div').removeClass('outer-map');
    if(data.nextPoint && (!data.dlcKeepDark ? true : data.world.showMap[`${data.nextPoint.join()}`] == '1')){
        $(`.to-map>div[data-point='${data.nextPoint.join()}']`).addClass('outer-map');
    }
    if(data.prePoint && (!data.dlcKeepDark ? true : data.world.showMap[`${data.prePoint.join()}`] == '1')){
        $(`.to-map>div[data-point='${data.prePoint.join()}']`).addClass('outer-map');
    }
    if(data.maps[data.worldIndex].endTerrain && data.endBoss && (!data.dlcKeepDark ? true : data.world.showMap[data.endBoss] == '1')){
        $(`.to-map>div[data-point='${data.endBoss}']`).addClass('outer-map');
    }

    //渲染NPC所在
    $('.to-map>div').removeClass('map-npc');
    $('.to-map>div').removeClass('map-cap-shop');
    data.world.npcs && data.world.npcs.filter(e => e.showMapLocation).forEach(e => {
        if(npcCfg.sole[e.type]){
            $(`.to-map>div[data-point='${e.location.join()}']`).addClass('map-cap-shop');
        }else{
            $(`.to-map>div[data-point='${e.location.join()}']`).addClass('map-npc');
        }
    })

    //渲染神话怪所在
    $('.to-map>div').removeClass('myth-monster');
    if(data.showMythDay === new Date(data.date).format('yyyyMMdd') || data.race.name.startsWith('寒影')){
        data.world.mythMonster.forEach(e => {
            if(!data.dlcKeepDark ? true : data.world.showMap[`${e.location.join()}`] == '1'){
                $(`.to-map>div[data-point='${e.location.join()}']`).addClass('myth-monster');
            }
        })
    }

    //渲染神殿
    $('.to-map>div').removeClass('temple-map-ele');
    $('.to-map>div').removeClass('deity-water');
    Object.keys(data.temples[data.worldIndex]).forEach(e => {
        if(!data.dlcKeepDark ? true : data.world.showMap[e] == '1'){
            $(`.to-map>div[data-point='${e}']`).addClass('temple-map-ele');
            if(data.temples[data.worldIndex][e] && data.temples[data.worldIndex][e].deity === '水之女神'){
                $(`.to-map>div[data-point='${e}']`).addClass('deity-water');
            }
        }
    })

}

//渲染快捷键
function renderKs(){
    if(data.ks){
        //渲染快捷方式
        $('.ks').html(data.ks.map((e,i) => e ? `<div data-index="${i}" class="ks-item">${e.length > 2 ? (e.startsWith('技能石') ? e.replace('技能石：','').substr(0,2) : e.substr(0,2)) : e}</div>` : `<div data-index="${i}">空</div>`))
    }
}

//渲染背包
let showItemType = 'all';
function renderBag(){
    $('.bag-items').html('');
    //渲染属性
    let lastName = '';
    if(data.race.name){
        if(data.race.name.startsWith('神性史莱姆')){
            lastName = `<font color="#2196f3">(神性：${data.divinity})</font>`;
        }
        if(data.race.name.startsWith('亡灵族') || data.race.name.startsWith('巫妖')){
            lastName = `<font color="#2196f3">(灵魂：${data.soul})</font>`;
        }
        if(data.race.name.startsWith('人类-法师') || data.race.name.startsWith('人类-元素师')){
            lastName = `<font color="#2196f3">(精神：${data.spi})</font>`;
        }
        if(data.race.name.startsWith('地球人-佛门') || data.race.name.startsWith('地球人-活佛')){
            lastName = `<font color="#2196f3">(功德/<font color="red">善业</font>：${data.merit}/<font color="red">${data.karma}</font>)</font>`;
        }
        if(data.race.name.startsWith('史莱姆')){
            lastName = `<font color="#2196f3">(粘液：${data.mucus})</font>`;
        }
        if(data.race.name.startsWith('操脑蛛') && data.control){
            lastName = `<font color="#2196f3">(${data.control.showName || data.control.name})</font>`;
        }
        if(data.race.name.startsWith('断肠人')){
            lastName = `<font color="#2196f3">(${data.soulName})</font>`;
        }
    }

    renderKs();

    $('.bag-lv').html(`${data.level}${lastName}${data.bind ? `<font color="#fb00ff">(${data.bind.race})</font>` : ''}`);
    $('.bag-race').html(data.race.name);
    $('.bag-exp').html(data.exp);
    $('.bag-level-up-exp').html(data.race.getLevelUpExp());
    $('.bag-attr-point').html(data.attrPoint + (data.consumePoint ? `(${data.consumePoint < 0 ? '+' : ''}${-data.consumePoint}<span onclick="javascript:says(['括号里显示的是额外属性点，例如你吃了1个神话之力，额外属性点就是+3，吃了10个就是+30，新人难度每个神话之力是+10。括号里的属性点不能使用，仅仅是让你知道，你有多少额外属性点。额外属性点是会带入下周目的，无论正负'])">🔍</span>)` : ''));
    $('.weight').html(data.weight);
    $('.max-weight').html(data.maxWeight);
    $('.bag-hp').html(data.hp);
    $('.bag-max-hp').html(data.maxHp);
    $('.bag-san').html(data.san);
    $('.san-status').html(data.zhc ? `<font color="#2196f3">(剑仙)</font>` : '')
    $('.bag-max-san').html(data.maxSan);
    $('.bag-hunger').html(data.hunger);
    $('.bag-max-hunger').html(data.maxHunger);
    $('.bag-water').html(data.water);
    $('.bag-max-water').html(data.maxWater);
    $('.bag-atk').html(`${data.atk}${data.weapon ? ` <font color="#2196f3">(+${data.weapon.getAtk(data.weapon)})</font>` : ''}`);
    $('.bag-def').html(`${data.def}`);
    $('.bag-camp').html(`${getPlayerCamp()}(${data.evil < 0 ? -data.evil : data.evil})`)
    const suck = (data.weapon && data.weapon.suck ? data.weapon.suck : 0) + (data.armor && data.armor.suck ? data.armor.suck : 0) + (data.suck || 0);
    $('.bag-suck').html(`${suck}%<font class="blue" onclick="javascript:$('.alert-win').show().find('.alert-win-title').html(explains['吸血'])">(点击查看]</font>`);
    $('.bag-reduceHart').html(`${parseInt(parseFloat2Fiexd(data.reduceHart || 0) * 100)}%`);
    $('.bag-spd').html(`${data.spd}%`);

    $('.bag-weapon').html(`武器：${data.weapon ? `<span class=" ${data.weapon.jp ? 'sponsor-name' : ''} ${data.weapon.quality ? `${qualityAttr[data.weapon.quality].color}` : ''}">${data.weapon.showName || data.weapon.name}(${data.weapon.endurance})${data.weapon.hole.length > 0 ? `{${data.weapon.hole.length}}` : ''}</span>` : '无'}`);
    $('.bag-armor').html(`护甲：${data.armor ? `<span class=" ${data.armor.jp ? 'sponsor-name' : ''} ${data.armor.quality ? `${qualityAttr[data.armor.quality].color}` : ''}">${data.armor.showName || data.armor.name}(${data.armor.endurance})${data.armor.hole.length > 0 ? `{${data.armor.hole.length}}` : ''}</span>` : '无'}`);
    $('.bag-bag').html(`背包：${data.bagEquip ? `<span class=" ${data.bagEquip.jp ? 'sponsor-name' : ''} ${data.bagEquip.quality ? `${qualityAttr[data.bagEquip.quality].color}` : ''}">${data.bagEquip.showName || data.bagEquip.name}</span>` : '无'}`);
    $('.bag-mount').html(`坐骑：${data.mount ? `<span class=" ${data.mount.jp ? 'sponsor-name' : ''} ${data.mount.quality ? `${qualityAttr[data.mount.quality].color}` : ''}">${data.mount.showName || data.mount.name}</span>` : '无'}`);

    $('.add-attr').removeClass('no-add');
    if(data.attrPoint <= 0){
        $('.add-attr').addClass('no-add');
    }
    if(data.race.getNoHunger()){
        $('.add-attr[data-attr=hunger]').hide();
        $('.add-attr[data-attr=water]').hide();
    }else{
        $('.add-attr[data-attr=hunger]').show();
        $('.add-attr[data-attr=water]').show();
    }
    if(data.race.name.startsWith('戏命师')){
        $('.add-attr[data-attr=atk]').hide();
    }else{
        $('.add-attr[data-attr=atk]').show();
    }
    if(data.race.name.startsWith('操脑蛛')){
        $('.add-attr[data-attr=hp]').hide();
    }else{
        $('.add-attr[data-attr=hp]').show();
    }
    if(data.race.name.startsWith('巫妖')){
        $('.add-level').show();
        if(data.exp >= data.race.getLevelUpExp()){
            $('.add-level').removeClass('no-add');
        }else{
            $('.add-level').addClass('no-add');
        }
    }else{
        $('.add-level').hide();
    }

    //顺便渲染一下主页面的属性
    renderAttrs();

    //渲染背包物品
    let showItems = [...data.bag];

    //只显示装备
    if(showItemType === 'equip'){
        showItems = showItems.filter(e => {
            return e.isWeapon || e.isArmor || e.isShield || e.addWeight || e.isMount;
        });
    }

    //只显示可使用
    if(showItemType === 'canUse'){
        showItems = showItems.filter(e => {
            return e.canUse;
        });
    }

    //只显示其他
    if(showItemType === 'other'){
        showItems = showItems.filter(e => {
            return !e.isWeapon && !e.isArmor && !e.isShield && !e.canUse;
        });
    }

    showItems.forEach(e => {
        $('.bag-items').append(`<div id="${e.id}" class="bag-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''} ${e.canUse ? 'can-use' : ''} ${(data.armor && data.armor.id === e.id) || (data.bagEquip && data.bagEquip.id === e.id) || (data.mount && data.mount.id === e.id) || (data.weapon && data.weapon.id === e.id) ? 'equiped' : ''}">${e.isLock ? `<font style="position: absolute;left: 10px;top:3px;-webkit-text-fill-color: red;" color="red">🔒︎</font>` : ``}${e.showName || e.name}${e.onlyOne ? `(${e.endurance})${e.hole.length > 0 ? `{${e.hole.length}}` : ''}` : ''}<br>x${e.quantity}</div>`);
    })
}

//渲染制作栏
let thisLevel = 0;
let thisNeed = 0;
let val = 10;
$('.work .select-num-input').change(function(){
    val = $('.work .select-num-input').val();
    renderWorkList(thisLevel || 0, thisNeed);
    renderKitchen();
})
$('.kitchen .select-num-input').change(function(){
    val = $('.kitchen .select-num-input').val();
    renderWorkList(thisLevel || 0, thisNeed);
    renderKitchen();
})

let workFilter = '';
$(".recipe-search input").bind("input propertychange",function(){
    workFilter = $(this).val();
    renderWorkList(thisLevel, thisNeed);
});

//获取可用的配方
function getCanRecipes(level, need){
    //可用的配方
    const canRecipes = {};

    //黑暗侵蚀DLC加入火把
    if(data.dlcKeepDark){
        canRecipes['火把'] = createRecipesCfg({'树枝' : 2, '纤维' : 2, '木材' : 1, '燧石' : 1});
    }

    //加入种族技能
    if(!need || need == 'undefined'){
        Object.keys(data.race.skills).forEach(e => {
            canRecipes[`技能石：${e}`] = data.race.skills[e];
        })


        //加载武器技能
        if(data.weapon && elementCfgs[data.weapon.name].skills){
            Object.keys(elementCfgs[data.weapon.name].skills).forEach(e => {
                canRecipes[`技能石：${e}`] = elementCfgs[data.weapon.name].skills[e];
            })
        }
        //加载护甲技能
        if(data.armor && elementCfgs[data.armor.name].skills){
            Object.keys(elementCfgs[data.armor.name].skills).forEach(e => {
                canRecipes[`技能石：${e}`] = elementCfgs[data.armor.name].skills[e];
            })
        }
        //加载坐骑技能
        if(data.mount && elementCfgs[data.mount.name].skills){
            Object.keys(elementCfgs[data.mount.name].skills).forEach(e => {
                canRecipes[`技能石：${e}`] = elementCfgs[data.mount.name].skills[e];
            })
        }
    }
    //加载种族专属配方
    recipes = {...data.race.recipes, ...recipes};

    //循环所有配方
    Object.keys(recipes).forEach(key => {
        //如果满足设施要求，则直接加入可用列表，无视级别要求
        if(recipes[key].need && recipes[key].need === need){
            canRecipes[key] = recipes[key];
        }else if(level >= recipes[key].level){//如果配方的制造级别小于等于本次展开页面的等级，则加入可用列表
            canRecipes[key] = recipes[key];
        }
    })

    return canRecipes;
}

//显示工作台
function showWorkWin(){
    $('.work-item-list div').removeClass('active');
    $('.work .work-item-recipes').html('');
    $('.work').show();
}

function renderWorkList(level, need){
    const active = $('.work-item-list div.active').attr('data-text');
    thisLevel = level;
    thisNeed = need;
    $('.select-num-input').attr({
        'data-level' : level,
        'data-need' : need
    }).val(val);
    $('.work .work-item-list').html('');
    //可用的配方
    const canRecipes = getCanRecipes(level, need);

    //循环所有可用配方
    Object.keys(canRecipes).filter(e => workFilter ? e.includes(workFilter) : true).forEach(key => {
        if(need === '天赋祭坛' && !key.startsWith(data.race.name)){
            return;
        }

        const items = canRecipes[key].items;
        //可以做几个
        let minNum = -1;

        Object.keys(items).forEach(item => {
            //获取持有物品，当在家所在的地块时，允许使用仓库的物品
            const itemNum = getNumByBag(item, data.location.join() === data.world.home.location.join());
            const needNum = items[item];

            let can = parseInt(itemNum / needNum);
            if(can < 0){
                can = 0;
            }
            if(minNum == -1){
                minNum = can;
            }else if(minNum > can){
                minNum = can;
            }
        })

        $('.work .work-item-list').append(`<div class="one-line ${minNum > 0 ? 'success' : ''}" data-text="${key}" data-level="${level}" data-need="${need}">${key}${minNum > 0 ? `(${minNum})` : ''}</div>`);
    })

    if(active){
        $(`.work-item-list div[data-text=${active}]`).click();
    }
}
//制造栏点击物品
$('.work-item-list').on('click','div',function(){
    const key = $(this).attr('data-text');
    const level = parseInt($(this).attr('data-level') || 0);
    const need = $(this).attr('data-need');
    $('.work-item-list div').removeClass('active');
    $(this).addClass('active');

    //可用的配方
    const canRecipes = getCanRecipes(level, need);
    const items = canRecipes[key].items;
    let canMake = true;
    let canMakeTen = true;

    let html = '';
    html += `<div class="recipe">`;
    const strs = key.split('-');
    html += `<div class="recipe-name">${key}<span class="to-cybernet" data-name="${isNaN(strs[1]) ? key : strs[0]}">🔍</span>*${canRecipes[key].getNum}</div>`;
    html += `<div class="recipe-items">`;

    //循环所有所需物品
    const num = parseInt($('.select-num-input').val())
    Object.keys(items).forEach(item => {
        //获取持有物品，当在家所在的地块时，允许使用仓库的物品
        const itemNum = getNumByBag(item, data.location.join() === data.world.home.location.join());
        const needNum = items[item];
        if(itemNum < needNum){
            canMake = false;
            canMakeTen = false
        }else if(itemNum < needNum * num){
            canMakeTen = false;
        }

        html += `<div class="recipe-item ${itemNum >= needNum ? 'recipe-item-have' : 'recipe-item-no'}">${item}<span class="to-cybernet" data-name="${item}">🔍</span>：${itemNum}/${needNum}</div>`;
    })
    html += `</div>`;
    html += `<div class="make ${canMake ? 'can-make' : ''}" data-name="${key}" data-level="${level}" data-need="${need}" data-num="1">制造</div>`;
    html += `<div class="make make-ten ${canMakeTen ? 'can-make' : ''}" data-name="${key}" data-level="${level}" data-need="${need}" data-num="${num}">批量</div>`;
    html += `</div>`;
    $('.work .work-item-recipes').html(html);
})

//渲染锻造页面
function renderForgeList(){
    const rates = getQualityRate();
    $('.forge-title').html(`锻造熟练度：${data.forgeExp}`);
    $('.forge-rate').html(`锻造概率：<font class="${qualityAttr[1].color}"> 优秀（${rates[1] / 10}%）</font>/<font class="${qualityAttr[2].color}"> 精良（${rates[2] / 10}%）</font>/<font class="${qualityAttr[3].color}"> 传说（${rates[3] / 10}%）</font>/<font class="${qualityAttr[4].color}"> 神话（${rates[4] / 10}%）</font>`);
    $('.forge-body').html('');

    //循环所有可用配方
    const keys = Object.keys(forgeRecipes);
    data.forgeRecipes = data.forgeRecipes.sort((a,b) => elementCfgs[b].level - elementCfgs[a].level);
    data.forgeRecipes.forEach(key => {
        if(!key || !forgeRecipes[key]){
            return;
        }
        const items = forgeRecipes[key].items;
        let canMake = true;

        let html = '';
        html += `<div class="recipe">`;
        html += `<div class="recipe-name">${key}<span class="to-cybernet" data-name="${key}">🔍</span></div>`;
        html += `<div class="recipe-items">`;

        //循环所有所需物品
        Object.keys(items).forEach(item => {
            //获取持有物品，当在家所在的地块时，允许使用仓库的物品
            const itemNum = getNumByBag(item, data.location.join() === data.world.home.location.join());
            const needNum = items[item];
            if(itemNum < needNum){
                canMake = false;
            }

            html += `<div class="recipe-item ${itemNum >= needNum ? 'recipe-item-have' : 'recipe-item-no'}">${item}：${itemNum}/${needNum}</div>`;
        })

        html += `</div>`;
        html += `<div class="forge-make ${canMake || data.race.name.startsWith('星灵-宇') ? 'forge-can-make' : ''}" data-name="${key}">锻造${elementCfgs[key].quality ? `<br>品质：${qualityAttr[elementCfgs[key].quality].name}` : ''}</div>`;
        html += `</div>`;
        $('.forge-body').append(html);
    })
}

//渲染战斗页面
function renderBattlePage(){
    $('.show-auto-battle').html(`自动攻击：${conf.showAutoBattle ? '已开启' : '已关闭'}`);
    $('.keep-atk').html(`连续攻击：${conf.keepAtk ? '已开启' : '已关闭'}`);
    //顺便刷新一下主页的属性
    renderAttrs();
    if(data.battleMonster){
        let type = $('.weapon-types>div.active').html();

        //渲染观察之眼
        if(getNumByBag('观察之眼')){
            $('.battle').addClass('show-attr');
            $('.monster-battle-attrs span:eq(0)').html(data.battleMonster.atk);
            $('.monster-battle-attrs span:eq(1)').html(data.battleMonster.def);
            $('.monster-battle-attrs span:eq(2)').html(data.battleMonster.suck || 0);
            $('.player-battle-attrs span:eq(0)').html(data.atk);
            $('.player-battle-attrs span:eq(1)').html(data.def);
            $('.player-battle-attrs span:eq(2)').html((data.weapon && data.weapon.suck ? data.weapon.suck : 0) + (data.armor && data.armor.suck ? data.armor.suck : 0) + (data.suck || 0));
        }else{
            $('.battle').removeClass('show-attr');
        }

        //渲染属性信息
        $('.monster-attrs .battle-attr-name').html(`${data.battleMonster.showName || data.battleMonster.name}<span class="to-cybernet" data-name="${data.battleMonster.name}">🔍</span>`);
        $('.monster-attrs .battle-attr-hp').css('width',`${Percentage(data.battleMonster.hp < 0 ? 0 : data.battleMonster.hp, data.battleMonster.maxHp)}%`);
        $('.monster-attrs .battle-attr-hp-number').html(`${data.battleMonster.hp}${data.battleMonster.shield > 0 ? `(${data.battleMonster.shield})` : ''}/${data.battleMonster.maxHp}`);
        $('.player-attrs .battle-attr-hp').css('width',`${Percentage(data.hp < 0 ? 0 : data.hp, data.maxHp)}%`);
        $('.player-attrs .battle-attr-hp-number').html(`${data.hp}${data.shield > 0 ? `(${data.shield})` : ''}/${data.maxHp}`);

        const self = getName() === getCode() ? '我' : getName();

        if(data.race.name.startsWith('扑克人')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[剩余牌数：${data.battleMonster.poker || 0}]</font>`);
        }else if(data.race.name.startsWith('史莱姆')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[粘液：${data.mucus || 0}]</font>`);
        }else if(data.race.name.startsWith('巫妖')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[灵魂：${data.soul || 0}]</font>`);
        }else if(data.race.name.startsWith('水之神裔')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[水分：${data.water || 0}(${`${Percentage(data.water, data.maxWater)}`.split('.')[0]}%)]</font>`);
        }else if(data.race.name.startsWith('神性史莱姆')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[神性：${data.divinity || 0}]</font>`);
        }else if(data.race.name.startsWith('戏命师')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[命运硬币：${getNumByBag('命运硬币') || 0}]</font>`);
        }else if(data.race.name.startsWith('机械族')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[碎片：${getNumByBag('机械碎片') || 0}；核心：${getNumByBag('机械核心') || 0}]</font>`);
        }else if(data.race.name.startsWith('人类-法师') || data.race.name.startsWith('人类-元素师')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[精神：${data.spi || 0}]</font>`);
        }else if(data.race.name.startsWith('地球人-佛门') || data.race.name.startsWith('地球人-活佛')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[功德：${data.merit || 0}]</font>`);
        }else if(data.race.name.startsWith('食人魔')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[饥饿：${data.hunger}/${data.maxHunger}]</font>`);
        }else if(data.race.name.startsWith('操脑蛛') && data.control){
            $('.player-attrs .battle-attr-name').html(data.control.showName || data.control.name);
        }else if(data.race.name.startsWith('污染者')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[理智：${data.san}/${data.maxSan}]</font>`);
        }else if(data.race.name.startsWith('狐族-')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[饥饿：${data.hunger}；水分：${data.water}]</font>`);
        }else if(data.mount && data.mount.tdi){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[${(data.mount.showName || data.mount.name).replace('坐骑：','')}：${data.mount.endurance}]</font>`);
        }else if(data.race.name.startsWith('断肠人')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">(${data.soulName})[理智：${data.san}/${data.maxSan}]</font>`);
        }else if(data.race.name.startsWith('天使')){
            $('.player-attrs .battle-attr-name').html(`${self}<font class="blue">[${getPlayerCamp()}：${data.evil < 0 ? -data.evil : data.evil}]</font>`);
        }else{
            $('.player-attrs .battle-attr-name').html(`${self}`);
        }

        //渲染状态
        $('.monster-status').html('');
        $('.player-status').html('');
        data.status.forEach(e => {
            $('.player-status').append(`<div>${e.name}(${e.num})</div>`);
        })
        data.battleMonster.status.forEach(e => {
            $('.monster-status').append(`<div>${e.name}(${e.num})</div>`);
        })

        //武器
        const weapons = [];
        data.bag.forEach(e => {
            if(e.isWeapon && e.endurance > 0){
                if(e.name.startsWith('技能石')){
                    weapons.push(e);
                }
            }
        })

        $('.weapons').html('');
        //计算逃跑概率
        const runRate = runSuccessRate;
        //渲染护甲属性
        if(data.armor){
            $('.weapons').append(`<div class="only-show">${data.armor.showName || data.armor.name}(${data.bag.filter(e => e.id === data.armor.id)[0].endurance})<br>防御力：${data.armor.def}</div>`);
        }else{
            $('.weapons').append(`<div class="only-show">无护甲<br>防御力：${data.def}</div>`)
        }
        //渲染空手攻击或者主武器，戏命师也不渲染装备的武器
        if(data.race.name.startsWith('戏命师')){
            $('.weapons').append(`<div class="only-show">无法攻击</div>`)
        }else{
            if(data.weapon){
                //被封印时不渲染技能
                if(isSeal(data) && data.weapon.name.startsWith('技能石')){
                    $('.weapons').append(`<div class="weapon hand" data-id="hand">空手<br>atk：${getSanAtk(data.atk)}</div>`);
                }else{
                    $('.weapons').append(`<div class="weapon hand" data-id="${data.weapon.id}">${data.weapon.showName || data.weapon.name}(${data.bag.filter(e=>e.id===data.weapon.id)[0].endurance})<br>atk：${getSanAtk(data.weapon.getAtk(data.weapon) + (data.weapon.name.startsWith('技能石') ? 0 : data.atk))}</div>`);
                }
            }else{
                $('.weapons').append(`<div class="weapon hand" data-id="hand">空手<br>atk：${getSanAtk(data.atk)}</div>`);
            }
        }
        //渲染闪避功能
        if(conf.showDodgeBtn){
            $('.weapons').append(`<div class="weapon" data-id="dodge">闪避<br>30%概率闪避</div>`);
        }
        //渲染逃跑功能
        if(data.race.name.startsWith('星灵') || (data.battleMonster && !data.battleMonster.notRun && (!data.battleMonster.isCthulhuGod || (data.weapon && data.weapon.name === '旧印')))){
            $('.weapons').append(`<div class="weapon" data-id="run">逃跑<br>成功率：${data.race.name.startsWith('星灵') ? 100 : data.battleMonster.seePlayer ? runRate : 100}/100</div>`);
        }
        //渲染自动攻击功能
       if(conf.showAutoBattle && !data.race.name.startsWith("戏命师")){
            $('.weapons').append(`<div class="weapon" data-id="auto">自动攻击<br>点击屏幕停止</div>`);
       }

        if(type === '全部' || type === '技能') {
            //渲染武器
            weapons.forEach(e => {
                //不渲染主武器
                if (data.weapon && e.id === data.weapon.id) {
                    return;
                }
                //不渲染等级未达到的武器
                if (e.level > data.level) {
                    return;
                }
                //被封印时不渲染技能
                if (isSeal(data) && e.name.startsWith('技能石')) {
                    return;
                }


                $('.weapons').append(`<div class="weapon ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''}" data-id="${e.id}">${e.showName || e.name}(${e.endurance})<br>atk：${getSanAtk(e.getAtk(e) + (e.name.startsWith('技能石') ? 0 : data.atk))}</div>`);
            })
        }

        if(type === '全部' || type === '投掷'){
            //投掷物品
            const throws = [];
            data.bag.forEach(e => {
                //被封印时不渲染技能
                if(isSeal(data) && e.name.startsWith('技能石')){
                    return;
                }
                if(e.isThrow){
                    //不渲染有种族限制的投掷品
                    if(e.races && e.races.indexOf(data.race.name) === -1){
                        return;
                    }
                    throws.push(e);
                }
            })
            throws.forEach(e => {
                $('.weapons').append(`<div class="throw ${e.quality ? `${qualityAttr[e.quality].color}` : ''}" data-id="${e.id}">${e.showName || e.name}(${e.quantity})<br>atk：${e.getAtk(e)}</div>`);
            })
        }

        if(type === '全部' || type === '物品'){
            //渲染药剂
            const drugs = [];
            data.bag.forEach(e => {
                //被封印时不渲染技能
                if(isSeal(data) && e.name.startsWith('技能石')){
                    return;
                }
                //和克苏鲁BOSS战斗时，没有手持旧印则不允许使用逃跑卷轴
                if(e.name === '短程传送卷轴'){
                    if(data.battleMonster.isCthulhuGod && (!data.weapon || data.weapon.name !== '旧印')){
                        return;
                    }
                    if(data.battleMonster.name === '创世神'){
                        return;
                    }
                }
                if(e.battleUse){
                    drugs.push(e);
                }
            })
            drugs.forEach(e => {
                $('.weapons').append(`<div class="drug" data-id="${e.id}">${e.showName || e.name}(${e.quantity})<br>hp：${e.getHp()}</div>`);
            })
        }
    }
}

$('.battle-cfg .system-menu').click(function(){
    setTimeout(renderBattlePage, 50)
})

let storeFilter = '';
$(".store-item-search input").bind("input propertychange",function(){
    storeFilter = $(this).val();
    renderStore();
});

let isRunesStore = false;
//渲染仓库,参数数量-1的物品
function renderStore(name){
    if(isRunesStore){
        $('.store-menus').show();
        renderRunesStore(name);
        return;
    }
    $('.store-menus').show();
    $('.bag-item-list .item-list-title').html(`背包`);
    $('.store-menus').show();
    //.bag-item-list .item-list-body<div class="store-item">纤维<br>x10</div>
    //渲染背包物品
    $('.bag-item-list .item-list-body').html('');
    data.bag.filter(e => {
        if(data.armor && data.armor.id === e.id){
            return false;
        }
        if(data.bagEquip && data.bagEquip.id === e.id){
            return false;
        }
        if(data.weapon && data.weapon.id === e.id){
            return false;
        }
        if(data.mount && data.mount.id === e.id){
            return false;
        }
        if(e.isLock){
            return false;
        }
        if(e.name === name && e.quantity <= 1){
            return false;
        }
        return true;
    }).forEach(e => {
        $('.bag-item-list .item-list-body').append(`<div class="store-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''}" data-id="${e.id}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' + `${e.hole.length > 0 ? `{${e.hole.length}}` : ''}` : ''}<br>x${e.name === name ? e.quantity - 1 : e.quantity}</div>`);
    })

    //渲染仓库物品
    $('.store-item-list .item-list-body').html('');
    data.world.home.store = data.world.home.store.filter(e => elementCfgs[e.name]);
    data.world.home.store.forEach(e => {
        if(storeShowType === '装备'){
            if(!e.onlyOne){
                return;
            }
        }
        if(storeShowType === '可使用'){
            if(!e.canUse){
                return;
            }
        }
        if(storeFilter && (e.showName || e.name).indexOf(storeFilter) === -1){
            return;
        }

        $('.store-item-list .item-list-body').append(`<div class="store-item ${e.jp ? 'sponsor-name' : ''} ${e.quality ? `${qualityAttr[e.quality].color}` : ''}" data-id="${e.id}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' + `${e.hole.length > 0 ? `{${e.hole.length}}` : ''}` : ''}<br>x${e.quantity}</div>`);
    })
}

//渲染镶嵌物仓库
function renderRunesStore(){
    //渲染背包物品
    $('.bag-item-list .item-list-body').html('');

    data.bag.filter(e => !e.isLock && e.isInlay && !e.washing && e.name.indexOf('(赠)') === -1).forEach(e => {
        $('.bag-item-list .item-list-body').append(`<div class="store-item" data-id="${e.id}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' + `${e.hole.length > 0 ? `{${e.hole.length}}` : ''}` : ''}<br>x${e.name === name ? e.quantity - 1 : e.quantity}</div>`);
    })

    //渲染仓库物品
    $('.store-item-list .item-list-body').html('');
    conf.runesStore = conf.runesStore.filter(e => elementCfgs[e.name]);
    conf.runesStore.forEach(e => {
        if(storeShowType === '装备'){
            if(!e.onlyOne){
                return;
            }
        }
        if(storeShowType === '可使用'){
            if(!e.canUse){
                return;
            }
        }
        if(storeFilter && (e.showName || e.name).indexOf(storeFilter) === -1){
            return;
        }

        $('.store-item-list .item-list-body').append(`<div class="store-item" data-id="${e.id}">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' + `${e.hole.length > 0 ? `{${e.hole.length}}` : ''}` : ''}<br>x${e.quantity}</div>`);
    })
}

//渲染家
function renderHome(){
    $('.facilitys').html('');
    $('.home-menus span').html(data.world.home.level);

    let facilitys = [];

    const homeLevelFacilitys = {...homeLevelFacility};
    if(festival && Object.keys(festival.shop).length > 0 && homeLevelFacilitys[0].indexOf('节日商店') === -1){
        homeLevelFacilitys[0] = [...homeLevelFacilitys[0],'节日商店'];
    }
    if(!conf.hideSponsorShop && !data.race.challenge && homeLevelFacilitys[0].indexOf('赞助商店') === -1){
        homeLevelFacilitys[0] = [...homeLevelFacilitys[0],'赞助商店'];
    }
    if(getNumByBag('欺诈宝石', true) && homeLevelFacilitys[0].indexOf('欺诈工作台') === -1){
        homeLevelFacilitys[0] = [...homeLevelFacilitys[0],'欺诈工作台'];
    }
    if(data.orderPoint && homeLevelFacilitys[0].indexOf('种族周目商店') === -1 && data.orderPoint > 0 && !data.race.challenge){
        homeLevelFacilitys[0] = [...homeLevelFacilitys[0],'种族周目商店'];
    }
    if(data.order > 1 && homeLevelFacilitys[0].indexOf('古神祭坛') === -1){
        homeLevelFacilitys[0] = [...homeLevelFacilitys[0],'古神祭坛'];
    }
    if(data.order > 1 && homeLevelFacilitys[0].indexOf('扭曲熔炉') === -1){
        homeLevelFacilitys[0] = [...homeLevelFacilitys[0],'扭曲熔炉'];
    }
    for(const key in homeLevelFacilitys){
        if(parseInt(key) <= data.world.home.level){
            facilitys = [...facilitys,...homeLevelFacilitys[key].map(e => ({name : e, level : 1}))]
        }
    }

    //设施排序功能
    if(!data.world.myFacilitys){
        data.world.myFacilitys = facilitys;
    }

    data.world.myFacilitys = [...data.world.myFacilitys, ...(facilitys.filter(e => data.world.myFacilitys.map(f => f.name).indexOf(e.name) === -1))]

    //不显示的设施
    let noShow = [];
    if(data.dlcWorldEnd){
        noShow.push('次元交易所')
    }
    if(data.dlcOriginal){
        noShow = [
            ...noShow,
            ...['镶嵌物仓库','镶嵌台','符文法阵','附魔台','纳米机器','元素实验室','次元金融所','赞助商店','装备打孔器','溶解室','洗涤室']
        ];
    }

    const showFacilitys = conf.homeOrder ? data.world.myFacilitys : facilitys;
    showFacilitys.forEach(e => {
        if(noShow.includes(e.name)){
            return;
        }
        $(`<div class="facility${conf.homeNum || 1}">${e.name}</div>`).click(function(){
            data.world.myFacilitys = [{name : e.name, level : 1}, ...(data.world.myFacilitys.filter(f => f.name !== e.name))];
            facilityFunction[e.name]();
            renderHome();
        }).appendTo('.facilitys');
    })

    //判断是否显示升级按钮
    if(upLevelNeedItems[data.world.home.level]){
        $('.home-level-up-btn').show();
    }else{
        $('.home-level-up-btn').hide();
    }
}

//渲染虚空分解机
function renderResolveMachine(){
    $('.resolve-machine .win-body').html('');
    let html = '';

    //循环所有背包物品的分解条目
    data.bag.forEach(e => {
        if(data.armor && data.armor.id === e.id){
            return false;
        }
        if(data.bagEquip && data.bagEquip.id === e.id){
            return false;
        }
        if(data.weapon && data.weapon.id === e.id){
            return false;
        }
        if(data.mount && data.mount.id === e.id){
            return false;
        }
        if(e.isLock){
            return false;
        }
        if(!elementCfgs[e.name].voidDust){
            return false;
        }

        if(e.name !== '虚空粉尘'){
            html += `<div class="resolve-item">`;
            html += `<div class="resolve-item-name">${e.showName || e.name}${e.onlyOne ? '(' + e.endurance +')' :''}${e.hole.length > 0 ? `{${e.hole.length}}` : ''}(=${elementCfgs[e.name].voidDust})*${e.quantity}</div>`;
            html += `<button class="resolve-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="9999999">所有</button>`;
            html += `<button class="resolve-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="10">10个</button>`;
            html += `<button class="resolve-item-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="1">1个</button>`;
            html += `</div>`;
        }
    })
    $('.resolve-machine .win-body').append(html);
}

//渲染虚空修复器
function renderVoidFix(){
    $('.void-fix .win-body').html('');
    let html = '';

    //循环所有背包物品的分解条目
    data.bag.forEach(e => {
        //兼容历史版本的装备
        if(e.fixNeedDust == null){
            e.fixNeedDust = elementCfgs[e.name].fixNeedDust;
            e.fixNum = 0;
        }

        //如果耐久度不满，则可以修复
        if(e.onlyOne && !e.name.startsWith('技能石') && e.endurance < (e.maxEndurance || elementCfgs[e.name].maxEndurance)){
            html += `<div class="fix-item">`;
            html += `<div class="fix-item-name">${e.showName || e.name}(${e.endurance})${e.hole.length > 0 ? `{${e.hole.length}}` : ''} (虚空粉尘：${e.fixNeedDust * ((e.maxEndurance || elementCfgs[e.name].maxEndurance) - e.endurance)}/${getNumByBag('虚空粉尘', true)})</div>`;
            html += `<button class="fix-item-btn repair-btn" data-name="${e.showName || e.name}" data-id="${e.id}" data-num="${e.fixNeedDust * ((e.maxEndurance || elementCfgs[e.name].maxEndurance) - e.endurance)}" ${e.fixNeedDust <= getNumByBag('虚空粉尘', true) ? '' : 'disabled'}>修复</button>`;
            html += `<button class="fix-item-btn maintain-btn" data-id="${e.id}">保养(${getNumByBag('装备保养油', true)})</button>`;
            html += `</div>`;
        }
    })
    $('.void-fix .win-body').append(html);
}

//图鉴搜索功能
let cybernetSearch = '';
$(".cybernet-search input").bind("input propertychange",function(){
    cybernetSearch = $(this).val();
    renderCybernetItems();
});
$('.cybernet-search button').click(function(){
    $('.cybernet-search input').val('');
    cybernetSearch = '';
    renderCybernetItems();
});

//交易所搜索功能
let exchangeSearch = '';
let isGoblinExchange = false;
$(".exchange-search input").bind("input propertychange",function(){
    exchangeSearch = $(this).val();
    if(isGoblinExchange){
        renderGoblinExchange();
    }else{
        renderExchange();
    }
});

//获取怪物掉落的物品集合
function getFromMonster(){
    let es = [];
    Object.keys(monsterCfgs).forEach(e => {
        es = [...es,...monsterCfgs[e].items.map(e => e.name)];
    })
    return [...new Set(es)].filter(e => !e.startsWith('图纸'))
}

function getCybernetList(type) {
    //获取采集得到的物品集合
    function getGathers(){
        let es = [];
        Object.keys(elementCfgs).filter(e => elementCfgs[e].canGather).forEach(e => {
            es = [...es,...elementCfgs[e].getItem.map(e => e.name)];
        })
        return [...new Set(es)];
    }

    let items = [];
    if(type === '地形'){
        items = Object.keys(terrainElements)
    }else if(type === '资源'){
        items = Object.keys(elementCfgs).map(e => ({...elementCfgs[e],name : e})).filter(e => e.canGather).map(e => e.name);
    }else if(type === '物品'){
        items = Object.keys(elementCfgs).map(e => ({...elementCfgs[e],name : e})).filter(e => !e.canGather).filter(e => !e.isWeapon && !e.isArmor && !e.isInlay && !e.isMount && !e.name.startsWith('技能石')).map(e => e.name);

        const gathers = getGathers();
        const fromMonster = getFromMonster();
        items = items.filter(e => gathers.indexOf(e) === -1 && fromMonster.indexOf(e) === -1)

    }else if(type === '装备'){
        items = Object.keys(elementCfgs).map(e => ({...elementCfgs[e],name : e})).filter(e => !e.canGather).filter(e => (e.isArmor || e.isWeapon || e.isAmulet) && !e.name.startsWith('技能石')).map(e => e.name);
    }else if(type === '镶嵌物'){
        items = Object.keys(elementCfgs).map(e => ({...elementCfgs[e],name : e})).filter(e => !e.canGather).filter(e => e.isInlay).map(e => e.name);
    }else if(type === '技能'){
        items = Object.keys(elementCfgs).map(e => ({...elementCfgs[e],name : e})).filter(e => !e.canGather).filter(e => e.name.startsWith('技能石')).map(e => e.name);
    }else if(type === '采集获得'){
        items = getGathers()
    }else if(type === '坐骑'){
        items = Object.keys(elementCfgs).filter(e => elementCfgs[e].isMount);
    }else if(type === '怪物掉落'){
        items =  getFromMonster()
    }else if(type === '怪物'){
        items = Object.keys(monsterCfgs)
    }else if(type === '说明'){
        items = Object.keys(explains)
    }

    return items;
}

$('body').on('click','.to-cybernet',function() {
    const name = $(this).attr('data-name');
    const filter = ['地形','资源','怪物','物品','装备','镶嵌物','技能','采集获得','坐骑','怪物掉落','说明'].filter(e => getCybernetList(e).includes(name));
    if(filter.length > 0){
        $('.common-win').hide();
        $('.cybernet').show()
        $('.cybernet-search input').val(name)
        cybernetSearch = name;
        $(`.cybernet-type[data-name=${filter[0]}]`).click();
        renderCybernetItems();
        $(`.cybernet-item[data-name=${name}]`).click();
    }else{
        winMsg(`图鉴中未找到${name}，请试试手动查找`, false, false)
    }
})

//渲染图鉴左侧的物品栏
function renderCybernetItems(){
    //获取图鉴类型
    const type = $('.cybernet-types .cybernet-active').text();
    let items = getCybernetList(type);

    //搜索过滤
    if(cybernetSearch){
        items = items.filter(e => e.indexOf(cybernetSearch) !== -1)
    }

    const color = {
        '精英' : 'blue',
        '传说' : 'orange',
        '神话' : 'red',
    };
    $('.cybernet-items').html(items.map((e,i) => `<div class="cybernet-item ${i === 0 ? 'cybernet-active' : ''}" data-name="${e}"><font class="${type === '怪物' ? color[monsterCfgs[e].type] || '' : elementCfgs[e] ? qualityAttr[elementCfgs[e].quality].color || '' : ''}">${e}</font></div>`).join(''));
    renderCybernetBody();
}

//渲染图鉴内容
function renderCybernetBody(){
    try{

        //获取图鉴类型
        const type = $('.cybernet-types .cybernet-active').text();
        //获取图鉴物品
        const item = $('.cybernet-items .cybernet-active').text();
        $('.cybernet-body').html('');

        if(type === '地形'){
            const terrain = terrainElements[item];

            $('.cybernet-body').append(`<h4>哪些地图有该地形：</h4><p>${Object.keys(terrainArray).filter(e => terrainArray[e].indexOf(item) !== -1).join('，')}</p>`);

            let html = '';
            html += Object.keys(terrain.elements || {}).map(e => {
                return `${e}<span class="to-cybernet" data-name="${e}">🔍</span>：初始${terrain.elements[e].num[0]}~${terrain.elements[e].num[1]}个，最多存在${terrain.elements[e].maxNum}个`;
            }).join('<br>')

            $('.cybernet-body').append(`<h4>可能存在的资源：</h4>（初始存在数量的最小值可能为负数，随机出的数量为负数时，视为0个。所以起始值越小，意味着出现该资源的概率越低）<br><br><p>${html}</p>`);

            html = '';
            html += Object.keys(terrain.monster).map(e => {
                return `${e}<span class="to-cybernet" data-name="${e}">🔍</span>：出现概率${terrain.monster[e].prob}%`;
            }).join('<br>')

            $('.cybernet-body').append(`<h4>可能出现的怪物：</h4><p>${html}</p>`);

        }else if(type === '资源'){
            let html = `<p>采集时间：${elementCfgs[item].time}分钟</p>`;
            html += `<p>可采集次数：${elementCfgs[item].num}</p>`;
            html += `<p>生成天数：${elementCfgs[item].day === -1 ? '不可再生' : `${elementCfgs[item].day}天`}</p>`;
            html += `<p>采集需要工具：${elementCfgs[item].needItem.length > 0 ? elementCfgs[item].needItem.map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>`).join() : '无需工具'}</p>`;
            if(elementCfgs[item].needItem.length > 0){
                html += `<p>是否可以空手采集（空手采集时消耗时间翻倍）：${elementCfgs[item].canHand ? '是' : '否'}</p>`;
            }

            html += `<p>可能出现在：${Object.keys(terrainElements).filter(e => terrainElements[e].elements && Object.keys(terrainElements[e].elements).indexOf(item) !== -1).map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>`).join('，')}</p>`;

            html += '<p><span class="cybernet-title">采集可能获得的物品：</span>';
            html += elementCfgs[item].getItem.map(e => `${e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span>：${e.minNum}~${e.maxNum}个`).join('<br>')
            html += `</p>`;
            $('.cybernet-body').append(html);

        }else if(type === '物品' || type === '装备' || type === '镶嵌物' || type === '技能' || type === '采集获得' || type === '怪物掉落' || type === '坐骑'){
            let html = '';

            if(elementCfgs[item].isMount){
                html += `<p>(坐骑)</p>`;
            }
            if(elementCfgs[item].isAmulet){
                html += `<p>(护身符)</p>`;
            }
            if(elementCfgs[item].isWeapon){
                html += `<p>(武器)</p>`;
            }
            if(elementCfgs[item].isArmor){
                html += `<p>(护甲)</p>`;
            }
            if(elementCfgs[item].isInlay){
                html += `<p>(镶嵌物)</p>`;
                html += `<p>等级：${elementCfgs[item].level}</p>`;
            }
            html += `<p>重量：${elementCfgs[item].weight}</p>`;
            html += `<p>分解粉尘数量：${elementCfgs[item].voidDust}</p>`;
            html += `<p>价值：${elementCfgs[item].gold}金币</p>`;
            html += `<p>吸引值：${elementCfgs[item].draw}</p>`;

            if(elementCfgs[item].elemental){
                html += `<p>元素：${Object.keys(elementCfgs[item].elemental).map(e => `${e}(${elementCfgs[item].elemental[e]})`).join('，')}</p>`;
            }

            if(elementCfgs[item].atkTags && elementCfgs[item].atkTags.length > 0){
                html += `<p>针对拥有指定标签的怪物增加/减少伤害：<br>${elementCfgs[item].atkTags.map(e => `对[${e.tag}]${e.rate < 0 ? '减少' : '增加'}${e.rate}倍伤害`).join('<br>')}</p>`;
            }

            //采集获得
            const fromEles = Object.keys(elementCfgs).filter(e => {return elementCfgs[e].getItem.filter(itm => itm.name === item).length > 0});
            if(fromEles.length > 0){
                html += `<p>采集获得：${fromEles.map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>`).join('，')}</p>`;
            }

            //怪物掉落
            const fromMonsters = Object.keys(monsterCfgs).filter(e => {return monsterCfgs[e].items.filter(itm => itm.name === item).length > 0}).map(e => {
                const i = monsterCfgs[e].items.filter(itm => itm.name === item)[0];
                return `${e}<span class="to-cybernet" data-name="${e}">🔍</span>(${i.minNum}~${i.maxNum})`;
            });
            if(fromMonsters.length > 0){
                html += `<p>怪物掉落：${fromMonsters.join('，')}</p>`;
            }

            const sellMaps = Object.keys(goods).filter(e => Object.keys(goods[e]).filter(g => goods[e][g].indexOf(item) !== -1).length > 0);
            if(sellMaps.length > 0){
                html += `<p>出售地图：${sellMaps.join('，')}</p>`;
            }

            //可使用物品
            if(elementCfgs[item].canUse){
                let str = '<span class="cybernet-title">使用效果：</span>';
                if(elementCfgs[item].battleUse){
                    str += `(战斗中可使用)<br>`;
                }
                if(elementCfgs[item].myHp || elementCfgs[item].hp){
                    str += `HP：${elementCfgs[item].myHp ? elementCfgs[item].myHp() : elementCfgs[item].hp}<br>`;
                }
                if(elementCfgs[item].hunger){
                    str += `饥饿：${elementCfgs[item].hunger}<br>`;
                }
                if(elementCfgs[item].water){
                    str += `水分：${elementCfgs[item].water}<br>`;
                }
                if(elementCfgs[item].getForgeRate){
                    str += `学会锻造配方：${elementCfgs[item].getForgeRate}<br>`;
                }
                html += `<p>${str}</p>`;
            }

            //投掷品
            if(elementCfgs[item].isThrow){
                html += `<p>攻击力：${elementCfgs[item].getAtk(elementCfgs[item])}<br></p>`;
            }

            //装备
            if(elementCfgs[item].onlyOne){
                let str = '<span class="cybernet-title">装备属性：</span>';
                if(elementCfgs[item].isWeapon || elementCfgs[item].isArmor){
                    if(elementCfgs[item].endurance){
                        str += `等级：${elementCfgs[item].level}<br>`;
                    }
                }
                if(elementCfgs[item].endurance){
                    str += `耐久：${elementCfgs[item].endurance}<br>`;
                }
                if(elementCfgs[item].hp){
                    str += `HP：${elementCfgs[item].hp}<br>`;
                }
                if(elementCfgs[item].getAtk(elementCfgs[item])){
                    str += `攻击力：${elementCfgs[item].getAtk(elementCfgs[item])}<br>`;
                }
                if(elementCfgs[item].def){
                    str += `防御力：${elementCfgs[item].def}<br>`;
                }
                if(elementCfgs[item].atkSpd){
                    str += `攻速${elementCfgs[item].atkSpd > 0 ? '+' : ''}${elementCfgs[item].atkSpd}<br>`;
                }
                if(elementCfgs[item].suck){
                    str += `吸血：${elementCfgs[item].suck}%<br>`;
                }
                if(elementCfgs[item].defProp){
                    str += `减少伤害：${elementCfgs[item].defProp * 100}%<br>`;
                }
                if(elementCfgs[item].addWeight){
                    str += `增加负重：${elementCfgs[item].addWeight}<br>`;
                }
                if(elementCfgs[item].weightUp){
                    str += `增加负重：${elementCfgs[item].weightUp}<br>`;
                }
                if(elementCfgs[item].spd){
                    str += `增加速度：${elementCfgs[item].spd}%<br>`;
                }
                if(elementCfgs[item].atkNeedItem.length > 0){
                    str += `使用时消耗物品：${elementCfgs[item].atkNeedItem.map(e => {
                        return `${e.name}*${e.num}`;
                    }).join('，')}`;
                }
                html += `<p>${str}</p>`;
            }

            //镶嵌物
            if(elementCfgs[item].isInlay){
                let str = '<span class="cybernet-title">镶嵌属性：</span>';
                if(elementCfgs[item].hp){
                    str += `HP：${elementCfgs[item].hp}<br>`;
                }
                if(elementCfgs[item].maxEndurance){
                    str += `耐久：${elementCfgs[item].maxEndurance}<br>`;
                }
                if(elementCfgs[item].def){
                    str += `防御力：${elementCfgs[item].def}<br>`;
                }
                if(elementCfgs[item].atk){
                    str += `攻击力：${elementCfgs[item].atk}<br>`;
                }
                if(elementCfgs[item].suck){
                    str += `吸血：${elementCfgs[item].suck}%<br>`;
                }
                if(elementCfgs[item].noWear){
                    str += `永不磨损`;
                }
                html += `<p>${str}</p>`;
            }

            //附带技能
            if(elementCfgs[item].skills){
                html += `<p>附带技能：${Object.keys(elementCfgs[item].skills).map(e => `${e}<span class="to-cybernet" data-name="技能石：${e}">🔍</span>`).join('，')}</p>`;
            }

            //配方
            const moreRecipes = Object.keys(recipes).filter(e => e.startsWith(`${item}-`));
            if(recipes[item] || moreRecipes.length > 0){
                let recipe = null;
                html += `<h4>配方</h4>`;
                if(recipes[item]){
                    recipe = recipes[item];
                    html += `<p>配方：${Object.keys(recipe.items).map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>*${recipe.items[e]}`).join('+')}</p>`;
                    if(recipe.need){
                        html += `<p>制造设施：${recipe.need}<span class="to-cybernet" data-name="${recipe.need}">🔍</span></p>`;
                    }else{
                        html += `<p>制造设施：${facility4level[recipe.level].map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>`).join('，')}</p>`;
                    }
                }else if(moreRecipes.length > 0){
                    moreRecipes.forEach(n => {
                        recipe = recipes[n];
                        html += `<p>配方-${n.split('-')[1]}：${Object.keys(recipes[n].items).map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>*${recipes[n].items[e]}`).join('+')}</p>`;
                    })
                    if(recipe.need){
                        html += `<p>制造设施：${recipe.need}</p>`;
                    }else{
                        html += `<p>制造设施：${facility4level[recipe.level].map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>`).join('，')}</p>`;
                    }
                }
            }
            if(forgeRecipes[item]){
                const recipe = forgeRecipes[item];
                html += `<p>锻造配方：${Object.keys(recipe.items).map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>*${recipe.items[e]}`).join('+')}</p>`;
            }

            //参与的合成物品
            const canRecipes = Object.keys(recipes).filter(e => Object.keys(recipes[e].items).includes(item));
            const canForgeRecipes = Object.keys(forgeRecipes).filter(e => Object.keys(forgeRecipes[e].items).includes(item));
            if(canRecipes.length > 0){
                html += `<h4>可用于制造</h4>`;
                canRecipes.forEach(e => {
                    const strs = e.split('-');
                    html += `<p>${e}<span class="to-cybernet" data-name="${isNaN(strs[1]) ? e : strs[0]}">🔍</span>：${Object.keys(recipes[e].items).map(i => `${i}*${recipes[e].items[i]}`).join('+')}</p>`;
                })
            }
            if(canForgeRecipes.length > 0){
                html += `<h4>可用于锻造</h4>`;
                canForgeRecipes.forEach(e => {
                    html += `<p>${e}<span class="to-cybernet" data-name="${e}">🔍</span>：${Object.keys(forgeRecipes[e].items).map(i => `${i}*${forgeRecipes[e].items[i]}`).join('+')}</p>`;
                })
            }


            //说明文本
            if(elementCfgs[item].text){
                html += `<h4>说明</h4>`;
                html += `<p>${elementCfgs[item].text}</p>`;
            }

            $('.cybernet-body').append(html);
        }else if(type === '怪物'){
            let html = '';
            html += `<h4>${item}</h4>`;
            html += `<p>标签：${monsterCfgs[item].tags.join('/')}</p>`;
            html += `<p>等级：${monsterCfgs[item].level}</p>`;
            html += `<p>职阶：${monsterCfgs[item].type || '普通'}</p>`;
            html += `<p>HP：${monsterCfgs[item].hp}</p>`;
            html += `<p>攻击力：${monsterCfgs[item].atk}</p>`;
            html += `<p>防御力：${monsterCfgs[item].def}</p>`;
            html += `<p>吸血：${monsterCfgs[item].suck || 0}%</p>`;
            html += `<p>攻速：${monsterCfgs[item].atkSpd}</p>`;
            html += `<p>经验值：${monsterCfgs[item].exp}</p>`;
            html += `<p>主动攻击时间：${monsterCfgs[item].atkProb === 0 ? '不主动攻击' : monsterCfgs[item].atkTime}</p>`;
            html += `<p>主动攻击概率：${monsterCfgs[item].atkProb === 0 ? '不主动攻击' : monsterCfgs[item].atkProb + '%'}</p>`;

            //怪物说明文本
            if(monsterCfgs[item].text){
                html += `<p>${monsterCfgs[item].text}</p><br>`;
            }

            //怪物出现位置
            if(monsterCfgs[item].type === '神话'){
                html += `<p>可能游荡在：${allMapList.filter(e => e.mythMonster.indexOf(item) !== -1).map(e => e.name).join('，')}</p>`;
            }
            html += `<h4>可能出现在</h4>`;
            const maps = allMapList.filter(e => terrainArray[e.name].filter(e2 => Object.keys(terrainElements[e2].monster).indexOf(item) !== -1 && (terrainElements[e2].monster[item].type ? terrainElements[e2].monster[item].level >= e.level[0] - 10 && terrainElements[e2].monster[item].level <= e.level[1] : terrainElements[e2].monster[item].level >= e.level[0] && terrainElements[e2].monster[item].level <= e.level[1])).length > 0).map(e => e.name);
            maps.forEach(e => {
                html += `<p>${e}：${terrainArray[e].filter(e => Object.keys(terrainElements[e].monster).indexOf(item) !== -1).map(e => `${e}<span class="to-cybernet" data-name="${e}">🔍</span>(${terrainElements[e].monster[item].prob}%)`).join('，')}</p>`;
            })

            if(monsterSkillMapping[item]){
                html += `<h4>拥有技能</h4>`;
                html += monsterSkillMapping[item].map(e => {
                    return `<p>${e}：${monsterSkills[e].text}</p>`;
                }).join('');
            }

            html += `<p><span class="cybernet-title">掉落物品</span>${monsterCfgs[item].items.map(e => `${e.showName || e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span>：${e.minNum}~${e.maxNum}个`).join('<br>')}</p>`;
            html += `<p><span class="cybernet-title">额外掉落</span>${getCommItems(monsterCfgs[item].type || '普通', monsterCfgs[item].level, false, monsterCfgs[item].tags).map(e => `${e.showName || e.name}<span class="to-cybernet" data-name="${e.name}">🔍</span>：${e.minNum}~${e.maxNum}个`).join('<br>')}</p>`;

            $('.cybernet-body').append(html);
        }else if(type === '说明'){
            $('.cybernet-body').append(typeof explains[item] === 'function' ? explains[item]() : explains[item]);
        }
    }catch (e) {
        console.error(e)
        throw e
    }
}

//渲染批量采集窗口
function renderMopUp(){
    $('.mop-up-win-body').html('');
    const arr = [...new Set(data.world.mapElements[data.location.join()].elementList.map(e => e.name))].filter(e => elementCfgs[e].mopUp).filter(e => {
        let needItem = elementCfgs[e].needItem;
        if(needItem && needItem.length > 0){
            for(let i = 0 ; i < needItem.length ; i++){
                if(getNumByBag(needItem[i])){
                    return true;
                }
            }
        }else{
            return true;
        }
    });
    arr.forEach(e => {
        let minCount = 0;
        data.world.mapElements[data.location.join()].elementList.filter(el => el.name === e).forEach(ele => {
            minCount += ele.time * ele.num;
        });
        $('.mop-up-win-body').append(`<div class="mop-up-element"><span>${e}</span>(${minCount}分钟)</div>`);
    })
}

//渲染经验提取器
function renderExpExtract(){
    $('.exp-items').html('');
    $('.exp-number-value').attr('id', '').html('0')

    //渲染背包物品
    let showItems = [...data.bag].filter(e => e.voidDust > 0 && !e.isLock && (data.weapon ? e.id !== data.weapon.id : true) && (data.armor ? e.id !== data.armor.id : true) && (data.bagEquip ? e.id !== data.bagEquip.id : true) && (data.mount ? e.id !== data.mount.id : true));

    showItems.forEach(e => {
        $('.exp-items').append(`<div id="${e.id}" class="bag-item ${e.quality ? `${qualityAttr[e.quality].color}` : ''}">${e.showName || e.name}${e.onlyOne ? `(${e.endurance})${e.hole.length > 0 ? `{${e.hole.length}}` : ''}` : ''}<br>x${e.quantity}</div>`);
    })
}

//显示藏宝图窗口
$('.treasure-map').click(function(){
    renderTreasureMap();
    $('.treasure-map-win').show();
})
//点击切换藏宝图类型
$('.treasure-map-type').click(function(){
    $('.treasure-map-type').removeClass('active')
    $(this).addClass('active')
    renderTreasureMap();
})
//点击挖掘藏宝图
$('.body').on('click', '.excavate', function(){
    let get = false;
    const arr = [];
    data.treasureMaps[data.worldIndex].forEach(e => {
        if(e.location.join() === data.location.join() && !get){
            get = true;
        }else{
            arr.push(e);
        }
    })
    data.treasureMaps[data.worldIndex] = arr;

    const num = randomNum(1, 100);
    if(num <= 1){
        const ran = randomNum(1,100);
        if(ran <= 50){
            addItem('武器固化卷轴');
            winMsg('你找到了1个武器固化卷轴')
        }else{
            addItem('护甲固化卷轴');
            winMsg('你找到了1个护甲固化卷轴')
        }
    }else if(num <= 4){
        const ran = randomNum(1,100);
        if(ran <= 50){
            addItem('万能武器打孔石');
            winMsg('你找到了1个万能武器打孔石')
        }else{
            addItem('万能护甲打孔石');
            winMsg('你找到了1个万能护甲打孔石')
        }
    }else if(num <= 10){
        addItem('耐磨珠宝');
        winMsg('你找到了1个耐磨珠宝')
    }else if(num <= 20){
        addItem('溶解药水');
        winMsg('你找到了1个溶解药水')
    }else if(num <= 50){
        addItem('锻造笔记');
        winMsg('你找到了1个锻造笔记')
    }else{
        addItem('牵引卷轴');
        winMsg('你找到了1个牵引卷轴')
    }

   timeLapses(5);
})
//渲染藏宝图
function renderTreasureMap(){
    if(!data.treasureMaps){
        data.treasureMaps = {};
    }
    const attr = $('.treasure-map-type.active').data('attr');
    if(attr === 'this-map'){
        if(data.treasureMaps[data.worldIndex]){
            const treasureMap = data.treasureMaps[data.worldIndex];
            treasureMap.sort(function (a,b) {
                const ax = a.location[0];
                const bx = b.location[0];
                const ay = a.location[1];
                const by = b.location[1];
                return (ax < bx) ? -1 : (ay > by) ? 1 : 0;
            });
            $('.treasure-map-body').html(treasureMap.map(e => `<div class="treasure-map-one">${e.mapName}：[${e.location[0]},${e.location[1]}]</div>`).join(''))
        }else{
            $('.treasure-map-body').html('')
        }
    }else{
        const keys = Object.keys(data.treasureMaps).filter(e => e != data.worldIndex);
        if(keys.length > 0){
            keys.sort();
            let datas = [];

            keys.forEach(e => {
                const treasureMap = data.treasureMaps[e];
                treasureMap.sort(function (a,b) {
                    const ax = a.location[0];
                    const bx = b.location[0];
                    const ay = a.location[1];
                    const by = b.location[1];
                    return (ax < bx) ? -1 : (ay > by) ? 1 : 0;
                });
                datas = [
                    ...datas,
                    ...treasureMap
                ];
            })
            $('.treasure-map-body').html(datas.map(e => `<div class="treasure-map-one">${e.mapName}：[${e.location[0]},${e.location[1]}]</div>`).join(''))
        }else{
            $('.treasure-map-body').html('')
        }
    }
}

//渲染统计页面
function renderStatistics(){
    const type = $('.statistics-type.active').data('type');
    const body = $('.statistics-body');
    body.html('')

    if(type === 'killed'){
        const allKey = Object.keys(monsterCfgs);
        let count = 0;
        Object.keys(data.killedMonster).sort((a,b) => allKey.indexOf(a) - allKey.indexOf(b)).forEach(e => {
            body.append(`<p>${e}：${data.killedMonster[e]}</p>`)
            count += data.killedMonster[e];
        })
        body.prepend(`<p>总击杀数：${count}</p>`)

    }else if(type === 'gathered'){
        const allKey = Object.keys(elementCfgs);
        let count = 0;
        Object.keys(data.gathered).sort((a,b) => allKey.indexOf(a) - allKey.indexOf(b)).forEach(e => {
            count += data.gathered[e];
            body.append(`<p>${e}：${data.gathered[e]}</p>`)
        })
        body.prepend(`<p>总采集数：${count}</p>`)
    }else if(type === 'order'){
        const allKey = Object.keys(races);
        let count = 0;
        Object.keys(conf.raceMaxOrder).sort((a,b) => allKey.indexOf(a) - allKey.indexOf(b)).forEach(e => {
            count += conf.raceMaxOrder[e];
            body.append(`<p>${e}：${conf.raceMaxOrder[e]}</p>`)
        })
        body.prepend(`<p>总周目数：${count}</p>`)
    }else if(type === 'time'){
        body.append(`<h2 style="text-align: center">本角色游戏时长</h2>`).append(`<h5 style="text-align: center" class="this-game-time">${data.startTime ? getTimeText(data.startTime) : '该存档无法计算游戏时长'}</h5><p style="text-align: center;line-height: 16px">说明：以前创建的存档无法记录游戏时间，1.55版本更新后新开的存档才能记录游戏时间。游戏时长只会在你打开游戏时增长，退出游戏后不会增长。如果你因为某些原因将游戏长时间挂着，或者放在后台没关闭，只要没做操作，可以直接退出游戏，然后重新打开游戏，此时你放置的那些无效时间也不会计入游戏时长。但是如果你长时间挂在后台，打开后又做了任何影响数据的操作，就会触发保存，那么你之前放置的时间都会被记录到游戏时长内</p>`)
            .append(`<h2 style="text-align: center">一周目速通记录</h2>`);

        if(conf.bestPassTime){
            const races = Object.keys(conf.bestPassTime);
            races.sort((a,b) => conf.bestPassTime[a] - conf.bestPassTime[b]);
            races.forEach(e => {
                body.append(`<p style="text-align: center">${e}：${getTimeText(conf.bestPassTime[e])}</p>`)
            })
        }
    }else{
        const allKey = Object.keys(elementCfgs);
        let count = {0 : 0, 1 : 0, 2 : 0, 3 : 0, 4 : 0};
        Object.keys(data.forgeCount).sort((a,b) => allKey.indexOf(a) - allKey.indexOf(b)).forEach(e => {
            if(!isNaN(data.forgeCount[e])){
                count[elementCfgs[e].quality] += data.forgeCount[e];
            }else{
                count[0] += data.forgeCount[e][0] || 0;
                count[1] += data.forgeCount[e][1] || 0;
                count[2] += data.forgeCount[e][2] || 0;
                count[3] += data.forgeCount[e][3] || 0;
                count[4] += data.forgeCount[e][4] || 0;
            }
            body.append(`<p>${e}：${!isNaN(data.forgeCount[e]) ? `<font class="${qualityAttr[elementCfgs[e].quality].color}">${data.forgeCount[e]}</font>` : `${data.forgeCount[e][0] || 0}/<font class="${qualityAttr[1].color}">${data.forgeCount[e][1] || 0}</font>/<font class="${qualityAttr[2].color}">${data.forgeCount[e][2] || 0}</font>/<font class="${qualityAttr[3].color}">${data.forgeCount[e][3] || 0}</font>/<font class="${qualityAttr[4].color}">${data.forgeCount[e][4] || 0}</font>`}</p>`)
        })
        body.prepend(`<p>总锻造数：${count[0]}/<font class="${qualityAttr[1].color}">${count[1]}</font>/<font class="${qualityAttr[2].color}">${count[2]}</font>/<font class="${qualityAttr[3].color}">${count[3]}</font>/<font class="${qualityAttr[4].color}">${count[4]}</font></p><br>`)
        body.prepend(`<p>物品名：普通/<font class="${qualityAttr[1].color}">优秀</font>/<font class="${qualityAttr[2].color}">精良</font>/<font class="${qualityAttr[3].color}">传说</font>/<font class="${qualityAttr[4].color}">神话</font></p>`)
    }

    $('.statistics-win').show();
}
$('.statistics-type').click(function(){
    $('.statistics-type').removeClass('active');
    $(this).addClass('active');
    renderStatistics();
});

//渲染死亡日志
function renderDieLog(){
    $('.del-log-win').show().find('.win-body').html(conf.dieLog.map(e => `<p>${e}</p>`).join(''));
}

//赞助商品
const sponsorGoods = {
    '鱼汤' : 1,
    '欺诈宝石' : 1,
    '捕捉缰绳' : 2,
    '神性结晶' : 2,
    '灵魂追猎' : 2,
    '敌对感知卷轴' : 2,
    '回城卷轴' : 3,
    '精英缰绳' : 3,
    '位面坐标：后院' : 3,
    '位面坐标：深渊' : 3,
    '小型传送阵' : 4,
    '传说缰绳' : 5,
    '次元信标' : 5,
    '遗忘之魂' : 5,
    '学习药剂' : 5,
    '经验药剂' : 5,
    '香甜药水' : 5,
    '重生十字章' : 10,
    '水晶球' : 10,
    '次元移动' : 10,
    '神话缰绳' : 10,
    '时空背包' : 20,
    '大灾变' : 20,
    '永恒珠宝(赠)' : 30,
    '神秘印记' : 50,
    '观察之眼' : 50,
    '超级转生卷轴' : 50,
    'DLC体验券' : 100,
    '我既是正义' : 100,
};

//渲染赞助商店
function renderSponsorShop(){
    if((data.sponsorPoint > 0 || countPoint > 0) && !conf.alertLogin){
        alert('当前已添加账号功能，请在赞助商店中点击“爱发电”按钮注册或登录账号，即可绑定你的赞助点，以后换设备或者卸载重装游戏，不需要再找作者改ID了');
        conf.alertLogin = true;
        save(confSavedName, conf);
    }
    $('.sponsor-point').html(data.sponsorPoint || 0)
    $('.sponsor-get-point').html(countPoint ?  countPoint - (data.getedSponsorPoint || 0): 0)
    $('.sponsor-shop .sponsor-buy').html('');
    Object.keys(sponsorGoods).forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name" style="width:100%;text-align: center"><h4 style="margin: 0px">${e}<span class="to-cybernet" data-name="${e}">🔍</span>(${sponsorGoods[e]}点)</h4></div></div>`;
        html += `<div style="height: 40px"><div class="buy-btns">`;
        html += `<button class="buy-sponsor-good-btn" data-name="${e}" data-num="1">买1个</button>`;
        html += `<button class="buy-sponsor-good-btn" data-name="${e}" data-num="10">买10个</button>`;
        html += `</div></div>`;
        $('.sponsor-shop .sponsor-buy').append(html);
    })
}

//领取点数
function getSponsorPoint(){
    if(countPoint){
        if(!data.getedSponsorPoint){
            data.getedSponsorPoint = 0;
        }
        if(!data.sponsorPoint){
            data.sponsorPoint = 0;
        }
        const canGet = countPoint - data.getedSponsorPoint;
        if(canGet > 0){
            data.sponsorPoint += canGet;
            data.getedSponsorPoint += canGet;
            winMsg(`领取成功`)
            renderSponsorShop();
            save();
        }else{
            winMsg(`你没有可领取的点数`)
        }
    }else{
        winMsg(`你没有可领取的点数`)
    }
}

//购买赞助商店
$('.sponsor-shop .sponsor-buy').on('click','.buy-sponsor-good-btn',function(){
    const name = $(this).attr('data-name');
    const num = parseInt($(this).attr('data-num'));
    const need = sponsorGoods[name] * num;

    if(data.sponsorPoint >= need){
        addItem(name, num);
        data.sponsorPoint -= need;
        winMsg(`你购买了${name}*${num}，消耗了${need}点赞助点数`)
        renderSponsorShop();
        save();
    }else{
        winMsg(`点数不足`)
    }
});
