//元素属性配置
const elementCfgs = {
    // 可采集资源
    '草丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 2, getItem : [{name : '纤维',minNum : 1, maxNum : 3}]}),
    '草药丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '草药',minNum : 1, maxNum : 3}]}),
    '树木' : new Element({canGather :true, mopUp : true, time : 20, num : 10, day : 5, canHand : true, needItem : ['木斧','石斧','铁斧','光荣斧'], getItem : [{name : '木材',minNum : 2, maxNum : 3},{name : '树枝',minNum : 1, maxNum : 3}]}),
    '石块' : new Element({canGather :true, mopUp : true, time : 20, num : 10, needItem : ['木镐','石镐','铁镐','光荣镐'], getItem : [{name : '燧石',minNum : 1, maxNum : 2},{name : '石头',minNum : 1, maxNum : 3}]}),
    '浆果丛' : new Element({canGather :true, mopUp : true, time : 5, num : 5, day : 2, getItem : [{name : '浆果',minNum : 1, maxNum : 3}]}),
    '仙人掌' : new Element({canGather :true, mopUp : true, time : 10, num : 5, day : 5, getItem : [{name : '仙人掌肉',minNum : 1, maxNum : 3}]}),
    '水源' : new Element({canGather :true, mopUp : true, time : 3, num : 20, day : 2, getItem : [{name : '水',minNum : 2, maxNum : 4}]}),
    '鱼群' : new Element({canGather :true, time : 10, num : 10, day : 3, needItem : ['鱼竿'], getItem : [{name : '鱼',minNum : 0, maxNum : 1}]}),
    '铁矿石' : new Element({canGather :true, mopUp : true, time : 30, num : 10, needItem : ['木镐','石镐','铁镐','光荣镐'], getItem : [{name : '燧石',minNum : 0, maxNum : 1},{name : '石头',minNum : 1, maxNum : 2},{name : '铁矿',minNum : 1, maxNum : 2}]}),
    '铜矿石' : new Element({canGather :true, mopUp : true, time : 30, num : 10, needItem : ['木镐','石镐','铁镐','光荣镐'], getItem : [{name : '燧石',minNum : 0, maxNum : 1},{name : '石头',minNum : 1, maxNum : 2},{name : '铜矿',minNum : 1, maxNum : 2}]}),
    '金矿石' : new Element({canGather :true, mopUp : true, time : 30, num : 10, needItem : ['石镐','铁镐','光荣镐'], getItem : [{name : '燧石',minNum : 0, maxNum : 1},{name : '石头',minNum : 1, maxNum : 2},{name : '金矿',minNum : 1, maxNum : 2}]}),
    '魔晶矿脉' : new Element({canGather :true, mopUp : true, time : 60, num : 5, day : 30, needItem : ['铁镐','光荣镐'], getItem : [{name : '魔晶石',minNum : 1, maxNum : 2}]}),
    '芦苇从' : new Element({canGather :true, mopUp : true, time : 5, num : 5, day : 5,getItem : [{name : '芦苇',minNum : 1, maxNum : 2}]}),
    '沙坑' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 1,getItem : [{name : '贝壳',minNum : 2, maxNum : 1},{name : '螃蟹',minNum : 0, maxNum : 1}]}),

    '蘑菇群' : new Element({canGather :true, mopUp : true, time : 2, num : 5, day : 2, getItem : [{name : '蘑菇',minNum : 1, maxNum : 3}]}),
    '微光蘑菇群' : new Element({canGather :true, mopUp : true, time : 2, num : 5, day : 2, getItem : [{name : '微光蘑菇',minNum : 1, maxNum : 3}]}),
    '扭曲树' : new Element({canGather :true, mopUp : true, time : 20, num : 10, day : 5, needItem : ['石斧','铁斧','光荣斧'], getItem : [{name : '木材',minNum : 2, maxNum : 3},{name : '树枝',minNum : 1, maxNum : 3}]}),
    '脆石壁' : new Element({canGather :true, mopUp : true, time : 20, num : 10, needItem : ['木镐','石镐','铁镐','光荣镐'], getItem : [{name : '燧石',minNum : 1, maxNum : 2},{name : '石头',minNum : 1, maxNum : 3}]}),
    '红晶矿' : new Element({canGather :true, mopUp : true, time : 60, num : 5, needItem : ['铁镐','光荣镐'], getItem : [{name : '红水晶',minNum : 1, maxNum : 2},{name : '纯净水晶',minNum : 0, maxNum : 1}]}),
    '黑曜石矿' : new Element({canGather :true, mopUp : true, time : 60, num : 5, needItem : ['铁镐','光荣镐'], getItem : [{name : '黑曜石',minNum : 1, maxNum : 3}]}),

    '珊瑚群' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 1,getItem : [{name : '珊瑚',minNum : 1, maxNum : 2}]}),
    '扇贝' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 1,getItem : [{name : '贝壳',minNum : 1, maxNum : 1},{name : '贝肉',minNum : 1, maxNum : 1},{name : '珍珠',minNum : 3, maxNum : 1}]}),
    '藤壶群' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 1,getItem : [{name : '藤壶',minNum : 1, maxNum : 2}]}),
    '蓝晶矿' : new Element({canGather :true, mopUp : true, time : 10, num : 3, needItem : ['铁镐','光荣镐'], getItem : [{name : '蓝水晶',minNum : 1, maxNum : 2},{name : '纯净水晶',minNum : 0, maxNum : 1}]}),

    '羊群' : new Element({canGather :true, mopUp : true, time : 30, num : 3, day : 5, getItem : [{name : '羊肉',minNum : 1, maxNum : 3},{name : '羊毛',minNum : 1, maxNum : 2}]}),
    '井' : new Element({canGather :true, mopUp : true, time : 3, num : 20, day : 2, getItem : [{name : '水',minNum : 2, maxNum : 4}]}),
    '杂物堆' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 3, getItem : [{name : '纤维',minNum : 1, maxNum : 3},{name : '木材',minNum : 1, maxNum : 2},{name : '树枝',minNum : 1, maxNum : 3}, {name : '草药膏',minNum : 1, maxNum : 1}]}),
    '宝箱' : new Element({canGather :true, mopUp : true, time : 5, num : 1, getItem : [{name : '紫晶',minNum : 1, maxNum : 2},{name : '灵魂晶粉',minNum : 3, maxNum : 2},{name : '紫晶之核',minNum : 8, maxNum : 1},{name : '疯狂之血',minNum : 8, maxNum : 1},{name : '疯狂的心',minNum : 8, maxNum : 1},{name : '神性结晶',minNum : 8, maxNum : 1},{name : '神性紫晶',minNum : 8, maxNum : 1},{name : '神性枢纽',minNum : 8, maxNum : 1},{name : '兽人必须死',minNum : 48, maxNum : 1},{name : '紫晶狂兽神',minNum : 98, maxNum : 1}]}),
    '紫晶簇' : new Element({canGather :true, mopUp : true, time : 60, num : 10, needItem : ['铁镐','光荣镐'], getItem : [{name : '紫晶',minNum : 1, maxNum : 3},{name : '魔力水晶',minNum : 0, maxNum : 1}]}),

    '灵魂草丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '灵魂草',minNum : 1, maxNum : 3}]}),
    '血肉魔树' : new Element({canGather :true, mopUp : true, time : 20, num : 10, day : 5, needItem : ['铁斧','光荣斧'], getItem : [{name : '木材',minNum : 1, maxNum : 2},{name : '树枝',minNum : 1, maxNum : 2},{name : '血肉果实',minNum : 1, maxNum : 2},{name : '血肉树心',minNum : 1, maxNum : 1}]}),
    '骨堆' : new Element({canGather :true, mopUp : true, time : 5, num : 5, day : 20,getItem : [{name : '骨头',minNum : 1, maxNum : 3},{name : '异化骨头',minNum : 0, maxNum : 1}]}),
    '尸体' : new Element({canGather :true, mopUp : true, time : 5, num : 5, day : 20,getItem : [{name : '异化血肉',minNum : 1, maxNum : 2},{name : '异化骨头',minNum : 0, maxNum : 1}]}),
    '活化血肉' : new Element({canGather :true, mopUp : true, time : 10, num : 5, day : 5, needItem : ['铁斧','光荣斧'], getItem : [{name : '异化血肉',minNum : 1, maxNum : 3}]}),
    '血水' : new Element({canGather :true, mopUp : true, time : 3, num : 10, day : 5, getItem : [{name : '异化血液',minNum : 1, maxNum : 3}]}),
    '巨大骨架' : new Element({canGather :true, mopUp : true, time : 20, num : 5, day : 20, needItem : ['铁镐','光荣镐'], getItem : [{name : '异化大骨',minNum : 1, maxNum : 1},{name : '异化骨头',minNum : 1, maxNum : 2}]}),
    '灵魂晶矿' : new Element({canGather :true, mopUp : true, time : 60, num : 5, day : 20, needItem : ['铁镐','光荣镐'], getItem : [{name : '灵魂结晶',minNum : 1, maxNum : 2}]}),
    '大块血肉' : new Element({canGather :true, mopUp : true, time : 5, num : 5, day : 20,getItem : [{name : '异化血肉',minNum : 2, maxNum : 4},{name : '异化血液',minNum : 1, maxNum : 2}]}),
    '烂家具' : new Element({canGather :true, mopUp : true, time : 10, num : 3, getItem : [{name : '纤维',minNum : 1, maxNum : 3},{name : '木材',minNum : 1, maxNum : 2},{name : '树枝',minNum : 1, maxNum : 3}]}),
    '物资箱' : new Element({canGather :true, mopUp : true, time : 10, num : 5, day : 30, getItem : [{name : '肉干',minNum : 1, maxNum : 2}, {name : '草药膏',minNum : 1, maxNum : 2}, {name : '荒骨之咬',minNum : 13, maxNum : 1}, {name : '赐福甲胄',minNum : 13, maxNum : 1}]}),

    '民宅' : new Element({canGather :true, time : 30, num : 1, getItem : [{name : '水果',minNum : 0, maxNum : 1}]}),
    '果树' : new Element({canGather :true, mopUp : true, time : 5, num : 5, day : 10, getItem : [{name : '水果',minNum : 2, maxNum : 3}]}),
    '房屋' : new Element({canGather :true, time : 30, num : 1, getItem : [{name : '裂开的红宝石',minNum : 48, maxNum : 1},{name : '裂开的黄宝石',minNum : 48, maxNum : 1},{name : '裂开的紫宝石',minNum : 48, maxNum : 1},{name : '裂开的绿宝石',minNum : 48, maxNum : 1},{name : '裂开的橙色宝石',minNum : 48, maxNum : 1}]}),
    '豪宅' : new Element({canGather :true, time : 60, num : 1, getItem : [{name : '完美的红宝石',minNum : 8, maxNum : 1},{name : '完美的黄宝石',minNum : 8, maxNum : 1},{name : '完美的紫宝石',minNum : 8, maxNum : 1},{name : '完美的绿宝石',minNum : 8, maxNum : 1},{name : '完美的橙色宝石',minNum : 8, maxNum : 1}]}),
    '城主府' : new Element({canGather :true, time : 120, num : 1, getItem : [{name : '璀璨的红宝石',minNum : 1, maxNum : 1},{name : '璀璨的黄宝石',minNum : 1, maxNum : 1},{name : '璀璨的紫宝石',minNum : 1, maxNum : 1},{name : '璀璨的绿宝石',minNum : 1, maxNum : 1},{name : '璀璨的橙色宝石',minNum : 1, maxNum : 1},{name : 'co',minNum : 3, maxNum : 1},{name : 'fen',minNum : 48, maxNum : 1},{name : 'ur',minNum : 88, maxNum : 1},{name : 'beta',minNum : 198, maxNum : 1},{name : 'tir',minNum : 498, maxNum : 1}]}),


    //采集或使用时可以获得的资源
    '观音土' : new Element({canUse :true, voidDust : 0, hunger : 50, func : function(){
            data.maxHunger -= 5;
            if(!data.eatGyt){
                data.eatGyt = 0;
            }

            if(randomNum(1,100) <= 50){
                data.eatGyt = 0;
                data.maxHp -= 20;
                if(data.hp > data.maxHp){
                    data.hp = data.maxHp
                }
            }else{
                data.eatGyt++;
                if(data.eatGyt >= 5){
                    if(!conf.races){
                        conf.races = [];
                    }
                    if(conf.races.indexOf('操脑蛛') === -1){
                        conf.races.push('操脑蛛');
                        save(confSavedName, conf);
                        winMsg('恭喜你解锁了操脑蛛种族！');
                    }
                }
            }


            if(data.maxHp <= 0 || data.maxHunger < 0){
                $('.win').hide();
                $('.item-use-win-modal').hide();
                $('.item-use-win').hide();
                addDieLog('吃观音土导致最大生命或最大饥饿为降到0之下');
                die();
                return true;
            }

            return true;
        }, text : '使用木铲即可获得。使用减少5饥饿上限，50%概率减少20生命上限，饥饿上限为0时不能使用，使用后生命上限小于等于0或饥饿上限小于0，则直接死亡'}),
    '纤维' : new Element({elemental : {木 : 1}}),
    '小麦种子' : new Element({canUse : true, hunger : 1}),
    '草药' : new Element({canUse : true, hp : 2, voidDust : 3, gold : 15, elemental : {水 : 1}}),
    '木材' : new Element({weight : 3, voidDust : 3, gold : 15, elemental : {木 : 2, 土 : 1}}),
    '树枝' : new Element({elemental : {木 : 1}}),
    '燧石' : new Element({elemental : {金 : 1, 土 : 1}}),
    '石头' : new Element({weight : 3, voidDust : 2, gold : 10, elemental : {金 : 2, 土 : 1}}),
    '浆果' : new Element({canUse : true, hunger : 1, water : 1, gold : 5, elemental : {木 : 1, 水 : 1}}),
    '仙人掌肉' : new Element({canUse : true, hunger : 1, water : 1, gold : 5, elemental : {土 : 1, 水 : 1}}),
    '水' : new Element({canUse : true, water : 10, voidDust : 0, elemental : {水 : 1}}),
    '鱼' : new Element({canUse : true, weight : 2, hunger : 1, gold : 10, isMeat : true, elemental : {水 : 1}}),
    '铁矿' : new Element({weight : 3, gold : 10, elemental : {金 : 3, 土 : 5}}),
    '铜矿' : new Element({weight : 3, gold : 10, elemental : {金 : 3, 土 : 5}}),
    '金矿' : new Element({weight : 3, gold : 450, elemental : {金 : 3, 土 : 5}}),
    '魔晶石' : new Element({weight : 2, voidDust : 10, gold : 100, elemental : {极 : 2}}),
    '芦苇' : new Element({voidDust : 5, gold : 25, elemental : {木 : 1, 水 : 1}}),
    '贝壳' : new Element({voidDust : 5, gold : 25, elemental : {水 : 2, 金 : 1}}),
    '螃蟹' : new Element({canUse : true, hunger : 2, voidDust : 3, gold : 15, isMeat : true, elemental : {木 : 1, 土 : 2, 水 : 2}}),

    '蘑菇' : new Element({canUse : true, hunger : 1, gold : 5, elemental : {木 : 1, 土 : 1}}),
    '微光蘑菇' : new Element({canUse : true, hp : 3, voidDust : 5, gold : 25, elemental : {木 : 2, 土 : 1}}),
    '红水晶' : new Element({voidDust : 10, gold : 50, elemental : {火 : 5}}),
    '纯净水晶' : new Element({voidDust : 20, gold : 100, elemental : {极 : 5}}),
    '黑曜石' : new Element({weight : 3, voidDust : 10, gold : 50, elemental : {火 : 3, 土 : 2}}),

    '珊瑚' : new Element({voidDust : 4, gold : 20, elemental : {木 : 2}}),
    '贝肉' : new Element({canUse : true, hunger : 2, voidDust : 5, gold : 25, isMeat : true, elemental : {木 : 2, 水 : 1}}),
    '珍珠' : new Element({elemental : {木 : 2, 金 : 3}}),
    '藤壶' : new Element({canUse : true, hunger : 1, voidDust : 2, gold : 10, isMeat : true, elemental : {木 : 1, 水 : 1}}),
    '蓝水晶' : new Element({voidDust : 10, gold : 50, elemental : {水 : 5}}),

    '羊肉' : new Element({canUse : true, weight : 1, hunger : 2, voidDust : 10, gold : 50, isMeat : true, elemental : {木 : 2}}),
    '羊毛' : new Element({voidDust : 5, gold : 25, elemental : {木 : 1}}),
    '紫晶' : new Element({voidDust : 10, gold : 50, elemental : {极 : 1}}),
    '魔力水晶' : new Element({voidDust : 50, gold : 250, elemental : {极 : 3}}),

    '灵魂草' : new Element({canUse : true, hp : 5, voidDust : 4, gold : 20, elemental : {木 : 4, 水 : 2, 土 : 3}}),
    '血肉果实' : new Element({canUse : true, hunger : 5, hp : 5, voidDust : 10, gold : 50, isMeat : true, elemental : {木 : 1, 火 : 5, 土 : 2}}),
    '血肉树心' : new Element({canUse : true, battleUse : true, hp : 30, voidDust : 20, gold : 100, elemental : {木 : 2, 火 : 5, 土 : 2}}),
    '异化血肉' : new Element({voidDust : 10, gold : 50, elemental : {火 : 2}}),
    '异化骨头' : new Element({voidDust : 10, gold : 50, elemental : {土 : 3}}),
    '异化血液' : new Element({voidDust : 10, gold : 50, elemental : {火 : 2, 水 : 4}}),
    '异化大骨' : new Element({voidDust : 10, gold : 50, elemental : {土 : 4}}),
    '灵魂结晶' : new Element({voidDust : 30, gold : 150, elemental : {火 : 10}}),

    '肉干' : new Element({canUse : true, hunger : 20, voidDust : 10, gold : 50, isMeat : true}),
    '水果' : new Element({canUse : true, hunger : 5, water : 10, voidDust : 10, gold : 50}),

    ...newMapElements.elements,

    //怪物掉落物
    '粘液' : new Element({fromMonster : true, elemental : {水 : 1}}),
    '软皮' : new Element({fromMonster : true, elemental : {水 : 1}}),
    '碎布片' : new Element({fromMonster : true, elemental : {木 : 1}}),
    '铁片' : new Element({fromMonster : true, elemental : {金 : 1}}),
    '尖牙' : new Element({fromMonster : true, gold : 5, elemental : {金 : 1}}),
    '利爪' : new Element({fromMonster : true, gold : 5, elemental : {金 : 1}}),
    '兽皮' : new Element({fromMonster : true, gold : 5, elemental : {土 : 1}}),
    '肉' : new Element({fromMonster : true, canUse : true, weight : 2, hunger : 2, gold : 5, isMeat : true, elemental : {木 : 1}}),
    '蜘蛛丝' : new Element({fromMonster : true, gold : 5, elemental : {金 : 1}}),
    '毒囊' : new Element({fromMonster : true, gold : 5, elemental : {土 : 1}}),
    '蛇胆' : new Element({fromMonster : true, voidDust : 3, gold : 10, elemental : {木 : 2}}),
    '甲壳' : new Element({fromMonster : true, voidDust : 2, gold : 5, elemental : {金 : 2}}),
    '羽毛' : new Element({fromMonster : true, voidDust : 2, gold : 10, elemental : {火 : 1}}),
    '哥布林之心' : new Element({fromMonster : true, canUse : true, hunger : 30, voidDust : 20, gold : 250, isMeat : true, elemental : {木 : 10},
        func : function(){
            if(data.eatGoblinHart == null){
                data.eatGoblinHart = 0;
            }
            data.eatGoblinHart++;
            if(data.eatGoblinHart >= 100 && conf.races.indexOf('食人魔') === -1){
                conf.races.push('食人魔');
                save(confSavedName, conf);
                winMsg('恭喜你解锁了食人魔种族！');
            }
            return true;
        }}),
    '哥布林魔晶' : new Element({fromMonster : true, voidDust : 50, gold : 1000, elemental : {金 : 10}}),
    '闪耀的皮' : new Element({fromMonster : true, voidDust : 1000, gold : 2500, elemental : {极 : 3}}),
    '神性结晶' : new Element({fromMonster : true, voidDust : 1000, gold : 5000, elemental : {极 : 10}}),
    '神性液体' : new Element({fromMonster : true, canUse : true, battleUse : true, water : 100, voidDust : 500, gold : 2500, elemental : {木 : 10, 水 : 10},
        func : function(){
            if(inBattle()){
                addObjWater(data, 100)
            }
            const text = `使用了神性液体，恢复${battleAddHp(data, (this.myHp ? this.myHp() : elementCfgs[this.name].myHp()))}HP，100水分`;
            msg(text);
            addBattleLog(text)

            if(data.race.name.startsWith('史莱姆') || data.race.name.startsWith('神性史莱姆')){
                if(data.divinity == null){
                    data.divinity = 0;
                }
                data.divinity += data.race.name.startsWith('神性史莱姆') ? 5 : 1;
                if(data.race.name.startsWith('史莱姆') && !data.getJhky && data.divinity >= 50){
                    data.getJhky = true;
                    addItem('进化刻印');
                }
            }
            return true;
        },
        myHp : function(){
            return 100;
        },text : '神性史莱姆使用时增加5点神性'}),

    '骨头' : new Element({fromMonster : true, elemental : {土 : 1}}),
    '魔核' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {金 : 1}}),
    '矮人胡环' : new Element({fromMonster : true, voidDust : 20, gold : 100, elemental : {金 : 3, 土 : 1}}),
    '硬皮' : new Element({fromMonster : true, voidDust : 10, gold : 50, elemental : {土 : 2}}),
    '硬壳' : new Element({fromMonster : true, voidDust : 10, gold : 50, elemental : {金 : 2}}),
    '兽骨' : new Element({fromMonster : true, voidDust : 10, gold : 50, elemental : {土 : 2, 木 : 1}}),
    '火结晶' : new Element({fromMonster : true, voidDust : 40, gold : 200, elemental : {火 : 3}}),
    '火焰灰烬' : new Element({fromMonster : true, voidDust : 30, gold : 150, elemental : {火 : 1}}),
    '灵魂残片' : new Element({fromMonster : true, voidDust : 30, gold : 150, elemental : {火 : 2}}),
    '血肉精华' : new Element({fromMonster : true, voidDust : 5, gold : 50, elemental : {木 : 3}}),
    '灵魂石' : new Element({fromMonster : true, canUse : true, battleUse : true, hp : 80, voidDust : 240, gold : 1200, elemental : {木 : 5, 火 : 3, 极 : 2}}),
    '残破的剑' : new Element({fromMonster : true, voidDust : 120, gold : 600, elemental : {金 : 10}}),
    '遗忘之魂' : new Element({fromMonster : true, canUse : true, voidDust : 1000, gold : 5000, elemental : {火 : 10}, func : function(){
            initAttr();
            winMsg('属性点已重置');
            return true;
        }, text : '重置属性点，说白了就是洗点道具啊！'}),
    '地穴领主之爪' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 5, 土 : 10}}),
    '地穴领主的壳' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 10, 土 : 8}}),
    '神性魂石' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {火 : 10, 极 : 10}}),
    '远古精魄' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {极 : 15}}),

    '鱼人鳞片' : new Element({fromMonster : true, voidDust : 10, gold : 50, elemental : {土 : 1}}),
    '鱼人牙齿' : new Element({fromMonster : true, voidDust : 10, gold : 50, elemental : {土 : 1}}),
    '鱼人眼球' : new Element({fromMonster : true, voidDust : 10, gold : 50, elemental : {木 : 1}}),
    '螃蟹壳' : new Element({fromMonster : true, voidDust : 10, gold : 50, elemental : {金 : 1, 木 : 1}}),
    '蟹肉' : new Element({fromMonster : true, canUse : true, hunger : 2, voidDust : 20, gold : 100, isMeat : true, elemental : {木 : 2}}),
    '巨大蟹钳' : new Element({fromMonster : true, voidDust : 20, gold : 100, elemental : {金 : 2, 木 : 1}}),
    '海胆毒刺' : new Element({fromMonster : true, voidDust : 20, gold : 100, elemental : {木 : 2}}),
    '海胆皮' : new Element({fromMonster : true, voidDust : 20, gold : 100, elemental : {火 : 1}}),
    '海龟壳' : new Element({fromMonster : true, voidDust : 30, gold : 150, elemental : {金 : 2}}),
    '藤壶' : new Element({fromMonster : true, canUse : true, hunger : 1, voidDust : 30, gold : 150, isMeat : true, elemental : {金 : 1, 木 : 2}}),
    '蓝鳞蛇皮' : new Element({fromMonster : true, voidDust : 30, gold : 150, elemental : {木 : 1, 水 : 2}}),
    '元素水' : new Element({fromMonster : true, voidDust : 30, gold : 150, elemental : {水 : 5}}),
    '水之核' : new Element({fromMonster : true, voidDust : 30, gold : 150, elemental : {水 : 3}}),
    '潮汐之眼' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {木 : 3, 水 : 5}}),
    '海浪之鳞' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {金 : 3, 水 : 5}}),
    '潮汐之心' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {木 : 3, 水 : 5}}),
    '海象角' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {土 : 3, 木 : 5, 水 : 10}}),
    '海象皮' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {木 : 5, 水 : 10}}),
    '海象牙' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {土 : 3, 木 : 5, 水 : 10}}),
    '蓝光鳞片' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {水 : 20, 极 : 10}}),
    '光辉鱼眼' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {木 : 15, 极 : 10}}),
    '冰凉鱼油' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {木 : 10, 水 : 10, 极 : 10}}),

    '史莱姆精华' : new Element({fromMonster : true, voidDust : 25, gold : 75, elemental : {水 : 10}}),
    '史莱姆核心' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {木 : 5, 水 : 7}}),
    '坚韧软皮' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {土 : 2, 水 : 5}}),
    '哥布林手爪' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {金 : 3, 木 : 5}}),
    '哥布林残刃' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {木 : 5, 土 : 2}}),
    '破口袋' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {木 : 5}}),
    '魔兽骨' : new Element({fromMonster : true, voidDust : 5, gold : 25, elemental : {木 : 2, 金 : 3}}),
    '魔兽皮' : new Element({fromMonster : true, voidDust : 5, gold : 25, elemental : {木 : 3, 土 : 5}}),
    '魔兽肉' : new Element({fromMonster : true, canUse : true, hunger : 2, voidDust : 5, gold : 25, isMeat : true, elemental : {木 : 5, 火 : 4}}),
    '魔兽爪' : new Element({fromMonster : true, voidDust : 5, gold : 25, elemental : {金 : 6}}),
    '暗影血肉' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 3, 土 : 4}}),
    '虎皮' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 2, 土 : 5}}),
    '角蛇的角' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {金 : 8}}),
    '血肉花蕊' : new Element({fromMonster : true, canUse : true, hunger : 10, voidDust : 70, gold : 350, isMeat : true, elemental : {木 : 8, 水 : 5}}),
    '柔韧根茎' : new Element({fromMonster : true, voidDust : 80, gold : 400, elemental : {木 : 10, 水 : 2, 土 : 5}}),
    '食人花汁' : new Element({fromMonster : true, canUse : true, hp : 5, voidDust : 70, gold : 350, elemental : {木 : 3, 水 : 8}}),
    '疾风鹰羽' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 3, 金 : 5}}),
    '雷角' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {极 : 3, 金 : 5}}),
    '蝎尾狮的尾巴' : new Element({fromMonster : true, voidDust : 120, gold : 600, elemental : {土 : 7, 金 : 3}}),
    '兽人之牙' : new Element({fromMonster : true, voidDust : 140, gold : 700, elemental : {木 : 2, 金 : 5}}),
    '兽人之心' : new Element({fromMonster : true, voidDust : 160, gold : 800, elemental : {木 : 10, 火 : 5}}),
    '灵魂晶粉' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {火 : 10}}),
    '紫晶之核' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {木 : 3, 金 : 2}}),
    '疯狂之血' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {火 : 10, 极 : 1}}),
    '疯狂的心' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {木 : 10, 极 : 1}}),
    '神性紫晶' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {火 : 20, 极 : 3}}),
    '神性枢纽' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {金 : 20, 极 : 2}}),

    '强酸粘液' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {土 : 5, 水 : 3}}),
    '酸性软皮' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {土 : 5, 木 : 2}}),
    '战刀残片' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {金 : 5}}),
    '重甲零件' : new Element({fromMonster : true, voidDust : 100, gold : 500, elemental : {金 : 5}}),
    '狼鞍' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {木 : 3, 土 : 5}}),
    '骨头杖' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 2, 土 : 4}}),
    '骨头项链' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 1, 木 : 5}}),
    '骨刺' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 8}}),
    '毒牙' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 3, 土 : 8}}),
    '幽灵蛛丝' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {火 : 5, 金 : 2}}),
    '幽灵毒囊' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {火 : 5, 土 : 2}}),
    '剧毒尾刺' : new Element({fromMonster : true, voidDust : 150, gold : 750, elemental : {金 : 3, 土 : 5}}),
    '重壳' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {木 : 5, 土 : 5}}),
    '巨爪' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 10, 木 : 3}}),
    '巨牙' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 10}}),
    '重皮' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {土 : 10, 火 : 2}}),
    '荒芜之核' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {土 : 10, 极 : 1}}),
    '亚龙鳞' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 10, 火 : 3}}),
    '亚龙肉' : new Element({fromMonster : true, canUse : true, hunger : 2, voidDust : 20, gold : 100, isMeat : true, elemental : {木 : 5, 火 : 1}}),
    '青牙' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 5, 土 : 5}}),
    '青牙兽皮' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {木 : 5, 土 : 3}}),
    '黄酮鳞' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {金 : 3, 水 : 5, 土 : 3}}),
    '黄酮胆' : new Element({fromMonster : true, voidDust : 200, gold : 1000, elemental : {木 : 10, 水 : 5}}),
    '大地之牙' : new Element({fromMonster : true, voidDust : 250, gold : 1250, elemental : {金 : 3, 土 : 15}}),
    '大地之皮' : new Element({fromMonster : true, voidDust : 250, gold : 1250, elemental : {木 : 3, 土 : 15}}),
    '氏族旗帜' : new Element({fromMonster : true, voidDust : 300, gold : 1500, elemental : {木 : 15}}),
    '兽人獠牙' : new Element({fromMonster : true, voidDust : 300, gold : 1500, elemental : {金 : 10, 木 : 5}}),
    '五彩蛟麟' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {金 : 10, 木 : 5, 水 : 5, 火 : 5, 土 : 5}}),
    '魔蛟精血' : new Element({fromMonster : true, voidDust : 800, gold : 4000, elemental : {金 : 5, 木 : 5, 水 : 10, 火 : 5, 土 : 5}}),
    '魔蛟骨髓' : new Element({fromMonster : true, canUse : true, hp : 200, voidDust : 800, gold : 4000, elemental : {金 : 5, 木 : 5, 水 : 5, 火 : 10, 土 : 5}}),
    '不死印记' : new Element({voidDust : 2000, gold : 10000, elemental : {极 : 10}}),
    '不灭灵魂' : new Element({voidDust : 2000, gold : 10000, elemental : {火 : 20, 极 : 3}}),
    '骑士颅骨' : new Element({fromMonster : true, voidDust : 1000, gold : 5000, elemental : {金 : 15}}),
    '残破徽章' : new Element({fromMonster : true, voidDust : 1000, gold : 5000, elemental : {金 : 10, 土 : 10}}),
    '魔餍魂核' : new Element({fromMonster : true, voidDust : 1000, gold : 5000, elemental : {火 : 15}}),
    '荒芜核心' : new Element({fromMonster : true, voidDust : 1200, gold : 6000, elemental : {土 : 30}}),
    '荒芜麟爪' : new Element({fromMonster : true, voidDust : 1200, gold : 6000, elemental : {金 : 15, 土 : 15}}),
    '龙晶' : new Element({fromMonster : true, voidDust : 6000, gold : 30000, elemental : {火 : 20, 极 : 10}}),
    '幼龙鳞' : new Element({fromMonster : true, voidDust : 1200, gold : 6000, elemental : {火 : 15, 金 : 10}}),
    '幼龙皮' : new Element({fromMonster : true, voidDust : 1200, gold : 6000, elemental : {木 : 20, 火 : 10}}),

    '骸骨' : new Element({fromMonster : true, voidDust : 550, gold : 1250, elemental : {土 : 10}}),
    '亡灵骨刀' : new Element({fromMonster : true, voidDust : 550, gold : 1250, elemental : {金 : 5, 土 : 5}}),
    '亡灵骨杖' : new Element({fromMonster : true, voidDust : 550, gold : 1250, elemental : {木 : 5, 土 : 5}}),
    '尸水' : new Element({fromMonster : true, voidDust : 550, gold : 1250, elemental : {水 : 10, 木 : 3}}),
    '尸核' : new Element({fromMonster : true, voidDust : 550, gold : 1250, elemental : {木 : 8, 火 : 3}}),
    '幽魂碎片' : new Element({fromMonster : true, voidDust : 330, gold : 1650, elemental : {火 : 5, 极 : 2}}),
    '幽魂核心' : new Element({fromMonster : true, voidDust : 330, gold : 1650, elemental : {金 : 3, 极 : 5}}),
    '尸毒牙' : new Element({fromMonster : true, voidDust : 330, gold : 1650, elemental : {金 : 2, 土 : 10}}),
    '尸毒蛇皮' : new Element({fromMonster : true, voidDust : 330, gold : 1650, elemental : {木 : 3, 土 : 8}}),
    '灵魂血肉' : new Element({fromMonster : true, voidDust : 330, gold : 1650, elemental : {木 : 10, 火 : 3}}),
    '血肉核心' : new Element({fromMonster : true, voidDust : 330, gold : 1650, elemental : {木 : 8, 土 : 8}}),
    '染血屠刀' : new Element({fromMonster : true, voidDust : 330, gold : 1650, elemental : {木 : 5, 土 : 5}}),
    '尸巫法杖' : new Element({fromMonster : true, voidDust : 410, gold : 2050, elemental : {木 : 3, 火 : 10}}),
    '亡灵法核' : new Element({fromMonster : true, voidDust : 410, gold : 2050, elemental : {金 : 5, 火 : 8}}),
    '吸血鬼牙' : new Element({fromMonster : true, voidDust : 410, gold : 2050, elemental : {金 : 5, 木 : 10}}),
    '血族翅膀' : new Element({fromMonster : true, voidDust : 410, gold : 2050, elemental : {水 : 5, 木 : 8}}),
    '亡灵碎石' : new Element({fromMonster : true, voidDust : 410, gold : 2050, elemental : {金 : 5, 土 : 10}}),
    '血肉石翼' : new Element({fromMonster : true, voidDust : 410, gold : 2050, elemental : {木 : 8, 土 : 8}}),
    '骷髅马鞍' : new Element({fromMonster : true, voidDust : 490, gold : 2450, elemental : {木 : 5, 金 : 8}}),
    '骷髅骑枪' : new Element({fromMonster : true, voidDust : 490, gold : 2450, elemental : {金 : 10}}),
    '血魔之心' : new Element({fromMonster : true, voidDust : 490, gold : 2450, elemental : {木 : 5, 土 : 5}}),
    '血魔残骸' : new Element({fromMonster : true, voidDust : 490, gold : 2450, elemental : {水 : 10, 木 : 5}}),
    '怨恨之魂' : new Element({fromMonster : true, voidDust : 490, gold : 2450, elemental : {火 : 10, 极 : 2}}),
    '诅咒核心' : new Element({fromMonster : true, voidDust : 490, gold : 2450, elemental : {土 : 10, 极 : 3}}),
    '死灵之书' : new Element({fromMonster : true, voidDust : 2400, gold : 12000, elemental : {木 : 20, 火 : 15}}),
    '灵魂护符' : new Element({fromMonster : true, voidDust : 2400, gold : 12000, elemental : {金 : 15, 火 : 20}}),
    '特制尸油' : new Element({fromMonster : true, voidDust : 2400, gold : 12000, elemental : {土 : 10, 水 : 15}}),
    '精铁断剑' : new Element({fromMonster : true, voidDust : 3200, gold : 16000, elemental : {金 : 30}}),
    '大剑士徽章' : new Element({fromMonster : true, voidDust : 3200, gold : 16000, elemental : {金 : 15, 土 : 15}}),
    '龙鳞' : new Element({fromMonster : true, voidDust : 7000, gold : 30000, elemental : {火 : 20, 金 : 20}}),
    '龙皮' : new Element({fromMonster : true, voidDust : 3200, gold : 16000, elemental : {木 : 15, 火 : 30}}),
    '龙血' : new Element({fromMonster : true, voidDust : 2400, gold : 12000, elemental : {木 : 10, 水 : 20, 火 : 10}}),
    '诅咒魂晶' : new Element({fromMonster : true, voidDust : 8000, gold : 40000, elemental : {极 : 20}}),

    '精密骨骼' : new Element({fromMonster : true, voidDust : 450, gold : 2250, elemental : {金 : 5, 土 : 10}}),
    '骨质大剑' : new Element({fromMonster : true, voidDust : 450, gold : 2250, elemental : {金 : 10, 土 : 5}}),
    '战士徽章' : new Element({fromMonster : true, voidDust : 450, gold : 2250, elemental : {金 : 5, 木 : 10}}),
    '赐福铠甲' : new Element({fromMonster : true, voidDust : 450, gold : 2250, elemental : {金 : 10, 火 : 5}}),
    '巨魔骨矛' : new Element({fromMonster : true, voidDust : 450, gold : 2250, elemental : {金 : 10, 土 : 5}}),
    '巨魔颅骨' : new Element({fromMonster : true, voidDust : 450, gold : 2250, elemental : {火 : 3, 土 : 12}}),
    '魔法宝石' : new Element({fromMonster : true, voidDust : 600, gold : 3000, elemental : {火 : 5, 水 : 5, 土 : 5}}),
    '法师帽' : new Element({fromMonster : true, voidDust : 600, gold : 3000, elemental : {木 : 15}}),
    '精密断弓' : new Element({fromMonster : true, voidDust : 600, gold : 3000, elemental : {金 : 2, 木 : 10}}),
    '附魔箭矢' : new Element({fromMonster : true, voidDust : 600, gold : 3000, elemental : {木 : 8, 金 : 1}}),
    '灰白的皮' : new Element({fromMonster : true, voidDust : 600, gold : 3000, elemental : {金 : 10, 土 : 5}}),
    '枯朽粘液' : new Element({fromMonster : true, voidDust : 600, gold : 3000, elemental : {水 : 10, 土 : 5}}),
    '赐福长枪' : new Element({fromMonster : true, voidDust : 750, gold : 3750, elemental : {金 : 10, 极 : 3}}),
    '骑士徽章' : new Element({fromMonster : true, voidDust : 750, gold : 3750, elemental : {金 : 8, 木 : 8}}),
    '鲜血图腾' : new Element({fromMonster : true, voidDust : 750, gold : 3750, elemental : {水 : 3, 木 : 8, 土 : 5}}),
    '鲜血骨爪' : new Element({fromMonster : true, voidDust : 750, gold : 3750, elemental : {水 : 5, 土 : 10}}),
    '元素印记' : new Element({fromMonster : true, voidDust : 750, gold : 3750, elemental : {金 : 4, 木 : 4, 水 : 4, 火 : 4, 土 : 4}}),
    '女巫徽章' : new Element({fromMonster : true, voidDust : 750, gold : 3750, elemental : {金 : 6, 木 : 10}}),
    '冠军凭证' : new Element({fromMonster : true, voidDust : 8000, gold : 40000, elemental : {水 : 5, 土 : 10}}),
    '神赐徽章' : new Element({fromMonster : true, canUse : true, voidDust : 10000, gold : 50000, quality : 4, func : function(){
            const location = data.temples[data.worldIndex][data.location.join()];
            if(!location){
                winMsg('只能在神殿使用', false, false);
                return false;
            }
            const deity = location.deity;
            if(data.deitys[deity].godFavor >= 1000){
                data.deitys[deity].godFavor -= 1000;
                data.deitys[deity].belief += 1000;
                winMsg(`你使用了神赐徽章，${deity}的神眷-1000，信仰+1000`);
                return true;
            }else{
                winMsg('神眷不足', false, false);
                return false;
            }
            return true;
        }, text : '只能在神殿使用，将当前神殿对应神灵的1000神眷转为1000信仰。'}),
    '赐福神力' : new Element({fromMonster : true, voidDust : 8000, gold : 40000, elemental : {极 : 30}}),
    '神圣重锤' : new Element({fromMonster : true, voidDust : 8000, gold : 40000, text : '带有神力的锤子，你可以用它给普通品质的装备锤炼，有可能锤炼出更高的品质，概率和锻造相同，受锻造熟练度影响。特别提醒：先做符文之语，再锤炼品质的话，不就可以获得高品质的神符之语装备了！'}),
    '龙魂' : new Element({fromMonster : true, voidDust : 6000, gold : 30000, elemental : {火 : 30}}),
    '巨龙之殇' : new Element({fromMonster : true, voidDust : 12000, gold : 60000, elemental : {木 : 20, 极 : 5}}),

    '负重锁链' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {金 : 20}}),
    '染血锁环' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {水 : 5, 金 : 15}}),
    '狂信徽章' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {火 : 10, 土 : 10}}),
    '信仰雕像' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {火 : 5, 土 : 15}}),
    '卫士之盾' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {金 : 15, 木 : 5}}),
    '卫士徽章' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {金 : 5, 木 : 15}}),
    '制式战弓' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {木 : 15, 金 : 5}}),
    '制式箭矢' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {木 : 10, 金 : 5}}),
    '猎人陷阱' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {金 : 5, 木 : 10, 土 : 5}}),
    '鲜血毛皮' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {水 : 5, 木 : 10, 火 : 5}}),
    '淬毒匕首' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {金 : 10, 木 : 5, 土 : 5}}),
    '精铁钩爪' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {金 : 5, 木 : 5, 火 : 10}}),
    '浸水皮' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {水 : 10, 木 : 5, 土 : 5}}),
    '战兽爪' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {金 : 8, 木 : 8, 土 : 4}}),
    '白鳞' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {金 : 5, 木 : 10, 水 : 5}}),
    '白皮' : new Element({fromMonster : true, voidDust : 930, gold : 4650, elemental : {水 : 5, 木 : 10, 土 : 5}}),
    '女妖手爪' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {金 : 7, 木 : 8, 火 : 5}}),
    '女妖翅膀' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {火 : 3, 木 : 15, 水 : 2}}),
    '女妖心脏' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {木 : 20}}),
    '飓风魔核' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {火 : 10, 木 : 5, 水 : 5}}),
    '飓风魔皮' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {火 : 5, 木 : 10, 水 : 5}}),
    '龙兽肝脏' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {木 : 10, 土 : 10}}),
    '荣耀长枪' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {金 : 10, 木 : 10}}),
    '荣耀马鞍' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {金 : 5, 木 : 5, 土 : 10}}),
    '神圣连枷' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {金 : 5, 火 : 10, 土 : 5}}),
    '神圣长袍' : new Element({fromMonster : true, voidDust : 1160, gold : 5800, elemental : {水 : 5, 木 : 10, 火 : 5}}),
    '水晶空瓶' : new Element({fromMonster : true, voidDust : 3200, gold : 16000, elemental : {土 : 10, 极 : 10}}),
    '战争号角' : new Element({fromMonster : true, voidDust : 4800, gold : 24000, elemental : {火 : 10, 木 : 10, 土 : 10}}),
    '沙尘印记' : new Element({fromMonster : true, voidDust : 8000, gold : 40000, elemental : {金 : 10, 土 : 30}}),
    '暴风龙眼' : new Element({fromMonster : true, voidDust : 8000, gold : 40000, elemental : {火 : 10, 水 : 20, 土 : 10}}),

    '烈焰亚龙牙' : new Element({fromMonster : true, voidDust : 2000, gold : 10000, elemental : {木 : 10, 火 : 15}}),
    '冰霜亚龙牙' : new Element({fromMonster : true, voidDust : 2000, gold : 10000, elemental : {木 : 10, 水 : 15}}),
    '剧毒亚龙牙' : new Element({fromMonster : true, voidDust : 2000, gold : 10000, elemental : {木 : 10, 土 : 15}}),
    '黑暗亚龙牙' : new Element({fromMonster : true, voidDust : 2000, gold : 10000, elemental : {木 : 10, 金 : 15}}),
    '红龙魂' : new Element({voidDust : 9000, gold : 45000, elemental : {火 : 30}}),
    '蓝龙魂' : new Element({voidDust : 9000, gold : 45000, elemental : {水 : 30}}),
    '绿龙魂' : new Element({voidDust : 9000, gold : 45000, elemental : {土 : 30}}),
    '黑龙魂' : new Element({voidDust : 9000, gold : 45000, elemental : {金 : 30}}),

    '草木神力精华' : new Element({voidDust : 0, gold : 0, quality : 4, text : '草木之神的神力精华'}),
    '森林神力精华' : new Element({voidDust : 0, gold : 0, quality : 4, text : '森林之神的神力精华'}),
    '山脉神力精华' : new Element({voidDust : 0, gold : 0, quality : 4, text : '山脉之神的神力精华'}),
    '大地神力精华' : new Element({voidDust : 0, gold : 0, quality : 4, text : '大地之神的神力精华'}),
    '生命神力精华' : new Element({voidDust : 0, gold : 0, quality : 4, text : '生命之神的神力精华'}),
    '弑神之证' : new Element({voidDust : 0, gold : 0, text : '杀死主神的证明'}),

    ...newMapElements.monsterItems,

    '10级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '10级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),

    '20级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '20级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),

    '30级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '30级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),

    '40级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '40级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),

    '50级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '50级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),

    '60级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '60级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),

    '70级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '70级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),

    '80级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '80级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '90级武器打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给武器增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '90级护甲打孔石' : new Element({voidDust : 1000, gold : 5000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '可以在装备打孔器给护甲增加1个孔，给不大于打孔石等级的装备打孔100%成功，打孔的装备每比打孔石高1级，成功率降低3%，用打孔石增加的孔数最多可以增加到9个'}),
    '万能武器打孔石' : new Element({voidDust : 10000, gold : 2000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '只能从藏宝图的宝藏中获得，可以在装备打孔器给武器增加1个孔，用万能打孔石增加的孔数最多可以增加到12个'}),
    '万能护甲打孔石' : new Element({voidDust : 10000, gold : 2000, quality : 4, func : function(){
            winMsg('请在装备打孔器使用', false, false)
            return false;
        }, text : '只能从藏宝图的宝藏中获得，可以在装备打孔器给护甲增加1个孔，用万能打孔石增加的孔数最多可以增加到12个'}),
    ...getBatchItem([1,2,4,8,16,32,64,128,256],function(e){
        return {
            [`世界之力：${e}点`] : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(item){
                    if(!data.worldPower){
                        data.worldPower = 0;
                    }
                    let count = 0;

                    data.bag.filter(f => f.name.startsWith('世界之力：')).forEach(i => {
                        count += parseInt(i.name.replace('世界之力：','').replace('点','')) * i.quantity;
                        if(i.id === item.id){
                            if(item.quantity > 1){
                                reduceItemById(i.id, i.quantity - 1)
                            }
                        }else{
                            reduceItemById(i.id, i.quantity)
                        }
                    })

                    data.worldPower += count;
                    winMsg(`获得${count}点世界之力`)
                    return true;
                }, text : '使用时，会自动用掉背包中所有的世界之力，并且获得对应的世界之力点数'})
        }
    }),

    '次元移动' : new Element({canUse : true, voidDust : 100, gold : 500, quality : 2, func : function(){
            data.safeRun = true;
            return true;
        }, text : '使用后不会被怪物主动攻击，当进行采集或者触发战斗时失效'}),
    '扭曲怀表' : new Element({canUse : true, voidDust : 100, gold : 500, quality : 2, func : function(){
            if(!confirm('是否确认使用扭曲怀表？')){
                return false;
            }
            if(data.weapon){
                equip(data.weapon)
            }
            if(data.armor){
                equip(data.armor)
            }

            //断肠人扭曲怀表标记达成
            if(data.dcrRaceFlag && (diff === '扩展难度' ? data.race.name === '断肠人-独竹' : data.race.name === '断肠人-黑邪')){
                data.dcrNqhbFlag = true;
                says(['鸳……等我'])
            }

            data.race = races[data.race.name.split('-')[0]];
            //蜥蜴人先祖附魔清空
            if(data.patriarchEnchantWeapon){
                data.atk -= data.patriarchEnchantWeapon.atk || 0;
                data.def -= data.patriarchEnchantWeapon.def || 0;
                data.reduceHart -= data.patriarchEnchantWeapon.defProp || 0;
                data.maxHp -= data.patriarchEnchantWeapon.hp || 0;
                data.suck -= data.patriarchEnchantWeapon.suck || 0;
                data.patriarchEnchantWeapon = null;
            }
            if(data.patriarchEnchantArmor){
                data.atk -= data.patriarchEnchantArmor.atk || 0;
                data.def -= data.patriarchEnchantArmor.def || 0;
                data.reduceHart -= data.patriarchEnchantArmor.defProp || 0;
                data.maxHp -= data.patriarchEnchantArmor.hp || 0;
                data.suck -= data.patriarchEnchantArmor.suck || 0;
                data.patriarchEnchantArmor = null;
            }

            if(data.race.name === '吸血鬼-伯爵'){
                data.suck -= 60;
            }
            if(data.race.name === '吸血鬼-亲王'){
                data.suck -= 100;
            }
            if(data.race.name === '半人马-轻骑兵'){
                data.spd -= 100;
            }
            if(data.race.name === '半人马-重骑兵'){
                data.suck += 50;
            }

            data.level = 1;
            data.exp = 0;
            initAttr();
            return true;
        }, text : '流浪商人独家出售，让你回到1级，经验清空，并变为初始种族（即重置觉醒，例如你现在是人类-战士，使用后变为人类），并自动进行一次洗点，自动脱下武器和护甲，蜥蜴人则会丢失身上的先祖附魔'}),
    '贤者之石' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 0, quality : 4, func : function(){
            if(!confirm('是否确认使用贤者之石？你背包或者仓库里还没使用的神话之力和神话诅咒将会浪费哦！')){
                return false;
            }

            const race = data.race.name.split('-')[0]

            if(data.weapon){
                equip(data.weapon)
            }
            if(data.armor){
                equip(data.armor)
            }
            if(data.bagEquip){
                equipBag(data.bagEquip)
            }
            if(data.mount){
                equipMount(data.mount)
            }

            data.bag = data.bag.filter(e => e.isAmulet || e.saveOrder);
            addItem('周目礼包',5 * data.order)
            addItem('成就礼包')
            if(data.dlcKeepDark){
                addItem('火把', 5);
            }

            //记录速通时间
            if(!conf.bestPassTime){
                conf.bestPassTime = {};
            }
            if(data.order === 1){
                if(conf.bestPassTime[race]){
                    if(data.startTime < conf.bestPassTime[race]){
                        conf.bestPassTime[race] = data.startTime;
                        save(confSavedName, conf);
                    }
                }else{
                    conf.bestPassTime[race] = data.startTime;
                    save(confSavedName, conf);
                }
            }

            data.passAll = false;
            data.order++;
            data.reduceHart = 0;
            data.spd = 0;
            data.suck = 0;

            //记录最高周目
            if(!conf.maxOrder){
                conf.maxOrder = 1;
            }
            if(data.order > conf.maxOrder){
                conf.maxOrder = data.order;
                save(confSavedName, conf);
            }
            //记录种族最高周目
            if(!conf.raceMaxOrder){
                conf.raceMaxOrder = {};
            }
            conf.raceMaxOrder[race] = conf.raceMaxOrder[race] || 0;
            if(data.order > conf.raceMaxOrder[race]){
                conf.raceMaxOrder[race] = data.order;
                save(confSavedName, conf);
            }

            //种族周目点数
            if(!conf.raceMaxOrder){
                conf.raceMaxOrder = {};
            }
            let num = 0;
            Object.keys(conf.raceMaxOrder).forEach(e => {
                num += conf.raceMaxOrder[e] - 1;
            });
            data.orderPoint = num;

            //卖出所有赞助点数的股票
            if(data.stock){
                Object.keys(data.stock['赞助点数']).filter(e => data.stock['赞助点数'][e].has).forEach(name => {
                    let {has, price} = data.stock['赞助点数'][name];
                    price = price * 0.99;
                    data.sponsorPoint += has * price;
                    data.sponsorPoint = parseFloat2Fiexd(data.sponsorPoint);
                })
            }
            //清理股票
            data.stock = null;

            data.race = races[race];
            data.race.attrPoint += 2;
            data.race.onCreate();
            data.level = 1;
            data.gold = 0;
            data.evil = 0;
            //蜥蜴人先祖附魔清空
            if(data.patriarchEnchantWeapon){
                data.atk -= data.patriarchEnchantWeapon.atk || 0;
                data.def -= data.patriarchEnchantWeapon.def || 0;
                data.reduceHart -= data.patriarchEnchantWeapon.defProp || 0;
                data.maxHp -= data.patriarchEnchantWeapon.hp || 0;
                data.suck -= data.patriarchEnchantWeapon.suck || 0;
                data.patriarchEnchantWeapon = null;
            }
            if(data.patriarchEnchantArmor){
                data.atk -= data.patriarchEnchantArmor.atk || 0;
                data.def -= data.patriarchEnchantArmor.def || 0;
                data.reduceHart -= data.patriarchEnchantArmor.defProp || 0;
                data.maxHp -= data.patriarchEnchantArmor.hp || 0;
                data.suck -= data.patriarchEnchantArmor.suck || 0;
                data.patriarchEnchantArmor = null;
            }

            //操脑蛛清掉操控的怪物
            data.control = null;

            //清除复活标记
            data.bind = null;

            //清理掉佛门属性
            data.merit = 0;
            data.karma = 0;

            //清空魅魔气息
            data.blood = [];

            initAttr();
            $(`.win`).hide();

            data.worldIndex = 0;
            data.maps = [mapConfig[data.worldIndex].getRandom()];
            data.world = {
                ...data.maps[data.worldIndex]
            }
            data.date = initDate;
            if(data.dlcWorldEnd){
                data.doomsday = data.date.format('yyyy-MM-dd')
            }
            if(data.edu){
                data.edu.eatDay = data.date;
                data.edu.sayDay = data.date;
            }
            data.temples = {};

            data.nextPoint = null;//前往下一个世界的坐标
            data.prePoint = null;//前往上一个世界的坐标
            //生成地图
            data.map = createMap(terrainArray[data.maps[data.worldIndex].name]);
            //创建初始世界
            data.world = {
                ...data.world,
                map : data.map,//世界地图
                showMap : {},//key为显坐标，value为1则代表已经显示出来，否则就是空白显示
                mapElements : {},//地图元素集合
                home : {
                    location : []//家的坐标[1,2]
                },
                nextPoint : data.nextPoint,
                prePoint : data.prePoint,
                pass : false,//用于记录是否通关，即是否已经战胜守关BOSS
                //神话怪物
                mythMonster : data.maps[data.worldIndex].mythMonster.map(e => ({name : e, location : [randomNum(0,xnum - 1), randomNum(0,ynum - 1)],day : new Date(data.date).format('yyyyMMdd')}))
            }
            data.worlds = [data.world];
            saveWorlds();
            //经验
            data.exp = 0;
            //清空神眷和信仰
            data.deitys = {};
            Object.keys(deitys).forEach(e =>{
                if(!data.deitys[e]){
                    data.deitys[e] = {
                        godFavor : 0,//神眷
                        belief : 0,//信仰
                    };
                }
            })
            //种族初始信仰和神眷
            if(data.race.deity){
                data.deitys[data.race.deity.name].godFavor = data.race.deity.godFavor;
                data.deitys[data.race.deity.name].belief = data.race.deity.belief;
            }

            //种族特有属性清空
            data.mucus = 0;
            data.soul = 0;
            data.divinity = 0;
            data.spi = 0;
            data.useEmbs = 0;

            //已学习的锻造配方
            data.race.initItems.forEach(e => {
                addItem(e.name, e.num)
            })
            addItem('心灵洗涤泉水', 10)

            //初始地点
            const x = randomNum(0,xnum - 1);
            const y = randomNum(0,ynum - 1);
            data.location = [x,y];
            //初始状态时间，记录最后一次状态变化的时间
            data.statusDate = data.date;
            //将当前坐标和四周坐标设置为已探索
            setShowMap();
            //渲染属性
            renderAttrs();
            //渲染地图元素
            renderMapElements(isInit,true);
            //渲染可前往的地图
            renderCanToMap();
            //渲染地图
            renderMap();

            //更改存档种族
            if(!conf.saveListNames){
                conf.saveListNames = {};
            }
            if(!conf.saveListNames[conf.savedName] || conf.saveListNames[conf.savedName] !== data.race.name){
                conf.saveListNames[conf.savedName] = data.race.name
                save(confSavedName, conf);
            }

            msg(`恭喜你进入${data.order}周目`)

            //渲染神话怪状态
            renderMythStatus()
            //初始化股市
            initStock();

            backupSaved(false);
            return true;
        }, text : '使用后进入下一周目，获得（周目-1）*3个周目礼包，种族将变为当前种族的未觉醒初始种族，你的护身符如果放在背包中，则可以被带入下一周目，除了护身符之外无法携带任何物品到下一周目。剧情：你违抗了整个世界的意志，除了逃跑你别无选择。然而你无论逃到哪里都逃不出至高神的追捕，但是你可以选择逃到一个平行世界，重新开始，但是，一丝神力会追寻着你，你会过得更艰难。'}),

    //转生相关
    '巨龙血脉' : new Element({voidDust : 20000, gold : 100000}),
    '神血' : new Element({voidDust : 1000, gold : 5000, text : '神灵的血液，神恩商店也有出售。'}),

    '转生卷轴：巨龙' : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(){
            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('巨龙') !== -1){
                winMsg('你已经解锁巨龙种族！', false, false);
                return false;
            }
            conf.races.push('巨龙');
            save(confSavedName, conf);
            winMsg('恭喜你解锁了巨龙种族！');
            return true;
        }, text : '使用后解锁巨龙种族（新档生效，不会改变当前存档的种族）'}),
    '转生卷轴：水之神裔' : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(){
            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('水之神裔') !== -1){
                winMsg('你已经解锁水之神裔种族！', false, false);
                return false;
            }
            conf.races.push('水之神裔');
            save(confSavedName, conf);
            winMsg('恭喜你解锁了水之神裔种族！');
            return true;
        }, text : '使用后解锁水之神裔种族（新档生效，不会改变当前存档的种族）'}),
    '转生卷轴：狩猎神裔' : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(){
            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('狩猎神裔') !== -1){
                winMsg('你已经解锁狩猎神裔种族！', false, false);
                return false;
            }
            conf.races.push('狩猎神裔');
            save(confSavedName, conf);
            winMsg('恭喜你解锁了狩猎神裔种族！');
            return true;
        }, text : '使用后解锁狩猎神裔种族（新档生效，不会改变当前存档的种族）'}),
    '进化刻印' : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(){
            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('神性史莱姆') !== -1){
                winMsg('你已经解锁神性史莱姆种族！', false, false);
                return false;
            }
            conf.races.push('神性史莱姆');
            save(confSavedName, conf);
            winMsg('恭喜你解锁了神性史莱姆种族！');
            data.hasSlmjhs = true;
            addItem('史莱姆进化石');
            return true;
        }, text : '使用后解锁神性史莱姆种族（新档生效，不会改变当前存档的种族）'}),
    '史莱姆进化石' : new Element({canUse : true, voidDust : 0, gold : 0, quality : 4, func : function(){
            if(data.order > 1){
                winMsg('该物品只能在1周目使用', false, false)
                return false;
            }
            if(!data.race.name.startsWith('史莱姆')){
                winMsg('只有史莱姆能使用', false, false)
                return false;
            }
            data.race = races['神性史莱姆'];
            data.race.onCreate();
            data.exp = 0;
            data.level = 1;
            initAttr();
            winMsg('你变成神性史莱姆了！');
            return true;
        }, text : '已解锁神性史莱姆后，史莱姆进入游戏时获得该物品，使用进化刻印解锁神性史莱姆时也会获得该物品。该物品只有史莱姆能使用，使用后变为神性史莱姆种族，等级回到1级，经验清空，自动进行一次洗点。该物品只能在1周目使用'}),
    '影魔传说' : new Element({canUse : true, voidDust : 50, gold : 250, quality : 4, func : function(){
            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('影魔') !== -1){
                winMsg('你已经解锁影魔种族！', false, false);
                return false;
            }

            conf.races.push('影魔');
            save(confSavedName, conf);
            winMsg('使用后解锁影魔种族');
            return true;
        }, text : '解锁影魔种族（新档生效，不会改变当前存档的种族）。'}),
    ...getBatchItem(Object.keys(races).filter(e => e.includes('-') && races[e].godRace && !e.startsWith('断肠人')), function(name){
        return {
            [name] : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(){
                    return checkRaceOnceAwaken(name);
                }, text : `${name.split('-')[0]}觉醒道具，至少60级才可以使用，使用后觉醒天赋，变为${name}，等级回到60级，已有的经验依旧保持不变，并自动进行一次洗点。`})
        }
    }),
    '神灵之力' : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(){
            if(data.level < 90){
                winMsg('至少90级才可以使用！', false, false);
                return false;
            }
            if(!races[data.race.name || '人类'].godRace || races[data.race.name || '人类'].godRace === '-1'){
                winMsg('该种族无法二次觉醒！', false, false);
                return false;
            }
            //断肠人种族标记达成
            if(data.race.name === '断肠人-独竹' && !data.dcrRaceFlag){
                says(['神灵之力抚平了“泷”灵魂中的混乱，泷想起了当初和鸳双魂一体的日子，才知晓两人当初虽不得相见，却从未相离。可自己肝肠寸断之时，却无意间将鸳的灵魂磨灭，魂消魄散。两人本可为比翼鸟，却因为自己的软弱，使得鸳永不超生，二人更是连人鬼殊途都算不上，便是能入碧落黄泉却再也寻不到鸳了。被抚平的灵魂彻底崩溃，泷彻底的疯了，但心中却多了一丝更加疯狂的执念，不惜一切代价也想要完成的执念']);
                data.dcrRaceFlag = true;
            }
            if(diff === '扩展难度'){
                winMsg('扩展难度无法二次觉醒！', false, false);
                return false;
            }

            talentAwakening(races[data.race.name || '人类'].godRace, 90);
            winMsg('恭喜你完成了二次觉醒！');
            return true;
        }, text : '二次觉醒道具，至少90级才可以使用，使用变为当前种族对应的二转种族，等级回到90级，已有的经验依旧保持不变，并自动进行一次洗点。'}),

    //配方
    '图纸：软皮甲' : new Element({canUse : true, getForgeRate : '软皮甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：利齿匕首' : new Element({canUse : true, getForgeRate : '利齿匕首',text : '使用后在1级家的锻造台锻造'}),
    '图纸：兽皮甲' : new Element({canUse : true, getForgeRate : '兽皮甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：兽爪拳刃' : new Element({canUse : true, getForgeRate : '兽爪拳刃',text : '使用后在1级家的锻造台锻造'}),
    '图纸：甲壳衣' : new Element({canUse : true, getForgeRate : '甲壳衣',text : '使用后在1级家的锻造台锻造'}),
    '图纸：羽刃扇' : new Element({canUse : true, getForgeRate : '羽刃扇',text : '使用后在1级家的锻造台锻造'}),
    '图纸：哥布林杀手' : new Element({canUse : true, getForgeRate : '哥布林杀手',voidDust : 10,  gold : 50,text : '使用后在1级家的锻造台锻造'}),
    '图纸：弱小联合' : new Element({canUse : true, getForgeRate : '弱小联合',voidDust : 10,  gold : 50,text : '使用后在1级家的锻造台锻造'}),

    '图纸：冲锋甲' : new Element({canUse : true, getForgeRate : '冲锋甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：麦林之刃' : new Element({canUse : true, getForgeRate : '麦林之刃',text : '使用后在1级家的锻造台锻造'}),
    '图纸：矮人之心' : new Element({canUse : true, getForgeRate : '矮人之心',text : '使用后在1级家的锻造台锻造'}),
    '图纸：重锤' : new Element({canUse : true, getForgeRate : '重锤',text : '使用后在1级家的锻造台锻造'}),
    '图纸：残火盔甲' : new Element({canUse : true, getForgeRate : '残火盔甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：熔火剑' : new Element({canUse : true, getForgeRate : '熔火剑',text : '使用后在1级家的锻造台锻造'}),
    '图纸：疯狂撕咬' : new Element({canUse : true, getForgeRate : '疯狂撕咬',text : '使用后在1级家的锻造台锻造'}),
    '图纸：灵魂外壳' : new Element({canUse : true, getForgeRate : '灵魂外壳',text : '使用后在1级家的锻造台锻造'}),

    '图纸：鱼蟹锤' : new Element({canUse : true, getForgeRate : '鱼蟹锤',text : '使用后在1级家的锻造台锻造'}),
    '图纸：刺壳甲' : new Element({canUse : true, getForgeRate : '刺壳甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：鳞枪' : new Element({canUse : true, getForgeRate : '鳞枪',text : '使用后在1级家的锻造台锻造'}),
    '图纸：蓝龟板甲' : new Element({canUse : true, getForgeRate : '蓝龟板甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：碧水枪' : new Element({canUse : true, getForgeRate : '碧水枪',text : '使用后在1级家的锻造台锻造'}),
    '图纸：波涛甲' : new Element({canUse : true, getForgeRate : '波涛甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：潮汐权杖' : new Element({canUse : true, getForgeRate : '潮汐权杖',text : '使用后在1级家的锻造台锻造'}),
    '图纸：怒浪重皮' : new Element({canUse : true, getForgeRate : '怒浪重皮',text : '使用后在1级家的锻造台锻造'}),

    '图纸：战刀' : new Element({canUse : true, getForgeRate : '战刀',text : '使用后在1级家的锻造台锻造'}),
    '图纸：柔韧软甲' : new Element({canUse : true, getForgeRate : '柔韧软甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：魔兽锋芒' : new Element({canUse : true, getForgeRate : '魔兽锋芒',text : '使用后在1级家的锻造台锻造'}),
    '图纸：魔兽骨甲' : new Element({canUse : true, getForgeRate : '魔兽骨甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：元素冲击' : new Element({canUse : true, getForgeRate : '元素冲击',text : '使用后在1级家的锻造台锻造'}),
    '图纸：兽人战甲' : new Element({canUse : true, getForgeRate : '兽人战甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：兽人必须死' : new Element({canUse : true, getForgeRate : '兽人必须死',text : '使用后在1级家的锻造台锻造'}),
    '图纸：紫晶狂兽神' : new Element({canUse : true, getForgeRate : '紫晶狂兽神',text : '使用后在1级家的锻造台锻造'}),

    '图纸：强酸利刃' : new Element({canUse : true, getForgeRate : '强酸利刃',text : '使用后在1级家的锻造台锻造'}),
    '图纸：强韧重甲' : new Element({canUse : true, getForgeRate : '强韧重甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：御灵权杖' : new Element({canUse : true, getForgeRate : '御灵权杖',text : '使用后在1级家的锻造台锻造'}),
    '图纸：毒刺铠甲' : new Element({canUse : true, getForgeRate : '毒刺铠甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：荒原战刀' : new Element({canUse : true, getForgeRate : '荒原战刀',text : '使用后在1级家的锻造台锻造'}),
    '图纸：亚龙皮甲' : new Element({canUse : true, getForgeRate : '亚龙皮甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：大地兽骨锤' : new Element({canUse : true, getForgeRate : '大地兽骨锤',text : '使用后在1级家的锻造台锻造'}),
    '图纸：大地兽骨甲' : new Element({canUse : true, getForgeRate : '大地兽骨甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：闪耀骑士剑' : new Element({canUse : true, getForgeRate : '闪耀骑士剑',text : '使用后在1级家的锻造台锻造'}),
    '图纸：狰狞巨兽' : new Element({canUse : true, getForgeRate : '狰狞巨兽',text : '使用后在1级家的锻造台锻造'}),

    '图纸：僵尸剑' : new Element({canUse : true, getForgeRate : '僵尸剑',text : '使用后在1级家的锻造台锻造'}),
    '图纸：僵尸甲' : new Element({canUse : true, getForgeRate : '僵尸甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：灵魂毒刺' : new Element({canUse : true, getForgeRate : '灵魂毒刺',text : '使用后在1级家的锻造台锻造'}),
    '图纸：血肉护甲' : new Element({canUse : true, getForgeRate : '血肉护甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：亡灵之手' : new Element({canUse : true, getForgeRate : '亡灵之手',text : '使用后在1级家的锻造台锻造'}),
    '图纸：亡灵石甲' : new Element({canUse : true, getForgeRate : '亡灵石甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：怨恨长枪' : new Element({canUse : true, getForgeRate : '怨恨长枪',text : '使用后在1级家的锻造台锻造'}),
    '图纸：诅咒铠甲' : new Element({canUse : true, getForgeRate : '诅咒铠甲',text : '使用后在1级家的锻造台锻造'}),

    '图纸：荒骨之咬' : new Element({canUse : true, getForgeRate : '荒骨之咬',text : '使用后在1级家的锻造台锻造'}),
    '图纸：赐福甲胄' : new Element({canUse : true, getForgeRate : '赐福甲胄',text : '使用后在1级家的锻造台锻造'}),
    '图纸：魔法弓' : new Element({canUse : true, getForgeRate : '魔法弓',text : '使用后在1级家的锻造台锻造'}),
    '图纸：魔法斗篷' : new Element({canUse : true, getForgeRate : '魔法斗篷',text : '使用后在1级家的锻造台锻造'}),
    '图纸：元素之灵' : new Element({canUse : true, getForgeRate : '元素之灵',text : '使用后在1级家的锻造台锻造'}),
    '图纸：元素庇佑' : new Element({canUse : true, getForgeRate : '元素庇佑',text : '使用后在1级家的锻造台锻造'}),

    '图纸：狂信战锤' : new Element({canUse : true, getForgeRate : '狂信战锤',text : '使用后在1级家的锻造台锻造'}),
    '图纸：信仰卫士' : new Element({canUse : true, getForgeRate : '信仰卫士',text : '使用后在1级家的锻造台锻造'}),
    '图纸：狩猎长刀' : new Element({canUse : true, getForgeRate : '狩猎长刀',text : '使用后在1级家的锻造台锻造'}),
    '图纸：猎人皮甲' : new Element({canUse : true, getForgeRate : '猎人皮甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：荣耀魔剑' : new Element({canUse : true, getForgeRate : '荣耀魔剑',text : '使用后在1级家的锻造台锻造'}),
    '图纸：妖风圣衣' : new Element({canUse : true, getForgeRate : '妖风圣衣',text : '使用后在1级家的锻造台锻造'}),

    '图纸：亚龙之咬' : new Element({canUse : true, getForgeRate : '亚龙之咬',text : '使用后在1级家的锻造台锻造'}),
    '图纸：亚龙鳞甲' : new Element({canUse : true, getForgeRate : '亚龙鳞甲',text : '使用后在1级家的锻造台锻造'}),
    '图纸：龙魂之力' : new Element({canUse : true, getForgeRate : '龙魂之力',text : '使用后在1级家的锻造台锻造'}),
    '图纸：龙魂守护' : new Element({canUse : true, getForgeRate : '龙魂守护',text : '使用后在1级家的锻造台锻造'}),

    ...newMapElements.tuzhi,

    /** -----不可采集,制造出来的物品[START]----- */
    //工具
    '木斧' : new Element({onlyOne :true, weight : 5, endurance : 20, voidDust : 2, gold : 5}),
    '石斧' : new Element({onlyOne :true, weight : 10, endurance : 50, voidDust : 5, gold : 5}),
    '铁斧' : new Element({onlyOne :true, weight : 20, endurance : 200, voidDust : 10, gold : 10}),
    '木镐' : new Element({onlyOne :true, weight : 5, endurance : 20, voidDust : 2, gold : 5}),
    '石镐' : new Element({onlyOne :true, weight : 10, endurance : 50, voidDust : 5, gold : 5}),
    '铁镐' : new Element({onlyOne :true, weight : 20, endurance : 200, voidDust : 10, gold : 10}),
    '木铲' : new Element({canUse :true, voidDust : 0, func : function(){
            if(data.race.name.startsWith('寒影')){
                winMsg('寒影不能使用木铲', false, false);
                return false
            }
            addItem('观音土', 10)
            winMsg('你获得了10个观音土');
            if(conf.achievement.indexOf('灵魂吸引') === -1 && randomNum(1,100) <= 1){
                data.hasSoul = true;
                winMsg('一股神秘的力量从土里窜出，沾染了你的灵魂');
            }
            return true;
        }, text : '用于挖掘观音土'}),
    '鱼竿' : new Element({onlyOne :true, weight : 10, endurance : 100, voidDust : 10, gold : 25, text : '用于钓鱼。在钓鱼时，如果没钓到鱼，则有30%概率钓到本地图商店可以买到的随机物品1个，60%概率是资源、食物或素材，35%几率是料理或药品，5%几率是稀有物品'}),

    //素材
    '布' : new Element({voidDust : 5, gold : 25}),
    '铁锭' : new Element({voidDust : 10, weight : 10, gold : 50}),
    '铜锭' : new Element({voidDust : 10, weight : 10, gold : 50}),
    '金锭' : new Element({voidDust : 2000, weight : 20, gold : 10000}),
    '虚空粉尘' : new Element({weight : 0}),
    '荧光粉' : new Element({voidDust : 5, gold : 25}),

    //装备
    '石矛' : new Element({onlyOne :true, isWeapon : true, atk : 2, weight : 2, endurance : 30, voidDust : 5, gold : 5}),
    '草甲' : new Element({onlyOne :true, isArmor : true, def : 1, weight : 5, endurance : 30, voidDust : 5, gold : 5}),
    '利齿匕首' : new Element({onlyOne :true, isWeapon : true, atk : 5, atkSpd : 1, weight : 3, endurance : 50, voidDust : 10,  gold : 50}),
    '软皮甲' : new Element({onlyOne :true, isArmor : true, def : 3, weight : 5, endurance : 50, voidDust : 10, gold : 50, onStartBattle(){
            addStatus(data, getStatus('毒素免疫'))
        }}),
    '兽爪拳刃' : new Element({onlyOne :true, isWeapon : true, atk : 8, weight : 3, endurance : 80, voidDust : 20,  level : 4, gold : 100}),
    '兽皮甲' : new Element({onlyOne :true, isArmor : true, def : 7, weight : 15, endurance : 80, voidDust : 20, level : 4, gold : 100}),
    '羽刃扇' : new Element({onlyOne :true, isWeapon : true, atk : 12, weight : 10, endurance : 150, voidDust : 50, level : 7, gold : 150}),
    '甲壳衣' : new Element({onlyOne :true, isArmor : true, def : 12, weight : 20, endurance : 150, voidDust : 50, level : 7, gold : 150}),
    '哥布林杀手' : new Element({onlyOne :true, isWeapon : true, atk : 15, def : 5, hole : 4, weight : 5, endurance : 300, level : 10, voidDust : 150, quality : 3, gold : 500, myAtk : function(item){
            return parseInt(data.battleMonster && data.battleMonster.name.indexOf('哥布林') !== -1 ? item.atk * 2 : item.atk)
        }, text : '和名字带有哥布林的怪物战斗时，攻击力变为2倍'}),
    '弱小联合' : new Element({onlyOne :true, isArmor : true, hp : 200, atk : 15, def : 40, hole : 6, weight : 10, endurance : 1000, level : 20, voidDust : 500, quality : 4, gold : 2500}),

    '麦林之刃' : new Element({onlyOne :true, isWeapon : true, atk : 15, weight : 10, endurance : 200, voidDust : 100, level : 10, gold : 200}),
    '冲锋甲' : new Element({onlyOne :true, isArmor : true, def : 15, weight : 10, endurance : 200, voidDust : 100, level : 10, gold : 200}),
    '重锤' : new Element({onlyOne :true, isWeapon : true, atkSpd : -1, atk : 20, weight : 15, endurance : 300, voidDust : 150, level : 13, gold : 300}),
    '矮人之心' : new Element({onlyOne :true, isArmor : true, def : 20, weight : 10, endurance : 300, voidDust : 150, level : 13, gold : 300}),
    '熔火剑' : new Element({onlyOne :true, isWeapon : true, atk : 25, weight : 20, endurance : 400, voidDust : 200, level : 17, gold : 500}),
    '残火盔甲' : new Element({onlyOne :true, isArmor : true, def : 25, weight : 10, endurance : 400, voidDust : 200, level : 17, gold : 500}),
    '疯狂撕咬' : new Element({onlyOne :true, isWeapon : true, atk : 40, suck : 20, hole : 4, weight : 20, endurance : 800, level : 20, voidDust : 500, quality : 3, gold : 1000}),
    '灵魂外壳' : new Element({onlyOne :true, isArmor : true, hp : 400, atk : 40, def : 80, hole : 6, weight : 10, endurance : 700, level : 30, voidDust : 2000, quality : 4,gold : 10000}),

    '鱼蟹锤' : new Element({onlyOne :true, isWeapon : true, atkSpd : -1, atk : 13, hp : 20, weight : 15, endurance : 200, voidDust : 100, level : 10, gold : 200}),
    '刺壳甲' : new Element({onlyOne :true, isArmor : true, def : 17, hp : 50, weight : 10, endurance : 200, voidDust : 100, level : 10, gold : 200}),
    '鳞枪' : new Element({onlyOne :true, isWeapon : true, atk : 18, def : 2, weight : 15, endurance : 300, voidDust : 150, level : 13, gold : 300}),
    '蓝龟板甲' : new Element({onlyOne :true, isArmor : true, def : 23, hp : 80, weight : 10, endurance : 300, voidDust : 150, level : 13, gold : 300}),
    '碧水枪' : new Element({onlyOne :true, isWeapon : true, atk : 20, weight : 20, endurance : 400, voidDust : 200, level : 17, gold : 500, getAtkNum : function(){
            return randomNum() <= 15 ? 2 : 1;
        }, text : '有15%概率触发两次攻击'}),
    '波涛甲' : new Element({onlyOne :true, isArmor : true, def : 20, defProp : 0.1, hp : 100, weight : 10, endurance : 400, voidDust : 200, level : 17, gold : 500}),
    '潮汐权杖' : new Element({onlyOne :true, isWeapon : true, atk : 40, hole : 4, weight : 20, endurance : 800, level : 20, voidDust : 500, quality : 3, gold : 1000, myAtk :            function(item){
            let terrainElement = terrainElements[data.world.map[data.location[1]][data.location[0]]];
            let rate = 0.8;
            if(terrainElement){
                rate =  terrainElement.elements && Object.keys(terrainElement.elements).indexOf('水源') != -1 ? 2 : 0.8;
            }
            return item.atk * rate
        }, text : '在能刷出水源的地形，攻击力变为2倍，在不能刷新出水源的地形攻击力变为0.8倍',
    }),
    '怒浪重皮' : new Element({onlyOne :true, isArmor : true, hp : 600, def : 60, defProp : 0.2, hole : 6, weight : 10, endurance : 700, level : 30, voidDust : 2000, quality : 4,gold : 10000}),

    '战刀' : new Element({onlyOne :true, isWeapon : true, atk : 30, weight : 10, endurance : 500, voidDust : 250, level : 20, gold : 800}),
    '柔韧软甲' : new Element({onlyOne :true, isArmor : true, def : 30, weight : 10, endurance : 500, voidDust : 250, level : 20, gold : 800}),
    '魔兽锋芒' : new Element({onlyOne :true, isWeapon : true, atk : 40, weight : 10, endurance : 500, voidDust : 300, level : 23, gold : 1000}),
    '魔兽骨甲' : new Element({onlyOne :true, isArmor : true, def : 40, weight : 20, endurance : 500, voidDust : 300, level : 23, gold : 1000}),
    '元素冲击' : new Element({onlyOne :true, isWeapon : true, atk : 50, weight : 15, endurance : 500, voidDust : 350, level : 27, gold : 1200}),
    '兽人战甲' : new Element({onlyOne :true, isArmor : true, def : 50, weight : 30, endurance : 500, voidDust : 350, level : 27, gold : 1200}),
    '兽人必须死' : new Element({onlyOne :true, isWeapon : true, atk : 70, def : 15, hole : 4, weight : 20, endurance : 700, level : 30, voidDust : 1500, quality : 3, gold : 7500, myAtk : function(item){
            return parseInt(data.battleMonster && data.battleMonster.name.indexOf('兽人') !== -1 ? item.atk * 2 : item.atk)
        }, text : '和名字带有兽人的怪物战斗时，攻击力变为2倍'}),
    '紫晶狂兽神' : new Element({onlyOne :true, isArmor : true, atk : 150, def : 60, hp : 800, hole : 6, weight : 30, endurance : 1500, level : 40, voidDust : 5000, quality : 4, gold : 25000}),

    '强酸利刃' : new Element({onlyOne :true, isWeapon : true, atk : 60, weight : 10, endurance : 600, voidDust : 400, level : 30, gold : 2000}),
    '强韧重甲' : new Element({onlyOne :true, isArmor : true, def : 60, weight : 10, endurance : 500, voidDust : 400, level : 30, gold : 2000}),
    '御灵权杖' : new Element({onlyOne :true, isWeapon : true, atk : 75, weight : 15, endurance : 600, voidDust : 500, level : 33, gold : 2500}),
    '毒刺铠甲' : new Element({onlyOne :true, isArmor : true, atk : 10, def : 75, weight : 20, endurance : 500, voidDust : 500, level : 33, gold : 2500}),
    '荒原战刀' : new Element({onlyOne :true, isWeapon : true, atk : 90, weight : 15, endurance : 600, voidDust : 600, level : 37, gold : 3000}),
    '亚龙皮甲' : new Element({onlyOne :true, isArmor : true, def : 90, weight : 30, endurance : 500, voidDust : 600, level : 37, gold : 3000}),
    '大地兽骨锤' : new Element({onlyOne :true, isWeapon : true, atkSpd : -1, atk : 105, weight : 30, endurance : 600, voidDust : 700, level : 40, gold : 3500}),
    '大地兽骨甲' : new Element({onlyOne :true, isArmor : true, def : 105, hp : 50, weight : 30, endurance : 500, voidDust : 700, level : 40, gold : 3500}),
    '闪耀骑士剑' : new Element({onlyOne :true, isWeapon : true, atk : 120, weight : 20, hole : 4, endurance : 1000, voidDust : 2000, level : 40, quality : 3, gold : 10000, myAtk : function(item){
            return parseInt(data.battleMonster && data.battleMonster.level > data.level ? item.atk * 2 : item.atk)
        }, text : '和等级比自己高的怪物战斗时，攻击力变为2倍'}),
    '狰狞巨兽' : new Element({onlyOne :true, isArmor : true, atk : 100, def : 200, hp : 1500, hole : 6, weight : 30, endurance : 2000, level : 50, voidDust : 20000, quality : 4, gold : 100000, fixNeedDust: 2}),

    '僵尸剑' : new Element({onlyOne :true, isWeapon : true, atk : 120, weight : 10, endurance : 700, voidDust : 800, level : 40, gold : 4000, fixNeedDust: 2}),
    '僵尸甲' : new Element({onlyOne :true, isArmor : true, def : 120, weight : 10, endurance : 700, voidDust : 800, level : 40, gold : 4000, fixNeedDust: 2}),
    '灵魂毒刺' : new Element({onlyOne :true, isWeapon : true, atk : 140, weight : 5, endurance : 700, voidDust : 900, level : 43, gold : 4500, fixNeedDust: 2}),
    '血肉护甲' : new Element({onlyOne :true, isArmor : true, def : 140, weight : 15, endurance : 700, voidDust : 900, level : 43, gold : 4500, fixNeedDust: 2}),
    '亡灵之手' : new Element({onlyOne :true, isWeapon : true, atk : 160, weight : 5, endurance : 700, voidDust : 1000, level : 47, gold : 5000, fixNeedDust: 2}),
    '亡灵石甲' : new Element({onlyOne :true, isArmor : true, def : 160, weight : 20, endurance : 700, voidDust : 1000, level : 47, gold : 5000, fixNeedDust: 2}),
    '怨恨长枪' : new Element({onlyOne :true, isWeapon : true, atk : 180, weight : 15, endurance : 700, voidDust : 1100, level : 50, gold : 5500, fixNeedDust: 2}),
    '诅咒铠甲' : new Element({onlyOne :true, isArmor : true, def : 180, weight : 15, endurance : 700, voidDust : 1100, level : 50, gold : 5500, fixNeedDust: 2}),

    '荒骨之咬' : new Element({onlyOne :true, isWeapon : true, atk : 200, weight : 5, endurance : 1000, voidDust : 1200, level : 50, gold : 6000, fixNeedDust: 2}),
    '赐福甲胄' : new Element({onlyOne :true, isArmor : true, def : 200, weight : 10, endurance : 1000, voidDust : 1200, level : 50, gold : 6000, fixNeedDust: 2}),
    '魔法弓' : new Element({onlyOne :true, isWeapon : true, atk : 230, weight : 5, endurance : 1000, voidDust : 1300, level : 53, gold : 6500, fixNeedDust: 2}),
    '魔法斗篷' : new Element({onlyOne :true, isArmor : true, def : 230, weight : 5, endurance : 1000, voidDust : 1300, level : 53, gold : 6500, fixNeedDust: 2}),
    '元素之灵' : new Element({onlyOne :true, isWeapon : true, atk : 260, weight : 5, endurance : 1000, voidDust : 1400, level : 57, gold : 7000, fixNeedDust: 2}),
    '元素庇佑' : new Element({onlyOne :true, isArmor : true, def : 260, weight : 5, endurance : 1000, voidDust : 1400, level : 57, gold : 7000, fixNeedDust: 2}),

    '狂信战锤' : new Element({onlyOne :true, isWeapon : true, atk : 290, weight : 20, endurance : 1200, voidDust : 1500, level : 60, gold : 8000, fixNeedDust: 2}),
    '信仰卫士' : new Element({onlyOne :true, isArmor : true, def : 290, weight : 15, endurance : 1200, voidDust : 1500, level : 60, gold : 8000, fixNeedDust: 2}),
    '狩猎长刀' : new Element({onlyOne :true, isWeapon : true, atk : 330, weight : 15, endurance : 1200, voidDust : 1600, level : 63, gold : 8500, fixNeedDust: 2}),
    '猎人皮甲' : new Element({onlyOne :true, isArmor : true, def : 330, weight : 5, endurance : 1200, voidDust : 1600, level : 63, gold : 8500, fixNeedDust: 2}),
    '荣耀魔剑' : new Element({onlyOne :true, isWeapon : true, atk : 370, weight : 10, endurance : 1200, voidDust : 1700, level : 67, gold : 9000, fixNeedDust: 2}),
    '妖风圣衣' : new Element({onlyOne :true, isArmor : true, def : 370, weight : 5, endurance : 1200, voidDust : 1700, level : 67, gold : 9000, fixNeedDust: 2}),

    '亚龙之咬' : new Element({onlyOne :true, isWeapon : true, atk : 450, weight : 10, endurance : 1500, voidDust : 2000, level : 70, gold : 10000, fixNeedDust: 2}),
    '亚龙鳞甲' : new Element({onlyOne :true, isArmor : true, def : 450, weight : 20, endurance : 1500, voidDust : 2000, level : 70, gold : 10000, fixNeedDust: 2}),
    '龙魂之力' : new Element({onlyOne :true, isWeapon : true, atk : 500, weight : 5, endurance : 2000, voidDust : 3000, level : 80, gold : 15000, fixNeedDust: 2}),
    '龙魂守护' : new Element({onlyOne :true, isArmor : true, def : 500, weight : 5, endurance : 2000, voidDust : 3000, level : 80, gold : 15000, fixNeedDust: 2}),

    ...newMapElements.equip,

    '冰皇剑' : new Element({onlyOne :true, isWeapon : true, atk : 700, weight : 5, hole : 6, endurance : 500, voidDust : 0, level : 80, fixNeedDust: 1, text : '水之神裔-冰皇独家打造的装备'}),
    '狩猎神甲' : new Element({onlyOne :true, isArmor : true, def : 700, defProp : 0.2, weight : 10, hole : 6, endurance : 2000, voidDust : 0, level : 80, fixNeedDust: 1, text : '狩猎神裔-铠甲神匠独家打造的装备'}),

    '心灵之剑' : new Element({onlyOne :true, isWeapon : true, washing : true, weight : 0, hole : 6, noWear : true, endurance : 1000, voidDust : 0, level : 1, quality : 4, gold : 0, myAtk : function(item){
            return data.level * (parseInt(data.level / 10) +1) + (data.level * 2) + (item.atk || 0)
        }, text : '只能从周目商店购买，攻击力为角色的等级*((等级/10) + 1) + (等级*2)。本武器默认为已洗涤状态，所以不能打孔'}),

    '弓胚' : new Element({onlyOne :true, atk : 0, weight : 5, isBow :true, endurance : 10, text : '未附着前不属于武器，附着后属于弓类武器，射击时不消耗耐久，装备后在战斗中不要点击该装备，直接点击对应的箭矢即可射击。可以使用自然附着技能将其他武器的属性附着在弓胚上'}),
    '弓胚：猎人' : new Element({onlyOne :true, atk : 0, weight : 10, isBow :true, endurance : 10, atkTags:[{tag : '野兽', rate : 0.5}], text : '未附着前不属于武器，附着后属于弓类武器，射击时不消耗耐久，装备后在战斗中不要点击该装备，直接点击对应的箭矢即可射击。可以使用自然附着技能将其他武器的属性附着在弓胚上'}),
    '弓胚：灵魂' : new Element({onlyOne :true, atk : 0, weight : 5, isBow :true, endurance : 10, atkTags:[{tag : '不死族', rate : 1}, {tag : '幽灵', rate : 0.5}], text : '未附着前不属于武器，附着后属于弓类武器，射击时不消耗耐久，装备后在战斗中不要点击该装备，直接点击对应的箭矢即可射击。可以使用自然附着技能将其他武器的属性附着在弓胚上'}),
    '弓胚：巨人杀手' : new Element({onlyOne :true, atk : 0, weight : 20, isBow :true, endurance : 10, atkTags:[{tag : '巨型生物', rate : 1}], text : '未附着前不属于武器，附着后属于弓类武器，射击时不消耗耐久，装备后在战斗中不要点击该装备，直接点击对应的箭矢即可射击。可以使用自然附着技能将其他武器的属性附着在弓胚上'}),
    '弓胚：游侠' : new Element({onlyOne :true, atk : 0, weight : 20, isBow :true, endurance : 10, atkTags:[{tag : '人型生物', rate : 1}], text : '未附着前不属于武器，附着后属于弓类武器，射击时不消耗耐久，装备后在战斗中不要点击该装备，直接点击对应的箭矢即可射击。可以使用自然附着技能将其他武器的属性附着在弓胚上'}),
    '弓胚：屠龙者' : new Element({onlyOne :true, atk : 0, weight : 20, isBow :true, endurance : 10, atkTags:[{tag : '龙', rate : 1}], text : '未附着前不属于武器，附着后属于弓类武器，射击时不消耗耐久，装备后在战斗中不要点击该装备，直接点击对应的箭矢即可射击。可以使用自然附着技能将其他武器的属性附着在弓胚上'}),

    //盾牌
    '黄昏盾牌' : new Element({onlyOne :true, isWeapon : true, defProp : 0.1, weight : 20, endurance : 300, voidDust : 100, level : 20, gold : 500, fixNeedDust: 1,
        preFunc : function(){
            if(randomNum(1,100) <= 20){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}眩晕了。`)
                addStatus(data.battleMonster, getStatus('眩晕'));
            }

            return true;
        },text : '使用该盾牌攻击有20%概率使对方眩晕1回合'}),
    '海洋盾牌' : new Element({onlyOne :true, isWeapon : true, defProp : 0.1, weight : 20, endurance : 300, voidDust : 100, level : 20, gold : 500, fixNeedDust: 1, getAtkNum : function(){
            const num = randomNum();
            return num <= 1 ? 4 : num <= 5 ? 3 : num <= 20 ? 2 : 1;
        },text : '20%概率触发2次伤害，5%概率触发3次伤害，1%概率触发4次伤害'}),
    '紫星盾牌' : new Element({onlyOne :true, isWeapon : true, defProp : 0.15, weight : 30, endurance : 400, voidDust : 200, level : 30, gold : 1000, fixNeedDust: 1,
        preFunc : function(){
            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}眩晕了。`)
                addStatus(data.battleMonster, getStatus('眩晕'));
            }

            return true;
        },text : '使用该盾牌攻击有30%概率使对方眩晕1回合'}),
    '山岭盾牌' : new Element({onlyOne :true, isWeapon : true, def : 80, defProp : 0.15, weight : 50, endurance : 400, voidDust : 200, level : 30, gold : 1000, fixNeedDust: 1,text : '无特效，就是防御高一些'}),
    '世界之盾' : new Element({onlyOne :true, isWeapon : true, defProp : 0.2, weight : 40, endurance : 500, voidDust : 300, level : 40, gold : 1500, fixNeedDust: 1,
        preFunc : function(){
            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}眩晕了。`)
                addStatus(data.battleMonster, getStatus('眩晕'));
            }

            return true;
        },text : '使用该盾牌攻击有30%概率使对方眩晕1回合'}),
    '病毒之盾' : new Element({onlyOne :true, isWeapon : true, defProp : 0.2, weight : 40, endurance : 500, voidDust : 300, level : 40, gold : 1500, fixNeedDust: 1,
        preFunc : function(){
            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}中毒了。`)
                addStatus(data.battleMonster, getStatus('中毒', {num : 3, harm : 100}));
            }

            return true;
        },text : '使用该盾牌攻击有30%概率使对方附加中毒状态，每回合受到100伤害，持续3回合'}),
    '幽灵盾牌' : new Element({onlyOne :true, isWeapon : true, defProp : 0.25, weight : 10, endurance : 600, voidDust : 500, level : 50, gold : 2500, fixNeedDust: 2,
        myAtk : function(item){
            let weaponAtk = item.atk;
            return weaponAtk + (data.battleMonster && data.battleMonster.def > 0  && data.weapon && data.weapon.id === item.id ? data.battleMonster.def : 0)
        },text : '使用该盾牌攻击时无视防御'}),
    '冠军盾牌' : new Element({onlyOne :true, isWeapon : true, defProp : 0.3, weight : 30, endurance : 800, voidDust : 700, level : 60, gold : 3500, fixNeedDust: 2,
        preFunc : function(){
            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}眩晕了。`)
                addStatus(data.battleMonster, getStatus('眩晕'));
            }
            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}受了内伤。`)
                addStatus(data.battleMonster, getStatus('内伤'));
            }

            return true;
        },text : '使用该盾牌攻击有30%概率使对方眩晕1回合，30%概率给对方附加内伤状态，减少75%治疗量，持续3回合'}),
    '暴风盾牌' : new Element({onlyOne :true, isWeapon : true, defProp : 0.35, weight : 20, endurance : 1000, voidDust : 1000, level : 70, gold : 5000, fixNeedDust: 2,
        preFunc : function(){
            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被封印了。`)
                addStatus(data.battleMonster, getStatus('封印'));
            }

            return true;
        },text : '使用该盾牌攻击有30%概率封印对方3回合'}),
    '龙盾' : new Element({onlyOne :true, isWeapon : true, defProp : 0.4, weight : 50, endurance : 1200, voidDust : 1500, level : 80, gold : 7500, fixNeedDust: 2,
        preFunc : function(){
            if(data.weapon && data.weapon.name === '龙盾' && randomNum(1,100) <= 50){
                addBattleLog(`你获得了龙棘状态`)
                addStatus(data, getStatus('龙棘', {returnHarm : data.battleMonster.atk, num : 1}));
            }

            return true;
        },text : '使用该盾牌攻击有50%概率会给自己附加龙棘状态，对方攻击你时会受到等同于对方攻击力的伤害，持续1回合'}),

    //护身符
    '草编戒指' : new Element({onlyOne :true, isAmulet : true, weight : 1, voidDust : 0, gold : 0,
        text : '她做给你的戒指，放在背包中即可生效，同名护身符效果无法叠加。当怪物试图攻击你时，有10%几率愣神，你可以继续操作。愣神不会导致回合流转，所以不会触发状态伤害和减少层数。'}),
    '牙齿项链' : new Element({onlyOne :true, isAmulet : true, weight : 1, voidDust : 0, gold : 0,
        text : '她做给你的项链，放在背包中即可生效，同名护身符效果无法叠加。当怪物偷袭你时，有30%几率被你发现，此时进入战斗依旧是你先手，此时逃跑的成功率也是100%。'}),
    '水晶徽章' : new Element({onlyOne :true, isAmulet : true, weight : 1, voidDust : 0, gold : 0,
        text : '她亲手为你打磨的水晶徽章，放在背包中即可生效，同名护身符效果无法叠加。当回合结束时，如果你的生命值低于30%，则会为你增加一个持续3回合的心灵守护状态，每回合恢复相当于怪物两倍攻击力的生命值。该效果每场战斗只会触发一次'}),
    '灵魂布偶' : new Element({onlyOne :true, isAmulet : true, weight : 1, voidDust : 0, gold : 0,
        text : '她送给你的布偶，和她长得一模一样，放在背包中即可生效，同名护身符效果无法叠加。这里面存放着她的灵魂，当你触发真正的死亡，并且即将删档时，她会代替你死去，你将完美复活。该物品在新手和简单难度下不会触发'}),
    '破烂的布偶' : new Element({onlyOne :true, isAmulet : true, weight : 1, voidDust : 0, gold : 0,
        text : '她送给你的布偶，和她长得一模一样，但是已经碎掉了，不会再有任何效果了'}),

    //元素物品
    '力量药剂' : new Element({canUse : true, voidDust : 100, gold : 500, func(){
            useDrug('力量药剂', 40);
            return true;
        },
        text : '使用后，负重超过上限也可以移动，每超过1倍负重上限（不满一倍按一倍算），移动消耗的时间增加一倍。移动40格后失效（切换地图——例如孤岛前往地底——不计入格数），多次使用可以叠加格数。无论移动时是否超重，都会消耗1点力量药剂的耐久'}),
    '敏捷药剂' : new Element({canUse : true, voidDust : 100, gold : 500, func(){
            useDrug('敏捷药剂', 40);
            return true;
        },
        text : '使用后，移动时消耗的时间减半，移动40格后失效（切换地图——例如孤岛前往地底——不计入格数），多次使用可以叠加格数'}),
    '学习药剂' : new Element({canUse : true, voidDust : 100, gold : 500, func(){
            useDrug('学习药剂', 10);
            return true;
        },
        text : '使用后，接下来10场战斗受到的等级差减少经验的影响，改为每级降低2.5%（原本为每级5%），多次使用可以叠加战斗场数'}),
    '经验药剂' : new Element({canUse : true, voidDust : 100, gold : 500, func(){
            useDrug('经验药剂', 10);
            return true;
        },
        text : '使用后，接下来10场战斗获得的经验翻倍，多次使用可以叠加战斗场数'}),
    '香甜药水' : new Element({canUse : true, voidDust : 100, gold : 500, func(){
            data.sweetPotion = data.date.format('yyyy-MM-dd');
            return true;
        },
        text : '使用后，在直到游戏时间的当天24点，所有怪物出现的概率增加10%'}),

    //投掷品
    '巫毒药剂' : new Element({isThrow : true, atk : 30, weight : 5, endurance : 1, voidDust : 20, gold : 100, throwFunc(){
            addStatus(data.battleMonster, getStatus('中毒', {harm : 10, num : 5}))
        }, text : '给怪物附加中毒状态，每回合造成10伤害，持续5回合'}),
    '魔晶炸弹' : new Element({isThrow : true, atk : 100, weight : 10, endurance : 1, voidDust : 50, gold : 150, throwFunc(){
            if(randomNum(1,100) <= 30){
                addStatus(data.battleMonster, getStatus('眩晕'))
            }
        }, text : '30%概率使怪物眩晕1回合'}),
    '火焰爆弹' : new Element({isThrow : true, atk : 200, weight : 5, endurance : 1, voidDust : 100, gold : 250, throwFunc(){
            addStatus(data.battleMonster, getStatus('燃烧', {harm : 50, num : 3}))
        }, text : '给怪物附加燃烧状态，每回合造成50伤害，持续3回合'}),
    '潮汐珠宝' : new Element({isThrow : true, atk : 200, weight : 5, endurance : 1, voidDust : 100, gold : 250, throwFunc(){
            data.shield += 20;
        }, text : '给自己增加20护盾值'}),
    '飞雷矛' : new Element({isThrow : true, atk : 300, weight : 10, endurance : 1, voidDust : 200, gold : 1000, throwFunc(){
            if(randomNum(1,100) <= 30){
                addStatus(data.battleMonster, getStatus('麻痹'))
            }
        }, text : '30%概率使怪物麻痹1回合'}),
    '幽灵猛毒' : new Element({isThrow : true, atk : 100, weight : 5, endurance : 1, voidDust : 200, gold : 1000, throwFunc(){
            addStatus(data.battleMonster, getStatus('中毒', {harm : 300, num : 3}))
        }, text : '给怪物附加中毒状态，每回合造成300伤害，持续3回合'}),
    '尸毒飞镖' : new Element({isThrow : true, atk : 300, weight : 5, endurance : 1, voidDust : 300, gold : 1500, throwFunc(){
            addStatus(data.battleMonster, getStatus('中毒', {harm : 500, num : 3}))
        }, text : '给怪物附加中毒状态，每回合造成500伤害，持续3回合'}),
    '神性炸弹' : new Element({isThrow : true, atk : 500, weight : 1, endurance : 1, voidDust : 1000, gold : 5000, throwFunc(){
            if(randomNum(1,100) <= 50){
                addStatus(data.battleMonster, getStatus('眩晕', {num : 2}))
            }
        }, text : '50%概率使怪物眩晕2回合'}),
    '神性爆弹' : new Element({isThrow : true, atk : 1000, weight : 1, endurance : 1, voidDust : 1000, gold : 5000, throwFunc(){
            if(randomNum(1,100) <= 50){
                addStatus(data.battleMonster, getStatus('眩晕', {num : 3}))
            }
        }, text : '50%概率使怪物眩晕3回合'}),
    '暗影匕首' : new Element({isThrow : true, atk : 3000, weight : 1, endurance : 1, voidDust : 0, gold : 1}),
    '暗影神枪' : new Element({isThrow : true, atk : 10000, weight : 1, endurance : 1, voidDust : 0, gold : 1}),

    //背包
    '背篓' : new Element({onlyOne :true, addWeight : 50, weight : 10, voidDust : 5, gold : 5}),
    '布包' : new Element({onlyOne :true, addWeight : 100, weight : 3, voidDust : 10, gold : 25}),
    '皮包' : new Element({onlyOne :true, addWeight : 150, weight : 5, voidDust : 20, gold : 100}),
    '灵纹布包' : new Element({onlyOne :true, addWeight : 200, weight : 5, voidDust : 50, gold : 500}),
    '海胆皮包' : new Element({onlyOne :true, addWeight : 200, weight : 5, voidDust : 50, gold : 500}),
    '毛线背包' : new Element({onlyOne :true, addWeight : 250, weight : 5, voidDust : 100, gold : 1000}),
    '魔兽皮包' : new Element({onlyOne :true, addWeight : 300, weight : 10, voidDust : 100, gold : 1500}),
    '珍贵皮包' : new Element({onlyOne :true, addWeight : 400, weight : 10, voidDust : 500, gold : 2500}),
    '龙皮背包' : new Element({onlyOne :true, addWeight : 500, weight : 10, voidDust : 1000, gold : 5000}),
    '真龙皮包' : new Element({onlyOne :true, addWeight : 700, weight : 10, voidDust : 2000, gold : 10000}),
    '时空背包' : new Element({onlyOne :true, addWeight : 1000, weight : 0, voidDust : 0, gold : 0, text : '可以从种族周目商店购买'}),

    //药品
    '草药膏' : new Element({canUse : true, hp : 30, voidDust : 5, gold : 50}),
    '蘑菇药膏' : new Element({canUse : true, hp : 80, voidDust : 10, gold : 100}),
    '特效草药膏' : new Element({canUse : true, hp : 150, voidDust : 10, gold : 150}),
    '猩红药膏' : new Element({canUse : true, hp : 100, voidDust : 10, gold : 150}),
    '血肉药膏' : new Element({canUse : true, hp : 200, voidDust : 30, gold : 200}),
    '血肉之心' : new Element({canUse : true, hp : 300, voidDust : 80, gold : 400}),

    //药剂，可在战斗中使用
    '微效治疗药剂' : new Element({canUse : true, battleUse : true, voidDust : 10, gold : 100, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了微效治疗药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)
            if(inBattle()){
                addStatus(data, getStatus('恢复', {addHp : 10, num : 2}))
            }
            return true;
        },
        myHp : function(){
            return 20;
        },
        text : '获得恢复状态，每回合恢复10生命值，持续2回合'}),
    '弱效治疗药剂' : new Element({canUse : true, battleUse : true, voidDust : 20, gold : 200, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了弱效治疗药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)
            if(inBattle()){
                addStatus(data, getStatus('恢复', {addHp : 25, num : 3}))
            }
            return true;
        },
        myHp : function(){
            return 50;
        },
        text : '获得恢复状态，每回合恢复25生命值，持续3回合'}),
    '中效治疗药剂' : new Element({canUse : true, battleUse : true, voidDust : 50, gold : 500, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了中效治疗药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)
            if(inBattle()){
                addStatus(data, getStatus('恢复', {addHp : 70, num : 4}))
            }
            return true;
        },
        myHp : function(){
            return 100;
        },
        text : '获得恢复状态，每回合恢复70生命值，持续4回合'}),
    '高效治疗药剂' : new Element({canUse : true, battleUse : true, voidDust : 200, gold : 1000, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了高效治疗药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)
            if(inBattle()){
                addStatus(data, getStatus('恢复', {addHp : 200, num : 5}))
            }
            return true;
        },
        myHp : function(){
            return 200;
        },
        text : '获得恢复状态，每回合恢复200生命值，持续5回合'}),
    '强效治疗药剂' : new Element({canUse : true, battleUse : true, voidDust : 400, gold : 2000, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了强效治疗药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)
            if(inBattle()){
                addStatus(data, getStatus('恢复', {addHp : 400, num : 6}))
            }
            return true;
        },
        myHp : function(){
            return 300;
        },
        text : '获得恢复状态，每回合恢复400生命值，持续6回合'}),
    '龙血药剂' : new Element({canUse : true, battleUse : true, voidDust : 0, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了龙血药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)
            if(inBattle()){
                addStatus(data, getStatus('恢复', {addHp : 700, num : 7}))
            }
            return true;
        },
        myHp : function(){
            return 600;
        }, text : '获得恢复状态，每回合恢复700生命值，持续7回合'}),
    '哥布林心脉精华' : new Element({canUse : true, battleUse : true, voidDust : 30, gold : 250, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了哥布林心脉精华，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            return true;
        },
        myHp : function(){
            let add = parseInt(data.maxHp * 0.1);
            if(add < 100){
                add = 100;
            }
            return add;
        }, text : '恢复10%生命值上限的生命值，最少100点'}),
    '魔蛟心脉精华' : new Element({canUse : true, battleUse : true, voidDust : 30, gold : 250, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了魔蛟心脉精华，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            return true;
        },
        myHp : function(){
            let add = parseInt(data.maxHp * 0.3);
            if(add < 800){
                add = 800;
            }
            return add;
        }, text : '恢复30%生命值上限的生命值，最少800点'}),
    '传承药剂' : new Element({canUse : true, battleUse : true, voidDust : 300, gold : 1500, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了传承药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            if(data.battleMonster && !data.battleMonster.ccyj){
                data.battleMonster.ccyj = true;
                data.suck += 100;
                addBattleLog('你增加了100%吸血')
            }

            return true;
        },
        myHp : function(){
            return data.maxHp;
        }, text : '恢复全部生命值。如果是本次战斗第一次使用传承药剂，则增加100%吸血。'}),
    '神性药剂' : new Element({canUse : true, battleUse : true, voidDust : 1000, gold : 5000, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了神性药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            return true;
        },
        myHp : function(){
            let add = parseInt(data.maxHp * 0.5);
            if(add < 3000){
                add = 3000;
            }
            return add;
        }, text : '恢复50%生命值上限的生命值，最少3000点'}),
    '强效神性药剂' : new Element({canUse : true, battleUse : true, voidDust : 2000, gold : 10000, func(){
            if(data.battleMonster.qxsxyj){
                winMsg('你已经使用过强效神性药剂了', false, false);
                return false;
            }

            data.battleMonster.qxsxyj = true;

            data.shield += data.maxHp;
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            removeAllDebuff(data);
            const text = `使用了强效神性药剂，恢复${battleAddHp(data, addHp)}HP，获得${data.maxHp}护盾，并清除了所有负面效果`;
            msg(text);
            addBattleLog(text)

            return true;
        },
        myHp : function(){
            return data.maxHp;
        }, text : '生命值完全恢复，清除所有负面效果，并获得相当于生命值上限的护盾，每场战斗只能使用一次'}),
    '世界药剂' : new Element({canUse : true, battleUse : true, voidDust : 1, gold : 5, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            if(battle4WorldBoss()){
                addStatus(data, getStatus('恢复', {addHp : parseInt(data.maxHp * 0.1), num : 10}))
            }else{

            }
            const text = `流浪商人独家出售，使用了世界药剂，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            return true;
        },
        myHp : function(){
            return battle4WorldBoss() ? data.maxHp : parseInt(data.maxHp * 0.01);
        }, text : '流浪商人独家出售，恢复1%生命值。如果正在和世界BOSS战斗，则恢复100%生命值，且每回合恢复10%生命值，持续10回合。'}),
    '灵魂碎片' : new Element({canUse : true, battleUse : true, weight : 0, hp : 50, voidDust : 1, gold : 5}),
    '灵魂残骸' : new Element({canUse : true, battleUse : true, weight : 0, hp : 100, voidDust : 1, gold : 5}),
    '残缺灵魂' : new Element({canUse : true, battleUse : true, weight : 0, hp : 200, voidDust : 1, gold : 5}),
    '史莱姆之心' : new Element({canUse : true, battleUse : true, voidDust : 1, func(){
            if(!data.race.name.startsWith('史莱姆-巨化') && !data.race.name.startsWith('史莱姆-王者')){
                const text = `该物品只有史莱姆-巨化和史莱姆-王者种族可以使用`;
                winMsg(text, false, false);
                return false;
            }
            const addHp = parseInt(data.maxHp);
            const text = `使用了史莱姆之心，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            return true;
        },
        myHp : function(){
            return parseInt(data.maxHp);
        }, text : '恢复100%生命值'}),
    '巨龙之力' : new Element({battleUse : true, weight : 0, voidDust : 0, func(){
            if(data.battleMonster.jlzl){
                winMsg('你已经使用过巨龙之力了', false, false);
                return false;
            }

            data.battleMonster.jlzl = true;
            data.atk += 100;
            data.def += 100;
            addBattleLog('你使用了巨龙之力，攻击力+100，防御力+100')
            return true;
        }, text : '使用后本场战斗获得攻击力+100，防御力+100，每场战斗只能使用一次'}),
    '龙魂药剂' : new Element({battleUse : true, weight : 0, voidDust : 0, func(){
            if(data.battleMonster.lhyj){
                winMsg('你已经使用过龙魂药剂了', false, false);
                return false;
            }

            data.battleMonster.lhyj = true;
            data.atk += 400;
            data.def += 300;
            removeAllDebuff(data);
            data.hp = data.maxHp;
            addStatus(data, getStatus('恢复', {addHp : parseInt(data.maxHp * 0.2), num : 10}))
            addBattleLog('你使用了龙魂药剂，攻击力+400，防御力+300，解除所有负面状态，生命值完全恢复')
            return true;
        }, text : '使用后本场战斗获得攻击力+400，防御力+300，解除所有负面状态，生命值完全恢复，并附加恢复状态，每回合恢复生命上限20%的血量，持续10回合，每场战斗只能使用一次'}),
    '风暴号角' : new Element({battleUse : true, weight : 0, voidDust : 0, func(){
            if(hasStatus(data.battleMonster, '封印')){
                winMsg('对方已经被封印', false, false);
                return false;
            }

            if(!data.battleMonster.fbhjNum){
                data.battleMonster.fbhjNum = 0;
            }

            const num = 7 - data.battleMonster.fbhjNum;
            if(num <= 1){
                winMsg('对方已经适应了风暴的力量，无法再被封印', false, false);
                return false;
            }
            data.battleMonster.fbhjNum++;
            addStatus(data.battleMonster, getStatus('封印', {num}))

            addBattleLog(`你使用了风暴号角，${data.battleMonster.showName || data.battleMonster.name}获得了封印状态`)
            return true;
        }, text : '给对方施加封印状态，第一次使用持续7回合，每使用一次持续回合数减1，当使用6次后无法再使用'}),
    '风暴药剂' : new Element({battleUse : true, weight : 0, voidDust : 0, func(){
            addBattleLog(`你使用了风暴药剂，解除所有负面状态`)
            removeAllDebuff(data);
            return true;
        }, text : '解除所有负面状态'}),
    '封魔卷轴' : new Element({onlyOne : true, battleUse : true, weight : 0, voidDust : 0, func(){
            if(this.monster){
                data.atk += this.monster.atk;
                data.def += this.monster.def;
                const text = `使用了${this.showName}，恢复${battleAddHp(data, this.monster.hp)}HP，攻击力+${this.monster.atk}，防御力+${this.monster.def}`;
                addBattleLog(text)
            }else{
                if(data.battleMonster.noOneKill){
                    winMsg('该怪物不受此技能影响', false, false);
                    return false;
                }
                if(data.inDungeon){
                    winMsg('不能在副本中使用', false, false);
                    return false;
                }
                if(data.battleMonster.hp < data.battleMonster.maxHp * 0.15){
                    this.monster = data.battleMonster;
                    this.showName = `封：${this.monster.name}`;
                    msg(`封印${this.monster.name}成功`);
                    battleEnd();
                    setTimeout(function(){timeLapses(battleRunMin);},100)
                }else{
                    winMsg('怪物血量低于15%时才能封印')
                }
                return false;
            }
            return true;
        }, text : '只能从周目商店购买，未封印怪物时，在怪物血量低于15%时使用，可以将怪物封印起来，封印怪物时无法获得战斗奖励。封印怪物后，再次使用则恢复相当于怪物被封印时剩余血量的生命值，并增加怪物被封印时的攻击力和防御力。'}),
    '血液库存' : new Element({onlyOne : true, battleUse : true, weight : 0, voidDust : 0, func(){
            if(confirm('是否确认饮用血液')){
                let addAtk = parseInt(this.monster.atk * 0.5);
                let addDef = parseInt(this.monster.def * 0.5);
                if(data.battleMonster.xykc){
                    if(data.race.name === '吸血鬼-收割者'){
                        addAtk = parseInt(this.monster.atk * 0.2)
                        addDef = parseInt(this.monster.def * 0.2);
                        data.atk += addAtk;
                        data.def += addDef;
                        addBattleLog(`使用了${this.showName}，攻击力+${addAtk}，防御力+${addDef}`)
                        return true;
                    }else{
                        winMsg('你已经饮用过血液了', false, false);
                        return false;
                    }
                }

                data.battleMonster.xykc = true;
                data.atk += addAtk;
                data.def += addDef;
                const text = `使用了${this.showName}，攻击力+${addAtk}，防御力+${addDef}`;
                addBattleLog(text)
                return true;
            }
            return false;
        }, text : '刀锋战士或者收割者储存的血液，里面包含着怪物的力量，使用时增加血液主人被抽取血液时的攻击力和防御力的50%，刀锋战士一场战斗只能饮用一个血液，收割者没有限制，但是从第二个血液开始，每次只能获取血液中20%的攻防加成'}),

    //食物
    '烤肉' : new Element({canUse : true, hunger : 15, voidDust : 2, gold : 10, isMeat : true}),
    '烤鱼' : new Element({canUse : true, hunger : 10, voidDust : 2, gold : 10, isMeat : true}),
    '鱼汤' : new Element({canUse : true, hunger : 40, water : 30, weight : 5, voidDust : 10, gold : 50, isMeat : true}),
    '蟹肉大餐' : new Element({canUse : true, hunger : 20, hp : 50, weight : 5, voidDust : 20, gold : 100, isMeat : true}),
    '蘑菇煲' : new Element({canUse : true, hunger : 30, water : 15, hp : 10, weight : 5, voidDust : 10, gold : 50}),
    '烤干贝' : new Element({canUse : true, hunger : 10, hp : 50, weight : 2, voidDust : 10, gold : 50, isMeat : true}),
    '烤羊肉' : new Element({canUse : true, hunger : 20, voidDust : 15, gold : 100, isMeat : true}),
    '烤魔兽肉' : new Element({canUse : true, hunger : 30, voidDust : 10, gold : 50, isMeat : true}),
    '蜜汁血蕊' : new Element({canUse : true, hunger : 20, hp : 100, water : 5, weight : 2, voidDust : 20, gold : 100, isMeat : true}),
    '亚龙肉排' : new Element({canUse : true, hunger : 40, voidDust : 10, gold : 200, isMeat : true}),
    '水之精华' : new Element({canUse : true, water : 300, voidDust : 0}),

    //副本坐标
    '位面坐标：深渊' : new Element({canUse :true, quality : 2, voidDust : 100, gold : 500, func : function(){
            if(data.dungeon && data.dungeon.indexOf('深渊') !== -1){
                winMsg('你已经记录了该坐标', false, false);
                return false;
            }
            data.dungeon.push('深渊');
            winMsg('你发现了深渊位面的坐标');
            return true;
        }, text : '获得深渊位面的坐标，然后可以从家里的传送门传送去深渊。你可以在图鉴-地形-血战中看到深渊副本里有什么'}),
    '位面坐标：后院' : new Element({canUse :true, quality : 2, voidDust : 100, gold : 500, func : function(){
            if(data.dungeon && data.dungeon.indexOf('后院') !== -1){
                winMsg('你已经记录了该坐标', false, false);
                return false;
            }
            data.dungeon.push('后院');
            winMsg('你发现了后院位面的坐标');
            return true;
        }, text : '获得神域后院位面的坐标，然后可以从家里的传送门传送去神域后院。你可以在图鉴-地形-花园中看到深渊副本里有什么'}),
    '位面坐标：宝石' : new Element({canUse :true, quality : 2, voidDust : 100, gold : 500, func : function(){
            if(data.dungeon && data.dungeon.indexOf('宝石') !== -1){
                winMsg('你已经记录了该坐标', false, false);
                return false;
            }
            data.dungeon.push('宝石');
            winMsg('你发现了宝石晶脉的坐标');
            return true;
        }, text : '神恩商店出售。获得宝石晶脉的坐标，然后可以从家里的传送门传送去宝石晶脉。你可以在图鉴-地形-晶脉中看到深渊副本里有什么'}),
    '位面坐标：粘液' : new Element({canUse :true, quality : 2, voidDust : 100, gold : 500, func : function(){
            if(data.dungeon && data.dungeon.indexOf('粘液') !== -1){
                winMsg('你已经记录了该坐标', false, false);
                return false;
            }
            data.dungeon.push('粘液');
            winMsg('你发现了粘液位面的坐标');
            return true;
        }, text : '获得粘液位面的坐标，然后可以从家里的传送门传送去粘液位面。你可以在图鉴-地形-果冻中看到深渊副本里有什么'}),
    '位面坐标：精英' : new Element({canUse :true, quality : 2, voidDust : 0, func : function(){
            if(data.dungeon && data.dungeon.indexOf('精英') !== -1){
                winMsg('你已经记录了该坐标', false, false);
                return false;
            }
            data.dungeon.push('精英');
            winMsg('你发现了精英位面的坐标');
            return true;
        }, text : '狩猎神裔-追猎者种族才能制造该物品。获得精英巢穴位面的坐标，然后可以从家里的传送门传送去精英巢穴。你可以在图鉴-地形-巢穴中看到深渊副本里有什么'}),
    '位面坐标：传说' : new Element({canUse :true, quality : 2, voidDust : 0, func : function(){
            if(data.dungeon && data.dungeon.indexOf('传说') !== -1){
                winMsg('你已经记录了该坐标', false, false);
                return false;
            }
            data.dungeon.push('传说');
            winMsg('你发现了传说位面的坐标');
            return true;
        }, text : '狩猎神裔-追猎者种族才能制造该物品。获得传说领地位面的坐标，然后可以从家里的传送门传送去传说领地。你可以在图鉴-地形-领地中看到深渊副本里有什么'}),

    //技能
    ...skills,

    //制造出来的素材
    '冰霜结晶' : new Element({}),
    '命运硬币' : new Element({weight : 0}),

    //种族专属材料
    '折叠床' : new Element({canUse :true, onlyOne : true, weight : 30, endurance : 1000, func : function(){
            this.endurance--;
            timeLapses(15, false);
            if(inBattle()){
                winMsg(`你在休息时被攻击了`)
                addBattleLog('你在休息时突然被攻击，一阵手忙脚乱，怪物额外行动一次')
                monsterAtk();
            }else{
                winMsg(`你休息了15分钟，感觉状态好多了`)
                data.sleepTime += 1000 * 60 * 195;
                if(data.sleepTime > data.date.getTime()){
                    data.sleepTime = data.date.getTime();
                }
            }
            if(this.endurance > 0){
                clickBagItem(this);
                renderBag();
                renderMapElements();
                warning();
                return false;
            }else{
                return true;
            }
        }, text : '弑魂叔种族才能制造，耗时15分钟，并将上次睡觉时间延后3小时15分钟。每次使用消耗1耐久。如果因为使用折叠床导致被怪物攻击，则怪物会额外行动一次，且本次休息不会延后上次睡觉时间'}),
    '木罐' : new Element({weight : 3,text : '弑魂叔种族才能制造，用来装果汁的'}),
    '果汁' : new Element({canUse : true, water : 20, weight : 5, func(){
            data.guozhiTime = data.date.getTime() + 18000000;
            addItem('木罐');
            //渲染果汁剩余效果时间
            renderGuozhi();
            return true;
        },
        text : '弑魂叔种族才能制造，饮用后5小时内，夏季水分消耗从3倍变为2倍，多次饮用仅可刷新有效时间，不会叠加时间。使用后获得1个木罐。使用后，在主页时间后面能看到果汁剩余的生效时间'}),
    '机械碎片' : new Element({weight : 0}),
    '机械核心' : new Element({canUse : true, voidDust : 50, gold : 250, weight : 0, quality : 4, func : function(){
            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('机械族') !== -1){
                winMsg('你已经解锁机械族种族！', false, false);
                return false;
            }
            if(getNumByBag('机械碎片') < 20){
                winMsg('机械碎片不足', false, false)
                return false;
            }
            reduceItem('机械碎片', 20)

            conf.races.push('机械族');
            save(confSavedName, conf);
            winMsg('恭喜你解锁了机械族种族！');
            return true;
        }, text : '当背包中有20个机械碎片时可以使用，使用后解锁机械族种族。'}),
    '天剑' : new Element({voidDust : 0, gold : 0,onlyOne : true, weight : 30, endurance : 1000, quality : 4, text : '飞剑：天剑，天雷合并可发出超强的威力'}),
    '雷剑' : new Element({voidDust : 0, gold : 0,onlyOne : true, weight : 30, endurance : 1000, quality : 4, text : '飞剑：雷剑，天雷合并可发出超强的威力'}),
    '昊天镜' : new Element({voidDust : 0, gold : 0,onlyOne : true, weight : 10, endurance : 3000, quality : 4, text : '法器：昊天镜，可封印并持续消耗敌人的生命'}),
    '日金轮' : new Element({voidDust : 0, gold : 0,onlyOne : true, weight : 1, endurance : 100, quality : 4, text : '法器：日金轮，主防御'}),
    '月金轮' : new Element({voidDust : 0, gold : 0,onlyOne : true, weight : 1, endurance : 10000, quality : 4, text : '法器：月金轮，主攻击'}),
    '青果酿' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
            if(data.race.name !== '地球人-酒剑仙'){
                winMsg('只有酒剑仙才能饮用', false, false)
                return;
            }
            removeStatus(data, '临江');
            removeStatus(data, '蔷薇');
            removeStatus(data, '神游');
            addStatus(data, getStatus('临江'))
            addBattleLog('含情遥指碧波东，越王台殿蓼花红。');
            return true;
        }, text : '喝下后清除其他醉酒状态，获得“临江”状态，使用日金轮获得的减伤增加10%，使用昊天镜时造成的伤害翻倍'}),
    '女儿红' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
            if(data.race.name !== '地球人-酒剑仙'){
                winMsg('只有酒剑仙才能饮用', false, false)
                return;
            }
            removeStatus(data, '临江');
            removeStatus(data, '蔷薇');
            removeStatus(data, '神游');
            addStatus(data, getStatus('蔷薇'))
            addBattleLog('去住闲人看，晴明远蝶来。');
            return true;
        }, text : '喝下后清除其他醉酒状态，获得“蔷薇”状态，使用天剑/雷剑/天雷合并时造成的伤害翻倍'}),
    '竹叶青' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
            if(data.race.name !== '地球人-酒剑仙'){
                winMsg('只有酒剑仙才能饮用', false, false)
                return;
            }
            removeStatus(data, '临江');
            removeStatus(data, '蔷薇');
            removeStatus(data, '神游');
            addStatus(data, getStatus('神游'))
            addBattleLog('竹叶青汾酒，三杯入画游。');
            return true;
        }, text : '喝下后清除其他醉酒状态，获得“神游”状态，使用天剑或雷剑时额外附加另一把剑的状态'}),
    '醉红尘' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 10, func(){
            if(data.race.name !== '地球人-酒剑仙'){
                winMsg('只有酒剑仙才能饮用', false, false)
                return;
            }
            data.zhc = true;
            winMsg('香识花间客，醉邀月下人。');
            return true;
        }, text : '喝下后获得“剑仙”状态，在背包页面的理智栏后方显示。使用月金轮时，免疫即死攻击的怪物也可以杀死，但是免疫即死攻击的怪物需要消耗10倍的月金轮耐久度。使用一次月金轮后失去剑仙状态'}),
    '硫磺' : new Element({elemental : {金 : 3}, text : '地精专属物品，用于制造黑火药'}),
    '硝酸钾' : new Element({elemental : {木 : 2, 土 : 1}, text : '地精专属物品，用于制造黑火药'}),
    '木炭' : new Element({elemental : {木 : 1, 火 : 3}, text : '地精专属物品，用于制造黑火药'}),
    '黑火药' : new Element({elemental : {火 : 10, 极 : 5}, text : '地精专属物品'}),
    '强化黑火药' : new Element({elemental : {火 : 20, 极 : 10}, text : '地精专属物品'}),
    '信仰火药' : new Element({elemental : {火 : 30, 极 : 15}, text : '地精专属物品'}),
    '劣质炸药' : new Element({isThrow : true, atk : 80, weight : 1, endurance : 1, voidDust : 10, gold : 50, throwFunc(){
            addBattleLog(`你受到了炸药造成的${battleOtherAtk(this.atk * 0.1)}伤害`);
        }, text : '投掷时自己也会受到该炸弹10%的伤害，自己受到的伤害不波动，你的防御和减伤会降低你受到的伤害，如果你穿了护甲，且炸弹的伤害（被防御和减伤减免前的数值）超过了护甲防御的一半，则会扣除护甲1耐久'}),
    '魔晶炸药' : new Element({isThrow : true, atk : 200, weight : 2, endurance : 1, voidDust : 10, gold : 50, throwFunc(){
            addBattleLog(`你受到了炸药造成的${battleOtherAtk(this.atk * 0.1)}伤害`);
        }, text : '投掷时自己也会受到该炸弹10%的伤害，自己受到的伤害不波动，你的防御和减伤会降低你受到的伤害，如果你穿了护甲，且炸弹的伤害（被防御和减伤减免前的数值）超过了护甲防御的一半，则会扣除护甲1耐久'}),
    '骨刺炸药' : new Element({isThrow : true, atk : 500, weight : 3, endurance : 1, voidDust : 10, gold : 50, throwFunc(){
            addBattleLog(`你受到了炸药造成的${battleOtherAtk(this.atk * 0.1)}伤害`);
        }, text : '投掷时自己也会受到该炸弹10%的伤害，自己受到的伤害不波动，你的防御和减伤会降低你受到的伤害，如果你穿了护甲，且炸弹的伤害（被防御和减伤减免前的数值）超过了护甲防御的一半，则会扣除护甲1耐久'}),
    '魔法炸药' : new Element({isThrow : true, atk : 1200, weight : 5, endurance : 1, voidDust : 10, gold : 50, throwFunc(){
            addBattleLog(`你受到了炸药造成的${battleOtherAtk(this.atk * 0.1)}伤害`);
        }, text : '投掷时自己也会受到该炸弹10%的伤害，自己受到的伤害不波动，你的防御和减伤会降低你受到的伤害，如果你穿了护甲，且炸弹的伤害（被防御和减伤减免前的数值）超过了护甲防御的一半，则会扣除护甲1耐久'}),
    '飓风炸药' : new Element({isThrow : true, atk : 3000, weight : 5, endurance : 1, voidDust : 10, gold : 50, throwFunc(){
            addBattleLog(`你受到了炸药造成的${battleOtherAtk(this.atk * 0.1)}伤害`);
        }, text : '投掷时自己也会受到该炸弹10%的伤害，自己受到的伤害不波动，你的防御和减伤会降低你受到的伤害，如果你穿了护甲，且炸弹的伤害（被防御和减伤减免前的数值）超过了护甲防御的一半，则会扣除护甲1耐久'}),
    '坐骑：伐木机器人' : new Element({isMount : true, tdi : true, quality : 1, voidDust : 200, gold : 1000, onlyOne : true, weight : 12000, endurance : 30000, skills : {
            '启动备用模式': createRecipesCfg({'纤维': 1}),
        },
        changeEquip(isEquip){
            if(isEquip){
                data.weight -= this.weight;
                this.weight = 0;
            }else{
                this.weight = elementCfgs[this.name].weight;
                data.weight += this.weight;
            }
        },
        selfDes(){
            let en = elementCfgs[this.name].endurance;
            reduceShield(data, parseInt(en * 0.1));
            reduceShield(data.battleMonster, parseInt(en * 0.3));
            addStatus(data, getStatus('眩晕', {num : 2}))
            addBattleLog(`你的${this.name}已损坏，并自爆了`)
        },
        text : '乘骑该坐骑时，该坐骑的重量变为0。当你乘骑了该坐骑，并且在战斗中受到伤害时，不会扣除你的血量，而是优先扣除该坐骑的耐久度，耐久度扣完后，剩下的值才会开始扣除你的护盾和血量。该坐骑的耐久度归0时则损坏，并且触发自爆，对你造成该坐骑初始耐久度10%的伤害，并眩晕你2回合。对敌方造成初始耐久度30%的伤害'}),
    '心脏起搏器' : new Element({battleUse : true, weight : 10, voidDust : 100, gold : 500, func(){
            if(data.battleMonster.xzqbq){
                winMsg('你已经使用过心脏起搏器了', false, false);
                return false;
            }

            data.battleMonster.xzqbq = true;

            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            let text = `使用了心脏起搏器，`;
            let number = randomNum();
            if(number <= 30){
                battleAddHp(data, addHp);
                text += `生命值完全恢复了`;
            }else if(number <= 50){
                data.hp -= parseInt(data.maxHp * 0.1);
                text += `生命值完降低了10%`;
            }else{
                addStatus(data, getStatus('眩晕'))
                text += `眩晕1回合`;
            }
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        }, text : '30%概率生命值完全恢复，20%概率减少最大生命值的10%(不波动，无视一切护盾、减伤和防御，必定扣10%的血量)，50%概率眩晕1回合。每场战斗只能使用一次。年轻的地精哟，要不要来一下？'}),
    '空间撕裂器' : new Element({canUse :true, quality : 2, weight : 20, voidDust : 100, gold : 500, func : function(){
                data.location = [randomNum(0,xnum - 1), randomNum(0,ynum - 1)];
                //将当前坐标和四周坐标设置为已探索
                setShowMap();
                //渲染地图元素
                renderMapElements();
                //渲染可前往的地图
                renderCanToMap();
                //渲染地图
                renderMap();
                $('.item-use-win-modal').hide();
                $('.item-use-win').hide();
                $('.bag').hide();
                $('.home').hide();
                return true;
        }, text : '随机传送到当前地图任意坐标。什么，这个东西竟然是稳定的？这不地精！'}),
    '某元素235' : new Element({elemental : {极 : 30}, text : '地精专属物品。你别管这玩意我是怎么做出来的，总之我就是做出来了！——某爆破工程师'}),
    '某元素239' : new Element({elemental : {极 : 30}, text : '地精专属物品。你别管这玩意我是怎么做出来的，总之我就是做出来了！——某爆破工程师'}),
    '某元素241' : new Element({elemental : {极 : 30}, text : '地精专属物品。你别管这玩意我是怎么做出来的，总之我就是做出来了！——某爆破工程师'}),
    '会裂开的炸药' : new Element({elemental : {极 : 100}, weight : 2000, text : '地精专属物品，必须用载弹机器人才能发射。有效杀伤半径10公里，射程300米，芜湖~'}),
    '坐骑：载弹机器人' : new Element({isMount : true, tdi : true, quality : 1, voidDust : 200, gold : 1000, onlyOne : true, weight : 8000, endurance : 5000, skills : {
            '装弹': createRecipesCfg({'纤维': 1}, 0, null, 1000),
            '卸弹': createRecipesCfg({'纤维': 1}, 0, null, 1000),
            '地精万岁': createRecipesCfg({'纤维': 1}),
        },
        changeEquip(isEquip){
            if(isEquip){
                data.weight -= this.weight;
                this.weight = 0;
            }else{
                this.weight = elementCfgs[this.name].weight + (this.yzd ? 2000 : 0);
                data.weight += this.weight;
            }
        },
        selfDes(){
            let en = elementCfgs[this.name].endurance;
            reduceShield(data, parseInt(en * 0.1));
            reduceShield(data.battleMonster, parseInt(en * 0.3));
            addStatus(data, getStatus('眩晕', {num : 2}))
            addBattleLog(`你的${this.name}已损坏，并自爆了`)

            //触发地精万岁
            if(this.yzd){
                addBattleLog(`你的${this.name}装载的会裂开的炸药爆炸了，对${data.battleMonster.showName || data.battleMonster.name}造成了${battleOtherAtk(10000000, data.battleMonster, false)}伤害`)
                addBattleLog(`你的${this.name}装载的会裂开的炸药爆炸了，对你造成了${battleOtherAtk(10000000, data, false)}伤害`)
                nuclearExplosion();
            }
        },
        text : '乘骑该坐骑时，该坐骑的重量变为0。当你乘骑了该坐骑，并且在战斗中受到伤害时，不会扣除你的血量，而是优先扣除该坐骑的耐久度，耐久度扣完后，剩下的值才会开始扣除你的护盾和血量。该坐骑的耐久度归0时则损坏，并且触发自爆，对你造成该坐骑初始耐久度10%的伤害，并眩晕你2回合。对敌方造成初始耐久度30%的伤害。如果已载弹，那么自爆时会引爆“会裂开的炸药”，造成和技能“地精万岁”相同的效果'}),
    '一包饼干' : new Element({canUse : true, hunger : 10, text : '弑魂叔随身携带的饼干，很幸运的被带来了，可惜吃完就没了'}),
    '书包' : new Element({onlyOne :true, addWeight : 50, weight : 5, text : '弑魂叔几乎走到哪都会背着的书包'}),

    //龙蛋
    '金色龙蛋' : new Element({canUse : true, voidDust : 20000, gold : 100000, quality : 4, weight : 10, func(){
            addItem('坐骑：金龙')
            return true;
        }, text : '开启了龙骑士DLC才能获取，使用后获得坐骑：金龙'}),
    '银色龙蛋' : new Element({canUse : true, voidDust : 20000, gold : 100000, quality : 4, weight : 10, func(){
            addItem('坐骑：银龙')
            return true;
        }, text : '开启了龙骑士DLC才能获取，使用后获得坐骑：银龙'}),
    '青铜龙蛋' : new Element({canUse : true, voidDust : 20000, gold : 100000, quality : 4, weight : 10, func(){
            addItem('坐骑：青铜龙')
            return true;
        }, text : '开启了龙骑士DLC才能获取，使用后获得坐骑：青铜龙'}),
    '翡翠龙蛋' : new Element({canUse : true, voidDust : 20000, gold : 100000, quality : 4, weight : 10, func(){
            addItem('坐骑：翡翠龙')
            return true;
        }, text : '开启了龙骑士DLC才能获取，使用后获得坐骑：翡翠龙'}),

    //坐骑
    '捕捉缰绳' : new Element({battleUse : true, quality : 1, func(){
            if(data.battleMonster.type){
                winMsg('该缰绳只能捕捉普通怪物', false, false)
                return;
            }
            if(mountList.includes(data.battleMonster.name)){
                let rate = parseInt(100 - Percentage(data.battleMonster.hp,data.battleMonster.maxHp)) - data.battleMonster.level + (data.battleMonster.status.filter(e => e.sleep).length ? 30 : 0);
                if(randomNum(1,100) <= rate){
                    winMsg(`捕捉${data.battleMonster.name}成功`);
                    addItem('坐骑：' + data.battleMonster.name)
                    battleEnd();
                    setTimeout(function(){timeLapses(battleRunMin);},100)
                }else{
                    addBattleLog('捕捉失败')
                }
            }else{
                winMsg('该怪物不能捕捉', false, false)
                return false;
            }
            return true;
        }, text : '可以在阵营商店购买，面对可以捕捉为坐骑的生物，使用此物品有概率将其捕获。只能用于捕捉普通怪物（即不可捕捉精英、传说、神话怪物）。捕获概率初始为0，怪物血量每降低1%，捕捉概率提高1%。怪物等级每有1级，概率降低1%（例如30级的怪物满血量时捕捉概率为-30%，半血时概率为20%）。当怪物处于眩晕、冰冻等不可行动的状态时（必须状态栏显示有该状态，所以只持续1回合的眩晕是没用的，因为会直接跳过那一回合，状态栏不会显示），概率额外提高30%。具体哪些怪物可以捕捉，见图鉴-坐骑，里面的坐骑同名的怪都可以捕捉'}),
    '精英缰绳' : new Element({battleUse : true, quality : 2, func(){
            if(data.battleMonster.type === '传说' || data.battleMonster.type === '神话'){
                winMsg('该缰绳只能捕捉普通和精英怪物', false, false)
                return;
            }
            if(mountList.includes(data.battleMonster.name)){
                let rate = parseInt(100 - Percentage(data.battleMonster.hp,data.battleMonster.maxHp)) - data.battleMonster.level + (data.battleMonster.status.filter(e => e.sleep).length ? 30 : 0);
                if(randomNum(1,100) <= rate){
                    winMsg(`捕捉${data.battleMonster.name}成功`);
                    addItem('坐骑：' + data.battleMonster.name)
                    battleEnd();
                    setTimeout(function(){timeLapses(battleRunMin);},100)
                }else{
                    addBattleLog('捕捉失败')
                }
            }else{
                winMsg('该怪物不能捕捉', false, false)
                return false;
            }
            return true;
        }, text : '可以在阵营商店购买，面对可以捕捉为坐骑的生物，使用此物品有概率将其捕获。只能用于捕捉普通怪物和精英怪物（即不可捕捉传说、神话怪物）。捕获概率初始为0，怪物血量每降低1%，捕捉概率提高1%。怪物等级每有1级，概率降低1%（例如30级的怪物满血量时捕捉概率为-30%，半血时概率为20%）。当怪物处于眩晕、冰冻等不可行动的状态时（必须状态栏显示有该状态，所以只持续1回合的眩晕是没用的，因为会直接跳过那一回合，状态栏不会显示），概率额外提高30%。具体哪些怪物可以捕捉，见图鉴-坐骑，里面的坐骑同名的怪都可以捕捉'}),
    '传说缰绳' : new Element({battleUse : true, quality : 3, func(){
            if(data.battleMonster.type === '神话'){
                winMsg('该缰绳不能捕捉神话怪物', false, false)
                return;
            }
            if(mountList.includes(data.battleMonster.name)){
                let rate = parseInt(100 - Percentage(data.battleMonster.hp,data.battleMonster.maxHp)) - data.battleMonster.level + (data.battleMonster.status.filter(e => e.sleep).length ? 30 : 0);
                if(randomNum(1,100) <= rate){
                    winMsg(`捕捉${data.battleMonster.name}成功`);
                    addItem('坐骑：' + data.battleMonster.name)
                    battleEnd();
                    setTimeout(function(){timeLapses(battleRunMin);},100)
                }else{
                    addBattleLog('捕捉失败')
                }
            }else{
                winMsg('该怪物不能捕捉', false, false)
                return false;
            }
            return true;
        }, text : '可以在阵营商店购买，面对可以捕捉为坐骑的生物，使用此物品有概率将其捕获。只能用于捕捉普通怪物、精英怪物和传说怪物（即不可捕捉神话怪物）。捕获概率初始为0，怪物血量每降低1%，捕捉概率提高1%。怪物等级每有1级，概率降低1%（例如30级的怪物满血量时捕捉概率为-30%，半血时概率为20%）。当怪物处于眩晕、冰冻等不可行动的状态时（必须状态栏显示有该状态，所以只持续1回合的眩晕是没用的，因为会直接跳过那一回合，状态栏不会显示），概率额外提高30%。具体哪些怪物可以捕捉，见图鉴-坐骑，里面的坐骑同名的怪都可以捕捉'}),
    '神话缰绳' : new Element({battleUse : true, quality : 4, func(){
            if(mountList.includes(data.battleMonster.name)){
                let rate = parseInt(100 - Percentage(data.battleMonster.hp,data.battleMonster.maxHp)) - data.battleMonster.level + (data.battleMonster.status.filter(e => e.sleep).length ? 30 : 0);
                if(randomNum(1,100) <= rate){
                    winMsg(`捕捉${data.battleMonster.name}成功`);
                    addItem('坐骑：' + data.battleMonster.name)
                    battleEnd();
                    setTimeout(function(){timeLapses(battleRunMin);},100)
                }else{
                    addBattleLog('捕捉失败')
                }
            }else{
                winMsg('该怪物不能捕捉', false, false)
                return false;
            }
            return true;
        }, text : '可以在阵营商店购买，面对可以捕捉为坐骑的生物，使用此物品有概率将其捕获。可以捕捉所有位阶的怪物。捕获概率初始为0，怪物血量每降低1%，捕捉概率提高1%。怪物等级每有1级，概率降低1%（例如30级的怪物满血量时捕捉概率为-30%，半血时概率为20%）。当怪物处于眩晕、冰冻等不可行动的状态时（必须状态栏显示有该状态，所以只持续1回合的眩晕是没用的，因为会直接跳过那一回合，状态栏不会显示），概率额外提高30%。具体哪些怪物可以捕捉，见图鉴-坐骑，里面的坐骑同名的怪都可以捕捉'}),
    '坐骑：狮鹫' : new Element({isMount : true, quality : 1, voidDust : 200, gold : 1000, onlyOne : true, weight : 0, hp : 50, weightUp : 20, spd : 20}),
    '坐骑：蝎尾狮' : new Element({isMount : true, quality : 1, voidDust : 500, gold : 2500, onlyOne : true, weight : 0, hp : 300, weightUp : 100, spd : 25}),
    '坐骑：荒龙' : new Element({isMount : true, quality : 1, voidDust : 800, gold : 4000, onlyOne : true, weight : 0, hp : 400, weightUp : 150, spd : 30}),
    '坐骑：飓风龙兽' : new Element({isMount : true, quality : 1, voidDust : 2000, gold : 10000, onlyOne : true, weight : 0, hp : 500, weightUp : 200, spd : 35}),
    '坐骑：五彩魔蛟' : new Element({isMount : true, quality : 2, voidDust : 2000, gold : 10000, onlyOne : true, weight : 0, hp : 800, weightUp : 100, spd : 30}),
    '坐骑：沙暴地龙' : new Element({isMount : true, quality : 3, voidDust : 2000, gold : 10000, onlyOne : true, weight : 0, hp : 1000, weightUp : 300, spd : 30}),
    '坐骑：荒芜亚龙' : new Element({isMount : true, quality : 4, voidDust : 2000, gold : 10000, onlyOne : true, weight : 0, hp : 500, weightUp : 200, spd : 35, skills : {
            '撕咬冲锋' : createRecipesCfg({'纤维' : 1}),
        }}),

    '坐骑：皇家狮鹫' : new Element({isMount : true, quality : 2, voidDust : 2000, gold : 10000, onlyOne : true, weight : 0, hp : 100, weightUp : 50, spd : 60, text : '只能在阵营商店购买'}),
    '坐骑：雷霆巨蜥' : new Element({isMount : true, quality : 3, voidDust : 2000, gold : 10000, onlyOne : true, weight : 0, hp : 1000, weightUp : 500, spd : -30, text : '只能在阵营商店购买'}),
    '坐骑：独角兽' : new Element({isMount : true, quality : 3, voidDust : 3000, gold : 15000, onlyOne : true, weight : 0, hp : 500, weightUp : 100, spd : 80, text : '只能在跑环奖励中获得'}),
    '坐骑：虚无梦魇' : new Element({isMount : true, quality : 4, voidDust : 5000, gold : 25000, onlyOne : true, weight : 0, hp : 100, weightUp : 50, spd : 50, saveOrder : true, skills : {
            '窃梦' : createRecipesCfg({'纤维' : 1}),
        }, text : '只能在阵营商店购买，该坐骑跳周目时保留'}),

    '坐骑：水之女神' : new Element({isMount : true, quality : 4, voidDust : 10000, gold : 50000, onlyOne : true, weight : 0, hp : 10000, weightUp : 0, spd : 0, skills : {
            '水之回城术' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        }}),

    '坐骑：金龙' : new Element({isMount : true, quality : 4, voidDust : 200, gold : 1000, onlyOne : true, weight : 0, hp : 2000, weightUp : 1000, spd : 150, skills : {
            '烈火焚城' : createRecipesCfg({'纤维' : 1}),
        }, text : '龙骑士DLC专属坐骑，只能从金色龙蛋中孵化获得'}),
    '坐骑：银龙' : new Element({isMount : true, quality : 4, voidDust : 200, gold : 1000, onlyOne : true, weight : 0, hp : 2000, weightUp : 1000, spd : 150, skills : {
            '净化之光' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        }, text : '龙骑士DLC专属坐骑，只能从银色龙蛋中孵化获得'}),
    '坐骑：青铜龙' : new Element({isMount : true, quality : 4, voidDust : 200, gold : 1000, onlyOne : true, weight : 0, hp : 2000, weightUp : 1000, spd : 150, skills : {
            '金属外壳' : createRecipesCfg({'纤维' : 1}, 0, null, 1000),
        }, text : '龙骑士DLC专属坐骑，只能从青铜龙蛋中孵化获得'}),
    '坐骑：翡翠龙' : new Element({isMount : true, quality : 4, voidDust : 200, gold : 1000, onlyOne : true, weight : 0, hp : 2000, weightUp : 1000, spd : 150, skills : {
            '虚幻的现实': createRecipesCfg({'纤维': 1}, 0, null, 1000),
        }, text : '龙骑士DLC专属坐骑，只能从翡翠龙蛋中孵化获得'}),

    //特殊物品
    '水之神殿感应器' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 0, func(item){
            if(diff !== '扩展难度'){
                winMsg('只能在扩展难度使用', false, false)
                return false;
            }
            if(data.date.getTime() !== initDate.getTime()){
                winMsg('只能在刚开局使用', false, false)
                return false;
            }
            if(getNumByBag('短程传送卷轴') <= 0){
                winMsg('缺少短程传送卷轴', false, false)
                return false;
            }

            const [x, y] = Object.keys(data.temples[data.worldIndex]).filter(point => data.temples[data.worldIndex][point] && data.temples[data.worldIndex][point].deity === '水之女神')[0].split(',');
            if(x == data.location[0] && y == data.location[1]){
                winMsg(`？？？你想干什么？`);
                return false;
            }
            winMsg(`水之女神神殿位于${x > data.location[0] ? '东' : x < data.location[0] ? '西' : ''}${y > data.location[1] ? '南' : y < data.location[1] ? '北' : ''}方`);
            reduceItem('短程传送卷轴')
            timeLapses(1);

            return true;
        }, text : '挑战种族专属物品，只能在扩展难度使用，只能在刚开局使用，时间流逝后无法使用。耗费1分钟和1个短程传送卷轴，感应水之女神神殿的大致方向'}),
    '狩猎神殿感应器' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 0, func(item){
            if(diff !== '扩展难度'){
                winMsg('只能在扩展难度使用', false, false)
                return false;
            }
            if(data.date.getTime() !== initDate.getTime()){
                winMsg('只能在刚开局使用', false, false)
                return false;
            }
            if(getNumByBag('短程传送卷轴') <= 0){
                winMsg('缺少短程传送卷轴', false, false)
                return false;
            }

            const [x, y] = Object.keys(data.temples[data.worldIndex]).filter(point => data.temples[data.worldIndex][point] && data.temples[data.worldIndex][point].deity === '狩猎之神')[0].split(',');
            if(x == data.location[0] && y == data.location[1]){
                winMsg(`？？？你想干什么？`);
                return false;
            }
            winMsg(`狩猎之神神殿位于${x > data.location[0] ? '东' : x < data.location[0] ? '西' : ''}${y > data.location[1] ? '南' : y < data.location[1] ? '北' : ''}方`);
            reduceItem('短程传送卷轴')
            timeLapses(1);

            return true;
        }, text : '挑战种族专属物品，只能在扩展难度使用，只能在刚开局使用，时间流逝后无法使用。耗费1分钟，感应狩猎之神神殿的大致方向'}),
    '地图出口感应器' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 0, func(item){
            if(diff !== '扩展难度'){
                winMsg('只能在扩展难度使用', false, false)
                return false;
            }
            if(data.date.getTime() !== initDate.getTime()){
                winMsg('只能在刚开局使用', false, false)
                return false;
            }
            if(getNumByBag('短程传送卷轴') <= 0){
                winMsg('缺少短程传送卷轴', false, false)
                return false;
            }

            const [x, y] = data.nextPoint;
            if(x == data.location[0] && y == data.location[1]){
                winMsg(`？？？你想干什么？`);
                return false;
            }
            winMsg(`地图出口位于${x > data.location[0] ? '东' : x < data.location[0] ? '西' : ''}${y > data.location[1] ? '南' : y < data.location[1] ? '北' : ''}方`);
            reduceItem('短程传送卷轴')
            timeLapses(1);

            return true;
        }, text : '挑战种族专属物品，只能在扩展难度使用，只能在刚开局使用，时间流逝后无法使用。耗费1分钟，感应地图出口的大致方向'}),
    '火把' : new Element({onlyOne : true, voidDust : 10, endurance : 20, gold : 50, weight : 5, text : '只能在开启黑暗侵蚀DLC后制造，放在背包中即可带来光明，背包中有火把时会自动消耗，每小时消耗1耐久，页面左上角会标注剩余火把所有的总耐久度。'}),
    'DLC体验券' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 10, func(item){
            if(diff === '扩展难度'){
                winMsg('扩展难度不可使用该物品', false, false)
                return false;
            }
            if(data.dlcExperience){
                winMsg('你已经使用过该物品', false, false)
                return false;
            }
            data.dlcExperience = true;
            $('.dlc-split,.init-dlc,.dlc-show').show();
            return true;
        }, text : '种族周目商店和赞助商店出售。使用后，非扩展难度也可以在系统里开启DLC，扩展难度不可使用该物品，已使用过的档也不能重复使用'}),
    '超级转生卷轴' : new Element({canUse : true, voidDust : 0, gold : 0, quality : 4, weight : 0, func(item){
            if(data.order > 1){
                winMsg('该物品只能在1周目使用', false, false)
                return false;
            }
            if(data.race.challenge){
                winMsg('挑战种族无法使用', false, false)
                return false;
            }

            $('.super-select-race-list .race-list').html('')
            let unlock = [...initRaces,...(conf.races ? conf.races : [])]
            if(diff === '扩展难度'){
                unlock = Object.keys(races).filter(e => races[e].name.indexOf('-') == -1);
            }

            unlock.forEach(e => {
                if(races[e].challenge || e === '教学种族'){
                    return;
                }
                $('.super-select-race-list .race-list').append(`<div class="race one-line">${e}</div>`)
            })
            $('.super-select-race .race').click(function(){
                $('.super-select-race .race').removeClass('active');
                if(!$(this).hasClass('lock')){
                    $(this).addClass('active');
                }
                $('.super-select-race .race-info').html(getRaceText($(this).html().split('(')[0]))
            });
            $('.super-select-race').show();
            $('.item-use-win-close').click()

            return false;
        }, text : '种族周目商店和赞助商店出售。立即转变为其他已经解锁的种族，例如人类转哥布林。如果是扩展难度使用，可以转生为未解锁的种族。该物品只能在第一周目使用，使用后弹出一个可以关闭的选择种族页面，如果没有选择种族并确认转生，则不会消耗该物品。转生后等级变为1级，经验清空，并自动进行一次洗点。该物品挑战种族和教学种族不可用，也无法使你变成挑战种族和教学种族'}),
    '命运干扰' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 10, func(item){
            data.monthType = {
                ...dlcFateMonths.getRandom(),
                month : data.date.format('MM')
            };
            $('.alert-win').show().find('.alert-win-title').html(`本月为[${data.monthType.name}]，${data.monthType.text}，点击页面顶部的游戏时间可以查看本月主题`)
            return true;
        }, text : '在开启了命运之月DLC之后可以在阵营商店购买，使用后随机改变本月的主题，有可能还是随机到当前这个主题'}),
    '装备保养油' : new Element({voidDust : 1000, gold : 5000, quality : 2, text : '只能在阵营商店购买，可以在虚空修复器中保养装备，重置装备的修复次数'}),
    '宓兰香精' : new Element({voidDust : 10, gold : 50, elemental : {极 : 10000}, text : '只能在阵营商店购买，散发着诱人的香味'}),
    '敌对感知卷轴' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 1, func(item){
            if(data.world.npcs){
                const filter = data.world.npcs.filter(e => {
                    if(data.evil > 0 && e.camp === '善良'){
                        return true;
                    }
                    if(data.evil < 0 && e.camp === '邪恶'){
                        return true;
                    }
                    return false;
                });
                if(filter.length > 0){
                    filter.getRandom().showMapLocation = true;
                }
            }
            return true;
        }, text : '只能在阵营商店购买，使用后将地图上随机一个敌对阵营的NPC位置标注出来，多次使用可以标注多个NPC，但是有可能标注到同一个NPC，那就是白用了。中立阵营也可以用，但是不会有任何效果'}),
    '一次性烹饪锅' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 10, func(item){
            renderKitchen();
            $('.kitchen').show();
            return true;
        }, text : '可以在阵营商店购买，使用后打开厨房页面'}),
    '神恩烹饪锅' : new Element({canUse : true, onlyOne : true, voidDust : 0, gold : 0, weight : 10, saveOrder : true, func(item){
            renderKitchen();
            $('.kitchen').show();
            $('.item-use-win-close').click()
            return false;
        }, text : '跑环任务专属奖励，使用后打开厨房页面，可以无限次数使用，该物品跳周目时不会丢失'}),
    '阵营检测卷轴' : new Element({canUse : true, voidDust : 0, gold : 1000, weight : 1, func(item){
            if(data.world.npcs){
                const location = data.location.join();
                data.world.npcs.filter(e => e.location.join() === location).forEach(e => {
                    e.showCamp = true;
                })
                renderMapElements(false, true)
            }
            return true;
        }, text : '只能通过向NPC购买获得，使用后可以检测目视范围内（即你屏幕上能看到的）NPC得阵营，检测以后这些NPC的阵营将永久显示。'}),
    '我既是正义' : new Element({canUse : true, onlyOne : true, voidDust : 0, gold : 0, weight : 1, quality : 3, func(item){
            data.evil = 0;
            return true;
        }, text : '通过成就“入侵者”获得，能让你的善良值和罪恶值变为0，即转为中立阵营'}),
    '神恩口袋' : new Element({canUse : true, onlyOne : true, voidDust : 0, gold : 0, weight : 10, quality : 3, func(item){
            if(item.hasGold || (item.hasItems && Object.keys(item.hasItems).length > 0)){
                const msg = [];
                if(item.hasGold){
                    data.gold += item.hasGold;
                    msg.push(`你在这个口袋里发现了${item.hasGold}金币`)
                }
                if(item.hasItems && Object.keys(item.hasItems).length > 0){
                    const itemList = [];
                    Object.keys(item.hasItems).forEach(e => {
                        itemList.push(e + '*' + item.hasItems[e])
                        addItem(e, item.hasItems[e]);
                    })
                    msg.push(`你在这个口袋里发现了[${itemList.join('，')}]`)
                }
                winMsg(msg.join('，'))
            }else{
                winMsg(`这个口袋里什么也没有`)
            }
            return true;
        }, text : '附有神力的空间口袋，里面可能装着一些东西'}),
    '欺诈宝石' : new Element({voidDust : 0, gold : 0, weight : 0, quality : 4, text : '周目礼包中有几率开出，纯娱乐用品，不会提供任何游戏加成，也不是镶嵌物，不占用镶嵌栏。背包或仓库有此物品时，在家里可以看到欺诈工作台，可以修改装备的名称，但是如果装备带有符文之语，那么装备即使你修改了装备名称，装备名后面也还是会标注符文之语。例如你给“利齿匕首：刺客”改名为“天下剑”，最终得到的武器是“天下剑：刺客”。但是要注意，如果你先把名字改掉了，再制造符文之语，会导致名字被改回去，因为符文之语需要覆盖显示名，所以请先造出符文之语，再改名字。最后，名字里不要使用特殊符号，否则造成的一切后果自负'}),
    '幸运卷轴' : new Element({canUse : true, onlyOne : true, voidDust : 0, gold : 0, weight : 1, quality : 4, func(item){
            if(data.usedXyjz){
                winMsg('你已经使用过幸运卷轴了', false, false)
                return false;
            }
            data.usedXyjz = true;
            return true;
        }, text : '只能通过成就“欧皇”和“非酋”获得，下次锻造装备全属性必定波动为120%'}),
    '神秘印记' : new Element({canUse : true, voidDust : 0, gold : 0, weight : 10, quality : 4, func(){
            if(data.edu){
                winMsg('你无法使用这件物品', false, false)
                return false;
            }
            if(data.eduOver){
                winMsg('创世神已经收回了遗失的人性，这个印记已经不会再有效果了', false, false)
                return false;
            }
            data.edu = createEduRole();
            winMsg('似乎有什么事情发生了，又似乎什么也没发生');
            renderMapElements();
            return true;
        }, text : '和你灵魂里的神秘力量发生共鸣，然后会发生什么呢？具体阅读图鉴-说明-养成，及和养成相关的其他说明'}),
    '观察之眼' : new Element({voidDust : 0, gold : 0, func(){
            winMsg('此物品已经不需要使用了', false, false)
            return false;
        }, text : '流浪商人独家出售，放在背包中即可在战斗中显示自己和怪物当前的攻击、防御和吸血属性'}),
    '神话诅咒' : new Element({
        canUse :true, quality : 4, voidDust : 0, gold : 0,
        text : '首次击杀神话怪时会获得1个神话诅咒（副本中击杀不会获得）。使用神话诅咒后，下一个触发战斗的怪物将附带“诅咒”前缀，攻击、防御变为2倍，血量提高5倍，所有基础掉落物（不包括镶嵌物等额外掉落物）最大和最小掉落数增加5，并且最少掉落5个（例如：原本某物品掉落为[-8~1]个，变为诅咒怪物后，掉落变为[5~6]个，而不是[-3~6]个），并且固定掉落1个神话之力。',
        func(){
            if(data.mythCurse){
                winMsg('你已经使用过神话诅咒了', false, false)
                return false;
            }
            data.mythCurse = true;
            winMsg('诅咒降临！！！！');
            return true;
        }
    }),
    '神恩赐福' : new Element({
        canUse :true, quality : 4, voidDust : 50000, gold : 10000,
        text : '跑环任务专属奖励，获得1属性点，该方式获得的属性点永久保留，即便洗点也不会失去',
        func(){
            const num = 1;
            data.attrPoint += num;
            if(!data.consumePoint){
                data.consumePoint = 0;
            }
            data.consumePoint -= num;
            return true;
        }
    }),
    '神话之力' : new Element({
        canUse :true, quality : 4, voidDust : 50000, gold : 10000,
        text : '获得3属性点（新人难度获得10点属性点），该方式获得的属性点永久保留，即便洗点也不会失去',
        func(){
            const num = diff === '新人难度' ? 10 : 3;
            data.attrPoint += num;
            if(!data.consumePoint){
                data.consumePoint = 0;
            }
            data.consumePoint -= num;
            return true;
        }
    }),
    '牵引卷轴' : new Element({
        canUse :true, quality : 3, voidDust : 0, gold : 0,
        text : '流浪商人独家出售，能吸引当前地图的世界BOSS前来，使用后触发和当前地图世界BOSS的战斗。',
        func(){
            let finalBoss = null;
            const map = data.maps.filter(e => e.name === data.world.name);
            if(map.length > 0){
                finalBoss = map[0].finalBoss;
            }

            if(!finalBoss){
                winMsg('当前地图没有世界BOSS')
                return false;
            }

            if(!confirm('是否确认使用牵引卷轴？')){
                return false;
            }

            //获取战斗对象
            data.battleMonster = createBattleMonster(finalBoss);
            if(data.world.finalBossObj && data.battleMonster.name === data.world.finalBossObj.name){
                data.battleMonster.hp = data.world.finalBossObj.hp;
                data.battleMonster.maxHp = data.world.finalBossObj.maxHp || data.battleMonster.maxHp;
                data.battleMonster.startAtk = data.world.finalBossObj.startAtk;
                data.battleMonster.startDef = data.world.finalBossObj.startDef;
                data.battleMonster.startSuck = data.world.finalBossObj.startSuck;
                data.battleMonster.atk = data.world.finalBossObj.startAtk || data.battleMonster.atk;
                data.battleMonster.def = data.world.finalBossObj.startDef || data.battleMonster.def;
                data.battleMonster.suck = data.world.finalBossObj.startSuck || data.battleMonster.suck;
            }else{
                data.battleMonster.startAtk = data.battleMonster.atk;
                data.battleMonster.startDef = data.battleMonster.def;
                data.battleMonster.startSuck = data.battleMonster.suck;
            }

            //记录原本的属性
            recordPlayerAttr()
            //初始化护盾
            data.shield = 0;
            //清空日志
            $('.battle-logs').html('');

            //影魔属性处理
            if(data.race.name.startsWith('影魔')){
                const h = parseInt(data.date.format('hh'));
                if(h >= 8 && h <= 19){
                    data.atk = parseInt(data.atk * 0.8);
                    data.def = parseInt(data.def * 0.8);
                }else{
                    data.atk = parseInt(data.atk * 1.2);
                    data.def = parseInt(data.def * 1.2);
                    addStatus(data.battleMonster, getStatus('难以观察', {num : 1, keep : true, reduceHitRate :20}))
                }
            }

            //渲染战斗页面
            renderBattlePage();
            $('.battle').show();
            $('.stop-auto-battle').hide();

            return true;
        }
    }),
    '世界庇佑' : new Element({canUse : true, voidDust : 0, func : function(){
            if(data.bind && data.bind.race === '世界庇佑'){
                winMsg('你已经准备好窃取世界之力了')
                return false;
            }else{
                data.bind = {
                    index : data.worldIndex,
                    location : data.location,
                    race : '世界庇佑'
                };
                winMsg('世界庇佑使用成功，你已经准备好窃取世界之力了！')
                return true;
            }
        }, text : '流浪商人独家出售，死亡时窃取世界之力重生，死亡后原地复活并恢复所有血量。如果死亡时正在和世界BOSS战斗，复活无代价。如果不是在和世界BOSS死亡时复活，非挑战种族减少3点属性点（属性点不足则变为负数，此方式减少的属性点无法以任何方式找回），挑战种族等级变为1级。操脑蛛种族不但会丢失属性点，还会失去当前操控的怪物。丢失身上携带的所有物品，并在孤岛随机位置复活。注意：使用该物品会将原本的复活标记替换掉。'}),
    '时光砂砾' : new Element({canUse :true, quality : 4, voidDust : 0, gold : 0, func : function(){
            if(data.weapon){
                equip(data.weapon);
            }
            if(data.armor){
                equip(data.armor);
            }
            data.level = 1;
            data.exp = 0;
            initAttr();
            return true;
        }, text : '流浪商人独家出售，使你的等级回到1级，自动脱下所有装备并进行1次洗点'}),
    '洗涤灵泉' : new Element({canUse :true, quality : 4, voidDust : 0, gold : 0, func : function(){
            if(data.weapon){
                const item = getBagItemById(data.weapon.id);
                data.weapon.level = 1;
                item.level = 1;
                item.washing = true;
            }
            if(data.armor){
                const item = getBagItemById(data.armor.id);
                data.armor.level = 1;
                item.level = 1;
                item.washing = true;
            }
            return true;
        }, text : '流浪商人独家出售，直接使用可以将你身上装备的武器和护甲的等级都变成1级，不影响其属性，但是洗涤后的装备无法使用打孔石打孔，在家里的洗涤室使用可以洗涤未穿戴的装备'}),
    '溶解药水' : new Element({canUse :true, quality : 2, voidDust : 0, gold : 0, func : function(){
            if(!confirm('是否确认使用溶解药水？使用后你装备的武器和护甲将被销毁')){
                return false;
            }
            if(data.weapon){
                const item = getBagItemById(data.weapon.id);
                equip(data.weapon);
                item.hole.forEach(e => {
                    if(e){
                        addItem(e);
                    }
                });
                reduceItemById(item.id)
            }
            if(data.armor){
                const item = getBagItemById(data.armor.id);
                equip(data.armor);
                item.hole.forEach(e => {
                    if(e){
                        addItem(e);
                    }
                });
                reduceItemById(item.id)
            }

            return true;
        }, text : '流浪商人独家出售，直接使用可以将你身上装备的武器和护甲溶解，并回收其上面的镶嵌物，在家里的溶解室使用可以溶解未穿戴的装备'}),
    '大灾变' : new Element({canUse :true, quality : 4, voidDust : 0, gold : 0, func : function(){
            if(data.inDungeon){
                winMsg(`不能在副本中使用`, false, false);
                return false;
            }
            if(!confirm('是否确认要重置当前地图？')){
                return false;
            }
            //创建地图
            data.temples[data.worldIndex] = {};
            const map = createMap(terrainArray[data.world.name], false);
            data.map = map;
            //创建世界
            data.world = {
                ...data.maps[data.worldIndex],
                map : map,//世界地图
                showMap : data.world.showMap,//key为显坐标，value为1则代表已经显示出来，否则就是空白显示
                mapElements : {},//地图元素集合
                home : data.world.home,
                nextPoint : data.nextPoint,
                prePoint : data.prePoint,
                pass : data.world.pass,//用于记录是否通关，即是否已经战胜守关BOSS
                mythMonster : data.world.mythMonster
            }

            //渲染可前往的地图
            renderCanToMap();
            //渲染地图
            renderMap();
            //时间流逝
            timeLapses(30);

            winMsg('整个世界都发生了变化')
            return true;
        }, text : '流浪商人独家出售，灾祸之力扭曲了世界，消耗1小时，重新绘制当前地图，家的坐标不会改变，已探索过的坐标依旧可以看到地形，已被摧毁的神殿也会重新刷新'}),
    '武器固化卷轴' : new Element({canUse :true, quality : 4, voidDust : 0, gold : 0, weight :1, func : function(){
            if(data.weapon){
                if(data.weapon.name.startsWith("技能石")){
                    winMsg('技能石不能固化', false, false)
                    return false;
                }
                const item = getBagItemById(data.weapon.id);
                item.noWear = true;
            }else{
                winMsg('你没有装备武器');
                return false;
            }

            return true;
        }, text : '只能从藏宝图的宝藏中获得，给你装备的武器附加永不磨损属性'}),
    '护甲固化卷轴' : new Element({canUse :true, quality : 4, voidDust : 0, gold : 0, weight :1, func : function(){
            if(data.armor){
                const item = getBagItemById(data.armor.id);
                item.noWear = true;
            }else{
                winMsg('你没有装备护甲');
                return false;
            }

            return true;
        }, text : '只能从藏宝图的宝藏中获得，给你装备的护甲附加永不磨损属性'}),
    '耐磨珠宝' : new Element({isInlay :true, endurance : 1000, quality : 2, voidDust : 1000, gold : 5000, weight : 1, text : '只能从藏宝图的宝藏中获得'}),
    '锻造笔记' : new Element({canUse :true, quality : 2, voidDust : 1000, gold : 5000, weight :1, func : function(){
            const num = getNumByBag('锻造笔记');
            if(num > 1){
                data.forgeExp += 1000 * num;
                reduceItem('锻造笔记', num - 1);
            }else{
                data.forgeExp += 1000;
            }
            return true;
        }, text : '使用时会把背包中所有锻造笔记一起用掉，每用掉一个，增加1000锻造熟练度'}),
    '藏宝图' : new Element({canUse :true, quality : 2, voidDust : 0, gold : 0, func : function(item){
            if(!data.treasureMaps){
                data.treasureMaps = {};
            }

            const hasNum = getNumByBag('藏宝图')
            for(let i = 0 ; i < hasNum ; i++){
                const map = randomNum(0, data.worlds.length - 1);
                const treasureMap = {
                    map,
                    mapName : data.maps[map].name,
                    location : [randomNum(0, xnum - 1), randomNum(0, ynum - 1)],
                };
                if(!data.treasureMaps[map]){
                    data.treasureMaps[map] = [];
                }
                data.treasureMaps[map].push(treasureMap);
            }

            reduceItem('藏宝图', hasNum - 1)

            winMsg(`你获得了${hasNum}个宝藏的坐标`)
            return true;
        }, text : '流浪商人独家出售，记录了一个宝藏的坐标，使用后在主页下方菜单的藏宝图页面查看，到了对应的坐标就会出现挖掘按钮。使用时，如果背包有多个藏宝图，会一起被使用掉。藏宝图记录的位置只会在玩家已解锁的地图中，即只去过大陆的角色不会开出坐标在死地的藏宝图。宝藏中可能获得以下物品：1%概率获得武器固化卷轴或者护甲固化卷轴，3%概率获得万能武器打孔石或者万能护甲打孔石，6%概率获得耐磨珠宝，10%概率获得溶解药水，30%概率获得锻造笔记，50%概率获得牵引卷轴。'}),
    '成就礼包' : new Element({canUse :true, quality : 4, voidDust : 1000, weight :0, func : function(){
            checkAchievement(true)
            return true;
        }, text : '可以获得你已经完成的成就的所有奖励，建议在家里使用，否则可能会导致负重超标无法移动'}),
    '周目礼包' : new Element({canUse :true, quality : 4, voidDust : 1000, weight :0, func : function(){
            const items = [{
                name : '欺诈宝石',
                num : 1
            },{
                name : '次元钥匙',
                num : 1
            },{
                name : '草药膏',
                num : 10
            },{
                name : '烤肉',
                num : 20
            },{
                name : '金锭',
                num : 1
            },{
                name : '重生十字章',
                num : 1
            },{
                name : '短程传送卷轴',
                num : 3
            },{
                name : '世界之力：1点',
                num : 5
            }];
            const item = items.getRandom();
            addItem(item.name, item.num, {washing : true});
            winMsg(`你获得了${item.name}*${item.num}`)
            return true;

        }, text : '跳转周目获得的礼包，随机获得以下任意一项物品：欺诈宝石*1，次元钥匙*1，草药膏*10，烤肉*20，金锭*1，重生十字章*1，短程传送卷轴*3，世界之力：1点*5。'}),
    '种族周目点数券' : new Element({canUse :true, quality : 4, voidDust : 1000, weight :0, func : function(){
            if(!data.orderPoint){
                data.orderPoint = 0;
            }
            data.orderPoint += 1;
            return true;
        }, text : '获得1点种族周目点数'}),
    '水晶球' : new Element({canUse :true, quality : 4, voidDust : 0, weight :0, func : function(){
            if(data.nextPoint && data.nextPoint.length === 2 && data.worldIndex < mapNum - 1){
                winMsg('下一个地图的入口在坐标：' + data.nextPoint.join())
                setShowMap(data.nextPoint);
                return true;
            }else{
                winMsg('没有下一个地图了', false, false)
                return false;
            }
        }, text : '只能通过成就获得。能直接找到下个地图的入口，使用后打开地图查看即可看到'}),
    '五龙魂' : new Element({voidDust : 0, text : '五种龙魂合成的物品，可作为材料'}),
    '五彩石' : new Element({voidDust : 0, text : '五种璀璨的宝石合成的物品，可作为材料'}),
    '小型传送阵' : new Element({quality : 2, voidDust : 1000, gold : 5000, text : '用于在地图页面进行传送'}),
    '回城卷轴' : new Element({canUse :true, quality : 2, voidDust : 1000, gold : 5000, func : function(){
            if(randomNum(1,100) <= 5){
                winMsg(`遭遇时空乱流，回城失败`)

                if(conf.races.indexOf('地球人') === -1){
                    conf.races.push('地球人');
                    save(confSavedName, conf);
                    winMsg(`恭喜你解锁了地球人！`);
                }

                return false;
            }


            if(data.world.home && data.world.home.location && data.world.home.location.length === 2){
                data.location = data.world.home.location;
                //渲染地图元素
                renderMapElements();
                //渲染可前往的地图
                renderCanToMap();
                //渲染地图
                renderMap();
                $('.item-use-win-modal').hide();
                $('.item-use-win').hide();
                $('.bag').hide();
                $('.home').hide();
                return true;
            }else{
                winMsg(`当前地图还没有安家`);
                return false;
            }
        }, text : '回到当前地图的家。'}),
    '水之女神回城卷' : new Element({canUse :true, quality : 2, voidDust : 1, gold : 1, func : function(){
            return deityBack('水之女神');
        }, text : '神恩商店独有物品，回到当前地图的水之女神神殿。'}),
    '狩猎之神回城卷' : new Element({canUse :true, quality : 2, voidDust : 1, gold : 1, func : function(){
            return deityBack('狩猎之神');
        }, text : '神恩商店独有物品，回到当前地图的狩猎之神神殿。'}),
    '虚空行走' : new Element({canUse :true, quality : 4, voidDust : 0, gold : 0, func : function(){
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }
            if(data.nextPoint){
                toWorld(data.worldIndex + 1);
                winMsg(`你前往了${data.world.name}`)
                return true;
            }else{
                winMsg('已经是最后一个地图了')
                return false;
            }
        }, text : '只能从周目商店购买，不用打BOSS，直接进入下一个地图。但是如果返回之前的地图，守关BOSS依旧存在。'}),
    '时空粉尘' : new Element({voidDust : 10, gold : 50, text : '神恩商店独有物品。'}),
    '时空碎片' : new Element({voidDust : 100, gold : 500, text : '神恩商店独有物品。'}),
    '灵魂威慑' : new Element({onlyOne :true, isWeapon : true, atk : 0, weight : 5, endurance : 50, voidDust : 50, gold : 500, quality : 3, text : '灵魂威慑不受永不磨损属性影响。灵魂威慑对神(不是神话，是神域的神)和守关BOSS无效，但是当怪物不是守关BOSS状态时可以生效。例如你在孤岛还没打赢哥布林英雄时，打地底入口的哥布林英雄不会触发灵魂威慑，但是去了地底后，可以对地底的哥布林英雄使用灵魂威慑。装备后，当你主动攻击怪物时，如果你的攻击力的1.2倍高于怪物防御力，且怪物的攻击力*1.2未超过你的防御力，则不进行战斗，直接获得战利品，每触发一次，耐久-1。如果你穿了护甲，则无论如何一定会进行战斗模拟。模拟战斗只会有2个结果，1.怪物死亡，扫荡成功，并且消耗对应的护甲的耐久度。需要注意，只要模拟战斗，无论你的护甲防御力多高，都一定会消耗耐久，这是穿甲扫荡的代价，不适用于不破防规则。2.护甲耐久度清空之前，你在模拟战斗中无法击杀怪物，则护甲爆掉，并且怪物以满血姿态触发战斗。所以穿甲模拟战斗前请确认清楚自己的攻击力和怪物的防御力，以及护甲耐久，避免造成无谓的消耗。'}),
    '变异核心' : new Element({voidDust : 3, weight : 0, gold : 50}),
    '灵魂追猎' : new Element({canUse : true, voidDust : 1000, gold : 1000, func : function(){
            if(data.showMythDay === new Date(data.date).format('yyyyMMdd')){
                winMsg('今天你正在追猎。');
                return false;
            }
            data.showMythDay = new Date(data.date).format('yyyyMMdd');
            const monsters = data.world.mythMonster.filter(e => !e.deathTime);
            if(monsters.length === 0){
                winMsg(`当前地图没有存活的神话怪`);
            }else{
                winMsg(monsters.map(e => `${e.name}：坐标${e.location.join()}`).join('，'));
            }

            //渲染可前往的地图
            renderCanToMap();
            //渲染地图
            renderMap();
            return true;
        }, text : '显示当前地图的神话怪物位置，只持续到当天0点。'}),
    '次元钥匙' : new Element({canUse : true, voidDust : 1000, gold : 5000, func : function(){
            if(data.inDungeon){
                winMsg(`在副本中不可打开仓库`, false, false);
                return false;
            }
            if(data.world.home && data.world.home.location && data.world.home.location.length === 2){
                if(!data.world.home.store){
                    data.world.home.store = [];
                    save();
                }
                $('.store-item-search input').val('')
                storeFilter = '';
                isRunesStore = false;
                renderStore('次元钥匙');
                $('.store').show();
                $('.item-use-win-modal').hide();
                $('.item-use-win').hide();
                return true;
            }else{
                winMsg(`当前地图还没有安家`);
                return false;
            }
        }, text : '远程打开一次仓库，注意，使用一个次元钥匙只打开一次仓库，关闭后即失效。'}),
    '次元信标' : new Element({canUse : true, voidDust : 1000, gold : 5000, func : function(){
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }
            if(data.world.home && data.world.home.location && data.world.home.location.length > 0){
                data.world.home.location = data.location;
                winMsg('你搬家了！')
                timeLapses(60)
                return true;
            }else{
                winMsg(`你还没有家`, false, false);
                return false;
            }

        }, text : '消耗1小时，将家移动到当前位置。'}),
    '短程传送卷轴' : new Element({battleUse : true, voidDust : 1000, gold : 5000, func : function(){
            if(!confirm('是否确认使用短程传送卷轴？')){
                return false;
            }
            msg('你脱离了战斗');
            battleEnd();
            setTimeout(function(){timeLapses(battleRunMin);},100)
            return true;
        }, text : '立刻脱离战斗。'}),
    '先生的外套' : new Element({battleUse : true, voidDust : 1000, gold : 5000, func : function(){
            if(data.battleMonster.xsdwt){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.xsdwt = true;
            data.reduceHart += 0.2;
            const text = `使用了先生的外套，增加20%减伤`;
            addBattleLog(text)
            return true;
        }, text : '只能从成就“金刚不坏”的奖励中获得，增加20%减伤，每场战斗只能使用一次。'}),
    '灵魂标记：亡灵族' : new Element({canUse : true, voidDust : 1000, gold : 1000, func : function(){

            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('亡灵族') === -1){
                conf.races.push('亡灵族');
                save(confSavedName, conf);
                winMsg(`恭喜你解锁了亡灵族！`);
            }

            if(data.bind){
                winMsg('你已经设置了复活标记了。', false, false);
                return false;
            }
            if(data.race.name.startsWith('亡灵族') || data.race.name.startsWith('巫妖') || data.race.name === '机械族'){
                winMsg('亡灵生物或机器人无法设置灵魂标记。', false, false);
                return false;
            }
            if(confirm(`严重警告！请确保你已经仔细阅读了该物品的说明！是否确认使用？`)){
                data.bind = {
                    index : data.worldIndex,
                    location : data.location,
                    race : '亡灵族'
                };
                winMsg('设置灵魂标记成功！')
                return true;
            }

            return false;
        }, text : '使用后直接解锁亡灵族，无论是否使用成功，也不需要死亡一次再复活来解锁，使用了直接就解锁了。在当前位置设置灵魂标记，死亡后复活，等级变为1级，种族变为亡灵族。死亡会使你失去背包里的所有物品。使用该灵魂标记后，再使用其他复活道具（例如世界庇佑，重生十字章）可以覆盖掉该灵魂标记，避免死亡后复活为亡灵族。'}),
    '灵魂标记：巫妖' : new Element({canUse : true, voidDust : 1000, gold : 1000, func : function(){

            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('亡灵族') === -1){
                conf.races.push('亡灵族');
                save(confSavedName, conf);
                winMsg(`恭喜你解锁了亡灵族！`);
            }
            if(conf.races.indexOf('巫妖') === -1){
                conf.races.push('巫妖');
                save(confSavedName, conf);
                winMsg(`恭喜你解锁了巫妖！`);
            }

            if(data.bind){
                winMsg('你已经设置了复活标记了。', false, false);
                return false;
            }
            if(data.race.name.startsWith('亡灵族') || data.race.name.startsWith('巫妖') || data.race.name === '机械族'){
                winMsg('亡灵生物和机器人无法设置灵魂标记。', false, false);
                return false;
            }
            if(confirm(`严重警告！请确保你已经仔细阅读了该物品的说明！是否确认使用？`)){
                data.bind = {
                    index : data.worldIndex,
                    location : data.location,
                    race : '巫妖'
                };
                winMsg('设置灵魂标记成功！')
                return true;
            }

            return false;
        }, text : '使用后直接解锁亡灵族和巫妖，无论是否使用成功，也不需要死亡一次再复活来解锁，使用了直接就解锁了。在当前位置设置灵魂标记，死亡后复活，等级变为1级，种族变为巫妖。死亡会使你失去背包里的所有物品。使用该灵魂标记后，再使用其他复活道具（例如世界庇佑，重生十字章）可以覆盖掉该灵魂标记，避免死亡后复活为巫妖。'}),
    '神格' : new Element({voidDust : 100000, gold : 500000, text : '表面上看，这只是一个普普通通的神格。实际上，这真的只是个普普通通的神格。'}),
    '巫妖生态研究笔记' : new Element({canUse : true, voidDust : 1000, gold : 5000, quality : 4, func : function(){
            if(data.race.name !== '亡灵族'){
                const text = `只有亡灵族能转化为巫妖`;
                winMsg(text, false, false);
                return false;
            }
            data.race = races['巫妖'];
            data.exp = 0;
            data.level = 1;
            data.race.initItems.forEach(e => {
                addItem(e.name, e.num)
            })
            initAttr();
            winMsg('恭喜你通过自己的研究转化成了巫妖！');

            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf(data.race.name) === -1){
                conf.races.push(data.race.name);
                save(confSavedName, conf);
                winMsg(`恭喜你解锁了${data.race.name}！`);
            }

            return true;
        }, text : '通过一系列的研究，你了解了巫妖生态发展规律和形态转变方法。你可以使用这个笔记，将自己转变为巫妖了。使用后解锁巫妖种族，并立刻变为巫妖种族，等级变为1级。注意：只有亡灵族能转化为巫妖。'}),
    '重生十字章' : new Element({canUse : true, voidDust : 0, func : function(){
            if(data.bind && data.bind.race === '神力庇佑'){
                if(!data.consumePoint){
                    data.consumePoint = 0;
                }
                if(data.consumePoint > 0){
                    data.attrPoint += 1;
                    data.consumePoint -= 1;
                    winMsg('重生十字章使用成功，你已有神力的庇护，神力恢复了你的暗伤，你获得1点额外属性点！')
                }else{
                    winMsg('你已有神力的庇护，且身上没有暗伤，不需要使用重生十字章')
                    return false;
                }
            }else{
                data.bind = {
                    index : data.worldIndex,
                    location : data.location,
                    race : '神力庇佑'
                };
                winMsg('重生十字章使用成功，你受到了神力的庇护！')
            }
            return true;
        }, text : '死亡后原地复活并恢复所有血量。注意：使用该物品会将原本的灵魂标记或者巫妖命匣替换掉。如果身上已经有重生十字章的复活标记（即神力庇佑），再次使用重生十字章时，如果你的额外属性点为负数，则给你增加一点额外属性点。请注意，如果你使用过3个神话之力，获得了9点属性点，那么你因为世界庇佑死了2次，也扣除了6属性点，那么你的额外属性点就是正3点，此时用重生十字章是不会增加属性点的。如果你从没用过神话之力，世界庇佑死了2次，那么就是-6点，就可以用6个重生十字章来把额外属性点洗为0'}),
    '天赋神晶' : new Element({voidDust : 10000, gold : 50000, text : '用于激活天赋。'}),
    '潮湿的爆炸物' : new Element({canUse : true, voidDust : 1000, gold : 1000, func : function(){

            if(!conf.races){
                conf.races = [];
            }
            if(conf.races.indexOf('地精') === -1){
                conf.races.push('地精');
                save(confSavedName, conf);
                winMsg(`恭喜你解锁了地精！`);
            }
            return true;
        }, text : '钓鱼时，如果没钓到鱼，则有1%几率获得该物品，使用后解锁地精种族。如果已经解锁了地精种族，使用该物品不会发生任何事情'}),

    //镶嵌物
    ...getElementsInlays(),
    '永恒珠宝(赠)' : new Element({
        isInlay : true,
        endurance : null,
        level : 1,
        noWear : true,
        text : '可以在镶嵌台镶嵌到有孔的装备里'
    }),

    //符文
    ...getElementsRunes(),
    //古神入侵专属物品
    ...cthulhuItems,

    /** -----不可采集,制造出来的物品[END]----- */

    //活动专属物品
    ...getFestivalElements()
}
